package pwc.taxtech.atms.constant.enums;

public enum EnumServiceType {
    /// <summary>
    /// 后台admin
    /// </summary>
     Administration(1),

    /// <summary>
    /// 增值税申报分析
    /// </summary>
    VAT(2),

    /// <summary>
    /// 电子税务管理
    /// </summary>
    AM (3),

    /// <summary>
    /// 财务尽职调查
    /// </summary>
    FDD (4),

    /// <summary>
    /// 税务管理平台
    /// </summary>
    Dashboard (5),

    /// <summary>
    /// 企业所得税
    /// </summary>
    CIT(6),

    /// <summary>
    /// 电子税务审计
    /// </summary>
    TCS(7);

    private Integer code;

    EnumServiceType(Integer code) {
        this.code = code;
    }

    public Integer getCode() {
        return code;
    }

    public static EnumServiceType getEnumByCode(Integer code){
        for(EnumServiceType enumServiceType : EnumServiceType.values()){
            if(Integer.compare(code, enumServiceType.getCode())==0){
                return enumServiceType;
            }
        }
        return null;
    }

}
