package pwc.taxtech.atms.constant.enums;

public enum  ErpCheckType {
    Success (0),
    ComBalanceAcctUnValidate (1), //Const_ComBalanceAcctUnValidate (")试算平衡表中出现的科目不在科目表中";
    VoucherAcctValidate (2), // Const_VoucherAcctUnValidate (")凭证表中出现的科目不在科目表中";
    VSingleDebitCreditUnValidate (3),//Const_VSingleDebitCreditUnValidate (")凭证表中凭证借贷不平衡";
    VEmptyCheckUnValidateItemID (4),//Const_VEmptyCheckUnValidateItemID (")凭证表中凭证分录号为空";
    VEmptyCheckUnValidateGroup (5),//Const_VEmptyCheckUnValidateGroup (")凭证表中凭证类型为空";
    VEmptyCheckUnValidateAcctCode (6),//Const_VEmptyCheckUnValidateAcctCode (")凭证表中科目代码为空";
    VEmptyCheckUnValidateSummary (7),//Const_VEmptyCheckUnValidateSummary (")凭证表中凭证摘要为空";
    AcctBegBalAcctLevelUnValidate (8),// Const_AcctBegBalAcctLevelUnValidate (")试算平衡表中期初余额上下级不平衡";
    BegBalUnValidate (9), //Const_BegBalUnValidate (")试算平衡表中期初余额借贷不平衡";
    CompCustEndBalUnValidate (10),//Const_CompCustEndBalUnValidate (")系统计算所得的试算平衡表期末余额与导入的不一致";
    CompCustAmountUnValidate (11),//Const_CompCustAmountUnValidate (")系统计算所得的试算平衡表期间发生与导入的不一致";
    CompCustBegBalUnValidate (12),//Const_CompCustBegBalUnValidate (")系统计算所得的试算平衡表期初余额与导入的不一致";
    BegEndBalUnValidate (13),//Const_BegEndBalUnValidate (")系统计算所得的上月期末与导入的本月期初不一致";
    DuplicatedVoucher (14),//Voucher重复数据检查
    DuplicatedTb (15),

    CustomInvoice_DuplicatePayNum (20), //海关清单：海关缴款书号码重复

    Tb_NoAcctCode (30),//Tb验证 科目不在科目表中
    Tb_PeriodBalance (31),//本月期初(月期末      )
    Tb_BegBalDebitAndCreditBanlace (32),//期初余额借贷平衡
    Tb_BegBalUpAndDownBanlace (33),//期初余额上下级平衡
    Tb_CurentDebitAndCreditBanlace (34),//发生额借贷平衡
    Tb_CurrentUpAndDownBanlace (35),//发生额上下级平衡
    Tb_EndBalDebitAndCreditBanlace (36),//期末借贷平衡
    Tb_EndBalUpAndDownBanlace (37),//期末上下级平衡
    Tb_CurrentBalance (38),//期末(初)+（借-贷）*方向
    Tb_DuplicatedData (39),//重复数据

    Mapping_DuplicatedData (45),//重复数据

    JE_AcctInvalid (50),//凭证表中的科目不在科目表中
    JE_DebitAndCreditBanlace (51),//凭证借贷平衡
    JE_DuplicatedData (52),//重复数据
    JE_SummaryEmpty (53),//摘要为空
    JE_GroupEmpty (53), //凭证类型为空
    JE_ItemIdEmpty (54),//分录号为空

    Invoice_DuplicatedData (60),//进项发票汇总重复
    Invoice_ErrorData (61),//进项发票信息错误
    Invoice_CertificationResultError (62),//进项发票认证结果错误

    InvoiceItem_NotHaveTotalInvoice (65),//进项明细与进项汇总表无关联
    InvoiceItem_AmountCompare (66),//进项汇总表与明细表金额，税额比对
    InvoiceItem_TaxRateCompare (67),//金额与税率的乘积与导入的税额比较

    Output_DuplicatedData (80),//销项发票重复
    OutputItem_TaxRateCompare (81),//金额与税率的乘积与导入的税额比较

    AccountMapping_NotMapStd (90), //Const_AccountMapping_NotMapStd 没有对应标准科目

    Shimao_Tb (100),//世贸数据正确性验证
    Shimao_OutputInvoice (101),//世贸销项正确性验证
    Shimao_JournalEntry (102),//序时帐正确性验证
    Shimao_InputInvoice (103);//世贸进项正确性验证

    private Integer code;

    ErpCheckType(Integer code) {
        this.code=code;
    }

    public Integer getCode() {
        return code;
    }
}
