package pwc.taxtech.atms.constant.enums;

public enum FormulaDataSourceType {
    /// <summary>
    /// 其他数据源，如公式中的税率、数字部分
    /// </summary>
    Other(0),

    /// <summary>
    /// 进项数据源
    /// </summary>
    InputInvoice(1),

    /// <summary>
    /// 进项明细数据源
    /// </summary>
    InputInvoiceDetail(2),

    /// <summary>
    /// 销项数据源
    /// </summary>
    OutputInvoice(3),

    /// <summary>
    /// 凭证数据源
    /// </summary>
    Voucher(4),

    /// <summary>
    /// 报表数据源
    /// </summary>
    Report(5),

    /// <summary>
    /// 条件判断数据源
    /// </summary>
    Judgment(6),

    /// <summary>
    /// Sap日报数据源
    /// </summary>
    SapDaily(7),

    /// <summary>
    /// 土地出让金数据源
    /// </summary>
    LandSell(8),

    /// <summary>
    /// 未开票数据源
    /// </summary>
    Unbilled(9),
    KeyInSource(10),
    //由于开会讨论，期末余额，期初余额等都是试算平衡数据源， code 11,12,14 所以删除他们统一改成试算平衡表
    //试算平衡数据源
    TrialBalanceSource(11),
    //QMYESource(12),
    ModelSource(13),
    TrialBalance(20);
    // FSESource(14),

    private Integer code;

    FormulaDataSourceType(Integer code) {
        this.code = code;
    }

    public Integer getCode() {
        return code;
    }
}
