package pwc.taxtech.atms.controller;

import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.service.IdentityService;
import pwc.taxtech.atms.vat.service.FinanceDataImportService;

@RestController
@RequestMapping("/api/v1/financeImportData")
public class FinanceDataImportController {

    @Autowired
    private FinanceDataImportService financeDataImport;
    @Autowired
    private IdentityService identityService;

    @ApiOperation(value = "")
    @RequestMapping(value = "checkData/basicCheck", method = RequestMethod.GET)
    public ResponseEntity getBasicValidationResults() {
        return ResponseEntity.ok().body(financeDataImport.getBasicValidationResults(identityService.getIdentityUser().getID()));
    }
}
