package pwc.taxtech.atms.controller;

import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.vatdto.QueryJeDto;
import pwc.taxtech.atms.vat.service.impl.JournalEntryImportServiceImpl;

@RestController
@RequestMapping(value = "/api/v1/journalEntryImport")
public class JournalEntryImportController {

    @Autowired
    private JournalEntryImportServiceImpl journalEntryDataImportService;

    @ApiOperation(value = "queryJournalEntryData", notes = "")
    @RequestMapping(value = "/queryJournalEntryData", method = RequestMethod.POST)
    public ResponseEntity queryJournalEntryData(@RequestBody QueryJeDto queryJeDto) {
        return ResponseEntity.ok(journalEntryDataImportService.qeryJournalEntryData(queryJeDto));
    }

    @ApiOperation(value = "getValidationInfo", notes = "")
    @RequestMapping(value = "getValidationInfo/{type}/{period}", method = RequestMethod.GET)
    public ResponseEntity getValidationInfo(@PathVariable Integer type, @PathVariable Integer period) {
        return ResponseEntity.ok(journalEntryDataImportService.getValidationInfoList(type, period));
    }
}

