package pwc.taxtech.atms.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import pwc.taxtech.atms.dto.ModelProfileDto;
import pwc.taxtech.atms.service.ModelConfigurationService;

@RestController
@RequestMapping(value = "api/v1/modelConfiguration")
public class ModelConfigurationController {

	@Autowired
	ModelConfigurationService modelConfigurationService;

	@RequestMapping(value = "/model/byIndustry/{serviceTypeID}/{industryID}", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
	public @ResponseBody List<ModelProfileDto> getModelListByIndustry(@PathVariable String industryID,
			@PathVariable String serviceTypeID) {
		return modelConfigurationService.getModelListByIndustry(serviceTypeID, industryID);
	}
}
