package pwc.taxtech.atms.controller;

import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.taxadmin.ProjectStatusManageDto;
import pwc.taxtech.atms.service.IdentityService;
import pwc.taxtech.atms.service.ProjectStatusManageService;

@RestController
@RequestMapping("/api/v1/ProjectStatusManage")
public class ProjectStatusManageController {

    @Autowired
    private ProjectStatusManageService projectStatusManageService;

    @Autowired
    private IdentityService identityService;

    @ApiOperation(value = "setProjectStatus", notes = "")
    @RequestMapping(value = {"/setProjectStatus/{dbName}/{periodId}/{status}"}, method = RequestMethod.GET,
            produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    @ResponseBody
    public OperationResultDto<ProjectStatusManageDto> setProjectStatus(@PathVariable("dbName") String dbName,
                                                                       @PathVariable("periodId") Integer periodId,
                                                                       @PathVariable("status") Integer status) {
        return projectStatusManageService.setProjectStatus(dbName, periodId, status, identityService.getIdentityUser().getID());
    }


    @ApiOperation(value = "getProjectStatus", notes = "")
    @RequestMapping(value = {"getProjectStatus/{dbName}/{projectId}/{periodId}"}, method = RequestMethod.GET,
            produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
    @ResponseBody
    public OperationResultDto<ProjectStatusManageDto> getProjectStatus(@PathVariable String dbName, @PathVariable String projectId,
                                                                       @PathVariable Integer periodId) {
        return projectStatusManageService.getProjectStatus(dbName, projectId, periodId);
    }
}
