package pwc.taxtech.atms.dao.dao;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dao.TemplateMapper;
import pwc.taxtech.atms.entitiy.Template;
import pwc.taxtech.atms.entitiy.TemplateExample;

import java.util.List;

@Service
public class TemplateDao {
    @Autowired
    private TemplateMapper mapper;

    public List<Template> getByName(String name) {
        TemplateExample example = new TemplateExample();
        TemplateExample.Criteria criteria = example.createCriteria();
        criteria.andNameEqualTo(name);
        return mapper.selectByExample(example);
    }

    public List<Template> getByCode(String code) {
        TemplateExample example = new TemplateExample();
        TemplateExample.Criteria criteria = example.createCriteria();
        criteria.andCodeEqualTo(code);
        return mapper.selectByExample(example);
    }

    public List<Template> getByGroupID(Long groupID) {
        TemplateExample example = new TemplateExample();
        TemplateExample.Criteria criteria = example.createCriteria();
        criteria.andTemplateGroupIdEqualTo(groupID);
        return mapper.selectByExample(example);
    }

}
