package pwc.taxtech.atms.dto;

import java.util.Date;
import java.util.List;
import java.util.Optional;

import pwc.taxtech.atms.common.EnumHelper;
import pwc.taxtech.atms.common.IdKeyNameData;
import pwc.taxtech.atms.common.ModelTypeEnum;

public class ModelProfileDto {
	private String ID;

	private int ruleType;

	private String code;

	private String name;

	private int type;

	private String modelTypeName;

	private int isStatus;

	private String description;

	private int feature;

	private int isFilter;

	private String monthJudge;

	private String yearJudge;

	private String yearExplain;

	private Date createTime;

	private Date upDateTime;

	private String industryID;

	private String industryName;

	private String organizationName;

	private String serviceTypeID;

	private String serviceTypeName;

	private String categoryID;

	private String categoryString;

	private boolean isFilterShow;

	private String orgID;

	private List<IndexAnalysisDetailDto> indexAnalysisDetaileList;

	private List<EntriesCheckDetailDto> entriesCheckDetailList;

	public String getID() {
		return ID;
	}

	public void setID(String ID) {
		this.ID = ID;
	}

	public int getRuleType() {
		return ruleType;
	}

	public void setRuleType(int ruleType) {
		this.ruleType = ruleType;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getType() {
		return type;
	}

	public void setType(int type) {
		this.type = type;
	}

	public String getModelTypeName() {

		List<IdKeyNameData> typeNames = EnumHelper.ToIdkeyNameCollection(ModelTypeEnum.class);
		Optional<IdKeyNameData> typeName = typeNames.stream().filter(a -> (int) a.getID() == this.getType())
				.findFirst();
		if (typeName != null) {
			this.setModelTypeName(typeName.get().getName());
		} else {
			this.setModelTypeName("");
		}
		return modelTypeName;
	}

	public void setModelTypeName(String modelTypeName) {
		this.modelTypeName = modelTypeName;
	}

	public int getIsStatus() {
		return isStatus;
	}

	public void setIsStatus(int isStatus) {
		this.isStatus = isStatus;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public int getFeature() {
		return feature;
	}

	public void setFeature(int feature) {
		this.feature = feature;
	}

	public int getIsFilter() {
		return isFilter;
	}

	public void setIsFilter(int isFilter) {
		this.isFilter = isFilter;
	}

	public String getMonthJudge() {
		return monthJudge;
	}

	public void setMonthJudge(String monthJudge) {
		this.monthJudge = monthJudge;
	}

	public String getYearJudge() {
		return yearJudge;
	}

	public void setYearJudge(String yearJudge) {
		this.yearJudge = yearJudge;
	}

	public String getYearExplain() {
		return yearExplain;
	}

	public void setYearExplain(String yearExplain) {
		this.yearExplain = yearExplain;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public Date getUpDateTime() {
		return upDateTime;
	}

	public void setUpDateTime(Date upDateTime) {
		this.upDateTime = upDateTime;
	}

	public String getIndustryID() {
		return industryID;
	}

	public void setIndustryID(String industryID) {
		this.industryID = industryID;
	}

	public String getIndustryName() {
		return industryName;
	}

	public void setIndustryName(String industryName) {
		this.industryName = industryName;
	}

	public String getOrganizationName() {
		return organizationName;
	}

	public void setOrganizationName(String organizationName) {
		this.organizationName = organizationName;
	}

	public String getServiceTypeID() {
		return serviceTypeID;
	}

	public void setServiceTypeID(String serviceTypeID) {
		this.serviceTypeID = serviceTypeID;
	}

	public String getServiceTypeName() {
		return serviceTypeName;
	}

	public void setServiceTypeName(String serviceTypeName) {
		this.serviceTypeName = serviceTypeName;
	}

	public String getCategoryID() {
		return categoryID;
	}

	public void setCategoryID(String categoryID) {
		this.categoryID = categoryID;
	}

	public String getCategoryString() {
		return categoryString;
	}

	public void setCategoryString(String categoryString) {
		this.categoryString = categoryString;
	}

	public boolean isFilterShow() {
		return isFilterShow;
	}

	public void setFilterShow(boolean isFilterShow) {
		this.isFilterShow = isFilterShow;
	}

	public String getOrgID() {
		return orgID;
	}

	public void setOrgID(String orgID) {
		this.orgID = orgID;
	}

	public List<IndexAnalysisDetailDto> getIndexAnalysisDetaileList() {
		return indexAnalysisDetaileList;
	}

	public void setIndexAnalysisDetaileList(List<IndexAnalysisDetailDto> indexAnalysisDetaileList) {
		this.indexAnalysisDetaileList = indexAnalysisDetaileList;
	}

	public List<EntriesCheckDetailDto> getEntriesCheckDetailList() {
		return entriesCheckDetailList;
	}

	public void setEntriesCheckDetailList(List<EntriesCheckDetailDto> entriesCheckDetailList) {
		this.entriesCheckDetailList = entriesCheckDetailList;
	}

}
