package pwc.taxtech.atms.dto.organization;

import java.util.Date;
import java.util.List;

import pwc.taxtech.atms.dto.DimensionValueOrgDto;
import pwc.taxtech.atms.dto.OrganizationServiceTemplateGroupDto;
import pwc.taxtech.atms.dto.TaxControlDiskDto;
import pwc.taxtech.atms.dto.epaccount.EnterpriseAccountSetOrgDto;
import pwc.taxtech.atms.dto.user.UserRoleInfo;

public class OrganizationDto {

    private String ID;
    private String clientCode;
    private String name;
    private String englishName;
    private String abbreviation;
    private String code;
    private String invoiceType;
    private String parentID;
    private String taxPayerNumber;
    private String regionID; // City
    private String parentRegionID; // Province
    private String structureID;
    private String industryID;
    public Boolean isActive;
    public Date createTime;
    public Date updateTime;
    private String parentName;
    private String areaName;
    private String areaID;
    private String businessUnitID;
    public List<OrganizationDto> subOrgs;
    // for cargill
    private String legalPersonName;
    private String manufactureAddress;
    private String registerAddress;
    private String bankAccountName;
    private String bankAccountNumber;
    private String phoneNumber;
    private String registrationType;
    private String structureName;
    private String regionName;
    private String industryName;
    private String businessUnitName;
    private String dimensionID;
    private String dimensionName;
    private String dimensionValueName;
    private String dimensionValueID;
    private String attributeID;
    private String attributeName;
    public Boolean isSystemDimension;
    // 用于UI GRID Tree Level
    public Integer level;
    // 用于机构层级本身的上下级
    public Integer pLevel;
    private String remark;
    private String vehicleroutinglocation;
    public List<EnterpriseAccountSetOrgDto> enterpriseAccountSetOrgList;
    public List<OrganizationServiceTemplateGroupDto> organizationServiceTemplateGroupList;
    public List<DimensionValueOrgDto> dimensionValueOrgList;
    public List<UserRoleInfo> userRoleList;
    public List<OrganizationDto> sameVehicleroutinglocationList;
    public List<TaxControlDiskDto> taxControlDiskList;

    public String getID() {
        return ID;
    }

    public void setID(String iD) {
        ID = iD;
    }

    public String getClientCode() {
        return clientCode;
    }

    public void setClientCode(String clientCode) {
        this.clientCode = clientCode;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getEnglishName() {
        return englishName;
    }

    public void setEnglishName(String englishName) {
        this.englishName = englishName;
    }

    public String getAbbreviation() {
        return abbreviation;
    }

    public void setAbbreviation(String abbreviation) {
        this.abbreviation = abbreviation;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getInvoiceType() {
        return invoiceType;
    }

    public void setInvoiceType(String invoiceType) {
        this.invoiceType = invoiceType;
    }

    public String getParentID() {
        return parentID;
    }

    public void setParentID(String parentID) {
        this.parentID = parentID;
    }

    public String getTaxPayerNumber() {
        return taxPayerNumber;
    }

    public void setTaxPayerNumber(String taxPayerNumber) {
        this.taxPayerNumber = taxPayerNumber;
    }

    public String getRegionID() {
        return regionID;
    }

    public void setRegionID(String regionID) {
        this.regionID = regionID;
    }

    public String getParentRegionID() {
        return parentRegionID;
    }

    public void setParentRegionID(String parentRegionID) {
        this.parentRegionID = parentRegionID;
    }

    public String getStructureID() {
        return structureID;
    }

    public void setStructureID(String structureID) {
        this.structureID = structureID;
    }

    public String getIndustryID() {
        return industryID;
    }

    public void setIndustryID(String industryID) {
        this.industryID = industryID;
    }

    public Boolean getIsActive() {
        return isActive;
    }

    public void setIsActive(Boolean isActive) {
        this.isActive = isActive;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    public String getAreaName() {
        return areaName;
    }

    public void setAreaName(String areaName) {
        this.areaName = areaName;
    }

    public String getAreaID() {
        return areaID;
    }

    public void setAreaID(String areaID) {
        this.areaID = areaID;
    }

    public String getBusinessUnitID() {
        return businessUnitID;
    }

    public void setBusinessUnitID(String businessUnitID) {
        this.businessUnitID = businessUnitID;
    }

    public List<OrganizationDto> getSubOrgs() {
        return subOrgs;
    }

    public void setSubOrgs(List<OrganizationDto> subOrgs) {
        this.subOrgs = subOrgs;
    }

    public String getLegalPersonName() {
        return legalPersonName;
    }

    public void setLegalPersonName(String legalPersonName) {
        this.legalPersonName = legalPersonName;
    }

    public String getManufactureAddress() {
        return manufactureAddress;
    }

    public void setManufactureAddress(String manufactureAddress) {
        this.manufactureAddress = manufactureAddress;
    }

    public String getRegisterAddress() {
        return registerAddress;
    }

    public void setRegisterAddress(String registerAddress) {
        this.registerAddress = registerAddress;
    }

    public String getBankAccountName() {
        return bankAccountName;
    }

    public void setBankAccountName(String bankAccountName) {
        this.bankAccountName = bankAccountName;
    }

    public String getBankAccountNumber() {
        return bankAccountNumber;
    }

    public void setBankAccountNumber(String bankAccountNumber) {
        this.bankAccountNumber = bankAccountNumber;
    }

    public String getPhoneNumber() {
        return phoneNumber;
    }

    public void setPhoneNumber(String phoneNumber) {
        this.phoneNumber = phoneNumber;
    }

    public String getRegistrationType() {
        return registrationType;
    }

    public void setRegistrationType(String registrationType) {
        this.registrationType = registrationType;
    }

    public String getStructureName() {
        return structureName;
    }

    public void setStructureName(String structureName) {
        this.structureName = structureName;
    }

    public String getRegionName() {
        return regionName;
    }

    public void setRegionName(String regionName) {
        this.regionName = regionName;
    }

    public String getIndustryName() {
        return industryName;
    }

    public void setIndustryName(String industryName) {
        this.industryName = industryName;
    }

    public String getBusinessUnitName() {
        return businessUnitName;
    }

    public void setBusinessUnitName(String businessUnitName) {
        this.businessUnitName = businessUnitName;
    }

    public String getDimensionID() {
        return dimensionID;
    }

    public void setDimensionID(String dimensionID) {
        this.dimensionID = dimensionID;
    }

    public String getDimensionName() {
        return dimensionName;
    }

    public void setDimensionName(String dimensionName) {
        this.dimensionName = dimensionName;
    }

    public String getDimensionValueName() {
        return dimensionValueName;
    }

    public void setDimensionValueName(String dimensionValueName) {
        this.dimensionValueName = dimensionValueName;
    }

    public String getDimensionValueID() {
        return dimensionValueID;
    }

    public void setDimensionValueID(String dimensionValueID) {
        this.dimensionValueID = dimensionValueID;
    }

    public String getAttributeID() {
        return attributeID;
    }

    public void setAttributeID(String attributeID) {
        this.attributeID = attributeID;
    }

    public String getAttributeName() {
        return attributeName;
    }

    public void setAttributeName(String attributeName) {
        this.attributeName = attributeName;
    }

    public Boolean getIsSystemDimension() {
        return isSystemDimension;
    }

    public void setIsSystemDimension(Boolean isSystemDimension) {
        this.isSystemDimension = isSystemDimension;
    }

    public Integer getLevel() {
        return level;
    }

    public void setLevel(Integer level) {
        this.level = level;
    }

    public Integer getpLevel() {
        return pLevel;
    }

    public void setpLevel(Integer pLevel) {
        this.pLevel = pLevel;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getVehicleroutinglocation() {
        return vehicleroutinglocation;
    }

    public void setVehicleroutinglocation(String vehicleroutinglocation) {
        this.vehicleroutinglocation = vehicleroutinglocation;
    }

    public List<EnterpriseAccountSetOrgDto> getEnterpriseAccountSetOrgList() {
        return enterpriseAccountSetOrgList;
    }

    public void setEnterpriseAccountSetOrgList(List<EnterpriseAccountSetOrgDto> enterpriseAccountSetOrgList) {
        this.enterpriseAccountSetOrgList = enterpriseAccountSetOrgList;
    }

    public List<OrganizationServiceTemplateGroupDto> getOrganizationServiceTemplateGroupList() {
        return organizationServiceTemplateGroupList;
    }

    public void setOrganizationServiceTemplateGroupList(
            List<OrganizationServiceTemplateGroupDto> organizationServiceTemplateGroupList) {
        this.organizationServiceTemplateGroupList = organizationServiceTemplateGroupList;
    }

    public List<DimensionValueOrgDto> getDimensionValueOrgList() {
        return dimensionValueOrgList;
    }

    public void setDimensionValueOrgList(List<DimensionValueOrgDto> dimensionValueOrgList) {
        this.dimensionValueOrgList = dimensionValueOrgList;
    }

    public List<UserRoleInfo> getUserRoleList() {
        return userRoleList;
    }

    public void setUserRoleList(List<UserRoleInfo> userRoleList) {
        this.userRoleList = userRoleList;
    }

    public List<OrganizationDto> getSameVehicleroutinglocationList() {
        return sameVehicleroutinglocationList;
    }

    public void setSameVehicleroutinglocationList(List<OrganizationDto> sameVehicleroutinglocationList) {
        this.sameVehicleroutinglocationList = sameVehicleroutinglocationList;
    }

    public List<TaxControlDiskDto> getTaxControlDiskList() {
        return taxControlDiskList;
    }

    public void setTaxControlDiskList(List<TaxControlDiskDto> taxControlDiskList) {
        this.taxControlDiskList = taxControlDiskList;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((ID == null) ? 0 : ID.hashCode());
        result = prime * result + ((abbreviation == null) ? 0 : abbreviation.hashCode());
        result = prime * result + ((areaID == null) ? 0 : areaID.hashCode());
        result = prime * result + ((areaName == null) ? 0 : areaName.hashCode());
        result = prime * result + ((attributeID == null) ? 0 : attributeID.hashCode());
        result = prime * result + ((attributeName == null) ? 0 : attributeName.hashCode());
        result = prime * result + ((bankAccountName == null) ? 0 : bankAccountName.hashCode());
        result = prime * result + ((bankAccountNumber == null) ? 0 : bankAccountNumber.hashCode());
        result = prime * result + ((businessUnitID == null) ? 0 : businessUnitID.hashCode());
        result = prime * result + ((businessUnitName == null) ? 0 : businessUnitName.hashCode());
        result = prime * result + ((clientCode == null) ? 0 : clientCode.hashCode());
        result = prime * result + ((code == null) ? 0 : code.hashCode());
        result = prime * result + ((createTime == null) ? 0 : createTime.hashCode());
        result = prime * result + ((dimensionID == null) ? 0 : dimensionID.hashCode());
        result = prime * result + ((dimensionName == null) ? 0 : dimensionName.hashCode());
        result = prime * result + ((dimensionValueID == null) ? 0 : dimensionValueID.hashCode());
        result = prime * result + ((dimensionValueName == null) ? 0 : dimensionValueName.hashCode());
        result = prime * result + ((dimensionValueOrgList == null) ? 0 : dimensionValueOrgList.hashCode());
        result = prime * result + ((englishName == null) ? 0 : englishName.hashCode());
        result = prime * result + ((enterpriseAccountSetOrgList == null) ? 0 : enterpriseAccountSetOrgList.hashCode());
        result = prime * result + ((industryID == null) ? 0 : industryID.hashCode());
        result = prime * result + ((industryName == null) ? 0 : industryName.hashCode());
        result = prime * result + ((invoiceType == null) ? 0 : invoiceType.hashCode());
        result = prime * result + ((isActive == null) ? 0 : isActive.hashCode());
        result = prime * result + ((isSystemDimension == null) ? 0 : isSystemDimension.hashCode());
        result = prime * result + ((legalPersonName == null) ? 0 : legalPersonName.hashCode());
        result = prime * result + ((level == null) ? 0 : level.hashCode());
        result = prime * result + ((manufactureAddress == null) ? 0 : manufactureAddress.hashCode());
        result = prime * result + ((name == null) ? 0 : name.hashCode());
        result = prime * result + ((organizationServiceTemplateGroupList == null) ? 0
                : organizationServiceTemplateGroupList.hashCode());
        result = prime * result + ((pLevel == null) ? 0 : pLevel.hashCode());
        result = prime * result + ((parentID == null) ? 0 : parentID.hashCode());
        result = prime * result + ((parentName == null) ? 0 : parentName.hashCode());
        result = prime * result + ((parentRegionID == null) ? 0 : parentRegionID.hashCode());
        result = prime * result + ((phoneNumber == null) ? 0 : phoneNumber.hashCode());
        result = prime * result + ((regionID == null) ? 0 : regionID.hashCode());
        result = prime * result + ((regionName == null) ? 0 : regionName.hashCode());
        result = prime * result + ((registerAddress == null) ? 0 : registerAddress.hashCode());
        result = prime * result + ((registrationType == null) ? 0 : registrationType.hashCode());
        result = prime * result + ((remark == null) ? 0 : remark.hashCode());
        result = prime * result
                + ((sameVehicleroutinglocationList == null) ? 0 : sameVehicleroutinglocationList.hashCode());
        result = prime * result + ((structureID == null) ? 0 : structureID.hashCode());
        result = prime * result + ((structureName == null) ? 0 : structureName.hashCode());
        result = prime * result + ((subOrgs == null) ? 0 : subOrgs.hashCode());
        result = prime * result + ((taxControlDiskList == null) ? 0 : taxControlDiskList.hashCode());
        result = prime * result + ((taxPayerNumber == null) ? 0 : taxPayerNumber.hashCode());
        result = prime * result + ((updateTime == null) ? 0 : updateTime.hashCode());
        result = prime * result + ((userRoleList == null) ? 0 : userRoleList.hashCode());
        result = prime * result + ((vehicleroutinglocation == null) ? 0 : vehicleroutinglocation.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;
        OrganizationDto other = (OrganizationDto) obj;
        if (ID == null) {
            if (other.ID != null)
                return false;
        } else if (!ID.equals(other.ID))
            return false;
        if (abbreviation == null) {
            if (other.abbreviation != null)
                return false;
        } else if (!abbreviation.equals(other.abbreviation))
            return false;
        if (areaID == null) {
            if (other.areaID != null)
                return false;
        } else if (!areaID.equals(other.areaID))
            return false;
        if (areaName == null) {
            if (other.areaName != null)
                return false;
        } else if (!areaName.equals(other.areaName))
            return false;
        if (attributeID == null) {
            if (other.attributeID != null)
                return false;
        } else if (!attributeID.equals(other.attributeID))
            return false;
        if (attributeName == null) {
            if (other.attributeName != null)
                return false;
        } else if (!attributeName.equals(other.attributeName))
            return false;
        if (bankAccountName == null) {
            if (other.bankAccountName != null)
                return false;
        } else if (!bankAccountName.equals(other.bankAccountName))
            return false;
        if (bankAccountNumber == null) {
            if (other.bankAccountNumber != null)
                return false;
        } else if (!bankAccountNumber.equals(other.bankAccountNumber))
            return false;
        if (businessUnitID == null) {
            if (other.businessUnitID != null)
                return false;
        } else if (!businessUnitID.equals(other.businessUnitID))
            return false;
        if (businessUnitName == null) {
            if (other.businessUnitName != null)
                return false;
        } else if (!businessUnitName.equals(other.businessUnitName))
            return false;
        if (clientCode == null) {
            if (other.clientCode != null)
                return false;
        } else if (!clientCode.equals(other.clientCode))
            return false;
        if (code == null) {
            if (other.code != null)
                return false;
        } else if (!code.equals(other.code))
            return false;
        if (createTime == null) {
            if (other.createTime != null)
                return false;
        } else if (!createTime.equals(other.createTime))
            return false;
        if (dimensionID == null) {
            if (other.dimensionID != null)
                return false;
        } else if (!dimensionID.equals(other.dimensionID))
            return false;
        if (dimensionName == null) {
            if (other.dimensionName != null)
                return false;
        } else if (!dimensionName.equals(other.dimensionName))
            return false;
        if (dimensionValueID == null) {
            if (other.dimensionValueID != null)
                return false;
        } else if (!dimensionValueID.equals(other.dimensionValueID))
            return false;
        if (dimensionValueName == null) {
            if (other.dimensionValueName != null)
                return false;
        } else if (!dimensionValueName.equals(other.dimensionValueName))
            return false;
        if (dimensionValueOrgList == null) {
            if (other.dimensionValueOrgList != null)
                return false;
        } else if (!dimensionValueOrgList.equals(other.dimensionValueOrgList))
            return false;
        if (englishName == null) {
            if (other.englishName != null)
                return false;
        } else if (!englishName.equals(other.englishName))
            return false;
        if (enterpriseAccountSetOrgList == null) {
            if (other.enterpriseAccountSetOrgList != null)
                return false;
        } else if (!enterpriseAccountSetOrgList.equals(other.enterpriseAccountSetOrgList))
            return false;
        if (industryID == null) {
            if (other.industryID != null)
                return false;
        } else if (!industryID.equals(other.industryID))
            return false;
        if (industryName == null) {
            if (other.industryName != null)
                return false;
        } else if (!industryName.equals(other.industryName))
            return false;
        if (invoiceType == null) {
            if (other.invoiceType != null)
                return false;
        } else if (!invoiceType.equals(other.invoiceType))
            return false;
        if (isActive == null) {
            if (other.isActive != null)
                return false;
        } else if (!isActive.equals(other.isActive))
            return false;
        if (isSystemDimension == null) {
            if (other.isSystemDimension != null)
                return false;
        } else if (!isSystemDimension.equals(other.isSystemDimension))
            return false;
        if (legalPersonName == null) {
            if (other.legalPersonName != null)
                return false;
        } else if (!legalPersonName.equals(other.legalPersonName))
            return false;
        if (level == null) {
            if (other.level != null)
                return false;
        } else if (!level.equals(other.level))
            return false;
        if (manufactureAddress == null) {
            if (other.manufactureAddress != null)
                return false;
        } else if (!manufactureAddress.equals(other.manufactureAddress))
            return false;
        if (name == null) {
            if (other.name != null)
                return false;
        } else if (!name.equals(other.name))
            return false;
        if (organizationServiceTemplateGroupList == null) {
            if (other.organizationServiceTemplateGroupList != null)
                return false;
        } else if (!organizationServiceTemplateGroupList.equals(other.organizationServiceTemplateGroupList))
            return false;
        if (pLevel == null) {
            if (other.pLevel != null)
                return false;
        } else if (!pLevel.equals(other.pLevel))
            return false;
        if (parentID == null) {
            if (other.parentID != null)
                return false;
        } else if (!parentID.equals(other.parentID))
            return false;
        if (parentName == null) {
            if (other.parentName != null)
                return false;
        } else if (!parentName.equals(other.parentName))
            return false;
        if (parentRegionID == null) {
            if (other.parentRegionID != null)
                return false;
        } else if (!parentRegionID.equals(other.parentRegionID))
            return false;
        if (phoneNumber == null) {
            if (other.phoneNumber != null)
                return false;
        } else if (!phoneNumber.equals(other.phoneNumber))
            return false;
        if (regionID == null) {
            if (other.regionID != null)
                return false;
        } else if (!regionID.equals(other.regionID))
            return false;
        if (regionName == null) {
            if (other.regionName != null)
                return false;
        } else if (!regionName.equals(other.regionName))
            return false;
        if (registerAddress == null) {
            if (other.registerAddress != null)
                return false;
        } else if (!registerAddress.equals(other.registerAddress))
            return false;
        if (registrationType == null) {
            if (other.registrationType != null)
                return false;
        } else if (!registrationType.equals(other.registrationType))
            return false;
        if (remark == null) {
            if (other.remark != null)
                return false;
        } else if (!remark.equals(other.remark))
            return false;
        if (sameVehicleroutinglocationList == null) {
            if (other.sameVehicleroutinglocationList != null)
                return false;
        } else if (!sameVehicleroutinglocationList.equals(other.sameVehicleroutinglocationList))
            return false;
        if (structureID == null) {
            if (other.structureID != null)
                return false;
        } else if (!structureID.equals(other.structureID))
            return false;
        if (structureName == null) {
            if (other.structureName != null)
                return false;
        } else if (!structureName.equals(other.structureName))
            return false;
        if (subOrgs == null) {
            if (other.subOrgs != null)
                return false;
        } else if (!subOrgs.equals(other.subOrgs))
            return false;
        if (taxControlDiskList == null) {
            if (other.taxControlDiskList != null)
                return false;
        } else if (!taxControlDiskList.equals(other.taxControlDiskList))
            return false;
        if (taxPayerNumber == null) {
            if (other.taxPayerNumber != null)
                return false;
        } else if (!taxPayerNumber.equals(other.taxPayerNumber))
            return false;
        if (updateTime == null) {
            if (other.updateTime != null)
                return false;
        } else if (!updateTime.equals(other.updateTime))
            return false;
        if (userRoleList == null) {
            if (other.userRoleList != null)
                return false;
        } else if (!userRoleList.equals(other.userRoleList))
            return false;
        if (vehicleroutinglocation == null) {
            if (other.vehicleroutinglocation != null)
                return false;
        } else if (!vehicleroutinglocation.equals(other.vehicleroutinglocation))
            return false;
        return true;
    }
}
