package pwc.taxtech.atms.dto.vatdto;

import lombok.Getter;
import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.EvaluationException;
import org.apache.poi.ss.formula.eval.ValueEval;

import static pwc.taxtech.atms.common.util.FormulaUtil.resolverInteger;
import static pwc.taxtech.atms.common.util.FormulaUtil.resolverString;

@Getter
public class BBParasBo {
    private String reportCode;
    private Integer columnIndex;
    private Integer rowIndex;
    private Integer period;
    private Integer year;

    public BBParasBo(ValueEval[] args, OperationEvaluationContext ec) throws EvaluationException {
        reportCode = resolverString(args, ec, 0);
        columnIndex = resolverInteger(args, ec, 1);
        rowIndex = resolverInteger(args, ec, 2);
        period = args.length == 4 ? resolverInteger(args, ec, 3) : 0;
        year = args.length == 5 ? resolverInteger(args, ec, 4) : 0;
    }

    public void disCount() {
        rowIndex--;
        columnIndex--;
    }

    public BBParasBo(BBParasBo otherBo, int period, int curYear) {
        this.reportCode = otherBo.reportCode;
        this.columnIndex = otherBo.getColumnIndex();
        this.rowIndex = otherBo.rowIndex;
        this.period = period;
        this.year = curYear;
    }
}
