package pwc.taxtech.atms.dto.vatdto;

import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Getter
@Setter
public class DataSourceDto {
    private static String _DataSourcePrefix = "DS[";
    private static String _DataSourceSuffix = "]";

    public DataSourceDto() {
        this.internalCode = _DataSourcePrefix + hashCode() + _DataSourceSuffix;
    }

    Long id;

    String internalCode;
    String name;

    // 1: Formula, 2: Voucher, 3: OutputInvoice, 4: InputInvoice, 5: CustomInvoice, 6: KeyIn, 7: RelatedModel, 8: SapDaily
    Integer dataSourceType;
    BigDecimal amount;
    String description;

    // 1: +, 2: -, 3: *, 4: /
    Integer operationType;

    // 1: Number, 2: Percentage, 3: Boolean, 4: String
    Integer resultType;

    Integer type;
    String keyValueDataID;
    String creator;
    Date createTime;
    String updater;
    Date updateTime;

    String cellDataID;
    List<String> items;

    String projectID;
    String serviceTypeID;
}
