package pwc.taxtech.atms.dto.vatdto;

import lombok.Getter;
import pwc.taxtech.atms.constant.DataSourceName;
import pwc.taxtech.atms.constant.enums.FormulaDataSourceType;
import pwc.taxtech.atms.vat.entity.CellData;

@Getter
public class ReportCellDataSourceDto extends FormulaDataSourceDto {
    Integer year;
    Integer period;
    Integer columnIndex;
    String columnName;
    Integer rowIndex;
    String rowName;
    String reportTemplateID;
    String reportName;
    String cellDataID;
    String cellTemplateID;
    Boolean isOnlyManualInput;

    public ReportCellDataSourceDto() {
        super();
        this.type = FormulaDataSourceType.Report.getCode();
    }

    public static ReportCellDataSourceDto nullDataSource(BBParasBo bbParasBo, CurrentPeriodBo currentPeriodBo) {
        ReportCellDataSourceDto nulDataSource = new ReportCellDataSourceDto();
        nulDataSource.name = DataSourceName.ReportDataSource;
        nulDataSource.reportTemplateID = bbParasBo.getReportCode();
        nulDataSource.year = currentPeriodBo.curYear;
        nulDataSource.period = currentPeriodBo.getCurYear();
        nulDataSource.columnIndex = bbParasBo.getColumnIndex() - 1;
        nulDataSource.rowIndex = bbParasBo.getRowIndex() - 1;
        nulDataSource.isOnlyManualInput = false;
        return nulDataSource;
    }

    public static ReportCellDataSourceDto extractFromGroup(BBParasBo bbParasBo, CurrentPeriodBo currentPeriodBo,
                                                           CellData cellData, CellTemplatePerGroupDto cellTemplateData) {
        ReportCellDataSourceDto dataSource = new ReportCellDataSourceDto();
        dataSource.name = DataSourceName.ReportDataSource;
        dataSource.year = currentPeriodBo.curYear;
        dataSource.period = currentPeriodBo.curPeriod;
        dataSource.columnIndex = bbParasBo.getColumnIndex();
        dataSource.columnName = cellTemplateData.getColumnName();
        dataSource.rowIndex = bbParasBo.getRowIndex();
        dataSource.rowName = cellTemplateData.getRowName();
        dataSource.reportTemplateID = cellTemplateData.getReportTemplateID();
        dataSource.cellDataID = cellData.getId() + "";
        dataSource.cellTemplateID = cellData.getCellTemplateId() + "";
        dataSource.resultType = cellTemplateData.getResultType();
        dataSource.isOnlyManualInput = false;
        return dataSource;
    }

    public void fixedWithGroup(CellTemplatePerGroupDto dto) {
        cellTemplateID = dto.getCellTemplateID();
        rowName = dto.getRowName();
        columnName = dto.getColumnName();
        reportTemplateID = dto.getReportTemplateID();
        resultType = dto.getResultType();
    }
}
