package pwc.taxtech.atms.service;

import java.util.List;

import pwc.taxtech.atms.dto.AreaDto;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.entitiy.Area;

public interface AreaService {

    /**
     * Find Top level areas (parentId == null)
     * 
     * @return List<Area>
     */
    List<Area> findTopAreas();

    /**
     * Find only next level sub Areas By ParentId
     * 
     * @param parentId
     * @return
     */
    List<Area> getSubAreaListIngoreActive(String parentId);

    /**
     * Find all sub areas by parentId
     * 
     * @param parentId
     * @return
     */
    List<Area> getAllSubAreas(String parentId);

    /**
     * Set the area and its sub areas active or inactive
     * 
     * @param AreaDto
     *            model
     * @return
     */
    OperationResultDto<List<String>> setIsActive(AreaDto model);

    /**
     * Get Area list
     * 
     * @param type:0
     *            取启用的数据; type:1 取全部数据(默认)
     * @return List<AreaDto>
     */
    List<AreaDto> getAreaList(int type);

    /**
     * Get Area tree
     * 
     * @param type:0
     *            取启用的数据; type:1 取全部数据(默认)
     * @return List<AreaDto>
     */
    List<AreaDto> getAreaTree(int type);
}
