package pwc.taxtech.atms.service;

import java.util.List;

import pwc.taxtech.atms.dto.*;
import pwc.taxtech.atms.dto.formula.FormulaConfigDto;

public interface KeyValueConfigService {
    List<KeyValueConfigDisplayDto> get();

    OperationResultDto<List<FormulaConfigDto>> getAllFormulaList();

    List<FinancialStatementDetail> getFinacialStatement(String configurationID);

    List<TaxReturnDetail> getTaxReturn(String configurationID);

    List<AnalyticsModelDetail> getAnalyticsModel(String configurationID);

    int deleteKeyValueConfiguration(String keyID);

    void addKeyValueConfiguration(AddKeyValueConfigDto addKeyValueConfigDto);

    void updateKeyValueConfiguration(UpdateKeyValueConfigDto updateKeyValueConfigDto);

    boolean isKeyValueDuplicated(String name);

    List<KeyValueConfigDisplayDto> getByOrgID(String orgID);
}
