package pwc.taxtech.atms.service;

import pwc.taxtech.atms.dto.*;
import pwc.taxtech.atms.dto.vatdto.TemplateByGroupDto;
import pwc.taxtech.atms.entitiy.Template;

import java.util.List;

public interface TemplateService {
    /**
     * @param 模板组ID
     * @param 报表类型
     * @return 模板DTO 列表
     */
    List<TemplateDto> get(Long templateGroupID, Integer reportType);

    String getTemplatePath(Long templateID);

    Template getTemplateByID(Long templateID);

    List<TemplateUniqDto> getTemplateUniqList(String serviceTypeID, Integer payTaxType, Integer reportType, String industryIDs);

    OperationResultDto<Object> updateTemplateName(UpateNameParam param);

    OperationResultDto<String> deleteTemplate(DeleteTemplateParam param);

    OperationResultDto setRowColName(Long id,List<CellBriefDto> cellInfo);

    OperationResultDto<List<TemplateByGroupDto>> getByGroupID(Long templateGroupID, String projectID);
}
