package pwc.taxtech.atms.service.impl;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.common.util.SnowFlake;

import javax.annotation.PostConstruct;

@Service
public class DistributedIDService extends BaseService {
    @Value("${distributed_id_datacenter}")
    private Integer dataCenterId;
    @Value("${distributed_id_machine}")
    private Integer machineId;

    private SnowFlake snowFlake;

    @PostConstruct
    public void init() {
        snowFlake = new SnowFlake(dataCenterId, machineId);
    }

    /**
     * 获取ID
     *
     * @return long
     */
    public long nextId() {
        return snowFlake.nextId();
    }
}
