package pwc.taxtech.atms.service.impl;

import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.formula.FormulaParseException;
import org.apache.poi.ss.formula.FormulaParser;
import org.apache.poi.ss.formula.FormulaType;
import org.apache.poi.xssf.usermodel.XSSFEvaluationWorkbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.service.TemplateFormulaService;

@Service
public class TemplateFormulaServiceImpl extends AbstractService implements TemplateFormulaService {

    private FormulaHelper formulaHelper = new FormulaHelper();
    //private static ScriptEngine m_engine = Python.CreateEngine();


    @Override
    public OperationResultDto validate(String formula) {
        OperationResultDto result = new OperationResultDto();

        if (StringUtils.isBlank(formula)) {
            result.setResult(true);
            return result;
        }

        try {
            //String tidyFormula = formulaHelper.formatFormula(formula);
            XSSFWorkbook workbook = new XSSFWorkbook();
            XSSFEvaluationWorkbook xssfEvaluationWorkbook = XSSFEvaluationWorkbook.create(workbook);
            try {
                FormulaParser.parse(formula, xssfEvaluationWorkbook, FormulaType.CELL, 0);
                result.setResult(true);
                return result;
            } catch (FormulaParseException e) {
                result.setResult(false);
                result.setResultMsg(e.getMessage());
            }
            /*todo: find the replace solution for here to check formual is correct or not
            //var sourceCode = m_engine.CreateScriptSourceFromString(tidyFormula, SourceCodeKind.AutoDetect);
            //var compileCode = sourceCode.Compile();
            rtn.Result = compileCode != null;*/

            result.setResult(true);
            return result;
        } catch (Exception e) {
            result.setResult(false);
            result.setResultMsg(e.getMessage());
        }

        return null;
    }
}
