package pwc.taxtech.atms.vat.dao;

import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.session.RowBounds;
import pwc.taxtech.atms.MyVatMapper;
import pwc.taxtech.atms.dto.vatdto.OutputVATInvoiceInfoDto;
import pwc.taxtech.atms.dto.vatdto.QueryOutputDto;
import pwc.taxtech.atms.vat.entity.OutputVATInvoice;
import pwc.taxtech.atms.vat.entity.OutputVATInvoiceExample;

@Mapper
public interface OutputVATInvoiceMapper extends MyVatMapper {
    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    long countByExample(OutputVATInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    int deleteByExample(OutputVATInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    int deleteByPrimaryKey(String invoiceID);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    int insert(OutputVATInvoice record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    int insertSelective(OutputVATInvoice record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    List<OutputVATInvoice> selectByExampleWithRowbounds(OutputVATInvoiceExample example, RowBounds rowBounds);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    List<OutputVATInvoice> selectByExample(OutputVATInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    OutputVATInvoice selectByPrimaryKey(String invoiceID);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    int updateByExampleSelective(@Param("record") OutputVATInvoice record, @Param("example") OutputVATInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    int updateByExample(@Param("record") OutputVATInvoice record, @Param("example") OutputVATInvoiceExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    int updateByPrimaryKeySelective(OutputVATInvoice record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table OutputVATInvoice
     *
     * @mbg.generated
     */
    int updateByPrimaryKey(OutputVATInvoice record);

    List<OutputVATInvoiceInfoDto> selectOutputVATInvoiceInfoLeftJoinItem(@Param("queryDto")QueryOutputDto queryDto);

    @Select("SELECT  " +
            "    o.PeriodID, " +
            "    o.InvoiceType, " +
            "    o.ClassCode, " +
            "    o.InvoiceNumber, " +
            "    o.BuyerName, " +
            "    o.BuyerTaxNumber, " +
            "    o.BankAccount, " +
            "    o.PhoneNum, " +
            "    o.InvoiceDate, " +
            "    oi.CodeVersion, " +
            "    oi.ProductName, " +
            "    oi.DocumentNum, " +
            "    oi.ProductStandard, " +
            "    oi.Unit, " +
            "    oi.Quantity, " +
            "    oi.UnitPrice, " +
            "    oi.Amount, " +
            "    oi.TaxRate, " +
            "    oi.TaxAmount, " +
            "    oi.TaxClassCode " +
            "FROM " +
            "    OutputVATInvoice o, " +
            "    OutputVATInvoiceItem oi, " +
            "    (SELECT  " +
            "        InvoiceID, MIN(SeqNo) minSeqNo " +
            "    FROM " +
            "        OutputVATInvoiceItem " +
            "    GROUP BY InvoiceID) m " +
            "WHERE " +
            "    o.InvoiceID = oi.InvoiceID " +
            "        AND o.InvoiceID = m.InvoiceID " +
            "        AND oi.SeqNo = m.minSeqNo  " +
            "        AND o.PeriodID = #{period}" +
            "UNION SELECT  " +
            "    o2.PeriodID, " +
            "    NULL AS InvoiceType, " +
            "    '' AS ClassCode, " +
            "    '' AS InvoiceNumber, " +
            "    '' AS BuyerName, " +
            "    '' AS BuyerTaxNumber, " +
            "    '' AS BankAccount, " +
            "    '' AS PhoneNum, " +
            "    NULL AS InvoiceDate, " +
            "    oi2.CodeVersion, " +
            "    oi2.ProductName, " +
            "    oi2.DocumentNum, " +
            "    oi2.ProductStandard, " +
            "    oi2.Unit, " +
            "    oi2.Quantity, " +
            "    oi2.UnitPrice, " +
            "    oi2.Amount, " +
            "    oi2.TaxRate, " +
            "    oi2.TaxAmount, " +
            "    oi2.TaxClassCode " +
            "FROM " +
            "    OutputVATInvoice o2, " +
            "    OutputVATInvoiceItem oi2, " +
            "    (SELECT  " +
            "        InvoiceID, MIN(SeqNo) minSeqNo " +
            "    FROM " +
            "        OutputVATInvoiceItem " +
            "    GROUP BY InvoiceID) m2 " +
            "WHERE " +
            "    o2.InvoiceID = oi2.InvoiceID " +
            "        AND o2.InvoiceID = m2.InvoiceID " +
            "        AND oi2.SeqNo != m2.minSeqNo " +
            "        AND o.PeriodID = #{period}" +
            " ")
    List<OutputVATInvoiceInfoDto> queryOutputDetailWithItem(Integer period);
}