package pwc.taxtech.atms.vat.service;

import pwc.taxtech.atms.constant.enums.EnumServiceType;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.vatdto.CellTemplateReferenceDto;
import pwc.taxtech.atms.dto.vatdto.VatEnterpriseAccountResultDto;
import pwc.taxtech.atms.dto.vatdto.ReportDataDto;
import pwc.taxtech.atms.dto.vatdto.ReportDto;
import pwc.taxtech.atms.vat.entity.PeriodCellTemplateConfig;
import pwc.taxtech.atms.vat.entity.Report;
import pwc.taxtech.atms.vat.entity.VatEnterpriseAccount;

import java.util.List;

public interface ReportService {
    OperationResultDto<List<ReportDto>> getReportTemplate(String projectID, EnumServiceType serviceType, Integer period);

    OperationResultDto updateConfig(String projectId, Integer period, Boolean ifDeleteManualDataSource, String generator);

    OperationResultDto generateData(String projectId, EnumServiceType serviceType, Boolean ifDeleteManualDataSource, Integer periodParam, Integer reportType, String generator);

    List<CellTemplateReferenceDto> getTemplateReferences(int period);

    OperationResultDto<ReportDataDto> getCellData(Long reportId);

    OperationResultDto<Report> getReportByTemplate(Long templateId, Integer period);

    OperationResultDto<PeriodCellTemplateConfig> getCellTemplateConfig(Long reportTemplateId, Integer periodParam, int rowIndex, int columnIndex);

    OperationResultDto<List<VatEnterpriseAccount>> getStdAccountByIndustry(String industryID);

    OperationResultDto<List<VatEnterpriseAccountResultDto>> getCellAccountRange(Long reportTemplateId, Integer period, int rowIndex, int columnIndex);
}
