package pwc.taxtech.atms.vat.service;

import pwc.taxtech.atms.constant.enums.VoucherSearchEnum;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.PagingDto;
import pwc.taxtech.atms.dto.vatdto.QueryConditionDto;
import pwc.taxtech.atms.dto.vatdto.VatEnterpriseAccountDto;

import java.util.List;

public interface VoucherService {
    /**
     * 按分录显示查询
     * @param listQueryCondition 查询条件模板
     * @param mainRelation 查询条件之间的逻辑关系
     * @param allJe 显示全部凭证
     * @param pagingInfo 分页信息
     * @return 分录信息
     */
    OperationResultDto<Object> voucherSelectAdvancedByEntry(List<QueryConditionDto> listQueryCondition, VoucherSearchEnum mainRelation, boolean allJe, PagingDto pagingInfo) throws Exception;

    /**
     * 根据满足查询条件返回总数
     * @param listQueryCondition 查询条件模板
     * @param mainRelation 查询条件之间的逻辑关系
     * @param isEntryShow 是否为分录显示
     * @param allJe 显示全部凭证
     * @return 满足条件的总条数
     */
    OperationResultDto<Object> voucherSelectAdvancedCount(List<QueryConditionDto> listQueryCondition, VoucherSearchEnum mainRelation, boolean isEntryShow, boolean allJe) throws Exception;

    /**
     * 按凭证显示查询
     * @param listQueryCondition 查询条件模板
     * @param mainRelation 查询条件之间的逻辑关系
     * @param allJe 显示全部凭证
     * @param pagingInfo 分页信息
     * @return 凭证信息
     */
    OperationResultDto<Object> voucherSelectAdvancedByVoucher(List<QueryConditionDto> listQueryCondition, VoucherSearchEnum voucherSearchEnum, boolean allJe, PagingDto pagingInfo) throws Exception;
}
