package pwc.taxtech.atms.vat.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import pwc.taxtech.atms.dao.AreaRegionMapper;
import pwc.taxtech.atms.vat.dao.InvoiceMappingMapper;
import pwc.taxtech.atms.vat.dao.VoucherMappingMapper;
import pwc.taxtech.atms.vat.entity.InvoiceMapping;
import pwc.taxtech.atms.vat.entity.InvoiceMappingExample;
import pwc.taxtech.atms.vat.entity.VoucherMapping;
import pwc.taxtech.atms.vat.entity.VoucherMappingExample;

import java.util.Comparator;
import java.util.List;

@Service
public class VoucherInvoiceMappingServiceImpl {
    @Autowired
    private InvoiceMappingMapper invoiceMappingMapper;
    @Autowired
    private VoucherMappingMapper voucherMappingMapper;

    public List<VoucherMapping> getVourcherMappings(Integer period) {
        VoucherMappingExample example = new VoucherMappingExample();
        example.createCriteria().andPeriodEqualTo(period);
        List<VoucherMapping> result = voucherMappingMapper.selectByExample(example);
        result.sort(Comparator.comparing(invoiceMapping -> invoiceMapping.getTranCode() + "_"
                + invoiceMapping.getGroup() + "_" + invoiceMapping.getItemID()));

        return result;
    }

    public List<InvoiceMapping> getInvoiceMappings(Integer period) {
        InvoiceMappingExample example = new InvoiceMappingExample();
        example.createCriteria().andPeriodEqualTo(period);
        List<InvoiceMapping> result = invoiceMappingMapper.selectByExample(example);
        result.sort(Comparator.comparing(invoiceMapping -> invoiceMapping.getPeriod() + "_"
                + invoiceMapping.getInvoiceCode() + "_" + invoiceMapping.getInvoiceNumber()));

        return result;
    }
}
