package pwc.taxtech.atms;

import java.lang.reflect.Field;

public class FieldsCompare {
    public static <S, D> void map(S source, D dest) throws ClassNotFoundException, IllegalAccessException {
        Class destClass = Class.forName(dest.getClass().getName());
        Class clsSource = Class.forName(source.getClass().getName());

        Field[] declaredFields = destClass.getDeclaredFields();
        Field[] clsFields = clsSource.getDeclaredFields();
        System.out.println(destClass.getName());
        System.out.println();
        System.out.println(clsSource.getName());
        System.out.println(clsFields.toString());

        System.out.println(clsSource.getName() + ":" + clsFields.length);
        System.out.println(destClass.getName() + ":" + declaredFields.length);

        Field[] fieldsMax = null;
        Field[] fieldsMin = null;
        Class fieldsMaxClass = null;
        Class fieldsMinClass = null;
        if (declaredFields.length > clsFields.length) {
            fieldsMax = declaredFields;
            fieldsMin = clsFields;

            fieldsMaxClass = destClass;
            fieldsMinClass = clsSource;
        } else {
            fieldsMax = clsFields;
            fieldsMaxClass = clsSource;

            fieldsMin = declaredFields;
            fieldsMinClass = destClass;
        }

        for (Field field : fieldsMax) {
            field.setAccessible(true);
            String fieldName = field.getName();
            try {
                if ("serialVersionUID".equals(fieldName)) {
                    continue;
                }
                fieldsMinClass.getDeclaredField(fieldName);

            } catch (NoSuchFieldException e) {
                System.out.println("NoSuchFieldException " + fieldsMinClass.getName() + "." + fieldName);
            }
        }

        for (Field field : fieldsMin) {
            field.setAccessible(true);
            String fieldName = field.getName();
            try {
                if ("serialVersionUID".equals(fieldName)) {
                    continue;
                }
                fieldsMaxClass.getDeclaredField(fieldName);

            } catch (NoSuchFieldException e) {
                System.out.println("NoSuchFieldException " + fieldsMaxClass.getName() + "." + fieldName);
            }
        }
    }

    public static void main(String[] args) throws IllegalAccessException, ClassNotFoundException {
//        map(new CompanyBalanceDto(), new CompanyBalance());
    }
}