package pwc.taxtech.atms.common;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;

import pwc.taxtech.atms.CommonIT;
import pwc.taxtech.atms.security.JwtAuthenticationProvider;
import pwc.taxtech.atms.security.JwtAuthenticationToken;

public class AuthUserHelperIT extends CommonIT {

    @Autowired
    private AuthUserHelper authUserHelper;

    @Autowired
    private JwtAuthenticationProvider jwtAuthenticationProvider;

    @Before
    public void init() {
        Authentication request = new JwtAuthenticationToken("xxxx");
        Authentication authenticaiton = jwtAuthenticationProvider.authenticate(request);
        SecurityContextHolder.getContext().setAuthentication(authenticaiton);
    }

    @Test
    public void test() {
        Assert.assertNotNull(SecurityContextHolder.getContext());
        Assert.assertNotNull(SecurityContextHolder.getContext().getAuthentication());
        Assert.assertNotNull(SecurityContextHolder.getContext().getAuthentication().getName());
        Assert.assertNotNull(authUserHelper);
        Assert.assertNotNull(authUserHelper.getCurrentAuditor());
        System.out.println(authUserHelper.getCurrentAuditor());
    }
}
