package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.dto.LoginOutputDto;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.user.UserPasswordDto;
import pwc.taxtech.atms.service.UserAccountService;

@RunWith(MockitoJUnitRunner.class)
public class AccountControllerTest {
//    @Mock
//    private UserService userService;
    @Mock
    private UserAccountService userAccountService;
    @InjectMocks
    private AccountController accountController;

    @Test
    public void nullResult() {
        UserPasswordDto userPasswordDto = new UserPasswordDto();
        assertThat(accountController.changeExternalUserPassword(userPasswordDto)).isNull();
    }

    @Test
    public void notNullResult() {
        UserPasswordDto userPasswordDto = new UserPasswordDto();
        when(userAccountService.changeExternalUserPassword(userPasswordDto))
                .thenReturn(new OperationResultDto<LoginOutputDto>());
        assertThat(accountController.changeExternalUserPassword(userPasswordDto)).isNotNull();
    }

}
