package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.common.CommonConstants;
import pwc.taxtech.atms.common.CommonUtils;
import pwc.taxtech.atms.dto.AreaDto;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.service.AreaService;

@RunWith(MockitoJUnitRunner.class)
public class AreaControllerTest {
    
    @Mock
    private AreaService areaService;

    @InjectMocks
    private AreaController areaController = new AreaController();
    
    @Test
    public void setIsActiveNotNullResult() {
        
        AreaDto areaDto = new AreaDto();
        areaDto.setID(CommonUtils.getUUID());
        areaDto.setIsActive(CommonConstants.ACTIVE_STATUS);
        areaDto.setName("areaNotNull");
        
        OperationResultDto<List<String>> operationResultDto = new OperationResultDto<>();
        when(areaService.setIsActive(areaDto)).thenReturn(operationResultDto);
        assertThat(areaController.setIsActive(areaDto)).isNotNull();
    }
    
    @Test
    public void getAreaListTest() {
        when(areaService.getAreaList(1)).thenReturn(new ArrayList<>());
        assertThat(areaController.getAreaList(1)).isNotNull();
    }
}
