package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.common.CommonUtils;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.arearegion.AreaRegionInfo;
import pwc.taxtech.atms.service.AreaRegionService;

@RunWith(MockitoJUnitRunner.class)
public class AreaRegionControllerTest {
    
    @Mock
    private AreaRegionService areaRegionService;

    @InjectMocks
    private AreaRegionController areaRegionController = new AreaRegionController();
    
    @Test
    public void addNotNullResult() {
        
        AreaRegionInfo areaRegionInfo = new AreaRegionInfo();
        areaRegionInfo.setName("areaNotNull");
        areaRegionInfo.setParentId(CommonUtils.getUUID());
        
        OperationResultDto<?> operationResultDto = new OperationResultDto<>();
        when(areaRegionService.add(areaRegionInfo)).thenReturn(operationResultDto);
        assertThat(areaRegionController.add(areaRegionInfo)).isNotNull();
    }
    
    @Test
    public void updateNotNullResult() {
        
        AreaRegionInfo areaRegionInfo = new AreaRegionInfo();
        areaRegionInfo.setName("areaNotNull");
        areaRegionInfo.setParentId(CommonUtils.getUUID());
        
        OperationResultDto<?> operationResultDto = new OperationResultDto<>();
        when(areaRegionService.update(areaRegionInfo)).thenReturn(operationResultDto);
        assertThat(areaRegionController.update(areaRegionInfo)).isNotNull();
    }
}
