package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.common.CommonUtils;
import pwc.taxtech.atms.dto.BusinessUnitDto;
import pwc.taxtech.atms.dto.IdModel;
import pwc.taxtech.atms.service.BusinessUnitService;

@RunWith(MockitoJUnitRunner.class)
public class BusinessUnitControllerTest {

    @Mock
    private BusinessUnitService businessUnitService;

    @InjectMocks
    private BusinessUnitController businessUnitController = new BusinessUnitController();

    @Test
    public void getBusinessUnitsNotNullResult() {
        List<BusinessUnitDto> businessUnitDtos = new ArrayList<>();
        when(businessUnitService.getBusinessUnits()).thenReturn(businessUnitDtos);
        assertThat(businessUnitController.getBusinessUnits()).isNotNull();
    }

    @Test
    public void updateBusinessUnitsNotNullResult() {
        List<BusinessUnitDto> businessUnitDtos = new ArrayList<>();
        BusinessUnitDto businessUnitDto = new BusinessUnitDto();
        businessUnitDto.setID(CommonUtils.getUUID());
        businessUnitDto.setIsActive(true);
        businessUnitDto.setName("businessUnitNotNull");
        businessUnitDtos.add(businessUnitDto);

        when(businessUnitService.updateBusinessUnits(businessUnitDtos)).thenReturn(true);
        assertThat(businessUnitController.updateBusinessUnits(businessUnitDtos)).isNotNull();
    }

    @Test
    public void deleteBusinessUnitNotNullResult() {
        IdModel idModel = new IdModel();
        idModel.setID(CommonUtils.getUUID());

        when(businessUnitService.deleteBusinessUnit(idModel)).thenReturn(1);
        assertThat(businessUnitController.deleteBusinessUnit(idModel)).isNotNull();
    }

}
