package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.dto.MenuDisplayDto;
import pwc.taxtech.atms.dto.MenuDto;
import pwc.taxtech.atms.service.MenuService;

@RunWith(MockitoJUnitRunner.class)
public class MenuControllerTest {

    @Mock
    private MenuService menuService;

    @InjectMocks
    private MenuController menuController = new MenuController();

    @Test
    public void getMenusForDisplayNotNull() {
        List<MenuDisplayDto> menuDisplayDtos = new ArrayList<>();
        Integer moduleId = 1;
        when(menuService.getMenusForDisplay(moduleId)).thenReturn(menuDisplayDtos);
        assertThat(menuController.getMenusForDisplay(moduleId)).isNotNull();
    }

    @Test
    public void getMenusNotNull() {
        List<MenuDto> menuDtos = new ArrayList<>();
        Integer moduleId = 1;
        when(menuService.getMenus(moduleId)).thenReturn(menuDtos);
        assertThat(menuController.getMenus(moduleId)).isNotNull();
    }

}
