package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.common.CommonUtils;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.OrganizationStructureDto;
import pwc.taxtech.atms.dto.OrganizationStructureInputDto;
import pwc.taxtech.atms.dto.customer.CustomerDto;
import pwc.taxtech.atms.dto.customer.CustomerValidateInfoDto;
import pwc.taxtech.atms.service.CustomerService;
import pwc.taxtech.atms.service.OrganizationStructureService;

@RunWith(MockitoJUnitRunner.class)
public class OrganizationStructureControllerTest {
    @Mock
    private OrganizationStructureService organizationStructureService;
    @InjectMocks
    private OrganizationStructureController organizationStructureController = new OrganizationStructureController();

    @Test
    public void addRangeNotNullResult() {
        List<OrganizationStructureDto> organizationStructureDtoList = new ArrayList<>();
        when(organizationStructureService.getOrganizationStructures()).thenReturn(organizationStructureDtoList);
        assertThat(organizationStructureController.getOrganizationStructures()).isNotNull();
    }
    
    @Test
    public void addOrganizationStructuresNotNullResult() {
        List<OrganizationStructureInputDto> organizationStructureDtoList = new ArrayList<>();
        OrganizationStructureInputDto organizationStructureDto = new OrganizationStructureInputDto();
        organizationStructureDto.setID(CommonUtils.getUUID());
        organizationStructureDto.setIsActive(true);
        organizationStructureDto.setName("organization-tructure-name");
        organizationStructureDtoList.add(organizationStructureDto);
        
        when(organizationStructureService.updateOrganizationStructures(organizationStructureDtoList)).thenReturn(true);
        assertThat(organizationStructureController.updateOrganizationStructure(organizationStructureDtoList)).isNotNull();
    }
    
}
