package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.Arrays;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.dto.navtree.DevTreeDto;
import pwc.taxtech.atms.dto.navtree.RolePermissionDisplayDto;
import pwc.taxtech.atms.service.PermissionService;

@RunWith(MockitoJUnitRunner.class)
public class PermissionControllerTest {

    @Mock private PermissionService permissionService;
    
    @InjectMocks
    private PermissionController permissionController = new PermissionController();
    
    @Test
    public void getIvhTreePermissionsByRoleIDTest() {
        when(permissionService.getIvhTreePermissionsByRoleID("ID", "serviceType")).thenReturn(new RolePermissionDisplayDto());
        assertThat(permissionController.getIvhTreePermissionsByRoleID("ID", "serviceType")).isNotNull();
    }
    
    @Test
    public void getIvhTreePermissionsByRoleIDListTest() {
        when(permissionService.getIvhTreePermissionsByRoleIDList(Arrays.asList("ID1","ID2"), "serviceType")).thenReturn(new ArrayList<DevTreeDto>());
        assertThat(permissionController.getIvhTreePermissionsByRoleIDList(Arrays.asList("ID1","ID2"), "serviceType")).isNotNull();
    }
    
    @Test 
    public void getAllPermissionsTest() {
        when(permissionService.getAllPermissions("serviceType")).thenReturn(new ArrayList<DevTreeDto>());
        assertThat(permissionController.getAllPermissions("serviceType")).isNotNull();
    }
}
