package pwc.taxtech.atms.controller;

import static org.assertj.core.api.Assertions.assertThat;
import static org.mockito.Mockito.when;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.MockitoJUnitRunner;

import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.StatisticAttributeDisplayDto;
import pwc.taxtech.atms.dto.StatisticAttributeDto;
import pwc.taxtech.atms.service.StatisticAttributeService;

@RunWith(MockitoJUnitRunner.class)
public class StatisticAttributeControllerTest {

    @Mock
    private StatisticAttributeService statisticAttributeService;

    @InjectMocks
    private StatisticAttributeController statisticAttributeController = new StatisticAttributeController();

    @Test
    public void getByParentDimensionIDTest() {
        List<StatisticAttributeDisplayDto> statisticAttributeDisplayDtos = new ArrayList<>();
        when(statisticAttributeService.getStatisticAttributeListByDimensionID("1", null))
                .thenReturn(statisticAttributeDisplayDtos);
        assertThat(statisticAttributeController.getDimensionStatics("1")).isNotNull();
    }

    @Test
    public void getStatisticAttributeListTest() {
        List<StatisticAttributeDto> statisticAttributeDisplayDtos = new ArrayList<>();
        when(statisticAttributeService.getStatisticAttributeList("1")).thenReturn(statisticAttributeDisplayDtos);
        assertThat(statisticAttributeController.getStatisticAttributeList("1")).isNotNull();
    }

    @SuppressWarnings("rawtypes")
    @Test
    public void updateDimensionTest() {
        OperationResultDto operationResultDto = new OperationResultDto();
        List<StatisticAttributeDisplayDto> modelList = new ArrayList<>();
        when(statisticAttributeService.updateStatisticAttribute(modelList)).thenReturn(operationResultDto);
        assertThat(statisticAttributeController.updateDimension(modelList)).isNotNull();
    }

    @Test
    public void getOrgSubChildrenStatAttributeListTest() {
        List<StatisticAttributeDisplayDto> statisticAttributeDisplayDtos = new ArrayList<>();
        when(statisticAttributeService.getOrgSubChildrenStatAttributeList("1"))
                .thenReturn(statisticAttributeDisplayDtos);
        assertThat(statisticAttributeController.getOrgSubChildrenStatAttributeList("1")).isNotNull();
    }
}
