package pwc.taxtech.atms.service.impl;

import java.util.Date;
import java.util.List;

import org.apache.commons.lang3.BooleanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.interceptor.TransactionAspectSupport;

import pwc.taxtech.atms.common.CommonUtils;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.dimension.DimensionDto;
import pwc.taxtech.atms.entitiy.Dimension;
import pwc.taxtech.atms.service.DemoService;

@Service
public class DemoServiceImpl extends AbstractService implements DemoService {

    @Override
    public OperationResultDto addDimensionWithoutTranction(List<DimensionDto> modelList) {
        logger.debug("Enter addDimensionWithoutTranction");
        try {
            int i = 0;
            for (DimensionDto model : modelList) {
                logger.debug("Insert 第{}条记录, name:{}", ++i, model.getName());
                Dimension entity = new Dimension();
                CommonUtils.copyProperties(model, entity);
                entity.setID(CommonUtils.getUUID());
                entity.setOrderIndex((short) 1);
                entity.setIsSystemDimension(false);
                entity.setIsMandatory(BooleanUtils.isTrue(entity.getIsMandatory()));
                entity.setIsActive(BooleanUtils.isTrue(entity.getIsActive()));
                String currentUserId = authUserHelper.getCurrentUserID();
                entity.setCreateBy(currentUserId);
                entity.setUpdateBy(currentUserId);
                entity.setCreateTime(new Date());
                entity.setUpdateTime(new Date());
                dimensionMapper.insert(entity);
            }
            return new OperationResultDto(true);
        } catch (Exception e) {
            logger.debug("出错了:" + e);
            return new OperationResultDto(false);
        }
    }

    @Override
    public OperationResultDto addDimensionWithTranction(List<DimensionDto> modelList) {
        logger.debug("Enter addDimensionWithTranction");
        try {
            int i = 0;
            for (DimensionDto model : modelList) {
                logger.debug("Insert 第{}条记录, name:{}", ++i, model.getName());
                Dimension entity = new Dimension();
                CommonUtils.copyProperties(model, entity);
                entity.setID(CommonUtils.getUUID());
                entity.setOrderIndex((short) 1);
                entity.setIsSystemDimension(false);
                entity.setIsMandatory(BooleanUtils.isTrue(entity.getIsMandatory()));
                entity.setIsActive(BooleanUtils.isTrue(entity.getIsActive()));
                String currentUserId = authUserHelper.getCurrentUserID();
                entity.setCreateBy(currentUserId);
                entity.setUpdateBy(currentUserId);
                entity.setCreateTime(new Date());
                entity.setUpdateTime(new Date());
                dimensionMapper.insert(entity);
            }
            return new OperationResultDto(true);
        } catch (Exception e) {
            logger.debug("出错了:" + e);
            logger.debug("标记回滚, ready to call setRollbackOnly");
            TransactionAspectSupport.currentTransactionStatus().setRollbackOnly();
            return new OperationResultDto(false);
        }
    }

    @Override
    public OperationResultDto addDimensionWithTranctionType2(List<DimensionDto> modelList) {
        logger.debug("Enter addDimensionWithTranctionType2");
        int i = 0;
        for (DimensionDto model : modelList) {
            logger.debug("Insert 第{}条记录, name:{}", ++i, model.getName());
            Dimension entity = new Dimension();
            CommonUtils.copyProperties(model, entity);
            entity.setID(CommonUtils.getUUID());
            entity.setOrderIndex((short) 1);
            entity.setIsSystemDimension(false);
            entity.setIsMandatory(BooleanUtils.isTrue(entity.getIsMandatory()));
            entity.setIsActive(BooleanUtils.isTrue(entity.getIsActive()));
            String currentUserId = authUserHelper.getCurrentUserID();
            entity.setCreateBy(currentUserId);
            entity.setUpdateBy(currentUserId);
            entity.setCreateTime(new Date());
            entity.setUpdateTime(new Date());
            dimensionMapper.insert(entity);
        }
        return new OperationResultDto(true);
    }

}
