package pwc.taxtech.atms.service.impl;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import pwc.taxtech.atms.CommonIT;
import pwc.taxtech.atms.dao.MailQueueMapper;
import pwc.taxtech.atms.dto.MailMto;
import pwc.taxtech.atms.entitiy.MailQueue;
import pwc.taxtech.atms.service.CommonService;

import java.util.Date;

public class MailServiceIT extends CommonIT {
    private static final Logger logger = LoggerFactory.getLogger(MailServiceIT.class);
    @Autowired
    private CommonService commonService;
    @Autowired
    private MailQueueMapper mailQueueMapper;

    @Before
    public void setUp() {
        mailQueueMapper.deleteByExample(null);
    }

    @Test
    public void sendMail() {
        MailMto mailmto = new MailMto();
        mailmto.setTo("test@test.com");
        mailmto.setSubject("sub1");
        mailmto.setContent("content1");
        commonService.sendMail(mailmto);
        long count = mailQueueMapper.countByExample(null);
        Assert.assertTrue(count > 0);
    }

    @Test
    public void insertThenCount() {
        MailQueue record = new MailQueue();
        record.setAppcode("appcode1");
        record.setMto("a@a.com");
        record.setMfrom("from@a.com");
        record.setReplyto("from@a.com");
        record.setSubject("subject1中文");
        record.setContent("aaabbb");
        record.setSubmitby("by1");
        record.setSubmitdate(new Date());
        record.setPostedflag("N");
        record.setSenddate(new Date());
        record.setImmediateflag("N");
        Assert.assertNull(record.getMailseq());
        int inserted = mailQueueMapper.insert(record);
        // logger.debug("inserted:{}", inserted);
        Assert.assertTrue(inserted > 0);
        // logger.debug("record.getMailseq():{}", record.getMailseq());
        Assert.assertNotNull(record.getMailseq());

        long count = mailQueueMapper.countByExample(null);
        // logger.debug("MailQueue count:{}", count);
        Assert.assertTrue(count > 0);
    }

}
