package pwc.taxtech.atms.service.impl;

import java.util.ArrayList;
import java.util.List;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import pwc.taxtech.atms.CommonIT;
import pwc.taxtech.atms.CommonTestUtils;
import pwc.taxtech.atms.dto.ProjectClientDto;
import pwc.taxtech.atms.dto.ServiceTypeDto;
import pwc.taxtech.atms.service.ProjectService;

public class ProjectServiceIT extends CommonIT {
    private static final Logger logger = LoggerFactory.getLogger(ProjectServiceIT.class);

    @Autowired
    private ProjectService projectService;

    @Before
    public void setUp() {
        cleanUpAllTables();
        CommonTestUtils.initTestAuth();
    }

    @Test
    public void getServiceListOk() {

        logger.debug("Start excute sql/templateGroup_test_data.sql");
        execSqlFile("sql/templateGroup_test_data.sql");

        logger.debug("Start excute sql/serviceType_test_data.sql");
        execSqlFile("sql/serviceType_test_data.sql");

        List<ServiceTypeDto> result = new ArrayList<ServiceTypeDto>();
        result = projectService.getServiceList();
        Assert.assertEquals(8, result.size());
        Assert.assertEquals(1, result.get(0).getTemplateGroupList().size());
    }

    @Test
    public void getProjectClientListOk() {

        logger.debug("Start excute sql/projectClient_test_data.sql");
        execSqlFile("sql/projectClient_test_data.sql");

        List<ProjectClientDto> result = new ArrayList<ProjectClientDto>();
        result = projectService.getProjectClientList();
        Assert.assertTrue("find client 'pwc' in db", result.stream().anyMatch(res -> "pwc".equals(res.getName())));
    }

}
