﻿infrastructureModule
   .controller('OrganizationListViewController', ['$location', '$scope', '$log', 'SweetAlert', '$translate', 'areaRegionService', 'uiGridTreeViewConstants', '$timeout', 'dimensionService', '$interval', 'orgService', '$q','loginContext',
        function ($location, $scope, $log, SweetAlert, $translate, areaRegionService, uiGridTreeViewConstants, $timeout, dimensionService, $interval, orgService, $q, loginContext) {

            $scope.expanded = true;
            var translate={
                Enabled:$translate.instant('BusinessUnitActive'),  //已启用
                Disabled: $translate.instant('BusinessUnitDisabled'),//已停用
            };
            $scope.showOperateLogPop = function () {
                $scope.isShowLog = true;
                // $('#showOperatePop').modal('show');
            };

            //添加过滤下拉列表
            var InitFilterList = function () {
                //初始化选择器为空
                $scope.filter = {};
                $scope.filter.selected = [];

                var datasource = constant.taxpayerNumberFilter.dataSource;

                datasource.forEach(function (row) {
                    row.value = $translate.instant(row.value);
                });
                $scope.taxPayerFilterList = datasource;
            };


            //筛选的时候，ng-check event will be triggered
            $scope.stateChanged = function ($event, data) {
                $scope.filter.selected = [];
                var checkbox = $event.target;
                if (checkbox.checked && $scope.filter.selected.indexOf(data.key) < 0) {
                    $scope.filter.selected.push(data.key);
                }

                taxPayerFilterChanged();
            };

            var taxPayerFilterChanged = function () {
                var selectedList = $scope.filter.selected;
                if (selectedList.length == 0) return;
                
                var selectedID = $scope.filter.selected[0] || constant.taxpayerNumberFilter.key_0;
                var oldData = angular.copy($scope.oldData);
                switch (selectedID) {
                    //所有对应状态,取默认值
                    case constant.taxpayerNumberFilter.key_0:  //all data
                        $scope.DataGridSource = oldData;
                        break;
                        //have taxpayerNumber
                    case constant.taxpayerNumberFilter.key_1:
                        var findResult = _.filter(oldData, function (item) {
                            return item.taxPayerNumber !== null && item.taxPayerNumber != '';
                        });
                        $scope.DataGridSource = findResult;
                        break;
                        //Don't have taxpayerNumber
                    case constant.espAccountFilter.key_2:
                        var findResult = _.filter(oldData, function (item) {
                            return item.taxPayerNumber == null || item.taxPayerNumber == '';
                        });
                        $scope.DataGridSource = findResult;
                        break;
                }

                $scope.orgTreeListInstance.refresh();
            };


            $scope.createOrg = function ()
            {
                $scope.orgOperateType = constant.Operation.Add;
                $scope.selectedOrg = null;
                $scope.isOrgUpdate = false;
            };

            // 添加或者编辑机构成功之后，刷新当前页面的数据
            $scope.$watch('isOrgUpdate', function (newValue, oldValue) {
                if (newValue) {
                    getOrgList();
                }
            });

            var getOrgList = function () {
                orgService.getOrgListLevel().success(function (data) {
                    if (data) {
                        //data.forEach(function (row) {
                        //    if (row.userList) {
                        //        row.userListStr = _.map(row.userList, function (x) { return x.userName; }).join(constant.comma);
                        //    }
                        //});
                        //console.log("dat:" + JSON.stringify(data));
                        if (loginContext.userName && loginContext.userName.toLowerCase() === "simon") {
                            data = _.filter(data, function (row) {
                                return row && row.industryID === "10";
                            });
                        }
                        $scope.DataGridSource = data;
                        $scope.oldData = angular.copy(data);
                        $scope.setGridHeight();
                    }
                });
            };

            
            $scope.collapseAll = function () {
                var treeList = $scope.orgTreeListInstance;
                treeList.beginUpdate();
                $scope.DataGridSource.forEach(function (item) {

                    treeList.collapseRow(item.id);
                });
          
                treeList.endUpdate();
                $scope.expanded = false;
            }

            $scope.expandAll = function () {
                var treeList = $scope.orgTreeListInstance;
                treeList.beginUpdate();
                $scope.DataGridSource.forEach(function (item) {

                    treeList.expandRow(item.id);
                });

                treeList.endUpdate();
                $scope.expanded = true;
            }

            var loadDatagrid = function () {

                $scope.orgUserTreeOptions = {
                    bindingOptions: {
                        dataSource: 'DataGridSource'
                    },
                    columns: [
                            {
                                dataField: "name",
                                caption: $translate.instant('OrganizationName'),
                                allowHeaderFiltering:false,
                                cellTemplate: function (container, options) {
                                    try {
                                        $('<a class="hyper-link">' + options.value + '</a>')
                                            .attr('href', '#/organization/' + options.row.data.id)
                                            .appendTo(container);
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },
                            {
                                dataField: "code",
                                allowHeaderFiltering: false,
                                caption: $translate.instant('OrganizationCode')
                            },
                            {
                                dataField: "taxPayerNumber",
                                allowHeaderFiltering: true,
                                caption: $translate.instant('TaxPayerNumber'),
                                //headerFilter: {
                                //    dataSource: {
                                //        load: function () {
                                //            return [{
                                //                text: hasTaxpayNumer,
                                //                 value: [['taxPayerNumber', '<>', null],'and', ['taxPayerNumber', '<>', '']]
                                //            }, {
                                //                text: noTaxpayNumer,
                                //                value: [['taxPayerNumber', '=', null], 'or', ['taxPayerNumber', '=', '']]
                                //            }];
                                //        }
                                //    }
                                //},

                            },
                            {
                                dataField: "structureName",
                                caption: $translate.instant('OrganizationStructureDesc')
                            },
                            {
                                dataField: "regionName",
                                caption: $translate.instant('AreaRegionTitle'),
                                allowHeaderFiltering: false,
                            },
                             {
                                 dataField: "businessUnitName",
                                 caption: $scope.businessName,
                                 allowHeaderFiltering: false,
                             },
                            {
                                dataField: "areaName",
                                caption: $scope.areaName,
                                allowHeaderFiltering: false,
                            },
                            {
                                dataField: "industryName",
                                caption: $translate.instant('PIndustry'),
                                allowHeaderFiltering: false,
                            },
                            {
                                dataField: "isActive",
                                caption: $translate.instant('EnableStatus'),
                                allowHeaderFiltering: false,
                                cellTemplate: function (container, options) {
                                    try {
                                        if (options.data.isActive) {
                                            $('<span>').text(translate.Enabled).appendTo(container);
                                        }
                                        else {
                                            $('<span style="color:gray">').text(translate.Disabled).appendTo(container);
                                        }
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            }
                    ],
                    onContentReady: function (e) {
                        $scope.orgTreeListInstance = e.component;
                        var totalCount =e.component.totalCount();
                        if(totalCount>0)
                        {
                            $scope.totalCount=totalCount;
                        }
                    },
                    loadPanel: {
                        enabled: false
                    },
                    scrolling: {
                        mode: "virtual"
                    },
                    keyExpr: "id",
                    parentIdExpr: "parentID",
                    selection: {
                        mode: "single"
                    },
                    autoExpandAll:true,
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,  //单双行颜色
                    noDataText: $translate.instant('NoDataText'),
                    showBorders: true,
                    selectAllText: $translate.instant('SelectAll'),
                    searchPanel: {
                        placeholder: $translate.instant('Search'),
                        width: 518,
                        visible: true
                    },
                    headerFilter: {
                        visible: false,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: $translate.instant('SelectAll'),
                        }
                    },

                    //columnHidingEnabled: true, //自定义显示列
                    //columnChooser: {
                    //    enabled: true,
                    //    mode: "select"
                    //},
                };

            };

            var getDimensionList = function () {
                dimensionService.getDimensionList().success(function (data) {
                    if (data) {
                        $scope.customDimensionList = data;

                        $log.debug($scope.customDimensionList);

                        $scope.businessName = dimension.getBusinessUnitName();
                        $scope.areaName = dimension.getAreaName();
                        
                        loadDatagrid();
                    }
                });
            };

            var dimension = {
                getBusinessUnitName: function () {
                    var findResult = _.find($scope.customDimensionList, function (item) {
                        return item.id == constant.dimensionID.businessUnitID;
                    });
                    if (findResult) {
                        return findResult.name;
                    }
                    else {
                        return '';
                    }
                },
                getAreaName: function () {
                    var findResult = _.find($scope.customDimensionList, function (item) {
                        return item.id == constant.dimensionID.areaID;
                    });
                    if (findResult) {
                        return findResult.name;
                    }
                    else {
                        return '';
                    }
                }
            };

            var initData = function () {
                InitFilterList();
                getDimensionList();
                getOrgList();
            };

            var checkUserPermission = function () {

                var list = [];
                $scope.hasQueryPermission = false;
                $scope.hasAddPermission = false;
                $scope.hasEditPermission = false;

                var temp = constant.adminPermission.infrastructure.organizationManage;
                list.push(temp.queryCode);
                list.push(temp.addCode);
                list.push(temp.editCode);

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    $scope.hasQueryPermission = data[temp.queryCode];
                    $scope.hasAddPermission = data[temp.addCode];
                    $scope.hasEditPermission = data[temp.editCode];
                    if ($scope.hasQueryPermission) {
                        initData();
                    }
                });
            };


            (function initialize() {
                $log.debug('OrganizationListViewController.ctor()...');
      
                checkUserPermission();
            })();
        }
   ]);