﻿basicDataModule
    .controller('OrganizationViewInfrastructureController', ['$scope', '$log', 'SweetAlert', 'organizationStructureService', '$translate', 'businessUnitService', 'customerService', 'dimensionService', '$timeout', '$location', '$window', '$state',
        function ($scope, $log, SweetAlert, organizationStructureService, $translate, businessUnitService, customerService, dimensionService, $timeout, $location, $window, $state) {
            'use strict';

            var tabColor = ['orange', 'orange', 'orange', 'purple', 'pink', 'orange', 'purple', 'pink', 'orange'];

            var dimensionId = "#editDimensionModal";

            var dimensionFormValidator = null;

            var selected = null,
                previous = null;

            $scope.showOperateLogPop = function () {
                $scope.isShowLog = true;
            };

            var getDimensionStatics = function () {
                dimensionService.getDimensionStatics().success(function (data) {

                    // 个数一样，改了统计值
                    $scope.dimensionStatics = data;

                    if ($scope.tabItems && $scope.tabItems.length > 0) {

                        // 如果是修改维度值
                        updateTabItem();

                    } else {

                        // 如果是新增维度值
                        //$location.path(path);
                        initTabItem();
                    }
                });
            };

            var updateTabItem = function () {
                if ($scope.dimensionStatics && $scope.dimensionStatics.length > 0) {
                    for (var i = 0; i < $scope.dimensionStatics.length; i++) {
                        var row = $scope.dimensionStatics[i];

                        var existTab = _.find($scope.tabItems, function (tab) {
                            return tab.data.id === row.id;
                        });

                        if (existTab) {

                            existTab.data = row;
                            continue;
                        }
                        var item = {
                            id: i,
                            color: tabColor[row.dimensionType],
                            isEdit: true,
                            data: row,
                        };

                        // 变成灰色
                        if (row.dimensionType === constant.DimensionType.BusinessUnit) {
                            // 事业部
                            if ($scope.hasBuQueryPermission) {
                                item.iconCss = 'fa fa-bank fa-2x';
                                item.uiSref = '.organizationBusinessUnitView({dimensionID:"' + row.id + '"})';
                            }
                        } else if (row.dimensionType === constant.DimensionType.Area) {
                            // 区域
                            if ($scope.hasAreaQueryPermission) {
                                item.iconCss = 'material-icons';
                                item.iconText = 'place';
                                item.uiSref = '.organizationAreaView({dimensionID:"' + row.id + '"})';
                            }
                        }
                            //else if (row.dimensionType === constant.DimensionType.OrganizationStructure && $scope.hasOrgQueryPermission) {
                            //    //机构层级
                            //    item.iconCss = 'fa fa-building fa-2x';
                            //    item.uiSref = '.organizationSubsidiaryView({dimensionID:"' + row.id + '"})';
                            //}
                        else if (row.dimensionType === constant.DimensionType.OrgSubChildren) {
                            if ($scope.hasOrgQueryPermission) {
                                //机构 - 子分公司
                                item.iconCss = 'fa fa-building fa-2x';
                                item.uiSref = '.organizationSubsidiaryView({dimensionID:"' + row.id + '"})';
                            }
                        } //股权架构
                        else if (row.dimensionType === constant.DimensionType.Stock) {
                            if ($scope.hasOrgQueryPermission) {
                                //股权架构
                                item.iconCss = 'fa fa-building fa-2x';
                                item.uiSref = '.storeArchitectureView({dimensionID:"' + row.id + '"})';
                            }
                        } else {
                            if ($scope.hasDimensionQueryPermission) {
                                // 自定义维度和其他
                                item.iconCss = 'fa fa-cube fa-2x';
                                item.uiSref = '.organizationBusinessUnitView({dimensionID:"' + row.id + '"})';
                            }
                        }
                        if (item.uiSref) {

                            $scope.tabItems.push(item);
                        }
                    }
                }

            };

            var initTabItem = function () {
                var tabItems = [];
                if ($scope.dimensionStatics && $scope.dimensionStatics.length > 0) {
                    for (var i = 0; i < $scope.dimensionStatics.length; i++) {
                        var row = $scope.dimensionStatics[i];
                        var item = {
                            id: i,
                            color: tabColor[row.dimensionType],
                            isEdit: true,
                            canEdit: false,
                            data: row,
                        };

                        // 变成灰色
                        if (row.dimensionType === constant.DimensionType.BusinessUnit) {
                            // 事业部

                            item.iconCss = 'fa fa-bank fa-2x';
                            item.uiSref = '.organizationBusinessUnitView({dimensionID:"' + row.id + '"})';


                            item.canEdit = $scope.hasBuEditPermission;
                        } else if (row.dimensionType === constant.DimensionType.Area) {
                            // 区域

                            item.iconCss = 'material-icons';
                            item.iconText = 'place';
                            item.uiSref = '.organizationAreaView({dimensionID:"' + row.id + '"})';


                            item.canEdit = $scope.hasAreaEditPermission;
                        }
                            //else if (row.dimensionType === constant.DimensionType.OrganizationStructure && $scope.hasOrgQueryPermission) {
                            //    //机构层级
                            //    item.iconCss = 'fa fa-building fa-2x';
                            //    item.uiSref = '.organizationSubsidiaryView({dimensionID:"' + row.id + '"})';
                            //}
                        else if (row.dimensionType === constant.DimensionType.OrgSubChildren) {

                            //机构 - 子分公司
                            item.iconCss = 'fa fa-building fa-2x';
                            item.uiSref = '.organizationSubsidiaryView({dimensionID:"' + row.id + '"})';

                            item.canEdit = $scope.hasOrgEditPermission;
                        } else if (row.dimensionType === constant.DimensionType.Stock) {
                            if ($scope.hasOrgQueryPermission) {
                                //股权架构
                                item.iconCss = 'fa fa-building fa-2x';
                                item.uiSref = '.storeArchitectureView({dimensionID:"' + row.id + '"})';
                            }
                        } else {
                            // 自定义维度和其他
                            item.iconCss = 'fa fa-cube fa-2x';
                            item.uiSref = '.organizationBusinessUnitView({dimensionID:"' + row.id + '"})';

                            item.canEdit = $scope.hasDimensionEditPermission;
                        }
                        if (item.uiSref) {
                            tabItems.push(item);
                        }

                    }
                }

                var item = {
                    id: $scope.dimensionStatics.length,
                    color: 'gray-style',
                    iconCss: 'fa fa-plus fa-2x',
                    uiSref: '',
                    isEdit: false,
                    data: {
                        dimensionValueCount: '',
                        name: '添加维度',
                        isActive: true,
                        isMandatory: false,
                    }
                };

                item.canEdit = $scope.hasDimensionEditPermission;

                tabItems.push(item);

                $scope.tabItems = tabItems;
            };

            var watchSelectedIndex = function () {
                $scope.$watch('selectedIndex', function (current, old) {
                    previous = selected;
                    if (!$scope.tabItems) {
                        return;
                    }

                    if (current) {
                        selected = $scope.tabItems[current];
                    }

                    if (old + 1 && (old != current) && previous) $log.debug('Goodbye ' + previous.data.name + '!');
                    if (current + 1 && selected) $log.debug('Hello ' + selected.data.name + '!');
                });
            };

            $scope.$on("hasDimensionUpdated", function (event, data) {
                // console.log('DimensionUpdate' + JSON.stringify(data));
                // 强制刷新机构部分

                console.log('before:selectedIndex' + $scope.selectedIndex);
                var oldselectedIndex = $scope.selectedIndex;
                $scope.selectedIndex = oldselectedIndex;
                getDimensionStatics();
                $scope.selectedIndex = oldselectedIndex;
            });

            $scope.$on("hasOrgUpdated", function (event, data) {
                // console.log('DimensionUpdate' + JSON.stringify(data));
                // 强制刷新机构部分
                getDimensionStatics();
            });


            $scope.getWidth = function () {
                var latitudeGroupWidth = $('.latitude-group').css('width');
                var width = 800;
                if (latitudeGroupWidth) {
                    width = parseInt(latitudeGroupWidth) - 20;

                    var latitudeWidth = parseInt((width - 124) / 4);
                    if (latitudeWidth > 200) {
                        $('.latitude').css('width', latitudeWidth + 'px');
                        // $('.md-tab').css('width', (latitudeWidth + 20) + 'px');
                    }
                }

                return { width: width + 'px' };
            };

            //添加维度，使用模态框实现编辑入口tabItems
            $scope.newDimension = function (data, $event) {

                if (!data.canEdit) {
                    return;
                }

                $scope.isEdit = false;
                $scope.editingObject = {
                    dimensionValueCount: 0,
                    name: '',
                    isActive: true,
                    isMandatory: false,
                };

                $scope.editingObject.name = '';
                resetDimensionField();
                $(dimensionId).modal('show');
                $event.stopPropagation();
            };

            $scope.editDimension = function (data, $event) {
                if (!data.canEdit) {
                    return;
                }

                $scope.isEdit = true;
                $scope.editingObject = angular.copy(data.data);
                resetDimensionField();
                $(dimensionId).modal('show');
                $event.stopPropagation();
            };

            //清空当前编辑字段值
            var resetDimensionField = function () {
                var elms = $(dimensionId).find("form:first div[data-for]");
                elms.html("");
                elms.attr("class", "validate-success");
            };

            //保存当前正在编辑数据行,经过界面初步校验后才会进入本功能
            $scope.saveDimension = function () {
                if ($scope.editingObject == null) {
                    showError("BusinessUnitNoSelected");
                    return;
                }

                if (!($(dimensionId).find("form").valid())) {

                    return;
                }

                var saveDimensionCallBack = function (data) {
                    if (data && data.result) {

                        SweetAlert.success($translate.instant('SaveSuccess'));
                        $(dimensionId).modal('hide');

                        if (!$scope.isEdit) {
                            // 如果是添加

                            var secondLast = $scope.tabItems.length - 1;
                            var row = data.data;
                            var item = {
                                id: $scope.tabItems.length,
                                color: tabColor[row.dimensionType],
                                isEdit: true,
                                data: row,

                            };

                            if ($scope.hasDimensionQueryPermission && row.isActive) {
                                item.iconCss = 'fa fa-cube fa-2x';
                                item.uiSref = '.organizationBusinessUnitView({dimensionID:"' + row.id + '"})';
                            }

                            $scope.tabItems.splice(secondLast, 0, item);

                            if (item.uiSref) {
                                $state.go('organizationView.organizationBusinessUnitView', { dimensionID: data.data.id });
                                return;
                            }
                        }

                        //$window.location.reload();
                        getDimensionStatics();

                        //注册一个向下传播的事件，eventName:'FromSelf', data:oneObject
                        $scope.$broadcast("DimensionUpdate", { isupdated: true });

                    } else {
                        swal($translate.instant('SaveFail'), $translate.instant(data.resultMsg), 'warning');
                    }
                };

                if (!$scope.isEdit) {
                    dimensionService.addDimension($scope.editingObject).success(saveDimensionCallBack);
                } else {
                    dimensionService.updateDimension($scope.editingObject).success(saveDimensionCallBack);
                }
            };

            var initValidateDimension = function () {
                $.validator.addMethod("dimensionNameRepeated", function (value, element, param) {
                    if ($scope.tabItems && $scope.tabItems.length > 0) {
                        var objects = $.grep($scope.tabItems, function (n, i) {
                            return $scope.editingObject.id != n.data.id && $.trim(n.data.name) == $.trim(value);
                        });

                        return objects.length < 1;
                    }

                    return true;

                });

                dimensionFormValidator = $(dimensionId).find("form").validate({
                    debug: true,

                    rules: {
                        name: {
                            required: true,
                            minlength: 2,
                            maxlength: 20,
                            dimensionNameRepeated: true
                        },
                        isActive: {
                            required: "input[name='isActive']:checked"
                        }
                    },
                    messages: {
                        name: {
                            required: $translate.instant('DimensionNameRequired'),
                            minlength: $translate.instant('DimensionNameRequired'),
                            maxlength: $translate.instant('DimensionNameOutOfLength'),
                            dimensionNameRepeated: $translate.instant('DimensionNameRepeated')
                        },
                        isActive: $translate.instant('DimensionStatusUnsureness')
                    },
                    errorPlacement: function (error, element) {
                        var elm = $(element).parents("form:first");
                        elm = elm.find("div[data-for='" + element.attr("name") + "']");
                        elm.html(error);
                        elm.attr("class", "validate-fail");
                    }
                });

            };

            var initParams = function () {
                // 设置默认tab选中项
                var url = $location.absUrl();
                // 只有第一次打开这个页面才会进来
                // console.log(url);
                if (url.indexOf('organizationAreaView') > -1) {
                    $scope.selectedIndex = 1;
                } else if (url.indexOf('organizationSubsidiaryView') > -1) {
                    $scope.selectedIndex = 2;
                } else if (url.indexOf('organizationSubsidiaryView') > -1) {
                    $scope.selectedIndex = 3;
                } else {


                    //$state.go('organizationView.organizationBusinessUnitView', { dimensionID: 'a971fe7c-079d-4722-820c-fe367a80d4cc' });
                    $scope.selectedIndex = 0;
                }
            };


            var checkUserPermission = function () {

                var list = [];

                $scope.hasDimensionQueryPermission = false;
                $scope.hasDimensionEditPermission = false;

                $scope.hasOrgQueryPermission = false;
                $scope.hasOrgEditPermission = false;

                $scope.hasAreaQueryPermission = false;
                $scope.hasAreaEditPermission = false;

                $scope.hasBuQueryPermission = false;
                $scope.hasBuEditPermission = false;

                var dimensionTemp = constant.adminPermission.basicData.selfDimension;
                list.push(dimensionTemp.queryCode);
                list.push(dimensionTemp.editCode);

                var orgTemp = constant.adminPermission.infrastructure.organizationManage;
                list.push(orgTemp.queryCode);
                list.push(orgTemp.editCode);

                var areaTemp = constant.adminPermission.basicData.areaManage;
                list.push(areaTemp.queryCode);
                list.push(areaTemp.editCode);

                var buTemp = constant.adminPermission.basicData.businessUnit;
                list.push(buTemp.queryCode);
                list.push(buTemp.editCode);

                $scope.$root.checkUserPermissionList(list).success(function (data) {
                    // console.log('data: ' + data);
                    $scope.hasDimensionQueryPermission = data[dimensionTemp.queryCode];
                    $scope.hasDimensionEditPermission = data[dimensionTemp.editCode];

                    $scope.hasOrgQueryPermission = data[orgTemp.queryCode];
                    $scope.hasOrgEditPermission = data[orgTemp.editCode];

                    $scope.hasAreaQueryPermission = data[areaTemp.queryCode];
                    $scope.hasAreaEditPermission = data[areaTemp.editCode];

                    $scope.hasBuQueryPermission = data[buTemp.queryCode];
                    $scope.hasBuEditPermission = data[buTemp.editCode];

                    if ($scope.hasOrgQueryPermission) {
                        getDimensionStatics();
                    }
                });
            };

            (function initialize() {
                $log.debug('OrganizationViewInfrastructureController.ctor()...');

                initParams();
                initValidateDimension();
                watchSelectedIndex();

                checkUserPermission();
            })();
        }
    ]);
