﻿infrastructureModule.directive('storeArchitectureView', ['$log', '$compile', '$timeout', '$interval',
   function ($log, $compile, $timeout, $interval) {
       'use strict';
       $log.debug('storeArchitectureView.ctor()...');

       return {
           restrict: 'E',
           templateUrl: '/app/admin/infrastructure/storeArchitectureView/store-architecture-view.html' + '?_=' + Math.random(),
           scope: {},
           replace: true,
           controller: 'storeArchitectureViewController',
           link: function (scope, element) {
                 
               $(".card").draggable({ containment: "parent", cursor: "cursor", handle: ".card-header" });

               var showCardSeleted = '.show-card';

               //$(document).off('click');
               element.off('click');

               var stopPropagation = function (event) {
                   event = event || window.event;
                   if (event.stopPropagation) {
                       event.stopPropagation();
                   } else {
                       event.cancelBubble = true;
                   }
               };

               element.on('mouseenter', '.node', function () {

                   $(this).find('.title-name-edit').css('display', 'block');
                   stopPropagation();
               });
               element.on('mouseleave', '.node', function () {
                   $(this).find('.title-name-edit').css('display', 'none');
                   stopPropagation();
               });


               //编辑机构的股权结构
               element.on('click', '.edit-stock-value', function () {
                   //事业部ID
                   var orgID = $(this).attr("data-organization-id");
                   if (orgID) {
                       console.log("orgID: " + orgID);

                       scope.editOrgStock(orgID);
                   }
                   stopPropagation();
                   return false;
                   //  stopPropagation();
               });

               scope.showFullScreen = function () {

                   $('.store-architecture-view').parent().toggleClass('fullScreen');
                   if ($('.store-architecture-view').parent().hasClass('fullScreen')) {
                       scope.fullScreenText = '退出全屏';
                       scope.isShowFullScreen = true;
                   } else {
                       scope.fullScreenText = '全屏展示';
                       scope.isShowFullScreen = false;
                   }
               }
           }
       };
   }
]);

