﻿systemConfigurationModule.directive('taxpayerTypeExceptionsTable', ['$log','ruleEngineOp','$rootScope',
    function ($log, ruleEngineOp, $rootScope) {
        return {
            restrict: 'E',
            templateUrl: '/app/admin/systemConfiguration/ruleEngineeConfiguration/vatRuleEnginee/taxpayer-type-exceptions-table.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                isEdit: '=',
                taxPayerExceptions: '=',
                orgs: '=',
                taxpayerTypes: '=',
                reportTypes:'=',
                selectedOrgs: '=',
                operation:'='
            },
            link: function (scope, element, attr) {

                var currentException;

                $rootScope.$on('orgsChanged', function (event, orgs) {
                    if (currentException !== undefined) {
                        currentException.orgs = orgs;
                    }
                });

                scope.openRuleEngineSelectorModel = function (exception) {
                    if (scope.isEdit === true) {
                        scope.operation = { type: 'open' };
                        currentException = exception;
                        scope.selectedOrgs = exception.orgs;
                    }
                };

                scope.addException = function () {
                    var newException = { id: PWC.newGuid(),isNotPersistent: true, editKey: +new Date() };
                    ruleEngineOp.addTaxPayerReportRuleOperation(newException);
                    scope.taxPayerExceptions.push(newException);
                };

                scope.delete = function (exception) {
                    var index = scope.taxPayerExceptions.indexOf(exception);
                    if (index !== -1) {
                        if (exception.editKey == null) {
                            exception.editKey = +new Date();
                        }
                        scope.taxPayerExceptions.splice(index,1);
                    }
                };

                scope.taxPayerTypesDropdownOption = {
                    bindingOptions: {
                        value: 'exception.taxPayerType',
                        dataSource: 'taxpayerTypes',
                        disabled:'!isEdit'
                    },
                    valueExpr: 'id',
                    displayExpr: 'name'
                };

                scope.reportTypesDropdownOption = {
                    bindingOptions: {
                        value: 'exception.templateGroupID',
                        dataSource: 'reportTypes',
                        disabled: '!isEdit'
                    },
                    valueExpr: 'id',
                    displayExpr: 'name'
                };

               
             
            }
        }
    }]);