﻿commonModule.controller('accountVoucherGridFilterController', ['$scope', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload'
    , 'dataImportService', 'SweetAlert', '$q', 'uiGridConstants', 'projectService', 'uiGridGroupingConstants', 'enums'
    , 'vatImportService', 'i18nService', 'browserService', '$interval', 'region', 'vatSessionService', 'vatReductionService',
    function ($scope, $log, $translate, $timeout, apiInterceptor, Upload
        , dataImportService, SweetAlert, $q, uiGridConstants, projectService, uiGridGroupingConstants,enums
        , vatImportService, i18nService, browserService, $interval, region, vatSessionService, vatReductionService) {
        'use strict';
        $log.debug("accountVoucherGridFilterController  start.....");
        $log.debug($scope.enterpriseCode);
        $log.debug($scope.periodId);
        $log.debug($scope.selectedVouchers);
        
        function initGridView(periodId, accountCode) {
            var remapBatchId = !_.isUndefined($scope.reMapItem) ? $scope.reMapItem.remapBatchId : null;
            vatReductionService.getVouchersByConditions(periodId, accountCode, $scope.processTypeId, remapBatchId)
                .success(function (or) {
                    if (or.result) {
                        $scope.gridData = [];
                        $scope.gridData = or.data;
                        $log.debug($scope.gridData);                  
                        initGirdConfig();

                    }
                });
        }


        function initGirdConfig() {
            initGridFilter();         
            $("#gridOptions").dxDataGrid({
                dataSource: {
                    store: {
                        data: $scope.gridData,
                        type: "array",
                        key: 'voucherID'
                    }
                },
                allowColumnResizing: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true, //单双行颜色
                showBorders: true,
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                scrolling: {
                    mode: "standard" //standard 设置为infinite或者virtual: paging配置将不可用
                },
                filterRow: {
                    visible: true,
                    applyFilter: "auto",
                    showOperationChooser:false //filterRow是否出现放大镜的筛选条件
                },
                searchPanel: {
                    visible: true,
                    width: 240,
                    placeholder: $translate.instant('Search'),
                },
                pager:{
                    allowedPageSizes: "auto",
                    visible: "auto"
                },
                paging:{
                    enabled: true,
                    pageIndex: 0,
                    pageSize: constant.page.pageSize
                },
                selection : {
                    mode: 'multiple',
                    allowSelectAll: false,  
                    selectAllMode: 'allPages',
                    showCheckBoxesMode: 'always',
                    deferred: true
                },
                selectionFilter: $scope.filterCondition, //使用filter来把$scope.selectedVouchers中的凭证勾选上            
                columns: [
                    {
                        alignment: "left",
                        dataField: "period",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColPeriod'),   
                        columnAutoWidth: true
                        //sortOrder: 'asc',
                        //sortIndex: 0
                    },
                    {
                        alignment: "center",
                        dataField: "date",
                        dataType: "date",
                        format: "yyyy-MM-dd",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColDate'),
                        columnAutoWidth: true
                        //sortOrder: 'asc',
                        //sortIndex: 1
                    },
                    {
                        dataField: "group",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColGroup'),
                        //sortIndex: 2,
                        //sortOrder: 'asc',
                        columnAutoWidth: true
                    },
                    {
                        dataField: "vid",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColVID'),
                        //sortIndex: 3,
                        //sortOrder: 'asc',
                        columnAutoWidth: true
                    },
                    {
                        dataField: "customerCode",
                        caption: $translate.instant('AccountVoucher_DataGrid_CustomerCode'),
                        columnAutoWidth: true
                    },
                    {
                        dataField: "summary",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColSummary'),
                        columnAutoWidth: true
                    },
                    {
                        dataField: "acctCodeAndNameShow",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColAcctCodeAndNameShow'),
                        columnAutoWidth: true
                    },
                    {
                        dataField: "stdCodeAndNameShow",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColStdCodeAndNameShow'),
                        columnAutoWidth: true
                    },
                    {
                        dataField: "debit",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColDebit'),
                        alignment: "right",
                        columnAutoWidth: true
                    },
                    {
                        dataField: "credit",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColCredit'),
                        alignment: "right",
                        columnAutoWidth: true
                    },
                    {
                        dataField: "vid",
                        caption: $translate.instant('AccountVoucher_DataGrid_ColVID'),
                        alignment: "right",
                        columnAutoWidth: true,
                        visible: false
                    },
                    {
                        dataField: "voucherID",
                        caption: $translate.instant('AccountVoucher_DataGrid_VoucherID'),
                        alignment: "right",
                        columnAutoWidth: true,
                        visible: false
                    },
                    {
                        dataField: "itemID",
                        caption: $translate.instant('AccountVoucher_DataGrid_ItemID'),
                        alignment: "right",
                        columnAutoWidth: true,
                        visible: false
                    },
                    {
                        dataField: "mappingUser",
                        caption: $translate.instant('AccountVoucher_DataGrid_MappingUser'),
                        alignment: "right",
                        columnAutoWidth: true,
                        visible: false
                    },
                ],
                onSelectionChanged: function (selectedItems) {                            
                    $scope.gridInstance.getSelectedRowsData().done(function (rowData) {
                        $scope.selectedVouchers = rowData;
                    });                 
                },
                onContentReady: function () {                   
                    //setVoucherSelected();                  
                    $scope.gridInstance.getSelectedRowsData().done(function (rowData) {
                        $scope.selectedVouchers = rowData;
                    });
                },
                onCellPrepared: function (e) {
                                    
                    //新增状态时，已经做过凭证重分类的分录不能选择 
                    if ($scope.processTypeId === enums.processType.Add) {
                        if (e.rowType === "data" && e.column.command === 'select') {
                            var stdCode = e.row.data.stdCode;
                            var remapId = e.row.data.remapId;
                            if (!_.isNull(stdCode) && !_.isNull(remapId)) {
                                var instance = e.cellElement.find('.dx-select-checkbox').dxCheckBox("instance");
                                instance.option("disabled", true);
                                e.cellElement.off();
                            }                                                                                 
                        }
                    }     
                    
                    //编辑状态时：1) 没有重对应过的分录 2)当前重对应记录对应的分录可以 check/uncheck; 
                    //对应到'其他'重对应记录的分录'不可以' check/uncheck (其实这些分录都不会显示出来)
                    if ($scope.processTypeId === enums.processType.Edit) {
                        if (e.rowType === "data" && e.column.command === 'select') {
                            var stdCode = e.row.data.stdCode;
                            var remapId = e.row.data.remapId;
                            if (!_.isNull(stdCode) && !_.isNull(remapId) && !_.isNull($scope.reMapItem) && !_.isUndefined($scope.reMapItem)) {
                                var chkRepId = _.find($scope.reMapItem.remapIdes, function (num) { return num === remapId; });
                                if (_.isUndefined(chkRepId)) {
                                    var instance = e.cellElement.find('.dx-select-checkbox').dxCheckBox("instance");
                                    instance.option("disabled", true);
                                    e.cellElement.off();
                                }                                                        
                            }
                        }
                    }

                    
                }
            });         
        }


        //凭证重对应编辑时, 勾选已重对应的凭证
        function setVoucherSelected () {        
            if (!_.isNull($scope.selectedVouchers) && !_.isNull($scope.gridData)
                && $scope.selectedVouchers.length > 0 && $scope.gridData.length > 0) {
                var voucherIndexArray = [];
                var gridInstance = $('#gridOptions').dxDataGrid('instance');
                var pageIndex = gridInstance.pageIndex();
                var dataSource = gridInstance.option("dataSource");
                var pageData = _.chain(dataSource).rest(pageIndex * constant.page.pageSize).first(constant.page.pageSize).value()
                $scope.selectedVouchers.forEach(function (item, index) {
                    pageData.forEach(function (vdItem, vdIndex) {
                        if (_.isEqual(item.voucherID, vdItem.voucherID)) {                
                            voucherIndexArray.push(vdIndex);
                        }
                    });
                });         
                             
                $log.debug(pageData);           
                gridInstance.selectRowsByIndexes(voucherIndexArray);              
            }
        };


        //result example:
        //  [
        //    ["voucherID", "=", "DEAC1059-5088-469B-B0C8-3A5612E1DF63"], "or",
        //    ["voucherID", "=", "48F38499-762E-44D9-83A5-4FBFF8FA5A1A"], "or",
        //    ["voucherID", "=", "E6886487-927C-4CF5-A3E4-7F94A856184F"]
        //  ]
        function initGridFilter() {    
            $scope.filterCondition = [];
            $scope.selectedVoucherIds = _.map($scope.selectedVouchers, function (item) { return item.voucherID});
            $scope.selectedVoucherIds.forEach(function (item, index) {
                var tempFilter = ["voucherID", "=", item];
                if (index > 0) {
                    $scope.filterCondition.push("or");
                }
                $scope.filterCondition.push(tempFilter);             
            });

            $log.debug("initGridFilter");
            $log.debug($scope.filterCondition);
        }

        //开始
        (function initialize() {
            $scope.gridData = [];
            initGirdConfig();
            $scope.initGridView = initGridView;
            $scope.gridInstance = $('#gridOptions').dxDataGrid('instance');
            
        })();
    }
]);