﻿commonModule.controller('editPriceModalController', ['$log', '$scope', '$translate', '$uibModal', '$document', 'SweetAlert', 'enums',
    '$timeout', '$document', '$compile', 'vatOutputInvoiceManageService',
    function($log, $scope, $translate, $uibModal, $document, SweetAlert, enums, $timeout, $document, $compile, vatOutputInvoiceManageService) {

        var thisService = {
            debug: false,

            // 主函数
            main: function() {

                $scope.editModel = {};

                thisService.watchCollection();

                $scope.changeSubtotalforFinalPayment = thisService.changeSubtotalforFinalPayment;
            },

            // 限制输入两位小数
            limitTwoDigital: function(value) {
                //先把非数字的都替换掉，除了数字和.
                value = value.replace(/[^\d.]/g, "");
                //必须保证第一个为数字而不是.
                value = value.replace(/^\./g, "");
                //保证只有出现一个.而没有多个.
                value = value.replace(/\.{2,}/g, ".");
                //保证.只出现一次，而不能出现两次以上
                value = value.replace(".", "$#$").replace(/\./g, "").replace("$#$", ".");
                //保证.只后面只能出现两位有效数字
                value = value.replace(/([0-9]+\.[0-9]{2})[0-9]*/, "$1");

                return value;
            },

            // watch 数据
            watchCollection: function() {
                $scope.$watch('operateType', function(newValue, oldValue) {
                    if (newValue) {

                        if (newValue === constant.Operation.Edit) {

                            //$scope.isReadOnly = true;
                            thisService.open();
                        }
                    }
                });


                //$scope.$watch('editModel.subtotalforFinalPayment', function (newValue, oldValue) {
                //    if (newValue) {
                //        thisService.changeSubtotalforFinalPayment();
                //    }
                //});
            },

            // 打开弹出框
            open: function() {
                var editModel = {};

                if ($scope.operateModel) {
                    $scope.editModel = $scope.operateModel;
                } else {
                    $scope.editModel = editModel;
                }

                $scope.editModel.oldSubtotalforFinalPayment = $scope.editModel.subtotalforFinalPayment;

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'editInvoicePriceModal.html',
                    windowClass: 'edit-price-modal-wrapper',
                    scope: $scope,
                    resolve: {
                        editModel: $scope.editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    // $scope.templateModel = data;
                    $scope.isUpdate = true;
                    $scope.isReadOnly = true;
                    // $scope.onClosed({ model: data });
                    $scope.operateType = null;
                }, function() {
                    $scope.operateType = null;
                    $scope.isReadOnly = true;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });


                var saveData = function(model) {

                    if (!model.bdSubtotalforFinalPayment) {
                        swal($translate.instant('SaveFail'), $translate.instant('PleaseInputPrice'), 'warning');
                        return;
                    }

                    vatOutputInvoiceManageService.manualAdjustPrice(model).success(function(ret) {
                        if (ret.result) {
                            modalInstance.close(model);
                            SweetAlert.success($translate.instant('SaveSuccess'));

                            if ($scope.onClosed) {
                                $scope.onClosed({ param: model });
                            }
                        } else {
                            swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                        }
                    });

                };

                // 保存
                $scope.save = function() {
                    var model = $scope.editModel;

                    saveData(model);
                };

                // 取消
                $scope.cancel = function() {
                    modalInstance.dismiss('cancel');
                };
            },

            // 验证输入金额
            // 小写金额 自动转大写
            changeSubtotalforFinalPayment: function() {
                var value = $scope.editModel.bdSubtotalforFinalPayment;

                value = thisService.limitTwoDigital(value);

                $scope.editModel.bdSubtotalforFinalPayment = value;
            }

        };

        (function() {
            thisService.main();
        })();

    }
]);