﻿commonModule.
controller('menuSelectorController', ['$scope', 'menuService', 
    function ($scope, menuService) {

        //toggle tree node
        $scope.toggleMenu = function (scope) {
            scope.toggle();
        };

        function FindParentMenu(menus, id) {
            var parentMenu = null;
            for (var i = 0, len = menus.length; i < len; i++) {
               
                if (menus[i].id === id) {
                    parentMenu = menus[i];
                    break;
                } else if (menus[i].subMenus && menus[i].subMenus.length > 0)
                {                     
                    parentMenu = FindParentMenu(menus[i].subMenus, id);
                    if (parentMenu != null)
                        break;
                }
            }           
            return parentMenu;
        };

        function CheckedParentMenu(menus, id) {
            var parentObj = FindParentMenu(menus, id);

            if (parentObj) {
                var allCheck = true;
                for (var i = 0, len = parentObj.subMenus.length; i < len; i++) {
                    if (!parentObj.subMenus[i].isChecked) {
                        allCheck = false;
                        break;
                    }
                }
                if (allCheck) {
                    parentObj.isChecked = true;
                    $scope.checkedMenusNameSet[id] = parentObj.name;
                    if (parentObj.parentID && $.inArray(parentObj.parentID + "", $scope.selectedMenuCodes) === -1) {
                        CheckedParentMenu($scope.menuData, parentObj.parentID);
                    }
                }

            } else {
                console.error("Not found the parent authority.");
            }
        };

        function UnCheckParentMenu(menus, id) {

            var parentObj = FindParentMenu(menus, id);
            if (parentObj) {
                parentObj.isChecked = false;
                delete $scope.checkedMenusNameSet[id];
                if (parentObj.parentID && $.inArray(parentObj.parentID + "", $scope.selectedMenuCodes) !== -1) {
                    UnCheckParentMenu($scope.menuData, parentObj.parentID);

                }
            } else {
                console.error("Not found the parent authority.");
            }

        };

        $scope.toggleMenuSub = function (menu) {
            if (menu.isChecked) {
                $scope.checkedMenusNameSet[menu.id] = menu.name;
                if (menu.parentID && $.inArray(menu.parentID + "", $scope.selectedMenuCodes) === -1) {
                    CheckedParentMenu($scope.menuData, menu.parentID);
                }
            }
            else {

                delete $scope.checkedMenusNameSet[menu.id];
                //if the menu is child menu, and parent menu is checked, need to uncheck parent menu
                if (menu.parentID && $.inArray(menu.parentID + "", $scope.selectedMenuCodes) !== -1) {
                    UnCheckParentMenu($scope.menuData, menu.parentID);
                }
            }

            $scope.selectedMenuCodes = _.keys($scope.checkedMenusNameSet);
            $scope.selectedMenuNames = _.values($scope.checkedMenusNameSet);

            if (!menu.subMenus) {
                return;
            }
            menu.subMenus.forEach(function (d) {
                d.isChecked = menu.isChecked;
                $scope.toggleMenuSub(d);
            });
        };

        $scope.getSelectedOrgDisplayText = function () {
            if ($scope.selectedMenuNames !== "") {
                return $scope.selectedMenuNames;
            }
            else {
                return '';
            }
        };

        function checkSelectMenu(menuArray) {

            menuArray.forEach(function (menu) {
                if ($scope.selectedMenuNames.indexOf(menu.name) > -1) {
                    menu.isChecked = true; // drop dirty data: $scope.$digest();                  
                  
                    $scope.checkedMenusNameSet[menu.id] = menu.name;

                }
                if (menu.subMenus && menu.subMenus.length > 0) {
                    checkSelectMenu(menu.subMenus);
                }
            });
            $scope.selectedMenuCodes = _.keys($scope.checkedMenusNameSet);
            $scope.selectedMenuNames = _.values($scope.checkedMenusNameSet);
        }

        //fix issue: when re-create dialog, the menu check still keep last status, not refresh;
        $scope.updateMenuChecked = function () {
           
            $scope.checkedMenusNameSet = {};
            //clear all checked status
            $scope.menuData.forEach(function (menu) {
                menu.isChecked = false;
                if (!menu.subMenus || menu.subMenus.length === 0) {
                    return;
                }
                menu.subMenus.forEach(function (subMenu) {

                    subMenu.isChecked = false;

                });

            });
            if ($scope.selectedMenuNames && $scope.selectedMenuNames.length > 0) {
                checkSelectMenu($scope.menuData);
            }
           

        };

       
        $scope.$watch('serviceId', function (newValue, oldValue) {
          
            if (newValue === oldValue) {
                return newValue;
            }

            getMenusByService(newValue);
        });

        function getMenusByService(serviceID) {
            if (serviceID != null && angular.isString(serviceID)) {
                menuService.getMenus(serviceID).success(function (menuData) {
                    $scope.menuData = menuData;
                });
            }
        }
        (function () {

            getMenusByService($scope.serviceId);
            //menu property
            $scope.menuData = [];
            $scope.checkedMenusNameSet = {};

        })();

    }
]);
