﻿commonModule.directive('modelAnalysisReport', ['$log', function ($log) {
    'use strict';
    return {
        restrict: 'E',
        templateUrl: '/app/common/controls/model-analysis-report/model-analysis-report.html' + '?_=' + Math.random(),
        replace: true,
        scope: {
            hasQueryPermission: "=",
            hasFilterIssuePermission: "=",
            modelType: "=",
            projectYear: "=",
            periodFrom: "=",
            periodTo: "=",

            //以下三个参数模型回填特有
            isModelBackFill: "=?",
            cellDataId: "=?",
            modelDataSourceId: "=?",
            modelIdList: "=?",

            //以下四个参数模型分析特有
            categoryId: "=?",
            industryId: "=?",
            organizationId: "=?",
            serviceTypeId: "=?"
        },
        controller: 'modelAnalysisReportController',
        link: function ($scope, $element, $attr) {

            $scope.element = $element;

            //由于 dx-resizable 没有 onContentReady 事件,所以在第一次渲染时进行判断并添加 collapse.png
            $scope.$watch("analysisResult.selectedRow", function (newValue, oldValue) {
                var detailElem = $($element).find(".detail[dx-resizable]");
                var handleElem = detailElem.find(".dx-resizable-handle-top");

                if (handleElem.length > 0 && handleElem.has("img").length == 0) {
                    handleElem.html("<img src='../../../../app-resources/images/collapse.png'/>");
                }

                if ((!!newValue) != (!!oldValue)) {
                    $scope.analysisResult.indexAnalysis.dataGridInstance.resize();
                    $scope.analysisResult.entriesCheck.dataGridInstance.resize();
                }
            });
        }
    };
}]);