﻿commonModule.directive('orgMultiSelector', ['$log','orgService',
    function ($log, orgService) {
        'use strict';
        $log.debug('regionSelector.ctor()...');
        return {
            restrict: 'E',
            templateUrl: '/app/common/controls/org-multi-selector/org-multi-selector.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                selectedNoList: '=',
                provinceCityData: '=',
            },
            controller: 'orgMultiSelectorController',
            link: function (scope, element) {
                var provinceMap = {};
                scope.selectedNames = '';
                scope.$watch('provinceCityData', function (newValue, oldValue) {
                    scope.provinceCityData.forEach(function (row) {
                        provinceMap[row.id] = row;
                    });
                    refresh();
                });


                scope.$watch('selectedNoList', function (newValue, oldValue) {
                    if (newValue !== oldValue) {
                        refresh();
                    }
                });

                function refresh() {
                    scope.selectedNames = '';
                    scope.selectedNoList.forEach(function (id) {
                        if (provinceMap[id]) {
                            scope.selectedNames += provinceMap[id].name + ',';
                        }
                    });
                    scope.selectedNames = scope.selectedNames.substring(0, scope.selectedNames.length - 2);
                }

                (function () {
                })();
            }
        };
    }
]);