﻿commonModule.
controller('roleMultiSelectorController', ['$scope', 'roleService',
    function ($scope, roleService) {
        roleService.getRoleTreeList().success(function (data) {
            $scope.roleList = data;
        });

        $scope.toggleRoleSpan = function(role){
            if (!role.data.roleCategoryID){
                return;
            }
            if (role.isChecked){
                role.isChecked = false;
            } else {
                role.isChecked = true;
            }
            $scope.toggleRoleSub(role);
        };

        $scope.toggleRoleSub = function (role) {
            //根据当前的SelectedRoleIds判断是新增还是修改，
            //如果为空，则表示是新增操作，需要将checkedRolesSet和checkedRolesNameSet设置为空
             
            if (!$scope.selectedRoleIds) {
                $scope.checkedRolesSet = {};
                $scope.checkedRolesNameSet = {};
            }
            if (role.isChecked) {
                $scope.checkedRolesSet[role.data.id] = role;
                $scope.checkedRolesNameSet[role.data.id] = role.label;
            }
            else {
                delete $scope.checkedRolesSet[role.data.id];
                delete $scope.checkedRolesNameSet[role.data.id];
            }

            $scope.selectedRoleIds = _.keys($scope.checkedRolesSet);
            $scope.selectedRoleNames = _.values($scope.checkedRolesNameSet);

            if (!role.subRoles) {
                return;
            }
            role.subRoles.forEach(function (d) {
                d.isChecked = role.isChecked;
                if (role.isChecked) {
                    $scope.checkedRolesSet[d.data.id] = d;
                    $scope.checkedRolesNameSet[d.data.id] = d.label;
                }
                else {
                    delete $scope.checkedRolesSet[d.data.id];
                    delete $scope.checkedRolesNameSet[d.data.id];
                }
            });

            $scope.selectedRoleIds = _.keys($scope.checkedRolesSet);
            $scope.selectedRoleNames = _.values($scope.checkedRolesNameSet);
        };


        $scope.getSelectedRoleDisplayText = function () {
            if ($scope.selectedRoleNames && $scope.selectedRoleNames.length > 0) {

                for (var i = 0; i < $scope.selectedRoleIds.length; i++) {
                    $scope.checkedRolesSet[$scope.selectedRoleIds[i]] = { 'id': $scope.selectedRoleIds[i], 'name': $scope.selectedRoleNames[i] };
                    $scope.checkedRolesNameSet[$scope.selectedRoleIds[i]] = $scope.selectedRoleNames[i];
                }

                return $scope.selectedRoleNames;
            }
            else {
                return '';
            }
        };

        var clearAllChecked = function () {
            $scope.roleList.forEach(function (m) {
                m.children.forEach(function (n) {
                    n.isChecked = false;
                });
            });
        }

        $scope.initialCheckedNode = function () {
            if ($scope.selectedRoleIds !== '') {
                clearAllChecked();
                $scope.roleList.forEach(function (m) {
                    m.children.forEach(function (n) {
                        if ($.inArray(n.data.id, $scope.selectedRoleIds) > -1) {
                            n.isChecked = true;
                        }
                    });
                });
            }
            else {
                clearAllChecked();
            }
        };


        (function () {
            //role property

            if (!angular.isDefined($scope.itemMaxLength)){
                $scope.itemMaxLength = 40;
            }

            $scope.roleList = [];
            $scope.checkedRolesSet = {};
            $scope.checkedRolesNameSet = {};

            $scope.selectedRoleIds = [];
            $scope.selectedRoleNames = [];

        })();
    }
]);