﻿commonModule.controller('taxReportAnalyzeReportController', ['$scope', '$translate', 'SweetAlert', 'enums', 'modelConfigurationService', '$compile',
    function ($scope, $translate, SweetAlert, enums, modelConfigurationService, $compile) {

        $scope.modelType = 2;
        $scope.editModalWriteBackData = false;

        //焦点单元格发生变化和显示类型发生变化时,若当前正在编辑"模型回填"则直接取消,编辑
        $scope.$watch("modelType", "cellDataId", function (newValue, oldValue) {
            if ($scope.editModalWriteBackData)
                $scope.fireCancelEditModelWriteBack();
        });

        //数据源列表发生变化时,获取当前单元格的模型回填数据源 Id,并绑定到 model-analysis-report 中,用于提交回填更改时需要 dataSourceId 的要求
        $scope.$watchCollection("modelDataSourceItems", function (newValue, oldValue) {
            $scope.dataSource = _.find(newValue, function (e) {
                return e.type === enums.formulaDataSourceType.ModelDatasource;
            });
        });

        $scope.fireEditModelWriteBack = function () {
            $scope.editModalWriteBackData = true;
            $scope.$broadcast("EditModelWriteBack");
        };

        $scope.fireCancelEditModelWriteBack = function () {
            $scope.editModalWriteBackData = false;
            $scope.$broadcast("CancelEditModelWriteBack");
        };

        $scope.fireCheckModelWriteBackHasChanged = function () {
            $scope.$broadcast("CheckModelWriteBackHasChanged");
            $scope.editModalWriteBackData = false;
        };
    }
]);