﻿commonModule.controller('vatParentCodeModalController', ['$scope', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', '$q', 'uiGridConstants', 'projectService', 'uiGridGroupingConstants', 'vatImportService', 'i18nService', 'browserService', '$interval', 'region', 'vatSessionService',
    function ($scope, $log, $translate, $timeout, apiInterceptor, Upload, dataImportService, SweetAlert, $q, uiGridConstants, projectService, uiGridGroupingConstants, vatImportService, i18nService, browserService, $interval, region, vatSessionService) {
        'use strict';

        $scope.subjectNames = [];
        $scope.selectedSubjectCodes = ["", "资产", "负债", "共同", "权益", "成本", "损益", "其他"];

        $scope.$watch('isShow', function (newValue, oldValue) {
            if (newValue) {
                $('#showParentCodePop').modal('show');
            } else {
                $('#showParentCodePop').modal('hide');
            }
        });

        $scope.$watch('isUncheckedAll', function (newValue, oldValue) {
            if (newValue) {
                $scope.gridApi.selection.clearSelectedRows();
                $scope.selectedSubjectCodes = [];
            } 
        });

        $scope.closeModal = function () {
            $scope.isShow = false;
        };

        $scope.cancelModal = function () {

        };

        // $scope.confirmedRecords = [];

        $scope.cancelModal = function () {
            $scope.isShow = false;

            $scope.onCancelSelection();
        };

        $scope.getSelectedCodes = function () {
            $scope.selectedSubjectCodes = [];
            var selectedCodeRecords = $scope.gridApi.selection.getSelectedRows();
            selectedCodeRecords.forEach(function (item) {
                if (item.subjectCode.length > 0)
                    $scope.selectedSubjectCodes.push(item);
            });

            $scope.onConfirmSelection({ confirmedRecords: $scope.selectedSubjectCodes });
            $scope.isShow = false;

        };




        // ************************************************************************************************
        // SETUP UI GRID TREE:
        var treeData;

        // 国际化；
        // i18nService.setCurrentLang("zh-cn");

        $scope.parentCodePopOptions = {
            rowHeight: 40,
            showGridFooter: false,
            showColumnFooter: false,
            selectionRowHeaderWidth: 30,
            enableFullRowSelection: false,
            enableRowSelection: true,
            enableSorting: false,
            enableFiltering: false,
            enableColumnMenus: false,
            enableRowHeaderSelection: true,
            multiSelect: true,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
            showTreeExpandNoChildren: false,
            enableGridMenu: false,
            enableSelectAll: true,
            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;

                $scope.gridApi.selection.on.rowSelectionChanged($scope, function (row) {

                    if (row.treeNode.children.length > 0 && row.isSelected == true) {
                        var childRows = row.treeNode.children;
                        for (var j = 0, length = childRows.length; j < length; j++) {
                            var rowEntity = childRows[j].row.entity;
                            $scope.gridApi.selection.selectRow(rowEntity);
                        }
                    }

                    if (row.treeNode.children.length > 0 && row.isSelected == false) {
                        var childRows = row.treeNode.children;
                        for (var j = 0, length = childRows.length; j < length; j++) {
                            var rowEntity = childRows[j].row.entity;
                            $scope.gridApi.selection.unSelectRow(rowEntity);
                        }
                    }

                });

                //$interval(function () {
                //    $scope.gridApi.core.handleWindowResize();
                //}, 500, 60 * 60 * 8);
            },

            columnDefs: [
            {
                field: 'subjectCode', name: $translate.instant('AccountCode'),
                cellTemplate:
                '<div ng-if="row.entity.$$treeLevel==0" class=""><span>{{row.entity.subjectCode}}<span></div>' +
                          '<div ng-if="row.entity.$$treeLevel==1" class="text-align-left-padding"><span>&nbsp;&nbsp;{{row.entity.subjectCode}}<span></div>' +
                          '<div ng-if="row.entity.$$treeLevel==2" class="text-align-left-padding"><span>&nbsp;&nbsp;&nbsp;&nbsp;{{row.entity.subjectCode}}<span></div>' +
            '<div ng-if="row.entity.$$treeLevel==3" class="text-align-left-padding"><span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{row.entity.subjectCode}}<span></div>' +
    '<div ng-if="row.entity.$$treeLevel==4" class="text-align-left-padding"><span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{row.entity.subjectCode}}<span></div>'
            },
            {
                field: 'subjectName', width: 220, name: $translate.instant('AccountName'),

                cellTemplate: '<div class=""><span title={{row.entity.subjectName}}>{{row.entity.subjectName | limitString:25}}<span></div>'

            }
            ,
            {
                field: 'direction', width: 80, name: $translate.instant('SubjectDirectionCol'),

                cellTemplate: '<div class=""><span>{{row.entity.direction}}<span></div>'

            },
            {
                field: 'acctProp', width: 80, name: $translate.instant('SubjectTypeCol'),

                cellTemplate: '<div class=""><span>{{row.entity.acctProp}}<span></div>'

            }

            ]
        };
        // SETUP UI GRID TREE:
        // ************************************************************************************************
        function increaseTreeLevelGroup(group) {
            group.forEach(function (item) {
                // item.parentCode = 'A';
                increaseTreeLevel(item);
            });
        }

        function increaseTreeLevel(item) {
            item.$$treeLevel++;
            if (angular.isArray(item.children) && item.children.length > 0) {
                item.children.forEach(function (chiild) {
                    increaseTreeLevel(chiild);
                });
            }
        }

        $scope.$watch('uBackendData', function (newValue, oldValue) {
            if (newValue === oldValue && typeof (newValue) != "undefined") {
                $scope.getSubjectDataFromDatabase(newValue);
            }
        });

        $scope.$watch('uList', function (newV, oldV) {
            if (newV !== oldV) {

                var subjectNewTree;
                var subjectNewTrees = [];
                newV.forEach(function (item) {
                    subjectNewTree = item;
                    subjectNewTree.acctProp = $scope.selectedSubjectCodes[item.acctProp];
                    subjectNewTrees.push(subjectNewTree);
                });

                $scope.parentCodePopOptions.data = subjectNewTrees;
                /*
                var headerItems=[];
                var headerItem;
                
            

                // add header name to data BEGIN:
                var group_1 = newV.filter(function (o) {
                    return o.acctProp === "1";
                });

                increaseTreeLevelGroup(group_1);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[资产]";
               

                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_1);


                //2:
                var group_2 = newV.filter(function (o) {
                    return o.acctProp === "2";
                });

                increaseTreeLevelGroup(group_2);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[负债]";
                

                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_2);

                //3
                var group_3 = newV.filter(function (o) {
                    return o.acctProp === "3";
                });

                increaseTreeLevelGroup(group_3);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[共同]";
                

                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_3);

                //4
                var group_4 = newV.filter(function (o) {
                    return o.acctProp === "4";
                });

                increaseTreeLevelGroup(group_4);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[权益]";
                

                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_4);

                //5
                var group_5 = newV.filter(function (o) {
                    return o.acctProp === "5";
                });

                increaseTreeLevelGroup(group_5);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[成本]";
               

                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_5);
                //6
                var group_6 = newV.filter(function (o) {
                    return o.acctProp === "6";
                });

                increaseTreeLevelGroup(group_6);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[损益]";
                

                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_6);
                //7
                var group_7 = newV.filter(function (o) {
                    return (o.acctProp !== "1" && o.acctProp !== "2" && o.acctProp !== "3" && o.acctProp !== "4" && o.acctProp !== "5" && o.acctProp !== "6");
                });

                increaseTreeLevelGroup(group_7);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[其他]";
                

                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_7);


                // add header name to data END;
                $scope.parentCodePopOptions.data = headerItems;
                console.log(group_1);
                */
            }
        });



        // ************************************************************************************************
        // ************************************************************************************************
        // ************************************************************************************************
        // function to get data subjectFrom Backend
        $scope.getSubjectDataFromDatabase = function (subjectCategory) {
            //  vatImportService.getBalanceDataForDisplay(subjectCategory, subjectFrom, subjecTo, "").success(function (subjectxData) {
            vatImportService.getParentCodesForDisplay(subjectCategory).success(function (subjectxData) {

                var subjectTreeData = JSON.parse(subjectxData);
                writeoutSubjectNode(subjectTreeData, 0, newTree);

                var subjectNewTree;
                var subjectNewTrees = [];
                var debit = $translate.instant('AccountVoucher_Direction_Debit'), credit = $translate.instant('AccountVoucher_Direction_Credit');

                newTree.forEach(function (item) {
                    subjectNewTree = new Object();
                    subjectNewTree.$$treeLevel = item.$$treeLevel;
                    subjectNewTree.subjectCode = item.accountCode;
                    subjectNewTree.subjectName = item.accountName;
                    subjectNewTree.acctProp = $scope.selectedSubjectCodes[item.acctProp];
                    subjectNewTree.direction = item.direction === "1" ? debit : credit;
                    // subjectNewTree.category=
                    subjectNewTrees.push(subjectNewTree);
                });

                $scope.parentCodePopOptions.data = subjectNewTrees;
                /*
                var headerItems = [];
                var headerItem;

                var newV = subjectNewTrees;
                // add header name to data BEGIN:
                var group_1 = newV.filter(function (o) {
                    return o.acctProp === "1";
                });

                increaseTreeLevelGroup(group_1);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[资产]";


                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_1);


                //2:
                var group_2 = newV.filter(function (o) {
                    return o.acctProp === "2";
                });

                increaseTreeLevelGroup(group_2);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[负债]";


                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_2);

                //3
                var group_3 = newV.filter(function (o) {
                    return o.acctProp === "3";
                });

                increaseTreeLevelGroup(group_3);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[共同]";


                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_3);

                //4
                var group_4 = newV.filter(function (o) {
                    return o.acctProp === "4";
                });

                increaseTreeLevelGroup(group_4);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[权益]";


                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_4);

                //5
                var group_5 = newV.filter(function (o) {
                    return o.acctProp === "5";
                });

                increaseTreeLevelGroup(group_5);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[成本]";


                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_5);
                //6
                var group_6 = newV.filter(function (o) {
                    return o.acctProp === "6";
                });

                increaseTreeLevelGroup(group_6);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[损益]";


                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_6);
                //7
                var group_7 = newV.filter(function (o) {
                    return (o.acctProp !== "1" && o.acctProp !== "2" && o.acctProp !== "3" && o.acctProp !== "4" && o.acctProp !== "5" && o.acctProp !== "6");
                });

                increaseTreeLevelGroup(group_7);
                headerItem = {};

                headerItem.$$treeLevel = 0;
                headerItem.subjectCode = "";
                headerItem.subjectName = "[其他]";


                headerItems.push(headerItem);
                headerItems = headerItems.concat(group_7);
               

                // add header name to data END;
                $scope.parentCodePopOptions.data = headerItems;
                 */
            });
        };
        // function to get data subjectFrom Backend
        // ************************************************************************************************



        // ************************************************************************************************
        // Write UI GRID TREE NOTES:
        var newTree = [];
        var id = "0";
        var writeoutSubjectNode = function (childArray, currentLevel, dataSubjectArray) {
            childArray.forEach(function (childNode) {
                if (childNode.children.length > 0) {
                    childNode.$$treeLevel = currentLevel;
                    id = childNode.accountCode;
                }
                else {
                    childNode.$$treeLevel = currentLevel;
                }
                dataSubjectArray.push(childNode);
                writeoutSubjectNode(childNode.children, currentLevel + 1, dataSubjectArray);
            });
        };
        // Write UI GRID TREE NOTES:
        // ************************************************************************************************
        // ************************************************************************************************
        // ************************************************************************************************
        //开始
        (function initialize() {

        })();
    }
]);