﻿commonModule.directive('vatReportView', ['$log', 'enums',
    function ($log, enums) {
        'use strict';
        $log.debug('vatReportView.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/common/controls/vat-report-view/vat-report-view.html' + '?_=' + Math.random(),
            scope: {
                templateId: '=',
                reportId: '=',
                templateName:'=',
                templateCode: '=',
                isDocumentList: '=',
                serviceType: '=',
                initRow: '=?',
                initCol: '=?'
            },
            controller: 'VatReportViewController',
            link: function ($scope, $ele, $attr) {
                $ele.find("#tax-cell-detail").draggable({
                    scroll: true,
                    cancel: '#dataSourceGrid,.hand-input-container,.add-voucher-range-propover,.add-invoice,.tab-type,.dx-texteditor-input,input,.btn'
                });

                var saveFunc = $scope.$on('saveReportSheet', function (event, args) {
                    $scope.saveReportCache();
                });

                $scope.$on('$destroy', function () {
                    saveFunc();
                });
            }
        };
    }
]);