﻿commonModule.factory('loginContext', ['$log', '$cookies', '$location', '$window', function ($log, $cookies, $location, $window)
{
    $log.debug('loginContext.ctor()...');
    
    var apiTokenObj = $cookies.getObject('AtmsApiToken');
    $cookies.put('logout', '0');

    var redirectToLogOut = function ()
    {
        var status = $cookies.get('logout');
        if (status !== '1') {
            alert("登录已经超时，请重新登录");
            $window.location.href = '/Account/LogOut' + '?_=' + (new Date).valueOf();
            // in order to fix ie 10 not reload issue
            $("a[href='/Account/LogOut?_=" + (new Date).valueOf() + "']").click();
            $cookies.put('logout', '1');
        }
    };

    if (!(apiTokenObj)) {
        $log.error("loginContext: Fail to get api token, please log in first.");

        redirectToLogOut();
        return {};
    }

    var serverUrl = $location.protocol() + '://' + $location.host() + ':' + $location.port();

    return {
        redirectToLogOutFunction: redirectToLogOut,
        apiToken: apiTokenObj.access_token,
        tokenType: apiTokenObj.token_type,
        apiHost: apiTokenObj.api_host,
        vatApiToken: apiTokenObj.vat_access_token,
        vatTokenType: apiTokenObj.vat_token_type,
        vatApiHost: apiTokenObj.vat_api_host,
        tpUrl: apiTokenObj.tp_url,
        pdfService: apiTokenObj.pdf_service,
        clinetAgentVersion: apiTokenObj.client_agent,
        printHtml: apiTokenObj.print_html,
        printService: apiTokenObj.print_service,
        risgcService: apiTokenObj.risgc_service,
        userName: decodeURI(apiTokenObj.user_name),
        localName: decodeURI(apiTokenObj.local_name),
        userId: apiTokenObj.user_id,
        domain: apiTokenObj.domain,
        site: apiTokenObj.site,
        language: apiTokenObj.language,
        serverUrl: serverUrl,
        needChangePassword: apiTokenObj.need_change_password,
        isExternalUser: apiTokenObj.is_external_user,
        projectCustomerName: apiTokenObj.project_customer_name,
        passwordHash: apiTokenObj.password_hash
    };
}])