﻿webservices.factory('vatDashboardService', ['$log', '$http', 'apiConfig',
    function ($log, $http, apiConfig) {
        'use strict';
        $log.debug('vatDashboardService.ctor()...');

        return {
            getModelNameList: function () {
                return $http.get('/Dashboard/getModelNameList', apiConfig.createVat());
            },
            getSubModelList: function (year, period) {
                return $http.get('/Dashboard/getSubModelList/' + year + '/' + period, apiConfig.createVat());
            },
            saveSummaryConfig: function (data) {
                return $http.post('/Dashboard/saveSummaryConfig', data, apiConfig.createVat())
            },
            getDashboardConfigSummary: function (id) {
                return $http.get('/Dashboard/getDashboardConfigSummary/' + id, apiConfig.createVat());
            },
            deleteChartConfig: function (id) {
                return $http.post('/Dashboard/deleteChartConfig/' + id, {}, apiConfig.createVat());
            },
            deleteConfigById: function (id) {
                return $http.post('/Dashboard/deleteConfigById/' + id, {}, apiConfig.createVat());
            },
            saveOrganizationConfig: function (data) {
                return $http.post('/Dashboard/saveOrganizationConfig', data, apiConfig.createVat())
            },
            getOrganizationConfig: function (id) {
                return $http.get('/Dashboard/getOrganizationConfig/' + id, apiConfig.createVat());
            },
            getOrganizationSubModelList: function (organizationId) {
                return $http.get('/Dashboard/getOrganizationSubModelList/' + organizationId, apiConfig.createVat());
            }
        };
    }]);