﻿// registration web service proxy
webservices.factory('accountService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getAccountDemoOne: function (accountId) {
            var config = { ignoreLoadingBar: true };
            return $http.get('/NewAccount/' + accountId, apiConfig.create(config));
        },
        getAccountDemoList: function () {
            var config = { ignoreLoadingBar: true };
            return $http.get('/NewAccount', apiConfig.create(config));
        },
        getAccountGroup : function(){
            var config = { ignoreLoadingBar: true };
            return $http.get('/AccountGroup', apiConfig.create(config));
        },
        getProjectList: function (){
            return $http.get('/Account/UserProjects', apiConfig.create());
        },
        getEnterpriseAccounts: function (){
            return $http.get('/EnterpriseAccount', apiConfig.create());
        },
        mapAccount: function (accountMap){
            return $http.post('/EnterpriseAccount/Map', accountMap, apiConfig.create());
        },
        clearAccountMap: function (codes){
            return $http.post('/EnterpriseAccount/ClearMap', codes, apiConfig.create());
        },
        clearAllAccountMap: function (){
            return $http.post('/EnterpriseAccount/ClearAllMap', {},apiConfig.create());
        },
        autoMap: function () {
            return $http.post('/EnterpriseAccount/AutoMap', {}, apiConfig.create());
        }
    };
}]);