﻿// web service proxy for standard account
webservices.factory('dimensionService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getDimensionStatics: function (espID, orgID) {
            return $http.get('/dimension/getDimensionStatics', apiConfig.create());
        },
        getAllDimensionOrgList: function () {
            return $http.get('/dimension/getAllDimensionOrgList', apiConfig.create());
        },
        getDimensionList: function () {
            return $http.get('/dimension/getDimensionList', apiConfig.create());
        },
        getDimensionById: function (id) {
            return $http.get('/dimension/getDimensionById?id=' + id, apiConfig.create());
        },
        addDimension: function (model) {
            return $http.post('/dimension/addDimension', model, apiConfig.create());
        },
        updateDimension: function (model) {
            return $http.post('/dimension/updateDimension', model, apiConfig.create());
        },
        getDimensionValueList: function (dimensionID) {
            return $http.get('/dimension/getDimensionValueList?dimensionID=' + dimensionID, apiConfig.create());
        },
        getDevDimensionTreeList: function () {
            return $http.get('/dimension/getDevDimensionTreeList', apiConfig.create({ cache: true }));
        },
        updateDimensionValue: function (model) {
            return $http.post('/dimension/updateDimensionValue', model, apiConfig.create());
        },
        addDimensionValue: function (model) {
            return $http.post('/dimension/addDimensionValue', model, apiConfig.create());
        },
        getAllDimensionList: function () {
            return $http.get('/dimension/getAllDimensionList', apiConfig.create());
        }
    };
}]);
