﻿// registration web service proxy
webservices.factory('productService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getFileContent: function (tempFileName, selectedSheetIndex, topRowNumber) {
            return $http.get('/product/FileContent/' + tempFileName + '/' + selectedSheetIndex + '/' + topRowNumber, apiConfig.create());
        },
        getProductList: function () {
            return $http.get('/product/listProduct', apiConfig.create());
        },
        getProductItemList: function (fSetCode, productIDs) {
            return $http.get('/product/listProductItem/'+fSetCode+'/'+productIDs, apiConfig.create());
        },
        getProductItemListByPage: function (paras) {
            return $http.post('/product/listProductItemByPage', paras, apiConfig.create());
        },
        getProductItemValueAmount: function (paras) {
            return $http.post('/product/productItemValueAmount', paras, apiConfig.create());
        },
        importProductItemData: function (productItemList, importType,startYear,startMonth) {
            return $http.post('/product/productItemListImport', { ProductItemList: productItemList, ImportType: importType, StartYear: startYear, StartMonth: startMonth }, apiConfig.create());
        },
        addNewProduct: function (product) {
            return $http.post('/product/addNewProduct', product, apiConfig.create());
        },
        importProductData: function (importProductList) {
            return $http.post('/product/productImport', { ProductList: importProductList }, apiConfig.create());
        }
    };
}]);