﻿// web service proxy for standard account
webservices.factory('stdAccountService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getStdAccountHierarchy: function (orgID) {
            return $http.get('/stdAccount/StdAccountHierarchy?orgID=' + orgID, apiConfig.create());
        },
        GetStdAccountList: function () {
            return $http.get('/stdAccount/GetStdAccountList', apiConfig.create());
        },
        add: function (model) {
            return $http.post('/stdAccount/add', model, apiConfig.create());
        },
        update: function (model) {
            return $http.post('/stdAccount/update', model, apiConfig.create());
        },
        isactive: function (model) {
            return $http.post('/stdAccount/isactive', model, apiConfig.create());
        },
        get: function (id) {
            return $http.get('/stdAccount/getsingle?id=' + id, apiConfig.create());
        },
        getStdAccountLinkEtsAccount: function (orgID, accountSetID) {
            return $http.get('/stdAccount/getStdAccountLinkEtsAccount?orgID=' + orgID + '&accountSetID=' + accountSetID, apiConfig.create());
        },
        getStdAccountByOrgID: function (orgID) {
            return $http.get('/stdAccount/getStdAccountByOrgID?orgID=' + orgID , apiConfig.create());
        },
        getStdAccountByIndustryID: function (industryID) {
            return $http.get('/stdAccount/stdAccount/byIndustry/' + industryID, apiConfig.create());
        }
    };
}]);