﻿/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AdminAppNavController', ['$scope', '$rootScope', '$log', 'loginContext', 'enums', '$state',
function ($scope, $rootScope, $log, loginContext, enums, $state) {
    'use strict';
    $log.debug('AdminAppNavController.ctor()...');

    $scope.companyName = loginContext.projectCustomerName;

    $scope.toggleMenu = function () {
        $rootScope.$broadcast(enums.adminEvent.layoutChanged);
    };

    $scope.gotoAdminHomePage = function ($event) {
        var element = $event.target;
        if (element.hasClass('sidebar-toggler')) {
            return;
        } else {
            $state.go('adminHomePage');
        }
    };
}
]);