﻿
vatDongfengModule.controller('navBarController', ['$scope', '$rootScope', '$log', '$timeout', '$state', '$translate', 'projectService', 'SweetAlert', 'loginContext', 'vatSessionService', 'vatCommonService', 'application', 'enums', '$uibModal',
    function ($scope, $rootScope, $log, $timeout, $state, $translate, projectService, SweetAlert, loginContext, vatSessionService, vatCommonService, application, enums, $uibModal) {
        'use strict';
        $log.debug('navBarController.ctor()...');
        var baseDFFilePath = '/app/df/code/pages/';

        $scope.dateFormat = $translate.instant('dateFormat4YearMonth');
        $scope.showSubMenu = true;
        if (vatSessionService.project.name) {
            $scope.projectName = vatSessionService.project.name;
        } else {
            $scope.projectName = "普华永道上海税务(a1700000)";
        }

        $('#year').datepicker({
            format: 'yyyy年',
            weekStart: 1,
            autoclose: true,
            startView: 2,
            maxViewMode: 2,
            minViewMode: 2,
            forceParse: false,
            language: 'zh-CN'
        });

        $scope.selectedDate = new Date(vatSessionService.project.year, vatSessionService.month - 1, 1);
        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31, 23, 59, 59);

        var subStatusDto = {
            dispalyIndex: -1,
            name: '',
            isImported: false
        };

        var msgboxOptions = {
            title: $translate.instant('UnsavedChange'),
            text: $translate.instant('ComfirmIgnoreUnsavedChanges'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#e0301e",
            confirmButtonText: $translate.instant('ConfirmYes'),
            cancelButtonText: $translate.instant('ConfirmNo'),
            closeOnConfirm: true,
            closeOnCancel: true
        };

        $scope.changeDate = function () { };

        var dongfengGoUrl = function (src) {
            $log.debug('new page src:' + src);
            $('#dfiframe').attr("src", src);
        };

        $scope.uiHandling = function (menu) {

            $scope.selectedMenu = menu;
            $log.debug(menu);
            if ($scope.type === 1) {//递延所得税
                $scope.submenus = [
                    { text: '构成分析', title: "构成分析", src: '/app/df/code/pages/DFModleIndex.html' + '?_=' + Math.random(), icon: 'fa fa-bank' },
                    { text: '对未来现金流的影响分析', title: "对未来现金流的影响分析", src: '/app/df/code/pages/DFModleIndex2.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' },
                    { name: '变动分析', title: "变动分析", text: "变动分析", src: '/app/df/code/pages/DFModleIndex3.html' + '?_=' + Math.random(), icon: 'fa fa-list-ul' },
                    { name: '对当期利润的影响分析模型', title: "对当期利润的影响分析模型", permission: '02.001.009', text: "对当期利润的影响分析模型", icon: 'fa fa-file-text-o' }
                ];
                if (menu.fileName.indexOf('deferredTaxNEWWorkingPaper.html') > -1) {
                    $scope.setFrameHeight();
                }
                dongfengGoUrl(baseDFFilePath + menu.fileName);

                if (menu.num === 3) {
                    //选中submenu的第一个默认
                    $scope.dongfengGo($scope.submenus[0]);
                }
            } else if ($scope.type === 2) {//现金流
                $scope.hideSubMenu = false;

                if (menu.name == "税务预算") {
                    $scope.submenus = [
                        { text: '数据状态', src: baseDFFilePath + menu.fileName, icon: 'fa fa-bank' },
                        { text: '数据上传', src: baseDFFilePath + 'DFTaxBudgetUpload.htm' + '?_=' + Math.random(), icon: 'fa fa-upload', clickId: 'clickDataUpload' },
                        { text: '地产数据', src: baseDFFilePath + 'DFRealEstateData.html' + '?_=' + Math.random(), icon: 'fa fa-university', clickId: 'realEstateData' },
                        { text: '数据计算', src: baseDFFilePath + 'DFTaxBudgetCaculateSummary.htm' + '?_=' + Math.random(), icon: 'fa fa-calculator', clickId: 'clickDataCalculate' },
                        { text: '数据预览', src: baseDFFilePath + 'DFTaxBudgetView.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' }
                    ];
                } else if (menu.name == "实交税额") {
                    $scope.submenus = [
                        { text: '数据状态', src: baseDFFilePath + menu.fileName, icon: 'fa fa-bank' },
                        { text: '数据处理', src: baseDFFilePath + "DFTaxPaymentProcess.html", icon: 'fa fa-cogs', clickId: 'taxPaymentProcess'  },
                        { text: '数据分析', src: baseDFFilePath + 'actualPayDashboard.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' },
                        { text: '数据预览', src: baseDFFilePath + 'DFTaxPaymentView.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' },
                    ];
                } else if (menu.name == "预实对比") {
                    $scope.submenus = [
                        { text: '数据处理', src: baseDFFilePath + "DFPreRealContrastProcess.html", icon: 'fa fa-cogs', clickId: 'taxPaymentProcess' },
                        { text: '数据分析', src: baseDFFilePath + 'DFPreRealContrastDashboard.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' },
                    ];
                }else if (menu.name == "税收返还") {
                    $scope.submenus = [
                        { text: '数据状态', src: baseDFFilePath + menu.fileName, icon: 'fa fa-bank' },
                        { text: '数据处理', src: baseDFFilePath + "DFTaxReturnProcess.html", icon: 'fa fa-cogs' },
                        { text: '数据预览', src: baseDFFilePath + 'DFTaxReturnView.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' }];
                } else {
                    $scope.submenus = [{ text: '数据导入', src: baseDFFilePath + menu.fileName, icon: 'fa fa-bank' }];
                    $scope.hideSubMenu = true;
                }

                //if (menu.fileName) {
                $scope.dongfengGo($scope.submenus[0]);
                //}
            } else if ($scope.type === 3) { //数据统计
                
            }

        };

        var initMenu = function () {
            if ($scope.type === 1) { //递延所得税
                $('.vat-import-menu').show();
                $scope.serviceTitle = $translate.instant('DeferrIncomeTitle');
                $scope.menus = [{
                    name: '数据导入', num: 1, permission: '02.001', url: '#/vat/importData/balanceSheet', fileName: 'deferredTaxNEW.html' + '?_=' + Math.random()
                },
                { name: '数据核算', num: 2, permission: '02.002', url: '#/vat/previewData/balanceSheet', fileName: 'deferredTaxNEWWorkingPaper.html' + '?_=' + Math.random() },
                { name: '数据分析', num: 3, permission: '02.003', url: '#/vat/previewData/balanceSheet', fileName: 'DFModleIndex.html' + '?_=' + Math.random() },
                //{ name: '变动分析', num: 4, permission: '02.003', url: '#/vat/previewData/balanceSheet', fileName: 'DFModleIndex3.html' + '?_=' + Math.random() }
                ];
                //默认选中第一个
            } else if ($scope.type === 2) { //现金流
                $('.vat-import-menu').show();
                $scope.menus = [
                    { name: '税务预算', num: 1, permission: '02.001', url: '#', fileName: 'DFTaxActualStatus.html' + '?_=' + Math.random() },
                    { name: '实交税额', num: 2, permission: '02.002', url: '#', fileName: 'DFTaxPaymentStatus.html' + '?_=' + Math.random() },
                    { name: '预实对比', num: 3, permission: '02.003', url: '#', fileName: 'DFPreRealContrast.html' + '?_=' + Math.random() },
                    //{ name: '税额模拟', num: 4, permission: '02.004', url: '#', fileName: 'DFTaxAmountSimulation.html' + '?_=' + Math.random() },
                    { name: '税收返还', num: 4, permission: '02.005', url: '#', fileName: 'DFTaxReturnStatus.html' + '?_=' + Math.random() }
                ];
            } else if ($scope.type === 3) { //现金流 
                $('.vat-import-menu').hide();
                setTimeout(function(){
                    dongfengGoUrl(baseDFFilePath + 'DataSummary.html');
                },1000);
                return false;
            } else if ($scope.type === 4) { //现金流 
                $('.vat-import-menu').hide();
                setTimeout(function(){
                    dongfengGoUrl(baseDFFilePath + 'GlobalSearchResult.html');
                },1000);
                return false;
            }

            $scope.selectedMenu = $scope.menus[0];
            $timeout(function () {
                $scope.uiHandling($scope.menus[0]);
            }, 100);

            initTreeDrop();
        };

        $scope.orglist = [
             { "ID": 1, "name": "东风汽车有限公司", "expanded": true, "status": "已核算" },
             { "ID": "1_1", "categoryId": 1, "name": "东风汽车零部件（集团）有限公司", "expanded": true, "status": "未开始" },
             { "ID": "1_1_1", "categoryId": '1_1', "name": "东风贝洱热系统有限公司", "expanded": true, "status": "已导入" },
             { "ID": "1_1_2", "categoryId": '1_1', "name": "东风汽车紧固件有限公司", "expanded": true, "status": "已核算" },
             { "ID": "1_1_3", "categoryId": '1_1', "name": "上海弗列加滤清器有限公司", "expanded": true, "status": "已提交" },
             { "ID": "1_1_4", "categoryId": '1_1', "name": "东风精密铸造有限公司", "expanded": true, "status": "已分析" },
             { "ID": "1_2", "categoryId": 1, "name": "东风日产乘用车公司", "expanded": true, "status": "未开始" },
             { "ID": "1_2_1", "categoryId": '1_2', "name": "东风风神汽车有限公司", "expanded": true, "status": "已导入" },
             { "ID": "1_2_2", "categoryId": '1_2', "name": "东风日产发动机分公司", "expanded": true, "status": "已提交" },
             { "ID": "1_3", "categoryId": 1, "name": "东风汽车有限公司装备公司", "expanded": true, "status": "未开始" },
             { "ID": "1_4", "categoryId": 1, "name": "东风英菲尼迪有限公司", "expanded": true, "status": "未开始" },
        ];

        var initTreeDrop = function () {
            var dropDownTree = $("#org-treebox").dxDropDownBox({
                value: [1],
                valueExpr: "ID",
                displayExpr: "name",
                placeholder: "组织单元",
                showClearButton: true,
                dataSource: $scope.orglist,
                contentTemplate: function (e) {
                    var value = e.component.option("value"),
                        $treeView = $("<div>").dxTreeView({
                            dataSource: e.component.option("dataSource"),
                            dataStructure: "plain",
                            keyExpr: "ID",
                            parentIdExpr: "categoryId",
                            selectionMode: "single",
                            displayExpr: "name",
                            selectByClick: true,
                            onContentReady: function (args) {
                                syncTreeViewSelection(args.component, value);
                            },
                            selectNodesRecursive: false,
                            onItemSelectionChanged: function (args) {
                                var value = args.component.getSelectedNodesKeys();

                                e.component.option("value", value);
                                
                            }
                        });

                    treeView = $treeView.dxTreeView("instance");

                    e.component.on("valueChanged", function (args) {
                        var value = args.value;
                        syncTreeViewSelection(treeView, value);
                        dropDownTree.dxDropDownBox("instance").close();
                    });

                    return $treeView;
                }
            });

        };

        var showAccountingStatusModal = function () {
            var dropDownTree = $("#accounting-status-org-treebox").dxDropDownBox({
                value: [1],
                valueExpr: "ID",
                displayExpr: "name",
                placeholder: "组织单元",
                showClearButton: true,
                dataSource: $scope.orglist,
                contentTemplate: function (e) {
                    var value = e.component.option("value"),
                        $treeView = $("<div>").dxTreeView({
                            dataSource: e.component.option("dataSource"),
                            dataStructure: "plain",
                            keyExpr: "ID",
                            parentIdExpr: "categoryId",
                            selectionMode: "single",
                            displayExpr: "name",
                            selectByClick: true,
                            onContentReady: function (args) {
                                syncTreeViewSelection(args.component, value);
                            },
                            selectNodesRecursive: false,
                            onItemSelectionChanged: function (args) {
                                var value = args.component.getSelectedNodesKeys();

                                e.component.option("value", value);
                            }
                        });

                    accountingStatusTreeView = $treeView.dxTreeView("instance");

                    e.component.on("valueChanged", function (args) {
                        var value = args.value;
                        syncTreeViewSelection(accountingStatusTreeView, value);
                        dropDownTree.dxDropDownBox("instance").close();
                    });

                    return $treeView;
                }
            });
            $("#accountingStatusModal").modal('show');
        };

        var treeView, accountingStatusTreeView, dataGrid;
        var syncTreeViewSelection = function (treeView, value) {
            if (!value) {
                treeView.unselectAll();
                return;
            }

            value.forEach(function (key) {
                treeView.selectItem(key);
            });
        };

        $scope.$on(application.events.showSubMenu, function (event, data) {
            if (data) {
                $scope.showSubMenu = data.show;
            }
        });

        $scope.dongfengGo = function (menu) {
            parent.PWC.simulateProgress();
            $log.debug('new page src:' + menu.src);
            $scope.selectedSubMenu = menu;
            $('#dfiframe').attr("src", menu.src);
        };

        (function initialize() {
            $log.debug("nav-bar-crtl.js initialize() ");
            $scope.displaySubStatus = false;//导入子状态是否显示

            $rootScope.$on('statusChanged', function (event, args) {
                $log.debug("receive statusChanged");
                $log.debug(args.status);
                setLayoutStatusTitle(args.status);
            });

            if ($scope.type !== 5) {
                initMenu();
            }
            else {
                $timeout(function () {
                    $('#dfiframe').attr("src", '/app/df/code/pages/ETaxAudit.html');
                }, 500);
               
            }
            $scope.hideSubMenu = false;

            $timeout(function () {
                $scope.setFrameHeight();
            }, 500);
            
            $log.debug('dongfeng Type:' + $scope.type);

            $scope.showAccountingStatusModal = showAccountingStatusModal;
        })();
    }]);