﻿vatModule.controller('ImportCustomInvoiceCtrl', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval', 'enums', 'apiInterceptor'
    , 'Upload', 'dataImportService', 'vatImportService', 'vatSessionService', 'SweetAlert', 'uiGridConstants'
    , 'vatCommonService', 'vatWorkflowService', 'vatOperationLogService',
function ($scope, $log, $translate, $timeout, $q, $interval, enums, apiInterceptor
    , Upload, dataImportService, vatImportService, vatSessionService, SweetAlert, uiGridConstants
    , vatCommonService, vatWorkflowService, vatOperationLogService) {
    var successCount = 0;
    var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
    var _BlankChar = $translate.instant('PleaseSelectColumn');
    var resumable = true;
    var pageStatusEnum = { ToImport: 1, ShowData: 2, Reimport: 3 }; //状态 
    var importEnum = { Import: 0, CoverImport: 1, AddImport: 2 };   //导入方式
    var period = vatSessionService.month;
    var projectDbName = vatSessionService.project.dbName;
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    $scope.showErrorTable = false;
    $scope.showInitTable = false;
    $scope.showImportTable = false
    $scope.period = vatSessionService.month;
    //上传文件有效后缀名
    var ValidFileExtension = {
        XLS: "xls",
        XLSX: "xlsx"
    }
    $scope.chunkSize = 100000;
    $scope.success = false;
    //写日志
    $scope.moduleid = enums.vatModuleEnum.Import_CustomInvoice;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        OperationObject: $translate.instant('customInvoice'),
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.period,
    };



    //显示图标
    $scope.errorLevelToString = function (errorLevel) {
        if (errorLevel === 0) {
            return '/app-resources/images/vat/error.png';
        }
        if (errorLevel === 1) {
            return '/app-resources/images/vat/warning.png';
        }
        if (errorLevel === 2) {
            return '/app-resources/images/vat/tips.png';
        }
        else {
            return '/app-resources/images/vat/tips.png';
        }
    }


    //显示验证信息
    $scope.toggleErrorTab = function () {
        $scope.ImportErrorTag = !$scope.ImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.ImportErrorTag) {
            setErrorWrapCssDefault();
        } else {

            if (parseInt($('#content-resizer').css('bottom')) < 100) {
                $('#content-resizer').css('bottom', '150px');

                $('#topIcon').css({ bottom: '-381px' });

                $('.error-info-wrapper').css('height', '150px');
            }
        }
    };


    $scope.getGridHeight = function () {
        if ($scope.isLoadComplete) {
            return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
        }
        else {
            return { height: 0 + "px" };
        }
    };


    $scope.getErrorGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $("#error-info-wrapper").height();
            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: y + "px" };
            } else {

                return { height: '0px' };
            }
        }
        return {};
    };

    //日志
    $scope.showOperateLogPop = function () {
        $scope.isShowLog = true;
    };

    //检查用户机构权限
    var checkUserOrganizationPermissionList = function () {
        var list = [];
        var userManageTemp = constant.vatPermission.dataImport.customInvoice;
        list.push(userManageTemp.importCode);
        $scope.hasImportPermission = false;
        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {      
            $scope.hasImportPermission = data[userManageTemp.importCode];      
        });
    };


    //初始化列数据
    var initColumns = function () {
        //初始化进项发票汇总表列名
        $scope.mapNameList = [
            $translate.instant('PleaseSelectColumn'),
            $translate.instant('CustomsPayNum'),
            $translate.instant('CustomsIssueDate'),
            $translate.instant('InvoiceSE'),
            $translate.instant('InvoiceJE'),
            $translate.instant('CustomsAuditResult')
        ];
    };


    //设置上传文件名
    var updateFileName = function (newValue) {
        $scope.fileName = newValue.name;      
        //_.each(newValue, function (item) {
        //    $scope.fileName = item.name;
        //});
    };


    //上传文件
    var uploadfile = function (file) {
        if (file && checkUploadFiles(file)) {
            successCount = 0;
            if (!file.$error) {
                var tempFileName = PWC.newGuid() + '.dat';
                var token = $('input[name="__RequestVerificationToken"]').val();
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        cancel: false,
                        filename: file.name,
                        tempFileName: tempFileName,
                        file: file
                    },
                    resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(uploadSuccess);
            }
        }
    };


    //上传成功
    var uploadSuccess = function (resp) {
        successCount++;
        if (successCount === 1) {
            $scope.tempFileName = resp.data;
            changeSheet(0);
        }
    };


    //选择sheet
    function changeSheet(selectedSheet) {      
        var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
            return num.name === selectedSheet.name;
        });
        $scope.selectedMappingList = [];
        //initColumns();       
        //$scope.sheetInfo.selectedSheetIndex = sheetIndex;
        $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
        refreshTable();
    };


    //刷新列表
    function refreshTable() {
        $scope.showErrorTable = false;
        if (_.isString($scope.tempFileName)) {
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, 0).success(function (data) {
                $log.debug("refreshTable");
                $scope.showInitTable = false;
                $scope.showImportTable = true
                var sheetNameObjectArray = [];
                data.sheetNameList.forEach(function (v) {
                    sheetNameObjectArray.push({ 'name': v });
                });

                $scope.sheetData = data;
                $scope.sheetData.sheetNameList = sheetNameObjectArray;                           
                $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                initColumns();
                vatSessionService.dataChanged = true; //设置为true表示在切换页面前数据有变更, 需要提示
            });
        }
    };


    //列名对应
    //parentIndex：当前列号
    //index：下拉列表中选项的序号
    //colName:
    var changeMapping = function (parentIndex, index, colName) {       
        if (colName) {
            var newColumn = $scope.mapNameList[index];
            var oldColumn = $scope.selectedMappingList[parentIndex];

            //如果新的选择项与老的选择项一致，则不进行操作
            if (oldColumn === newColumn) {
                return;
            }
            else {
                $scope.selectedMappingList[parentIndex] = colName;

                if (colName !== $translate.instant('PleaseSelectColumn')) {
                    //如果当前选择的不是"请选择列名",则将选项从数组中移除
                    $scope.mapNameList.splice(index, 1);

                    if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                        //将老的选项追加到选项列表中
                        $scope.mapNameList.push(oldColumn);
                    }
                }
                else {
                    //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                    if (oldColumn) {
                        $scope.mapNameList.push(oldColumn);
                    }
                }
            }
        }
        $log.debug($scope.selectedMappingList);
    };


    function constructLogDto(logData, importType) {
        logData.ID = PWC.newGuid();
        logData.CreateTime = new Date();
        logData.UpdateTime = new Date();
        logData.OperationContent = $scope.fileName;
        if (importType === $scope.importEnum.Import) {
            logData.OperationName = $translate.instant('ImportCustomInvoice');
            logData.OperationType = enums.vatLogOperationTypeEnum.Import;
        }
        else if (importType === $scope.importEnum.CoverImport) {
            logData.OperationName = $translate.instant('ConvertCustomInvoice');
            logData.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
        }
        else if (importType === $scope.importEnum.AddImport) {
            logData.OperationName = $translate.instant('AppendCustomInvoice');
            logData.OperationType = enums.vatLogOperationTypeEnum.AddImport;
        }

        return logData;
    }

    function doImportCustomsInvoice(importType) {
        $log.debug("start to import customs invovice");
        $log.debug("file name: " + $scope.fileName);
        if (isSelectedFile() && validationColumnMapping() && checkUploadStartNum()) {
            var importresult = getCustDataBySheet(importType);
            vatSessionService.dataChanged = false; //设置为false表示不需要提示
            if (importresult && $scope.custInputList.length > 0) {
                vatImportService.importCustomsInvoiceList($scope.custInputList, importType).success(function (rsp) {
                    if (rsp.result) {
                        $scope.pageStatus = pageStatusEnum.ShowData;
                        getCustomsInvoiceList();
                        vatCommonService.importSetProjectStatus(projectDbName, period, constant.DictionaryDictKey.WFImportCustomInvoice
                                                                , enums.FinishStatusEnum.Finished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isCustomInvoiceImport, true);
                        var importLogDto = constructLogDto(logDto, importType);
                        importLogDto.UpdateState = $translate.instant('ImportSuccess');
                        vatOperationLogService.addOperationLog(importLogDto);
                        $log.debug("import customInvoice importCustomsInvoice: " + vatSessionService.project.importSubStatus.isCustomInvoiceImport);
                        SweetAlert.success($translate.instant('ImportSuccess'));
                    }
                    else {
                        if ($scope.haveImported) {
                            $scope.pageStatus = pageStatusEnum.Reimport;
                        }
                        else {
                            $scope.pageStatus = pageStatusEnum.ToImport;
                        }

                        var importLogDto = constructLogDto(logDto, importType);
                        importLogDto.UpdateState = $translate.instant('ImportFail');
                        vatOperationLogService.addOperationLog(importLogDto);
                        SweetAlert.error($translate.instant('ImportFail'));
                    }

                    $scope.fileName = null;
                });
            }
        }
    }

    //上传CustomsInvoice数据
    function importCustomsInvoice(importType) {
        if (vatSessionService.project.projectStatusList[$scope.period] >= constant.ProjectStatusEnum.Generated) {     
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[$scope.period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doImportCustomsInvoice(importType);
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doImportCustomsInvoice(importType);
        }
    };


    //判断是否选择了文件
    function isSelectedFile() {
        if (_.isUndefined($scope.fileName) || _.isNull($scope.fileName)) {           
            SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
            return false;
        }
        else if ($scope.sheetData.dataList.length <= 0) {         
            SweetAlert.warning($translate.instant('EmptyFileContent'));
            return false;
        }
        else {
            return true;
        }
    }


    //验证是否选中了正确的列名
    function validationColumnMapping() {
        var errorMsg = [];
        //1.海关缴款书号码是必选项
        if ($scope.selectedMappingList.indexOf($translate.instant('CustomsPayNum')) == -1) {
            errorMsg.push($translate.instant('CustomsPayNum'));         
        }

        //2. 开具日期是必选项
        if ($scope.selectedMappingList.indexOf($translate.instant('CustomsIssueDate')) == -1) {           
            errorMsg.push($translate.instant('CustomsIssueDate'));       
        }

        //3. 稽核结果是必选项
        if ($scope.selectedMappingList.indexOf($translate.instant('CustomsAuditResult')) == -1) {
            errorMsg.push($translate.instant('CustomsAuditResult'));      
        }


        //4. 税金是必选项
        if ($scope.selectedMappingList.indexOf($translate.instant('InvoiceSE')) == -1) {
            errorMsg.push($translate.instant('InvoiceSE'));     
        }

        if (errorMsg.length > 0)
        {
            var strError = '';
            errorMsg.forEach(function (item, index) {
                strError += item + ' ';
            });      
            SweetAlert.error($translate.instant('RequiredColumnNotSelect').formatObj({ errorMsg: strError }));
            return false;
        }
        else
        {
            return true;
        }
        
    }


    //准备导入数据
    function getCustDataBySheet(importType) {
        var isSuccess = true;
        $scope.custInputList = [];
        for (var i = $scope.startRowNum - 1; i < $scope.sheetData.dataList.length; i++) {
            var mappOk = true;
            var balanceDto = {};
            balanceDto.customsId = PWC.newGuid();
            balanceDto.periodId = period;          
            var rowData = $scope.sheetData.dataList[i];
            balanceDto = SetDefaultPriceValue(rowData, balanceDto, i);
            mappOk = validateColumnType(importType, rowData, balanceDto, i);
            //数据验证通过
            if (mappOk) {
                $scope.custInputList.push(balanceDto);
            }
            else {
                isSuccess = false;
                return false;
            }
        }
        return isSuccess;
    }


    //如果金额或者税金的导入数据为空，那么默认为0
    function SetDefaultPriceValue(rowData,balanceDto,i) {
        $.each($scope.selectedMappingList, function (cloumnindex, mappitem) {
            var columnData = mappitem;
            var cellData = rowData[cloumnindex];
            if (columnData == $translate.instant('InvoiceSE')) {
                if (PWC.isNullOrEmpty(cellData)) {
                    balanceDto.invoiceTaxAmount = '0.00';
                    rowData[cloumnindex] = '0.00';
                }              
            }

            if (columnData == $translate.instant('InvoiceJE')) {
                if (PWC.isNullOrEmpty(cellData)) {
                    balanceDto.invoiceAmount = '0.00';
                    rowData[cloumnindex] = '0.00';
                }               
            }
        });

        return balanceDto;
    }


    //验证并为Dto赋值
    function validateColumnType(importType,rowData, balanceDto, rowIndex) {
        var isSuccess = true;
        $.each($scope.selectedMappingList, function (cloumnindex, mappitem) {
            var columnData = mappitem;
            var cellData = rowData[cloumnindex];
            var payNumIndex = $scope.selectedMappingList.indexOf($translate.instant('CustomsPayNum'));
            if (columnData == $translate.instant('CustomsPayNum')) {
                if (_.isNull(cellData) || cellData === "") {                    
                    SweetAlert.error($translate.instant('CustomsPayNumEorror').formatObj({ rowIndex: rowIndex + 1 }));
                    isSuccess = false;
                    return false;
                }
                //else if (IsPayNumDuplicateInSheet($scope.sheetData.dataList, cellData, payNumIndex,rowIndex)) {
                //    swal({
                //        title: $translate.instant('FailureTitle'),
                //        text: $translate.instant('CustomsPayNumExistedInSheet').formatObj({ rowIndex: rowIndex + 1 , rows: rowData[payNumIndex] }),
                //        type: "error",
                //        confirmButtonText: $translate.instant('Confirm')
                //    });

                //    isSuccess = false;
                //    return false;
                //}
                //else if (IsPayNumInDb(importType, cellData)) {
                //    swal({
                //        title: $translate.instant('FailureTitle'),
                //        text: $translate.instant('CustomsPayNumExisted').formatObj({ rowIndex : rowIndex + 1, rows: rowData[payNumIndex] }),
                //        type:  "error",
                //        confirmButtonText: $translate.instant('Confirm')
                //    });

                //    isSuccess = false;
                //    return false;
                //}
                else {
                    balanceDto.payNum = cellData;
                }
            }

            if (columnData == $translate.instant('CustomsIssueDate')) {
                if (!PWC.isNullOrEmpty(cellData))
                {
                    if (PWC.checkDate(cellData)) {
                        balanceDto.issueDate = cellData
                    }
                    else {                   
                        SweetAlert.error($translate.instant('CustomsIssueNotDate').formatObj({ rowIndex: rowIndex + 1, rows: rowData[payNumIndex] }));
                        isSuccess = false;
                        return false;
                    }
                }
                else 
                {                  
                    SweetAlert.error($translate.instant('CustomsIssueEmpty').formatObj({ rowIndex: rowIndex + 1 }));
                    isSuccess = false;
                    return false;
                }

            }


            if (columnData == $translate.instant('InvoiceSE')) {
                if (isNaN(parseFloat(cellData))) {                  
                    SweetAlert.error($translate.instant('InvoiceSEError').formatObj({ rowIndex: rowIndex + 1, rows: rowData[payNumIndex] }));
                    isSuccess = false;
                    isSuccess = false;
                    return false;
                }
                else {
                    balanceDto.invoiceTaxAmount = cellData;
                }
            }

            if (columnData == $translate.instant('InvoiceJE')) {
                if (isNaN(parseFloat(cellData))) {                  
                    SweetAlert.error($translate.instant('InvoiceJEError').formatObj({ rowIndex: rowIndex + 1, rows: rowData[payNumIndex] }));
                    isSuccess = false;
                    return false;
                }
                else {
                    balanceDto.invoiceAmount = cellData;
                }

            }

            if (columnData == $translate.instant('CustomsAuditResult')) {
                if (_.isNull(cellData) || cellData === "") {                  
                    SweetAlert.error($translate.instant('CustomsAuditResultError').formatObj({ rowIndex: rowIndex + 1, rows: rowData[payNumIndex] }));
                    isSuccess = false;
                    return false;
                }
                else {
                    balanceDto.auditResult = cellData;
                }
            }
        });

        return isSuccess;
    };


    //获取CustomsInvoice数据
    function getCustomsInvoiceList() {    
        vatImportService.getCustomsInvoicesByPeriodId(period).success(function (data) {
                $scope.balanceOuputList = [];              
                $scope.pageStatus = pageStatusEnum.ShowData;
                $scope.haveImported = true;
                $scope.showInitTable = true;
                $scope.showImportTable = false;
                $scope.showErrorTable = false;
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;             

                //添加title
                var balanceTitleDto = [];
                balanceTitleDto.push($translate.instant('SequenceNo'));
                balanceTitleDto.push($translate.instant('CustomsPayNum'));
                balanceTitleDto.push($translate.instant('CustomsIssueDate'));
                balanceTitleDto.push($translate.instant('InvoiceSE'));
                balanceTitleDto.push($translate.instant('InvoiceJE'));
                balanceTitleDto.push($translate.instant('CustomsAuditResult'));
                //balanceTitleDto.push($translate.instant('PeriodId'));
                $scope.balanceOuputList.push(balanceTitleDto);
                   
                if (data.length > 0) {                  
                    data.forEach(function (item, index) {
                        var balancedto = [];                    
                        if (balanceTitleDto.indexOf($translate.instant('CustomsPayNum')) !== -1) {
                            balancedto.push(item.payNum);
                        }
                        if (balanceTitleDto.indexOf($translate.instant('CustomsIssueDate')) !== -1) {

                            balancedto.push(new Date(item.issueDate).dateTimeToString("yyyyMMdd"));
                        }
                        if (balanceTitleDto.indexOf($translate.instant('InvoiceSE')) !== -1) {
                            balancedto.push(item.invoiceTaxAmount);
                        }
                        if (balanceTitleDto.indexOf($translate.instant('InvoiceJE')) !== -1) {
                            balancedto.push(item.invoiceAmount);
                        }
                        if (balanceTitleDto.indexOf($translate.instant('CustomsAuditResult')) !== -1) {
                            balancedto.push(item.auditResult);
                        }
                        //if (balanceTitleDto.indexOf($translate.instant('PeriodId')) !== -1) {
                        //    balancedto.push(item.periodId);
                        //}             
                        $scope.balanceOuputList.push(balancedto);
                    });
                }
                else {
                    //$scope.balanceOuputList = [];
                    //$scope.pageStatus = pageStatusEnum.ToImport;
                    $scope.haveImported = false;
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }

                $log.debug('start to set gridview data....');
                $log.debug($scope.haveImported);
                $log.debug($scope.pageStatus);
                $log.debug($scope.showImportTable);
                $scope.gridOptionsIncomeInvoiceTotal.data = data;
                getValidationList();
        }).error(function () {            
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }
     

    //payNum是否在导入的sheet中重复
    function IsPayNumDuplicateInSheet(sheetData, payNum, payNumIndex,rowIndex) {
        var exist = false;
        for (var i = $scope.startRowNum - 1; i < sheetData.length; i++) {
            if(i === 0 || i === rowIndex){
                continue;
            }
            else {        
                if (sheetData[i][payNumIndex] === payNum) {
                    exist = true;
                    $log.debug("IsPayNumDuplicateInSheet有重复. payNum= " + payNum);
                    break;
                }
            }
        }
        return exist;
    }
    

    //payNum是否已经存在于数据库中
    function IsPayNumInDb(importType, payNum) {
        var exist = false;
        if (importType === importEnum.CoverImport) {
            exist = false;
        }
        else {
            $.each($scope.balanceOuputList, function (index, item) {
                if (item[0] === payNum) {
                    exist = true;
                    return false;
                }
            });
        }      
        return exist;
    }


    //清理海关数据
    function clearCustomInvocie() {
        swal({
            title: $translate.instant('IsDelete'),
            text: $translate.instant('ConfirmClearCustomsInvoice'),
            type: "warning",
            showCancelButton: true,
            confirmButtonText: $translate.instant('Yes'),
            cancelButtonText: $translate.instant('No'),
            closeOnConfirm: true,
            closeOnCancel: true
        },
        function (isConfirm) {
            if (isConfirm) {
                deleteCustomsInvoices(period);
            }
        });
       
    }


    function refreshCustomInvoice() {
        getCustomsInvoiceList();
    }
    
    function deleteCustomsInvoices(periodId) {
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = '';
        logDto.OperationName = $translate.instant('ClearCustomInvoice');
        logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;

        vatImportService.deleteCustomsInvoicesByPeriodId(periodId).success(function (data) {
            if (data) {             
                logDto.UpdateState = $translate.instant('DeleteSuccess');
                vatOperationLogService.addOperationLog(logDto);

                getCustomsInvoiceList();
                vatCommonService.clearProjectStatus(projectDbName, periodId, constant.DictionaryDictKey.WFImportCustomInvoice
                                                           , enums.FinishStatusEnum.NotFinished);
                vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isCustomInvoiceImport, false);
                $log.debug("clear customInvoice deleteCustomsInvoices: " + vatSessionService.project.importSubStatus.isCustomInvoiceImport);
                SweetAlert.success($translate.instant('DeleteSuccess'));             
            }
            else {
                logDto.UpdateState = $translate.instant('DeleteFailure');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.error($translate.instant('DeleteFailure'));              
            }          
        }).error(function () {
            logDto.UpdateState = $translate.instant('ClearFailed');
            vatOperationLogService.addOperationLog(logDto);
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }


    //校验上传文件后缀名
    function checkUploadFiles(file) {
        var result = true;       
        var fileName = file.name;
        var fileExtension = fileName.substr(fileName.lastIndexOf(".") + 1, fileName.length - fileName.lastIndexOf(".")).toLowerCase();
        if (fileExtension !== ValidFileExtension.XLS
            && fileExtension !== ValidFileExtension.XLSX) {         
            SweetAlert.warning($translate.instant('CustomInvoiceFileCheck'));
            result = false;
        }

        return result;
    }
    

    //校验起始行号
    function checkUploadStartNum()
    {
        var result = true;
        if (PWC.isNullOrEmpty($scope.startRowNum)) {        
            SweetAlert.warning($translate.instant('StartRowNull'));
            result = false;
        }
        if (parseInt($scope.startRowNum) > $scope.sheetData.dataList.length) {          
            SweetAlert.warning($translate.instant('StartRowNumberCheckMsg'));
            result = false;
        }
        return result;
    }


    //获取验证信息
    function getValidationList() {
        //改成海关清单类型
        //$scope.validationType = 0;
        vatImportService.getCustomsInvoicesValidates($scope.period).success(function (or) {
            if (!_.isNull(or) && !_.isUndefined(or)) {
                if (or.data.length > 0) {
                    var index = 1;
                    or.data.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.errorList = or.data;
                    $scope.gridOptionsErrorMsg.data = or.data;

                    showErrTab();
                    $scope.toggleErrorTab();
                    $scope.showErrorTable = true;
                }
                else {
                    $scope.errorList = [];
                    $scope.gridOptionsErrorMsg.data = [];
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            }
            
        });
    }


    var setErrorWrapCssDefault = function () {
        $('#content-resizer').css('bottom', '30px');

        $('#topIcon').css({ bottom: '-501px' });

        $('.error-info-wrapper').css('height', '30px');
    };


    function showErrTab() {
        $scope.ImportErrorTab = true;
        $scope.ImportErrorTag = true;
        $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

    };

    function closeModal (e) {
        var buttonId = e.target.id;
        if (!_.isUndefined(buttonId) && !_.isNull(buttonId)) {
            if (_.isEqual(buttonId, "btnClosePayNumDuplicate")) {
                $('#payNumDuplicateModal').modal('hide');
            }
        }
    }
    

    function showValidateDetails (row) {
        $log.debug("showValidateDetails");
        $log.debug(row);
        //海关缴款文书标号重复信息
        if (_.isEqual(row.erpCheckTypeId, constant.ErpCheckType.CustomInvoice_DuplicatePayNum)) {
            vatImportService.getPayNumDuplicateDetails().success(function (or) {
                if (!_.isNull(or) && !_.isUndefined(or)) {
                    if (or.result) {
                        $scope.gridOptionsPayNumDuplicate.data = or.data;
                        $('#payNumDuplicateModal').modal('show');
                    }
                    else {
                        SweetAlert.warning($translate.instant(or.resultMsg));
                    }
                }

            });
        }
        
    }


    function deleteDuplicatePayNum() {
        $log.debug("deleteDuplicatePayNum");
        var dupIds = [];
        var dupPayNums = [];
        var dupRows = $scope.gridApiPayNumDuplicate.selection.getSelectedRows();
        dupRows.forEach(function (item, index) {
            dupIds.push(item.customsId);
            dupPayNums.push(item.payNum);
        });

        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = dupPayNums.join(",");
        logDto.OperationName = $translate.instant('DeleteDuplicateData');
        logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

        vatImportService.deleteCustomInvoiceByIds(dupIds).success(function (or) {
            if (!_.isNull(or) && !_.isUndefined(or)) {
                if (or.result) {
                    logDto.UpdateState = $translate.instant('DeleteSuccess');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.success($translate.instant('DeleteSuccess'));
                    $('#payNumDuplicateModal').modal('hide');
                    vatImportService.updateCustomsInvoiceValidation(period).success(function (or) {
                        if (!_.isNull(or) && !_.isUndefined(or)) {
                            if (or.result) {
                                getCustomsInvoiceList();
                            }
                        }
                    });

                }
                else {
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }
            }
        }).error(function () {
            logDto.UpdateState = $translate.instant('DeleteFailed');
            vatOperationLogService.addOperationLog(logDto);
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    };

    //开始
    (function initialize() {
        $log.debug('ImportCustomInvoiceCtrl.ctor()...');
        $scope.startRowNum = 2;
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };//UI中sheet的数据
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 }; //sheet基本信息      
        $scope.custInputList = [];//存放待导入数据  //$scope.balanceInputList = [];
        $scope.changeSheet = changeSheet;
        $scope.changeMapping = changeMapping;
        $scope.pageStatusEnum = pageStatusEnum;
        $scope.pageStatus = pageStatusEnum.ToImport;
        $scope.importEnum = importEnum;
        $scope.importCustomsInvoice = importCustomsInvoice;
        $scope.haveImported = true;
        $scope.clearCustomInvocie = clearCustomInvocie;
        $scope.refreshCustomInvoice = refreshCustomInvoice;
        $scope.closeModal = closeModal;
        $scope.showValidateDetails = showValidateDetails;
        $scope.deleteDuplicatePayNum = deleteDuplicatePayNum;   
        $scope.$watch('fileNameWrapper', function (newValue, oldValue) {
            if (newValue != null && newValue !== oldValue) {
                $log.debug("custom-invoice: watch fileNameWrapper");
                updateFileName(newValue);
                uploadfile($scope.fileNameWrapper);
                $scope.selectedMappingList = [];
                initColumns();
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;
                if ($scope.haveImported) {
                    $scope.pageStatus = pageStatusEnum.Reimport;
                }
                else {
                    $scope.pageStatus = pageStatusEnum.ToImport;
                }

                $log.debug($scope.haveImported);
                $log.debug($scope.pageStatus);
                $log.debug($scope.showImportTable);
            }
        });

        $scope.showInitTable = true;//仅展示导入数据
        $scope.showImportTable = false; //选择导入后，显示excel sheet和colum mapping
        getCustomsInvoiceList(); 
        checkUserOrganizationPermissionList();
        $timeout(function () {
            $scope.isLoadComplete = true;
        }, 500);


        //验证信息数据源
        $scope.gridOptionsErrorMsg = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
              {
                  name: $translate.instant('Icon'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
              },
              {
                  name: $translate.instant('SequenceNo'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)" ><span>{{row.entity.index}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorResult'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)" ><span>{{row.entity.validationResult}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorCount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)" ><span>{{row.entity.number}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)" ><span>{{row.entity.validationDetails}}<span></div>'
              },
              {
                  name: $translate.instant('ValidationTips'), width: '25%', cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}" ng-dblClick="grid.appScope.showValidateDetails(row.entity)"><span>{{row.entity.validationTips}}<span></div>'
              }
            ],
            onRegisterApi: function (gridApi) {
                $scope.errorGridApi = gridApi;

                $interval(function () {
                    $scope.errorGridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        $scope.gridOptionsIncomeInvoiceTotal = {
            //set gridview options
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            //set gridview header
            columnDefs: [
              {
                  name: $translate.instant('SequenceNo'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.seqNo}}<span></div>'
              },
              {
                  name: $translate.instant('CustomsPayNum'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.payNum}}<span></div>'
              },
              {
                  name: $translate.instant('CustomsIssueDate'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.issueDate | date:"yyyy-MM-dd" }}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceSE'), width: '15%', headerCellClass: 'right', cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.invoiceTaxAmount | number:2}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceJE'), width: '15%', headerCellClass: 'right', cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.invoiceAmount | number:2}}</span></div>'
              },
              {
                  name: $translate.instant('CustomsAuditResult'), width: '30%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.auditResult}}</span></div>'
              }
              //{
              //    name: $translate.instant('PeriodId'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodId}}</span></div>'
              //}
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiTotal = gridApi;
                $interval(function () {
                    $scope.gridApiTotal.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };


        //海关缴款书号重复弹出框数据源
        $scope.gridOptionsPayNumDuplicate = {
            enableColumnResizing: true,
            enableRowSelection: false,
            enableSelectAll: true,
            rowHeight: constant.UIGrid.rowHeight,
            enableRowHeaderSelection: true,
            modifierKeysToMultiSelect: true, //按住Ctrl才能多选 
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableFiltering: false,
            showTreeExpandNoChildren: false,
            enableFullRowSelection: false, //是否点击行任意位置后选中,默认为false
            multiSelect: true,// 是否可以选择多个,默认为true;
            columnDefs: [
               {
                   name: $translate.instant('CustomsPayNum'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding" ><span>{{row.entity.payNum}}</span></div>'
               },
               {
                   name: $translate.instant('CustomsIssueDate'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.issueDate | date:"yyyy-MM-dd" }}</span></div>'
               },
               {
                   name: $translate.instant('InvoiceSE'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.invoiceTaxAmount}}</span></div>'
               },
               {
                   name: $translate.instant('InvoiceJE'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.invoiceAmount}}</span></div>'
               },
               {
                   name: $translate.instant('CustomsAuditResult'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.auditResult}}</span></div>'
               },
               {
                   name: $translate.instant('InvoiceQJ'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.periodId}}</span></div>'
               }
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiPayNumDuplicate = gridApi;
                //$scope.gridApiPayNumDuplicate.core.handleWindowResize();

                $interval(function () {
                    $scope.gridApiPayNumDuplicate.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };


        
    })();
}]);