﻿invoiceModule.controller('invoiceManageMainController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', 'InvoiceManageService', '$location', 'Upload',
        function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, InvoiceManageService, $location, Upload) {
            'use strict';
  
            var parentSelector = '.invoice-manage-main';

            $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
            $scope.pleaseInput = $translate.instant('InputPlaceholder'),

            //分页的设置
            $scope.pagingOptions = { 
                pageIndex: 1,  //当前页码
                totalItems: 100,  //总数据
                pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
            };

            $scope.searchEntity = {};
            $scope.datagrid = {};
            $scope.hasShowMoreSearchBox = false;
            $scope.selectedRecourdCount = 0;

            var uploadIndexPageUrl = "/invoiceManagement/main/uploadIndex";


            $scope.translated = {
                NoData: $translate.instant('NoDataText'),
                pleaseSelect: $translate.instant("ChoosePlaceholder"),
                pleaseInput: $translate.instant('InputPlaceholder'),
            };


            //消息弹框
            var messageBox = {
                getMsg: function (resultMsg, hasTranslated) {
                    hasTranslated = hasTranslated || false;
                    var msg = resultMsg;
                    if (!hasTranslated) {
                        msg = $translate.instant(resultMsg);
                    }
                    return msg;
                },

                success: function (resultMsg, hasTranslated) {
                    var msg = this.getMsg(resultMsg, hasTranslated)
                    SweetAlert.success(msg);
                },

                warning: function (resultMsg, hasTranslated) {
                    var msg = this.getMsg(resultMsg, hasTranslated)
                    SweetAlert.warning(msg);
                },

                //有确认和取消按钮
                confirm: function (title, text, customClass) {
                    var deferred = $q.defer();
                    SweetAlert.swal({
                        title: title,
                        text: text,
                        html: true,
                        type: "warning",
                        customClass: customClass || '',
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        allowOutsideClick: false,
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                      function (isConfirm) {
                          deferred.resolve(isConfirm);
                      });

                    return deferred.promise;
                },

                //没有取消按钮
                info: function (title, text, customClass) {
                    var deferred = $q.defer();

                    SweetAlert.swal({
                        title: title,
                        text: text,
                        html: true,
                        type: "warning",
                        customClass: customClass || '',
                        showCancelButton: false,
                        confirmButtonColor: "#DD6B55",
                        allowOutsideClick: false,
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: true,
                        closeOnCancel: false
                    },
                      function (isConfirm) {
                          deferred.resolve(isConfirm);
                      });

                    return deferred.promise;
                },
            };

            //模态框
            var createModalInstance = function (templateUrl, windowClass) {
                var thisModalService = new Object();
                var parentElem = parentSelector ? angular.element($document[0].querySelector(parentSelector)) : undefined;

                thisModalService.open = function () {
                    var modalInstance = $uibModal.open({
                        animation: true,
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        backdrop: 'static',  //点击父页面不会自动关闭 
                        templateUrl: templateUrl, //模板
                        windowClass: windowClass, //弹框页面的css
                        scope: $scope,
                        appendTo: parentElem,
                    });

                    thisModalService.modalInstance = modalInstance;
                };

                thisModalService.close = function (result) {
                    if (thisModalService.modalInstance) {
                        thisModalService.modalInstance.close(result);
                    }
                };

                thisModalService.cancel = function () {
                    if (thisModalService.modalInstance) {
                        thisModalService.modalInstance.dismiss('cancel');
                    }
                }
                return thisModalService;
            };

            //弹框服务
            $scope.modalService = {
                //打开发票认证模态框
                invoiceVerify:{
                    open:function(){
                        $scope.verifyInvoiceModalInstance = createModalInstance('uploadInvoiceVerify.html', 'importVerifyInvoiceModal');
                        $scope.verifyInvoiceModalInstance.open();
                    },
                    save: function () {
                        uploadService.uplodFile();
                    },
                    cancel:function(){
                        $scope.verifyInvoiceModalInstance.cancel();
                    },
                },

                invoiceDetail: {
                    open: function () {
                        $scope.invoiceDetailTableInstance = createModalInstance('invoiceDetailTable.html', 'invoice-table-dialog');
                        $scope.invoiceDetailTableInstance.open();
                    },
                    save: function () {
                        $scope.invoiceDetailTableInstance.cancel();
                    },
                    cancel: function () {
                        $scope.invoiceDetailTableInstance.cancel();
                    },
                }
            };

            //上传认证清单
            var uploadService = {
                 resumable : true,
                 uploadUrl: apiInterceptor.webApiHostUrl + '/invoiceManage/UploadInvoiceVerifyFile',
                 uplodFile: function () {
                     var verifyFile = $scope.$$childTail.invoiceVerifyfile;
                     var fileName = verifyFile && $scope.$$childTail.invoiceVerifyfile.name;
                     if (!fileName) {
                         messageBox.warning("请先选择文件", true);
                         return;
                     }

                     var tempFileName = PWC.newGuid() + '.dat';
         
                     var token = $('input[name="__RequestVerificationToken"]').val();
                     Upload.upload({
                         url: uploadService.uploadUrl,
                         data: {
                             cancel: false,
                             filename: fileName,
                             tempFileName: tempFileName,
                         },
                         file: verifyFile,
                         resumeChunkSize: uploadService.resumable ? $scope.chunkSize : null,
                         headers: {
                             'Access-Control-Allow-Origin': '*',
                             Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken,
                             __RequestVerificationToken: token,
                             withCredentials: true
                         }, withCredentials: true
                     }).then(function (resp) {
                         if (resp.data.result) {
                             messageBox.success('文件上传成功');
                             $scope.verifyInvoiceModalInstance.close();
                             //刷新table
                             $scope.eventService.refreshInvoiceDataGrid();
                         }
                         else {
                             messageBox.warning(resp.data.resulMsg, true);
                         }
                     });
                 },

            };

            //获取数据服务
            var getService = {
                //查询的数据源准备
                getInvoiceFilterBasicData: function () {
                    var deferred = $q.defer();
                    InvoiceManageService.getInvoiceFilterBasicData().success(function (data) {
                        if (data) {
                            if (!$scope.searchFilterOptions) {
                                $scope.searchFilterOptions = {};
                            }
                            // console.log('data' + JSON.stringify(data));
                            $scope.searchFilterOptions = {
                                invoiceStatusList: memoryService.translateEnumValue(data.invoiceStatusList),
                                invoiceEntityList: memoryService.translateEnumValue(data.invoiceEntityList),
                                invoiceTypeList: memoryService.translateEnumValue(data.invoiceTypeList),
                                invoiceSourceList: memoryService.translateEnumValue(data.invoiceSourceList),
                                invoiceUploadTypeList: memoryService.translateEnumValue(data.invoiceUploadTypeList),
                            };
                            //退票理由
                            $scope.refundReasons = memoryService.translateEnumValue(data.invoiceRefundReasonList);

                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },

                //筛选invoice list
                getInputInvoiceList: function () {
                    var deferred = $q.defer();

                    var invoiceParams = {
                        InvoiceQuery: $scope.searchEntity,
                        pagingDto: $scope.pagingOptions,
                    };

                    InvoiceManageService.getInputInvoiceList(invoiceParams).success(function (data) {
                        if (data) {
                            $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                            if (data && data.list) {
                                data.list.forEach(function (item) {
                                    item.statusString = $translate.instant(item.statusString);
                                    item.invoiceEntityTypeString = $translate.instant(item.invoiceEntityTypeString);
                                    item.invoiceSourceTypeString = $translate.instant(item.invoiceSourceTypeString);
                                    item.invoiceTypeString = $translate.instant(item.invoiceTypeString);
                                    item.uploadTypeString = $translate.instant(item.uploadTypeString);
                                    item.uploadDate = moment(item.uploadDate).format(constant.date.dateFormatUppercase);
                                    item.invoiceDate = moment(item.invoiceDate).format(constant.date.dateFormatUppercase);
                                });
                            }
                            $scope.invoiceGridDataSource = data.list;
                            deferred.resolve(data);
                        };
                    });
                    return deferred.promise;
                },

            };

            //更新数据服务
            var updateService = {
                //发票识别,手动识别
                invoiceManualRecognize: function (invoiceIDList) {
                    var deferred = $q.defer();
                    InvoiceManageService.invoiceManualRecognize(invoiceIDList).success(function (data) {
                        if (data) {
                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },
                //发票验真
                invoiceExamination: function (invoiceIDList) {
                    var deferred = $q.defer();
                    InvoiceManageService.invoiceExamination(invoiceIDList).success(function (data) {
                        if (data) {
                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },
                //变更发票状态
                updateInvoiceStatus: function (invoiceIDList,invoiceStatusID) {
                    var deferred = $q.defer();
                    InvoiceManageService.updateInvoiceStatus(invoiceStatusID, invoiceIDList).success(function (data) {
                        if (data) {
                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },
            };

    
            //内部处理
            var memoryService = {
                repaintInvoiceGrid: function () {
                    $scope.setInvoiceGridHeight();
                },
                //翻译查询的数据源
                translateEnumValue: function (data) {
                    if (!data || data.length == 0) return null;

                    data.forEach(function (item) {
                        item.value = $translate.instant(item.value);
                    });
                    return data;
                },
            };

            //button的事件
            $scope.eventService = {
                //上传
                gotoUploadIndexPage: function () {
                    $location.path(uploadIndexPageUrl);
                },

                checkHasItemSelected: function () {
                    if (!$scope.datagrid.selectedItems || $scope.datagrid.selectedItems.length == 0)
                    {
                        messageBox.warning("请至少选择一条记录", true);
                        return false;
                    }
                    return true;
                },

                //发票识别,已上传、已补录：识别
                invoiceManualRecognize: function () {

                    if (!$scope.eventService.checkHasItemSelected()) {
                        return false;
                    }

                    //只有已上传、已补录，可以做识别
                    var filterResult = _.filter($scope.datagrid.selectedItems, function (item) {
                        return item.status !== constant.inputInvoice.statusType.InvoiceHasUpload.id 
                            && item.status !== constant.inputInvoice.statusType.InvoiceHasAddRecord.id
                    });

                    if (filterResult.length > 0) {
                        messageBox.warning("只有已上传或者已补录的发票可以做发票识别", true);
                        return;
                    }
                    var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');

                    updateService.invoiceManualRecognize(selectedInvoiceIDList).then(function (data) {
                        if (data) {
                            messageBox.success("发票识别成功", true);
                        }
                    });
                },

                //发票验真,只有识别成功的才可以做验真。
                invoiceExamination: function () {
                    if (!$scope.eventService.checkHasItemSelected()) {
                        return false;
                    }
                    //只有识别成功的才可以做验真。
                    var filterResult = _.filter($scope.datagrid.selectedItems, function (item) {
                        return item.status !== constant.inputInvoice.statusType.InvoiceRecognizeSuccess.id;
                    });

                    if (filterResult.length > 0) {
                        messageBox.warning("只有识别成功的发票可以做验真", true);
                        return;
                    }
                    var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');

                    updateService.invoiceExamination(selectedInvoiceIDList).then(function (data) {
                        if (data) {
                            messageBox.success("发票验真成功", true);
                        }
                    });
                },

                //退票
                refundInovice: function () {
                    //弹框
                    if (!$scope.eventService.checkHasItemSelected()) {
                        return false;
                    }
                    $scope.selectedItemIDs = _.pluck($scope.datagrid.selectedItems, 'id');
                    $scope.showRefundModal = true;
                },

                //发票认证
                verifyInvoice: function () {
                    //上传excel
                },

                //失效
                expireInvoice: function () {
                    if (!$scope.eventService.checkHasItemSelected()) {
                        return false;
                    }
                    var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');
                    var status = stant.inputInvoice.statusType.InvoiceHasExpired.id;
                    messageBox.confirm("确认要把选中的发票进行失效处理吗？", '').then(function (isConfirm) {
                        if (isConfirm) {
                            updateService.updateInvoiceStatus(selectedInvoiceIDList, status).then(function (data) {
                                if (data) {
                                    messageBox.success("处理成功", true);
                                }
                            });
                        }
                    });
                },

                refreshInvoiceDataGrid: function () {
                    getService.getInputInvoiceList().then(function (data) {
                        $timeout(function () {
                            memoryService.repaintInvoiceGrid();
                        }, 100);
                    });
                },
            }

            //datagrid内部的事件
            $scope.dataGridService = {
                //发票识别
                manualRecognizInvoice: function (data) {

                    var selectedInvoiceIDList = [];
                    if (data)
                    {
                        selectedInvoiceIDList.push(data.id);
                    }
                    if (selectedInvoiceIDList.length > 0) {
                        updateService.invoiceManualRecognize(selectedInvoiceIDList).then(function (data) {
                            if (data) {
                                messageBox.success("发票识别成功", true);
                            }
                        });
                    }
                },

                //发票手动验真
                invoiceExamination: function (data) {
                    var selectedInvoiceIDList = [];
                    if (data) {
                        selectedInvoiceIDList.push(data.id);
                    }
                    if (selectedInvoiceIDList.length > 0) {
                        updateService.invoiceExamination(selectedInvoiceIDList).then(function (data) {
                            if (data) {
                                messageBox.success("发票验真成功", true);
                            }
                        });
                    }
                },

                //退票
                refundInovice: function (data) {
                    //弹框
                    var selectedInvoiceIDList = [];
                    if (data) {
                        selectedInvoiceIDList.push(data.id);
                    }
                    $scope.selectedItemIDs = selectedInvoiceIDList;
                    $scope.showRefundModal = true;
                },
                //票账匹配
                matchTicketAccount: function (data) {

                },
                //手动验真
                invoiceManualExamination: function (data) {
                    //弹框
                    $scope.isShowExaminationModal = true;
                    $scope.selectedInvoiceEntity = data;
                },
            }

            //搜索框的处理
            $scope.searchboxService = {
                //隐藏或者展示搜索框
                showOrHideSearchBox: function () {
                    $scope.hasShowMoreSearchBox = !$scope.hasShowMoreSearchBox;
                   // $scope.eventService.refreshInvoiceDataGrid();
                    $timeout(function () {
                        memoryService.repaintInvoiceGrid();
                    }, 50);
                  
                },
                
                //根据条件搜索发票
                searchInvoice: function () {
                    console.log('searchEntity:' + JSON.stringify($scope.searchEntity));
                    $scope.pagingOptions.pageIndex = 1;
                    $scope.eventService.refreshInvoiceDataGrid();
               
                },
            }

             //初始化invoice datagrid data
            var loadInvoiceGridData = function () {

                $scope.eventService.refreshInvoiceDataGrid();
            }

            //初始化invoice datagrid 树
            var InitInvoiceGrid = function () {

                var allowFilter = false;
                $scope.invoiceGridOptions = {
                    bindingOptions: {
                        dataSource: 'invoiceGridDataSource',
                    },
                    headerFilter: {
                        visible: true,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: '全选'//$translate.instant('SelectAll'),
                        }
                    },
                   // keyExpr: "ID",
                    selection: {
                        mode: "multiple",
                        showCheckBoxesMode: 'always'
                    },
                    paging: {
                        enabled: false,
                    },
                    hoverStateEnabled: true,
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                   //rowAlternationEnabled: true,
                    showBorders: true,
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),

                    onContentReady: function (e) {
                        $scope.invoiceGridInstance = e.component;
                    },
                    onCellPrepared: function (e) {
                        //已退票,已失效不显示checkbox
                        if (e.rowType === "data" & e.column.command === 'select' &&
                            (e.data.status === constant.inputInvoice.statusType.InvoiceHasRefund.id
                            || e.data.status === constant.inputInvoice.statusType.InvoiceHasExpired.id)) {
                            e.cellElement.find('.dx-select-checkbox').hide();
                            //e.cellElement.find('.dx-select-checkbox').addClass('dx-state-disabled');
                            e.cellElement.off();
                        }
                    },
                    onSelectionChanged: function (data) {
                        $scope.datagrid.selectedItems = data.selectedRowsData;
                        $scope.selectedRecourdCount = data.selectedRowsData.length;
                        //$scope.selectedItemIDs = _.pluck(data.selectedRowsData, 'id');
                        //$scope.selectedPlaceholder = data.selectedRowsData.length;
                        //$scope.disabled = !$scope.selectedItemIDs.length;
                    },
                    columns: [
                            { dataField: 'invoiceCode', caption: $translate.instant('InvoiceFPDM'), allowHeaderFiltering: allowFilter },
                            {
                                dataField: 'invoiceNumber', caption: $translate.instant('InvoiceFPHM'),allowHeaderFiltering: allowFilter,
                                cellTemplate: function (container, options) {
                                    try {
                                        $('<a class="invoiceNumber-link">').text(options.value)
                                           .on('click', function () {
                                               $scope.selectedInvoice = options.data;
                                               $scope.modalService.invoiceDetail.open();
                                           })
                                          .appendTo(container);
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },
                            { dataField: 'statusString', caption: $translate.instant('InvoiceStatus'), allowHeaderFiltering: true },
                            { dataField: 'buyerName', caption: $translate.instant('BuyerName'), width: 100, allowHeaderFiltering: allowFilter },
                            { dataField: 'buyerTaxNumber', caption: $translate.instant('BuyerTaxNumber'), width: 100, allowHeaderFiltering: allowFilter },
                            { dataField: 'sellerName', caption: $translate.instant('SellerName'), width: 100, allowHeaderFiltering: allowFilter },
                            { dataField: 'sellerTaxNumber', caption: $translate.instant('SellerTaxNumber'), width: 100, allowHeaderFiltering: allowFilter },
                            { dataField: 'amount', caption: $translate.instant('FaceTaxAmount'), width: 60, allowHeaderFiltering: allowFilter }, //税额合计小写
                            { dataField: 'taxAmount', caption: $translate.instant('InvoiceSE'), allowHeaderFiltering: allowFilter },  //税额
                            { dataField: 'invoiceDate', caption: $translate.instant('InvoiceDate'), allowHeaderFiltering: allowFilter }, //开票日期
                            { dataField: 'invoiceEntityTypeString', caption: $translate.instant('InvoiceEntity'), allowHeaderFiltering: allowFilter },
                            { dataField: 'invoiceTypeString', caption: $translate.instant('InvoiceFPLX'), allowHeaderFiltering: allowFilter },
                            { dataField: 'uploadDate', caption: $translate.instant('UploadDate'), allowHeaderFiltering: allowFilter },
                            { dataField: 'invoiceSourceTypeString', caption: $translate.instant('InvoiceSource'), allowHeaderFiltering: allowFilter }, //发票来源
                            { dataField: 'uploadTypeString', caption: $translate.instant('UploadType'), allowHeaderFiltering: allowFilter },
                            { dataField: 'statusString', caption: $translate.instant('InvoiceStatus'), allowHeaderFiltering: true },
                            {
                                dataField: 'id', caption: $translate.instant('Operation'),allowHeaderFiltering: allowFilter,
                                cellTemplate: function (container, options) {
                                    try {
                                        var data = options.data;
                                        var invoiceStatusType = constant.inputInvoice.statusType;
                                        //已上传、已补录：识别
                                        if (data.status == invoiceStatusType.InvoiceHasUpload.id || data.status == invoiceStatusType.InvoiceHasAddRecord.id) {
                                            $("<span class='span-btn' />")
                                                .text('识别')
                                                .on('click', function () {
                                                    $scope.dataGridService.manualRecognizInvoice(data);
                                                })
                                            .appendTo(container);
                                        }
                                            //识别成功：验真
                                        else if (data.status == invoiceStatusType.InvoiceRecognizeSuccess.id) {
                                            $("<span class='span-btn' />")
                                                .text('验真')
                                                .on('click', function () {
                                                    $scope.dataGridService.invoiceExamination(data);
                                                })
                                            .appendTo(container);
                                        }
                                            //无法识别：退票或者重新识别
                                        else if (data.status == invoiceStatusType.InvoiceUnrecognize.id) {
                                            $("<span class='span-btn' />")
                                                .text('退票')
                                                .on('click', function () {
                                                    $scope.dataGridService.refundInovice(data);
                                                })
                                            .appendTo(container);

                                            $("<span class='span-btn' />")
                                                .text('重新识别')
                                                .on('click', function () {
                                                    $scope.dataGridService.manualRecognizInvoice(data);
                                                })
                                            .appendTo(container);

                                        }
                                            //识别失败：退票
                                        else if (data.status == invoiceStatusType.InvoiceRecognizeFailure.id) {
                                            $("<span class='span-btn' />")
                                                .text('退票')
                                                .on('click', function () {
                                                    $scope.dataGridService.refundInovice(data);
                                                })
                                            .appendTo(container);
                                        }

                                            //验真失败：手动验真
                                        else if (data.status == invoiceStatusType.InvoiceVerifyFailure.id) {
                                            $("<span class='span-btn' />")
                                                .text('手动验真')
                                                .on('click', function () {
                                                    $scope.dataGridService.invoiceManualExamination(data);
                                                })
                                            .appendTo(container);
                                        }
                                            //待匹配：票账匹配，退票 
                                        else if (data.status == invoiceStatusType.InvoicePendingMatch.id) {
                                            $("<span class='span-btn' />")
                                            .text('票账匹配')
                                            .on('click', function () {
                                                $scope.dataGridService.matchTicketAccount(data);
                                            })
                                            .appendTo(container);

                                            $("<span class='span-btn' />")
                                                .text('退票')
                                                .on('click', function () {
                                                    $scope.dataGridService.refundInovice(data);
                                                })
                                            .appendTo(container);
                                        }
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },
                           ],

                    masterDetail: {
                        enabled: true,
                        template: "detail"
                    },
                    detailGridOptions: function (invoiceID) {
                        return {
                            dataSource: new DevExpress.data.DataSource({
                                load: function (loadOptions) {
                                    var deferred = $q.defer();
                                   return InvoiceManageService.getInputInvoiceItemList(invoiceID).success(function (response) {
                                       deferred.resolve({ data: response, totalCount: response.length });
                                   }).error(function () {
                                       deferred.reject("Data Loading Error");
                                   });
                                    return deferred.promise;
                    }
                            }),
                            noDataText: $translate.instant('NoDataText'),
                            columnAutoWidth: true,
                            //showBorders: true,
                            allowColumnResizing: true,
                            columns: [
                                {
                                    dataField: 'productionName',
                                    caption: $translate.instant('ProductAndService')
                                },
                            {
                                dataField: 'specification',
                                caption: $translate.instant('Specifications')
                            },
                            {
                                dataField: 'unit',
                                caption: $translate.instant('Unit')
                            },
                             {
                                 dataField: 'quantity',
                                 caption: $translate.instant('Quantity')
                             },
                              {
                                  dataField: 'unitPrice',
                                  caption: $translate.instant('UnitPrice')
                              },
                               {
                                   dataField: 'amount',
                                   caption: $translate.instant('Amount')

                               },
                               {
                                   dataField: 'taxRate',
                                   caption: $translate.instant('TaxRate')
                               },
                               {
                                   dataField: 'taxAmount',
                                   caption: $translate.instant('TaxAmount')
                               },
                               {
                                   dataField: 'remark',
                                   caption: $translate.instant('Remark')
                               }
                            ]
                        }
                    }
                };
            };

            var initDatePicker = function () {
                $('#invoiceDatePicker,#uploadDatepicker').datepicker({
                    language: region
                });
            };

            //搜索框初始化
            var initSearchBoxContorls = function () {

                var valueExpr = "id";
                var displayExpr = "value";

                var isShowClearButton = true;
                
                $scope.searchEntityOptions = {
                    //1. 购买方
                    selectboxBuyerNameOptions: {
                        bindingOptions: {
                            value: 'searchEntity.buyerName',
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //2. 销售方
                    txtSellerNameBoxOptions: {
                        bindingOptions: {
                            value: 'searchEntity.sellerName',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                        //onValueChanged: function (data) {
                        //    $scope.searchEntity.sellerName = data.value;
                        //}
                    },
                    //3. 发票号码
                    txtInvoiceNumberOptions: {
                        bindingOptions: {
                            value: 'searchEntity.invoiceNumber',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                    },
                    //4.发票状态，已经上传，已补录。。
                    selectstatusOptions: {
                     
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.status',
                            dataSource: 'searchFilterOptions.invoiceStatusList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //5.开票日期，目前是boostrap控件
                    //invoiceDateFrom,invoiceDateTo
                    //6.发票来源
                    selectinvoiceSourceTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceSourceType',
                            dataSource: 'searchFilterOptions.invoiceSourceList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //7.发票类型,普票和专票
                    selectInvoiceTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceType',
                            dataSource: 'searchFilterOptions.invoiceTypeList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //8. UploadDate,   upload 日期，目前是boostrap控件, uploadDateFrom,uploadDateTo
                    //9. amount
                    txtAmountOptions: {
                        bindingOptions: {
                            value: 'searchEntity.amount',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //10/发票实体，纸票或者电子票
                    selectInvoiceEntityTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceEntityType',
                            dataSource: 'searchFilterOptions.invoiceEntityList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //11/发票上传方式，pdf,或者扫描
                    selectInvoiceUploadTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceUploadType',
                            dataSource: 'searchFilterOptions.invoiceUploadTypeList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                };
            };

            //初始化控件
            var initControls = function () {
                initDatePicker();
                initSearchBoxContorls();
                InitInvoiceGrid();
            };

            //初始化数据
            var initData = function () {
                $scope.searchFilterOptions = {};
                $scope.hasShowMoreSearchBox =true;
                $scope.searchboxService.showOrHideSearchBox();
                loadInvoiceGridData();
                getService.getInvoiceFilterBasicData();
            };

            (function initialize() {
                $log.debug('invoiceManageMainController.ctor()...');

                initControls();
                initData();

            })();
        }
    ]);
