vatModule.controller('VatAnalysisMenuController', ['$scope', '$rootScope', '$log', '$translate', '$timeout', '$q',
	'SweetAlert', 'vatSessionService',
    function ($scope, $rootScope, $log, $translate, $timeout, $q, SweetAlert, vatSessionService) {
        'use strict';
        $log.debug('VatAnalysisMenuController.ctor()...');

        $scope.menus = [
            { name: '.analyzeReport', text: $translate.instant('ModelAnalysis'), icon: 'glyphicon glyphicon-flag', permission: constant.vatPermission.dataAnalysis.modelAnalysisCode, show: true },
            { name: 'analyzeOrganizeDashboard({id:"' + vatSessionService.project.organizationID + '"})', text: $translate.instant('Dashboard'), icon: 'glyphicon glyphicon-stats', permission: constant.vatPermission.dataAnalysis.dashboard.dashboardCode, show: true },
            { name: '.vatTaxDifference', text: $translate.instant('BookTaxDifference'), icon: 'glyphicon glyphicon-tree-conifer', show: true }
        ];
        vatSessionService.querySummayDashboardModel = {
            organizationID: vatSessionService.project.organizationID,
            year: (new Date()).getFullYear(),
            month: (new Date()).getMonth() === 0 ? 12 : (new Date()).getMonth()
        };

        vatSessionService.dashboardSingelOrganizationId = vatSessionService.project.organizationID;

        var analyzeMenuEvent = function (obj) {
            if (obj.menu.text === $translate.instant('Dashboard')) {
                vatSessionService.urlFromAnalyze = true;
                return true;
            }
        };

        (function initialize() {
            $log.debug('VatAnalysisMenuController.initialize()...');
            $scope.analyzeMenuEvent = analyzeMenuEvent;
        })();
    }
]);

vatModule.directive('vatAnalysisMenu', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatAnalysisMenu.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/analyzeReport/vat-analysis-menu/vat-analysis-menu.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'VatAnalysisMenuController',
            link: function ($scope, $element, $attr) {

            }
        };
    }
]);
vatModule.controller('vatChartAddController', ['$log', '$scope', '$translate', '$sce', 'dashboardService',
    function ($log, $scope, $translate, $sce, dashboardService) {
        'use strict';
        $log.debug('vatChartAddController.ctor()...');
        var queryItem = function () {
            if ($scope.queryStr) {
                $scope.queryResult = _.filter($scope.systemchartDicValue, function (item) {
                    return item.systemChartName.indexOf($scope.queryStr) >= 0
                });
                if ($scope.queryResult.length === 0) {
                    $scope.queryResult.push({ "systemChartName": "NoSearchContent" });
                }
                $scope.showSearch = true;
            } else {
                $scope.showSearch = false;
            }
        };
        var loadSystemChart = function () {
            // dashboardService.getSystemChartList().success(renderTreeMenu);
            $scope.systemchartDic = {
                "增值税指标分析": [
                  {
                      "systemChartID": "9b6a0e47-8979-451e-84dc-0d91c1d25044",
                      "systemChartName": "销项税额与进项税额对比",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是销项税额，进项税额以及两者差异情况。通过对比情况，可以发现销售与采购的不平衡之处， 从而合理分配销售与采购计划。",
                      "imgUrl": "../../../app-resources/images/addchart/output vs input.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "5329c267-391b-4d5d-90d7-50fbdd0ef39a",
                      "systemChartName": "申报收入分类占比",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "通过本图表可以了解申报收入中各个分类的占比情况。",
                      "imgUrl": "../../../app-resources/images/addchart/perclass.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "42c7b2c5-882e-47d7-959e-5e72d2a80990",
                      "systemChartName": "销项税税率占比",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是销项税中各个税率的占比情况。通过占比情况，可以发现是否有税率上错报的异常情况。",
                      "imgUrl": "../../../app-resources/images/addchart/perrate.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "d2692a00-6332-487e-b393-7997588a5d7b",
                      "systemChartName": "申报收入与营业收入对比",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是申报收入与营业收入对比情况。通过差异额，可以发现可能存在的不报、少报销售收入、少纳税款的问题。",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "551e3d3e-5c16-4920-a3f3-b82f4f589c8f",
                      "systemChartName": "实缴税负变动",
                      "categoryName": "增值税指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表反映一般纳税人的增值税实际负担情况。",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  }
                ],
                "财务指标分析": [
                  {
                      "systemChartID": "5b8911a9-657c-4a43-93c6-91eed630d93d",
                      "systemChartName": "主营业务收入变化",
                      "categoryName": "财务指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是主营业务收入情况。根据主营业务收入的波动情况，分析其合理性，查证和判断企业是否存在隐匿主营业务收入的情况。",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "7b26243d-125f-41a3-91a7-c4bcb27540e5",
                      "systemChartName": "其他应收账款变化",
                      "categoryName": "财务指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是期末其他应收账款情况。通过其变动情况，可以查看有无发出的货物未计入申报或虚增的销售长期挂在该科目",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  },
                  {
                      "systemChartID": "4bc2c26d-56ef-468d-b6a5-c689b69064c8",
                      "systemChartName": "应收账款变化",
                      "categoryName": "财务指标分析",
                      "dataSourceName": null,
                      "defaultChartTypeValue": null,
                      "defaultArgumentField": null,
                      "defaultValueField": null,
                      "description": "本图表展示的是期末应收账款情况",
                      "imgUrl": "../../../app-resources/images/addchart/samplepic.JPG",
                      "sortId": 0
                  }
                ]
            };
            $scope.systemchartDicValue = [];
            _.values($scope.systemchartDic).forEach(function (item) {
                $scope.systemchartDicValue = $scope.systemchartDicValue.concat(item);
            });
        };
        var initDefault = function () {
            $scope.selectedChart = {
                chartName: $translate.instant('AddChartDefault'),
                chartDescription: $sce.trustAsHtml(
                    $translate.instant("AddChartDescF") + "<br/>" +
                    $translate.instant("AddChartDescS") + "<br/>") +
                    $translate.instant("AddChartDescT"),
                imgUrl: "../../../app-resources/images/addchart/u6.png",
                systemchartId: '000000',
                showAddButton: false
            };
        };
        var ShowAddChart = function () {
            //initDefault();
            $("#addChart").modal('show');
        };
       
        var showDetail = function (item) {
            //if ($scope.noClick) {
            //    return false;
            //}
            $scope.selectedChart.chartName = item.systemChartName;
            $scope.selectedChart.chartDescription = item.description;
            $scope.selectedChart.imgUrl = item.imgUrl;
            $scope.selectedChart.systemchartId = item.systemChartID;
            $scope.selectedChart.showAddButton = true;
        };
        (function () {
            //----query---------
            $scope.showSearch = false;
            $scope.queryItem = queryItem;
            $scope.queryResult = [];
            $scope.queryStr = '';

            //-----list-------------
            $scope.systemchartDic = {};
            $scope.systemchartDicValue = [];
            $scope.selectedChart = {};
            initDefault();
            loadSystemChart();            

            $scope.ShowAddChart = ShowAddChart;

            //---detail-------------
            $scope.showDetail = showDetail;
            
        })();
    }]);
vatModule.directive('vatChartAdd', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatChartAdd.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/analyzeReport/vat-analysis/vat-chart-add/vat-chart-add.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'vatChartAddController',
            link: function ($scope, $element, $attr) {
                $scope.toggle = function ($event) {                    
                    $($event.target).parent().children('ul.tree').toggle(200);
                };
               
            }
        };
    }
]);
vatModule.factory('dataTransformService', ['$translate', function ($translate) {
    'use strict';

    var prefixField = 'c_';

    _.groupByMulti = function (obj, values, context) {
        if (!values.length)
            return obj;
        var byFirst = _.groupBy(obj, values[0], context),
            rest = values.slice(1);
        for (var prop in byFirst) {
            byFirst[prop] = _.groupByMulti(byFirst[prop], rest, context);
        }
        return byFirst;
    };

    var computeValue = function (oneValue, oneGroup) {
        if (_.isEmpty(oneGroup)) {
            return null;
        }
        switch (oneValue.method) {
            case 'sum':
                var sum = _.reduce(_.pluck(oneGroup, oneValue.field),
                    function (memo, num) { return memo + num; }, 0);
                return _.isNumber(sum) ? sum : null;
            case 'avg':
                var sum = _.reduce(_.pluck(oneGroup, oneValue.field),
                    function (memo, num) { return memo + num; }, 0);
                return _.isNumber(sum) ? sum / oneGroup.length : 0;
            case 'max':
                var max = _.max(oneGroup, function (obj) { return obj[oneValue.field] })[oneValue.field];
                return max ? max : null;
            case 'min':
                var min = _.min(oneGroup, function (obj) { return obj[oneValue.field] })[oneValue.field];
                return min ? min : null;
            case 'count':
                return oneGroup.length;
            default:
                return null;
        }
    };

    //sourceData=[];
    //valueList: compute function
    //argumentFieldList: group by
    var computeGroup = function (sourceData, valueList, argumentFieldList) {
        //first group by argumentFieldList
        //groupData=[key:[],key1:[]]       
        var groupDicData = _.groupByMulti(sourceData, argumentFieldList);
        var newDataArray = [];
        var seriesArray = [];
        var argumentField = argumentFieldList[0];
        //dimension  index      data structure
        // 2          1         newData={'groupkey':value, 'groupkey1':''};seriesArray = [{'name':groupkey1, 'valueField':'groupkey1'}]
        // 1          n         newData={'month:'15/11','v0':number,'v1':number,...};seriesArray=[{name:'sum(xxxx)',valueField:'v0'},{name:'max(xxxx)',valueField:'v1'},...]

        if (argumentFieldList.length === 1) {
            var flag = true;
            _.each(groupDicData, function (groupData, key) {
                var newData = {};
                newData[argumentField] = key;
                for (var i = 0; i < valueList.length; i++) {
                    var oneValue = valueList[i];
                    var secondFieldKey = 'v' + i;                  
                    //fill data to series
                    if (flag) {
                        var fieldDisplayName = prefixField + valueList[i].field;
                        seriesArray.push({
                            valueField: secondFieldKey,
                            name: valueList[i].method + '(' + $translate.instant(fieldDisplayName) + ')'
                        });
                    }
                    newData[secondFieldKey] = computeValue(oneValue, groupData);
                }
                flag = false;
                newDataArray.push(newData);
            });

        } else if (argumentFieldList.length > 1) {
            _.each(groupDicData, function (groupData, key) {

                var newData = {};
                newData[argumentField] = key;
                var arName = _.first(_.keys(groupData));
                var group = groupData[arName];             
                addSeries(seriesArray, arName, arName);
                newData[arName] = computeValue(valueList[0], group);
                newDataArray.push(newData);

            });
        }
        return { dataSource: newDataArray, series: seriesArray, argumentField: argumentField };
    };

    var addSeries = function (seriesArray, sencondFieldName, sencondArgumentFieldValue) {
        var containIt = false;
        for (var i = 0; i < seriesArray.length ; i++) {
            if (seriesArray[i].valueField === sencondFieldName) {
                containIt = true;
                break;
            }
        }

        if (!containIt) {
            seriesArray.push({ valueField: sencondFieldName, name: sencondArgumentFieldValue });
        }
    };


    var getMeasuresValueList = function (valueField) {
        if (valueField.length === 0) {
            return new Array();
        }

        var valueList = new Array();

        var valueStrList = valueField.split(",");

        for (var i = 0 ; i < valueStrList.length; i++) {
            var methodArray = /sum|avg|count|max|min/g.exec(valueStrList[i]);
            var valuefieldArray = /\((.*?)\)/g.exec(valueStrList[i]);
            valueList.push({ method: methodArray[0], field: getPrefixedFieldName(valuefieldArray[1]) });
        }

        return valueList;
    };

    var getDimensionList = function (valueField) {
        if (valueField.length === 0) {
            return new Array();
        }

        var valueList = new Array();

        var valueStrList = valueField.split(",");

        valueStrList.forEach(function (e) {
            valueList.push(getPrefixedFieldName(e));
        });

        return valueList;
    };

    var fixFieldList = function (valueField) {
        var newValueField = new Array();
        for (var i = 0 ; i < valueField.length ; i++) {
            newValueField.push({ method: valueField[i].method, field: getFieldName(valueField[i].field) });
        }
        return newValueField;
    };

    var getFieldName = function (prefixedfiedName) {
        return prefixedfiedName;
        //return prefixedfiedName.length > 2 ? prefixedfiedName.substring(2) : '';
    }

    //lower fist letter
    var getPrefixedFieldName = function (fileName) {
        return fileName.length >= 1 ? fileName.substring(0, 1).toLowerCase() + fileName.substring(1) : '';
    };

    var getDimensionValue = function (argumentList) {
        if (typeof (argumentList) === 'undefined') {
            return '';
        }

        return argumentList.join(',');
    };

    var getMeasuresValue = function (measuresList) {
        if (typeof (measuresList) === 'undefined') {
            return '';
        }

        var valStr = '';

        measuresList.forEach(function (e) {
            valStr = valStr + e.method + '(' + e.field + '),';
        });

        if (valStr.length > 0) {
            valStr = valStr.substring(0, valStr.length - 1);
        }

        return valStr;
    };

    var getDisplayName = function (type, value, projectList) {
        for (var pindex = 0; pindex < projectList.length; pindex++) {
            if (type === 'regionID' && projectList[pindex]['regionId'] === value) {
                return projectList[pindex]['regionName'];
            };

            if (type === 'projectID' && projectList[pindex]['projectId'] === value) {
                return projectList[pindex]['projectName'];
            };
        }
    };

    var formatRegionProject = function (dataList, projectList) {
        for (var index = 0; index < dataList.length; index++) {
            dataList[index].vatType = $translate.instant('vattype_' + dataList[index].vatType);
            dataList[index].rateType = $translate.instant('ratetype_' + dataList[index].rateType);
            dataList[index].regionID = getDisplayName('regionID', dataList[index].regionID, projectList);
            dataList[index].projectID = getDisplayName('projectID', dataList[index].projectID, projectList);

            //month format
            var monthStr = dataList[index].month >= 10 ? dataList[index].month.toString() : '0' + dataList[index].month.toString();
            dataList[index].month = dataList[index].year.toString().substring(2, 4) + '/' + monthStr; //beacause number will be compressed, convert to string
        }
    };

    return {
        getTransformResult: function (dataSource, argumentFieldList, valueField) {
            //var valueList = getValueList(valueField);

            var fixedValueField = fixFieldList(valueField);
            var argumentField = getFieldName(argumentFieldList[0]);
            return computeGroup(dataSource, fixedValueField, argumentFieldList);
        },

        getFieldName: getFieldName,

        getPrefixedFieldName: getPrefixedFieldName,

        getShowName: function (fiedName) {
            return prefixField + fiedName;
        },

        getMeasuresValueList: getMeasuresValueList,

        getDimensionList: getDimensionList,

        getDimensionValue: getDimensionValue,

        getMeasuresValue: getMeasuresValue,

        formatRegionProject: formatRegionProject
    };
}]);
vatModule.controller('vatChartEditController', ['$log', '$scope', '$translate',
 function ($log, $scope, $timeout, $location, dashboardService, dataTransformService, chartRendererService, localStorageService, accountService) {

     'use strict';

     $log.debug('DashboardSettingController.ctor()...');

     $scope.computeMethod = ['sum', 'avg', 'count', 'max', 'min'];

     $scope.addDimension = function (name) {
         $scope.selectedDimension.push(name);

         var removeIndex = $scope.unSelectedDimension.indexOf(name);
         $scope.unSelectedDimension.splice(removeIndex, 1);

         RefreshView();
     };

     $scope.removeDimension = function (name) {
         var removeIndex = $scope.selectedDimension.indexOf(name);
         $scope.selectedDimension.splice(removeIndex, 1);

         $scope.unSelectedDimension.push(name);
         RefreshView();
     };

     $scope.dimensionAddDisabled = false;

     $scope.measuresAddDisabled = false;

     $scope.addMeasures = function (name, method) {
         var item = { field: name, method: method };

         var existItem = _.find($scope.selectedMeasures, item)

         if (existItem) {
             showErrorOperationMessage('measuresExist');
             return false;
         }

         $scope.selectedMeasures.push({ field: name, method: method });

         /*
         var removeIndex = $scope.unSelectedMeasures.indexOf(name);
         $scope.unSelectedMeasures.splice(removeIndex, 1);
         */
         RefreshView();
     };

     $scope.removeMeasures = function (field, method) {
         //$scope.unSelectedMeasures.push(field);

         for (var i = 0; i < $scope.selectedMeasures.length; i++) {
             if ($scope.selectedMeasures[i].field === field && $scope.selectedMeasures[i].method === method) {
                 $scope.selectedMeasures.splice(i, 1);
                 break;
             }
         }
         RefreshView();
     };

     $scope.changeChartType = function (chartType) {
         if (chartType === 'pie' && $scope.pieChartDisable) {
             return;
         }

         $scope.chartType = chartType;
         RefreshView();
     };

     $scope.pieChartDisable = false;

     function RefreshView() {
         $scope.initOperation = null;

         RefreshSetting();

         InitializeData(function () {
             chartRendererService.RefreshChart($scope.dataSourceList, $scope.selectedDimension, $scope.selectedMeasures, $scope.chartType,
             $scope.showValue, 'pieChartContainer', 'barChartContainer', localStorageService.get('dataValue') + '-01');
         }, failMessageCallBack);
     }

     function RefreshSetting() {
         if ($scope.chartType !== 'pie') {
             $scope.dimensionAddDisabled = false;
             $scope.measuresAddDisabled = false;

             //two dimension disable add dimension
             if ($scope.selectedDimension.length === 2) {
                 $scope.dimensionAddDisabled = true;

                 //and one measure disable add measures
                 if ($scope.selectedMeasures.length === 1) {
                     $scope.measuresAddDisabled = true;
                 }
             }

             //two measure above disable add dimension
             if ($scope.selectedMeasures.length > 1 && $scope.selectedDimension.length === 1) {
                 $scope.dimensionAddDisabled = true;
             }

             //enable or disable switch Pie Chart
             var pieChartDisable = $scope.selectedDimension.length > 1 || $scope.selectedMeasures.length > 1;
             $scope.pieChartDisable = pieChartDisable;
         }
         else {
             $scope.dimensionAddDisabled = false;
             $scope.measuresAddDisabled = false;

             if ($scope.selectedDimension.length >= 1) {
                 $scope.dimensionAddDisabled = true;
             }

             if ($scope.selectedMeasures.length >= 1) {
                 $scope.measuresAddDisabled = true;
             }
         }
     }


     var InitializeData = function (sucessCallBack, failCallBack) {
         var projectList = localStorageService.get('projectList');
         var endDate = localStorageService.get('dataValue') + '-01';
         var isMonth = $scope.selectedDimension.indexOf('month') === -1;

         dashboardService.getRangeChartData($scope.dataSourceName, projectList, endDate, isMonth)
             .success(function (dataList) {
                 if (dataList) {
                     dataTransformService.formatRegionProject(dataList, $scope.projectList);

                     $scope.dataSourceList = dataList;

                     if (sucessCallBack) {
                         sucessCallBack();
                     }
                 }
                 else {
                     failCallBack();
                 }
             })
             .error(function () {
                 failCallBack();
             });
     };


     var GetInitSetting = function (chartId, sucessCallback, failCallback) {
         dashboardService.getChartSetting(chartId).success(function (operationResult) {
             if (!operationResult.result && failCallback) {
                 //display error
                 failCallback();
                 return;
             }

             var chartSetting = operationResult.data;

             $scope.dataSourceName = chartSetting.dataSourceName;
             $scope.chartName = chartSetting.name;
             $scope.showValue = chartSetting.showValue;
             $scope.chartType = chartSetting.chartTypeValue;

             //Ignore IsArgumentField Value
             $scope.selectedDimension = dataTransformService.getDimensionList(chartSetting.argumentField);
             $scope.selectedMeasures = dataTransformService.getMeasuresValueList(chartSetting.valueField);

             $scope.unSelectedDimension = new Array();
             $scope.unSelectedMeasures = new Array();

             chartSetting.allValueFieldList.forEach(function (e) {
                 var fieldName = dataTransformService.getPrefixedFieldName(e);

                 if ($scope.selectedDimension.indexOf(fieldName) === -1) {
                     $scope.unSelectedDimension.push(fieldName);
                 }

                 //Measure can be added many times
                 $scope.unSelectedMeasures.push(fieldName);
             });

             if (sucessCallback) {
                 sucessCallback();
             }

         });

     };

     var showErrorOperationMessage = function (errorMessage) {
         $scope.operation = { result: false, message: errorMessage };

         $timeout(function () {
             $scope.operation = null;
         }, 2000);
     };


     $scope.saveSetting = function () {
         if ($scope.chartName.length === 0) {
             showErrorOperationMessage('noChartName');
             return false;
         }

         if ($scope.chartName.length >= 22) {
             showErrorOperationMessage('chartNameTooLong');
             return false;
         }

         var argumentFieldValue = dataTransformService.getDimensionValue($scope.selectedDimension);
         var valueField = dataTransformService.getMeasuresValue($scope.selectedMeasures);

         if (argumentFieldValue.length === 0 || valueField.length === 0) {
             showErrorOperationMessage('dimensionOrMeasuresError');
             return false;
         }

         dashboardService.saveSetting($scope.chartId, $scope.chartName, $scope.chartType, argumentFieldValue, valueField, $scope.showValue).success(function (operationResult) {
             showMessageAndBack(operationResult);
         });
     };

     var failMessageCallBack = function () {
         $scope.initOperation = { result: false, message: 'InitializeFail' };
     };

     var showMessageAndBack = function (operationResult) {
         $scope.operation = operationResult;

         $timeout(function () {
             $scope.operation = null;
             closeCurrentTab();
         }, 1000);
     };

     var closeCurrentTab = function () {
         $scope.$emit('event:closeCurrentTab');
     };

     // initialzation
     (function initialize() {        
         $scope.projectList = [];

         accountService.getProjectList().success(function (data) {
             $scope.projectList = data;
         });

         GetInitSetting($scope.chartId, function () {
             RefreshView();

             $('#showValue').bootstrapSwitch({ 'state': $scope.showValue, 'size': 'small' });

         }, failMessageCallBack);


         $scope.closeCurrentTab = closeCurrentTab;


         //-------------------------------------
         $scope.editSettingModel = {
             chartID:null,
             chartName:null,
             chartType: null,
             argumentFieldValue: null,
             valueField: null,
             showValue:null

         };


     }());
 }]);
vatModule.directive('vatChartEdit', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatChartEdit.ctor()...');
        return {
            restrict: 'E',
            templateUrl: '/app/vat/analyzeReport/vat-analysis/vat-chart-edit/vat-chart-edit.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                chartID:'@'
            },
            controller: 'vatChartEditController',
            link: function ($scope, $element, $attr) {
                $element.find('#showValue').on('switchChange.bootstrapSwitch', function (e, state) {
                    $scope.showValue = state;

                    RefreshView();
                    //$log.debug('ok');
                });

                $element.find('#pieChartClickId').click(function (e) {
                    if ($scope.pieChartDisable) {
                        e.preventDefault();
                        return false;
                    }
                });

            }
        }

}]);


vatModule.controller('VatVatAnalysisController', ['$scope', '$log', 'loginContext', '$translate', '$location',
function ($scope, $log, loginContext, $translate, $location) {
    'use strict';
    $log.debug('VatVatAnalysisController.ctor()...');

}
]);

vatModule.directive('vatVatAnalysis', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatVatAnalysis.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/analyzeReport/vat-analysis/vat-vat-analysis.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'VatVatAnalysisController',
            link: function ($scope, $element, $attr) {

            }
        };
    }
]);

vatModule.controller('VatDataSummaryController', ['$scope', '$log', 'loginContext', '$translate', '$location',
function ($scope, $log, loginContext, $translate, $location) {
    'use strict';
    $log.debug('VatDataSummaryController.ctor()...');
}
]);

vatModule.directive('vatDataSummary', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatDataSummary.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/analyzeReport/vat-data-summary/vat-data-summary.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'VatDataSummaryController',
            link: function ($scope, $element, $attr) {

            }
        };
    }
]);

vatModule.controller('VatFinanceTargetAnalysisController', ['$scope', '$log', 'loginContext', '$translate', '$location',
function ($scope, $log, loginContext, $translate, $location) {
    'use strict';
    $log.debug('VatFinanceTargetAnalysisController.ctor()...');
}
]);

vatModule.directive('vatFinanceTargetAnalysis', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatFinanceTargetAnalysis.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/analyzeReport/vat-finance-target-analysis/vat-finance-target-analysis.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'VatFinanceTargetAnalysisController',
            link: function ($scope, $element, $attr) {

            }
        };
    }
]);
vatModule.controller('VatModelAnalysisController', ['$scope', '$translate', '$uibModal', 'vatSessionService', 'modelConfigurationService', '$compile', '$timeout', '$q', 'vatImportService', 'vatPreviewService', 'SweetAlert', 'enums', 'vatExportService',
    function ($scope, $translate, $uibModal, vatSessionService, modelConfigurationService, $compile, $timeout, $q, vatImportService, vatPreviewService, SweetAlert, enums, vatExportService) {
        'use strict';

        //由 project 决定的在本页面中固定的变量
        $scope.industryId = vatSessionService.project.industryID;
        $scope.organizationId = vatSessionService.project.organizationID;
        $scope.projectId = vatSessionService.project.id;
        $scope.projectYear = vatSessionService.project.year;
        $scope.serviceTypeId = vatSessionService.project.serviceTypeID;

        /************* ViewModels BEGIN *************/
        $scope.logOptions = {
            isShown: false,
            period: vatSessionService.month,
            moduleId: enums.vatModuleEnum.Result_ModelAnalysisResult
        };

        $scope.modelType = 1;
        $scope.periodFrom = 1;
        $scope.periodTo = 12;
        $scope.modelTreeList = [];

        $scope.selectCategoryId = null;

        $scope.resizableOptions = {
            handles: "right",
            Width: 250,
            minWidth: 200,
            maxWidth: 350
        };

        $scope.dirtyDataProcess = {
            hasCheckedFinished: false,
            intervalId: null,
            progressBarValue: 0,
            processBarMax: 100,
            processBarModalInstance: null,
            progressBarOptions: {
                min: 0,
                width: "90%",
                bindingOptions: {
                    value: 'dirtyDataProcess.progressBarValue',
                    max: 'dirtyDataProcess.processBarMax'
                },
                statusFormat: function (value) {
                    return "计算进度: " + (value * 100).toFixed(0) + "%";
                },
                onComplete: function (e) {
                    $scope.dirtyDataProcess.processBarModalInstance.dismiss({$value: 'cancel'});
                    $scope.dirtyDataProcess.processBarModalInstance = null;

                    clearInterval($scope.dirtyDataProcess.intervalId);
                    $scope.dirtyDataProcess.intervalId = null;

                    loadTreeData();
                }
            }
        };
        /************* ViewModels END *************/

        var loadTreeData = function () {
            var apiFunc = modelConfigurationService.getModelCategory;
            apiFunc($scope.organizationId, $scope.industryId, $scope.serviceTypeId).success(function (data) {
                var dic = {};
                for (var ix = 0; ix < data.length; ix++) {
                    var item = data[ix];
                    dic[item.categoryID] = {
                        id: item.modelID,
                        title: item.modelName,
                        isCategory: item.isCategory,
                        questionCount: item.questionCount,
                        totalCount: item.modelTotalCount,
                        categoryId: item.categoryID,
                        parentID: item.parentID,
                        modelType: item.modelType,
                        parentNode: null,
                        sort: item.sort,
                        data: item,
                        feature: item.feature,
                        nodes: [],
                    };
                }

                //查找每个节点是否存在父节点,并维护父节点与本节点的关系
                for (var key in dic) {
                    if (!dic.hasOwnProperty(key))
                        continue;
                    var item = dic[key];
                    var parentId = item.parentID;
                    if (!parentId || !dic.hasOwnProperty(parentId))
                        continue;

                    var p = dic[parentId];
                    if (!p && p === item)
                        continue;

                    item.parentNode = p;
                    p.nodes.push(item);
                }

                var srcData = [];
                for (var key in dic) {
                    if (!dic.hasOwnProperty(key))
                        continue;

                    var item = dic[key];
                    if (!item || item.parentNode)
                        continue;

                    srcData.push(item);
                }
                $scope.modelTreeList = srcData;
            });
        };

        var getModelAnalysisPermission = function () {
            var list = [];
            var modelManageTemp = constant.vatPermission.dataAnalysis.modelAnalysis;
            list.push(modelManageTemp.queryCode);
            list.push(modelManageTemp.filterCode);
            $scope.hasQueryPermission = false;
            $scope.hasFilterIssuePermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasQueryPermission = data[modelManageTemp.queryCode];
                $scope.hasFilterIssuePermission = data[modelManageTemp.filterCode];
            });
        };

        $scope.nodeSelected = function (node) {
            $scope.selectCategoryId = node.categoryId;
            $scope.modelType = node.feature;
        };

        (function () {
            getModelAnalysisPermission();

            //检查是否有脏数据
            modelConfigurationService.projectHasDirtyData($scope.projectId, $scope.serviceTypeId).success(function (result) {
                if (!result) {
                    loadTreeData();
                    return;
                }

                SweetAlert.swal({
                    title: $translate.instant('OrganizationsHasDirtyData'),
                    text: '',
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Confirm'),
                    cancelButtonText: $translate.instant('Cancel'),
                    closeOnConfirm: true
                }, function (isConfirm) {
                    if (!isConfirm) {
                        loadTreeData();
                        return;
                    }

                    $scope.dirtyDataProcess.processBarModalInstance = $uibModal.open({
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        templateUrl: "vat-model-analysis-dirty-data-process-bar.html",
                        backdrop: 'static',
                        scope: $scope,
                        windowClass: "vat-model-analysis-dirty-data-process-bar"
                    });

                    $scope.dirtyDataProcess.intervalId = setInterval(function () {
                        $scope.dirtyDataProcess.progressBarValue++;
                        if (!$scope.dirtyDataProcess.hasCheckedFinished) {
                            $scope.dirtyDataProcess.processBarMax++;
                        }
                    }, 100);

                    //重新计算模型数据
                    modelConfigurationService.updateProjectModelDirtyDataSingleCard($scope.projectId, $scope.serviceTypeId).success(function () {
                        $scope.dirtyDataProcess.hasCheckedFinished = true;
                    });
                });
            });
        })();
    }
]);
vatModule.directive('vatModelAnalysis', ['$translate',
    function ($translate) {
        'use strict';

        return {
            restrict: 'E',
            templateUrl: '/app/vat/analyzeReport/vat-model-analysis/vat-model-analysis.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'VatModelAnalysisController',
            link: function ($scope, $element, $attr) {
                $scope.element = $element;

                // rangePicker 需要手动释放,否则经过多次操作后,页面中会存在多个 rangePicker 的 div
                var rangePicker = null;

                var initializePeriodRangePicker = function () {
                    //初始化期间选择控件
                    var input = $($scope.element).find(".right-container .menu .period-range input");
                    var monthList = [
                        $translate.instant('Month01'),
                        $translate.instant('Month02'),
                        $translate.instant('Month03'),
                        $translate.instant('Month04'),
                        $translate.instant('Month05'),
                        $translate.instant('Month06'),
                        $translate.instant('Month07'),
                        $translate.instant('Month08'),
                        $translate.instant('Month09'),
                        $translate.instant('Month10'),
                        $translate.instant('Month11'),
                        $translate.instant('Month12')
                    ];
                    input = input.rangePicker({
                        minDate: [1, $scope.projectYear],
                        maxDate: [12, $scope.projectYear],
                        setDate: [
                            [1, $scope.projectYear],
                            [12, $scope.projectYear]
                        ],
                        months: monthList,
                        ConfirmBtnText: $translate.instant('Confirm'),
                        CancelBtnText: $translate.instant('ButtonCancel')
                    });
                    input.on('datePicker.done', function (e, result) {
                        $scope.periodFrom = result[0][0];
                        $scope.periodTo = result[1][0];
                    });

                    rangePicker = $(input).data("_ranegPicker");
                };

                (function () {
                    initializePeriodRangePicker();

                    $scope.$on("$destroy", function () {
                        rangePicker.destroy();
                    });
                })();
            }
        };
    }
]);
vatModule.controller('vatTaxDifferenceController', ['$log', '$location','$q', '$scope', '$translate', '$compile', '$uibModal', 'vatPreviewService', 'vatDifferenceService', 'vatSessionService',
    function ($log, $location,$q ,$scope, $translate, $compile, $uibModal, vatPreviewService, vatDifferenceService, vatSessionService) {
        'use strict';
        $log.debug('vatTaxDifferenceController.ctor()...');
        //grid configuration
        $scope.grid = {
            differenceOptions: {
                height:'600px',
                bindingOptions: {
                    dataSource: 'differenceList'
                },
                keyExpr: "id",
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                parentIdExpr: "head_ID",
                expandedRowKeys: [1],
                showBorders: false,
                showColumnLines: false,
                showRowLines:false,
                columnAutoWidth: true,
                autoExpandAll:true,
                columns: [
                    { dataField: 'typeName', caption: $translate.instant('IncomeType') },
                    { dataField: 'description', caption: $translate.instant('Description') },
                    { dataField: 'amount', caption: $translate.instant('Amount'), format: { type: 'fixedPoint', precision: 2 } }
                ],
                selection: {
                    mode: "single"
                },
                onSelectionChanged: function (e) {
                    var row = e.selectedRowsData[0];
                    //row.clickType = 2;
                    if (row.clickType === 1) {                       
                        $location.path('/vat/generateReport/reportView?id=' + row.reportID + '&templateid=' + row.templateID +
                            '&name=本期销售情况明细(附表一)&templatecode=VAT001');
                        $location.url($location.path());
                    }
                    else if (row.clickType === 2) {
                        $scope.queryVoucherDto.listQueryCondition = [];
                        $scope.queryVoucherDto.listQueryCondition.push({ conditionName: "科目代码", searchKeyWord: "1", searchValue: row.typeName });
                        //显示凭证
                        //  getService.getVoucherList(row.name);
                        $scope.curVoucherItemPage = 1;
                        computeVoucherItemPage(false);
                        getService.voucherDataLoad($scope.curVoucherItemPage);
                        getService.showVoucherModal();
                    }
                },
                onRowPrepared: function (info) {
                    if (info.rowType != 'header') {
                        if (info.data.head_ID === "0") {
                            info.rowElement.addClass('top-category');
                        }
                    }

                }
            },
            reasonOptions: {
                height: '600px',
                bindingOptions: {
                    dataSource: 'reasonList'
                },
                keyExpr: "id",
                parentIdExpr: "head_ID",
                expandedRowKeys: [1],
                showBorders: false,
                showColumnLines: false,
                showRowLines: false,
                columnAutoWidth: true,
                autoExpandAll: true,
                columns: [
                    { dataField: 'name', caption: $translate.instant('DifferenceReason') },
                    { dataField: 'desc', caption: $translate.instant('Description') },
                    { dataField: 'amount', caption: $translate.instant('Amount'), format: { type: 'fixedPoint', precision: 2 } }
                ],
                onRowPrepared: function (info) {
                    if (info.rowType != 'header') {
                        if (info.data.head_ID==="0") {
                            info.rowElement.addClass('top-category');
                        }

                        if (info.data.id === 'total') {
                            info.rowElement.addClass('table-summary');
                        }
                    }

                }
              
            }
        };
        $scope.toggleAllMasterRows = function ($event) {
            var expand = "dx-datagrid-group-closed";
            var collapse = "dx-datagrid-group-opened";
            if ($($event.target).hasClass(expand)) {
                $scope.gridInstance.expandAll(-1);
                $($event.target).removeClass(expand);
                $($event.target).addClass(collapse);
            } else {
                $scope.gridInstance.collapseAll(-1);
                $($event.target).removeClass(collapse);
                $($event.target).addClass(expand);
            }
        };
        $scope.openSingularVoucher = function (date, period, group, vid) {
            var modalInstance = $uibModal.open({
                animation: false,
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: "static",
                templateUrl: 'vat-preview-voucher-singular-voucher.html',
                scope: $scope,
                windowClass: "vat-preview-voucher-singular-voucher"
            });

            var singularVoucher = $scope.singularVoucher;
            singularVoucher.date = new Date(date).dateTimeToString("yyyyMMdd");
            singularVoucher.period = period;
            singularVoucher.group = group;
            singularVoucher.groupNum = vid;

            vatPreviewService.getVoucherByConditon($scope.queryVoucherDto.mainRelation, $scope.queryVoucherDto.allJe, period, vid, group, $scope.queryVoucherDto.listQueryCondition).success(function (data) {
                data.data.forEach(function (v) {
                    v.debit = PWC.round(v.debit, 2);
                    v.credit = PWC.round(v.credit, 2);
                });
                singularVoucher.dataList = data.data;
            });

            modalInstance.opened.then(function () {
                singularVoucher.gridColumns = angular.copy(singularVoucher.VOUCHER_COLUMNS);
            });

            singularVoucher.close = function () {
                modalInstance.dismiss('cancel');
            };
        };
        //计算页数，创建分页栏
        var computeVoucherItemPage = function (fristLoad) {

            if (!fristLoad) {
                vatPreviewService.voucherSelectAdvancedCount($scope.queryVoucherDto.mainRelation, $scope.queryVoucherDto.isEntryShow, $scope.queryVoucherDto.allJe, $scope.queryVoucherDto.listQueryCondition).success(function (data) {
                    if (data && !data.result&&data.resultMsg) {
                        SweetAlert.warning($translate.instant(data.resultMsg));
                        return false;
                    }
                    $scope.queryVoucherDto.pagingInfo.totalCount = data.data;

                    if ($scope.queryVoucherDto.pagingInfo && $scope.queryVoucherDto.pagingInfo.totalCount > 0) {

                        var totalPage = parseInt($scope.queryVoucherDto.pagingInfo.totalCount / $scope.queryVoucherDto.pagingInfo.pageSize);
                        totalPage = $scope.queryVoucherDto.pagingInfo.totalCount % $scope.queryVoucherDto.pagingInfo.pageSize == 0 ? totalPage : totalPage + 1;

                        var createPage = $("#totalVoucherPage").createPage({
                            pageCount: totalPage,
                            current: $scope.curVoucherItemPage,
                            backFn: function (p) {
                                //单击回调方法，p是当前页码
                                getService.voucherDataLoad(p);
                            }
                        });

                        $('#totalVoucherPage').css('display', 'inline-block');
                    } else {
                        var createPage = $("#totalVoucherPage").createPage({
                            pageCount: 0,
                            current: $scope.curVoucherItemPage,
                            backFn: function (p) {
                                //单击回调方法，p是当前页码
                                getService.voucherDataLoad(p);
                            }
                        });

                        $('#totalVoucherPage').css('display', 'inline-block');
                    }
                });
            } else {
                var createPage = $("#totalVoucherPage").createPage({
                    pageCount: 0,
                    current: $scope.curVoucherItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        getService.voucherDataLoad(p);
                    }
                });

                $('#totalVoucherPage').css('display', 'inline-block');
            }
            return true;
        };
        $scope.queryVoucherDto = {
            mainRelation: '7',
            allJe: false,
            pagingInfo: {
                "totalCount": 0,
                "pageIndex": 1,
                "pageSize": 100
            },
            listQueryCondition: [],
            isEntryShow:false
        }; 

        var getService = {
            getDifferenceList: function () {
                vatDifferenceService.getTaxDifferenceList(vatSessionService.project.id, vatSessionService.month)
                .success(function (res) {
                    $scope.differenceList = res;
                })
                .error(function () {
                    alert("error");
                });
               
            },
            getReasonList: function () {
                $scope.reasonList = [
                    {
                        "id": "1", "head_ID": "0", "name": "预提未发放的折扣及赠料", "desc": "", "amount": 50639
                    },
                    {
                        "id": "1-1", "head_ID": "1", "name": "当前折扣净发生额", "desc": "", "amount": 50639
                    },
                    {
                        "id": "1-1-1", "head_ID": "1-1", "name": "61858.229840.88", "desc": "系统自动生成已实现折让", "amount": 50639
                    },
                    {
                        "id": "1-2", "head_ID": "1", "name": "当前赠料净发生额", "desc": "", "amount": 0
                    },
                    {
                        "id": "1-2-1", "head_ID": "1-2", "name": "61858.229840.55", "desc": "预提月末赠料", "amount": 0
                    },
                    {
                        "id": "1-3", "head_ID": "1", "name": "当期其他折扣/赠料净发生额", "desc": "", "amount": 0
                    },
                    {
                        "id": "1-3-1", "head_ID": "1-3", "name": "61858.229840.66", "desc": "预提系统自动生成未实现折让", "amount": 0
                    },
                    {
                        "id": "1-3-2", "head_ID": "1-3", "name": "61858.229840.77", "desc": "手工计算未实现折让", "amount": 0
                    },
                    {
                        "id": "1-3-3", "head_ID": "1-3", "name": "61858.229840.99", "desc": "手工计算已实现折让", "amount": 0
                    },
                    {
                        "id": "2", "head_ID": "0", "name": "延期付款利息（赊销）", "desc": "", "amount": -5999
                    },
                    {
                        "id": "2-1", "head_ID": "2", "name": "会计当月确认的延期付款利息", "desc": "", "amount": -5999
                    },
                    {
                        "id": "2-1-1", "head_ID": "2-1", "name": "61858.121201.03", "desc": "", "amount": -5999
                    },
                    {
                        "id": "3", "head_ID": "0", "name": "资产处置收入", "desc": "", "amount": -3
                    },
                    {
                        "id": "3-1", "head_ID": "3", "name": "固定资产处置收入", "desc": "", "amount": -3.39
                    },
                    {
                        "id": "3-1-1", "head_ID": "3-1", "name": "858013.793101.100", "desc": "固定资产清理收入", "amount": -3
                    },
                    {
                        "id": "3-1-2", "head_ID": "3-1", "name": "858013.486901.08", "desc": "固定资产清理收入-先按无收入处置再变卖", "amount": 0
                    },
                     {
                         "id": "4", "head_ID": "0", "name": "委贷利息", "desc": "", "amount": 5388
                     },
                    {
                        "id": "4-1", "head_ID": "4", "name": "会计当月确认的委贷利息", "desc": "", "amount": 23185
                    },
                    {
                        "id": "4-1-1", "head_ID": "4-1", "name": "858013.472902.01", "desc": "资金池收入", "amount": 24576
                    },
                    {
                        "id": "4-1-2", "head_ID": "4-1", "name": "剔除增值税", "desc": "", "amount": -1391
                    },
                     {
                         "id": "4-2", "head_ID": "4", "name": "本月税控系统开具发票的委贷利息收入", "desc": "", "amount": 28574
                     },
                    {
                        "id": "4-2-1", "head_ID": "4-2", "name": "6%税率（金融服务）", "desc": "", "amount": 28574
                    },
                    {
                        "id": "5", "head_ID": "0", "name": "其他（手工修改）", "desc": "", "amount": 0
                    },
                    {
                        "id": "5-1", "head_ID": "5", "name": "XXXXX", "desc": "", "amount": 0
                    },
                    {
                        "id": "total", "head_ID": "0", "name": "核对会计差异总计", "desc": "", "amount": 50025
                    },
                    {
                        "id": "not-recognize-total", "head_ID": "0", "name": "未识别税会差异", "desc": "", "amount": 0
                    }
                ];
            },
            voucherDataLoad: function ( pageIndex) {
                $scope.queryVoucherDto.pagingInfo.pageIndex = pageIndex;                
                vatDifferenceService.taxDifferenceByVoucher($scope.queryVoucherDto).success(function (listData) {
                    //listData.data.debitSum = PWC.round(listData.data.debitSum, 2);
                    //listData.data.creditSum = PWC.round(listData.data.creditSum, 2);
                    listData.data.voucherMainList.forEach(function (v) {
                        v.debitSum = PWC.round(v.debitSum, 2);
                        v.creditSum = PWC.round(v.creditSum, 2);
                    });
                    $scope.voucherDataList = listData.data.voucherMainList;
                    //var dataGrid = $('#gridContainer').dxDataGrid('instance');
                    //dataGrid.refresh();
                   // initDataGrid();
                    //vatPreviewService.getSelectWhereString($scope.queryVoucherDto.mainRelation, $scope.queryVoucherDto.allJe, $scope.queryVoucherDto.listQueryCondition).success(function (queryString) {
                    //    showVoucherCount(listData.data.itemIDCount, listData.data.vidCount, listData.data.debitSum, listData.data.creditSum, queryString);
                    //});
                    
                });
                computeVoucherItemPage(false);
            },
            showVoucherModal: function () {
                var modalInstance = $uibModal.open({
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'voucher.html',
                    scope: $scope,
                    backdrop: 'static',
                    windowClass: 'difference-modal'
                });

                $scope.cancel = function () {
                    modalInstance.dismiss('cancel');
                };

                //paintVoucherGrid();
            },
            getVoucherDataFromDatabase : function (mainRelation, allJe, period, vID, group, queryCondition) {
                var deferred = $q.defer();
                vatPreviewService.getVoucherByConditon(mainRelation, allJe, period, vID, group, queryCondition).success(function (dataList) {
                    deferred.resolve(dataList);

                }).error(function () {
                    deferred.reject();
                });
                return deferred.promise;
            }
        };
        var initData = function () {
            getService.getDifferenceList();
            getService.getReasonList();
        };
        $scope.datagridOptions = {
            height:'300px',
            bindingOptions: {
                dataSource: 'voucherDataList',
            },
            scrolling: {
                mode: "virtual"
            },
            sorting: {
                mode: "none"
            },
            selection: {
                mode: "single"
            },
            width:'98%',
            columnAutoWidth: true,
            showBorders: true,
            allowColumnResizing: true,
            showRowLines: true,
            showColumnLines: true,
            noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
            columns: [
                {
                    dataField: "period",
                    caption: $translate.instant('AccountVoucher_DataGrid_ColPeriod'),
                    sortIndex: 0,
                    sortOrder: 'asc'
                    
                },
                {
                    alignment: "center",
                    dataField: "date",
                    dataType: "date",
                    caption: $translate.instant('AccountVoucher_DataGrid_ColDate'),
                    format: "yyyy-MM-dd",
                    sortIndex: 1,
                    sortOrder: 'asc'
                  
                },
                {
                    dataField: "group",
                    caption: $translate.instant('AccountVoucher_DataGrid_ColGroup'),
                    sortIndex: 2,
                    sortOrder: 'asc'                   
                },
                {
                    dataField: "vid",
                    caption: $translate.instant('AccountVoucher_DataGrid_ColVID'),
                    sortIndex: 3,
                    sortOrder: 'asc'                    
                },
                {
                    dataField: "debitSum",
                    caption: $translate.instant('AccountVoucher_DataGrid_ColDebitSum'),
                    alignment: "right"
                },
                {
                    dataField: "creditSum",
                    caption: $translate.instant('AccountVoucher_DataGrid_ColCreditSum'),
                    alignment: "right"
                }
            ],
            //onRowClick: function (e) {
            //    var component = e.component;
            //    var prevClickTime = component.lastClickTime;
            //    component.lastClickTime = new Date();
            //    if (prevClickTime && (component.lastClickTime - prevClickTime < 300)) {
            //        //Double click code                         
            //        $scope.openSingularVoucher(e.data.date, e.data.period, e.data.group, e.data.vid);
            //    }
            //},
            masterDetail: {
                enabled: true,
                template: function (container, options) {
                    var currentVoucherData = options.data;
                    $scope.queryVoucherDto.period = currentVoucherData.period;
                    $scope.queryVoucherDto.vID = currentVoucherData.vid;
                    $scope.queryVoucherDto.group = currentVoucherData.group;
                    container.addClass("internal-grid-container");
                    $("<div>")
                        .addClass("internal-grid")
                        .dxDataGrid({
                            columnAutoWidth: true,
                            loadPanel: {
                                enabled: false
                            },
                            showBorders: true,
                            sorting: {
                                mode: "none"
                            },
                            selection: {
                                mode: "single"
                            },
                            columns: [
                                {
                                    dataField: "summary",
                                    caption: $translate.instant('AccountVoucher_DataGrid_ColSummary')
                                   
                                },
                                //{
                                //    dataField: "customerCodeAndNameShow",
                                //    caption: $translate.instant('AccountVoucher_DataGrid_ColCustomerCodeAndNameShow') ,
                                //    //width: 170
                                //},
                                {
                                    dataField: "acctCodeAndNameShow",
                                    caption: $translate.instant('AccountVoucher_DataGrid_ColAcctCodeAndNameShow'),
                                    sortIndex: 1,
                                    sortOrder: 'asc'
                                },
                                {
                                    dataField: "stdCodeAndNameShow",
                                    caption: $translate.instant('AccountVoucher_DataGrid_ColStdCodeAndNameShow'),
                                    sortIndex: 0,
                                    sortOrder: 'asc'
                                },
                                {
                                    dataField: "debit",
                                    caption: $translate.instant('AccountVoucher_DataGrid_ColDebit'),
                                    alignment: "right"
                                },
                                {
                                    dataField: "credit",
                                    caption: $translate.instant('AccountVoucher_DataGrid_ColCredit'),
                                    alignment: "right"
                                }
                            ],
                            dataSource: {
                                store: new DevExpress.data.CustomStore({
                                    load: function (loadOptions) {
                                        return getService.getVoucherDataFromDatabase('7', false, currentVoucherData.period, currentVoucherData.vid, currentVoucherData.group, $scope.queryVoucherDto.listQueryCondition).then(function (data) {
                                            data.data.forEach(function (v) {
                                                v.debit = PWC.round(v.debit, 2);
                                                v.credit = PWC.round(v.credit, 2);
                                            });
                                            return {
                                                data: data.data,
                                                totalCount: data.data.length
                                            };
                                        }, function () {
                                            return $q.reject($translate.instant("DataLoadingError"));
                                        });
                                    }
                                })
                            }
                        }).appendTo(container);
                }
            },
            onCellPrepared: function (e) {
                if (e.rowType === "header" && $(e.cellElement).hasClass("dx-command-expand")) {
                    var btn = $("<div class='dx-datagrid-group-closed'></div>");
                    btn.attr("ng-click", "toggleAllMasterRows($event)");
                    e.cellElement.empty();
                    e.cellElement.append($compile(btn)($scope));
                }
            },
            onContentReady: function () {
                $log.debug("onContentReady voucher");
            },
            onInitialized: function (e) {
                $scope.gridInstance = e.component;
            }
        };
        (function () {
            initData();
            
        })();
    }
]);
vatModule.directive('vatTaxDifference', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatTaxDifference.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/analyzeReport/vat-tax-difference/vat-tax-difference.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'vatTaxDifferenceController',
            link: function ($scope, $element, $attr) {

            }
        };
    }
]);
vatModule.service('cardValidationService', ['$log','$translate',
    function ($log, $translate) {
    var checkCard = function (card) {
        var result = {
            pass: true,
            message: ''
        };
            //是否为空  
            if (card==undefined||card==null||card=="") {
                result.message = $translate.instant('BuyerCodePlaceholder');
                result.pass = false;
                return result;
            }
            //校验长度，类型  
            if (!isCardNo(card)) {
                result.message = $translate.instant('LengthNotEqual')+" 18 or "+$translate.instant("CarIDTypeError");
                result.pass = false;
                return result;
            }
            //检查省份  
            if (!checkProvince(card)) {
                result.message = $translate.instant('CardCountryValidationError');
                result.pass = false;
                return result;
            }
            //校验生日  
            if (!checkBirthday(card)) {
                result.message = $translate.instant('CardDateValidationError');
                result.pass = false;
                return result;
            }
            //检验位的检测  
            if (!checkParity(card)) {
                result.message = $translate.instant('CardCheckCodeValidationError');
                result.pass = false;
                return result;
            }
           
            return result;
        };


        //检查号码是否符合规范，包括长度，类型  
       var isCardNo = function (card) {
            //身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X  
           // var reg = /(^\d{15}$)|(^\d{17}(\d|X)$)/;
           var reg = /(^\d{17}(\d|X)$)/;
            if (reg.test(card) === false) {
                return false;
            }

            return true;
        };

        //取身份证前两位,校验省份  
       var checkProvince = function (card) {
            var province = card.substr(0, 2);
            if (constant.vcity[province] == undefined) {
                return false;
            }
            return true;
        };

        //检查生日是否正确  
       var checkBirthday = function (card) {
            var len = card.length;
            //身份证15位时，次序为省（3位）市（3位）年（2位）月（2位）日（2位）校验位（3位），皆为数字  
            if (len == '15') {
                var re_fifteen = /^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/;
                var arr_data = card.match(re_fifteen);
                var year = arr_data[2];
                var month = arr_data[3];
                var day = arr_data[4];
                var birthday = new Date('19' + year + '/' + month + '/' + day);
                return verifyBirthday('19' + year, month, day, birthday);
            }
            //身份证18位时，次序为省（3位）市（3位）年（4位）月（2位）日（2位）校验位（4位），校验位末尾可能为X  
            if (len == '18') {
                var re_eighteen = /^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/;
                var arr_data = card.match(re_eighteen);
                var year = arr_data[2];
                var month = arr_data[3];
                var day = arr_data[4];
                var birthday = new Date(year + '/' + month + '/' + day);
                return verifyBirthday(year, month, day, birthday);
            }
            return false;
        };

        //校验日期  
       var verifyBirthday = function (year, month, day, birthday) {
            var now = new Date();
            var now_year = now.getFullYear();
            //年月日是否合理  
            if (birthday.getFullYear() == year && (birthday.getMonth() + 1) == month && birthday.getDate() == day) {
                //判断年份的范围（3岁到100岁之间)  
                var time = now_year - year;
                if (time >= 3 && time <= 100) {
                    return true;
                }
                return false;
            }
            return false;
        };

        //校验位的检测  
       var checkParity = function (card) {
            //15位转18位  
            card = changeFivteenToEighteen(card);
            var len = card.length;
            if (len == '18') {
                var arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
                var arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
                var cardTemp = 0, i, valnum;
                for (i = 0; i < 17; i++) {
                    cardTemp += card.substr(i, 1) * arrInt[i];
                }
                valnum = arrCh[cardTemp % 11];
                if (valnum == card.substr(17, 1)) {
                    return true;
                }
                return false;
            }
            return false;
        };

        //15位转18位身份证号  
       var changeFivteenToEighteen = function (card) {
            if (card.length == '15') {
                var arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
                var arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
                var cardTemp = 0, i;
                card = card.substr(0, 6) + '19' + card.substr(6, card.length - 6);
                for (i = 0; i < 17; i++) {
                    cardTemp += card.substr(i, 1) * arrInt[i];
                }
                card += arrCh[cardTemp % 11];
                return card;
            }
            return card;
        };
        return {
            CardCheck: checkCard
        }
    }]);
vatModule.service('keyValueDataService', ['enums',
function (enums) {
    return {
        parseValue: function (keyValueData, targetType) {
            // parseValue(50, enums.cellDataType.Accounting)
            // or parseValue({ value: 50, type: enums.cellDataType.Accounting })

            var type, value;
            if (targetType !== undefined) {
                type = targetType;
                value = keyValueData;
            }
            else {
                type = keyValueData.resultType;
                value = keyValueData.value;
            }

            if (!_.isString(value) || _.isEmpty(value)) {
                return value;
            }

            if (!type || type === enums.cellDataType.Accounting || type === enums.cellDataType.Percentage) {
                return parseFloat(value);
            }
            else if (type === enums.cellDataType.Boolean) {
                return value.toLowerCase() === 'true';
            }
            else if (type === enums.cellDataType.String) {
                return value;
            }
            else if (type === enums.cellDataType.Integer) {
                return parseInt(value);
            }
            return value;
        }
    };
}]);
vatModule.directive('onFinishRender', ['$timeout', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit(attr.onFinishRender);
                }, 500);
            }
        }
    }
}]);
vatDashboardModule.controller('OrganizationDashboardController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval',
    'apiInterceptor', 'SweetAlert', 'dashboardConfigSummaryService', '$stateParams', 'vatSessionService', 'modelConfigurationService',
    'canvasUtil','vatDashboardService',
    function ($scope, $log, $translate, $timeout, $q, $interval, apiInterceptor, SweetAlert, dashboardConfigSummaryService, $stateParams,
        vatSessionService, modelConfigurationService, canvasUtil, vatDashboardService) {
        'use strict';

        var thisData = {
            organizationId: '',
            year: vatSessionService.year,
            period: vatSessionService.month
        };

        var thisConstant = {
            dashSignSeparator: '-',
            rowCountPerPage: 9,
            orgColumn: 'v1',
            prefixField: 'v',
            tableBeginXml: '<w:tbl><w:tblPr><w:tblW w:w="5000" w:type="pct"/><w:tblLook w:val="04A0" w:firstRow="1" w:lastRow="0" w:firstColumn="1" w:lastColumn="0" w:noHBand="0" w:noVBand="1"/></w:tblPr><w:tblGrid>',
            tableEndXml: '</w:tbl>',
            tableColDefXml: '<w:gridCol w:w="2000"/>',
            tableColBeginXml: '</w:tblGrid><w:tr>',
            headerFirstCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:bottom w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            headerCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:bottom w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:jc w:val="right"/><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            headerCellEndXml: '</w:t></w:r></w:p></w:tc>',
            firstCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:top w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/><w:bottom w:val="single" w:sz="2" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            cellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:top w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/><w:bottom w:val="single" w:sz="2" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:jc w:val="right"/><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:color w:val="ED7D31" w:themeColor="accent2"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            rowBeginXml: '<w:tr>',
            rowEndXml: '</w:tr>',
            chartPrefix: 'chart-'
        };

        var thisDateService = {

            // 转换为页面展示数据
            parseShowData: function (data) {
                if (data && data.length > 0) {
                    data.forEach(function (row) {
                        var values = _.values(row.header);
                        var keys = _.keys(row.header);
                        var length = keys ? keys.length : 0;
                        row.keys = keys;
                        row.headerObj = JSON.parse(row.headerObj);
                        var headerKey = _.keys(row.header);
                        var headerArr = _.pairs(row.header);
                        var monthIdx = '';
                        var headerValue = _.map(headerArr, function (x) {
                            if (x[1] === '月份') {
                                monthIdx = x[0];
                                x[1] = $translate.instant('MonthDimension');
                            }
                            return x[1];
                        });

                        row.header = _.object(headerKey, headerValue);

                        if (!_.isEmpty(monthIdx)) {
                            _.each(row.data, function (x) {
                                x[monthIdx] = $translate.instant('Month' + x[monthIdx]);
                            });
                        }
                    });
                }

                return data;
            },

            // 查询汇总数据
            querySummaryProcess: function () {

                dashboardConfigSummaryService.queryOrganizationData(thisData.organizationId,thisData.year,thisData.period).success(function (data) {
                    // 进行数据转换    
                    //data[0].isShowChart = false;
                    $scope.querySummaryResult = thisDateService.parseShowData(data);
                    data.forEach(function (m) {
                        if (!_.isNull(m.modelTips)) {
                            m.modelTips.forEach(function (r) {
                                thisDateService.setRiskTipStyle(r);
                            });
                        }                        
                    });

                    $timeout(function () {
                        thisDateService.drawTableList($scope.querySummaryResult);
                    }, 200);

                    // console.log(JSON.stringify($scope.querySummaryResult));
                });
            },

            drawTableList: function (data) {
                if (data && data.length > 0) {
                    data.forEach(function (row) {
                        thisDateService.drawTable(row);
                    });
                }
            },

            drawTable: function (node) {

                if (_.isEmpty(node.data)) {
                    node.isEmpty = true;
                }
                else {
                    node.isEmpty = false;
                var vatGallery = thisDateService.createGalleryData(node);

                var itemTemplate = function (item, index) {
                    var columns = thisDateService.createColumns(node);

                    return $('<div class="gallery-table"/>').dxDataGrid({
                        dataSource: item.dataValue,
                        width: '390px',
                        showRowLines: true,
                        showColumnLines: false,
                        noDataText: '',
                        showBorders: false,
                        cellHintEnabled: true,
                        format: { type: 'fixedPoint', precision: 2 },
                        columns: columns
                    });

                };
                var galleryWidget = $("#" + node.id).dxGallery({
                    dataSource: vatGallery,
                    // height: 260,
                    width: "458px",
                    loop: false,
                    showIndicator: true,
                    showNavButtons: true,
                    itemTemplate: itemTemplate,

                }).dxGallery("instance");
                }
            },
            // 构造GalleryData
            createGalleryData: function (node) {

                var index = Math.ceil(node.data.length / thisConstant.rowCountPerPage);
                // var x = node.data.length % thisConstant.rowCountPerPage;
                // if (x !== 0) {
                //     index = index + 1;
                // }

                var result = [];
                for (var i = 0; i < index; i++) {
                    var item = {};
                    item.id = i;
                    item.dataValue = [];
                    var start = i * thisConstant.rowCountPerPage;
                    for (var j = start; j < start + thisConstant.rowCountPerPage; j++) {
                        var rowData = angular.copy(node.data[j]);
                        if (!rowData) {
                            continue;
                        }

                        for (var k = 1; k < node.headerObj.length; k++) {
                            var dataModel = node.headerObj[k];
                            var field = thisConstant.prefixField + (k + 1);
                            if (dataModel.dataType === 1) {
                                rowData[field] = Number(rowData[field]).formatAmount();

                            } else if (dataModel.dataType === 3) {
                                rowData[field] = rowData[field] == 1 ? '是' : '否';
                            } else {
                                var percentData = Number(rowData[field]) * 100;
                                rowData[field] = Number(percentData).formatAmount() + '%';
                            }
                        }

                        item.dataValue.push(rowData);
                    }

                    result.push(item);
                }

                return result;
            },

            // 构造列表
            createColumns: function (node) {
                var result = [];
                node.keys.forEach(function (key) {
                    var item = {};
                    item.dataField = key,
                        item.caption = node.header[key];
                    item.alignment = 'center';
                    if (key !== thisConstant.orgColumn) {
                        item.format = { type: 'fixedPoint' };
                        item.cssClass = 'orange-color';
                        item.alignment = 'right';
                    }

                    result.push(item);
                });

                return result;
            },


            setRiskTipStyle: function (risk) {
                if (risk.hasRisk) {
                    return { color: '#b4122a' }
                }               
            },
         
            toggleChart: function ($event,node) {
                var target = $event.target;
                node.isShowChart = !node.isShowChart;
            }
        };

        $scope.hasCheckedDirtyData = false;
        $scope.progressBarValue = 0;
        $scope.processBarModalInstance = null;
        $scope.intervalId = null;
        $scope.hasCheckedDirtyDataSuccess = false;


        function timer() {
            $scope.$apply(function () {
                $scope.progressBarValue++;
                if (!$scope.hasCheckedDirtyDataSuccess) {
                    $scope.processBarMax++;
                }
            });
        }

        $scope.processBarMax = 100;
        $scope.hasCheckedFinished = false;
        $scope.progressBarOptions = {
            min: 0,
            width: "95%",
            bindingOptions: {
                value: 'progressBarValue',
                max: 'processBarMax'
            },
            statusFormat: function (value) {
                return "计算进度: " + (value * 100).toFixed(0) + "%";
            },
            onComplete: function (e) {
                //重新计算模型数据结束后加载图表。
                thisDateService.querySummaryProcess();
            }
        };

        //删除图表
        $scope.deleteChartConfig = function (id) {
            SweetAlert.swal({
                title: $translate.instant('ConfirmDelete'),
                text: $translate.instant('deleteChart') + "?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Confirm'),
                cancelButtonText: $translate.instant('Cancel'),
                closeOnConfirm: true
            }, function (isConfirm) {
                if (isConfirm) {
                    vatDashboardService.deleteConfigById(id).success(function () {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                        thisDateService.querySummaryProcess();
                    });
                }
            });
        };

        var mainModule = {

            // 初始化参数
            initParams: function () {
                thisData.organizationId = $stateParams.id;
                vatSessionService.dashboardSingelOrganizationId = $stateParams.id;
                var queryMonth = vatSessionService.lastDashboardSummaryQueryMonth;
                if (!_.isEmpty(queryMonth) && queryMonth.indexOf('-') >= 0) {
                    var dateStrs = queryMonth.split('-');
                    thisData.year = Number(dateStrs[0]);
                    thisData.period = Number(dateStrs[1]);
                }
            },

            // 入口函数
            main: function () {
                mainModule.initParams();
                if ($scope.hasCheckedDirtyData) {
                    thisDateService.querySummaryProcess();
                } else {
                    modelConfigurationService.organizationsHasDirtyData(thisData.organizationId, vatSessionService.querySummayDashboardModel.year, 2).success(function (result) {
                        if (result) {
                            SweetAlert.swal({
                                title: $translate.instant('OrganizationsHasDirtyData'),
                                text: '',
                                type: "warning",
                                showCancelButton: true,
                                confirmButtonColor: "#DD6B55",
                                confirmButtonText: $translate.instant('Confirm'),
                                cancelButtonText: $translate.instant('Cancel'),
                                closeOnConfirm: true
                            }, function (isConfirm) {
                                if (isConfirm) {

                                    var parentElem = angular.element($('#organizationDirtyProcessBarContainer'));
                                    $scope.processBarModalInstance = $uibModal.open({
                                        ariaLabelledBy: 'modal-title',
                                        ariaDescribedBy: 'modal-body',
                                        templateUrl: 'dirtyDataProcessBar.html',
                                        windowClass: 'data-table',
                                        appendTo: parentElem,
                                        backdrop: 'static',
                                        scope: $scope
                                    });

                                    $scope.intervalId = setInterval(timer, 50);

                                    //重新计算模型数据
                                    modelConfigurationService.updateOrganizationsModelDirtyData(thisData.organizationId, vatSessionService.querySummayDashboardModel.year, 2).success(function () {
                                        $scope.hasCheckedDirtyDataSuccess = true;
                                    });
                                } else {
                                    thisDateService.querySummaryProcess();
                                }
                            });
                        } else {
                            thisDateService.querySummaryProcess();
                        }
                    });
                    $scope.hasCheckedDirtyData = true;
                }
            },

            loadFile: function (url, callback) {
                JSZipUtils.getBinaryContent(url, callback);
            },

            generateDoc: function (doc) {
                var tableContent = thisConstant.tableBeginXml;
                var colNum = doc.keys.length;
                var rowNum = doc.data.length;
                for (var i = 0; i < colNum; i++) {
                    tableContent += thisConstant.tableColDefXml;
                }

                tableContent += thisConstant.tableColBeginXml;

                for (var i = 0; i < colNum; i++) {
                    tableContent = tableContent
                        + (i === 0 ? thisConstant.headerFirstCellBeginXml : thisConstant.headerCellBeginXml)
                        + doc.header[doc.keys[i]] + thisConstant.headerCellEndXml;
                }

                tableContent += thisConstant.rowEndXml;

                for (var j = 0; j < rowNum; j++) {
                    tableContent += thisConstant.rowBeginXml;

                    for (var i = 0; i < colNum; i++) {
                        var dataModel = doc.headerObj[i];
                        var data = doc.data[j][doc.keys[i]];
                        if (i > 0) {
                            if (dataModel.dataType === 1) {
                                data = Number(data).formatAmount();

                            } else if (dataModel.dataType === 3) {
                                data = data == 1 ? '是' : '否';
                            }
                            else {
                                var percentData = Number(data) * 100;
                                data = Number(percentData).formatAmount() + '%';
                            }
                        }

                        if (i === 0) {
                            tableContent = tableContent + thisConstant.firstCellBeginXml
                                + data + thisConstant.headerCellEndXml;
                        }
                        else {
                            tableContent = tableContent + thisConstant.cellBeginXml
                                + data + thisConstant.headerCellEndXml;
                        }
                    }

                    tableContent += thisConstant.rowEndXml;
                }

                tableContent += thisConstant.tableEndXml;

                return {
                    chartName: doc.name,
                    chartContent: thisConstant.chartPrefix + doc.id,
                    riskTip: _.isArray(doc.modelTips) ? doc.modelTips : [],
                    tableContent: tableContent
                };
            },

            generateDocImages: function () {
                var opts = {
                    centered: true,
                    getImage: function (tagValue, tagName) {
                        return canvasUtil.toBinaryData(document.getElementById(tagValue));
                    },
                    getSize: function (img, tagValue, tagName) {
                        return [550, 250];
                    }
                }

                var imageModule = new ImageModule(opts);
                return imageModule;
            },

            exportChart: function (chart) {
                var exportModel = mainModule.generateDoc(chart);

                var exportDocName = chart.name + '.docx';
                var templateName = '/ExportTemplate/DashboardExportTemplate.docx';

                mainModule.loadFile(templateName + '?_=' + Math.random(), function (err, content) {
                    if (err) { throw e };
                    var zip = new JSZip2(content);
                    var imageModule = mainModule.generateDocImages();
                    var doc = new docxtemplater().attachModule(imageModule).loadZip(zip);
                    doc.setData(exportModel);
                    try {
                        doc.render();
                    }
                    catch (err) {
                        $log.info(err);
                        swal({
                            title: '导出发生一个错误，请重试',
                            confirmButtonColor: "#dc6000",
                            confirmButtonText: "确定",
                            closeOnConfirm: true,
                            type: "error"
                        });
                        return;
                    }

                    var out = doc.getZip().generate({
                        type: "blob",
                        mimeType: "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
                    });
                    saveAs(out, exportDocName);
                })
            }
        };

        //重新计算模型完成时执行
        $scope.$watch('progressBarValue', function (newValue) {
            if (newValue == $scope.processBarMax) {
                $scope.processBarModalInstance.dismiss({ $value: 'cancel' });
                clearInterval($scope.intervalId);
            }
        });

        //开始
        (function initialize() {
            $log.debug('OrganizationDashboardController.ctor()...');

            if (vatSessionService.urlFromAnalyze) {
                $scope.urlFromAnalyze = 'analyzeOrganizeDashboardConfig';
            } else {
                $scope.urlFromAnalyze = 'reportAnalysisDashboardConfig';
            }

            $scope.exportChart = mainModule.exportChart;
            $scope.setRiskTipStyle = thisDateService.setRiskTipStyle;
            $scope.setRowblockStyle = thisDateService.setRowblockStyle;
            $scope.toggleChart = thisDateService.toggleChart;
            mainModule.main();        
        })();
    }
]);
vatDashboardModule.directive('organizationDashboard', ['$log',
    function ($log) {
        'use strict';
        $log.debug('organizationDashboard.ctor()...');
        console.log('organizationDashboard');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/dashboard/vat-organization-dashboard/vat-organization-dashboard.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'OrganizationDashboardController',
            link: function (scope, element) {

            }
        };

    }
]);
vatDashboardModule.controller('ReportAnalysisDashboardConfigController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval',
    'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', 'vatSessionService', 'enums', 'vatOperationLogService',
    'projectService', 'vatCommonService', 'vatDashboardService', '$stateParams', '$state', 'indexAnalysisDetailService',
function ($scope, $log, $translate, $timeout, $q, $interval, apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants,
    vatSessionService, enums, vatOperationLogService, projectService, vatCommonService, vatDashboardService, $stateParams, $state,
    indexAnalysisDetailService) {
    'use strict';

    $scope.config = {
        id: '',
        chartName: '',
        modelItems: [],
        analysisItems: [],
        isShowData: 0,
        isShowGrid:0
    };

    //取当前的dashboard机构。
    $scope.selectedOrgId = vatSessionService.dashboardSingelOrganizationId;

    $scope.chartRenderOption = {
        id: '',
        name: $scope.config.chartName,
        isShowData: $scope.config.isShowData,
        header: { v1: $translate.instant('OrgName') },
        headerObj: [{ name: $translate.instant('OrgName'), dataType: 1, chartType: 'line' }],
        data: []
    };

    //图表名称text box option
    $scope.chartNameOption = {
        width: 280,
        placeholder: $translate.instant('PleaseInputChartName'),
    }

    var year = (new Date()).getFullYear();
    var yearList = [{ id: year, name: year }, { id: year - 1, name: year - 1 }, { id: year - 2, name: year - 2 }, { id: year - 3, name: year - 3 }];

    //年份筛选select box option
    $scope.yearTreeView = null;
    var initalYearTree = function () {
        if ($scope.yearTreeView) {
            $scope.fromSyncSelection = true;
            if (!$scope.selectedYears || $scope.selectedYears.length === 0) {
                $scope.yearTreeView.unselectAll();
            }
            _.each($scope.selectedYears, function (year) {
                $scope.yearTreeView.selectItem(year);
            });

            _.each(yearList, function (year) {
                if (!_.contains($scope.selectedYears, year.id) && !_.contains($scope.selectedYears, year.id + '')) {
                    $scope.yearTreeView.unselectItem(year.id);
                }
            });
            $scope.fromSyncSelection = false;
        }
    };

    $scope.selectedYears = [year];
    $scope.yearFilterOptions = {
        bindingOptions: {
            value: 'selectedYears'
        },
        valueExpr: "id",
        displayExpr: "name",
        placeholder: "",
        showClearButton: false,
        dataSource: yearList,
        treeView: {
            dataSource: yearList,
            dataStructure: "plain",
            keyExpr: "id",
            displayExpr: "name",
            selectByClick: true,
            selectNodesRecursive: false,
            showCheckBoxesMode: "normal",
            selectionMode: "multiple",
            onContentReady: function (e) {
                $scope.yearTreeView = e.component;
                initalYearTree();
            },
            onItemSelectionChanged: function (args) {
                if (!$scope.fromSyncSelection) {
                    var value = args.component.getSelectedNodesKeys();
                    $scope.selectedYears = value;
                }

            }
        }
    };

    //分析维度select box option
    $scope.selectedDimensionType = 1;
    $scope.dimensionOptions = {
        width: 280,
        bindingOptions: {
            value: 'selectedDimensionType'
        },
        noDataText: '',
        placeholder: $translate.instant('PleaseSelect'),
        items: [{ id: 1, name: $translate.instant('c_month') }, { id: 2, name: $translate.instant('ProjectYearCol') }],
        valueExpr: 'id',
        displayExpr: 'name',
        onItemClick: function (e) {
            if (e) {
                if ($scope.config.analysisItems.length > 1 && $scope.selectedYears.length > 1 && e.itemData.id == 1) {
                    SweetAlert.warning($translate.instant('DimensionalityCheckInfo'));
                    e.component.option('value', 2);
                    e.component.option('text', $translate.instant('ProjectYearCol'));
                    return;
                }
            }
        }
    };

    //获取指定机构的二级分析指标数据信息
    $scope.organizationSubModelDataList = [];
    var getOrganizationSubModelList = function (orgId) {
        vatDashboardService.getOrganizationSubModelList(orgId).success(function (result) {
            if (result && result.data && result.data.length > 0) {
                $scope.organizationSubModelDataList = result.data;
            }
        });
    };

    //添加分析指标下拉树控件
    $scope.selectIdList = [];
    var syncTreeViewSelection = function () {
        if ($scope.treeView) {
            $scope.fromSyncSelection = true;
            if (!$scope.selectIdList || $scope.selectIdList.length === 0) {
                $scope.treeView.unselectAll();
                $scope.fromSyncSelection = false;
                return;
            }

            $scope.selectIdList.forEach(function (key) {
                $scope.treeView.selectItem(key);
            });

            _.each($scope.indexList, function (item) {
                if (!_.contains($scope.selectIdList, item.id) && item.parentId) {
                    $scope.treeView.unselectItem(item.id);
                }
            });

            $scope.fromSyncSelection = false;
        }
    };

    $scope.indexList = [];
    $scope.treeView = null;

    $scope.multiSelectAnalysisOptionHeight = 300;
    $scope.multiSelectAnalysisOption = {
        placeholder: $translate.instant('PleaseSelectTarget'),
        width: 280,
        valueExpr: "name",
        displayExpr: "name",
        showClearButton: true,
        bindingOptions: {
            value: 'selectNameList',
            dataSource: 'indexList',
        },
        onValueChanged: function (args) {
            if (!args.value) {
                $scope.selectIdList = [];
            }
        },
        treeView: {
            bindingOptions: {
                dataSource: 'indexList',
                searchValue: 'searchText',
                height: 'multiSelectAnalysisOptionHeight'
            },
            dataStructure: "plain",
            keyExpr: "id",
            parentIdExpr: "parentId",
            selectionMode: "multiple",
            displayExpr: "name",
            selectByClick: true,
            selectNodesRecursive: true,
            showCheckBoxesMode: "normal",
            onContentReady: function (e) {
                $scope.treeView = e.component;
            },
            onItemSelectionChanged: function (args) {
                if (!$scope.fromSyncSelection) {
                    var value = args.component.getSelectedNodesKeys();
                    if (value.length > 1 && $scope.selectedYears.length > 1 && $scope.dimension == 1) {
                        SweetAlert.warning($translate.instant('MultiYearCheckInfo'));
                        syncTreeViewSelection();
                        return;
                    }
                    $scope.selectIdList = value;
                    $scope.selectNameList = _.filter($scope.indexList, function (nameItem) {
                        return _.contains($scope.selectIdList, nameItem.id) && nameItem.parentId;
                    });
                    $scope.riskDataSource = [];
                    _.each($scope.selectNameList, function (nameItem) {
                        var parentNode = _.where($scope.indexList, { id: nameItem.parentId })[0];
                        if (_.where($scope.riskDataSource, { id: parentNode.id }).length < 1) {
                            if (_.contains($scope.selectRiskIdList, parentNode.id)) {
                                $scope.riskDataSource.push({ id: parentNode.id, name: parentNode.name, selected: true });
                            } else {
                                $scope.riskDataSource.push({ id: parentNode.id, name: parentNode.name, selected: false });
                            }
                        }
                    });

                    $scope.selectNameList = _.map($scope.selectNameList, function (item) {
                        return item.name;
                    });
                }
            }
        }
    };

    $scope.riskDataSource = [];
    $scope.selectRiskNameList = [];
    $scope.selectRiskIdList = [];
    //风险提示Options
    $scope.riskTipMultiSelectAnalysisOption = {
        width: 280,
        valueExpr: "id",
        displayExpr: "name",
        showClearButton: true,
        contentTemplate: 'riskContent',
        bindingOptions: {
            dataSource: 'riskDataSource',
            value: 'selectRiskIdList'
            
        },
        onValueChanged: function (args) {
            if (!args.value) {
                $scope.selectRiskIdList = [];
            }
        },
        treeView: {
            bindingOptions: {
                dataSource: 'riskDataSource'
            },
            height: 300,
            dataStructure: "plain",
            keyExpr: "id",
            selectionMode: "multiple",
            displayExpr: "name",
            selectByClick: true,
            selectNodesRecursive: true,
            showCheckBoxesMode: "normal",
            onContentReady: function (e) {
                var riskTree = $('#riskTipTree').dxTreeView('instance');
                _.each($scope.riskDataSource, function (nameItem) {
                    if (_.contains($scope.selectRiskIdList, nameItem.id)) {
                        riskTree.selectItem(nameItem.id);
                    } else {
                        riskTree.unselectItem(nameItem.id);
                    }
                    return nameItem;
                });
            },
            onItemSelectionChanged: function (args) {
                var value = args.component.getSelectedNodesKeys();
                $scope.selectRiskIdList = value;
                $scope.selectRiskNameList = _.filter($scope.riskDataSource, function (nameItem) {
                    return _.contains($scope.selectRiskIdList, nameItem.id);
                });
                $scope.selectRiskNameList = _.map($scope.selectRiskNameList, function (item) {
                    return item.name;
                });
            }
        }
    };

    $scope.$watch('selectRiskIdList', function () {
        var riskTree = $('#riskTipTree').dxTreeView('instance');
        if (riskTree) {
            _.each($scope.riskDataSource, function (nameItem) {
                if (_.contains($scope.selectRiskIdList, nameItem.id)) {
                    riskTree.selectItem(nameItem.id);
                } else {
                    riskTree.unselectItem(nameItem.id);
                }
                return nameItem;
            });
        }

    });

    //删除分析指标
    var removeAnalysisItem = function (item) {
        $scope.config.analysisItems = _.filter($scope.config.analysisItems, function (analysisItem) {
            return analysisItem.id != item.id;
        });
        $scope.selectIdList = _.filter($scope.selectIdList, function (indexItem) {
            return indexItem != item.id;
        });
    };

    var checkConfigValible = function () {
        //多年月份多指标未不合法配置。
        if ($scope.selectedYears.length > 1 && $scope.dimension === 1 && $scope.config.analysisItems.length > 1) {
            return false;
        }
        return true;
    }

    //保存指标配置
    var saveDashboardConfig = function () {
        if (!checkConfigValible()) {
            SweetAlert.warning($translate.instant('CheckOrganizationDashboardConfig'));
            return;
        }
        if ($scope.config.analysisItems.length < 1) {
            SweetAlert.warning($translate.instant('DeleteMeasureAlert'));
            return;
        }
        if (!$scope.config.chartName) {
            SweetAlert.warning($translate.instant('checkChartName'));
            return;
        }
        if ($scope.selectedYears.length < 1) {
            SweetAlert.warning($translate.instant('checkChartYears'));
            return;
        }
        var userSetting = '';
        var indexIds = '';
        var indexIdArr = [];
        var userSettingArr = [{ name: 'OrgName', dataType: 1, chartType: 'line' }];

        _.each($scope.config.analysisItems, function (item) {
            userSettingArr.push({ name: item.analysisName, dataType: item.dataType, chartType: item.chartType });
            indexIdArr.push(item.id);
        });
        userSetting = JSON.stringify(userSettingArr);
        indexIds = indexIdArr.join(',');

        var data = {};
        data.ID = $scope.config.id;
        data.Name = $scope.config.chartName;
        data.IndexIDs = indexIds;
        data.UserSetting = userSetting;
        data.IsShowData = $scope.config.isShowData;
        data.OrderIndex = 4;
        data.riskTip = $scope.selectRiskIdList.join(',');
        data.isShowGrid = $scope.config.isShowGrid;

        data.Years = $scope.selectedYears.join(',');
        data.DimensionType = $scope.dimension; //1月份，2年份

        vatDashboardService.saveOrganizationConfig(data).success(function () {
            if (vatSessionService.urlFromAnalyze) {
                $state.go('analyzeOrganizeDashboard', { id: vatSessionService.dashboardSingelOrganizationId });
            } else {
                $state.go('organizationDashboard', { id: vatSessionService.dashboardSingelOrganizationId });
            }
        });
    };

    //取消保存
    var cancelConfig = function () {
        if (vatSessionService.urlFromAnalyze) {
            $state.go('analyzeOrganizeDashboard', { id: vatSessionService.dashboardSingelOrganizationId });
        } else {
            $state.go('organizationDashboard', { id: vatSessionService.dashboardSingelOrganizationId });
        }
    };

    //删除图表
    //var deleteChartConfig = function () {
    //    SweetAlert.swal({
    //        title: $translate.instant('ConfirmDelete'),
    //        text: $translate.instant('deleteChart') + "?",
    //        type: "warning",
    //        showCancelButton: true,
    //        confirmButtonColor: "#DD6B55",
    //        confirmButtonText: $translate.instant('Confirm'),
    //        cancelButtonText: $translate.instant('Cancel'),
    //        closeOnConfirm: true
    //    }, function (isConfirm) {
    //        if (isConfirm) {
    //            vatDashboardService.deleteConfigById($scope.config.id).success(function () {
    //                SweetAlert.success($translate.instant('DeleteSuccess'));
    //                if (vatSessionService.urlFromAnalyze) {
    //                    $state.go('analyzeOrganizeDashboard', { id: vatSessionService.dashboardSingelOrganizationId });
    //                } else {
    //                    $state.go('organizationDashboard', { id: vatSessionService.dashboardSingelOrganizationId });
    //                }
    //            });
    //        }
    //    });
    //};

    $scope.chartChanged = true;
    var setAnalysisItems = function () {

        $scope.config.analysisItems = _.filter($scope.config.analysisItems, function (item) {
            return _.contains($scope.selectIdList, item.id);
        });

        _.each($scope.selectIdList, function (selectIndexItem) {
            _.each($scope.organizationSubModelDataList, function (organizItem) {
                if (selectIndexItem === organizItem.id && _.where($scope.config.analysisItems, { id: selectIndexItem }).length === 0) {
                    //添加分析指标
                    var obj = new Object();
                    obj.id = organizItem.id;
                    obj.analysisName = organizItem.name;
                    obj.dataType = organizItem.dataType;
                    obj.chartType = 'bar';
                    obj.chartOptions = {
                        items: [
                            { typeName: $translate.instant("barchart"), typeValue: 'bar' },
                            { typeName: $translate.instant("linechart"), typeValue: 'line' },
                            { typeName: $translate.instant("areachart"), typeValue: 'area' },
                            { typeName: $translate.instant("stepchart"), typeValue: 'step' }
                        ],
                        displayExpr: 'typeName',
                        valueExpr: 'typeValue',
                        itemTemplate: 'chartTypeItemTemplate',
                        value: 'bar',
                        onItemClick: function (e) {
                            obj.chartType = e.itemData.typeValue;
                            $scope.chartChanged = !$scope.chartChanged;
                        }
                    };

                    if (!_.isEmpty($scope.indexList)) {
                        var indexItemObj = _.find($scope.indexList, function (indexItem) {
                            return indexItem.id == selectIndexItem;
                        });

                        if (!_.isEmpty(indexItemObj)) {
                            obj.index = indexItemObj.orderIndex;
                        }
                    }

                    $scope.config.analysisItems.push(obj);
                }
            })
        });

        //对分析指标排序，使分析指标顺序与指标列表中一致。
        $scope.config.analysisItems = _.sortBy($scope.config.analysisItems, 'index');
    };

    //设置分析指标下拉框的显示值
    $scope.$watchGroup(['selectIdList', 'indexList', 'treeView'], function (newItems, oldItems) {
        if (newItems[1].length > 0) {
            $scope.selectNameList = _.filter($scope.indexList, function (nameItem) {
                return _.contains($scope.selectIdList, nameItem.id) && nameItem.parentId;
            });
            $scope.riskDataSource = [];
            _.each($scope.selectNameList, function (nameItem) {
                var parentNode = _.where($scope.indexList, { id: nameItem.parentId })[0];
                if (_.where($scope.riskDataSource, { id: parentNode.id }).length < 1) {
                    if (_.contains($scope.selectRiskIdList, parentNode.id)) {
                        $scope.riskDataSource.push({ id: parentNode.id, name: parentNode.name, selected: true });
                    } else {
                        $scope.riskDataSource.push({ id: parentNode.id, name: parentNode.name, selected: false });
                    }
                }
            });

            $scope.selectNameList = _.map($scope.selectNameList, function (item) {
                return item.name;
            });
        }
        syncTreeViewSelection();

    });

    //分析指标根据选中的指标变化
    $scope.$watchGroup(['selectIdList', 'organizationSubModelDataList', 'indexList'], function () {
        setAnalysisItems();
    });

    $scope.$watch('selectedYears', function (newValue, oldValue) {
        if ($scope.config.analysisItems.length > 1 && $scope.dimension == 1 && $scope.selectedYears.length > 1) {
            SweetAlert.warning($translate.instant('MultilTargetCheckInfo'));
            $scope.selectedYears = oldValue;
            initalYearTree();
            return;
        }
    });

    //显示图标提示信息
    var showChartTipInfo = function () {
        $timeout(function () {
            if ($scope.chartRenderOption.isNoChart) {
                $('.row-block-left').children('div:eq(0)').children('div:eq(0)').css({ 'top': '45%', 'width': '400px', 'height': 'auto', 'left': '42%', 'font-size': '25px', 'color': '#777' }).html($translate.instant('PleaseAddMeasuresRight'));
            }
        }, 1000);
    };

    //分析指标配置变动联动图表
    $scope.$watchGroup(['config.analysisItems', 'config.isShowData', 'dimension', 'selectedYears', 'chartChanged', 'organizationSubModelDataList'], function (newItems, oldItems) {
        if (newItems[0].length > 0 && newItems[2] > 0 && newItems[3].length > 0 && newItems[5].length > 0) {
            ////数据合法性检查
            //if (newItems[0].length != oldItems[0].length) {
            //    if ($scope.selectedYears.length > 1 && $scope.dimension == 1 && newItems[0] > 1) {
            //        SweetAlert.warning($translate.instant('当前已选择多个年份，只允许选择1个指标'));
            //        config.analysisItems = oldItems[0];
            //        return;
            //    }
            //} else if (newItems[3].length != oldItems[3].length) {
            //    if ($scope.config.analysisItems.length > 1 && $scope.dimension == 1 && newItems[3].length > 1) {
            //        SweetAlert.warning($translate.instant('当前已选择多个指标，只允许选择1个年份'));
            //        $scope.selectedYears = oldItems[3];
            //        return;
            //    }
            //} else if (newItems[2] != oldItems[2]) {
            //    if ($scope.config.analysisItems.length > 1 && $scope.selectedYears.length > 1 && newItems[2] == 1) {
            //        SweetAlert.warning($translate.instant('当前已选择多个指标、多个年份，只允许选择年份维度'));
            //        $scope.dimension = oldItems[2];
            //        return;
            //    }
            //}

            var obj = new Object();
            obj.id = $scope.config.id;
            obj.name = $scope.config.chartName;
            obj.isShowData = $scope.config.isShowData;
            obj.header = {};
            obj.data = [];

            if ($scope.selectedYears.length > 1) {//多年
                if ($scope.dimension === 1 && $scope.config.analysisItems.length === 1) {//月份|单指标
                    var analysisItem = $scope.config.analysisItems[0];
                    obj.header["v1"] = $translate.instant('c_month');
                    obj.headerObj = [{ name: $translate.instant('c_month'), dataType: analysisItem.dataType, chartType: analysisItem.chartType }];

                    _.each($scope.selectedYears, function (item, index) {
                        obj.header["v" + (index + 2)] = item + '年';
                        obj.headerObj.push({ name: item + '年', dataType: analysisItem.dataType, chartType: analysisItem.chartType });
                    });

                    for (var i = 1; i < 13; i++) {
                        var mounthModelObj = { v0: '', v1: i };
                        if ($scope.config.analysisItems.length > 0 && $scope.organizationSubModelDataList.length > 0) {
                            _.each($scope.selectedYears, function (year, index) {
                                var flag = true;
                                _.each($scope.organizationSubModelDataList, function (itemData) {
                                    if (itemData.year == year && $scope.config.analysisItems[0].id === itemData.id && i === itemData.period) {
                                        mounthModelObj['v' + (index + 2)] = itemData.data;
                                        flag = false;
                                    }
                                });
                                if (flag) {
                                    mounthModelObj['v' + (index + 2)] = 0;
                                }
                            });
                        }
                        obj.data.push(mounthModelObj);
                    }
                } else if ($scope.dimension === 2) {//年份|多指标
                    obj.header["v1"] = $translate.instant('ProjectYearCol');
                    obj.headerObj = [{ name: $translate.instant('ProjectYearCol'), dataType: 1, chartType: 'line' }];

                    _.each($scope.config.analysisItems, function (value, index) {
                        obj.header['v' + (index + 2)] = value.analysisName;
                        obj.headerObj.push({ name: value.analysisName, dataType: value.dataType, chartType: value.chartType });
                    });

                    _.each($scope.selectedYears, function (year) {
                        var yearModelObj = { v0: '', v1: year + '年' };
                        if ($scope.config.analysisItems.length > 0 && $scope.organizationSubModelDataList.length > 0) {
                            _.each($scope.config.analysisItems, function (value, index) {
                                var total = 0;
                                _.each($scope.organizationSubModelDataList, function (itemData) {
                                    if (itemData.year == year && itemData.period == 13 && value.id === itemData.id && !isNaN(itemData.data)) {
                                        total += parseFloat(itemData.data);
                                    }
                                });
                                yearModelObj['v' + (index + 2)] = total;
                            });
                        }
                        obj.data.push(yearModelObj);
                    });
                }
            } else {//单年
                if ($scope.dimension === 1) {//月份|多指标
                    obj.header["v1"] = $translate.instant('c_month');
                    obj.headerObj = [{ name: $translate.instant('c_month'), dataType: 1, chartType: 'line' }];

                    _.each($scope.config.analysisItems, function (value, index) {
                        obj.header['v' + (index + 2)] = value.analysisName;
                        obj.headerObj.push({ name: value.analysisName, dataType: value.dataType, chartType: value.chartType });
                    });

                    for (var i = 1; i < 13; i++) {
                        var mounthModelObj = { v0: '', v1: i };
                        if ($scope.config.analysisItems.length > 0 && $scope.organizationSubModelDataList.length > 0) {
                            _.each($scope.config.analysisItems, function (value, index) {
                                var flag = true;
                                _.each($scope.organizationSubModelDataList, function (itemData) {
                                    if (itemData.year == $scope.selectedYears[0] && value.id === itemData.id && i === itemData.period) {
                                        mounthModelObj['v' + (index + 2)] = itemData.data;
                                        flag = false;
                                    }
                                });
                                if (flag) {
                                    mounthModelObj['v' + (index + 2)] = 0;
                                }
                            });
                        }
                        obj.data.push(mounthModelObj);
                    }

                } else {//年份|多指标
                    obj.header["v1"] = $translate.instant('ProjectYearCol');
                    obj.headerObj = [{ name: $translate.instant('ProjectYearCol'), dataType: 1, chartType: 'line' }];

                    _.each($scope.config.analysisItems, function (value, index) {
                        obj.header['v' + (index + 2)] = value.analysisName;
                        obj.headerObj.push({ name: value.analysisName, dataType: value.dataType, chartType: value.chartType });
                    });

                    _.each($scope.selectedYears, function (year) {
                        var yearModelObj = { v0: '', v1: year + '年' };
                        if ($scope.config.analysisItems.length > 0 && $scope.organizationSubModelDataList.length > 0) {
                            _.each($scope.config.analysisItems, function (value, index) {
                                var total = 0;
                                _.each($scope.organizationSubModelDataList, function (itemData) {
                                    if (itemData.year == year && itemData.period == 13 && value.id === itemData.id && !isNaN(itemData.data)) {
                                        total += parseFloat(itemData.data);
                                    }
                                });
                                yearModelObj['v' + (index + 2)] = total;
                            });
                        }
                        obj.data.push(yearModelObj);
                    });
                }
            }
            if (obj.data && obj.data.length > 0) {
            obj.isNoChart = false;
            $scope.chartRenderOption = obj;
        } else {
                obj.isNoChart = true;
                showChartTipInfo();
            }
        } else {
            $scope.chartRenderOption = { isNoChart: true };
            showChartTipInfo();
        }

    });

    (function initialize() {
        //获取机构的所有指标信息
        indexAnalysisDetailService.getIndexAnalysisDropDownList().success(function (data) {
            var dataOrder = 0;
            data = _.map(data, function (item) {
                item.orderIndex = dataOrder;
                dataOrder++;
                return item;
            });
            $scope.indexList = data;

            $scope.multiSelectAnalysisOptionHeight = 300;
            if ($scope.indexList && $scope.indexList.length <= 15) {
                $scope.multiSelectAnalysisOptionHeight = 20 * $scope.indexList.length;
            }
        });

        getOrganizationSubModelList($scope.selectedOrgId);

        $scope.removeAnalysisItem = removeAnalysisItem;
        $scope.saveDashboardConfig = saveDashboardConfig;
        $scope.cancelConfig = cancelConfig;
        //$scope.deleteChartConfig = deleteChartConfig;

        if ($stateParams.id) {
            $scope.config.id = $stateParams.id;
            //获取指标汇总配置
            vatDashboardService.getOrganizationConfig($scope.config.id).success(function (result) {
                if (result && result.data) {
                    var selectedAnalysisItems = JSON.parse(result.data.userSetting);
                    selectedAnalysisItems.splice(0, 1);
                    var ids = result.data.indexIDs.split(',');
                    $scope.selectedIndexIds = result.data.indexIDs;
                    _.each(ids, function (id, index) {
                        //添加分析指标
                        var obj = new Object();
                        obj.id = id;
                        obj.analysisName = selectedAnalysisItems[index].name;
                        obj.dataType = selectedAnalysisItems[index].dataType;
                        obj.chartType = selectedAnalysisItems[index].chartType;
                        obj.chartOptions = {
                            items: [
                                { typeName: $translate.instant("barchart"), typeValue: 'bar' },
                                { typeName: $translate.instant("linechart"), typeValue: 'line' },
                                { typeName: $translate.instant("areachart"), typeValue: 'area' },
                                { typeName: $translate.instant("stepchart"), typeValue: 'step' }
                            ],
                            displayExpr: 'typeName',
                            valueExpr: 'typeValue',
                            itemTemplate: 'chartTypeItemTemplate',
                            value: obj.chartType,
                            onItemClick: function (e) {
                                obj.chartType = e.itemData.typeValue;
                                $scope.chartChanged = {};
                            }
                        };
                        $scope.config.analysisItems.push(obj);
                    });

                    if (result.data.indexIDs && ids.length > 0) {
                        $scope.selectIdList = ids;
                    }

                    var riskTipIds = result.data.riskTip ? result.data.riskTip.split(',') : null;
                    if (riskTipIds && riskTipIds.length > 0) {
                        $scope.selectRiskIdList = riskTipIds;
                    }

                    $scope.config.chartName = result.data.name;
                    $scope.config.isShowData = result.data.isShowData;
                    $scope.config.isShowGrid = result.data.isShowGrid ? result.data.isShowGrid : 0;

                    $scope.selectedDimensionType = result.data.dimensionType;
                    $scope.selectedYears = result.data.years.split(',');
                    $timeout(function () {
                        $('#year-filter').dxDropDownBox('instance').field().val($scope.selectedYears.join(', '));
                    });
                }
            });
        }
    })();
}
]);
vatDashboardModule.directive('reportAnalysisDashboardConfig', ['$log',
    function ($log) {
        'use strict';

        return {
            restrict: 'E',
            templateUrl: '/app/vat/dashboard/vat-report-analysis-dashboard-config/vat-report-analysis-dashboard-config.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'ReportAnalysisDashboardConfigController',
            link: function (scope, element) {

            }
        };

    }
]);
vatDashboardModule.controller('SummaryDashboardConfigController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval',
    'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', 'vatSessionService', 'enums', 'vatOperationLogService',
    'projectService', 'vatCommonService', 'vatDashboardService', 'indexAnalysisDetailService', '$stateParams', '$state',
function ($scope, $log, $translate, $timeout, $q, $interval, apiInterceptor, Upload, vatImportService, SweetAlert, uiGridConstants,
    vatSessionService, enums, vatOperationLogService, projectService, vatCommonService, vatDashboardService, indexAnalysisDetailService,
    $stateParams, $state) {
    'use strict';

    $scope.config = {
        id: '',
        chartName: '',
        modelItems: [],
        analysisItems: [],
        isShowData: 0,
        isShowGrid: 0
    };

    if (!_.isEmpty(vatSessionService.querySummayDashboardModel)) {
        if (!_.isEmpty(vatSessionService.querySummayDashboardModel.organizationIDList)) {
            $scope.selectedOrganizes = vatSessionService.querySummayDashboardModel.organizationIDList;
            $scope.selectedOrgIds = vatSessionService.querySummayDashboardModel.organizationIDList.join(',');
        }
        else {
            $scope.selectedOrganizes = [];
            $scope.selectedOrgIds = '';
        }

        $scope.filterYear = vatSessionService.querySummayDashboardModel.year;
        $scope.filterPeriod = vatSessionService.querySummayDashboardModel.period;
    }
    else {
        $scope.selectedOrganizes = [];
        $scope.selectedOrgIds = '';
        $scope.filterYear = 0;
        $scope.filterPeriod = 0;
    }

    $scope.chartRenderOption = {
        id: '',
        name: '',
        isShowData: $scope.config.isShowData,
        header: { v1: $translate.instant('OrgName') },
        headerObj: [{ name: $translate.instant('OrgName'), dataType: 1, chartType: 'line' }],
        data: []
    };

    //图表名称text box option
    $scope.chartNameOption = {
        width: 280,
        placeholder: $translate.instant('PleaseInputChartName'),
        bindingOptions: {
            value: 'config.chartName'
        }
    }

    //获取指定指标的二级分析指标
    $scope.subModelDataList = [];
    var getSubModelList = function () {
        vatDashboardService.getSubModelList($scope.filterYear, $scope.filterPeriod).success(function (result) {
            if (result && result.data && result.data.length > 0) {
                $scope.subModelDataList = result.data;
            }
        });
    };

    //添加分析指标下拉树控件
    $scope.selectIdList = [];
    var syncTreeViewSelection = function () {
        if ($scope.treeView) {
            $scope.fromSyncSelection = true;
            if (!$scope.selectIdList || $scope.selectIdList.length === 0) {
                $scope.treeView.unselectAll();
                $scope.fromSyncSelection = false;
                return;
            }

            $scope.selectIdList.forEach(function (key) {
                $scope.treeView.selectItem(key);
            });

            _.each($scope.indexList, function (item) {
                if (!_.contains($scope.selectIdList, item.id) && item.parentId) {
                    $scope.treeView.unselectItem(item.id);
                }
            });

            $scope.fromSyncSelection = false;
        }
    };

    $scope.indexList = [];
    $scope.treeView = null;

    $scope.multiSelectAnalysisOptionHeight = 300;
    $scope.multiSelectAnalysisOption = {
        width: 280,
        valueExpr: "name",
        displayExpr: "name",
        showClearButton: true,
        bindingOptions: {
            value: 'selectNameList',
            dataSource: 'indexList'
        },
        onValueChanged: function (args) {
            if (!args.value) {
                $scope.selectIdList = [];
            }
        },
        treeView: {
            bindingOptions: {
                dataSource: 'indexList',
                searchValue: 'searchText',
                height: 'multiSelectAnalysisOptionHeight'
            },
            dataStructure: "plain",
            keyExpr: "id",
            parentIdExpr: "parentId",
            selectionMode: "multiple",
            displayExpr: "name",
            selectByClick: true,
            selectNodesRecursive: true,
            showCheckBoxesMode: "normal",
            onContentReady: function (e) {
                $scope.treeView = e.component;
            },
            onItemSelectionChanged: function (args) {
                if (!$scope.fromSyncSelection) {
                    var value = args.component.getSelectedNodesKeys();
                    $scope.selectIdList = value;
                    $scope.selectNameList = _.filter($scope.indexList, function (nameItem) {
                        return _.contains($scope.selectIdList, nameItem.id) && nameItem.parentId;
                    });

                    $scope.riskDataSource = [];
                    _.each($scope.selectNameList, function (nameItem) {
                        var parentNode = _.where($scope.indexList, { id: nameItem.parentId })[0];
                        if (_.where($scope.riskDataSource, { id: parentNode.id }).length < 1) {
                            if (_.contains($scope.selectRiskIdList, parentNode.id)) {
                                $scope.riskDataSource.push({ id: parentNode.id, name: parentNode.name, selected: true });
                            } else {
                                $scope.riskDataSource.push({ id: parentNode.id, name: parentNode.name, selected: false });
                            }
                        }
                    });

                    $scope.selectRiskIdList = _.filter($scope.selectRiskIdList, function (riskId) {
                        return _.where($scope.riskDataSource, { id: riskId }).length > 0;
                    });

                    $scope.selectNameList = _.map($scope.selectNameList, function (item) {
                        return item.name;
                    });
                }
            }
        }
    };


    $scope.riskDataSource = [];
    $scope.selectRiskNameList = [];
    $scope.selectRiskIdList = [];
    //风险提示Options
    $scope.riskTipMultiSelectAnalysisOption = {
        width: 280,
        valueExpr: "id",
        displayExpr: "name",
        showClearButton: true,
        contentTemplate: 'riskContent',
        bindingOptions: {
            dataSource: 'riskDataSource',
            value: 'selectRiskIdList'

        },
        onValueChanged: function (args) {
            if (!args.value) {
                $scope.selectRiskIdList = [];
            }
        },
        treeView: {
            bindingOptions: {
                dataSource: 'riskDataSource'
            },
            height: 300,
            dataStructure: "plain",
            keyExpr: "id",
            selectionMode: "multiple",
            displayExpr: "name",
            selectByClick: true,
            selectNodesRecursive: true,
            showCheckBoxesMode: "normal",
            onContentReady: function (e) {
                var riskTree = $('#riskTipTree').dxTreeView('instance');
                _.each($scope.riskDataSource, function (nameItem) {
                    if (_.contains($scope.selectRiskIdList, nameItem.id)) {
                        riskTree.selectItem(nameItem.id);
                    } else {
                        riskTree.unselectItem(nameItem.id);
                    }
                    return nameItem;
                });
            },
            onItemSelectionChanged: function (args) {
                var value = args.component.getSelectedNodesKeys();
                $scope.selectRiskIdList = value;
                $scope.selectRiskNameList = _.filter($scope.riskDataSource, function (nameItem) {
                    return _.contains($scope.selectRiskIdList, nameItem.id);
                });
                $scope.selectRiskNameList = _.map($scope.selectRiskNameList, function (item) {
                    return item.name;
                });
            }
        }
    };

    $scope.$watch('selectRiskIdList', function () {
        var riskTree = $('#riskTipTree').dxTreeView('instance');
        if (riskTree) {
            _.each($scope.riskDataSource, function (nameItem) {
                if (_.contains($scope.selectRiskIdList, nameItem.id)) {
                    riskTree.selectItem(nameItem.id);
                } else {
                    riskTree.unselectItem(nameItem.id);
                }
                return nameItem;
            });
        }
    });

    //删除分析指标
    var removeAnalysisItem = function (item) {
        $scope.config.analysisItems = _.filter($scope.config.analysisItems, function (analysisItem) {
            return analysisItem.id != item.id;
        });
        $scope.selectIdList = _.filter($scope.selectIdList, function (indexItem) {
            return indexItem != item.id;
        });
    };

    //保存指标配置
    var internalSaveConfig = function (data) {
        vatDashboardService.saveSummaryConfig(data).success(function () {
            $state.go('summaryDashboard');
        });
    };

    var saveDashboardConfig = function () {
        if ($scope.config.analysisItems.length < 1) {
            SweetAlert.warning($translate.instant('DeleteMeasureAlert'));
            return;
        }
        if (!$scope.config.chartName) {
            SweetAlert.warning($translate.instant('checkChartName'));
            return;
        }

        var indexIds = '';
        var indexIdArr = [];
        var userSetting = '';
        var userSettingArr = [{ name: $translate.instant('OrgName'), dataType: 1, chartType: 'line' }];

        _.each($scope.config.analysisItems, function (item) {
            indexIdArr.push(item.id);
            userSettingArr.push({ name: item.analysisName, dataType: item.dataType, chartType: item.chartType });
        });
        indexIds = indexIdArr.join(',');
        userSetting = JSON.stringify(userSettingArr);

        var data = {};
        data.ID = $scope.config.id;
        data.name = $scope.config.chartName;
        data.indexIDs = indexIds;
        data.userSetting = userSetting;
        data.isShowData = $scope.config.isShowData;
        data.isShowGrid = $scope.config.isShowGrid;
        data.riskTip = $scope.selectRiskIdList.join(',');
        data.orderIndex = 4;
        $scope.internalSaveConfig(data);
    };

    //取消保存
    var cancelConfig = function () {
        $state.go('summaryDashboard');
    };

    //删除图表
    //var deleteChartConfig = function () {
    //    SweetAlert.swal({
    //        title: $translate.instant('ConfirmDelete'),
    //        text: $translate.instant('deleteChart') + "?",
    //        type: "warning",
    //        showCancelButton: true,
    //        confirmButtonColor: "#DD6B55",
    //        confirmButtonText: $translate.instant('Confirm'),
    //        cancelButtonText: $translate.instant('Cancel'),
    //        closeOnConfirm: true
    //    }, function (isConfirm) {
    //        if (isConfirm) {
    //            vatDashboardService.deleteChartConfig($scope.config.id).success(function () {
    //                SweetAlert.success($translate.instant('DeleteSuccess'));
    //                $state.go('summaryDashboard');
    //            });
    //        }
    //    });
    //};

    $scope.chartChanged = true;
    var setAnalysisItems = function () {

        $scope.config.analysisItems = _.filter($scope.config.analysisItems, function (item) {
            return _.contains($scope.selectIdList, item.id);
        });

        _.each($scope.selectIdList, function (selectIndexItem) {
            _.each($scope.subModelDataList, function (item) {
                if (selectIndexItem === item.id && _.where($scope.config.analysisItems, { id: selectIndexItem }).length === 0) {
                    //添加分析指标
                    var obj = new Object();
                    obj.id = item.id;
                    obj.analysisName = item.indexName;
                    obj.dataType = item.dataType;
                    obj.chartType = 'bar';
                    obj.chartOptions = {
                        items: [
                            { typeName: $translate.instant("barchart"), typeValue: 'bar' },
                            { typeName: $translate.instant("linechart"), typeValue: 'line' },
                            { typeName: $translate.instant("areachart"), typeValue: 'area' },
                            { typeName: $translate.instant("stepchart"), typeValue: 'step' }
                        ],
                        displayExpr: 'typeName',
                        valueExpr: 'typeValue',
                        itemTemplate: 'chartTypeItemTemplate',
                        value: 'bar',
                        onItemClick: function (e) {
                            obj.chartType = e.itemData.typeValue;
                            $scope.chartChanged = !$scope.chartChanged;
                        }
                    };

                    if (!_.isEmpty($scope.indexList)) {
                        var indexItemObj = _.find($scope.indexList, function (indexItem) {
                            return indexItem.id == selectIndexItem;
                        });

                        if (!_.isEmpty(indexItemObj)) {
                            obj.index = indexItemObj.orderIndex;
                        }
                    }

                    $scope.config.analysisItems.push(obj);
                }
            })
        });

        //对分析指标排序，使分析指标顺序与指标列表中一致。
        $scope.config.analysisItems = _.sortBy($scope.config.analysisItems, 'index');
    };

    var getModel = function () {
        //获取指标汇总配置
        var modelPromise;
        if (!_.isEmpty($scope.model)) {
            modelPromise = $q.when($scope.model);
        }
        else if ($stateParams.id) {
            $scope.config.id = $stateParams.id;
            modelPromise = vatDashboardService.getDashboardConfigSummary($scope.config.id).then(function (result) {
                if (result && result.data && result.data.data) {
                    return $q.when(result.data.data);
                }
                else {
                    return $q.reject();
                }
            });
        }
        else {
            modelPromise = $q.reject();
        }

        modelPromise.then(function (result) {
            if (result) {
                if (_.isEmpty($scope.model)) {
                    $scope.model = result;
                }

                var selectedAnalysisItems = JSON.parse(result.userSetting);
                selectedAnalysisItems.splice(0, 1);
                var ids = result.indexIDs.split(',');
                $scope.selectedIndexIds = result.indexIDs;
                $scope.config.analysisItems.length = 0;
                _.each(ids, function (id, index) {
                    //添加分析指标
                    var obj = new Object();
                    obj.id = id;
                    obj.analysisName = selectedAnalysisItems[index].name;
                    obj.dataType = selectedAnalysisItems[index].dataType;
                    obj.chartType = selectedAnalysisItems[index].chartType;
                    obj.chartOptions = {
                        items: [
                            { typeName: $translate.instant("barchart"), typeValue: 'bar' },
                            { typeName: $translate.instant("linechart"), typeValue: 'line' },
                            { typeName: $translate.instant("areachart"), typeValue: 'area' },
                            { typeName: $translate.instant("stepchart"), typeValue: 'step' }
                        ],
                        displayExpr: 'typeName',
                        valueExpr: 'typeValue',
                        itemTemplate: 'chartTypeItemTemplate',
                        value: obj.chartType,
                        onItemClick: function (e) {
                            obj.chartType = e.itemData.typeValue;
                            $scope.chartChanged = {};
                        }
                    };
                    $scope.config.analysisItems.push(obj);
                });

                if (result.indexIDs && ids.length > 0) {
                    $scope.selectIdList = ids;
                }

                var riskTipIds = result.riskTip ? result.riskTip.split(',') : null;
                if (riskTipIds && riskTipIds.length > 0) {
                    $scope.selectRiskIdList = riskTipIds;
                }

                $scope.config.selectedModelId = result.modelID;
                $scope.config.chartName = result.name;
                $scope.config.isShowData = result.isShowData;
                $scope.config.isShowGrid = result.isShowGrid ? result.isShowGrid : 0;
            }
        });
    };

    //设置分析指标下拉框的显示值
    $scope.$watchGroup(['selectIdList', 'indexList', 'treeView'], function (newItems, oldItems) {
        if (newItems[1].length > 0) {
            $scope.selectNameList = _.filter($scope.indexList, function (nameItem) {
                return _.contains($scope.selectIdList, nameItem.id) && nameItem.parentId;
            });

            $scope.riskDataSource = [];
            _.each($scope.selectNameList, function (nameItem) {
                var parentNode = _.where($scope.indexList, { id: nameItem.parentId })[0];
                if (_.where($scope.riskDataSource, { id: parentNode.id }).length < 1) {
                    if (_.contains($scope.selectRiskIdList, parentNode.id)) {
                        $scope.riskDataSource.push({ id: parentNode.id, name: parentNode.name, selected: true });
                    } else {
                        $scope.riskDataSource.push({ id: parentNode.id, name: parentNode.name, selected: false });
                    }
                }
            });

            $scope.selectRiskIdList = _.filter($scope.selectRiskIdList, function (riskId) {
                return _.where($scope.riskDataSource, { id: riskId }).length > 0;
            });

            $scope.selectNameList = _.map($scope.selectNameList, function (item) {
                return item.name;
            });
        }
        syncTreeViewSelection();

    });

    //分析指标根据选中的指标变化
    $scope.$watchGroup(['selectIdList', 'subModelDataList', 'indexList'], function () {
        setAnalysisItems();
    });

    // 如果直接传入model,则在model有值后触发设置操作
    $scope.$watch('model', function (newVal, oldVal) {
        if (!_.isEmpty(newVal)) {
            getModel();
        }
    });

    // 如果直接传入外部数据源,则在有值后更新这些数据源
    $scope.$watch('externalDataSource', function (newVal, oldVal) {
        if (!_.isEmpty(newVal)) {
            if (!_.isEmpty(newVal.orgIds)) {
                $scope.selectedOrganizes = newVal.orgIds;
                $scope.selectedOrgIds = newVal.orgIds.join(',');
            }

            if (_.isFunction(newVal.onSave)) {
                $scope.internalSaveConfig = newVal.onSave;
            }

            if (_.isFunction(newVal.onCancel)) {
                $scope.cancelConfig = newVal.onCancel;
            }
        }
    }, true);

    //分析指标配置变动联动图表
    $scope.$watchGroup(['config.analysisItems.length', 'subModelDataList.length', 'selectedOrganizes.length', 'chartChanged', 'config.isShowData'], function (newItems, oldItems) {
        if (newItems[0] > 0 && newItems[1] > 0) {
            var obj = {
                id: $scope.config.id,
                name: $scope.config.chartName,
                isShowData: $scope.config.isShowData,
                header: { v1: $translate.instant('OrgName') },
                headerObj: [{ name: $translate.instant('OrgName'), dataType: 1, chartType: 'line' }],
                data: [],
                noChartMsg: $translate.instant('PleaseAddMeasuresRight')
            };

            for (var key in obj.header) {
                if (key != "v1") {
                    delete obj.header[key];
                }
            }
            var org = obj.headerObj.pop();
            obj.headerObj = [org];

            _.each($scope.config.analysisItems, function (value, index) {
                obj.header['v' + (index + 2)] = value.analysisName;
                obj.headerObj.push({ name: value.analysisName, dataType: value.dataType, chartType: value.chartType });
            });

            obj.data = [];
            _.each($scope.selectedOrganizes, function (orgItem) {
                var flag = false;
                var orgModelObj = { v0: '', v1: '' };
                if ($scope.config.analysisItems.length > 0 && $scope.subModelDataList.length > 0) {
                    _.each($scope.config.analysisItems, function (value, index) {
                        orgModelObj['v' + (index + 2)] = 0;
                        _.chain($scope.subModelDataList).where({ organizationID: orgItem, flag: true }).each(function (itemData) {
                            if (itemData.id === value.id) {
                                orgModelObj['v' + (index + 2)] = parseFloat(itemData.data ? itemData.data : 0);
                                if (!flag) {
                                    orgModelObj['v0'] = itemData.organizationID;
                                    orgModelObj['v1'] = itemData.organizationName;
                                    flag = true;
                                }
                            }
                        }).value();
                    });
                }
                if (flag) {
                    obj.data.push(orgModelObj);
                }
            });

            $scope.chartRenderOption = obj;
        } else {
            $scope.chartRenderOption = { noChartMsg: $translate.instant('PleaseAddMeasuresRight') };
        }

        //showChartTipInfo();
    });

    (function initialize() {
        //获取所有指标信息
        indexAnalysisDetailService.getIndexAnalysisDropDownList().success(function (data) {
            var dataOrder = 0;
            data = _.map(data, function (item) {
                item.orderIndex = dataOrder;
                dataOrder++;
                return item;
            });
            $scope.indexList = data;

            $scope.multiSelectAnalysisOptionHeight = 300;
            if ($scope.indexList && $scope.indexList.length <= 15) {
                $scope.multiSelectAnalysisOptionHeight = 20 * $scope.indexList.length;
            }
        });

        getSubModelList();

        $scope.removeAnalysisItem = removeAnalysisItem;
        $scope.internalSaveConfig = internalSaveConfig;
        $scope.saveDashboardConfig = saveDashboardConfig;
        $scope.cancelConfig = cancelConfig;
        //$scope.deleteChartConfig = deleteChartConfig;

        getModel();
    })();
}
]);
vatDashboardModule.directive('summaryDashboardConfig', ['$log',
    function ($log) {
        'use strict';

        return {
            restrict: 'E',
            templateUrl: '/app/vat/dashboard/vat-summary-dashboard-config/vat-summary-dashboard-config.html' + '?_=' + Math.random(),
            scope: {
                model: '=?',
                externalDataSource: '=?'
            },
            controller: 'SummaryDashboardConfigController',
            link: function (scope, element) {

            }
        };

    }
]);
vatDashboardModule.controller('SummaryDashboardController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval',
    'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', 'uiGridConstants', 'vatSessionService', 'enums',
    'vatOperationLogService', 'projectService', 'vatCommonService', 'dashboardConfigSummaryService', 'modelConfigurationService',
    '$uibModal', 'canvasUtil','vatDashboardService',
    function ($scope, $log, $translate, $timeout, $q, $interval, apiInterceptor, Upload, vatImportService, SweetAlert,
        uiGridConstants, vatSessionService, enums, vatOperationLogService, projectService, vatCommonService,
        dashboardConfigSummaryService, modelConfigurationService, $uibModal, canvasUtil, vatDashboardService) {
        'use strict';

        var thisData = {


        };

        var thisConstant = {
            filterMonth: 'filterMonth',
            dateFormate: 'yyyy-MM',
            dashSignSeparator: '-',
            rowCountPerPage: 9,
            orgColumn: 'v1',
            prefixField: 'v',
            tableBeginXml: '<w:tbl><w:tblPr><w:tblW w:w="5000" w:type="pct"/><w:tblLook w:val="04A0" w:firstRow="1" w:lastRow="0" w:firstColumn="1" w:lastColumn="0" w:noHBand="0" w:noVBand="1"/></w:tblPr><w:tblGrid>',
            tableEndXml: '</w:tbl>',
            tableColDefXml: '<w:gridCol w:w="2000"/>',
            tableColBeginXml: '</w:tblGrid><w:tr>',
            headerFirstCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:bottom w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            headerCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:bottom w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:jc w:val="right"/><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            headerCellEndXml: '</w:t></w:r></w:p></w:tc>',
            firstCellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:top w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/><w:bottom w:val="single" w:sz="2" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:b/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            cellBeginXml: '<w:tc><w:tcPr><w:tcW w:w="2000" w:type="dxa"/><w:tcBorders><w:top w:val="single" w:sz="12" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/><w:bottom w:val="single" w:sz="2" w:space="0" w:color="A5A5A5" w:themeColor="accent3"/></w:tcBorders></w:tcPr><w:p><w:pPr><w:jc w:val="right"/><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr></w:pPr><w:r><w:rPr><w:rFonts w:ascii="宋体" w:eastAsia="宋体" w:hAnsi="宋体"/><w:color w:val="ED7D31" w:themeColor="accent2"/><w:sz w:val="20"/><w:szCs w:val="20"/></w:rPr><w:t>',
            rowBeginXml: '<w:tr>',
            rowEndXml: '</w:tr>',
            chartPrefix: 'chart-'
        };

        var thisDateService = {

            // 获取当前月份的上一个月时间
            getLastMonth: function () {
                var date = new Date();
                date.setMonth(date.getMonth() - 1);
                return date;
            },

            // 获取查询条件
            getQueryModel: function () {
                var arr = $scope.filterMonth.split(thisConstant.dashSignSeparator);
                var year = parseInt(arr[0]);
                var month = parseInt(arr[1]);

                var model = {
                    year: year,
                    period: month,
                    organizationIDList: $scope.selectedOrganizationList
                };

                return model;
            },

            // 验证有效月份
            validDateMonth: function () {
                var date = $scope.filterMonth + '-01';
                return window.PWC.checkDate(date);
            },

            // 转换为页面展示数据
            parseShowData: function (data) {
                if (data && data.length > 0) {
                    data.forEach(function (row) {
                        var values = _.values(row.header);
                        var keys = _.keys(row.header);
                        var length = keys ? keys.length : 0;
                        row.keys = keys;
                        row.headerObj = JSON.parse(row.headerObj);
                    });
                }

                return data;
            },

            // 查询汇总数据
            querySummaryProcess: function () {
                if (!thisDateService.validDateMonth) {
                    return;
                }

                var model = thisDateService.getQueryModel();
                vatSessionService.querySummayDashboardModel = model;
                dashboardConfigSummaryService.querySummaryData(model).success(function (data) {
                    // 进行数据转换
                    $scope.querySummaryResult = thisDateService.parseShowData(data);
                    var hasData = false;
                    if ($scope.querySummaryResult && $scope.querySummaryResult.length > 0) {
                        hasData = true;
                    }

                    $scope.hasData = hasData;

                    $timeout(function () {
                        thisDateService.drawTableList($scope.querySummaryResult);
                    }, 100);

                    // console.log(JSON.stringify($scope.querySummaryResult));
                });
            },

            drawTableList: function (data) {
                if (data && data.length > 0) {
                    data.forEach(function (row) {
                        thisDateService.drawTable(row);
                    });
                }
            },

            drawTable: function (node) {
                if (_.isEmpty(node.data)) {
                    node.isEmpty = true;
                }
                else {
                    node.isEmpty = false;
                    var vatGallery = thisDateService.createGalleryData(node);

                    var itemTemplate = function (item, index) {
                        var columns = thisDateService.createColumns(node);

                        return $('<div class="gallery-table"/>').dxDataGrid({
                            dataSource: item.dataValue,
                            width: '100%',
                            showRowLines: true,
                            showColumnLines: false,
                            noDataText: '',
                            cellHintEnabled: true,
                            showBorders: false,
                            format: { type: 'fixedPoint', precision: 2 },
                            columns: columns
                        });

                    };
                    var galleryWidget = $("#" + node.id).dxGallery({
                        dataSource: vatGallery,
                        // height: 260,
                        width: "458px",
                        loop: false,
                        showIndicator: true,
                        noDataText: '',
                        showNavButtons: true,
                        itemTemplate: itemTemplate,

                    }).dxGallery("instance");
                }
            },
            // 构造GalleryData
            createGalleryData: function (node) {

                var index = Math.ceil(node.data.length / thisConstant.rowCountPerPage);
                // var x = node.data.length % thisConstant.rowCountPerPage;
                // if (x !== 0) {
                //     index = index + 1;
                // }

                var result = [];
                for (var i = 0; i < index; i++) {
                    var item = {};
                    item.id = i;
                    item.dataValue = [];
                    var start = i * thisConstant.rowCountPerPage;
                    for (var j = start; j < start + thisConstant.rowCountPerPage; j++) {
                        var rowData = angular.copy(node.data[j]);
                        if (!rowData) {
                            continue;
                        }

                        for (var k = 1; k < node.headerObj.length; k++) {
                            var dataModel = node.headerObj[k];
                            var field = thisConstant.prefixField + (k + 1);
                            if (dataModel.dataType === 1) {
                                rowData[field] = Number(rowData[field]).formatAmount();

                            } else if (dataModel.dataType === 3) {
                                rowData[field] = rowData[field] == 1 ? '是' : '否';
                            }
                            else {
                                var percentData = Number(rowData[field]) * 100;
                                rowData[field] = Number(percentData).formatAmount() + '%';
                            }
                        }
                        item.dataValue.push(rowData);
                    }

                    result.push(item);
                }

                return result;
            },

            // 构造列表
            createColumns: function (node) {
                var result = [];
                node.keys.forEach(function (key) {
                    var item = {};
                    item.dataField = key;
                    if (key === thisConstant.orgColumn) {
                        item.caption = $translate.instant('EntityName');
                    }
                    else {
                        item.format = { type: 'fixedPoint' };
                        item.cssClass = 'orange-color';
                        item.alignment = 'right';
                        item.caption = _.isEmpty(node.header[key]) ? key : node.header[key];
                    }

                    result.push(item);
                });

                return result;
            },

            isChangedArray: function (newValue, oldValue) {
                if (!newValue && !oldValue) {
                    return false;
                }

                if (!newValue) {
                    return true;
                }

                if (!oldValue) {
                    return true;
                }

                if (newValue.length !== oldValue.length) {
                    return true;
                }

                // 排序
                newValue = newValue.sort();
                oldValue = oldValue.sort();

                for (var i = 0; i < newValue.length; i++) {
                    if (newValue[i] !== oldValue[i]) {
                        return true;
                    }
                }

                return false;
            },
            querySummary: function (queryModel) {

                if (thisDateService.isChangedArray(queryModel, $scope.selectedOrganizationList)) {

                    $scope.selectedOrganizationList = queryModel;

                    var newValue = queryModel;

                    var model = thisDateService.getQueryModel();
                    if ($scope.hasCheckedDirtyData) {
                        thisDateService.querySummaryProcess();
                    }

                    if (!$scope.hasCheckedDirtyData) {
                        modelConfigurationService.organizationsHasDirtyData(newValue.join(','), model.year, 2).success(function (result) {
                            if (result) {
                                SweetAlert.swal({
                                    title: $translate.instant('OrganizationsHasDirtyData'),
                                    text: '',
                                    type: "warning",
                                    showCancelButton: true,
                                    confirmButtonColor: "#DD6B55",
                                    confirmButtonText: $translate.instant('Confirm'),
                                    cancelButtonText: $translate.instant('Cancel'),
                                    closeOnConfirm: true
                                }, function (isConfirm) {
                                    if (isConfirm) {

                                        var parentElem = angular.element($('#organizationDirtyProcessBarContainer'));
                                        $scope.processBarModalInstance = $uibModal.open({
                                            ariaLabelledBy: 'modal-title',
                                            ariaDescribedBy: 'modal-body',
                                            templateUrl: 'dirtyDataProcessBar.html',
                                            windowClass: 'data-table',
                                            appendTo: parentElem,
                                            backdrop: 'static',
                                            scope: $scope
                                        });

                                        $scope.intervalId = setInterval(timer, 50);

                                        //重新计算模型数据
                                        modelConfigurationService.updateOrganizationsModelDirtyData(newValue.join(','), model.year, 2).success(function () {
                                            $scope.hasCheckedFinished = true;
                                        });
                                    } else {
                                        thisDateService.querySummaryProcess();
                                    }
                                });
                            } else {
                                thisDateService.querySummaryProcess();
                            }
                        });
                        $scope.hasCheckedDirtyData = true;
                    }

                }
            },

            toggleChart: function ($event, node) {
                var target = $event.target;
                node.isShowChart = !node.isShowChart;
            }
        };

        $scope.progressBarValue = 0;
        $scope.processBarModalInstance = null;
        $scope.intervalId = null;

        function timer() {
            $scope.$apply(function () {
                $scope.progressBarValue++;
                if (!$scope.hasCheckedFinished) {
                    $scope.processBarMax++;
                }
            });
        }

        $scope.processBarMax = 100;
        $scope.hasCheckedFinished = false;
        $scope.progressBarOptions = {
            min: 0,
            width: "95%",
            bindingOptions: {
                value: 'progressBarValue',
                max: 'processBarMax'
            },
            statusFormat: function (value) {
                return "计算进度: " + (value * 100).toFixed(0) + "%";
            },
            onComplete: function (e) {
                //重新计算模型数据结束后加载图表。
                thisDateService.querySummaryProcess();
            }
        };

        $scope.hasCheckedDirtyData = false;

        var mainModule = {

            // 初始化参数
            initParams: function () {
                $scope.selectedOrganizationList = [];
                $scope.hasData = true;
                mainModule.initFilterMonth();

                mainModule.watchFilter();
            },

            // 初始化查询月份
            initFilterMonth: function () {

                var lastmonth = thisDateService.getLastMonth();

                $scope.filterMonth = lastmonth.formatDateTime(thisConstant.dateFormate);;

                var elem1 = $("#" + thisConstant.filterMonth);
                elem1.datepicker({
                    minViewMode: 1,
                    autoclose: true,
                    language: "zh-CN",
                    format: "yyyy-mm",
                });

                elem1.datepicker('setDate', lastmonth);
            },

            // 监视查询条件变更
            watchFilter: function () {

                // 机构选择改变时
                // $scope.$watch('selectedOrganizationList', function(newValue, oldValue) {
                //     // console.log(newValue.join(',') + '-' + $scope.filterMonth);
                //     if (thisDateService.isChangedArray(newValue, oldValue)) {
                //         var model = thisDateService.getQueryModel();
                //         if ($scope.hasCheckedDirtyData) {
                //             thisDateService.querySummaryProcess();
                //         }

                //         if (!$scope.hasCheckedDirtyData) {
                //             modelConfigurationService.organizationsHasDirtyData(newValue.join(','), model.year, 2).success(function(result) {
                //                 if (result) {
                //                     SweetAlert.swal({
                //                         title: $translate.instant('OrganizationsHasDirtyData'),
                //                         text: '',
                //                         type: "warning",
                //                         showCancelButton: true,
                //                         confirmButtonColor: "#DD6B55",
                //                         confirmButtonText: $translate.instant('Confirm'),
                //                         cancelButtonText: $translate.instant('Cancel'),
                //                         closeOnConfirm: true
                //                     }, function(isConfirm) {
                //                         if (isConfirm) {

                //                             var parentElem = angular.element($('#organizationDirtyProcessBarContainer'));
                //                             $scope.processBarModalInstance = $uibModal.open({
                //                                 ariaLabelledBy: 'modal-title',
                //                                 ariaDescribedBy: 'modal-body',
                //                                 templateUrl: 'dirtyDataProcessBar.html',
                //                                 windowClass: 'data-table',
                //                                 appendTo: parentElem,
                //                                 backdrop: 'static',
                //                                 scope: $scope
                //                             });

                //                             $scope.intervalId = setInterval(timer, 50);

                //                             //重新计算模型数据
                //                             modelConfigurationService.updateOrganizationsModelDirtyData(newValue.join(','), model.year, 2).success(function() {
                //                                 $scope.hasCheckedFinished = true;
                //                             });
                //                         } else {
                //                             thisDateService.querySummaryProcess();
                //                         }
                //                     });
                //                 } else {
                //                     thisDateService.querySummaryProcess();
                //                 }
                //             });
                //             $scope.hasCheckedDirtyData = true;
                //         }


                //     }
                // });

                // 日期选择改变时
                $scope.$watch('filterMonth', function (newValue, oldValue) {
                    // console.log($scope.selectedOrganizationList.join(',') + '-' + $scope.filterMonth);
                    if (newValue !== oldValue) {
                        thisDateService.querySummaryProcess();
                    }
                });
            },

            // 入口函数
            main: function () {
                mainModule.initParams();
            },

            loadFile: function (url, callback) {
                JSZipUtils.getBinaryContent(url, callback);
            },

            generateDoc: function (doc) {
                var tableContent = thisConstant.tableBeginXml;
                var colNum = doc.keys.length;
                var rowNum = doc.data.length;
                for (var i = 0; i < colNum; i++) {
                    tableContent += thisConstant.tableColDefXml;
                }

                tableContent += thisConstant.tableColBeginXml;

                for (var i = 0; i < colNum; i++) {
                    tableContent = tableContent
                        + (i === 0 ? thisConstant.headerFirstCellBeginXml : thisConstant.headerCellBeginXml)
                        + doc.header[doc.keys[i]] + thisConstant.headerCellEndXml;
                }

                tableContent += thisConstant.rowEndXml;

                for (var j = 0; j < rowNum; j++) {
                    tableContent += thisConstant.rowBeginXml;

                    for (var i = 0; i < colNum; i++) {
                        var dataModel = doc.headerObj[i];
                        var data = doc.data[j][doc.keys[i]];
                        if (i > 0) {
                            if (dataModel.dataType === 1) {
                                data = Number(data).formatAmount();

                            } else if (dataModel.dataType === 3) {
                                data = data == 1 ? '是' : '否';
                            }
                            else {
                                var percentData = Number(data) * 100;
                                data = Number(percentData).formatAmount() + '%';
                            }
                        }

                        if (i === 0) {
                            tableContent = tableContent + thisConstant.firstCellBeginXml
                                + data + thisConstant.headerCellEndXml;
                        }
                        else {
                            tableContent = tableContent + thisConstant.cellBeginXml
                                + data + thisConstant.headerCellEndXml;
                        }
                    }

                    tableContent += thisConstant.rowEndXml;
                }

                tableContent += thisConstant.tableEndXml;

                return {
                    chartName: doc.name,
                    chartContent: thisConstant.chartPrefix + doc.id,
                    riskTip: _.isArray(doc.modelTips) ? doc.modelTips : [],
                    tableContent: tableContent
                };
            },

            generateDocImages: function () {
                var opts = {
                    centered: true,
                    getImage: function (tagValue, tagName) {
                        return canvasUtil.toBinaryData(document.getElementById(tagValue));
                    },
                    getSize: function (img, tagValue, tagName) {
                        return [550, 250];
                    }
                }

                var imageModule = new ImageModule(opts);
                return imageModule;
            },

            exportChart: function (chart) {
                var exportModel = mainModule.generateDoc(chart);

                var exportDocName = chart.name + '.docx';
                var templateName = '/ExportTemplate/DashboardExportTemplate.docx';

                mainModule.loadFile(templateName + '?_=' + Math.random(), function (err, content) {
                    if (err) { throw e };
                    var zip = new JSZip2(content);
                    var imageModule = mainModule.generateDocImages();
                    var doc = new docxtemplater().attachModule(imageModule).loadZip(zip);
                    doc.setData(exportModel);
                    try {
                        doc.render();
                    }
                    catch (err) {
                        $log.info(err);
                        swal({
                            title: '导出发生一个错误，请重试',
                            confirmButtonColor: "#dc6000",
                            confirmButtonText: "确定",
                            closeOnConfirm: true,
                            type: "error"
                        });
                        return;
                    }

                    var out = doc.getZip().generate({
                        type: "blob",
                        mimeType: "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
                    });
                    saveAs(out, exportDocName);
                })
            }
        };

        //删除图表
        $scope.deleteChartConfig = function (id) {
            SweetAlert.swal({
                title: $translate.instant('ConfirmDelete'),
                text: $translate.instant('deleteChart') + "?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Confirm'),
                cancelButtonText: $translate.instant('Cancel'),
                closeOnConfirm: true
            }, function (isConfirm) {
                if (isConfirm) {
                    vatDashboardService.deleteChartConfig(id).success(function () {
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                        thisDateService.querySummaryProcess();
                    });
                }
            });
        };

        //重新计算模型完成时执行
        $scope.$watch('progressBarValue', function (newValue) {
            if (newValue == $scope.processBarMax) {
                $scope.processBarModalInstance.dismiss({ $value: 'cancel' });
                clearInterval($scope.intervalId);
            }
        });
     
        //开始
        (function initialize() {
            $log.debug('SummaryDashboardController.ctor()...');
            console.log('SummaryDashboardController');
            $scope.querySummary = thisDateService.querySummary;
            $scope.exportChart = mainModule.exportChart;
            $scope.toggleChart = thisDateService.toggleChart;
            mainModule.main();         
        })();
    }
]);
vatDashboardModule.directive('summaryDashboard', ['$log',
    function ($log) {
        'use strict';
        $log.debug('summaryDashboard.ctor()...');
        console.log('summaryDashboard');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/dashboard/vat-summary-dashboard/vat-summary-dashboard.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'SummaryDashboardController',
            link: function (scope, element) {

            }
        };

    }
]);
vatModule.controller('devGridHeaderController', ['$log', '$scope', '$translate',
    function ($log, $scope, $translate) {
        $scope.trialBalanceOptions = [
            { id: 1, name: '科目代码' },
            { id: 2, name: '科目名称' },
            { id: 3, name: '期初借方' },
            { id: 4, name: '期初贷方' },
            { id: 5, name: '发生借方' },
            { id: 6, name: '发生贷方' },
            { id: 7, name: '期末借方' },
            { id: 8, name: '期末贷方' }
        ];
        //var allData = "101,现金,\"1,086.11\",,\"5,731,688.37\",\"5,738,891.10\",\"-6,116.62\",\r\n102,银行存款,\"3,349,505.10\",,\"52,426,746.24\",\"48,621,012.13\",\"7,155,239.21\",\r\n  10201,城南办-1004,\"245,570.87\",,\"29,215,963.81\",\"29,462,293.30\",-758.62,\r\n  10202,城南办-6626,\"442,587.28\",,\"9,040,329.42\",\"8,467,800.76\",\"1,015,115.94\",\r\n  10203,城西办-9801,0.00,,0.00,0.00,0.00,\r\n  10204,商行汇丰处,\"1,010,376.35\",,\"6,869,634.96\",\"6,850,536.80\",\"1,029,474.51\",\r\n  10205,中行,0.00,,0.00,0.00,0.00,\r\n  10206,建行公积金,\"1,612,770.31\",,\"635,572.45\",\"434,256.97\",\"1,814,085.79\",\r\n  10207,交行-9153,84.09,,\"2,394,726.85\",\"2,394,711.98\",98.96,\r\n  10208,商行-2605,54.41,,\"513,486.70\",\"511,374.82\",\"2,166.29\",\r\n  10209,交行61993,\"38,061.79\",,\"2,755,831.85\",\"500,017.50\",\"2,293,876.14\",\r\n  10210,浦发银行营业部,0.00,,\"1,001,200.20\",20.00,\"1,001,180.20\",\r\n109,其他货币资金,0.00,,0.00,0.00,0.00,\r\n111,短期投资,0.00,,0.00,0.00,0.00,\r\n  11101,债券投资,0.00,,0.00,0.00,0.00,\r\n112,应收票据,0.00,,0.00,0.00,0.00,\r\n  11201,银行承兑汇票,0.00,,0.00,0.00,0.00,\r\n    1120101,中船工业贸易公司,0.00,,0.00,0.00,0.00,\r\n113,应收帐款,\"5,378,448.13\",,\"27,803,015.89\",\"29,274,089.59\",\"3,907,374.43\",\r\n114,坏帐准备,\"-244,592.35\",,0.00,\"-1,690.47\",\"-242,901.88\",\r\n115,预付帐款,0.00,,0.00,0.00,0.00,\r\n119,其他应收款,\"762,052.88\",,\"1,838,645.80\",\"1,452,103.84\",\"1,148,594.84\",\r\n  11901,单位,\"764,211.77\",,\"949,468.94\",\"651,327.60\",\"1,062,353.11\",\r\n  11902,个人,\"-2,158.89\",,\"889,176.86\",\"800,776.24\",\"86,241.73\",\r\n121,材料采购,0.00,,0.00,0.00,0.00,\r\n123,原材料,\"2,429,520.26\",,\"8,981,127.14\",\"8,356,586.92\",\"3,054,060.48\",\r\n  12301,原材料一,\"267,760.77\",,\"292,200.64\",\"197,766.10\",\"362,195.31\",\r\n  12302,原材料二,\"94,213.51\",,\"737,111.55\",\"714,538.29\",\"116,786.77\",\r\n  12303,原材料三,\"56,212.95\",,\"136,788.67\",\"169,589.16\",\"23,412.46\",\r\n  12304,原材料四,\"472,936.21\",,\"1,667,805.94\",\"1,359,437.83\",\"781,304.32\",\r\n  12311,补助材料一,\"48,476.08\",,\"84,281.87\",\"86,105.18\",\"46,652.77\",\r\n  12312,补助材料二,\"4,675.10\",,\"70,024.70\",\"68,692.23\",\"6,007.57\",\r\n  12313,补助材料三,\"3,051.39\",,\"188,200.26\",\"182,625.83\",\"8,625.82\",\r\n  12314,补助材料四,\"5,675.27\",,\"47,291.77\",\"39,474.06\",\"13,492.98\",\r\n  12315,补助材料五,\"18,248.78\",,\"79,296.67\",\"70,443.75\",\"27,101.70\",\r\n  12316,补助材料六,\"52,135.91\",,\"492,228.21\",\"468,640.58\",\"75,723.54\",\r\n  12317,补助材料七,\"19,873.42\",,\"19,998.19\",\"19,230.39\",\"20,641.22\",\r\n  12318,补助材料八,\"86,252.27\",,\"104,187.70\",\"90,301.32\",\"100,138.65\",\r\n  12319,补助材料九,\"4,927.95\",,\"82,765.95\",\"67,702.64\",\"19,991.26\",\r\n  12320,补助材料十,\"5,434.67\",,\"179,377.71\",\"176,117.20\",\"8,695.18\",\r\n  12321,补助材料十一,\"370,908.97\",,\"2,027,177.99\",\"1,965,096.07\",\"432,990.89\",\r\n  12322,补助材料十二,0.00,,\"28,846.82\",\"27,973.90\",872.92,\r\n  12323,补助材料十三,\"114,918.21\",,\"383,258.38\",\"374,926.20\",\"123,250.39\",\r\n  12324,补助材料十四,\"150,105.88\",,\"1,427,092.97\",\"1,443,198.18\",\"134,000.67\",\r\n  12325,补助材料十五,\"29,929.34\",,\"244,931.97\",\"211,207.99\",\"63,653.32\",\r\n  12326,补助材料十六,\"572,354.80\",,\"351,490.09\",\"308,964.21\",\"614,880.68\",\r\n  12331,工具一,\"10,152.38\",,\"12,783.54\",\"11,171.53\",\"11,764.39\",\r\n  12332,工具二,\"7,997.93\",,\"16,832.64\",\"14,004.35\",\"10,826.22\",\r\n  12333,工具三,\"4,528.44\",,\"22,690.74\",\"20,488.52\",\"6,730.66\",\r\n  12334,工具四,\"14,278.07\",,\"29,975.95\",\"23,706.81\",\"20,547.21\",\r\n  12335,工具五,\"2,223.84\",,\"10,008.17\",\"9,206.57\",\"3,025.44\",\r\n  12336,工具六,\"7,071.70\",,\"29,192.41\",\"25,918.02\",\"10,346.09\",\r\n  12337,工具七,\"4,872.13\",,\"45,228.01\",\"40,076.85\",\"10,023.29\",\r\n  12341,燃料,304.29,,\"171,864.23\",\"171,436.22\",732.30,\r\n  12371,材料差价,0.00,,\"-1,806.60\",\"-1,453.06\",-353.54,\r\n128,包装物,0.00,,0.00,0.00,0.00,\r\n129,低值易耗品,0.00,,0.00,0.00,0.00,\r\n131,材料成本差异,0.00,,0.00,0.00,0.00,\r\n133,委托加工材料,0.00,,0.00,0.00,0.00,\r\n135,自制半成品,\"2,151,165.34\",,\"6,125,830.96\",\"7,774,384.36\",\"502,611.94\",\r\n  13501,生产科库,\"2,151,165.34\",,\"6,125,830.96\",\"7,774,384.36\",\"502,611.94\",\r\n137,产成品,\"400,669.58\",,\"21,642,319.55\",\"21,814,514.36\",\"228,474.77\",\r\n138,分期收款发出商品,0.00,,0.00,0.00,0.00,\r\n139,待摊费用,\"32,938.54\",,\"3,773.16\",\"36,127.09\",584.61,\r\n  13901,办公用品,0.00,,\"1,637.60\",\"1,052.99\",584.61,\r\n  13902,工具室,\"32,938.54\",,\"2,135.56\",\"35,074.10\",0.00,\r\n  13909,抵税户,0.00,,0.00,0.00,0.00,\r\n151,长期投资,0.00,,0.00,0.00,0.00,\r\n  15101,债券投资,0.00,,0.00,0.00,0.00,\r\n161,固定资产,\"31,342,716.05\",,\"674,511.69\",\"50,000.00\",\"31,967,227.74\",\r\n  16101,生产经营用,\"9,302,447.01\",,\"575,000.00\",\"50,000.00\",\"9,827,447.01\",\r\n  16102,非生产经营用,\"2,890,269.04\",,\"99,511.69\",0.00,\"2,989,780.73\",\r\n  16103,土地,\"19,150,000.00\",,0.00,0.00,\"19,150,000.00\",\r\n165,累计折旧,,\"8,265,828.22\",\"50,277.76\",\"498,345.04\",,\"8,713,895.50\"\r\n166,固定资产清理,0.00,,0.00,0.00,0.00,\r\n169,在建工程,0.00,,0.00,0.00,0.00,\r\n  16901,工程物资,0.00,,0.00,0.00,0.00,\r\n171,无形资产,0.00,,0.00,0.00,0.00,\r\n181,递延资产,0.00,,0.00,0.00,0.00,\r\n191,待处理财产损溢,0.00,,0.00,0.00,0.00,\r\n  19101,待处理流动资产损溢,0.00,,0.00,0.00,0.00,\r\n  19102,待处理固定资产损溢,0.00,,0.00,0.00,0.00,\r\n201,短期借款,,0.00,0.00,0.00,,0.00\r\n  20101,临时借款,,0.00,0.00,0.00,,0.00\r\n202,应付票据,,0.00,0.00,0.00,,0.00\r\n  20201,北京维梦贸易公司,,0.00,0.00,0.00,,0.00\r\n203,应付帐款,,\"4,506,240.23\",\"12,042,889.97\",\"13,755,640.49\",,\"6,218,990.75\"\r\n204,预收帐款,,0.00,0.00,0.00,,0.00\r\n209,其他应付款,,\"4,901,247.51\",\"818,414.53\",\"1,325,477.81\",,\"5,408,310.79\"\r\n211,应付工资,,\"1,331,225.01\",\"9,368,466.63\",\"9,228,801.12\",,\"1,191,559.50\"\r\n  21101,工资结余,,\"1,331,225.01\",\"4,753,961.07\",\"4,614,295.56\",,\"1,191,559.50\"\r\n  21102,应付工资明细,,0.00,\"4,614,505.56\",\"4,614,505.56\",,0.00\r\n    2110201,标准工资,,0.00,\"3,401,142.35\",\"3,401,142.35\",,0.00\r\n    2110202,价格补贴,,0.00,\"623,327.00\",\"623,327.00\",,0.00\r\n    2110203,加班工资,,0.00,\"32,593.41\",\"32,593.41\",,0.00\r\n    2110204,奖金,,0.00,\"489,458.00\",\"489,458.00\",,0.00\r\n    2110205,夜班费,,0.00,\"19,408.00\",\"19,408.00\",,0.00\r\n    2110206,房贴,,0.00,\"48,576.80\",\"48,576.80\",,0.00\r\n214,应付福利费,,\"-99,247.47\",\"1,204,430.12\",\"759,287.46\",,\"-544,390.13\"\r\n  21401,提取福利费,,\"-99,247.47\",0.00,\"646,001.38\",,\"546,753.91\"\r\n  21402,福利费开支,,0.00,\"1,204,430.12\",\"113,286.08\",,\"-1,091,144.04\"\r\n    2140201,开支医疗费,,0.00,\"532,627.24\",\"106,100.90\",,\"-426,526.34\"\r\n      214020101,购药,,0.00,\"305,977.63\",\"64,899.18\",,\"-241,078.45\"\r\n      214020102,职工医疗费,,0.00,\"194,908.47\",\"41,201.72\",,\"-153,706.75\"\r\n      214020103,子女医疗费,,0.00,\"19,368.29\",0.00,,\"-19,368.29\"\r\n      214020104,家属医疗费,,0.00,\"12,372.85\",0.00,,\"-12,372.85\"\r\n    2140202,福利补助开支,,0.00,\"671,802.88\",\"7,185.18\",,\"-664,617.70\"\r\n      214020201,补助,,0.00,\"111,979.68\",0.00,,\"-111,979.68\"\r\n      214020202,食堂,,0.00,100.00,0.00,,-100.00\r\n      214020203,托儿所,,0.00,\"10,080.50\",0.00,,\"-10,080.50\"\r\n      214020204,独生子女费,,0.00,0.00,0.00,,0.00\r\n      214020205,团员活动费,,0.00,0.00,0.00,,0.00\r\n      214020206,其他,,0.00,\"549,642.70\",\"7,185.18\",,\"-542,457.52\"\r\n221,应交税金,,\"615,262.71\",\"9,975,086.68\",\"9,660,691.98\",,\"300,868.01\"\r\n  22101,应交增值税,,\"418,892.89\",\"9,638,078.41\",\"9,317,029.40\",,\"97,843.88\"\r\n    2210101,年初未交,,0.00,0.00,0.00,,0.00\r\n    2210102,进项税额,,0.00,\"2,276,419.33\",\"2,276,419.33\",,0.00\r\n    2210103,销项税额,,0.00,\"4,658,514.70\",\"4,658,514.70\",,0.00\r\n    2210104,已交税金,,\"418,892.89\",\"2,703,144.38\",\"2,382,095.37\",,\"97,843.88\"\r\n    2210105,进项税额转出,,0.00,0.00,0.00,,0.00\r\n  22102,营业税,,\"4,728.50\",\"18,827.65\",\"12,256.65\",,\"-1,842.50\"\r\n  22103,城建税,,\"64,078.14\",\"202,264.51\",\"145,157.72\",,\"6,971.35\"\r\n  22104,房产税,,0.00,\"10,853.73\",\"10,853.73\",,0.00\r\n  22105,车船使用税,,0.00,0.00,0.00,,0.00\r\n  22106,土地使用税,,0.00,0.00,0.00,,0.00\r\n  22107,所得税,,\"127,563.18\",\"103,146.19\",\"173,478.29\",,\"197,895.28\"\r\n  22108,固资方向税,,0.00,0.00,0.00,,0.00\r\n  22109,印花税,,0.00,\"1,916.19\",\"1,916.19\",,0.00\r\n223,应付利润,,0.00,0.00,0.00,,0.00\r\n  22303,个人投资利润,,0.00,0.00,0.00,,0.00\r\n224,应付股利,,0.00,0.00,\"77,486.97\",,\"77,486.97\"\r\n229,其他应交款,,\"580,213.68\",\"281,522.91\",\"224,140.38\",,\"522,831.15\"\r\n  22901,教育费附加,,\"33,968.35\",\"100,363.07\",\"82,956.88\",,\"16,562.16\"\r\n  22902,防洪保安基金,,\"2,523.74\",\"122,672.77\",\"120,149.03\",,0.00\r\n  22903,大交通基金,,\"2,969.34\",0.00,0.00,,\"2,969.34\"\r\n  22904,粮食补贴基金,,\"15,120.00\",0.00,0.00,,\"15,120.00\"\r\n  22905,土地使用税,,\"200,315.50\",\"47,021.80\",\"9,569.20\",,\"162,862.90\"\r\n  22906,房产税,,\"229,237.75\",\"11,465.27\",\"11,465.27\",,\"229,237.75\"\r\n  22907,印花税,,\"11,931.00\",0.00,0.00,,\"11,931.00\"\r\n  22908,车船使用税,,920.00,0.00,0.00,,920.00\r\n  22909,土地使用费,,\"83,228.00\",0.00,0.00,,\"83,228.00\"\r\n231,预提费用,,0.00,0.00,0.00,,0.00\r\n  23101,租金,,0.00,0.00,0.00,,0.00\r\n233,待扣税金,,0.00,0.00,0.00,,0.00\r\n241,长期借款,,0.00,0.00,0.00,,0.00\r\n251,应付债券,,0.00,0.00,0.00,,0.00\r\n  25101,债券本金,,0.00,0.00,0.00,,0.00\r\n  25102,债券利息,,0.00,0.00,0.00,,0.00\r\n261,长期应付款,,0.00,0.00,0.00,,0.00\r\n265,专项应付款,,\"1,107,137.22\",\"3,000.00\",\"392,249.06\",,\"1,496,386.28\"\r\n  26501,科技拨款,,\"1,060,750.00\",0.00,\"380,000.00\",,\"1,440,750.00\"\r\n  26502,标准拨款,,\"29,454.79\",0.00,0.00,,\"29,454.79\"\r\n  26503,新品拨款,,\"6,649.69\",0.00,0.00,,\"6,649.69\"\r\n  26504,住房基金,,\"10,282.74\",\"3,000.00\",\"12,249.06\",,\"19,531.80\"\r\n301,实收资本,,\"4,566,000.00\",0.00,0.00,,\"4,566,000.00\"\r\n  30101,国家资本金,,0.00,0.00,0.00,,0.00\r\n  30102,法人资本金,,0.00,0.00,0.00,,0.00\r\n  30103,个人资本金,,\"4,566,000.00\",0.00,0.00,,\"4,566,000.00\"\r\n311,资本公积,,\"20,022,653.00\",0.00,\"48,372.09\",,\"20,071,025.09\"\r\n  31101,财产重估增值,,\"122,603.37\",0.00,0.00,,\"122,603.37\"\r\n  31102,住房委托代管,,\"673,140.94\",0.00,0.00,,\"673,140.94\"\r\n  31103,土地委托代管,,\"19,150,000.00\",0.00,0.00,,\"19,150,000.00\"\r\n  31104,所得税返还,,\"76,908.69\",0.00,0.00,,\"76,908.69\"\r\n  31105,其他资本公积,,0.00,0.00,\"48,372.09\",,\"48,372.09\"\r\n313,盈余公积,,\"300,104.60\",0.00,\"282,826.54\",,\"582,931.14\"\r\n  31301,公益金,,\"55,180.61\",0.00,\"43,321.35\",,\"98,501.96\"\r\n  31302,一般盈余公积,,\"37,680.61\",0.00,\"35,221.35\",,\"72,901.96\"\r\n  31303,任意盈余公积,,\"113,041.84\",0.00,\"204,283.84\",,\"317,325.68\"\r\n  31304,补充流动资金,,\"94,201.54\",0.00,0.00,,\"94,201.54\"\r\n321,本年利润,,0.00,\"55,701,350.62\",\"55,231,350.62\",,\"-470,000.00\"\r\n  32101,收入,,0.00,\"27,878,521.21\",\"27,878,521.21\",,0.00\r\n    3210101,产品销售收入,,0.00,\"27,281,884.00\",\"27,281,884.00\",,0.00\r\n    3210102,其他业务收入,,0.00,\"352,876.84\",\"352,876.84\",,0.00\r\n    3210103,营业外收入,,0.00,\"243,760.37\",\"243,760.37\",,0.00\r\n    3210104,投资收益,,0.00,0.00,0.00,,0.00\r\n    3210105,利润总额,,0.00,0.00,0.00,,0.00\r\n  32102,支出合计,,0.00,\"27,822,829.41\",\"27,352,829.41\",,\"-470,000.00\"\r\n    3210201,产品销售成本,,0.00,\"21,593,258.94\",\"21,593,258.94\",,0.00\r\n    3210202,管理费用,,0.00,\"5,043,212.66\",\"4,673,212.66\",,\"-370,000.00\"\r\n    3210203,财务费用,,0.00,\"-122,279.00\",\"-122,279.00\",,0.00\r\n    3210204,产品销售费用,,0.00,\"462,207.37\",\"462,207.37\",,0.00\r\n    3210205,产销税金及附加,,0.00,\"226,756.72\",\"226,756.72\",,0.00\r\n    3210206,其他业为支出,,0.00,\"427,498.96\",\"427,498.96\",,0.00\r\n    3210207,营业外支出,,0.00,\"192,173.76\",\"92,173.76\",,\"-100,000.00\"\r\n  32103,投资收益,,0.00,0.00,0.00,,0.00\r\n  32104,未分配利润,,0.00,0.00,0.00,,0.00\r\n  32105,上年利润调整,,0.00,0.00,0.00,,0.00\r\n322,利润分配,,0.00,\"1,051,383.60\",\"1,051,383.60\",,0.00\r\n  32201,应交所得税,,0.00,\"173,478.29\",\"173,478.29\",,0.00\r\n  32202,盈余公积补亏,,0.00,0.00,0.00,,0.00\r\n  32203,应交其他税,,0.00,0.00,0.00,,0.00\r\n  32204,提取盈余公积,,0.00,\"239,505.19\",\"239,505.19\",,0.00\r\n  32205,应付利润,,0.00,0.00,0.00,,0.00\r\n  32206,应交特种基金,,0.00,0.00,0.00,,0.00\r\n  32207,未分配利润,,0.00,\"525,691.80\",\"525,691.80\",,0.00\r\n  32208,应付股利,,0.00,\"77,486.97\",\"77,486.97\",,0.00\r\n  32209,补充流动资金,,0.00,0.00,0.00,,0.00\r\n  32210,公益金,,0.00,\"35,221.35\",\"35,221.35\",,0.00\r\n323,所得税,,0.00,0.00,0.00,,0.00\r\n401,生产成本,\"493,155.07\",,\"24,494,702.64\",\"24,567,112.18\",\"420,745.53\",\r\n  40101,原材料,\"493,155.07\",,\"16,161,996.09\",\"16,234,405.63\",\"420,745.53\",\r\n  40102,燃料,0.00,,\"117,021.67\",\"117,021.67\",0.00,\r\n  40103,动力,0.00,,\"323,485.66\",\"323,485.66\",0.00,\r\n  40104,工资及福利,0.00,,\"4,208,136.64\",\"4,208,136.64\",0.00,\r\n  40105,制造费用,0.00,,\"2,580,627.18\",\"2,580,627.18\",0.00,\r\n  40106,外加工,0.00,,\"1,103,435.40\",\"1,103,435.40\",0.00,\r\n405,制造费用,0.00,,\"2,587,396.29\",\"2,587,396.29\",0.00,\r\n  40501,工资,0.00,,\"107,435.00\",\"107,435.00\",0.00,\r\n  40502,福利费,0.00,,\"13,406.40\",\"13,406.40\",0.00,\r\n  40503,修理费,0.00,,\"205,329.96\",\"205,329.96\",0.00,\r\n  40504,折旧费,0.00,,\"299,346.32\",\"299,346.32\",0.00,\r\n  40505,办公费,0.00,,216.97,216.97,0.00,\r\n  40506,差旅费,0.00,,\"93,722.10\",\"93,722.10\",0.00,\r\n  40507,低耗品摊销,0.00,,\"157,392.36\",\"157,392.36\",0.00,\r\n  40508,劳动保护费,0.00,,\"362,639.57\",\"362,639.57\",0.00,\r\n  40509,运费,0.00,,\"80,305.50\",\"80,305.50\",0.00,\r\n  40510,其他,0.00,,\"693,775.46\",\"693,775.46\",0.00,\r\n  40511,劳动补助费,0.00,,\"229,055.00\",\"229,055.00\",0.00,\r\n  40512,水电费,0.00,,\"14,681.63\",\"14,681.63\",0.00,\r\n  40513,材料消耗,0.00,,\"330,090.02\",\"330,090.02\",0.00,\r\n501,产品销售收入,,0.00,\"27,321,884.00\",\"27,281,884.00\",,\"-40,000.00\"\r\n502,产品销售成本,0.00,,\"21,593,258.94\",\"21,623,258.94\",\"-30,000.00\",\r\n503,产品销售费用,0.00,,\"462,207.37\",\"462,207.37\",0.00,\r\n  50301,工资福利,0.00,,\"37,893.60\",\"37,893.60\",0.00,\r\n  50302,包装物,0.00,,\"159,960.12\",\"159,960.12\",0.00,\r\n  50303,技术转让费,0.00,,0.00,0.00,0.00,\r\n  50304,其他,0.00,,\"264,353.65\",\"264,353.65\",0.00,\r\n504,产品销售税金及附加,0.00,,\"226,756.72\",\"226,756.72\",0.00,\r\n511,其他业务收入,,0.00,\"352,876.84\",\"352,876.84\",,0.00\r\n  51101,材料销售,,0.00,\"68,759.89\",\"68,759.89\",,0.00\r\n  51102,废料销售,,0.00,\"1,336.88\",\"1,336.88\",,0.00\r\n  51103,固定资产出租,,0.00,\"231,733.00\",\"231,733.00\",,0.00\r\n  51104,运费包装物,,0.00,\"51,047.07\",\"51,047.07\",,0.00\r\n  51105,劳务收入,,0.00,0.00,0.00,,0.00\r\n512,其他业务支出,0.00,,\"427,498.96\",\"427,498.96\",0.00,\r\n  51201,材料成本,0.00,,\"40,165.44\",\"40,165.44\",0.00,\r\n  51202,废料成本,0.00,,0.00,0.00,0.00,\r\n  51203,固资出租成本,0.00,,\"13,614.53\",\"13,614.53\",0.00,\r\n  51204,运费船检及包装费,0.00,,\"373,718.99\",\"373,718.99\",0.00,\r\n521,管理费用,0.00,,\"5,062,107.62\",\"5,100,107.62\",\"-38,000.00\",\r\n  52101,工资,0.00,,\"857,125.00\",\"857,125.00\",0.00,\r\n  52102,福利费,0.00,,\"121,632.00\",\"121,632.00\",0.00,\r\n  52103,修理费,0.00,,\"212,411.02\",\"212,411.02\",0.00,\r\n  52104,折旧费,0.00,,\"168,153.23\",\"168,153.23\",0.00,\r\n  52105,办公费,0.00,,\"115,662.52\",\"115,662.52\",0.00,\r\n  52106,差旅费,0.00,,\"1,118,034.07\",\"1,118,034.07\",0.00,\r\n  52107,低耗品摊销,0.00,,\"68,285.69\",\"68,285.69\",0.00,\r\n  52108,劳动保护费,0.00,,\"87,599.23\",\"87,599.23\",0.00,\r\n  52109,运费,0.00,,\"15,502.68\",\"15,502.68\",0.00,\r\n  52110,其他,0.00,,\"771,266.08\",\"771,266.08\",0.00,\r\n  52111,劳动补助费,0.00,,0.00,0.00,0.00,\r\n  52112,业务招待费,0.00,,\"121,845.65\",\"121,845.65\",0.00,\r\n  52113,存货盘盈亏,0.00,,0.00,0.00,0.00,\r\n  52114,工会经费,0.00,,\"92,285.91\",\"92,285.91\",0.00,\r\n  52115,教育经费,0.00,,\"69,214.43\",\"69,214.43\",0.00,\r\n  52116,待业保险费,0.00,,\"87,457.16\",\"87,457.16\",0.00,\r\n  52117,船检费,0.00,,0.00,0.00,0.00,\r\n  52118,审计费,0.00,,0.00,0.00,0.00,\r\n  52119,诉讼费,0.00,,0.00,0.00,0.00,\r\n  52120,排污费,0.00,,0.00,0.00,0.00,\r\n  52121,绿化费,0.00,,0.00,0.00,0.00,\r\n  52122,税金,0.00,,\"12,769.92\",\"12,769.92\",0.00,\r\n  52123,坏账准备,0.00,,\"-1,690.47\",\"-1,690.47\",0.00,\r\n  52125,劳动保险费,0.00,,\"1,132,553.50\",\"1,132,553.50\",0.00,\r\n    5212501,退休金,0.00,,\"24,343.40\",\"24,343.40\",0.00,\r\n    5212502,医药费,0.00,,\"18,679.80\",\"18,679.80\",0.00,\r\n    5212503,补抚费,0.00,,\"6,000.00\",\"6,000.00\",0.00,\r\n    5212504,离休费,0.00,,0.00,0.00,0.00,\r\n    5212505,其他,0.00,,\"1,083,530.30\",\"1,083,530.30\",0.00,\r\n522,财务费用,0.00,,\"-117,478.15\",\"-117,478.15\",0.00,\r\n  52201,利息支出,0.00,,\"-117,478.15\",\"-117,478.15\",0.00,\r\n531,投资收益,,0.00,0.00,0.00,,0.00\r\n541,营业外收入,,0.00,\"396,044.26\",\"396,044.26\",,0.00\r\n  54101,固资盘盈净益,,0.00,277.76,277.76,,0.00\r\n  54102,罚款收入,,0.00,50.00,50.00,,0.00\r\n  54103,应付款收入,,0.00,\"2,258.09\",\"2,258.09\",,0.00\r\n  54104,其他,,0.00,\"72,787.88\",\"72,787.88\",,0.00\r\n  54105,军品免税收入,,0.00,\"320,670.53\",\"320,670.53\",,0.00\r\n542,营业外支出,0.00,,\"394,457.64\",\"356,457.64\",\"38,000.00\",\r\n  54201,固资盘亏净损,0.00,,0.00,0.00,0.00,\r\n  54202,赔偿违约金,0.00,,0.00,0.00,0.00,\r\n  54203,罚款支出,0.00,,\"59,000.00\",\"59,000.00\",0.00,\r\n  54204,其他,0.00,,\"335,457.64\",\"335,457.64\",0.00,\r\n";
        //var superData = $.csv.toArrays(allData);
        var tbData = [];
        //for (i = 0; i < superData.length; i++) {
        //    if (!superData[i][2]) {
        //        superData[i][2] = 0.00;
        //    }
        //    if (!superData[i][3]) {
        //        superData[i][3] = 0.00;
        //    }
        //    if (!superData[i][4]) {
        //        superData[i][4] = 0.00;
        //    }
        //    if (!superData[i][5]) {
        //        superData[i][5] = 0.00;
        //    }
        //    if (!superData[i][6]) {
        //        superData[i][6] = 0.00;
        //    }
        //    if (!superData[i][7]) {
        //        superData[i][7] = 0.00;
        //    }
        //    var record = {};
        //    record["id"] = i + 1;
        //    record["code"] = superData[i][0];
        //    record["name"] = superData[i][1];
        //    record["initdebit"] = superData[i][2];
        //    record["initcridet"] = superData[i][3];
        //    record["debit"] = superData[i][4];
        //    record["cridet"] = superData[i][5];
        //    record["lastdebit"] = superData[i][6];
        //    record["lastcridet"] = superData[i][7];

        //    tbData.push(record)
        //};
        //var test = new DevExpress.data.CustomStore({
        //    load: function (loadOptions) {

        //    }
        //});
        $scope.selectOptions = {
            dataSource: $scope.trialBalanceOptions,
            valueExpr: 'id',
            displayExpr: 'name',
            placeholder: 'column name'
        };
        var initGrid = function () {           
            var onRowPrepared = function (info) {
                if (info.rowType == 'header') {
                    //var row = '<tr class="dx-row dx-column-lines dx-header-row" role="row">'+
                    //    '<td></td><td><div dx-select-box="{dataSource: trialBalanceOptions,valueExpr: \'id\',displayExpr: \'name\',placeholder: \'Select a column name\'}"></div></td>' +
                    //    '<td><div dx-select-box="selectOptions"></div></td>'+
                    //    '<td><div dx-select-box="selectOptions"></div></td>'+
                    //     '<td><div dx-select-box="selectOptions"></div></td>'+
                    //    '<td><div dx-select-box="selectOptions"></div></td>'+
                    //     '<td><div dx-select-box="selectOptions"></div></td>'+
                    //    '<td><div dx-select-box="selectOptions"></div></td>'+
                    //     '<td><div dx-select-box="selectOptions"></div></td></tr>';

                    var row = $('<tr class="dx-row dx-column-lines dx-header-row" role="row"/>');
                    for (var i = 0; i < 9; i++) {
                        var td = $('<td/>');
                        if (i !== 0) {
                            $("<div/>").dxSelectBox($scope.selectOptions).appendTo(td);
                        }                        
                        td.appendTo(row);
                    }
                    info.rowElement.after(row);

                    //var row = $("#rowHeader").html();
                    //info.rowElement.before(row);
                }else if(info.rowType != 'header'&&(info.rowIndex%2))
                {
                    info.rowElement.addClass('dx-row-alt');
                }
                
            };
            var gridRow = $("#gridRow");           
            $scope.dataGridHeaderOptions = {
                showRowLines: true,
                rowAlternationEnabled: true,
                showBorders: true,
                dataSource: tbData,
                width:'100%',
                // rowTemplate: $("#gridRow"),
                onRowPrepared: onRowPrepared,
                columnAutoWidth: true,
                columns: [
                    { dataField: 'id',  caption: '', alignment: "left" },
                    { dataField: 'code', caption: '1', alignment: "left" },
                    { dataField: 'name', caption: '2', alignment: "left" },
                    { dataField: 'initdebit', caption: '3',  alignment: "left" },
                    { dataField: 'initcridet', caption: '4',  alignment: "left" },
                    { dataField: 'debit', caption: '5',  alignment: "left" },
                   { dataField: 'cridet', caption: '6',  alignment: "left" },
                   { dataField: 'lastdebit', caption: '7',  alignment: "left" },
                   { dataField: 'lastcridet', caption: '8',  alignment: "left" }

                ],              
                //loadPanel: {
                //    enabled: true
                //},
                scrolling: {
                    mode: "infinite"
                },
                sorting: {
                    mode: "none"
                }
                //columnChooser: {
                //    enabled: true,
                //    height: 150,
                //    width: 300,
                //    emptyPanelText: 'A place to hide the columns'
                //},
                //activeStateEnabled: true              
            };
        };
        (function () {
            $scope.showPanel = 2;            
            initGrid();
        })();
    }]);
vatModule.controller('devGridController', ['$log', '$scope','$translate',
    function ($log, $scope, $translate) {
        'use strict';
        var customers = [{
            "ID": 1,
            "CompanyName": "Super Mart of the West",
            "Street": "702 SW 8th Street",
            "City": "Bentonville",
            "StateID": 2,
            "Zipcode": 72716,
            "Phone": "(800) 555-2797",
            "Fax": "(800) 555-2171",
            "Website": "http://www.nowebsitesupermart.com"
        }, {
            "ID": 2,
            "CompanyName": "Electronics Depot",
            "Street": "2455 Paces Ferry Road NW",
            "City": "Atlanta",
            "StateID": 1,
            "Zipcode": 30339,
            "Phone": "(800) 595-3232",
            "Fax": "(800) 595-3231",
            "Website": "http://www.nowebsitedepot.com"
        }, {
            "ID": 3,
            "CompanyName": "K&S Music",
            "Street": "1000 Nicllet Mall",
            "City": "Minneapolis",
            "StateID": 7,
            "Zipcode": 55403,
            "Phone": "(612) 304-6073",
            "Fax": "(612) 304-6074",
            "Website": "http://www.nowebsitemusic.com"
        }, {
            "ID": 4,
            "CompanyName": "Tom's Club",
            "Street": "999 Lake Drive",
            "City": "Issaquah",
            "StateID": 6,
            "Zipcode": 98027,
            "Phone": "(800) 955-2292",
            "Fax": "(800) 955-2293",
            "Website": "http://www.nowebsitetomsclub.com"
        }, {
            "ID": 5,
            "CompanyName": "E-Mart",
            "Street": "3333 Beverly Rd",
            "City": "Hoffman EStateIDs",
            "StateID": 7,
            "Zipcode": 60179,
            "Phone": "(847) 286-2500",
            "Fax": "(847) 286-2501",
            "Website": "http://www.nowebsiteemart.com"
        }, {
            "ID": 6,
            "CompanyName": "Walters",
            "Street": "200 Wilmot Rd",
            "City": "Deerfield",
            "StateID": 3,
            "Zipcode": 60015,
            "Phone": "(847) 940-2500",
            "Fax": "(847) 940-2501",
            "Website": "http://www.nowebsitewalters.com"
        }, {
            "ID": 7,
            "CompanyName": "StereoShack",
            "Street": "400 Commerce S",
            "City": "Fort Worth",
            "StateID": 5,
            "Zipcode": 76102,
            "Phone": "(817) 820-0741",
            "Fax": "(817) 820-0742",
            "Website": "http://www.nowebsiteshack.com"
        }, {
            "ID": 8,
            "CompanyName": "Circuit Town",
            "Street": "2200 Kensington Court",
            "City": "Oak Brook",
            "StateID": 6,
            "Zipcode": 60523,
            "Phone": "(800) 955-2929",
            "Fax": "(800) 955-9392",
            "Website": "http://www.nowebsitecircuittown.com"
        }, {
            "ID": 9,
            "CompanyName": "Premier Buy",
            "Street": "7601 Penn Avenue South",
            "City": "Richfield",
            "StateID": 4,
            "Zipcode": 55423,
            "Phone": "(612) 291-1000",
            "Fax": "(612) 291-2001",
            "Website": "http://www.nowebsitepremierbuy.com"
        }, {
            "ID": 10,
            "CompanyName": "ElectrixMax",
            "Street": "263 Shuman Blvd",
            "City": "Naperville",
            "StateID": 2,
            "Zipcode": 60563,
            "Phone": "(630) 438-7800",
            "Fax": "(630) 438-7801",
            "Website": "http://www.nowebsiteelectrixmax.com"
        }, {
            "ID": 11,
            "CompanyName": "Video Emporium",
            "Street": "1201 Elm Street",
            "City": "Dallas",
            "StateID": 10,
            "Zipcode": 75270,
            "Phone": "(214) 854-3000",
            "Fax": "(214) 854-3001",
            "Website": "http://www.nowebsitevideoemporium.com"
        }, {
            "ID": 12,
            "CompanyName": "Screen Shop",
            "Street": "1000 Lowes Blvd",
            "City": "Mooresville",
            "StateID": 1,
            "Zipcode": 28117,
            "Phone": "(800) 445-6937",
            "Fax": "(800) 445-6938",
            "Website": "http://www.nowebsitescreenshop.com"
        }];
        var states = [{
            "ID": 1,
            "Name": "Alabama"
        }, {
            "ID": 2,
            "Name": "Alaska"
        }, {
            "ID": 3,
            "Name": "Arizona"
        }, {
            "ID": 4,
            "Name": "Arkansas"
        }, {
            "ID": 5,
            "Name": "California"
        }, {
            "ID": 6,
            "Name": "Colorado"
        }, {
            "ID": 7,
            "Name": "Connecticut"
        }, {
            "ID": 8,
            "Name": "Delaware"
        }, {
            "ID": 9,
            "Name": "District of Columbia"
        }, {
            "ID": 10,
            "Name": "Florida"
        }];
        var initGrid = function () {           
            $scope.dataGridOptions = {
                dataSource: customers,
                editing: {
                    mode: "row",
                    allowUpdating: true,
                    allowDeleting: true,
                    allowAdding: true
                },
                columns: [
                    { dataField: 'ID', visible: false },
                    {
                        dataField:'CompanyName',
                        caption: 'CompanyName',
                        cellTemplate: 'companyTemplate',
                        editCellTemplate: function (cellElement, cellInfo) {
                            var name = document.createElement("div");
                            cellElement.get(0).appendChild(name);
                            $(name).dxTextBox({
                                placeholder:'Company name',
                                valueChangeEvent: "keyup",
                                value:cellInfo.value,
                                onValueChanged: function (e) {                                  
                                    cellInfo.setValue(e.value);
                                }
                            });
                            var link = document.createElement("div");
                            cellElement.get(0).appendChild(link);
                            $(link).dxTextBox({
                                placeholder: 'Company link',
                                valueChangeEvent: "keyup",
                                value: cellInfo.data.Website,                                
                                onValueChanged: function (e) {
                                    //data.value.replace(/\s/g, "").toLowerCase()
                                    cellInfo.data.Website=e.value;
                                }
                            });
                        }
                    },
                    {
                        caption: 'Address',
                        alignment: 'center',
                        columns: ['Street', 'City',
                            {
                                dataField: 'StateID',
                                caption: 'State',
                                lookup: {
                                    dataSource: states,
                                    displayExpr: "Name",
                                    valueExpr: "ID"
                                }
                            }
                        ]
                    },
                    "Phone", "Fax"],
                paging: { pageSize: 10 },
                pager: {
                    showPageSizeSelector: true,
                    allowPageSized: [5, 10, 20],
                    showInfo: true
                },
                loadPanel: {
                    enabled: true
                },
                //scrolling: {
                //    mode: "virtual"
                //},
                columnChooser: {
                    enabled: true,
                    height: 150,
                    width: 300,
                    emptyPanelText: 'A place to hide the columns'
                },
                activeStateEnabled: true,
                bindingOptions: {
                    allowColumnReordering: 'allowColumnReordering',
                    columnAutoWidth: 'autoWidth',
                    allowColumnResizing: 'allowColumResizing'

                },
                onEditingStart: function (info) {
                    console.log(info);
                }
            };
        };

        (function () {
            $scope.showPanel = 1;
            $scope.autoWidth = true;
            $scope.allowColumnReordering = true;
            $scope.allowColumResizing = true;
            initGrid();
        })();
}]);
vatModule.controller('devTreeController', ['$log', '$scope','$translate',
    function ($log, $scope, $translate) {
        'use strict';
        var data = [
   {
       "ID": 1,
       "name": "Stores",
       "expanded": true,
       "selected":true
   },
   {
       "ID": "1_1",
       "categoryId": 1,
       "name": "Super Mart of the West",
       "expanded": true,
       "selected": true
   },
   {
       "ID": "1_1_1",
       "categoryId": "1_1",
       "name": "Video Players",
       "selected": true
   },
   {
       "ID": "1_1_1_1",
       "categoryId": "1_1_1",
       "name": "HD Video Player",
       "price": 220,
       "selected": true
   },
   {
       "ID": "1_1_1_2",
       "categoryId": "1_1_1",
       "name": "SuperHD Video Player",
       "price": 270,
       "selected": true
   },
   {
       "ID": "1_1_2",
       "categoryId": "1_1",
       "name": "Televisions",
       "expanded": true,
       "selected": true
   },
   {
       "ID": "1_1_2_1",
       "categoryId": "1_1_2",
       "name": "SuperLCD 42",
       "price": 1200,
       "selected": true
   },
   {
       "ID": "1_1_2_2",
       "categoryId": "1_1_2",
       "name": "SuperLED 42",
       "price": 1450,
       "selected": true
   },
   {
       "ID": "1_1_2_3",
       "categoryId": "1_1_2",
       "name": "SuperLED 50",
       "price": 1600,
       "selected": true
   },
   {
       "ID": "1_1_2_4",
       "categoryId": "1_1_2",
       "name": "SuperLCD 55",
       "price": 1750,
       "selected": true
   },
   {
       "ID": "1_1_2_5",
       "categoryId": "1_1_2",
       "name": "SuperLCD 70",
       "price": 4000,
       "selected": true
   },
   {
       "ID": "1_1_3",
       "categoryId": "1_1",
       "name": "Monitors",
       "selected": true
   },
   {
       "ID": "1_1_3_1",
       "categoryId": "1_1_3",
       "name": "19\"",
       "selected": true
   },
   {
       "ID": "1_1_3_1_1",
       "categoryId": "1_1_3_1",
       "name": "DesktopLCD 19",
       "price": 160,
       "selected": true
   },
   {
       "ID": "1_1_4",
       "categoryId": "1_1",
       "name": "Projectors",
       "selected": true
   },
   {
       "ID": "1_1_4_1",
       "categoryId": "1_1_4",
       "name": "Projector Plus",
       "price": 550,
       "selected": true
   },
   {
       "ID": "1_1_4_2",
       "categoryId": "1_1_4",
       "name": "Projector PlusHD",
       "price": 750,
       "selected": true
   }
        ];

        var data1 = [
  {
      "ID": 1,
      "name": "Stores",
      "expanded": true
  },
  {
      "ID": "1_1",
      "categoryId": 1,
      "name": "Super Mart of the West",
      "expanded": true
  },
  {
      "ID": "1_1_1",
      "categoryId": "1_1",
      "name": "Video Players"
  },
  {
      "ID": "1_1_1_1",
      "categoryId": "1_1_1",
      "name": "HD Video Player",
      "price": 220
  },
  {
      "ID": "1_1_1_2",
      "categoryId": "1_1_1",
      "name": "SuperHD Video Player",
      "price": 270
  },
  {
      "ID": "1_1_2",
      "categoryId": "1_1",
      "name": "Televisions",
      "expanded": true
  },
  {
      "ID": "1_1_2_1",
      "categoryId": "1_1_2",
      "name": "SuperLCD 42",
      "price": 1200
  },
  {
      "ID": "1_1_2_2",
      "categoryId": "1_1_2",
      "name": "SuperLED 42",
      "price": 1450
  },
  {
      "ID": "1_1_2_3",
      "categoryId": "1_1_2",
      "name": "SuperLED 50",
      "price": 1600
  },
  {
      "ID": "1_1_2_4",
      "categoryId": "1_1_2",
      "name": "SuperLCD 55",
      "price": 1750
  },
  {
      "ID": "1_1_2_5",
      "categoryId": "1_1_2",
      "name": "SuperLCD 70",
      "price": 4000
  },
  {
      "ID": "1_1_3",
      "categoryId": "1_1",
      "name": "Monitors"
  },
  {
      "ID": "1_1_3_1",
      "categoryId": "1_1_3",
      "name": "19\""
  },
  {
      "ID": "1_1_3_1_1",
      "categoryId": "1_1_3_1",
      "name": "DesktopLCD 19",
      "price": 160
  },
  {
      "ID": "1_1_4",
      "categoryId": "1_1",
      "name": "Projectors"
  },
  {
      "ID": "1_1_4_1",
      "categoryId": "1_1_4",
      "name": "Projector Plus",
      "price": 550
  },
  {
      "ID": "1_1_4_2",
      "categoryId": "1_1_4",
      "name": "Projector PlusHD",
      "price": 750
  }
        ];

        (function () {
            var treeView;

            var syncTreeViewSelection = function (treeView) {
                if (!treeView) return;

                if (!$scope.treeBoxValue) {
                    treeView.unselectAll();
                    return;
                }

                $scope.treeBoxValue.forEach(function (key) {
                    treeView.selectItem(key);
                });
            };

            $scope.treeBoxValue = _.pluck(data1, 'ID');

            $scope.treeBoxOptions = {
                bindingOptions: {
                    value: 'treeBoxValue'
                },
                valueExpr: "ID",
                displayExpr: "name",
                placeholder: "Select a value...",
                showClearButton: true,
                dataSource: data1,
                onValueChanged: function () {
                    syncTreeViewSelection(treeView);
                },
                treeView: {
                    dataSource: data1,
                    dataStructure: "plain",
                    keyExpr: "ID",
                    parentIdExpr: "categoryId",
                    displayExpr: "name",
                    selectByClick: true,
                    selectNodesRecursive: true,
                    showCheckBoxesMode: "selectAll",
                    selectionMode:true,
                    //bindingOptions: {
                    //    selectionMode: "selectionMode"
                    //},
                    onContentReady: function (e) {
                        treeView = e.component;
                        //console.log('onContentReady');
                        //console.log(treeView);
                        //var value = treeView.getSelectedNodesKeys();
                        //$scope.treeBoxValue = value;
                        syncTreeViewSelection(treeView);
                    },
                    onItemSelectionChanged: function (args) {
                        var value = args.component.getSelectedNodesKeys();
                        $scope.treeBoxValue = value;
                    }
                }
            };
        })();
}]);
vatModule.directive('devGrid', ['$log',
    function ($log) {
        'use strict';

        $log.debug('devGrid.ctor()...');
        return {
            restrict: 'E',
            templateUrl: '/app/vat/devExtremeDemo/devDemo.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'devGridController'
           // controller:'devGridHeaderController'
        }
    }]);

vatDongfengModule.controller('navBarController', ['$scope', '$rootScope', '$log', '$timeout', '$state', '$translate', 'projectService', 'SweetAlert', 'loginContext', 'vatSessionService', 'vatCommonService', 'application', 'enums', '$uibModal',
    function ($scope, $rootScope, $log, $timeout, $state, $translate, projectService, SweetAlert, loginContext, vatSessionService, vatCommonService, application, enums, $uibModal) {
        'use strict';
        $log.debug('navBarController.ctor()...');
        var baseDFFilePath = '/app/df/code/pages/';

        $scope.dateFormat = $translate.instant('dateFormat4YearMonth');
        $scope.showSubMenu = true;
        if (vatSessionService.project.name) {
            $scope.projectName = vatSessionService.project.name;
        } else {
            $scope.projectName = "普华永道上海税务(a1700000)";
        }

        $('#year').datepicker({
            format: 'yyyy年',
            weekStart: 1,
            autoclose: true,
            startView: 2,
            maxViewMode: 2,
            minViewMode: 2,
            forceParse: false,
            language: 'zh-CN'
        });

        $scope.selectedDate = new Date(vatSessionService.project.year, vatSessionService.month - 1, 1);
        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31, 23, 59, 59);

        var subStatusDto = {
            dispalyIndex: -1,
            name: '',
            isImported: false
        };

        var msgboxOptions = {
            title: $translate.instant('UnsavedChange'),
            text: $translate.instant('ComfirmIgnoreUnsavedChanges'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#e0301e",
            confirmButtonText: $translate.instant('ConfirmYes'),
            cancelButtonText: $translate.instant('ConfirmNo'),
            closeOnConfirm: true,
            closeOnCancel: true
        };

        $scope.changeDate = function () { };

        var dongfengGoUrl = function (src) {
            $log.debug('new page src:' + src);
            $('#dfiframe').attr("src", src);
        };

        $scope.uiHandling = function (menu) {

            $scope.selectedMenu = menu;
            $log.debug(menu);
            if ($scope.type === 1) {//递延所得税
                $scope.submenus = [
                    { text: '构成分析', title: "构成分析", src: '/app/df/code/pages/DFModleIndex.html' + '?_=' + Math.random(), icon: 'fa fa-bank' },
                    { text: '对未来现金流的影响分析', title: "对未来现金流的影响分析", src: '/app/df/code/pages/DFModleIndex2.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' },
                    { name: '变动分析', title: "变动分析", text: "变动分析", src: '/app/df/code/pages/DFModleIndex3.html' + '?_=' + Math.random(), icon: 'fa fa-list-ul' },
                    { name: '对当期利润的影响分析模型', title: "对当期利润的影响分析模型", permission: '02.001.009', text: "对当期利润的影响分析模型", icon: 'fa fa-file-text-o' }
                ];
                if (menu.fileName.indexOf('deferredTaxNEWWorkingPaper.html') > -1) {
                    $scope.setFrameHeight();
                }
                dongfengGoUrl(baseDFFilePath + menu.fileName);

                if (menu.num === 3) {
                    //选中submenu的第一个默认
                    $scope.dongfengGo($scope.submenus[0]);
                }
            } else if ($scope.type === 2) {//现金流
                $scope.hideSubMenu = false;

                if (menu.name == "税务预算") {
                    $scope.submenus = [
                        { text: '数据状态', src: baseDFFilePath + menu.fileName, icon: 'fa fa-bank' },
                        { text: '数据上传', src: baseDFFilePath + 'DFTaxBudgetUpload.htm' + '?_=' + Math.random(), icon: 'fa fa-upload', clickId: 'clickDataUpload' },
                        { text: '地产数据', src: baseDFFilePath + 'DFRealEstateData.html' + '?_=' + Math.random(), icon: 'fa fa-university', clickId: 'realEstateData' },
                        { text: '数据计算', src: baseDFFilePath + 'DFTaxBudgetCaculateSummary.htm' + '?_=' + Math.random(), icon: 'fa fa-calculator', clickId: 'clickDataCalculate' },
                        { text: '数据预览', src: baseDFFilePath + 'DFTaxBudgetView.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' }
                    ];
                } else if (menu.name == "实交税额") {
                    $scope.submenus = [
                        { text: '数据状态', src: baseDFFilePath + menu.fileName, icon: 'fa fa-bank' },
                        { text: '数据处理', src: baseDFFilePath + "DFTaxPaymentProcess.html", icon: 'fa fa-cogs', clickId: 'taxPaymentProcess'  },
                        { text: '数据分析', src: baseDFFilePath + 'actualPayDashboard.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' },
                        { text: '数据预览', src: baseDFFilePath + 'DFTaxPaymentView.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' },
                    ];
                } else if (menu.name == "预实对比") {
                    $scope.submenus = [
                        { text: '数据处理', src: baseDFFilePath + "DFPreRealContrastProcess.html", icon: 'fa fa-cogs', clickId: 'taxPaymentProcess' },
                        { text: '数据分析', src: baseDFFilePath + 'DFPreRealContrastDashboard.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' },
                    ];
                }else if (menu.name == "税收返还") {
                    $scope.submenus = [
                        { text: '数据状态', src: baseDFFilePath + menu.fileName, icon: 'fa fa-bank' },
                        { text: '数据处理', src: baseDFFilePath + "DFTaxReturnProcess.html", icon: 'fa fa-cogs' },
                        { text: '数据预览', src: baseDFFilePath + 'DFTaxReturnView.html' + '?_=' + Math.random(), icon: 'fa fa-align-left' }];
                } else {
                    $scope.submenus = [{ text: '数据导入', src: baseDFFilePath + menu.fileName, icon: 'fa fa-bank' }];
                    $scope.hideSubMenu = true;
                }

                //if (menu.fileName) {
                $scope.dongfengGo($scope.submenus[0]);
                //}
            } else if ($scope.type === 3) { //数据统计
                
            }

        };

        var initMenu = function () {
            if ($scope.type === 1) { //递延所得税
                $('.vat-import-menu').show();
                $scope.serviceTitle = $translate.instant('DeferrIncomeTitle');
                $scope.menus = [{
                    name: '数据导入', num: 1, permission: '02.001', url: '#/vat/importData/balanceSheet', fileName: 'deferredTaxNEW.html' + '?_=' + Math.random()
                },
                { name: '数据核算', num: 2, permission: '02.002', url: '#/vat/previewData/balanceSheet', fileName: 'deferredTaxNEWWorkingPaper.html' + '?_=' + Math.random() },
                { name: '数据分析', num: 3, permission: '02.003', url: '#/vat/previewData/balanceSheet', fileName: 'DFModleIndex.html' + '?_=' + Math.random() },
                //{ name: '变动分析', num: 4, permission: '02.003', url: '#/vat/previewData/balanceSheet', fileName: 'DFModleIndex3.html' + '?_=' + Math.random() }
                ];
                //默认选中第一个
            } else if ($scope.type === 2) { //现金流
                $('.vat-import-menu').show();
                $scope.menus = [
                    { name: '税务预算', num: 1, permission: '02.001', url: '#', fileName: 'DFTaxActualStatus.html' + '?_=' + Math.random() },
                    { name: '实交税额', num: 2, permission: '02.002', url: '#', fileName: 'DFTaxPaymentStatus.html' + '?_=' + Math.random() },
                    { name: '预实对比', num: 3, permission: '02.003', url: '#', fileName: 'DFPreRealContrast.html' + '?_=' + Math.random() },
                    //{ name: '税额模拟', num: 4, permission: '02.004', url: '#', fileName: 'DFTaxAmountSimulation.html' + '?_=' + Math.random() },
                    { name: '税收返还', num: 4, permission: '02.005', url: '#', fileName: 'DFTaxReturnStatus.html' + '?_=' + Math.random() }
                ];
            } else if ($scope.type === 3) { //现金流 
                $('.vat-import-menu').hide();
                setTimeout(function(){
                    dongfengGoUrl(baseDFFilePath + 'DataSummary.html');
                },1000);
                return false;
            } else if ($scope.type === 4) { //现金流 
                $('.vat-import-menu').hide();
                setTimeout(function(){
                    dongfengGoUrl(baseDFFilePath + 'GlobalSearchResult.html');
                },1000);
                return false;
            }

            $scope.selectedMenu = $scope.menus[0];
            $timeout(function () {
                $scope.uiHandling($scope.menus[0]);
            }, 100);

            initTreeDrop();
        };

        $scope.orglist = [
             { "ID": 1, "name": "东风汽车有限公司", "expanded": true, "status": "已核算" },
             { "ID": "1_1", "categoryId": 1, "name": "东风汽车零部件（集团）有限公司", "expanded": true, "status": "未开始" },
             { "ID": "1_1_1", "categoryId": '1_1', "name": "东风贝洱热系统有限公司", "expanded": true, "status": "已导入" },
             { "ID": "1_1_2", "categoryId": '1_1', "name": "东风汽车紧固件有限公司", "expanded": true, "status": "已核算" },
             { "ID": "1_1_3", "categoryId": '1_1', "name": "上海弗列加滤清器有限公司", "expanded": true, "status": "已提交" },
             { "ID": "1_1_4", "categoryId": '1_1', "name": "东风精密铸造有限公司", "expanded": true, "status": "已分析" },
             { "ID": "1_2", "categoryId": 1, "name": "东风日产乘用车公司", "expanded": true, "status": "未开始" },
             { "ID": "1_2_1", "categoryId": '1_2', "name": "东风风神汽车有限公司", "expanded": true, "status": "已导入" },
             { "ID": "1_2_2", "categoryId": '1_2', "name": "东风日产发动机分公司", "expanded": true, "status": "已提交" },
             { "ID": "1_3", "categoryId": 1, "name": "东风汽车有限公司装备公司", "expanded": true, "status": "未开始" },
             { "ID": "1_4", "categoryId": 1, "name": "东风英菲尼迪有限公司", "expanded": true, "status": "未开始" },
        ];

        var initTreeDrop = function () {
            var dropDownTree = $("#org-treebox").dxDropDownBox({
                value: [1],
                valueExpr: "ID",
                displayExpr: "name",
                placeholder: "组织单元",
                showClearButton: true,
                dataSource: $scope.orglist,
                contentTemplate: function (e) {
                    var value = e.component.option("value"),
                        $treeView = $("<div>").dxTreeView({
                            dataSource: e.component.option("dataSource"),
                            dataStructure: "plain",
                            keyExpr: "ID",
                            parentIdExpr: "categoryId",
                            selectionMode: "single",
                            displayExpr: "name",
                            selectByClick: true,
                            onContentReady: function (args) {
                                syncTreeViewSelection(args.component, value);
                            },
                            selectNodesRecursive: false,
                            onItemSelectionChanged: function (args) {
                                var value = args.component.getSelectedNodesKeys();

                                e.component.option("value", value);
                                
                            }
                        });

                    treeView = $treeView.dxTreeView("instance");

                    e.component.on("valueChanged", function (args) {
                        var value = args.value;
                        syncTreeViewSelection(treeView, value);
                        dropDownTree.dxDropDownBox("instance").close();
                    });

                    return $treeView;
                }
            });

        };

        var showAccountingStatusModal = function () {
            var dropDownTree = $("#accounting-status-org-treebox").dxDropDownBox({
                value: [1],
                valueExpr: "ID",
                displayExpr: "name",
                placeholder: "组织单元",
                showClearButton: true,
                dataSource: $scope.orglist,
                contentTemplate: function (e) {
                    var value = e.component.option("value"),
                        $treeView = $("<div>").dxTreeView({
                            dataSource: e.component.option("dataSource"),
                            dataStructure: "plain",
                            keyExpr: "ID",
                            parentIdExpr: "categoryId",
                            selectionMode: "single",
                            displayExpr: "name",
                            selectByClick: true,
                            onContentReady: function (args) {
                                syncTreeViewSelection(args.component, value);
                            },
                            selectNodesRecursive: false,
                            onItemSelectionChanged: function (args) {
                                var value = args.component.getSelectedNodesKeys();

                                e.component.option("value", value);
                            }
                        });

                    accountingStatusTreeView = $treeView.dxTreeView("instance");

                    e.component.on("valueChanged", function (args) {
                        var value = args.value;
                        syncTreeViewSelection(accountingStatusTreeView, value);
                        dropDownTree.dxDropDownBox("instance").close();
                    });

                    return $treeView;
                }
            });
            $("#accountingStatusModal").modal('show');
        };

        var treeView, accountingStatusTreeView, dataGrid;
        var syncTreeViewSelection = function (treeView, value) {
            if (!value) {
                treeView.unselectAll();
                return;
            }

            value.forEach(function (key) {
                treeView.selectItem(key);
            });
        };

        $scope.$on(application.events.showSubMenu, function (event, data) {
            if (data) {
                $scope.showSubMenu = data.show;
            }
        });

        $scope.dongfengGo = function (menu) {
            parent.PWC.simulateProgress();
            $log.debug('new page src:' + menu.src);
            $scope.selectedSubMenu = menu;
            $('#dfiframe').attr("src", menu.src);
        };

        (function initialize() {
            $log.debug("nav-bar-crtl.js initialize() ");
            $scope.displaySubStatus = false;//导入子状态是否显示

            $rootScope.$on('statusChanged', function (event, args) {
                $log.debug("receive statusChanged");
                $log.debug(args.status);
                setLayoutStatusTitle(args.status);
            });

            if ($scope.type !== 5) {
                initMenu();
            }
            else {
                $timeout(function () {
                    $('#dfiframe').attr("src", '/app/df/code/pages/ETaxAudit.html');
                }, 500);
               
            }
            $scope.hideSubMenu = false;

            $timeout(function () {
                $scope.setFrameHeight();
            }, 500);
            
            $log.debug('dongfeng Type:' + $scope.type);

            $scope.showAccountingStatusModal = showAccountingStatusModal;
        })();
    }]);

vatDongfengModule.directive('dongfengNavBar', ['$log', 'region', 'enums',
function ($log, region, enums) {
    'use strict';

    $log.debug('dongfengNavBar.ctor()...');

    return {
        restrict: 'E',
        templateUrl: '/app/vat/dongfengWrapper/nav-bar/nav-bar.html' + '?_=' + Math.random(),
        replace: true,
        scope: {
            type: '='
        },
        controller: 'navBarController',
        link: function ($scope, $element, $attr) {

            $scope.setFrameHeight = function () {
                var pageHeight = $(window).height();
                if ($scope.type !== 5) {
                    $('#dfiframe').css('height', (pageHeight - 120) + 'px')
                    if ($(window.frames["dfiframe"].document).find("#spreadjsDYS").length > 0) {
                        $(window.frames["dfiframe"].document).find("#spreadjsDYS").css('height', (pageHeight - 180) + 'px');
                        $(window.frames["dfiframe"].document).find("#ss").css('height', (pageHeight - 180) + 'px');
                        $(window.frames["dfiframe"].document).find('#page-wrapper').css('min-height', (pageHeight - 120) + 'px');
                    }
                }
                else
                {
                    $('#dfiframe').css('height', (pageHeight) + 'px');
                }
            };

            var ele = $(".datepicker");
            ele.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                viewMode: 1,
                minViewMode: 1,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: false,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            }).on('changeDate', function (e) {
                $scope.changeDate(e);
            });
            ele.datepicker("setDate", $scope.selectedDate);
            $scope.elePicker = ele;

            $scope.menuStates = enums.vatMenuStates;
            $scope.menuState = enums.vatMenuStates.expanded;

            // Click to collapse the top menu
            // Param collapseMenu should be 1 to collapse, and 2 to expand.
            // 0: Expanded; 1: Collapsing, 2: Expanding, 3: Collapsed
            $scope.collapseMenu = function (collapseMenu) {
                $scope.menuState = collapseMenu;
            };

            // Handle css for top menu while collapse animation ended
            $scope.headerAnimationEnd = function ($event) {
                // Here we have to add class `collapsed` with JQuery grammar, because we want
                // it work immediately.
                if ($scope.menuState === enums.vatMenuStates.collapsing) {
                    angular.element('.vat-header').addClass('collapsed');
                }

                $scope.$apply(function () {
                    if ($scope.menuState === enums.vatMenuStates.collapsing) {
                        $scope.menuState = enums.vatMenuStates.collapsed;
                    }
                    else if ($scope.menuState === enums.vatMenuStates.expanding) {
                        $scope.menuState = enums.vatMenuStates.expanded;
                    }
                });
            }

            // Repaint spreadJS while spreadJS control expanded already
            $scope.contentAnimationEnd = function ($event) {
                $scope.$broadcast(enums.vatEvent.layoutChanged);
            };

            $scope.hideLeftSubMenus = function () {
                var iframeid = document.getElementById("dfiframe"); //iframe id

                var obj = iframeid.contentWindow;
                var ifmObj = obj.document.getElementById("page-wrapper");
            };

            $(window).on('resize', function () {
                $scope.setFrameHeight();
            });
        }
    };
}
]);
vatDongfengModule.controller('wrapperController', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval',
    function ($scope, $log, $translate, $timeout, $q, $interval) {
        'use strict';

        $scope.test = function () {
            $("#if").attr("src", "/app/df/code/pages/DFTaxBudgetProcess.html");
        };

        $scope.test1 = function () {
            $("#if").attr("src", "/app/df/code/pages/InventoryFallingPrice.html");
        };

        //开始
        (function initialize() {
            $log.debug('wrapperController.ctor()...');
            

        })();
    }
]);
vatDongfengModule.directive('dongfengWrapper', ['$log',
    function ($log) {
        'use strict';
        $log.debug('wrapperController.ctor()...');
       

        return {
            restrict: 'E',
            templateUrl: '/app/vat/dongfengWrapper/wrapper/wrapper.html' + '?_=' + Math.random(),
            scope: {
                type:"="
            },
            controller: 'wrapperController',
            link: function (scope, element) {
                 
            }
        };

    }
]);
vatModule.controller('ProductItemImportController', ['$scope', '$log', 'loginContext', '$translate', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', 'vatImportService', '$timeout', '$q', 'enums', 'uiGridConstants', '$interval', 'vatSessionService', 'vatOperationLogService', 'projectService', 'vatCommonService', 'productService',
function ($scope, $log, loginContext, $translate, apiInterceptor, Upload, dataImportService, SweetAlert, vatImportService, $timeout, $q, enums, uiGridConstants, $interval, vatSessionService, vatOperationLogService, projectService, vatCommonService, productService) {
    'use strict';

    var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
    var successCount = 0;
    $scope.chunkSize = 100000;
    var resumable = true;
    $scope.columnNum = 0;
    //从页面顶部的选择月份获取月份跟年份
    var curPeriod = vatSessionService.month;
    var curYear = vatSessionService.project.year;
    var projectID = vatSessionService.project.id;
    var projectDbName = vatSessionService.project.dbName;
    $scope.showImportTable = false;//是否显示导入table
    $scope.showInitTable = false;//是否显示初始数据ui-grid
    $scope.showErrorTable = false;//是否显示错误信息列表

    //写日志
    //导入方式
    $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 };
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    $scope.period = vatSessionService.month;
    $scope.moduleid = enums.vatModuleEnum.Import_JournalEntry;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        OperationObject: $translate.instant('JournalEntryTitle'),
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.period,
    };

    var validationErrorType = {
        ColumnsMapErrorType: $translate.instant('ColumnsMapErrorType'),
        JournalEntryVIDEmptyErrorType: $translate.instant('JournalEntryVIDEmptyErrorType'),
        JournalEntryGroupEmptyErrorType: $translate.instant('JournalEntryGroupEmptyErrorType'),
        JournalEntryItemIDEmptyErrorType: $translate.instant('JournalEntryItemIDEmptyErrorType'),
        JournalEntryAcctCodeEmptyErrorType: $translate.instant('JournalEntryAcctCodeEmptyErrorType'),
        JournalEntryVoucherDateEmptyErrorType: $translate.instant('JournalEntryVoucherDateEmptyErrorType'),
        JournalEntryDateFormatErrorType: $translate.instant('JournalEntryDateFormatErrorType'),
        JournalEntryAmountErrorType: $translate.instant('JournalEntryAmountErrorType'),
        JournalEntryItemIDFormatErrorType: $translate.instant('JournalEntryItemIDFormatErrorType'),
        JournalEntryPeriodFormatErrorType: $translate.instant('JournalEntryPeriodFormatErrorType'),
        NumOutRangeErrorType: $translate.instant('NumOutRangeErrorType'),
        OutputStringLengthType: $translate.instant('OutputStringLengthType'),
        StartRowError: $translate.instant('StartRowError')
    };

    //初始化列数据
    var initColumns = function () {
        //初始化进项发票汇总表列名（包括请选择列）
        $scope.journalEntryColumns = [
            $translate.instant('PleaseSelectColumn'),
            $translate.instant('JournalPZRQ'),
            $translate.instant('JournalPZLX'),
            $translate.instant('JournalPZH'),
            $translate.instant('JournalFLH'),
            $translate.instant('JournalQJ'),
            $translate.instant('JournalKMDM'),
            $translate.instant('JournalZY'),
            $translate.instant('JournalJFJE'),
            $translate.instant('JournalDFJE'),
            $translate.instant('JournalKHDM')
        ];

        $scope.initJournalEntryColumnsIndex = _.range(1, $scope.journalEntryColumns.length);

        //序时账所有列
        $scope.journalEntryAllColumns = [
           $translate.instant('JournalPZRQ'),
           $translate.instant('JournalPZLX'),
           $translate.instant('JournalPZH'),
           $translate.instant('JournalFLH'),
           $translate.instant('JournalQJ'),
           $translate.instant('JournalKMDM'),
           $translate.instant('JournalZY'),
           $translate.instant('JournalJFJE'),
           $translate.instant('JournalDFJE'),
           $translate.instant('JournalKHDM')
        ];

        //必须进行map的列
        $scope.mustMappingTotalColumns = [
            $translate.instant('JournalPZRQ'),
            $translate.instant('JournalPZLX'),
            $translate.instant('JournalPZH'),
            $translate.instant('JournalFLH'),
            $translate.instant('JournalKMDM'),
            $translate.instant('JournalJFJE'),
            $translate.instant('JournalDFJE'),
            $translate.instant('JournalKHDM')
        ];
    };

    //从数据库中load数据，如果有，则页面导入按钮为覆盖导入或追加导入，否则为导入按钮
    var loadJournalEntryDataFromDB = function () {
        productService.getProductItemList().success(function (data) {
            if (data) {
                $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
                var index = 1;
                data.forEach(function (v) {
                    v.index = index++;
                });

                $scope.initJournalEntryList = data;
                $scope.gridOptionsJournalEntry.data = data;
                //当数据库中数据>=0时，就显示初始化数据ui-grid，
                //但是需要当数据库中数据大于0时才不显示导入按钮，而显示覆盖导入和追加导入按钮
                if (data.length >= 0) {
                    if (data.length > 0) {
                        $scope.isShowImportTotalBtn = false;
                    }
                    $scope.showInitTable = true;
                    $scope.showImportTable = false;
                }

                if (data && data.length > 0) {
                    $scope.gridOptionsJournalEntry.columnDefs = [
                        { name: '产品编号', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetCode}}<span></div>' },
                        { name: '产品名称', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetName}}<span></div>' },
                        { name: '科目代号', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctCode}}<span></div>' },
                        { name: '科目名称', width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctName}}<span></div>' },
                        { name: '科目类别', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctClass}}<span></div>' },
                        { name: '科目性质', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctAttr}}<span></div>' },
                        { name: '卖出金额汇总', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fcjje}}<span></div>' },
                        { name: '计税基数余额', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.bjsjzye}}<span></div>' },
                        { name: '应税状态', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fyszt}}<span></div>' }
                    ];
                }
                else {
                    $scope.gridOptionsJournalEntry.columnDefs = [
                       { name: '产品编号', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetCode}}<span></div>' },
                       { name: '产品名称', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetName}}<span></div>' },
                       { name: '科目代号', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctCode}}<span></div>' },
                       { name: '科目名称', width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctName}}<span></div>' },
                       { name: '科目类别', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctClass}}<span></div>' },
                       { name: '科目性质', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctAttr}}<span></div>' },
                       { name: '卖出金额汇总', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fcjje}}<span></div>' },
                       { name: '计税基数余额', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.bjsjzye}}<span></div>' },
                       { name: '应税状态', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fyszt}}<span></div>' }
                    ];
                }
            }
        });
    };

    //序时账选择列名事件
    //parentIndex：当前列号
    //index：下拉列表中选项的序号
    var mappingColumn = function (parentIndex, index, colName) {
        if (colName) {

            var oldColumn = $scope.selectedColumnMap[parentIndex];
            var newColumn = $scope.journalEntryColumns[index];

            //如果新的选择项与老的选择项一致，则不进行操作
            if (oldColumn === newColumn) {
                return;
            }
            else {
                $scope.selectedColumnMap[parentIndex] = colName;

                if (colName !== $translate.instant('PleaseSelectColumn')) {
                    //如果当前选择的不是"请选择列名",则将选项从数组中移除
                    $scope.journalEntryColumns.splice(index, 1);

                    if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                        //将老的选项追加到选项列表中
                        $scope.journalEntryColumns.push(oldColumn);
                    }
                }
                else {
                    //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                    if (oldColumn) {
                        $scope.journalEntryColumns.push(oldColumn);
                    }
                }
            }
        }
        //$log.debug($scope.selectedColumnMap);
    };

    //设置上传文件的文件名
    var updateJournalEntryFileName = function (newValue) {
        $scope.fileName = newValue.name;
    };

    var token = $('input[name="__RequestVerificationToken"]').val();
    //上传文件
    var doUploadJournalEntryFile = function (file) {
        if (file) {
            var arr = file.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.initJournalEntryList = [];
            $scope.gridOptionsJournalEntry.data = [];
            successCount = 0;
            if (!file.$error) {
                var tempFileName = PWC.newGuid() + '.dat';
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        filename: file.name,
                        tempFileName: tempFileName,
                        file: file
                    },
                    resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(uploadJournalEntrySuccess);
            }
        }
    };

    //上传成功后执行函数
    var uploadJournalEntrySuccess = function (resp) {
        console.log(resp);
        successCount++;
        if (successCount === 1) {
            $scope.tempFileName = resp.data;
            //初始化到excel文件的第一个sheet
            changeJournalEntrySheet(0);
        }
    };

    //初始化需要展示的sheet
    var changeJournalEntrySheet = function (selectedSheet) {
        var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
            return num.name === selectedSheet.name;
        })
        $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
        refreshJournalEntryTable();
    };

    //重新load页面上的table
    var refreshJournalEntryTable = function () {
        //在切换显示页面导入数据时，直接设置初始化数据ui-grid表不可见，错误信息不可见
        //导入数据表格可见
        $scope.showImportTable = true;
        $scope.showErrorTable = false;
        $scope.showInitTable = false;

        if (_.isString($scope.tempFileName)) {
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            $scope.columnNum = 0;
            $scope.selectedColumnMap = [];
            vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, $scope.sheetInfo.topRowNumber).success(function (data) {

                //将导入文件的sheet赋值到数组
                $scope.sheetData = data;
                //加入index序号
                var index = 1;
                data.dataList.forEach(function (v) {
                    v.index = index++;
                });
                var sheetNameObjectArray = [];
                data.sheetNameList.forEach(function (v) {
                    sheetNameObjectArray.push({ 'name': v });
                });
                $scope.sheetData.sheetNameList = sheetNameObjectArray;

                $scope.columnNum = data.dataList[0] ? data.dataList[0].length : $scope.columnNum;
                $scope.firstDataRow = data.dataList[0];
                $scope.startRowList = _.range(data.lastRowIndex);
                $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                initColumns();
                vatSessionService.dataChanged = true; //设置为true表示在切换页面前数据有变更, 需要提示

                if (data & data.result === false) {
                    SweetAlert.warning(data.resultMsg);
                    return;
                }
            });
        }
    };


    //对导入数据进行验证(前端)
    var FrontEndValidJournalEntryData = function (journalEntryList) {
        //2:验证关键字段不为空（凭证号，凭证类型，分录号，科目代码）
        //3:验证日期、金额格式、期间格式、分录号格式是否正确
        if (!KeyColumnsEmptyValid(journalEntryList)) {
            return;
        }

        //4:所有验证都通过后，筛选符合期间条件的数据进库
        FilterPeriodData(journalEntryList);

    };

    //1.判断是否有没有map的必须列和起始行输入格式是否正确
    var ColumnsMapCheck = function () {
        var result = true;
        var notMappedColumns = '';
        if ($scope.selectedColumnMap.length >= 0) {
            var count1 = 0;
            $scope.mustMappingTotalColumns.forEach(function (m) {
                if (m !== $translate.instant('PleaseSelectColumn')) {
                    if ($.inArray(m, $scope.selectedColumnMap) < 0) {
                        notMappedColumns += m + ',';
                        count1++;
                    }
                }
            });
            if (count1) {
                result = false;
                //加入到错误列表中
                $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.ColumnsMapErrorType,
                        'errorCount': count1,
                        'errorContent': $translate.instant('ColumnsMapErrorMsg').formatObj({ columns: notMappedColumns.substring(0, notMappedColumns.length - 1) })
                    });
            }
        }
        //2:判断起始行输入框输入内容是否合理
        var startNumberCheckMsg = '';
        var startRowNum = $('#StartRowNum').val();
        if (startRowNum === '') {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
        }
        else if (parseInt(startRowNum) > $scope.sheetData.dataList.length) {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
        }
        return result;
    };

    //2.验证关键字段不为空（凭证号，凭证类型，分录号，科目代码）
    //3.验证日期、金额格式、期间格式、分录号格式是否正确
    var KeyColumnsEmptyValid = function (journalEntryList) {
        var result = true;
        //#region 定义错误信息

        //凭证号为空
        var VIDEmptyCheckMsg = '';
        var VIDEmptyCheckCount = 0;
        //凭证类型为空
        var GroupEmptyCheckMsg = '';
        var GroupEmptyCheckCount = 0;
        //分录号为空
        var ItemIDEmptyCheckMsg = '';
        var ItemIDEmptyCheckCount = 0;
        //科目代码为空
        var AcctCodeEmptyCheckMsg = '';
        var AcctCodeEmptyCheckCount = 0;
        //验证凭证日期为空
        var VoucherDateEmptyErrorMsg = '';
        var VoucherDateEmptyErrorCount = 0;

        //验证凭证日期格式错误
        var VourcharDateFormatErrorMsg = '';
        var VourcharDateFormatErrorCount = 0;

        //验证借方金额、贷方金额格式错误
        var AmountFormatErrorMsg = '';
        var AmountFormatErrorCount = 0;

        //验证期间是否是正整数
        var PeriodFormatErrorMsg = '';
        var PeriodFormatErrorCount = 0;

        //验证分录号是否为正整数
        var ItemIDFormatErrorMsg = '';
        var ItemIDFormatErrorCount = 0;

        //数据范围超出范围
        var numOutRangeCheckMsg = '';
        var numOutRangeCheckCount = 0;

        //字符长度过长验证
        var stringOverLengthCheckMsg = '';
        var stringOverLengthCheckCount = 0;

        //#endregion

        //#region 验证错误信息
        journalEntryList.forEach(function (m) {
            var curRowInfo = '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' +
                            $translate.instant('JournalPZH') + ':' + m.VID + ',' +
                            $translate.instant('JournalPZLX') + ':' + m.Group + ',' +
                            $translate.instant('JournalFLH') + '：' + m.ItemID + ';<br />';
            //凭证号为空
            if (PWC.isNullOrEmpty(m.VID)) {
                VIDEmptyCheckCount++;
                VIDEmptyCheckMsg += curRowInfo;
            }
            else {
                //如果凭证号超过50个字符
                if (m.VID.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalPZH') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //凭证类型为空
            if (PWC.isNullOrEmpty(m.Group)) {
                GroupEmptyCheckCount++;
                GroupEmptyCheckMsg += curRowInfo;
            }
            else {
                //如果凭证类型超过50个字符
                if (m.Group.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalPZLX') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //分录号为空
            if (PWC.isNullOrEmpty(m.ItemID)) {
                ItemIDEmptyCheckCount++;
                ItemIDEmptyCheckMsg += curRowInfo;
            }
            else {
                //如果分录号超过50个字符
                if (m.ItemID.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalFLH') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //科目代码为空
            if (PWC.isNullOrEmpty(m.AcctCode)) {
                AcctCodeEmptyCheckCount++;
                AcctCodeEmptyCheckMsg += curRowInfo;
            }
            else {
                //如果科目代码超过50个字符
                if (m.AcctCode.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalKMDM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //凭证日期为空
            if (PWC.isNullOrEmpty(m.Date)) {
                VoucherDateEmptyErrorCount++;
                VoucherDateEmptyErrorMsg += curRowInfo;
            }
            else {
                //凭证日期格式错误
                if (!PWC.checkDate(m.Date)) {
                    VourcharDateFormatErrorMsg += curRowInfo;
                    VourcharDateFormatErrorCount++;
                }
            }

            //验证金额
            if (isNaN(parseFloat(m.Debit)) || isNaN(parseFloat(m.Credit))) {
                AmountFormatErrorMsg += curRowInfo;
                AmountFormatErrorCount++;
            }
            else {
                //如果在规定的数值范围外，则提示错误
                if (parseFloat(m.Debit) < constant.startNum || parseFloat(m.Debit) > constant.endNum) {
                    numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalJFJE') + $translate.instant('NumOverLengthMsg') + '<br />';
                    numOutRangeCheckCount++;
                }
                else {
                    m.Debit = PWC.round(m.Debit, 2);
                }
                //如果在规定的数值范围外，则提示错误
                if (parseFloat(m.Credit) < constant.startNum || parseFloat(m.Credit) > constant.endNum) {
                    numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalDFJE') + $translate.instant('NumOverLengthMsg') + '<br />';
                    numOutRangeCheckCount++;
                }
                else {
                    m.Credit = PWC.round(m.Credit, 2);
                }
            }

            //验证期间为正整数
            if (!PWC.isNullOrEmpty(m.Period)) {
                if (!PWC.isPositiveInteger(m.Period)) {
                    PeriodFormatErrorMsg += curRowInfo;
                    PeriodFormatErrorCount++;
                }
                else {
                    if (m.Period < 1 || m.Period > 12) {
                        numOutRangeCheckCount++;
                        numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalQJ') + $translate.instant('PeriodOverLengthMsg') + ';<br />';
                    }
                }
            }

            //验证客户代码不能超过50个字符
            if (!PWC.isNullOrEmpty(m.CustomerCode) && m.CustomerCode.length > constant.validateLength.StringLength_50) {
                stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalKHDM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                stringOverLengthCheckCount++;
            }

            //摘要不能超过200个字符
            if (!PWC.isNullOrEmpty(m.Summary) && m.Summary.length > constant.validateLength.StringLength_200) {
                stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('JournalZY') + $translate.instant('OutputStringLengthMsg_200') + ';<br />';
                stringOverLengthCheckCount++;
            }
        });
        //#endregion 

        //#region 添加错误信息到错误列表

        //push凭证号空信息到错误列表
        if (VIDEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryVIDEmptyErrorType,
                    'errorCount': VIDEmptyCheckCount,
                    'errorContent': VIDEmptyCheckMsg
                });
        }
        if (GroupEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryGroupEmptyErrorType,
                    'errorCount': GroupEmptyCheckCount,
                    'errorContent': GroupEmptyCheckMsg
                });
        }
        if (ItemIDEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryItemIDEmptyErrorType,
                    'errorCount': ItemIDEmptyCheckCount,
                    'errorContent': ItemIDEmptyCheckMsg
                });
        }
        if (AcctCodeEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryAcctCodeEmptyErrorType,
                    'errorCount': AcctCodeEmptyCheckCount,
                    'errorContent': AcctCodeEmptyCheckMsg
                });
        }
        if (VoucherDateEmptyErrorCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.JournalEntryVoucherDateEmptyErrorType,
                   'errorCount': VoucherDateEmptyErrorCount,
                   'errorContent': VoucherDateEmptyErrorMsg
               });
        }
        if (VourcharDateFormatErrorCount) {
            result = false;
            //凭证日期格式错误
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryDateFormatErrorType,
                    'errorCount': VourcharDateFormatErrorCount,
                    'errorContent': VourcharDateFormatErrorMsg
                });
        }
        //金额格式错误
        if (AmountFormatErrorCount) {
            result = false;
            $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.JournalEntryAmountErrorType,
                   'errorCount': AmountFormatErrorCount,
                   'errorContent': AmountFormatErrorMsg
               });
        }
        //验证期间为正整数
        if (PeriodFormatErrorCount) {
            result = false;
            $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.JournalEntryPeriodFormatErrorType,
                   'errorCount': PeriodFormatErrorCount,
                   'errorContent': PeriodFormatErrorMsg
               });
        }
        //push字符串过长的错误信息到错误列表
        if (stringOverLengthCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push({
                'errorType': validationErrorType.OutputStringLengthType,
                'errorCount': stringOverLengthCheckCount,
                'errorContent': stringOverLengthCheckMsg
            });
        }
        //push数值超过范围的错误信息到列表
        if (numOutRangeCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push({
                'errorType': validationErrorType.NumOutRangeErrorType,
                'errorCount': numOutRangeCheckCount,
                'errorContent': numOutRangeCheckMsg
            });
        }

        //#endregion
        return result;
    };


    //4:筛选符合期间条件的数据进库
    var FilterPeriodData = function (journalEntryList) {
        //存放筛选后的数据
        $scope.journalEntryListFilter = [];
        //如果对应了期间列,则只筛选符合当前期间的数据进行导入，否则整个数据进行导入
        if ($.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap) > -1) {
            $scope.MapPeriodFlag = true;//是否对应了期间列
            $scope.AllDataSamePeriodFlag = true;//默认设置所有数据期间都一样

            journalEntryList.forEach(function (item) {
                if (parseInt(item.Period) === curPeriod) {
                    //截断过长的内容
                    item.Group = item.Group.substring(0, constant.validateLength.StringLength_50);
                    item.VID = item.VID.substring(0, constant.validateLength.StringLength_256);
                    item.AcctCode = item.AcctCode.substring(0, constant.validateLength.StringLength_50);
                    $scope.journalEntryListFilter.push(item);
                }
                else {
                    $scope.AllDataSamePeriodFlag = false;//是否所有的数据期间都相同，如果有一个不相同，则设置标志为false
                }
            });
        }
        else {
            $scope.MapPeriodFlag = false;//是否对应了期间列
            journalEntryList.forEach(function (item) {
                //截断过长的内容
                item.Group = item.Group.substring(0, constant.validateLength.StringLength_50);
                item.VID = item.VID.substring(0, constant.validateLength.StringLength_256);
                item.AcctCode = item.AcctCode.substring(0, constant.validateLength.StringLength_50);
                $scope.journalEntryListFilter.push(item);
            });
            $scope.journalEntryListFilter = journalEntryList;
        }
    };


    //点击导入按钮时，进行导入操作
    var importJournalEntryData = function (importType) {
        if (vatSessionService.project.projectStatusList[curPeriod] >= constant.ProjectStatusEnum.Generated) {
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[curPeriod]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doImportJournalEntryData(importType);
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doImportJournalEntryData(importType);
        }
    };


    function doImportJournalEntryData(importType) {
        if (!$scope.fileName) {
            SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
            return;
        }

        var importType = importType;//0：第一次导入，1：覆盖导入，2：追加导入

        //设置数据导入时的起始行,默认设置从第一行开始
        var startRowNum = 1;
        if ($('#StartRowNum').val()) {
            startRowNum = $('#StartRowNum').val();
        }

        //验证前，将错误数据清空
        $scope.errorMsgMap = [];

        //1：判断是否有没有map的必须列和起始行输入格式是否正确
        if (!ColumnsMapCheck()) {
            $('#errorListModal').modal('show');
            return;
        }


        //将需要导入的数据组装到list中
        var inputJournalEntryList = [];

        for (var i = startRowNum - 1; i < $scope.sheetData.dataList.length; i++) {
            var journalEntryInfo = {
                'Index': $scope.sheetData.dataList[i].index,//行号
                'Period': $.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap) > -1 ?
                    $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap)] : curPeriod,//期间
                'Date': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalPZRQ'), $scope.selectedColumnMap)],//凭证日期
                'Group': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalPZLX'), $scope.selectedColumnMap)],//凭证类型
                'VID': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalPZH'), $scope.selectedColumnMap)],//凭证号
                'ItemID': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalFLH'), $scope.selectedColumnMap)],//分录号
                'AcctCode': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalKMDM'), $scope.selectedColumnMap)],//科目代码
                'Summary': $.inArray($translate.instant('JournalZY'), $scope.selectedColumnMap) > -1 ?
                    $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalZY'), $scope.selectedColumnMap)] : null,//摘要
                'Debit': PWC.isNullOrEmpty($scope.sheetData.dataList[i][$.inArray($translate.instant('JournalJFJE'), $scope.selectedColumnMap)]) ?
                    0 : $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalJFJE'), $scope.selectedColumnMap)],//如果金额为空，则设置为0
                'Credit': PWC.isNullOrEmpty($scope.sheetData.dataList[i][$.inArray($translate.instant('JournalDFJE'), $scope.selectedColumnMap)]) ?
                    0 : $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalDFJE'), $scope.selectedColumnMap)],//如果金额为空，则设置为0
                'CustomerCode': $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalKHDM'), $scope.selectedColumnMap)],//客户代码
                'ImportType': enums.vatImportType.journalEntry,//导入类型
                'MonthID': $.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap) > -1 ?
                    $scope.sheetData.dataList[i][$.inArray($translate.instant('JournalQJ'), $scope.selectedColumnMap)] : null//如果用户对应了期间字段，则保存用户对应的期间，否则保存为null
            };
            inputJournalEntryList.push(journalEntryInfo);
        }

        //前台数据验证
        FrontEndValidJournalEntryData(inputJournalEntryList);

        if ($scope.errorMsgMap.length > 0) {
            $('#errorListModal').modal('show');
            return;
        }
        else {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportJournalEntry');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            }
            else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportJournalEntry');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            }
            else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportJournalEntry');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }

            getImportType().then(function () {
                //如果状态为0，则提示需要先导入TB，不能导入
                if ($scope.importStatus === enums.vatDataImportStatus.UnImported) {
                    SweetAlert.warning($translate.instant('JournalEntryImportErrorNotImportTBData'));
                }
                    //如果状态为1，则表示可以导入
                else if ($scope.importStatus === enums.vatDataImportStatus.TbImported) {
                    //如果没有选择期间，则系统给出导入所有数据的提示，确认后数据进库，否则，取消导入操作
                    if (!$scope.MapPeriodFlag) {
                        swal({
                            title: "warning!",
                            text: $translate.instant('NoPeriod'),
                            type: "warning",
                            showCancelButton: true,
                            confirmButtonColor: "#DD6B55",
                            confirmButtonText: $translate.instant('Yes'),
                            cancelButtonText: $translate.instant('No'),
                            closeOnConfirm: true,
                            closeOnCancel: true
                        },
                            function (isConfirm) {
                                if (isConfirm) {

                                    //数据进库
                                    vatImportService.importJournalEntryData($scope.journalEntryListFilter, importType).success(function () {
                                        logDto.UpdateState = $translate.instant('ImportSuccess');
                                        vatOperationLogService.addOperationLog(logDto);
                                        vatCommonService.importSetProjectStatus(projectDbName, curPeriod
                                                                               , constant.DictionaryDictKey.WFImportJournalEntry
                                                                               , enums.FinishStatusEnum.Finished);
                                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                                        $log.debug("import entry importJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                                        SweetAlert.success($translate.instant('ImportSuccess'));
                                        loadJournalEntryDataFromDB();
                                        $scope.fileName = '';
                                        vatSessionService.dataChanged = false;//设置为false表示在切换页面前数据没有变更,不需要提示
                                    }).error(function () {
                                        logDto.UpdateState = $translate.instant('ImportFail');
                                        vatOperationLogService.addOperationLog(logDto);
                                    });
                                }
                            });
                    }
                    else {
                        //如果要导入的数据中期间不一样，给出提示信息,否则直接进库
                        if (!$scope.AllDataSamePeriodFlag) {
                            swal({
                                title: "warning!",
                                text: $translate.instant('PeriodDifferenceTip'),
                                type: "warning",
                                showCancelButton: true,
                                confirmButtonColor: "#DD6B55",
                                confirmButtonText: $translate.instant('Yes'),
                                cancelButtonText: $translate.instant('No'),
                                closeOnConfirm: true,
                                closeOnCancel: true
                            },
                            function (isConfirm) {
                                if (isConfirm) {
                                    //数据进库
                                    vatImportService.importJournalEntryData($scope.journalEntryListFilter, importType).success(function () {
                                        logDto.UpdateState = $translate.instant('ImportSuccess');
                                        vatOperationLogService.addOperationLog(logDto);
                                        vatCommonService.setProjectStatus(projectDbName, curPeriod, constant.ProjectStatusEnum.Imported
                                            , constant.DictionaryDictKey.WFImportJournalEntry, enums.FinishStatusEnum.Finished);
                                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                                        $log.debug("import entry importJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                                        SweetAlert.success($translate.instant('ImportSuccess'));
                                        loadJournalEntryDataFromDB();
                                        $scope.fileName = '';
                                        vatSessionService.dataChanged = false;//设置为false表示在切换页面前数据没有变更,不需要提示
                                    }).error(function () {
                                        logDto.UpdateState = $translate.instant('ImportFail');
                                        vatOperationLogService.addOperationLog(logDto);
                                    });
                                }
                            });
                        }
                        else {
                            //数据进库
                            vatImportService.importJournalEntryData($scope.journalEntryListFilter, importType).success(function () {
                                logDto.UpdateState = $translate.instant('ImportSuccess');
                                vatOperationLogService.addOperationLog(logDto);
                                vatCommonService.setProjectStatus(projectDbName, curPeriod, constant.ProjectStatusEnum.Imported
                                    , constant.DictionaryDictKey.WFImportJournalEntry, enums.FinishStatusEnum.Finished);
                                vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, true);
                                $log.debug("import entry importJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                                SweetAlert.success($translate.instant('ImportSuccess'));
                                loadJournalEntryDataFromDB();
                                $scope.fileName = '';
                                vatSessionService.dataChanged = false;//设置为false表示在切换页面前数据没有变更,不需要提示
                            }).error(function () {
                                logDto.UpdateState = $translate.instant('ImportFail');
                                vatOperationLogService.addOperationLog(logDto);
                            });
                        }
                    }
                }
                    //如果状态为2，则提示财务数据已导入，不能导入
                else if ($scope.importStatus === enums.vatDataImportStatus.ErpImported) {
                    SweetAlert.warning($translate.instant('JournalEntryImportErrorERPDataImportedAlready'));
                }
            });
        }
    }


    //获取验证信息
    //var getValidationList = function () {
    //    var deferred = $q.defer();

    //    vatImportService.getValidationDtoInfo(enums.validationType.JournalEntry, curPeriod).success(function (data) {
    //        if (data.length > 0) {
    //            var index = 1;
    //            data.forEach(function (v) {
    //                v.index = index++;
    //            });
    //            $scope.errorList = data;
    //            //$scope.gridOptionsErrorMsg.data = data;
    //        }
    //        else {
    //            $scope.errorList = [];
    //            //$scope.gridOptionsErrorMsg.data = [];
    //        }
    //        deferred.resolve();
    //    });

    //    return deferred.promise;
    //}

    var showErrTab = function () {
        $scope.ImportErrorTab = true;//默认显示顶部block
        $scope.ImportErrorTag = true;//默认隐藏下方的错误信息列表
        $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

    };

    $scope.getGridHeight = function () {
        if ($scope.isLoadComplete) {
            return { height: ($('.journal-entry-grid-wrapper').height()) + "px" };
        }
        else {
            return { height: 0 + "px" };
        }
    };

    $scope.toggleErrorTab = function () {
        $scope.ImportErrorTag = !$scope.ImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.ImportErrorTag) {
            setErrorWrapCssDefault();
        } else {

            if (parseInt($('#content-resizer').css('bottom')) < 100) {
                $('#content-resizer').css('bottom', '150px');

                $('#topIcon').css({ bottom: '-381px' });

                $('.error-info-wrapper').css('height', '150px');
            }
        }
    };

    var setErrorWrapCssDefault = function () {
        $('#content-resizer').css('bottom', '5px');

        $('#topIcon').css({ bottom: '-551px' });

        $('.error-info-wrapper').css('height', '0px');
    };

    $scope.getErrorGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $("#error-info-wrapper").height();

            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: y + "px" };
            } else {

                return { height: '0px' };
            }
        }

        return {};
    };

    //获取当前导入状态（0：未导入，1：TB已导入，2:财务数据已导入）
    //如果状态为0，则提示需要先导入TB，不能导入
    //如果状态为1，则表示可以导入
    //如果状态为2，则提示财务数据已导入，不能导入
    var getImportType = function () {
        var deferred = $q.defer();
        $scope.importStatus = 0;

        vatImportService.getImportType(projectID, curPeriod).success(function (result) {
            if (result) {
                $scope.importStatus = result;
            }
            deferred.resolve();
        });

        return deferred.promise;
    };


    //显示图标
    var errorLevelToString = function (errorLevel) {
        if (errorLevel === 0) {
            return '/app-resources/images/vat/error.png';
        }
        if (errorLevel === 1) {
            return '/app-resources/images/vat/warning.png';
        }
        if (errorLevel === 2) {
            return '/app-resources/images/vat/tips.png';
        }
        else {
            return '/app-resources/images/vat/tips.png';
        }
    };

    //显示分录明细
    var showJournalEntryModal = function (typeid, items) {
        var data = JSON.parse(items);
        $scope.devgridDataSource = data;
        //组装列
        var columns = [];
        columns.push({ caption: $translate.instant('JournalPZRQ'), dataField: "Date", dataType: "date", width: 100 });
        //如果期间不为null，则加入期间列
        if (data[0].Period != null) {
            columns.push({ caption: $translate.instant('JournalQJ'), dataField: "Period", width: 50 });
        }
        columns.push({ caption: $translate.instant('JournalPZLX'), dataField: "Group", width: 160 },
                     { caption: $translate.instant('JournalPZH'), dataField: "VID", width: 130 },
                     { caption: $translate.instant('JournalKMDM'), dataField: "AcctCode", width: 100 });
        //如果摘要不为null，则加入摘要列
        if (data[0].Summary != null) {
            columns.push({ caption: $translate.instant('JournalZY'), dataField: "Summary", width: 150 });
        }
        columns.push({ caption: $translate.instant('JournalJFJE'), dataField: "Debit", format: { type: 'fixedPoint', precision: 2 }, width: 100 },
                     { caption: $translate.instant('JournalDFJE'), dataField: "Credit", format: { type: 'fixedPoint', precision: 2 }, width: 100 },
                     { caption: $translate.instant('JournalKHDM'), dataField: "CustomerCode", width: 100 },
                     { caption: $translate.instant('JournalFLH'), dataField: "ItemID", width: 70 });


        //如果不是重复数据，就展示普通明细弹出框，否则就显示重复数据明细弹出框
        if (typeid !== 52) {
            $scope.gridJournalEntryItemGridOptions = {
                columns: columns,
                selection: {
                    mode: "single"
                },
                bindingOptions: {
                    "dataSource": "devgridDataSource"
                },
                scrolling: {
                    mode: "standard",
                    showScrollbar: "always"
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                }
            }
            $('#jounarEntryItemModal').modal('show');
        }
        else {
            $scope.deferStatus = true;
            $scope.filterCondition = ["IsDuplicate", "=", true];

            $scope.gridJournalEntryDuplicateItemGridOptions = {
                columns: columns,
                bindingOptions: {
                    "dataSource.store.data": "devgridDataSource",
                    "selection.deferred": "deferStatus",
                    "selectionFilter": "filterCondition"
                },
                dataSource: {
                    store: {
                        type: "array",
                        key: 'VoucherID'
                    }
                },
                selection: {
                    selectAllMode: "allPages",
                    showCheckBoxesMode: "always",
                    mode: "multiple"
                },
                scrolling: {
                    mode: "standard",
                    showScrollbar: "always"
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                }
            }

            $('#jounarEntryDuplicateItemModal').modal('show');
        }
    };


    //删除重复数据
    //var deleteDuplicateData = function () {
    //    var dataGrid = $('#gridJournalEntryDuplicateItemGrid').dxDataGrid("instance");

    //    var deleteList = [];
    //    dataGrid.getSelectedRowsData().done(function (rowData) {
    //        for (var i = 0; i < rowData.length; i++) {
    //            deleteList.push(rowData[i].AcctCode);
    //        }
    //    });



    //    dataGrid.getSelectedRowKeys().done(function (keys) {
    //        if (keys && keys.length === 0) {
    //            SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
    //            return;
    //        }

    //        logDto.ID = PWC.newGuid();
    //        logDto.CreateTime = new Date();
    //        logDto.UpdateTime = new Date();
    //        logDto.OperationContent = deleteList.join(",");
    //        logDto.OperationName = $translate.instant('DeleteDuplicateData');
    //        logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

    //        vatImportService.deleteJournalEntryData(keys).success(function (data) {
    //            if (data && data.result) {
    //                //删除数据后重新校验
    //                vatImportService.validateJournalEntryData(curPeriod).success(function () {
    //                    logDto.UpdateState = $translate.instant('DeleteSuccess');
    //                    vatOperationLogService.addOperationLog(logDto);

    //                    loadJournalEntryDataFromDB();
    //                    $('#jounarEntryDuplicateItemModal').modal('hide');
    //                    SweetAlert.success($translate.instant('DeleteSuccess'));
    //                    //获取错误列表信息
    //                    getValidationList().then(function () {
    //                        if ($scope.errorList.length > 0) {
    //                            showErrTab();
    //                            $scope.toggleErrorTab();

    //                            //当有错误信息时，显示错误信息表
    //                            $scope.showErrorTable = true;
    //                        }
    //                        else {
    //                            $scope.ImportErrorTab = false;
    //                            $scope.ImportErrorTag = false;
    //                        }
    //                    });

    //                });
    //            }
    //        }).error(function () {
    //            logDto.UpdateState = $translate.instant('DeleteFailed');
    //            vatOperationLogService.addOperationLog(logDto);
    //            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
    //        });
    //    });


    //};

    //清空当期数据
    var clearJournalEntryData = function () {
        swal({
            title: "warning!",
            text: $translate.instant('JournalEntryClearTips'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#DD6B55",
            confirmButtonText: $translate.instant('Yes'),
            cancelButtonText: $translate.instant('No'),
            closeOnConfirm: true,
            closeOnCancel: true
        }, function (isConfirm) {
            if (isConfirm) {
                logDto.ID = PWC.newGuid();
                logDto.CreateTime = new Date();
                logDto.UpdateTime = new Date();
                logDto.OperationContent = '';
                logDto.OperationName = $translate.instant('ClearTrialBalance');
                logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;

                vatImportService.clearJournalEntryData(curPeriod).success(function (data) {
                    if (data && data.result) {
                        logDto.UpdateState = $translate.instant('ClearSuccess');
                        vatOperationLogService.addOperationLog(logDto);
                        vatCommonService.clearProjectStatus(projectDbName, curPeriod
                                                           , constant.DictionaryDictKey.WFImportJournalEntry
                                                           , enums.FinishStatusEnum.NotFinished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isEntryImport, false);
                        $log.debug("clear entry clearJournalEntryData: " + vatSessionService.project.importSubStatus.isEntryImport);
                        SweetAlert.success($translate.instant('ClearSuccess'));
                        loadJournalEntryDataFromDB();
                        $scope.isShowImportTotalBtn = true;
                    } else {
                        logDto.UpdateState = $translate.instant('ClearFailed');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.warning($translate.instant('ClearFailed'));
                    }
                }).error(function () {
                    logDto.UpdateState = $translate.instant('ClearFailed');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        });
    };

    //刷新数据，实质是重新校验数据
    //var refreshJournalEntryData = function () {
    //    logDto.ID = PWC.newGuid();
    //    logDto.CreateTime = new Date();
    //    logDto.UpdateTime = new Date();
    //    logDto.OperationContent = '';
    //    logDto.OperationName = $translate.instant('RefreshValidationData');
    //    logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;

    //    vatImportService.validateJournalEntryData(curPeriod).success(function () {
    //        logDto.UpdateState = $translate.instant('RefreshSuccess');
    //        vatOperationLogService.addOperationLog(logDto);

    //        loadJournalEntryDataFromDB();
    //        //获取错误列表信息
    //        getValidationList().then(function () {
    //            if ($scope.errorList.length > 0) {
    //                showErrTab();
    //                $scope.toggleErrorTab();

    //                //当有错误信息时，显示错误信息表
    //                $scope.showErrorTable = true;
    //            }
    //            else {
    //                $scope.ImportErrorTab = false;
    //                $scope.ImportErrorTag = false;
    //            }
    //        });

    //    }).error(function () {
    //        logDto.UpdateState = $translate.instant('RefreshTbFail');
    //        vatOperationLogService.addOperationLog(logDto);

    //        SweetAlert.error($translate.instant('PleaseContactAdministrator'));
    //    });;
    //};

    //日志
    var showOperateLogPop = function () {
        $scope.isShowLog = true;
    };


    (function initialize() {
        $log.debug('VatImportJournalEntryController.ctor()...');

        $scope.errorMsgMap = [];
        $scope.journalEntryFileName = '';
        $scope.selectedColumnMap = [];
        $scope.journalEntryColumns = [];
        $scope.initJournalEntryColumnsIndex = [];
        $scope.startRowList = [];
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0, topRowNumber: 0 };
        $scope.isShowImportTotalBtn = true;

        //initColumns();

        loadJournalEntryDataFromDB();

        $scope.changeJournalEntrySheet = changeJournalEntrySheet;

        //$scope.mappingColumn = mappingColumn;

        ////$scope.importJournalEntryData = importJournalEntryData;

        //$scope.errorLevelToString = errorLevelToString;

        //$scope.showJournalEntryModal = showJournalEntryModal;

        //$scope.deleteDuplicateData = deleteDuplicateData;

        //$scope.clearJournalEntryData = clearJournalEntryData;

        //$scope.refreshJournalEntryData = refreshJournalEntryData;

        //$scope.showOperateLogPop = showOperateLogPop;


        $scope.gridOptionsJournalEntry = {
            enableColumnResizing: true,
            rowHeight: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            flatEntityAccess: true,
            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;

                $interval(function () {
                    $scope.gridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        $scope.$watch('journalEntryFileName', function (newValue, oldValue) {
            if (newValue && newValue !== oldValue) {
                updateJournalEntryFileName(newValue);
                doUploadJournalEntryFile($scope.journalEntryFileName);
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;
                $('#StartRowNum').val('2');
                //$scope.ImportFlag = true;
            }
        });

        $timeout(function () {
            $scope.isLoadComplete = true;
        }, 500);
    })();
}]);
vatModule.directive('productItemImport', ['$log',
    function ($log) {
        'use strict';
        $log.debug('productItemImport.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/import/product-item-import/product-item-import.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'ProductItemImportController',
            link: function (scope, element) {

            }
        };
    }
]);
vatModule.directive('vatAuditAdjust', ['$log', 'enums', 'vatSessionService',
    function ($log, enums, vatSessionService) {
        'use strict';

        $log.debug('vatAuditAdjust.ctor()...');

        return {
            restrict: 'E',
            template: '<import-audit-adjust service-type-id="serviceTypeId" period-id="periodId"></import-audit-adjust>',
            scope: {},
            link: function (scope, element) {
                scope.periodId = vatSessionService.month;
                scope.serviceTypeId = enums.serviceType.VAT;
            }
        };
    }
]);
vatModule.controller('VatImportAutoMappingController', ['$scope', '$log', 'loginContext', '$translate', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', 'vatImportService', '$timeout', '$q', 'enums', 'uiGridConstants', '$interval', 'vatSessionService', 'vatOperationLogService', 'projectService', 'vatCommonService',
function ($scope, $log, loginContext, $translate, apiInterceptor, Upload, dataImportService, SweetAlert, vatImportService, $timeout, $q, enums, uiGridConstants, $interval, vatSessionService, vatOperationLogService, projectService, vatCommonService) {
    'use strict';
   

    $scope.importFileName = 'Book.xlsx';
    $scope.importFileSheets = ['sheet1', 'sheet2', 'sheet3'];
    $scope.startRows = [1, 2, 3, 4, 5, 6, 7];
    $scope.currentSheet = 'sheet1';
    $scope.startRow = 1;
    $scope.systemSuggestNames = ['未识别', '序号', '凭证日期', '期间', '凭证的日期', '凭证类型', '凭证号', '科目代码', '摘要', '借方金额', '贷方金额', '客户代码', '分录号'];

    $scope.mapDetails = [
        { importColName: '序号', systemSuggestName: '序号', mapReuslt: 1, importColContent: '1' },
        {
            importColName: '序列日期', systemSuggestName: '未识别', mapReuslt: 2, importColContent: '13212506122',showDetail:true,
            failReason: '系统识别 导入列名【凭证日期】所在列内容“123212321” 与列名内容不符，与系统列名【凭证日期】应包含内容不符。',
            systemSuggests: {
                suggestsByCol: ['凭证日期', '凭证的日期', '期间'],
                suggestsByContent: ['科目代码','分录号'],
            }
        },
        { importColName: '期间', systemSuggestName: '期间', mapReuslt: 1, importColContent: '2' },
        { importColName: '凭证类型', systemSuggestName: '凭证类型', mapReuslt: 1, importColContent: '记账凭证' },
        { importColName: '凭证号', systemSuggestName: '凭证号', mapReuslt: 1, importColContent: '1111111' },
        { importColName: '科目代码', systemSuggestName: '科目代码', mapReuslt: 1, importColContent: '022010' },
        {
            importColName: '摘抄', systemSuggestName: '未识别', mapReuslt: 2, importColContent: '2015.08.31中行POS清算入账',
            failReason: '系统无法识别 导入列【摘抄】',
            systemSuggests: {
                suggestsByCol: ['摘要', '凭证日期', '期间'],
                suggestsByContent: ['摘要'],
            }
        },
        { importColName: '借方金额', systemSuggestName: '借方金额', mapReuslt: 1, importColContent: '500,000,000' },
        { importColName: '贷方金额', systemSuggestName: '贷方金额', mapReuslt: 1, importColContent: '500,000,000' },
        { importColName: '客户代码', systemSuggestName: '客户代码', mapReuslt: 1, importColContent: '江苏010111' },
        { importColName: '分录号', systemSuggestName: '分录号', mapReuslt: 1, importColContent: '0901110222' },
    ];


    function updateMapInfo() {
        $scope.matchedFailCount = $scope.mapDetails.filter(function (mapDetail) {
            return mapDetail.mapReuslt !== 1;
        }).length;

        $scope.matchedSuccessCount = $scope.mapDetails.filter(function (mapDetail) {
            return mapDetail.mapReuslt === 1;
        }).length;


        $scope.matchedPercentage = ($scope.matchedSuccessCount / $scope.mapDetails.length * 100).toFixed(0) + '%';

    }
    

    $scope.addMap = function (mapDetail, colName) {
        mapDetail.mapReuslt = 1;
        mapDetail.systemSuggestName = colName;
        updateMapInfo();
        swal({
            title: "是否记住此次匹配关系？",
            showCancelButton: true,
            closeOnConfirm: true,
            icon:'warning',
            confirmButtonText: '是，下次默认执行',
            cancelButtonText:'不，仅做单次修改'
        });

    };

    $scope.showDetail = function (md) {
        $scope.mapDetails.forEach(function (mapDetail) {
            mapDetail.showDetail = false;
        });
        md.showDetail = true;
    };

    updateMapInfo();
}]);
vatModule.directive('vatImportAutoMapping', ['$log',
    function ($log) {
        'use strict';
        $log.debug('vatImportAutoMapping.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/import/vat-import-auto-mapping/vat-import-auto-mapping.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'VatImportAutoMappingController',
            link: function (scope, element) {

            }
        };
    }
]);
vatModule.controller('ImportCustomInvoiceCtrl', ['$scope', '$log', '$translate', '$timeout', '$q', '$interval', 'enums', 'apiInterceptor'
    , 'Upload', 'dataImportService', 'vatImportService', 'vatSessionService', 'SweetAlert', 'uiGridConstants'
    , 'vatCommonService', 'vatWorkflowService', 'vatOperationLogService',
function ($scope, $log, $translate, $timeout, $q, $interval, enums, apiInterceptor
    , Upload, dataImportService, vatImportService, vatSessionService, SweetAlert, uiGridConstants
    , vatCommonService, vatWorkflowService, vatOperationLogService) {
    var successCount = 0;
    var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
    var _BlankChar = $translate.instant('PleaseSelectColumn');
    var resumable = true;
    var pageStatusEnum = { ToImport: 1, ShowData: 2, Reimport: 3 }; //状态 
    var importEnum = { Import: 0, CoverImport: 1, AddImport: 2 };   //导入方式
    var period = vatSessionService.month;
    var projectDbName = vatSessionService.project.dbName;
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    $scope.showErrorTable = false;
    $scope.showInitTable = false;
    $scope.showImportTable = false
    $scope.period = vatSessionService.month;
    //上传文件有效后缀名
    var ValidFileExtension = {
        XLS: "xls",
        XLSX: "xlsx"
    }
    $scope.chunkSize = 100000;
    $scope.success = false;
    //写日志
    $scope.moduleid = enums.vatModuleEnum.Import_CustomInvoice;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        OperationObject: $translate.instant('customInvoice'),
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.period,
    };



    //显示图标
    $scope.errorLevelToString = function (errorLevel) {
        if (errorLevel === 0) {
            return '/app-resources/images/vat/error.png';
        }
        if (errorLevel === 1) {
            return '/app-resources/images/vat/warning.png';
        }
        if (errorLevel === 2) {
            return '/app-resources/images/vat/tips.png';
        }
        else {
            return '/app-resources/images/vat/tips.png';
        }
    }


    //显示验证信息
    $scope.toggleErrorTab = function () {
        $scope.ImportErrorTag = !$scope.ImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.ImportErrorTag) {
            setErrorWrapCssDefault();
        } else {

            if (parseInt($('#content-resizer').css('bottom')) < 100) {
                $('#content-resizer').css('bottom', '150px');

                $('#topIcon').css({ bottom: '-381px' });

                $('.error-info-wrapper').css('height', '150px');
            }
        }
    };


    $scope.getGridHeight = function () {
        if ($scope.isLoadComplete) {
            return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
        }
        else {
            return { height: 0 + "px" };
        }
    };


    $scope.getErrorGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $("#error-info-wrapper").height();
            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: y + "px" };
            } else {

                return { height: '0px' };
            }
        }
        return {};
    };

    //日志
    $scope.showOperateLogPop = function () {
        $scope.isShowLog = true;
    };

    //检查用户机构权限
    var checkUserOrganizationPermissionList = function () {
        var list = [];
        var userManageTemp = constant.vatPermission.dataImport.customInvoice;
        list.push(userManageTemp.importCode);
        $scope.hasImportPermission = false;
        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {      
            $scope.hasImportPermission = data[userManageTemp.importCode];      
        });
    };


    //初始化列数据
    var initColumns = function () {
        //初始化进项发票汇总表列名
        $scope.mapNameList = [
            $translate.instant('PleaseSelectColumn'),
            $translate.instant('CustomsPayNum'),
            $translate.instant('CustomsIssueDate'),
            $translate.instant('InvoiceSE'),
            $translate.instant('InvoiceJE'),
            $translate.instant('CustomsAuditResult')
        ];
    };


    //设置上传文件名
    var updateFileName = function (newValue) {
        $scope.fileName = newValue.name;      
        //_.each(newValue, function (item) {
        //    $scope.fileName = item.name;
        //});
    };


    //上传文件
    var uploadfile = function (file) {
        if (file && checkUploadFiles(file)) {
            successCount = 0;
            if (!file.$error) {
                var tempFileName = PWC.newGuid() + '.dat';
                var token = $('input[name="__RequestVerificationToken"]').val();
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        cancel: false,
                        filename: file.name,
                        tempFileName: tempFileName,
                        file: file
                    },
                    resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(uploadSuccess);
            }
        }
    };


    //上传成功
    var uploadSuccess = function (resp) {
        successCount++;
        if (successCount === 1) {
            $scope.tempFileName = resp.data;
            changeSheet(0);
        }
    };


    //选择sheet
    function changeSheet(selectedSheet) {      
        var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
            return num.name === selectedSheet.name;
        });
        $scope.selectedMappingList = [];
        //initColumns();       
        //$scope.sheetInfo.selectedSheetIndex = sheetIndex;
        $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
        refreshTable();
    };


    //刷新列表
    function refreshTable() {
        $scope.showErrorTable = false;
        if (_.isString($scope.tempFileName)) {
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, 0).success(function (data) {
                $log.debug("refreshTable");
                $scope.showInitTable = false;
                $scope.showImportTable = true
                var sheetNameObjectArray = [];
                data.sheetNameList.forEach(function (v) {
                    sheetNameObjectArray.push({ 'name': v });
                });

                $scope.sheetData = data;
                $scope.sheetData.sheetNameList = sheetNameObjectArray;                           
                $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                initColumns();
                vatSessionService.dataChanged = true; //设置为true表示在切换页面前数据有变更, 需要提示
            });
        }
    };


    //列名对应
    //parentIndex：当前列号
    //index：下拉列表中选项的序号
    //colName:
    var changeMapping = function (parentIndex, index, colName) {       
        if (colName) {
            var newColumn = $scope.mapNameList[index];
            var oldColumn = $scope.selectedMappingList[parentIndex];

            //如果新的选择项与老的选择项一致，则不进行操作
            if (oldColumn === newColumn) {
                return;
            }
            else {
                $scope.selectedMappingList[parentIndex] = colName;

                if (colName !== $translate.instant('PleaseSelectColumn')) {
                    //如果当前选择的不是"请选择列名",则将选项从数组中移除
                    $scope.mapNameList.splice(index, 1);

                    if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                        //将老的选项追加到选项列表中
                        $scope.mapNameList.push(oldColumn);
                    }
                }
                else {
                    //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                    if (oldColumn) {
                        $scope.mapNameList.push(oldColumn);
                    }
                }
            }
        }
        $log.debug($scope.selectedMappingList);
    };


    function constructLogDto(logData, importType) {
        logData.ID = PWC.newGuid();
        logData.CreateTime = new Date();
        logData.UpdateTime = new Date();
        logData.OperationContent = $scope.fileName;
        if (importType === $scope.importEnum.Import) {
            logData.OperationName = $translate.instant('ImportCustomInvoice');
            logData.OperationType = enums.vatLogOperationTypeEnum.Import;
        }
        else if (importType === $scope.importEnum.CoverImport) {
            logData.OperationName = $translate.instant('ConvertCustomInvoice');
            logData.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
        }
        else if (importType === $scope.importEnum.AddImport) {
            logData.OperationName = $translate.instant('AppendCustomInvoice');
            logData.OperationType = enums.vatLogOperationTypeEnum.AddImport;
        }

        return logData;
    }

    function doImportCustomsInvoice(importType) {
        $log.debug("start to import customs invovice");
        $log.debug("file name: " + $scope.fileName);
        if (isSelectedFile() && validationColumnMapping() && checkUploadStartNum()) {
            var importresult = getCustDataBySheet(importType);
            vatSessionService.dataChanged = false; //设置为false表示不需要提示
            if (importresult && $scope.custInputList.length > 0) {
                vatImportService.importCustomsInvoiceList($scope.custInputList, importType).success(function (rsp) {
                    if (rsp.result) {
                        $scope.pageStatus = pageStatusEnum.ShowData;
                        getCustomsInvoiceList();
                        vatCommonService.importSetProjectStatus(projectDbName, period, constant.DictionaryDictKey.WFImportCustomInvoice
                                                                , enums.FinishStatusEnum.Finished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isCustomInvoiceImport, true);
                        var importLogDto = constructLogDto(logDto, importType);
                        importLogDto.UpdateState = $translate.instant('ImportSuccess');
                        vatOperationLogService.addOperationLog(importLogDto);
                        $log.debug("import customInvoice importCustomsInvoice: " + vatSessionService.project.importSubStatus.isCustomInvoiceImport);
                        SweetAlert.success($translate.instant('ImportSuccess'));
                    }
                    else {
                        if ($scope.haveImported) {
                            $scope.pageStatus = pageStatusEnum.Reimport;
                        }
                        else {
                            $scope.pageStatus = pageStatusEnum.ToImport;
                        }

                        var importLogDto = constructLogDto(logDto, importType);
                        importLogDto.UpdateState = $translate.instant('ImportFail');
                        vatOperationLogService.addOperationLog(importLogDto);
                        SweetAlert.error($translate.instant('ImportFail'));
                    }

                    $scope.fileName = null;
                });
            }
        }
    }

    //上传CustomsInvoice数据
    function importCustomsInvoice(importType) {
        if (vatSessionService.project.projectStatusList[$scope.period] >= constant.ProjectStatusEnum.Generated) {     
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[$scope.period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doImportCustomsInvoice(importType);
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doImportCustomsInvoice(importType);
        }
    };


    //判断是否选择了文件
    function isSelectedFile() {
        if (_.isUndefined($scope.fileName) || _.isNull($scope.fileName)) {           
            SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
            return false;
        }
        else if ($scope.sheetData.dataList.length <= 0) {         
            SweetAlert.warning($translate.instant('EmptyFileContent'));
            return false;
        }
        else {
            return true;
        }
    }


    //验证是否选中了正确的列名
    function validationColumnMapping() {
        var errorMsg = [];
        //1.海关缴款书号码是必选项
        if ($scope.selectedMappingList.indexOf($translate.instant('CustomsPayNum')) == -1) {
            errorMsg.push($translate.instant('CustomsPayNum'));         
        }

        //2. 开具日期是必选项
        if ($scope.selectedMappingList.indexOf($translate.instant('CustomsIssueDate')) == -1) {           
            errorMsg.push($translate.instant('CustomsIssueDate'));       
        }

        //3. 稽核结果是必选项
        if ($scope.selectedMappingList.indexOf($translate.instant('CustomsAuditResult')) == -1) {
            errorMsg.push($translate.instant('CustomsAuditResult'));      
        }


        //4. 税金是必选项
        if ($scope.selectedMappingList.indexOf($translate.instant('InvoiceSE')) == -1) {
            errorMsg.push($translate.instant('InvoiceSE'));     
        }

        if (errorMsg.length > 0)
        {
            var strError = '';
            errorMsg.forEach(function (item, index) {
                strError += item + ' ';
            });      
            SweetAlert.error($translate.instant('RequiredColumnNotSelect').formatObj({ errorMsg: strError }));
            return false;
        }
        else
        {
            return true;
        }
        
    }


    //准备导入数据
    function getCustDataBySheet(importType) {
        var isSuccess = true;
        $scope.custInputList = [];
        for (var i = $scope.startRowNum - 1; i < $scope.sheetData.dataList.length; i++) {
            var mappOk = true;
            var balanceDto = {};
            balanceDto.customsId = PWC.newGuid();
            balanceDto.periodId = period;          
            var rowData = $scope.sheetData.dataList[i];
            balanceDto = SetDefaultPriceValue(rowData, balanceDto, i);
            mappOk = validateColumnType(importType, rowData, balanceDto, i);
            //数据验证通过
            if (mappOk) {
                $scope.custInputList.push(balanceDto);
            }
            else {
                isSuccess = false;
                return false;
            }
        }
        return isSuccess;
    }


    //如果金额或者税金的导入数据为空，那么默认为0
    function SetDefaultPriceValue(rowData,balanceDto,i) {
        $.each($scope.selectedMappingList, function (cloumnindex, mappitem) {
            var columnData = mappitem;
            var cellData = rowData[cloumnindex];
            if (columnData == $translate.instant('InvoiceSE')) {
                if (PWC.isNullOrEmpty(cellData)) {
                    balanceDto.invoiceTaxAmount = '0.00';
                    rowData[cloumnindex] = '0.00';
                }              
            }

            if (columnData == $translate.instant('InvoiceJE')) {
                if (PWC.isNullOrEmpty(cellData)) {
                    balanceDto.invoiceAmount = '0.00';
                    rowData[cloumnindex] = '0.00';
                }               
            }
        });

        return balanceDto;
    }


    //验证并为Dto赋值
    function validateColumnType(importType,rowData, balanceDto, rowIndex) {
        var isSuccess = true;
        $.each($scope.selectedMappingList, function (cloumnindex, mappitem) {
            var columnData = mappitem;
            var cellData = rowData[cloumnindex];
            var payNumIndex = $scope.selectedMappingList.indexOf($translate.instant('CustomsPayNum'));
            if (columnData == $translate.instant('CustomsPayNum')) {
                if (_.isNull(cellData) || cellData === "") {                    
                    SweetAlert.error($translate.instant('CustomsPayNumEorror').formatObj({ rowIndex: rowIndex + 1 }));
                    isSuccess = false;
                    return false;
                }
                //else if (IsPayNumDuplicateInSheet($scope.sheetData.dataList, cellData, payNumIndex,rowIndex)) {
                //    swal({
                //        title: $translate.instant('FailureTitle'),
                //        text: $translate.instant('CustomsPayNumExistedInSheet').formatObj({ rowIndex: rowIndex + 1 , rows: rowData[payNumIndex] }),
                //        type: "error",
                //        confirmButtonText: $translate.instant('Confirm')
                //    });

                //    isSuccess = false;
                //    return false;
                //}
                //else if (IsPayNumInDb(importType, cellData)) {
                //    swal({
                //        title: $translate.instant('FailureTitle'),
                //        text: $translate.instant('CustomsPayNumExisted').formatObj({ rowIndex : rowIndex + 1, rows: rowData[payNumIndex] }),
                //        type:  "error",
                //        confirmButtonText: $translate.instant('Confirm')
                //    });

                //    isSuccess = false;
                //    return false;
                //}
                else {
                    balanceDto.payNum = cellData;
                }
            }

            if (columnData == $translate.instant('CustomsIssueDate')) {
                if (!PWC.isNullOrEmpty(cellData))
                {
                    if (PWC.checkDate(cellData)) {
                        balanceDto.issueDate = cellData
                    }
                    else {                   
                        SweetAlert.error($translate.instant('CustomsIssueNotDate').formatObj({ rowIndex: rowIndex + 1, rows: rowData[payNumIndex] }));
                        isSuccess = false;
                        return false;
                    }
                }
                else 
                {                  
                    SweetAlert.error($translate.instant('CustomsIssueEmpty').formatObj({ rowIndex: rowIndex + 1 }));
                    isSuccess = false;
                    return false;
                }

            }


            if (columnData == $translate.instant('InvoiceSE')) {
                if (isNaN(parseFloat(cellData))) {                  
                    SweetAlert.error($translate.instant('InvoiceSEError').formatObj({ rowIndex: rowIndex + 1, rows: rowData[payNumIndex] }));
                    isSuccess = false;
                    isSuccess = false;
                    return false;
                }
                else {
                    balanceDto.invoiceTaxAmount = cellData;
                }
            }

            if (columnData == $translate.instant('InvoiceJE')) {
                if (isNaN(parseFloat(cellData))) {                  
                    SweetAlert.error($translate.instant('InvoiceJEError').formatObj({ rowIndex: rowIndex + 1, rows: rowData[payNumIndex] }));
                    isSuccess = false;
                    return false;
                }
                else {
                    balanceDto.invoiceAmount = cellData;
                }

            }

            if (columnData == $translate.instant('CustomsAuditResult')) {
                if (_.isNull(cellData) || cellData === "") {                  
                    SweetAlert.error($translate.instant('CustomsAuditResultError').formatObj({ rowIndex: rowIndex + 1, rows: rowData[payNumIndex] }));
                    isSuccess = false;
                    return false;
                }
                else {
                    balanceDto.auditResult = cellData;
                }
            }
        });

        return isSuccess;
    };


    //获取CustomsInvoice数据
    function getCustomsInvoiceList() {    
        vatImportService.getCustomsInvoicesByPeriodId(period).success(function (data) {
                $scope.balanceOuputList = [];              
                $scope.pageStatus = pageStatusEnum.ShowData;
                $scope.haveImported = true;
                $scope.showInitTable = true;
                $scope.showImportTable = false;
                $scope.showErrorTable = false;
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;             

                //添加title
                var balanceTitleDto = [];
                balanceTitleDto.push($translate.instant('SequenceNo'));
                balanceTitleDto.push($translate.instant('CustomsPayNum'));
                balanceTitleDto.push($translate.instant('CustomsIssueDate'));
                balanceTitleDto.push($translate.instant('InvoiceSE'));
                balanceTitleDto.push($translate.instant('InvoiceJE'));
                balanceTitleDto.push($translate.instant('CustomsAuditResult'));
                //balanceTitleDto.push($translate.instant('PeriodId'));
                $scope.balanceOuputList.push(balanceTitleDto);
                   
                if (data.length > 0) {                  
                    data.forEach(function (item, index) {
                        var balancedto = [];                    
                        if (balanceTitleDto.indexOf($translate.instant('CustomsPayNum')) !== -1) {
                            balancedto.push(item.payNum);
                        }
                        if (balanceTitleDto.indexOf($translate.instant('CustomsIssueDate')) !== -1) {

                            balancedto.push(new Date(item.issueDate).dateTimeToString("yyyyMMdd"));
                        }
                        if (balanceTitleDto.indexOf($translate.instant('InvoiceSE')) !== -1) {
                            balancedto.push(item.invoiceTaxAmount);
                        }
                        if (balanceTitleDto.indexOf($translate.instant('InvoiceJE')) !== -1) {
                            balancedto.push(item.invoiceAmount);
                        }
                        if (balanceTitleDto.indexOf($translate.instant('CustomsAuditResult')) !== -1) {
                            balancedto.push(item.auditResult);
                        }
                        //if (balanceTitleDto.indexOf($translate.instant('PeriodId')) !== -1) {
                        //    balancedto.push(item.periodId);
                        //}             
                        $scope.balanceOuputList.push(balancedto);
                    });
                }
                else {
                    //$scope.balanceOuputList = [];
                    //$scope.pageStatus = pageStatusEnum.ToImport;
                    $scope.haveImported = false;
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }

                $log.debug('start to set gridview data....');
                $log.debug($scope.haveImported);
                $log.debug($scope.pageStatus);
                $log.debug($scope.showImportTable);
                $scope.gridOptionsIncomeInvoiceTotal.data = data;
                getValidationList();
        }).error(function () {            
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }
     

    //payNum是否在导入的sheet中重复
    function IsPayNumDuplicateInSheet(sheetData, payNum, payNumIndex,rowIndex) {
        var exist = false;
        for (var i = $scope.startRowNum - 1; i < sheetData.length; i++) {
            if(i === 0 || i === rowIndex){
                continue;
            }
            else {        
                if (sheetData[i][payNumIndex] === payNum) {
                    exist = true;
                    $log.debug("IsPayNumDuplicateInSheet有重复. payNum= " + payNum);
                    break;
                }
            }
        }
        return exist;
    }
    

    //payNum是否已经存在于数据库中
    function IsPayNumInDb(importType, payNum) {
        var exist = false;
        if (importType === importEnum.CoverImport) {
            exist = false;
        }
        else {
            $.each($scope.balanceOuputList, function (index, item) {
                if (item[0] === payNum) {
                    exist = true;
                    return false;
                }
            });
        }      
        return exist;
    }


    //清理海关数据
    function clearCustomInvocie() {
        swal({
            title: $translate.instant('IsDelete'),
            text: $translate.instant('ConfirmClearCustomsInvoice'),
            type: "warning",
            showCancelButton: true,
            confirmButtonText: $translate.instant('Yes'),
            cancelButtonText: $translate.instant('No'),
            closeOnConfirm: true,
            closeOnCancel: true
        },
        function (isConfirm) {
            if (isConfirm) {
                deleteCustomsInvoices(period);
            }
        });
       
    }


    function refreshCustomInvoice() {
        getCustomsInvoiceList();
    }
    
    function deleteCustomsInvoices(periodId) {
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = '';
        logDto.OperationName = $translate.instant('ClearCustomInvoice');
        logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;

        vatImportService.deleteCustomsInvoicesByPeriodId(periodId).success(function (data) {
            if (data) {             
                logDto.UpdateState = $translate.instant('DeleteSuccess');
                vatOperationLogService.addOperationLog(logDto);

                getCustomsInvoiceList();
                vatCommonService.clearProjectStatus(projectDbName, periodId, constant.DictionaryDictKey.WFImportCustomInvoice
                                                           , enums.FinishStatusEnum.NotFinished);
                vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isCustomInvoiceImport, false);
                $log.debug("clear customInvoice deleteCustomsInvoices: " + vatSessionService.project.importSubStatus.isCustomInvoiceImport);
                SweetAlert.success($translate.instant('DeleteSuccess'));             
            }
            else {
                logDto.UpdateState = $translate.instant('DeleteFailure');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.error($translate.instant('DeleteFailure'));              
            }          
        }).error(function () {
            logDto.UpdateState = $translate.instant('ClearFailed');
            vatOperationLogService.addOperationLog(logDto);
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }


    //校验上传文件后缀名
    function checkUploadFiles(file) {
        var result = true;       
        var fileName = file.name;
        var fileExtension = fileName.substr(fileName.lastIndexOf(".") + 1, fileName.length - fileName.lastIndexOf(".")).toLowerCase();
        if (fileExtension !== ValidFileExtension.XLS
            && fileExtension !== ValidFileExtension.XLSX) {         
            SweetAlert.warning($translate.instant('CustomInvoiceFileCheck'));
            result = false;
        }

        return result;
    }
    

    //校验起始行号
    function checkUploadStartNum()
    {
        var result = true;
        if (PWC.isNullOrEmpty($scope.startRowNum)) {        
            SweetAlert.warning($translate.instant('StartRowNull'));
            result = false;
        }
        if (parseInt($scope.startRowNum) > $scope.sheetData.dataList.length) {          
            SweetAlert.warning($translate.instant('StartRowNumberCheckMsg'));
            result = false;
        }
        return result;
    }


    //获取验证信息
    function getValidationList() {
        //改成海关清单类型
        //$scope.validationType = 0;
        vatImportService.getCustomsInvoicesValidates($scope.period).success(function (or) {
            if (!_.isNull(or) && !_.isUndefined(or)) {
                if (or.data.length > 0) {
                    var index = 1;
                    or.data.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.errorList = or.data;
                    $scope.gridOptionsErrorMsg.data = or.data;

                    showErrTab();
                    $scope.toggleErrorTab();
                    $scope.showErrorTable = true;
                }
                else {
                    $scope.errorList = [];
                    $scope.gridOptionsErrorMsg.data = [];
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            }
            
        });
    }


    var setErrorWrapCssDefault = function () {
        $('#content-resizer').css('bottom', '30px');

        $('#topIcon').css({ bottom: '-501px' });

        $('.error-info-wrapper').css('height', '30px');
    };


    function showErrTab() {
        $scope.ImportErrorTab = true;
        $scope.ImportErrorTag = true;
        $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

    };

    function closeModal (e) {
        var buttonId = e.target.id;
        if (!_.isUndefined(buttonId) && !_.isNull(buttonId)) {
            if (_.isEqual(buttonId, "btnClosePayNumDuplicate")) {
                $('#payNumDuplicateModal').modal('hide');
            }
        }
    }
    

    function showValidateDetails (row) {
        $log.debug("showValidateDetails");
        $log.debug(row);
        //海关缴款文书标号重复信息
        if (_.isEqual(row.erpCheckTypeId, constant.ErpCheckType.CustomInvoice_DuplicatePayNum)) {
            vatImportService.getPayNumDuplicateDetails().success(function (or) {
                if (!_.isNull(or) && !_.isUndefined(or)) {
                    if (or.result) {
                        $scope.gridOptionsPayNumDuplicate.data = or.data;
                        $('#payNumDuplicateModal').modal('show');
                    }
                    else {
                        SweetAlert.warning($translate.instant(or.resultMsg));
                    }
                }

            });
        }
        
    }


    function deleteDuplicatePayNum() {
        $log.debug("deleteDuplicatePayNum");
        var dupIds = [];
        var dupPayNums = [];
        var dupRows = $scope.gridApiPayNumDuplicate.selection.getSelectedRows();
        dupRows.forEach(function (item, index) {
            dupIds.push(item.customsId);
            dupPayNums.push(item.payNum);
        });

        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = dupPayNums.join(",");
        logDto.OperationName = $translate.instant('DeleteDuplicateData');
        logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

        vatImportService.deleteCustomInvoiceByIds(dupIds).success(function (or) {
            if (!_.isNull(or) && !_.isUndefined(or)) {
                if (or.result) {
                    logDto.UpdateState = $translate.instant('DeleteSuccess');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.success($translate.instant('DeleteSuccess'));
                    $('#payNumDuplicateModal').modal('hide');
                    vatImportService.updateCustomsInvoiceValidation(period).success(function (or) {
                        if (!_.isNull(or) && !_.isUndefined(or)) {
                            if (or.result) {
                                getCustomsInvoiceList();
                            }
                        }
                    });

                }
                else {
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }
            }
        }).error(function () {
            logDto.UpdateState = $translate.instant('DeleteFailed');
            vatOperationLogService.addOperationLog(logDto);
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    };

    //开始
    (function initialize() {
        $log.debug('ImportCustomInvoiceCtrl.ctor()...');
        $scope.startRowNum = 2;
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };//UI中sheet的数据
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 }; //sheet基本信息      
        $scope.custInputList = [];//存放待导入数据  //$scope.balanceInputList = [];
        $scope.changeSheet = changeSheet;
        $scope.changeMapping = changeMapping;
        $scope.pageStatusEnum = pageStatusEnum;
        $scope.pageStatus = pageStatusEnum.ToImport;
        $scope.importEnum = importEnum;
        $scope.importCustomsInvoice = importCustomsInvoice;
        $scope.haveImported = true;
        $scope.clearCustomInvocie = clearCustomInvocie;
        $scope.refreshCustomInvoice = refreshCustomInvoice;
        $scope.closeModal = closeModal;
        $scope.showValidateDetails = showValidateDetails;
        $scope.deleteDuplicatePayNum = deleteDuplicatePayNum;   
        $scope.$watch('fileNameWrapper', function (newValue, oldValue) {
            if (newValue != null && newValue !== oldValue) {
                $log.debug("custom-invoice: watch fileNameWrapper");
                updateFileName(newValue);
                uploadfile($scope.fileNameWrapper);
                $scope.selectedMappingList = [];
                initColumns();
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;
                if ($scope.haveImported) {
                    $scope.pageStatus = pageStatusEnum.Reimport;
                }
                else {
                    $scope.pageStatus = pageStatusEnum.ToImport;
                }

                $log.debug($scope.haveImported);
                $log.debug($scope.pageStatus);
                $log.debug($scope.showImportTable);
            }
        });

        $scope.showInitTable = true;//仅展示导入数据
        $scope.showImportTable = false; //选择导入后，显示excel sheet和colum mapping
        getCustomsInvoiceList(); 
        checkUserOrganizationPermissionList();
        $timeout(function () {
            $scope.isLoadComplete = true;
        }, 500);


        //验证信息数据源
        $scope.gridOptionsErrorMsg = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
              {
                  name: $translate.instant('Icon'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
              },
              {
                  name: $translate.instant('SequenceNo'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)" ><span>{{row.entity.index}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorResult'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)" ><span>{{row.entity.validationResult}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorCount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)" ><span>{{row.entity.number}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: '<div class="ui-grid-cell-contents" ng-dblClick="grid.appScope.showValidateDetails(row.entity)" ><span>{{row.entity.validationDetails}}<span></div>'
              },
              {
                  name: $translate.instant('ValidationTips'), width: '25%', cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}" ng-dblClick="grid.appScope.showValidateDetails(row.entity)"><span>{{row.entity.validationTips}}<span></div>'
              }
            ],
            onRegisterApi: function (gridApi) {
                $scope.errorGridApi = gridApi;

                $interval(function () {
                    $scope.errorGridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        $scope.gridOptionsIncomeInvoiceTotal = {
            //set gridview options
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            //set gridview header
            columnDefs: [
              {
                  name: $translate.instant('SequenceNo'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.seqNo}}<span></div>'
              },
              {
                  name: $translate.instant('CustomsPayNum'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.payNum}}<span></div>'
              },
              {
                  name: $translate.instant('CustomsIssueDate'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.issueDate | date:"yyyy-MM-dd" }}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceSE'), width: '15%', headerCellClass: 'right', cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.invoiceTaxAmount | number:2}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceJE'), width: '15%', headerCellClass: 'right', cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.invoiceAmount | number:2}}</span></div>'
              },
              {
                  name: $translate.instant('CustomsAuditResult'), width: '30%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.auditResult}}</span></div>'
              }
              //{
              //    name: $translate.instant('PeriodId'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodId}}</span></div>'
              //}
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiTotal = gridApi;
                $interval(function () {
                    $scope.gridApiTotal.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };


        //海关缴款书号重复弹出框数据源
        $scope.gridOptionsPayNumDuplicate = {
            enableColumnResizing: true,
            enableRowSelection: false,
            enableSelectAll: true,
            rowHeight: constant.UIGrid.rowHeight,
            enableRowHeaderSelection: true,
            modifierKeysToMultiSelect: true, //按住Ctrl才能多选 
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableFiltering: false,
            showTreeExpandNoChildren: false,
            enableFullRowSelection: false, //是否点击行任意位置后选中,默认为false
            multiSelect: true,// 是否可以选择多个,默认为true;
            columnDefs: [
               {
                   name: $translate.instant('CustomsPayNum'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding" ><span>{{row.entity.payNum}}</span></div>'
               },
               {
                   name: $translate.instant('CustomsIssueDate'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.issueDate | date:"yyyy-MM-dd" }}</span></div>'
               },
               {
                   name: $translate.instant('InvoiceSE'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.invoiceTaxAmount}}</span></div>'
               },
               {
                   name: $translate.instant('InvoiceJE'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.invoiceAmount}}</span></div>'
               },
               {
                   name: $translate.instant('CustomsAuditResult'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.auditResult}}</span></div>'
               },
               {
                   name: $translate.instant('InvoiceQJ'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.periodId}}</span></div>'
               }
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiPayNumDuplicate = gridApi;
                //$scope.gridApiPayNumDuplicate.core.handleWindowResize();

                $interval(function () {
                    $scope.gridApiPayNumDuplicate.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };


        
    })();
}]);
vatModule.directive('vatImportCustomInvoice', function () {
    return {
        restrict: 'E',
        //transclude: true,
        templateUrl: '/app/vat/import/vat-import-custom-invoice/vat-import-custom-invoice.html',
        scope: {},
        replace: true,
        controller: 'ImportCustomInvoiceCtrl'
    }

});
vatModule.controller('ImportDataCtrl', ['$scope', '$log', 'Upload', '$timeout', '$http', '$cookies', '$translate', '$interval', 'enums'
    , 'SweetAlert', 'dataImportService', 'vatImportService', 'modelConfigurationService'
    , 'vatSessionService', 'uiGridConstants', 'projectService', 'vatCommonService', 'vatOperationLogService', 'vatWorkflowService',
function ($scope, $log, Upload, $timeout, $http, $cookies, $translate, $interval, enums
    , SweetAlert, dataImportService, vatImportService, modelConfigurationService
    , vatSessionService, uiGridConstants, projectService, vatCommonService, vatOperationLogService, vatWorkflowService) {
    var apiTokenObj = $cookies.getObject('AtmsApiToken');
    var webHost = apiTokenObj.api_host;
    var fileGuid = ''; //保存上传文件后在server端生成的guid 
    var importMethod = ''; //oneClick:一键导入；universal：万能导入
    var importType = -1; //0:覆盖；1：添加
    var projectId = vatSessionService.project.id;
    var period = vatSessionService.month; //period < 0 覆盖导入时会删除所有数据
    var projectDbName = vatSessionService.project.dbName;
    var fileExtension = '';
    var fileNames = [];
    var token = $('input[name="__RequestVerificationToken"]').val();
    var CONST_ACEOLEDB = "Microsoft.ACE.OLEDB.12.0 is not registered"; 
    //上传文件有效后缀名
    var ValidFileExtension = {
        CSV: "csv",
        XLS: "xls",
        XLSX: "xlsx"
    }
    //对应PwC.Tax.Tech.Atms.Globals.Utils:ErpCheckType
    var ErpCheckTypeEnum = {
        Success : 0,
        ComBalanceAcctUnValidate : 1, 
        VoucherAcctValidate : 2, 
        VSingleDebitCreditUnValidate : 3,
        VEmptyCheckUnValidateItemID : 4,
        VEmptyCheckUnValidateGroup : 5,
        VEmptyCheckUnValidateAcctCode : 6,
        VEmptyCheckUnValidateSummary : 7,
        AcctBegBalAcctLevelUnValidate : 8,
        BegBalUnValidate : 9, 
        CompCustEndBalUnValidate : 10,
        CompCustAmountUnValidate : 11,
        CompCustBegBalUnValidate : 12,
        BegEndBalUnValidate : 13,
        DuplicatedVoucher: 14,
        DuplicatedTb: 15
    }
    var TbImportTypeEnum = {
        UnImported : 0,
        TbImported : 1,
        ErpImported : 2
    }

    var validteCategoryEnum = {
        Basic: 1,
        Correctness: 2,
        Duplicate:3
    }

    $scope.period = period;
    $scope.filePath = '';
    $scope.showUniversal = false;
    $scope.startNumber = -1;
    $scope.excelDownloadPath = webHost + '/Resource/ImportData/万能模板.xls';
    $scope.csvDownLoadPath = webHost + '/Resource/ImportData/csv万能模板.zip';
    $scope.duplicateList = [];
    $scope.basicCheckList = [];
    $scope.correctCheckList = [];
    var validteCategory = validteCategoryEnum.Basic;
    //写日志
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    $scope.moduleid = enums.vatModuleEnum.Import_Erpdata;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        OperationObject: $translate.instant('erpData'),
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.period,
    };

    //设置正确性、重复数据验证的错误提示图标
    $scope.setValidationErrorStyle = function (chkCorrect,checkDuplicate) {       
        var errorCount = 0;
        var duplicateNum = 0;
        var activeErrorStyle = {
            'background-image': 'url(/app-resources/images/vat/error.png)',
            'background-repeat': 'no-repeat',
            'background-position': 'right 5px center'
        }

        var inactiveErrorStyle = {
            'background-image': 'none'
        }

        if (chkCorrect) {
            for (var i = 1; i < $scope.correctCheckList.length; i++) {
                errorCount = $scope.correctCheckList[i][3]; //[3]: errorCount
                if (errorCount > 0) {
                    break;
                }
            }

            if (errorCount > 0) {
                return activeErrorStyle;
            }
            else {
                return inactiveErrorStyle;
            }
        }
        

        if (checkDuplicate) {
            for (var i = 1; i < $scope.duplicateList.length; i++) {
                duplicateNum = $scope.duplicateList[i][2]; //[2]: duplicateCount;
                if (duplicateNum > 0) {
                    break;
                }
            }

            if (duplicateNum > 0) {
                return activeErrorStyle;
            }
            else {
                return inactiveErrorStyle;
            }
        }
                                    
    };


    //点击一键/万能导入
    $scope.switch = function (index) {
        //一键导入
        if (index === 1) {
            $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');
            importMethod = 'oneClick';
            $scope.showUniversal = false;
            $scope.startNumber = -1;
            $('#btnOneClick').removeClass('disableBtn');
            $('#btnUniversal').addClass('disableBtn');
        }

        //万能导入
        if (index === 2) {
            $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');
            importMethod = 'universal';
            $scope.showUniversal = true;
            $scope.startNumber = 0;
            $('#btnUniversal').removeClass('disableBtn');
            $('#btnOneClick').addClass('disableBtn');
        }
    }


    //上传文件
    $scope.uploadFiles = function (files, errFiles) {
        $scope.f = files;
        $scope.showError = false;
        $scope.errFile = errFiles && errFiles[0];
        if (files && files.length) {
            fileNames = [];
            angular.forEach($scope.f, function (file) {
                fileNames.push(file.name);
            })
            $scope.filePath = fileNames.toString();//$scope.f[0].name;
            if (!checkUploadFiles($scope.f)) {
                return false;
            }

            Upload.upload({
                url: webHost + '/api/v1/financeImportData/importData/financeDataUpload',
                data: {
                    importMethod: importMethod,
                    file: files
                },
                headers: {
                    'Access-Control-Allow-Origin': '*',
                     Authorization: apiTokenObj.token_type + ' ' + apiTokenObj.access_token,
                     from: vatSessionService.project.dbName + '@cn.pwc.com'
                },
                __RequestVerificationToken: token,
                withCredentials: true
            }).then(function (response) {
                var ret = response.data;
                if (ret.result) {
                    fileGuid = ret.data.guid;
                    fileExtension = ret.data.fileExtension;                 
                    //swal({
                    //    title: $translate.instant('SuccessTitle'),
                    //    text: $translate.instant('UploadFileSuccess'),
                    //    type: "success",
                    //    confirmButtonText: $translate.instant('Confirm')
                    //});
                }
                else {
                    if (ret.resultMsg && ret.resultMsg.length > 0) {
                        swal({
                            title:$translate.instant('FailureTitle'),
                            text: $translate.instant('UploadFileFail') + ret.resultMsg,
                            type: "error",
                            confirmButtonText: $translate.instant('Confirm')
                        });
                        //alert(ret.resultMsg);
                    }
                }

                //$timeout(function () {
                //    file.result = response.data;
                //});

            }, function (response) {
                console.log('import error: ' + response.status);
                if (response.status > 0) {
                    //$scope.errorMsg = response.status + ': ' + response.data;
                    $log.debug('erp load file error:');
                    $log.debug(response.status + ': ' + response.data);
                }
                    

            }, function (evt) {
                //file.progress = Math.min(100, parseInt(100.0 *
                //                         evt.loaded / evt.total));
                $scope.progress =
                  Math.min(100, parseInt(100.0 * evt.loaded / evt.total));

            });
        }
        else {
            // $scope.showError = true;
        }

    }


    //导入财务数据
    $scope.importData = function (importTypeParam) {
        if ($scope.filePath == $translate.instant('ConfirmSelectErpImportFileTitle'))
        {
            swal({
                title: $translate.instant('ConfirmSelectErpImportFileTitle'),
                text: $translate.instant('ConfirmSelectErpImportFile'),
                type: "warning",
                confirmButtonText: $translate.instant('Yes')   
            });
            return false;
        }

        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Imported) {
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonText: $translate.instant('ConfirmYes'),
                cancelButtonText: $translate.instant('ConfirmNo'),
                closeOnConfirm: false,
                closeOnCancel: false
            },
            function (isConfirm) {
                if (isConfirm) {
                    swal.close();
                    startToImportErpData(importTypeParam);
                }
                else {               
                    swal.close();
                }
            });  
        }
        else {
            startToImportErpData(importTypeParam);
        }
            
            
        
    }


    //日志
    $scope.showOperateLogPop = function () {
        $scope.isShowLog = true;
    };


    function startToImportErpData(importTypeParam) {
        var importFileName = "";
        $scope.f.forEach(function (item, index) {
            importFileName += item.name;
        });
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = importFileName;
        if (importTypeParam === 0) { 
            logDto.OperationName = $translate.instant('ConvertErpData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
        }
        else if (importTypeParam === 1) {
            logDto.OperationName = $translate.instant('AppendErpData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
        }
       
        vatImportService.getImportType(projectId, period).success(function (data) {
            if (data === TbImportTypeEnum.UnImported || data === TbImportTypeEnum.ErpImported) {
                importErpData(importTypeParam);
            }

            if (data === TbImportTypeEnum.TbImported) {
                swal({
                    title: $translate.instant('ConfirmCleartTbTitle'),
                    text: $translate.instant('ConfirmTbDataToDelete'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                 function (isConfirm) {
                     //1. 清除TB导入数据
                     if (isConfirm) {
                         $log.debug("confirm to clear TB data");
                         vatImportService.deleteTbData(period)
                           .success(function (data) {
                               $log.debug("deleteTbData(period): ", data);
                               //2. 导入财务数据
                               if (data) {                                 
                                   importErpData(importTypeParam);
                               }
                               else {
                                   swal({
                                       title: $translate.instant('FailureTitle'),
                                       text: $translate.instant('ClearTbError'),
                                       type: "error",
                                       confirmButtonText: $translate.instant('Confirm')
                                   });
                               }
                           });
                     }
                 });
            }
        });
    }

    //校验界面
    $scope.openTab = function (evt, tabId) {
        var i, tabcontent, tablinks;
        //隐藏所有tabContent
        tabcontent = document.getElementsByClassName("tabContent");
        for (i = 0; i < tabcontent.length; i++) {
            tabcontent[i].style.display = "none";
        }

        //删除所有tab button中的active, inactive class
        tablinks = document.getElementsByClassName("tablinks");
        for (i = 0; i < tablinks.length; i++) {
            tablinks[i].className = tablinks[i].className.replace(" active", "");
            tablinks[i].className = tablinks[i].className.replace(" inactive", "");
            tablinks[i].className = tablinks[i].className.replace(" inactive-rightborder", "");   
        }

        //设置选中tab   
        document.getElementById(tabId).style.display = "block";
        evt.currentTarget.className += " active";

        //设置未选中tab
        for (i = 0; i < tablinks.length; i++) {
            if (tablinks[i].id != evt.currentTarget.id) {
                tablinks[i].className += " inactive";

                if ($("#btnCorrectChk").attr("class").indexOf(" active") === -1) {
                    if (_.isEqual(tablinks[i].id, "btnBasicChk")) {
                        tablinks[i].className += " inactive-rightborder";
                    }

                    if (_.isEqual(tablinks[i].id, "btnCorrectChk")) {
                        //基础数据验证和数据正确性验证都不可用时，只要基础数据验证加右边框就可以了
                        if ($("#btnBasicChk").attr("class").indexOf("inactive-rightborder") === -1) {
                            tablinks[i].className += " inactive-rightborder";
                        }
                    }
                }
                
            }            
        }

        //clearAllDataValidationArray();
        if (evt.currentTarget.id === "btnDuplicateData") {
            validteCategory = validteCategoryEnum.Duplicate;
            if ($scope.duplicateList.length === 0) {
                getDuplicateRecords();
            }
            
        }

        if (evt.currentTarget.id === "btnBasicChk") {
            validteCategory = validteCategoryEnum.Basic;
           if ($scope.basicCheckList.length === 0) {
                getBasicValidationRecords();
           }
            
        }

        if (evt.currentTarget.id === "btnCorrectChk") {
            validteCategory = validteCategoryEnum.Correctness;
           if ($scope.correctCheckList.length === 0) {
               getCorrectValidationRecords();
           }
        }
    }


    //双击查看验证详细数据
    $scope.checkDetailDbclick = function (evt) {
        //对应enum： ErpCheckType
        var erpCheckTypeId = -1;
        var errorCount = -1;
        if ($scope.basicCheckList.length > 0 && _.isEqual(validteCategory,validteCategoryEnum.Basic)) {          
            erpCheckTypeId = $scope.basicCheckList[evt.currentTarget.rowIndex][5];
            errorCount = $scope.basicCheckList[evt.currentTarget.rowIndex][3];
        }

        if ($scope.correctCheckList.length > 0 && _.isEqual(validteCategory,validteCategoryEnum.Correctness)) {
            erpCheckTypeId = $scope.correctCheckList[evt.currentTarget.rowIndex][5];
            errorCount = $scope.correctCheckList[evt.currentTarget.rowIndex][3];
        }
        
        if ($scope.duplicateList.length > 0 && _.isEqual(validteCategory,validteCategoryEnum.Duplicate)) {
            erpCheckTypeId = $scope.duplicateList[evt.currentTarget.rowIndex][3];
            errorCount = $scope.duplicateList[evt.currentTarget.rowIndex][2]; 
        }

        if (errorCount > 0) {
            getCheckDetails(erpCheckTypeId);
            if (erpCheckTypeId === ErpCheckTypeEnum.DuplicatedVoucher) {
                $('#duplicatedVouchers').modal('show');
            }
            else if (erpCheckTypeId === ErpCheckTypeEnum.DuplicatedTb) {
                $('#duplicatedTbes').modal('show');
            }
            else {
                $('#detailListModal').modal('show');
            }                  
        }
        else {
            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('ErpDetailWarning'),
                type: "warning",
                confirmButtonText: $translate.instant('Confirm')
            });
        }     
    }


    //删除选中的Voucher
    $scope.deleteDuplicateVouchers = function () {
        var selectedVouchers = $scope.gridApi.selection.getSelectedGridRows();
        $log.debug("get selected duplicated voucher details");
        $log.debug(selectedVouchers);
     
        if (selectedVouchers.length > 0) {
            var voucherIds = [];
            var voucherAccts = [];
            selectedVouchers.forEach(function(item,index){
                if (!_.isNull(item.entity.voucherID)) {
                    voucherIds.push(item.entity.voucherID);
                    voucherAccts.push(item.entity.acctCode);
                }
            });

            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = voucherAccts.join(",");
            logDto.OperationName = $translate.instant('DeleteVoucherDuplicate');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

            $log.debug("voucherIds ready to be deleted: " + voucherIds);
            //delete 
            dataImportService.deleteVoucherDuplicateItems(voucherIds)
              .success(function (data) {
                  $log.debug("delete duplicated vouchers results: " + data);
                  $('#duplicatedVouchers').modal('hide');
                  if (data) {
                      swal({
                          title: $translate.instant('SuccessTitle'),
                          text: $translate.instant('DeleteSuccess'),
                          type: "success",
                          timer: 1000
                      });

                      logDto.UpdateState = $translate.instant('DeleteSuccess');
                      vatOperationLogService.addOperationLog(logDto);
                      ReCheckAndManageData();
                  }        
                 
              });
        }
        else {
            logDto.UpdateState = $translate.instant('DeleteFailed');
            vatOperationLogService.addOperationLog(logDto);

            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('DeleteEmptyWarning'),
                type: "warning",
                confirmButtonText: $translate.instant('Confirm')
            });
        }
    }


    //删除选中的CustBalance
    $scope.deleteDuplicateTbes = function () {
        var selectedTbes = $scope.gridApiTb.selection.getSelectedGridRows();
        $log.debug("get selected duplicated custbalance details");
        $log.debug(selectedTbes);
        if (selectedTbes.length > 0) {
            var balanceIds = [];
            var balanceAccts = [];
            selectedTbes.forEach(function (item, index) {
                if (!_.isNull(item.entity.balanceId)) {
                    balanceIds.push(item.entity.balanceId);
                    balanceAccts.push(item.entity.acctCode);
                }
            });

            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = balanceAccts.join(",");
            logDto.OperationName = $translate.instant('DeleteCustBalanceDuplicate');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

            $log.debug("balanceIds ready to be deleted: " + balanceIds);
            //delete 
            dataImportService.deleteCustBalanceItems(balanceIds)
              .success(function (data) {
                  $log.debug("delete duplicated custbalance results: " + data);
                  $('#duplicatedTbes').modal('hide');
                  if (data) {
                      swal({
                          title: $translate.instant('SuccessTitle'),
                          text: $translate.instant('DeleteSuccess'),
                          type: "success",
                          timer: 1000
                      });
                      logDto.UpdateState = $translate.instant('DeleteSuccess');
                      vatOperationLogService.addOperationLog(logDto);
                      ReCheckAndManageData();
                  }
              });
        }
        else {
            logDto.UpdateState = $translate.instant('DeleteFailed');
            vatOperationLogService.addOperationLog(logDto);

            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('DeleteEmptyWarning'),
                type: "warning",
                confirmButtonText: $translate.instant('Confirm')
            });
        }
    }
    
    
    //检查用户机构权限
    $scope.checkUserOrganizationPermissionList = function () {
        var list = [];
        var userManageTemp = constant.vatPermission.dataImport.erpImport;
        list.push(userManageTemp.importCode);
        $scope.hasImportPermission = false;
        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {                     
            $scope.hasImportPermission = data[userManageTemp.importCode];        
        });
    };


    //根据hasImportPermission设置按钮的样式
    $scope.setButtonSetByPermission = function () {
        if (!$scope.hasImportPermission) {
            return { cursor: "not-allowed" };
        }
        else {
            return { cursor: "default" };
        }
    };


    //清理数据校验的数组
    function clearAllDataValidationArray() {
        $log.debug("start to clear all data validation array");
        $scope.duplicateList = [];
        $scope.basicCheckList = [];
        $scope.correctCheckList = [];
    }


    //导入数据
    function importErpData(importTypeParam) {
        $log.debug("start to import data");
        importType = importTypeParam;
        $http({
            method: 'POST',
            url: webHost + '/api/v1/financeImportData/importData/importFinancedata',
            params: {
                importMethod: importMethod,
                importType: importType,
                fileName: fileNames,
                fileGuid: fileGuid,
                fileExtension: fileExtension,
                period: period
            },
            headers: {
                'Access-Control-Allow-Origin': '*',
                Authorization: apiTokenObj.token_type + ' ' + apiTokenObj.access_token,
                from: vatSessionService.project.dbName + '@cn.pwc.com'
            },
            __RequestVerificationToken: token,
            withCredentials: true
        }).then(function successCallback(response) {
            var ret = response.data;
            if (ret.result) {
                swal({
                    title:$translate.instant('SuccessTitle'),
                    text: $translate.instant('ImportErpDataSuccess'),
                    type: "success",
                    timer: 1000           
                });
                $log.debug("import data successfully,start to update project import type");
                logDto.UpdateState = $translate.instant('ImportSuccess');
                vatOperationLogService.addOperationLog(logDto);
                updateProjectImportType();
                clearAllDataValidationArray();                   
                vatCommonService.importSetProjectStatus(projectDbName, period
                                                        , constant.DictionaryDictKey.WFImportErpData
                                                        , enums.FinishStatusEnum.Finished);
                vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isErpImport, true);
                $log.debug("import erp importErpData: " + vatSessionService.project.importSubStatus.isErpImport);
                startManageData(period);               
                $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');; //还原导入文件路径
                $scope.isImportTypeErp = true;
                
            }
            else {
                $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');//还原导入文件路径; //清理导入文件路径
                if (ret.resultMsg && ret.resultMsg.length > 0) {
                    var errorMessages = "";
                    var popUpErrorMsg = "";
                    ret.data.forEach(function (item, index) {
                        errorMessages = errorMessages + "\r\n" + item.errorMsg;
                    });
                    //出错信息中包含CONST_ACEOLEDB的话，弹出特殊提示
                    errorMessages = errorMessages.toLowerCase();
                    if (errorMessages.indexOf(CONST_ACEOLEDB.toLowerCase()) > 0) {
                        popUpErrorMsg = $translate.instant('ACEOLEDBUnInstallError');
                    }
                    else {
                        popUpErrorMsg = $translate.instant('ImportErpDataFail') + ret.resultMsg;
                    }

                    logDto.UpdateState = $translate.instant('FailureTitle');
                    vatOperationLogService.addOperationLog(logDto);

                    swal({
                        title: $translate.instant('FailureTitle'),
                        text: popUpErrorMsg,
                        type: "error",
                        confirmButtonText: $translate.instant('Confirm')
                    });
                }

            }
        }, function errorCallback(response) {
            $log.debug('erp import data error');
            $log.debug(response);
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }


    //上传文件格式验证
    function checkUploadFiles(files) {
        var result = true;
        for (var i = 0; i < files.length; i++) {
            var item = files[i];
            var fileName = item.name;
            var fileExtension = fileName.substr(fileName.lastIndexOf(".") + 1, fileName.length - fileName.lastIndexOf(".")).toLowerCase();
            if (fileExtension !== ValidFileExtension.CSV
              && fileExtension !== ValidFileExtension.XLS
              && fileExtension !== ValidFileExtension.XLSX) {
                swal({
                    title: $translate.instant('WarningTitle'),
                    text:  $translate.instant('ErpUploadFileExtensionCheck'),
                    type:  "warning",
                    confirmButtonText: $translate.instant('Confirm')
                });
                result = false;
            }

            if (fileName.length >= 30) {
                SweetAlert.warning($translate.instant('FileNameTooLong'));
                result = false;
            }
        }
  
        return result;
    }


    //组装重复数据验证数据
    function initDuplicateRecords(or) {
        //添加title
        var data = or.data;
        $scope.duplicateList = [];
        var duplicateTitleDto = [];
        duplicateTitleDto.push($translate.instant('Num'));
        duplicateTitleDto.push($translate.instant('TableName'));
        duplicateTitleDto.push($translate.instant('DuplicateNum'));
        duplicateTitleDto.push($translate.instant('ErpCheckTypeId'));
        $scope.duplicateList.push(duplicateTitleDto);

        data.forEach(function (item, index) {
            var duplicateDto = [];
            if (duplicateTitleDto.indexOf($translate.instant('Num')) !== -1) {
                duplicateDto.push(item.num);
            }

            if (duplicateTitleDto.indexOf($translate.instant('TableName')) !== -1) {
                duplicateDto.push(item.tableName);
            }

            if (duplicateTitleDto.indexOf($translate.instant('DuplicateNum')) !== -1) {
                duplicateDto.push(item.duplicateCount);
            }

            if (duplicateTitleDto.indexOf($translate.instant('ErpCheckTypeId')) !== -1) {
                duplicateDto.push(item.erpCheckTypeId);
            }

            $scope.duplicateList.push(duplicateDto);
        });


        if (or.resultMsg === constant.ValidationMessag.ReValidate) {
            vatWorkflowService.addErpImportExceptionMessage(projectDbName, period, enums.validationType.ErpDuplicate)
                .success(function (or) {
                    if (or.result) {
                        $log.debug("send erp duplicate validation message successfully");
                    }
                });
        }

    }


    //重复数据验证
    function getDuplicateRecords() {
        dataImportService.getDuplicateResults().success(function (or) {
            initDuplicateRecords(or);
          });
    }


    //组装基础校验数据
    function initBasicValicationsRecords(or)
    {
        var data = or.data;
        $scope.basicCheckList = [];
        //添加Title
        var basicChkTilteDto = [];
        basicChkTilteDto.push($translate.instant('Num'));
        basicChkTilteDto.push($translate.instant('ImagePic'));
        basicChkTilteDto.push($translate.instant('DataCheckType'));
        basicChkTilteDto.push($translate.instant('ErrorCount'));
        basicChkTilteDto.push($translate.instant('Tips'));
        basicChkTilteDto.push($translate.instant('ErpCheckTypeId'));
        $scope.basicCheckList.push(basicChkTilteDto);

        data.forEach(function (item, index) {
            var basicChkDto = [];
            if (basicChkTilteDto.indexOf($translate.instant('Num')) !== -1) {
                basicChkDto.push(item.num);
            }


            if (basicChkTilteDto.indexOf($translate.instant('ImagePic')) !== -1) {
                basicChkDto.push(item.imagePic);
            }

            if (basicChkTilteDto.indexOf($translate.instant('DataCheckType')) !== -1) {
                basicChkDto.push(item.dataCheckType);
            }

            if (basicChkTilteDto.indexOf($translate.instant('ErrorCount')) !== -1) {
                basicChkDto.push(item.errorCount);
            }

            if (basicChkTilteDto.indexOf($translate.instant('Tips')) !== -1) {
                basicChkDto.push(item.tips);
            }


            if (basicChkTilteDto.indexOf($translate.instant('ErpCheckTypeId')) !== -1) {
                basicChkDto.push(item.erpCheckTypeId);
            }

            $scope.basicCheckList.push(basicChkDto);
        });

        if (or.resultMsg === constant.ValidationMessag.ReValidate) {
            vatWorkflowService.addErpImportExceptionMessage(projectDbName, period, enums.validationType.ErpBasicCheck)
                .success(function (or) {
                    if (or.result) {
                        $log.debug("send erp basic validation message successfully");
                    }
                });
        }
    }


    //基础数据验证
    function getBasicValidationRecords() {
        dataImportService.getBasicValidationResults()
          .success(function (or) {
              if (or.result) {
                  initBasicValicationsRecords(or);                
              }
              
          });
    }


    //组装数据正确性验证
    function initCorrectValidationRecords(or) {
        //添加Title
        var data = or.data;
        $scope.correctCheckList = [];
        var crtTitleDto = [];
        crtTitleDto.push($translate.instant('Num'));
        crtTitleDto.push($translate.instant('ImagePic'));
        crtTitleDto.push($translate.instant('DataCheckType'));
        crtTitleDto.push($translate.instant('ErrorCount'));
        crtTitleDto.push($translate.instant('Tips'));
        crtTitleDto.push($translate.instant('ErpCheckTypeId'));
        $scope.correctCheckList.push(crtTitleDto);

        data.forEach(function (item, index) {
            var crtValication = [];
            if (crtTitleDto.indexOf($translate.instant('Num')) !== -1) {
                crtValication.push(item.num);
            }

            if (crtTitleDto.indexOf($translate.instant('ImagePic')) !== -1) {
                crtValication.push(item.imagePic);
            }

            if (crtTitleDto.indexOf($translate.instant('DataCheckType')) !== -1) {
                crtValication.push(item.dataCheckType);
            }

            if (crtTitleDto.indexOf($translate.instant('ErrorCount')) !== -1) {
                crtValication.push(item.errorCount);
            }

            if (crtTitleDto.indexOf($translate.instant('Tips')) !== -1) {
                crtValication.push(item.tips);
            }

            if (crtTitleDto.indexOf($translate.instant('ErpCheckTypeId')) !== -1) {
                crtValication.push(item.erpCheckTypeId);
            }
            $scope.correctCheckList.push(crtValication);
        });

        if (or.resultMsg === constant.ValidationMessag.ReValidate) {
            vatWorkflowService.addErpImportExceptionMessage(projectDbName, period, enums.validationType.ErpCorrect)
                .success(function (or) {
                    if (or.result) {
                        $log.debug("send erp correctness validation message successfully");
                    }
                });
        }
    }


    //数据正确性验证
    function getCorrectValidationRecords() {
        dataImportService.getCorrectValidationResults(period).success(function (or) {
              initCorrectValidationRecords(or);
        });
    }


    //运行所有校验并选中基础数据验证
    function getAllValidationResults(isManage) {
        dataImportService.getBasicValidationResults().success(function (or) {
            initBasicValicationsRecords(or);
            dataImportService.getCorrectValidationResults(period).success(function (or) {
                initCorrectValidationRecords(or);
                dataImportService.getDuplicateResults().success(function (or) {
                    initDuplicateRecords(or);
                    triggBasicCheck();
                    $scope.setValidationErrorStyle(true, false);
                    $scope.setValidationErrorStyle(false, true);
                    if (isManage) {
                        SweetAlert.success($translate.instant('ManageDataSuccess'));
                    }                  
                });
            });
        });
    }


    //1.数据整理
    function startManageData(period) {      
        dataImportService.manageData(period).success(function (data) {
            getAllValidationResults(true);
        });
    }


    //根据erpCheckTypeId初始化不同的详细数据
    function getCheckDetails(erpCheckTypeId) {
        $scope.checkDetails = [];
        //试算平和表中的科目不在企业科目列表中
        if (erpCheckTypeId === ErpCheckTypeEnum.ComBalanceAcctUnValidate) {
            dataImportService.getAccountsNotInCompanyBalance()
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailAcct(data);
              });
        }

        //Voucher中的科目不存在于科目表中
        if (erpCheckTypeId === ErpCheckTypeEnum.VoucherAcctValidate) {
            dataImportService.getAccountsNotInVoucherDetails()
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailAcct(data);
              });
        }

        //单个凭证借贷平衡
        if (erpCheckTypeId === ErpCheckTypeEnum.VSingleDebitCreditUnValidate) {
            dataImportService.getSingleVoucherCheck()
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
              });
        }
           
        //Voucher ItemID 为空
        if (erpCheckTypeId === ErpCheckTypeEnum.VEmptyCheckUnValidateItemID) {
            dataImportService.getVoucherEmptyCheck(true, false, false, false, false)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
              });
        }

        //Voucher Group 为空
        if (erpCheckTypeId === ErpCheckTypeEnum.VEmptyCheckUnValidateGroup) {
            dataImportService.getVoucherEmptyCheck(false, false, true, false, false)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
              });
        }

        //Voucher AccontCode 为空
        if (erpCheckTypeId === ErpCheckTypeEnum.VEmptyCheckUnValidateAcctCode) {
            dataImportService.getVoucherEmptyCheck(false, false, false, true, false)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
              });
        }

        //Voucher Summary 为空
        if (erpCheckTypeId === ErpCheckTypeEnum.VEmptyCheckUnValidateSummary) {
            dataImportService.getVoucherEmptyCheck(false,false,false,false,true)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
            });
        }

        //试算平衡表中期初余额上下级不平衡
        if (erpCheckTypeId === ErpCheckTypeEnum.AcctBegBalAcctLevelUnValidate) {
            dataImportService.getAccountBegBalances(period)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailAcct(data);
              });
        }

        //试算平衡表中期初余额借贷不平衡
        if (erpCheckTypeId === ErpCheckTypeEnum.BegBalUnValidate) {
            dataImportService.getBegBalancesByPeriod(period)
              .success(function (data) {
                  //title
                  var detailTitleDto = [];
                  detailTitleDto.push($translate.instant('BegDebitBal'));
                  detailTitleDto.push($translate.instant('BegCreditBal'));
                  $scope.checkDetails.push(detailTitleDto);

                  //body
                  var detailDto = [];
                  if (detailTitleDto.indexOf($translate.instant('BegDebitBal')) !== -1) {
                      data.forEach(function (item, index) {
                          if (item.direction == "1") {
                              detailDto.push(item.begBal);
                          }
                      });                    
                  }

                  if (detailTitleDto.indexOf($translate.instant('BegCreditBal')) !== -1) {
                      data.forEach(function (item, index) {
                          if (item.direction == "-1") {
                              detailDto.push(item.begBal);
                          }
                      });
                  }                 
                  $scope.checkDetails.push(detailDto);
              });
        }

        //原始/计算期末余额比较 
        if (erpCheckTypeId === ErpCheckTypeEnum.CompCustEndBalUnValidate) {
            var isExistedEndBal = false;
            dataImportService.getCompCustBalanceDetail(period, period)
              .success(function (data) {
                  dataImportService.isComBalanceEndBalNotZero(period)
                    .success(function (enddata) {
                        isExistedEndBal = enddata;
                        $scope.checkDetails = initCheckDetailCompareEndBal(isExistedEndBal, data);
                    })
              });
        }

        //原始/计算发生额比较
        if (erpCheckTypeId === ErpCheckTypeEnum.CompCustAmountUnValidate) {
            dataImportService.compareCompCustPeriodAmount(period, period)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailCompareAmount(data);
              });
        }

        //上月期末与导入的本月期初
        if (erpCheckTypeId === ErpCheckTypeEnum.BegEndBalUnValidate) {
            var isExistedEndBal = false;
            dataImportService.compareCustEndCompBeg(period, period)
              .success(function (data) {
                  dataImportService.isComBalanceEndBalNotZero(period)
                    .success(function (endData) {
                        isExistedEndBal = endData;
                        $scope.checkDetails = initCheckDetailEndBalCompare(isExistedEndBal, data);                     
                    });
              });
        }


        //凭证重复
        if (erpCheckTypeId === ErpCheckTypeEnum.DuplicatedVoucher) {
            dataImportService.getDuplicateVouchers()
              .success(function (data) {              
                  $log.debug("set duplicated voucher details data");
                  $scope.gridUiDuplicateVouchers.data = data;
                  $log.debug($scope.gridUiDuplicateVouchers.data);
              });
        }

        //CustBalance重复
        if (erpCheckTypeId === ErpCheckTypeEnum.DuplicatedTb) {
            dataImportService.getCustBalanceDuplicateItems()
              .success(function (data) {
                  $log.debug("set duplicated custbalance details data");
                  $scope.gridUiDuplicateTbes.data = data;
                  $log.debug($scope.gridUiDuplicateTbes.data);
              });
        }
    }


    //初始化Voucher相关的详细信息
    function initCheckDetailByVoucher(data) {
        var detailTitleDto = [];
        var voucherDetails = [];
        //title       
        detailTitleDto.push($translate.instant('AccountCode'));
        detailTitleDto.push($translate.instant('JournalKHDM'));
        detailTitleDto.push($translate.instant('vid'));
        detailTitleDto.push($translate.instant('vGroup'));
        detailTitleDto.push($translate.instant('period'));
        detailTitleDto.push($translate.instant('itemID'));
        detailTitleDto.push($translate.instant('JournalZY'));
        detailTitleDto.push($translate.instant('JournalJFJE'));
        detailTitleDto.push($translate.instant('JournalDFJE'));
        
        voucherDetails.push(detailTitleDto);

        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function(item,index){
            var detailDto = [];
            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.acctCode);
            }

            if (detailTitleDto.indexOf($translate.instant('JournalKHDM')) !== -1) {
                detailDto.push(item.customerCode);
            }

            if (detailTitleDto.indexOf($translate.instant('vid')) !== -1) {
                detailDto.push(item.vid);
            }

            if (detailTitleDto.indexOf($translate.instant('vGroup')) !== -1) {
                detailDto.push(item.group);
            }

            if (detailTitleDto.indexOf($translate.instant('period')) !== -1) {
                detailDto.push(item.period);
            }

            if (detailTitleDto.indexOf($translate.instant('itemID')) !== -1) {
                detailDto.push(item.itemID);
            }

            if (detailTitleDto.indexOf($translate.instant('JournalZY')) !== -1) {
                detailDto.push(item.summary);
            }

            if (detailTitleDto.indexOf($translate.instant('JournalJFJE')) !== -1) {
                detailDto.push(item.debit);
            }

            if (detailTitleDto.indexOf($translate.instant('JournalDFJE')) !== -1) {
                detailDto.push(item.credit);
            }
                     
            voucherDetails.push(detailDto);
        });
       
        return voucherDetails;
    }


    //初始话科目相关的详细信息
    function initCheckDetailAcct(data)
    {
        //title
        var detailTitleDto = [];
        var acctDetails = [];
        detailTitleDto.push($translate.instant('AccountCode'));
        acctDetails.push(detailTitleDto);
        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function (item, index) {
            var detailDto = [];
            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.acctCode);
            }
            acctDetails.push(detailDto);
        });                 
       
        return acctDetails
    }


    //初始化上月期末与导入的本月期初校验的详细信息
    function initCheckDetailEndBalCompare(isEndBal, data) {
        var detailTitleDto = [];
        var compareDetails = [];

        //title
        detailTitleDto.push($translate.instant('PeriodId'));
        detailTitleDto.push($translate.instant('AccountCode'));
        detailTitleDto.push($translate.instant('AccountName'));
         
        if (isEndBal) {
            detailTitleDto.push($translate.instant('LastPeriodEndBal'));
            detailTitleDto.push($translate.instant('CurrentPeriodEndBal'));
            detailTitleDto.push($translate.instant('BalDiff'));
        }
        else {
            detailTitleDto.push($translate.instant('LastPeriodEndDebitBal'));
            detailTitleDto.push($translate.instant('LastPeriodEndCreditBal'));
            detailTitleDto.push($translate.instant('CurrentPeriodBegDebitBal'));
            detailTitleDto.push($translate.instant('CurrentPeriodBegCreditBal'));
            detailTitleDto.push($translate.instant('DebitBalDiff'));
            detailTitleDto.push($translate.instant('CreditBalDiff'));
        }
        compareDetails.push(detailTitleDto);
        
        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function (item, index) {
            var detailDto = [];

            if (detailTitleDto.indexOf($translate.instant('PeriodId')) !== -1) {
                detailDto.push(item.periodId);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.accountCode);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountName')) !== -1) {
                detailDto.push(item.accountName);
            }

            if (isEndBal) {
                if (detailTitleDto.indexOf($translate.instant('LastPeriodEndBal')) !== -1) {
                    detailDto.push(item.custEndBal);
                }

                if (detailTitleDto.indexOf($translate.instant('CurrentPeriodEndBal')) !== -1) {
                    detailDto.push(item.comBegBal);
                }

                if (detailTitleDto.indexOf($translate.instant('BalDiff')) !== -1) {
                    detailDto.push(item.begBalDiff);
                }

            }
            else {

                if (detailTitleDto.indexOf($translate.instant('LastPeriodEndDebitBal')) !== -1) {
                    detailDto.push(item.custEndDebitBal);
                }

                if (detailTitleDto.indexOf($translate.instant('LastPeriodEndCreditBal')) !== -1) {
                    detailDto.push(item.custEndCreditBal);
                }

                if (detailTitleDto.indexOf($translate.instant('CurrentPeriodBegDebitBal')) !== -1) {
                    detailDto.push(item.comBegDebitBal);
                }

                if (detailTitleDto.indexOf($translate.instant('CurrentPeriodBegCreditBal')) !== -1) {
                    detailDto.push(item.comBegCreditBal);
                }

                if (detailTitleDto.indexOf($translate.instant('DebitBalDiff')) !== -1) {
                    detailDto.push(item.begDebitDiff);
                }

                if (detailTitleDto.indexOf($translate.instant('CreditBalDiff')) !== -1) {
                    detailDto.push(item.begCreditDiff);
                }
            }
            compareDetails.push(detailDto);
        });
        
        return compareDetails;
    }


    //初始化原始/计算发生额的详细信息
    function initCheckDetailCompareAmount(data) {
        var detailTitleDto = [];
        var amountsDetails = [];

        //title
        detailTitleDto.push($translate.instant('PeriodId'));
        detailTitleDto.push($translate.instant('AccountCode'));
        detailTitleDto.push($translate.instant('AccountName'));
        detailTitleDto.push($translate.instant('ComDebitBal'));
        detailTitleDto.push($translate.instant('ComCreditBal'));
        detailTitleDto.push($translate.instant('CustDebitBal'));
        detailTitleDto.push($translate.instant('CustCreditBal'));
        detailTitleDto.push($translate.instant('DebitBalDiff'));
        detailTitleDto.push($translate.instant('CreditBalDiff'));
        amountsDetails.push(detailTitleDto);

        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function (item, index) {
            var detailDto = [];

            if (detailTitleDto.indexOf($translate.instant('PeriodId')) !== -1) {
                detailDto.push(item.periodId);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.accountCode);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountName')) !== -1) {
                detailDto.push(item.accountName);
            }

            if (detailTitleDto.indexOf($translate.instant('ComDebitBal')) !== -1) {
                detailDto.push(item.comDebitBal.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('ComCreditBal')) !== -1) {
                detailDto.push(item.comCreditBal.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('CustDebitBal')) !== -1) {
                detailDto.push(item.custDebitBal.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('CustCreditBal')) !== -1) {
                detailDto.push(item.custCreditBal.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('DebitBalDiff')) !== -1) {
                detailDto.push(item.debitBalDiff.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('DebitBalDiff')) !== -1) {
                detailDto.push(item.creditBalDiff.toFixed(2));
            }

            amountsDetails.push(detailDto);
        });

        return amountsDetails;
    }


    //初始化原始/计算期末余额的详细信息
    function initCheckDetailCompareEndBal(isEndBal, data) {
        var detailTitleDto = [];
        var compareDetails = [];

        //title
        detailTitleDto.push($translate.instant('PeriodId'));
        detailTitleDto.push($translate.instant('AccountCode'));
        detailTitleDto.push($translate.instant('AccountName'));

        if (isEndBal) {
            detailTitleDto.push($translate.instant('ComEndBal'));
            detailTitleDto.push($translate.instant('CustEndBal'));
            detailTitleDto.push($translate.instant('BalDiff'));
        }
        else {
            detailTitleDto.push($translate.instant('ComDebitBal'));
            detailTitleDto.push($translate.instant('ComCreditBal'));
            detailTitleDto.push($translate.instant('CustDebitBal'));
            detailTitleDto.push($translate.instant('CustCreditBal'));
            detailTitleDto.push($translate.instant('DebitBalDiff'));
            detailTitleDto.push($translate.instant('CreditBalDiff'));
        }
        compareDetails.push(detailTitleDto);

        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function (item, index) {
            var detailDto = [];

            if (detailTitleDto.indexOf($translate.instant('PeriodId')) !== -1) {
                detailDto.push(item.periodId);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.accountCode);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountName')) !== -1) {
                detailDto.push(item.accountName);
            }

            if (isEndBal) {
                if (detailTitleDto.indexOf($translate.instant('ComEndBal')) !== -1) {
                    detailDto.push(item.comEndBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('CustEndBal')) !== -1) {
                    detailDto.push(item.custEndBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('BalDiff')) !== -1) {
                    detailDto.push(item.endDiff.toFixed(2));
                }

            }
            else {

                if (detailTitleDto.indexOf($translate.instant('ComDebitBal')) !== -1) {
                    detailDto.push(item.comEndDebitBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('ComCreditBal')) !== -1) {
                    detailDto.push(item.comEndCreditBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('CustDebitBal')) !== -1) {
                    detailDto.push(item.custEndDebitBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('CustCreditBal')) !== -1) {
                    detailDto.push(item.custEndCreditBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('DebitBalDiff')) !== -1) {
                    detailDto.push(item.debitBalDiff.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('CreditBalDiff')) !== -1) {
                    detailDto.push(item.creditBalDiff.toFixed(2));
                }
            }
            compareDetails.push(detailDto);
        });

        return compareDetails;
    } 


    //初始化重复Voucher弹出框
    function initUiGvVoucherDupDetails() {
        $scope.gridUiDuplicateVouchers = {
            //set gridview options
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            enableRowSelection: true,
            enableSelectAll: true,
            multiSelect: true,
            enableColumnResizing: true,
            columnDefs: [
                  {
                      name: $translate.instant('period'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.period}}<span></div>'
                  },
                  {
                      name: $translate.instant('vGroup'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.group}}<span></div>'
                  },
                  {
                      name: $translate.instant('vid'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.vid}}<span></div>'
                  },
                  {
                      name: $translate.instant('itemID'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.itemID}}</span></div>'
                  },
                  {
                      name: $translate.instant('AccountCode'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode}}<span></div>'
                  },
                  {
                      name: $translate.instant('JournalZY'), width: '30%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.summary}}<span></div>'
                  },
                  {
                      name: $translate.instant('DebitBal'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.debit}}<span></div>'
                  },
                  {
                      name: $translate.instant('CreditBal'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.credit}}<span></div>'
                  }                 
                  //{
                  //    name: $translate.instant('VoucherID'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.voucherID}}</span></div>'
                  //}
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;

                // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                $interval(function () {
                    $scope.gridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);

                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    var msg = 'row selected ' + row.isSelected;
                    $log.debug(msg);
                });

                gridApi.selection.on.rowSelectionChangedBatch($scope, function (rows) {
                    var msg = 'rows changed ' + rows.length;
                    $log.debug(msg);
                });
            }
        };

        $scope.gridUiDuplicateVouchers.data = [];
    }
    

    //初始化重复Tb弹出框
    function initUiGvTbDupDetails() {
        $scope.gridUiDuplicateTbes = {
            //set gridview options
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            enableRowSelection: true,
            enableSelectAll: true,
            multiSelect: true,
            columnDefs: [
                  {
                      name: $translate.instant('period'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodId}}<span></div>'
                  },
                  {
                      name: $translate.instant('AccountCode'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode}}<span></div>'
                  },
                  {
                      name: $translate.instant('JournalKHDM'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.customerCode}}<span></div>'
                  },
                  {
                      name: $translate.instant('BegDebitBal'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.begDebitBal}}<span></div>'
                  },
                  {
                      name: $translate.instant('BegCreditBal'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.begCreditBal}}<span></div>'
                  }, 
                  {
                      name: $translate.instant('BegBal'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.begBal}}<span></div>'
                  }
                               
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiTb = gridApi;

                // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                $interval(function () {
                    $scope.gridApiTb.core.handleWindowResize();
                }, 500, 60 * 60 * 8);

                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    //var msg = 'row selected ' + row.isSelected;
                    //$log.debug(msg);
                });

                gridApi.selection.on.rowSelectionChangedBatch($scope, function (rows) {
                    //var msg = 'rows changed ' + rows.length;
                    //$log.debug(msg);
                });
            }
        };

        $scope.gridUiDuplicateTbes.data = [];
    }


    //更新TaxAdmin中dbo.PeriodInfo.ImportType
    function updateProjectImportType() {
        var queryImportDto = {
            serviceTypeId: constant.serviceType.VAT,
            periods: [period],
            projectId: projectId,
            importTypeId: enums.TbImportTypeEnum.ErpImported
        }

        vatImportService.updatePeriodStatus(queryImportDto)
          .success(function (data) {
              $log.debug("vatImportService.updatePeriodStatus complete");
          });
    }


    //重新校验和整理数据
    function ReCheckAndManageData() {
        $log.debug("star to recheck and remanage data");         
        dataImportService.reManageData(period).success(function (data) {
            if (data) {
                $log.debug("remanage data successfully");
                getAllValidationResults(true);
            }
        });
    }


    function triggBasicCheck() {
        //默认选中基础校验
        setTimeout(function () {
            $('#btnBasicChk').trigger('click');
        }, 1000);
    }
    

    function getPeriodInfor() {
        vatImportService.getImportType(vatSessionService.project.id, period).success(function (data) {
            $scope.isImportTypeErp = enums.projectImportType.ErpImported === data ? true : false;                          
        });
    }

    //默认显示万能导入   
    $scope.switch(2);
    $scope.checkUserOrganizationPermissionList();
    getPeriodInfor();
    getAllValidationResults(false);
    initUiGvVoucherDupDetails();
    initUiGvTbDupDetails();


}]);
//vatModule.directive('vatImportErp', ['$log',
//    function ($log) {    
//        return {
//            restrict: 'E',
//            templateUrl: '/app/vat/import/vat-import-erpdata/vat-import-erpdata.html',                      
//            replace: true,
//            scope: {},
//            //controller: 'VatImportLayoutController',
//            link: function ($scope, $element, $attr) {

//            }
//        };
//    }
//]);


//var importData = angular.module('importData', ['ngFileUpload']);


vatModule.directive('vatImportErp', function () {
    return {
        restrict: 'E',
        //transclude: true,
        templateUrl: '/app/vat/import/vat-import-erpdata/vat-import-erpdata.html',
        scope: {},
        replace: true,
        controller: 'ImportDataCtrl'
    }

});

vatModule.controller('VatImportIncomeInvoiceController', ['$scope', '$log', 'loginContext', '$translate', 'apiInterceptor', 'Upload', 'SweetAlert', 'vatImportService', '$timeout', '$q', 'uiGridConstants', '$interval', 'vatSessionService', 'enums', 'vatOperationLogService', 'projectService', 'vatCommonService',
function ($scope, $log, loginContext, $translate, apiInterceptor, Upload, SweetAlert, vatImportService, $timeout, $q, uiGridConstants, $interval, vatSessionService, enums, vatOperationLogService, projectService, vatCommonService) {
    'use strict';

    var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
    var successCount = 0;
    $scope.chunkSize = 100000;
    var resumable = true;
    $scope.columnNum = 0;
    $scope.detailColumnNum = 0;
    var curPeriod = vatSessionService.month;
    var curYear = vatSessionService.project.year;
    var projectDbName = vatSessionService.project.dbName;

    $scope.showImportTable = false;//是否显示导入table
    $scope.showInitTable = false;//是否显示初始数据ui-grid
    $scope.showInputInvoiceErrorTable = false;//是否显示错误信息列表

    $scope.showImprotItemTable = false;
    $scope.showInitItemTable = false;
    $scope.showInputInvoiceItemErrorTable = false;//是否显示错误信息列表


    //写日志
    //导入方式
    $scope.importEnum = { Import: 0, CoverImport: 1, AddImport: 2 };
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    $scope.period = vatSessionService.month;
    $scope.moduleid = enums.vatModuleEnum.Import_InputInvoice;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        //OperationObject: $translate.instant('IncomeInvoiceTitle'),
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.period,
    };


    var validationErrorType = {
        ColumnsMapErrorType: $translate.instant('ColumnsMapErrorType'),
        InvoiceInfoEmptyCheckErrorType: $translate.instant('InvoiceInfoEmptyCheckErrorType'),
        InvoiceTypeEmptyCheckErrorType: $translate.instant('InvoiceTypeEmptyCheckErrorType'),
        CertificationDateEmptyCheckErrorType: $translate.instant('CertificationDateEmptyCheckErrorType'),
        InvoiceDateEmptyCheckErrorType: $translate.instant('InvoiceDateEmptyCheckErrorType'),
        AmountNumberCheckErrorType: $translate.instant('AmountNumberCheckErrorType'),
        TaxAmountNumberCheckErrorType: $translate.instant('TaxAmountNumberCheckErrorType'),
        TaxRateNumberCheckErrorType: $translate.instant('TaxRateNumberCheckErrorType'),
        InvoiceDateErrorType: $translate.instant('InvoiceDateErrorType'),
        CertificationDateFormatCheckErrorType: $translate.instant('CertificationDateFormatCheckErrorType'),
        CertificationDateRangeCheckErrorType: $translate.instant('CertificationDateRangeCheckErrorType'),
        OnlyInvoiceItemCheckErrorType: $translate.instant('OnlyInvoiceItemCheckErrorType'),
        StartRowError: $translate.instant('StartRowError'),
        NumOutRangeErrorType: $translate.instant('NumOutRangeErrorType'),
        OutputStringLengthType: $translate.instant('OutputStringLengthType'),
        InvoiceTypeErrorType: $translate.instant('InvoiceTypeErrorType'),
        InvoiceItemInfoEmptyCheckErrorType: $translate.instant('InvoiceItemInfoEmptyCheckErrorType')
    };

    var invoiceTypeEnum = {
        VATInvoice: $translate.instant('VATInvoice'),
        FreightTransport: $translate.instant('FreightTransport'),
        MotorVehicle: $translate.instant('MotorVehicle'),
        AgriculturalProduct: $translate.instant('AgriculturalProduct')
    };

    //定义进项发票类型数组
    var arrInvoiceTypeEnum = [
        $translate.instant('VATInvoice'),
        $translate.instant('FreightTransport'),
        $translate.instant('MotorVehicle'),
        $translate.instant('AgriculturalProduct')];

    //初始化ack-pagination
    $scope.pagingOptions = {
        pageIndex: 1, //当前页码
        totalItems: 0, //总数据
        totalPages: 10, //总页数
        maxSize: 5, //分页数字的限制。
        pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
        pageSizeString: constant.page.pageSizeArrary[3].toString(),
        firstPage: $translate.instant('PagingFirstPage'),
        previousPage: $translate.instant('PagingPreviousPage'),
        nextPage: $translate.instant('PagingNextPage'),
        lastPage: $translate.instant('PagingLastPage'),
    };

    $scope.totalData = {
        totalNumber: 0,
        amount: 0,
        taxAmount: 0
    };

    //根据当前的月份获取当月第一天日期
    var getCurrentMonthFirstDay = function () {
        var curMonth = curPeriod;
        if (curPeriod < 10) {
            curMonth = '0' + curPeriod;
        }
        var oneDay = 1000 * 60 * 60 * 8;
        return new Date(new Date(curYear + '-' + curMonth + '-' + '01') - oneDay)
    };

    //根据当前的月份获取当月的最后一天日期（实际获取的是下月的第一天00：00：00，因此在判断时应设置为小于而不是小于等于）
    var getCurrentMonthLastDay = function () {
        var curMonth = curPeriod;
        if (curPeriod < 10) {
            curMonth = '0' + curPeriod;
        }
        var date = new Date(curYear + '-' + curMonth + '-' + '01');
        var currentMonth = date.getMonth();
        var nextMonth = ++currentMonth;
        var nextMonthFirstDay = new Date(date.getFullYear(), nextMonth, 1);
        return new Date(nextMonthFirstDay);
    };


    //转换发票类型
    function translateInvoiceType(strType) {
        var type = 1;
        switch (strType) {
            case invoiceTypeEnum.VATInvoice:
                type = 1;
                break;
            case invoiceTypeEnum.FreightTransport:
                type = 2;
                break;
            case invoiceTypeEnum.MotorVehicle:
                type = 3;
                break;
            case invoiceTypeEnum.AgriculturalProduct:
                type = 4;
                break;
            default:
                type = 1;
        }
        return type;
    }


    /****************************************汇总表function start*************************************************/


    //初始化列数据
    var initColumns = function () {
        //初始化进项发票汇总表列名
        $scope.incomeInvoiceTotalColumns = [
            $translate.instant('PleaseSelectColumn'),
            $translate.instant('InvoiceFPDM'),
            $translate.instant('InvoiceFPHM'),
            $translate.instant('InvoiceKPRQ'),
            $translate.instant('InvoiceGHFSH'),
            $translate.instant('InvoiceJE'),
            $translate.instant('InvoiceSE'),
            $translate.instant('InvoiceRZRQ'),
            $translate.instant('InvoiceRZJG'),
            $translate.instant('InvoiceFPLX')
        ];


        $scope.initIncomeInvoiceTotalColumnsIndex = _.range(1, $scope.incomeInvoiceTotalColumns.length);

        //必须进行map的列
        $scope.mustMappingTotalColumns = [
            //$translate.instant('PleaseSelectColumn'),
            $translate.instant('InvoiceFPDM'),
            $translate.instant('InvoiceFPHM'),
            $translate.instant('InvoiceKPRQ'),
            $translate.instant('InvoiceGHFSH'),
            $translate.instant('InvoiceJE'),
            $translate.instant('InvoiceSE'),
            $translate.instant('InvoiceRZRQ'),
            $translate.instant('InvoiceRZJG'),
            $translate.instant('InvoiceFPLX')
        ];
    };

    //从数据库中load数据，如果有，则页面导入按钮为覆盖导入或追加导入，否则为导入按钮
    var loadIncomeInvoiceDataFromDB = function () {
        vatImportService.getInputInvoiceList(curPeriod).success(function (data) {
            if (data) {
                $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
                var index = 1;
                var amountSum = 0;
                var taxAmountSum = 0;
                data.forEach(function (v) {
                    v.index = index++;
                    if (!_.isNaN(parseFloat(v.amount) && !_.isNaN(parseFloat(v.taxAmount)))) {
                        amountSum += v.amount;
                        taxAmountSum += v.taxAmount;
                    }
                    v.amount = PWC.round(v.amount, 2);
                    v.taxAmount = PWC.round(v.taxAmount, 2);
                });

                initPagingControl(data.length);
                $scope.totalData.totalNumber = data.length;
                $scope.totalData.amount = PWC.round(amountSum, 2);
                $scope.totalData.taxAmount = PWC.round(taxAmountSum, 2);
                var skipCount = ($scope.pagingOptions.pageIndex - 1) * $scope.pagingOptions.pageSize;
                var pagingData = _.chain(data).rest(skipCount).first($scope.pagingOptions.pageSize).value();

                $scope.initIncomeInvoiceList = pagingData;
                $scope.gridOptionsIncomeInvoiceTotal.data = pagingData;
                $scope.queryIncomeInvoiceResult = pagingData;
                if (pagingData.length >= 0) {
                    if (pagingData.length > 0) {
                        $scope.isShowImportTotalBtn = false;
                    }
                    $scope.showInitTable = true;
                    $scope.showImportTable = false;
                }

                //获取错误列表信息
                getInputInvoiceValidationList().then(function () {
                    if ($scope.gridOptionsInputInvoiceErrorMsg.data.length > 0) {
                        showInputInvoiceErrTab();
                        $scope.toggleInputInvoiceErrorTab();

                        //当有错误信息时，显示错误信息表
                        $scope.showInputInvoiceErrorTable = true;
                    }
                    else {
                        $scope.InputInvoiceImportErrorTab = false;
                        $scope.InputInvoiceImportErrorTag = false;
                        $scope.showInputInvoiceErrorTable = false;
                    }
                });
            }
        });

    };

    //发票信息汇总数据表选择列名事件
    //parentIndex：当前列号
    //index：下拉列表中选项的序号
    var mappingColumn = function (parentIndex, index, colName) {
        if (colName) {

            var oldColumn = $scope.selectedColumnMap[parentIndex];
            var newColumn = $scope.incomeInvoiceTotalColumns[index];

            //如果新的选择项与老的选择项一致，则不进行操作
            if (oldColumn === newColumn) {
                return;
            }
            else {
                $scope.selectedColumnMap[parentIndex] = colName;

                if (colName !== $translate.instant('PleaseSelectColumn')) {
                    //如果当前选择的不是"请选择列名",则将选项从数组中移除
                    $scope.incomeInvoiceTotalColumns.splice(index, 1);

                    if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                        //将老的选项追加到选项列表中
                        $scope.incomeInvoiceTotalColumns.push(oldColumn);
                    }
                }
                else {
                    //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                    if (oldColumn) {
                        $scope.incomeInvoiceTotalColumns.push(oldColumn);
                    }
                }
            }
        }
        $log.debug($scope.selectedColumnMap);
    };

    //设置上传文件的文件名
    var updateIncomeInvoceTotalFileName = function (newValue) {
        $scope.fileName = newValue.name;
    };

    var token = $('input[name="__RequestVerificationToken"]').val();
    //上传文件
    var doUploadIncomeInvoiceTotalFile = function (file) {
        if (file) {
            var arr = file.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.initIncomeInvoiceList = [];
            $scope.gridOptionsIncomeInvoiceTotal.data = [];
            successCount = 0;
            if (!file.$error) {
                var tempFileName = PWC.newGuid() + '.dat';
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        filename: file.name,
                        tempFileName: tempFileName,
                        file: file
                    },
                    resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(uploadIncomeInvoiceTotalSuccess);
            }
        }
    };

    //上传成功后执行函数
    var uploadIncomeInvoiceTotalSuccess = function (resp) {
        successCount++;
        if (successCount === 1) {
            $scope.tempFileName = resp.data;
            //初始化到excel文件的第一个sheet
            changeIncomeInvoiceSheet(0);
        }
    };

    //初始化需要展示的sheet
    var changeIncomeInvoiceSheet = function (selectedSheet) {
        var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
            return num.name === selectedSheet.name;
        })
        $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
        refreshIncomeInvoiceTable();
    };

    //重新load页面上的table
    var refreshIncomeInvoiceTable = function () {
        $scope.showImportTable = true;
        $scope.showInitTable = false;
        $scope.showInputInvoiceErrorTable = false;

        if (_.isString($scope.tempFileName)) {
            $scope.selectedColumnMap = [];
            $scope.columnNum = 0;
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, $scope.sheetInfo.topRowNumber).success(function (data) {
                //将导入文件的sheet赋值到数组
                $scope.sheetData = data;
                //加入index序号
                var index = 1;
                data.dataList.forEach(function (v) {
                    v.index = index++;
                });
                var sheetNameObjectArray = [];
                data.sheetNameList.forEach(function (v) {
                    sheetNameObjectArray.push({ 'name': v });
                });

                $scope.sheetData.sheetNameList = sheetNameObjectArray;

                $scope.columnNum = data.dataList[0] ? data.dataList[0].length : $scope.columnNum;
                $scope.firstDataRow = data.dataList[0];
                $scope.startRowList = _.range(data.lastRowIndex);
                $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                initColumns();

                vatSessionService.dataChanged = true; //设置为true表示在切换页面前数据有变更, 需要提示

                if (data && data.result === false) {
                    SweetAlert.warning(data.resultMsg);
                    return;
                }
            });
        }
    };

    //对导入数据进行验证(前端)
    var FrontEndValidIncomeInvoiceData = function (inputInvoiceList) {

        //2.验证关键字段不为空（发票代码，发票号码，认证日期，开票日期）
        //3.验证数据格式是否正确（金额，税额，认证日期，开票日期）
        if (!KeyColumnsEmptyValidIncomeInvoice(inputInvoiceList)) {
            return;
        }
    };

    //1.判断是否有没有map的必须列和起始行输入格式是否正确
    var ColumnsMapCheckIncomeInvoice = function () {
        var result = true;
        //1：判断是否有没有map的必须列
        var notMappedColumns = '';
        if ($scope.selectedColumnMap.length >= 0) {
            var count1 = 0;
            $scope.mustMappingTotalColumns.forEach(function (m) {
                if (m !== $translate.instant('PleaseSelectColumn')) {
                    if ($.inArray(m, $scope.selectedColumnMap) < 0) {
                        notMappedColumns += m + ',';
                        count1++;
                    }
                }
            });
            if (count1) {
                result = false;
                //加入到错误列表中
                $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.ColumnsMapErrorType,
                        'errorCount': count1,
                        'errorContent': $translate.instant('ColumnsMapErrorMsg').formatObj({ columns: notMappedColumns.substring(0, notMappedColumns.length - 1) })
                    });
            }
        }
        //2:判断起始行输入框输入内容是否合理
        var startNumberCheckMsg = '';
        var startRowNum = $('#StartRowNum').val();
        if (startRowNum === '') {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
        }
        else if (parseInt(startRowNum) > $scope.sheetData.dataList.length) {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
        }
        return result;
    };

    //2.验证关键字段不为空（发票代码，发票号码，认证日期，开票日期）
    var KeyColumnsEmptyValidIncomeInvoice = function (inputInvoiceList) {
        var result = true;
        //#region 定义错误信息以及错误数量

        //发票信息
        var invoiceInfoEmptyCheckMsg = '';
        var invoiceInfoEmptyCheckCount = 0;
        //发票类型
        var invoiceTypeEmptyCheckMsg = '';
        var invoiceTypeEmptyCheckCount = 0;

        //认证日期
        var certificationDateEmptyCheckMsg = '';
        var certificationDateEmptyCheckCount = 0;
        //开票日期
        var invoiceDateEmptyCheckMsg = '';
        var invoiceDateEmptyCheckCount = 0;

        //金额正确性验证
        var amountNumberCheckMsg = '';
        var amountNumberCheckCount = 0;

        //税额正确性验证
        var taxAmountNumberCheckMsg = '';
        var taxAmountNumberCheckCount = 0;

        //认证日期格式验证
        var certificationDateCheckMsg = '';
        var certificationDateCheckCount = 0;
        //开票日期格式验证
        var invoiceDateCheckMsg = '';
        var invoiceDateCheckCount = 0;
        //认证日期与选定区间不符
        var certificationDateRangeCheckMsg = '';
        var certificationDateRangeCheckCount = 0;

        //字符长度过长验证
        var stringOverLengthCheckMsg = '';
        var stringOverLengthCheckCount = 0;

        //数值范围验证
        var numOutRangeCheckMsg = '';
        var numOutRangeCheckCount = 0;

        //发票类型错误
        var invoiceTypeCheckMsg = '';
        var invoiceTypeCheckCount = 0;

        //#endregion

        //#region 验证错误

        inputInvoiceList.forEach(function (m) {

            //发票信息
            if (PWC.isNullOrEmpty(m.InvoiceCode) || PWC.isNullOrEmpty(m.InvoiceNumber) || PWC.isNullOrEmpty(m.InvoiceType)) {
                invoiceInfoEmptyCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceInfoEmptyCheckErrorMsg') + ';<br />';
                invoiceInfoEmptyCheckCount++;
            }
            else {
                //发票代码过长超过50个字符
                if (PWC.getStringLength(m.InvoiceCode) > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceFPDM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
                //发票号码过长超过50个字符
                if (PWC.getStringLength(m.InvoiceNumber) > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceFPHM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }


            //发票类型
            if (!PWC.isNullOrEmpty(m.InvoiceType)) {
                //发票类型过长超过50个字符
                if (PWC.getStringLength(m.InvoiceType) > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceFPLX') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
                else {
                    //如果发票类型不在指定的发票类型数组中，则提示错误
                    if ($.inArray(m.InvoiceType, arrInvoiceTypeEnum) === -1) {
                        invoiceTypeCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceFPLX') + $translate.instant('InvoiceTypeErrorMsg') + ';<br />';
                        invoiceTypeCheckCount++;
                    }
                    else {
                        m.InvoiceType = translateInvoiceType(m.InvoiceType);
                    }
                }
            }

            //销方识别号过长超过50个字符
            if (PWC.getStringLength(m.SellerTaxNumber) > constant.validateLength.StringLength_50) {
                stringOverLengthCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceGHFSH') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                stringOverLengthCheckCount++;
            }
            //认证结果过长超过50个字符
            if (PWC.getStringLength(m.CertificationResult) > constant.validateLength.StringLength_50) {
                stringOverLengthCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceRZJG') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                stringOverLengthCheckCount++;
            }
            //认证日期
            if (PWC.isNullOrEmpty(m.CertificationDate)) {
                certificationDateEmptyCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('CertificationDateNullMsg') + ';<br />';
                certificationDateEmptyCheckCount++;
            }
            else {
                //判断认证日期格式是否正确
                if (!PWC.checkDate(m.CertificationDate)) {
                    certificationDateCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('CertificationDateFormatMsg') + ';<br />';
                    certificationDateCheckCount++;
                }
                //else {
                //    //如果认证日期不在选定期间
                //    if (!(new Date(m.CertificationDate.replace(/[\.-]/g, '/')) >= getCurrentMonthFirstDay() && new Date(m.CertificationDate.replace(/[\.-]/g, '/')) < getCurrentMonthLastDay())) {
                //        certificationDateRangeCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('CertificationDateCheckErrorMsg') + ';<br />';;
                //        certificationDateRangeCheckCount++;
                //    }
                //}
            }

            //开票日期
            if (PWC.isNullOrEmpty(m.InvoiceDate)) {
                invoiceDateEmptyCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceDateNullMsg') + ';<br />';
                invoiceDateEmptyCheckCount++;
            }
            else {
                //判断开票日期格式是否正确
                if (!PWC.checkDate(m.InvoiceDate)) {
                    invoiceDateCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceDateErrorMsg') + ';<br />';
                    invoiceDateCheckCount++;
                }
            }

            //判断金额是否为数字
            if (isNaN(parseFloat(m.Amount))) {
                amountNumberCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('AmountNumberCheckErrorMsg') + ';<br />';
                amountNumberCheckCount++;
            }
                //如果在规定的数值范围外，则提示错误
            else if (parseFloat(m.Amount) < constant.startNum || parseFloat(m.Amount) > constant.endNum) {
                numOutRangeCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceJE') + $translate.instant('NumOverLengthMsg') + ';<br />';
                numOutRangeCheckCount++;
            }
            else {
                m.Amount = PWC.round(m.Amount, 2);
            }

            //判断税额是否为数字
            if (isNaN(parseFloat(m.TaxAmount))) {
                taxAmountNumberCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('TaxAmountNumberCheckErrorMsg') + ';<br />';;
                taxAmountNumberCheckCount++;
            }
                //如果在规定的数值范围外，则提示错误
            else if (parseFloat(m.TaxAmount) < constant.startNum || parseFloat(m.TaxAmount) > constant.endNum) {
                numOutRangeCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceSE') + $translate.instant('NumOverLengthMsg') + ';<br />';
                numOutRangeCheckCount++;
            }
            else {
                m.TaxAmount = PWC.round(m.TaxAmount, 2);
            }
        });

        //#endregion

        //#region 将错误信息push到列表中

        //push发票信息空信息到错误列表
        if (invoiceInfoEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceInfoEmptyCheckErrorType,
                    'errorCount': invoiceInfoEmptyCheckCount,
                    'errorContent': invoiceInfoEmptyCheckMsg
                });
        }
        //push发票类型空信息到错误列表
        if (invoiceTypeEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceTypeEmptyCheckErrorType,
                    'errorCount': invoiceTypeEmptyCheckCount,
                    'errorContent': invoiceTypeEmptyCheckMsg
                });
        }
        //push发票类型错误信息到错误列表
        if (invoiceTypeCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceTypeErrorType,
                    'errorCount': invoiceTypeCheckCount,
                    'errorContent': invoiceTypeCheckMsg
                });
        }
        //push认证日期空信息到错误列表
        if (certificationDateEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.CertificationDateEmptyCheckErrorType,
                    'errorCount': certificationDateEmptyCheckCount,
                    'errorContent': certificationDateEmptyCheckMsg
                });
        }
        //push开票日期空信息到错误列表
        if (invoiceDateEmptyCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceDateEmptyCheckErrorType,
                    'errorCount': invoiceDateEmptyCheckCount,
                    'errorContent': invoiceDateEmptyCheckMsg
                });
        }
        //push金额错误信息到错误列表
        if (amountNumberCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.AmountNumberCheckErrorType,
                    'errorCount': amountNumberCheckCount,
                    'errorContent': amountNumberCheckMsg
                });
        }
        //push税额错误信息到错误列表
        if (taxAmountNumberCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.TaxAmountNumberCheckErrorType,
                    'errorCount': taxAmountNumberCheckCount,
                    'errorContent': taxAmountNumberCheckMsg
                });
        }
        //push认证日期错误信息到错误列表
        if (certificationDateCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.CertificationDateFormatCheckErrorType,
                    'errorCount': certificationDateCheckCount,
                    'errorContent': certificationDateCheckMsg
                });
        }
        //push开票日期错误信息到错误列表
        if (invoiceDateCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceDateErrorType,
                    'errorCount': invoiceDateCheckCount,
                    'errorContent': invoiceDateCheckMsg
                });
        }
        //push认证日期不在导入期间的错误信息到错误列表
        if (certificationDateRangeCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.CertificationDateRangeCheckErrorType,
                    'errorCount': certificationDateRangeCheckCount,
                    'errorContent': certificationDateRangeCheckMsg
                });
        }
        //push字符串长度过长错误信息到错误列表
        if (stringOverLengthCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.OutputStringLengthType,
                    'errorCount': stringOverLengthCheckCount,
                    'errorContent': stringOverLengthCheckMsg
                });
        }
        //push数值超出范围信息到错误列表
        if (numOutRangeCheckCount > 0) {
            result = false;
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.NumOutRangeErrorType,
                    'errorCount': numOutRangeCheckCount,
                    'errorContent': numOutRangeCheckMsg
                });
        }

        //#endregion

        return result;
    };

    function doImportInputInvoiceData(importType) {
        if (!$scope.fileName) {
            SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
            return;
        }

        var importType = importType;//0：第一次导入，1：覆盖导入，2：追加导入

        //设置数据导入时的起始行,默认设置从第一行开始
        var startRowNum = 1;
        if ($('#StartRowNum').val()) {
            startRowNum = $('#StartRowNum').val();
        }


        //验证前，将错误数据清空
        $scope.errorMsgMap = [];

        //判断是否有没有map的必须列和起始行输入格式是否正确
        if (!ColumnsMapCheckIncomeInvoice()) {
            $('#errorListModal').modal('show');
            return;
        }

        //将需要导入的数据组装到list中
        var inputInvoiceList = [];
        for (var i = startRowNum - 1; i < $scope.sheetData.dataList.length; i++) {
            var invoiceInfo = {
                'Index': $scope.sheetData.dataList[i].index,//行号
                'PeriodID': curPeriod,
                'InvoiceCode': $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceFPDM'), $scope.selectedColumnMap)],
                'InvoiceNumber': $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceFPHM'), $scope.selectedColumnMap)],
                'InvoiceDate': $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceKPRQ'), $scope.selectedColumnMap)],
                'SellerTaxNumber': $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceGHFSH'), $scope.selectedColumnMap)],
                'Amount': PWC.isNullOrEmpty($scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceJE'), $scope.selectedColumnMap)]) ?
                    0 : $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceJE'), $scope.selectedColumnMap)],
                'TaxAmount': PWC.isNullOrEmpty($scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceSE'), $scope.selectedColumnMap)]) ?
                    0 : $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceSE'), $scope.selectedColumnMap)],
                'CertificationDate': $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceRZRQ'), $scope.selectedColumnMap)],
                'CertificationResult': $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceRZJG'), $scope.selectedColumnMap)],
                'InvoiceType': $scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceFPLX'), $scope.selectedColumnMap)]
                //translateInvoiceType($scope.sheetData.dataList[i][$.inArray($translate.instant('InvoiceFPLX'), $scope.selectedColumnMap)])
            };
            inputInvoiceList.push(invoiceInfo);
        }



        //前台数据验证
        FrontEndValidIncomeInvoiceData(inputInvoiceList);

        if ($scope.errorMsgMap.length > 0) {
            $('#errorListModal').modal('show');
            return;
        }
        else {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            logDto.OperationObject = $translate.instant('IncomeInvoiceTotal');
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportInputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            }
            else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportInputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            }
            else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportInputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }


            vatImportService.importInputInvoiceData(inputInvoiceList, importType).success(function (or) {
                if (or && or.result) {
                    logDto.UpdateState = $translate.instant('ImportSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    vatCommonService.importSetProjectStatus(projectDbName, curPeriod, constant.DictionaryDictKey.WFImportIncomeInvoice
                                                            , enums.FinishStatusEnum.Finished);
                    vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isInputInvoiceImport, true);
                    $log.debug("import inputInvoice importInputInvoiceData: " + vatSessionService.project.importSubStatus.isInputInvoiceImport);

                    SweetAlert.success($translate.instant('ImportSuccess'));
                    loadIncomeInvoiceDataFromDB();
                    $scope.fileName = '';
                    vatSessionService.dataChanged = $scope.showInitItemTable ? false : true;//设置为false表示在切换页面前数据没有变更,不需要提示
                }
            }).error(function () {
                logDto.UpdateState = $translate.instant('ImportFail');
                vatOperationLogService.addOperationLog(logDto);
            });
        }
    }
    
    //点击导入按钮时，进行导入操作
    var importInputInvoiceData = function (importType) {
        if (vatSessionService.project.projectStatusList[curPeriod] >= constant.ProjectStatusEnum.Generated) {
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[curPeriod])}),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doImportInputInvoiceData(importType);
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doImportInputInvoiceData(importType);
        }
    };

    //动态设置grid高度
    $scope.getGridTotalHeight = function () {
        if ($scope.isLoadInputInvoiceComplete) {
            return { height: ($('#input-invoice-grid-wrapper').height()) + "px" };
        }
        else {
            return { height: 0 + "px" };
        }
    };

    //刷新发票汇总信息（重新验证）
    var refreshInputInvoiceData = function () {
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = '';
        logDto.OperationName = $translate.instant('RefreshInputInvoiceValidationData');
        logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
        logDto.OperationObject = $translate.instant('IncomeInvoiceTotal');

        vatImportService.validateInputInvoiceInfo(curPeriod).success(function () {
            logDto.UpdateState = $translate.instant('RefreshSuccess');
            vatOperationLogService.addOperationLog(logDto);

            $('#inputInvoiceDuplicateItemModal').modal('hide');
            SweetAlert.success($translate.instant('RefreshSuccess'));
            loadIncomeInvoiceDataFromDB();
        }).error(function () {
            logDto.UpdateState = $translate.instant('RefreshTbFail');
            vatOperationLogService.addOperationLog(logDto);

            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });

        vatSessionService.dataChanged = $scope.showInitItemTable ? false : true;
    };

    //清除当期发票汇总信息（同时会清掉发票明细数据）
    var clearInputInvoiceData = function () {
        swal({
            title: "warning!",
            text: $translate.instant('InputInvoiceClearTips'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#DD6B55",
            confirmButtonText: $translate.instant('Yes'),
            cancelButtonText: $translate.instant('No'),
            closeOnConfirm: true,
            closeOnCancel: true
        }, function (isConfirm) {
            if (isConfirm) {
                logDto.ID = PWC.newGuid();
                logDto.CreateTime = new Date();
                logDto.UpdateTime = new Date();
                logDto.OperationContent = '';
                logDto.OperationName = $translate.instant('ClearInputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;
                logDto.OperationObject = $translate.instant('IncomeInvoiceTotal');

                vatImportService.clearInputInvoiceData(curPeriod).success(function (data) {
                    if (data && data.result) {
                        logDto.UpdateState = $translate.instant('ClearSuccess');
                        vatOperationLogService.addOperationLog(logDto);

                        vatCommonService.clearProjectStatus(projectDbName, curPeriod, constant.DictionaryDictKey.WFImportIncomeInvoice
                                                            , enums.FinishStatusEnum.NotFinished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isInputInvoiceImport, false);
                        $log.debug("clear inputInvoice clearInputInvoiceData: " + vatSessionService.project.importSubStatus.isInputInvoiceImport);
                        SweetAlert.success($translate.instant('ClearSuccess'));
                        loadIncomeInvoiceDataFromDB();
                        loadIncomeInvoiceItemDataFromDB();
                        $scope.isShowImportTotalBtn = true;
                        $scope.isShowImportItemBtn = true;
                    }
                    else {
                        logDto.UpdateState = $translate.instant('ClearFailed');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.warning($translate.instant('ClearFailed'));
                    }
                }).error(function () {
                    logDto.UpdateState = $translate.instant('ClearFailed');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        });
    };

    //获取发票汇总验证信息
    var getInputInvoiceValidationList = function () {
        var deferred = $q.defer();

        vatImportService.getValidationDtoInfo(enums.validationType.InputVoice, curPeriod).success(function (data) {
            if (data.length > 0) {
                var index = 1;
                data.forEach(function (v) {
                    v.index = index++;
                });
                $scope.gridOptionsInputInvoiceErrorMsg.data = data;
            }
            else {
                $scope.gridOptionsInputInvoiceErrorMsg.data = [];
            }
            deferred.resolve();
        });

        return deferred.promise;
    }

    var showInputInvoiceErrTab = function () {
        $scope.InputInvoiceImportErrorTab = true;//默认显示顶部block
        $scope.InputInvoiceImportErrorTag = true;//默认隐藏下方的错误信息列表
        $scope.inputInvoiceErrorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.gridOptionsInputInvoiceErrorMsg.data.length });

    };

    $scope.toggleInputInvoiceErrorTab = function () {
        $scope.InputInvoiceImportErrorTag = !$scope.InputInvoiceImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.InputInvoiceImportErrorTag) {
            setInputInvoiceErrorWrapCssDefault();
        } else {

            if (parseInt($('#input-invoice-content-resizer').css('bottom')) < 100) {
                $('#input-invoice-content-resizer').css('bottom', '130px');
                $('#input-invoice-error-info-wrapper').css('height', '130px');
            }
        }
    };

    var setInputInvoiceErrorWrapCssDefault = function () {
        $('#input-invoice-content-resizer').css('bottom', '20px');
        $('#input-invoice-error-info-wrapper').css('height', '0px');
    };

    //获取发票汇总错误信息grid高度
    $scope.getInputInvoiceErrorGridHeight = function () {
        if ($scope.isLoadInputInvoiceComplete) {
            var y = $("#input-invoice-error-info-wrapper").height();

            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: y + "px" };
            } else {

                return { height: '0px' };
            }
        }

        return {};
    };

    //查看汇总发票日志
    var showInputInvoiceOperateLogPop = function () {
        $scope.isShowInputInvoiceLog = true;
    };

    /****************************************汇总表function end*************************************************/


    /****************************************明细表function start*************************************************/

    //初始化明细表列数据
    var initDetailColumns = function () {
        //初始化进项发票汇总表列名
        $scope.incomeInvoiceDetailColumns = [
            $translate.instant('PleaseSelectColumn'),
            $translate.instant('InvoiceFPDM'),
            $translate.instant('InvoiceFPHM'),
            $translate.instant('InvoiceJE'),
            $translate.instant('InvoiceSE'),
            $translate.instant('InvoiceSL'),
            $translate.instant('InvoiceHWMC')
        ];

        $scope.initIncomeInvoiceDetailColumnsIndex = _.range(1, $scope.incomeInvoiceDetailColumns.length);

        //必须进行map的列
        $scope.mustMappingItemColumns = [
            $translate.instant('InvoiceFPDM'),
            $translate.instant('InvoiceFPHM'),
            $translate.instant('InvoiceJE'),
            $translate.instant('InvoiceSE'),
            $translate.instant('InvoiceSL'),
            $translate.instant('InvoiceHWMC')
        ];
    };

    //从数据库中load数据，如果有，则页面导入按钮为覆盖导入或追加导入，否则为导入按钮
    var loadIncomeInvoiceItemDataFromDB = function () {
        vatImportService.getInputInvoiceItemList(curPeriod).success(function (data) {
            if (data) {
                $scope.sheetDataItem = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
                var index = 1;
                data.forEach(function (v) {
                    v.index = index++;
                    v.amount = PWC.round(v.amount, 2);
                    v.taxAmount = PWC.round(v.taxAmount, 2);
                });
                $scope.initIncomeInvoiceDetailList = data;
                $scope.gridOptionsIncomeInvoiceItem.data = data;
                $scope.queryIncomeInvoiceItemResult = data;
                if (data.length >= 0) {
                    if (data.length > 0) {
                        $scope.isShowImportItemBtn = false;
                    }
                    $scope.showInitItemTable = true;
                    $scope.showImportItemTable = false;
                }

                //获取错误列表信息
                getInputInvoiceItemValidationList().then(function () {
                    if ($scope.gridOptionsInputInvoiceItemErrorMsg.data.length > 0) {
                        showInputInvoiceItemErrTab();
                        $scope.toggleInputInvoiceItemErrorTab();

                        //当有错误信息时，显示错误信息表
                        $scope.showInputInvoiceItemErrorTable = true;
                    }
                    else {
                        $scope.InputInvoiceItemImportErrorTab = false;
                        $scope.InputInvoiceItemImportErrorTag = false;
                        $scope.showInputInvoiceItemErrorTable = false;
                    }
                });
            }
        });
    };

    //发票信息汇总数据表选择列名事件
    //parentIndex：当前列号
    //index：下拉列表中选项的序号
    var mappingDetailColumn = function (parentIndex, index, colName) {
        if (colName) {

            var oldColumn = $scope.selectedColumnMapItem[parentIndex];
            var newColumn = $scope.incomeInvoiceDetailColumns[index];

            //如果新的选择项与老的选择项一致，则不进行操作
            if (oldColumn === newColumn) {
                return;
            }
            else {
                $scope.selectedColumnMapItem[parentIndex] = colName;

                if (colName !== $translate.instant('PleaseSelectColumn')) {
                    //如果当前选择的不是"请选择列名",则将选项从数组中移除
                    $scope.incomeInvoiceDetailColumns.splice(index, 1);

                    if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                        //将老的选项追加到选项列表中
                        $scope.incomeInvoiceDetailColumns.push(oldColumn);
                    }
                }
                else {
                    //如果当前选中的是"请选择列名",则将该列原来的列名追加到选项列表中
                    if (oldColumn) {
                        $scope.incomeInvoiceDetailColumns.push(oldColumn);
                    }
                }
            }
        }
        $log.debug($scope.selectedColumnMapItem);
    };

    //设置上传文件的文件名
    var updateIncomeInvoceDetailFileName = function (newValue) {
        $scope.detailFileName = newValue.name;
    };

    //上传文件
    var doUploadIncomeInvoiceDetailFile = function (file) {
        if (file) {
            var arr = file.name.split('.');
            if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            }
            $scope.initIncomeInvoiceDetailList = [];
            $scope.gridOptionsIncomeInvoiceItem.data = [];
            successCount = 0;
            if (!file.$error) {
                var tempFileName = PWC.newGuid() + '.dat';
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        filename: file.name,
                        tempFileName: tempFileName,
                        file: file
                    },
                    resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(uploadIncomeInvoiceDetailSuccess);
            }
        }
    };

    //上传成功后执行函数
    var uploadIncomeInvoiceDetailSuccess = function (resp) {
        successCount++;
        if (successCount === 1) {
            $scope.tempDetailFileName = resp.data;
            //初始化到excel文件的第一个sheet
            changeIncomeInvoiceDetailSheet(0);
        }
    };

    //初始化需要展示的sheet
    var changeIncomeInvoiceDetailSheet = function (selectedSheet) {
        var sheetIndex = _.findIndex($scope.sheetDataItem.sheetNameList, function (num) {
            return num.name === selectedSheet.name;
        })
        $scope.sheetInfoDetail.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
        refreshIncomeInvoiceDetailTable();
    };

    //重新load页面上的table
    var refreshIncomeInvoiceDetailTable = function () {
        $scope.showImportItemTable = true;
        $scope.showInitItemTable = false;
        $scope.showInputInvoiceItemErrorTable = false;

        if (_.isString($scope.tempDetailFileName)) {
            $scope.selectedColumnMapItem = [];
            $scope.detailColumnNum = 0;
            $scope.sheetDataItem = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            vatImportService.getFileContent($scope.tempDetailFileName, $scope.sheetInfoDetail.selectedSheetIndex, $scope.sheetInfoDetail.topRowNumber).success(function (data) {

                //将导入文件的sheet赋值到数组
                $scope.sheetDataItem = data;
                //加入index序号
                var index = 1;
                data.dataList.forEach(function (v) {
                    v.index = index++;
                });
                var sheetNameObjectArray = [];
                data.sheetNameList.forEach(function (v) {
                    sheetNameObjectArray.push({ 'name': v });
                });
                $scope.sheetDataItem.sheetNameList = sheetNameObjectArray;

                $scope.detailColumnNum = data.dataList[0] ? data.dataList[0].length : $scope.detailColumnNum;;
                $scope.firstDetailDataRow = data.dataList[0];
                $scope.startRowListDetail = _.range(data.lastRowIndex);
                $scope.sheetInfoDetail.selectedSheetName = $scope.sheetDataItem.sheetNameList[$scope.sheetInfoDetail.selectedSheetIndex];
                initDetailColumns();

                vatSessionService.dataChanged = true; //设置为true表示在切换页面前数据有变更, 需要提示

                if (data && data.result === false) {
                    SweetAlert.warning(data.resultMsg);
                    return;
                }
            });
        }
    };

    //对导入数据进行验证(前端)
    var FrontEndValidIncomeInvoiceItemData = function (inputInvoiceItemList) {

        //3.验证关键字段不为空（发票代码，发票号码）
        //4.验证数据格式是否正确（金额，税额，税率）
        if (!KeyColumnsEmptyValidIncomeInvoiceItem(inputInvoiceItemList)) {
            return;
        }
    };

    //1.单独导入进项明细表check
    var OnlyInvoiceItemCheck = function () {
        var result = true;
        //如果进项汇总表没有数据，则提示不允许导入
        if ($scope.gridOptionsIncomeInvoiceTotal.data.length === 0) {
            result = false;
            $scope.itemErrorMsgMap.push(
               {
                   'errorType': validationErrorType.OnlyInvoiceItemCheckErrorType,
                   'errorCount': 1,
                   'errorContent': $translate.instant('OnlyInvoiceItemCheckErrorMsg')
               });
        }
        return result;
    };

    //2.判断是否有没有map的必须列和起始行输入格式是否正确
    var ColumnsMapCheckIncomeInvoiceItem = function () {
        var result = true;
        //1：判断是否有没有map的必须列
        var notMappedColumns = '';
        if ($scope.selectedColumnMapItem.length >= 0) {
            var count1 = 0;
            $scope.mustMappingItemColumns.forEach(function (m) {
                if (m !== $translate.instant('PleaseSelectColumn')) {
                    if ($.inArray(m, $scope.selectedColumnMapItem) < 0) {
                        notMappedColumns += m + ',';
                        count1++;
                    }
                }
            });
            if (count1) {
                result = false;
                //加入到错误列表中
                $scope.itemErrorMsgMap.push(
                    {
                        'errorType': validationErrorType.ColumnsMapErrorType,
                        'errorCount': count1,
                        'errorContent': $translate.instant('ColumnsMapErrorMsg').formatObj({ columns: notMappedColumns.substring(0, notMappedColumns.length - 1) })
                    });
            }
        }

        //2:判断起始行输入框输入内容是否合理
        var startNumberCheckMsg = '';
        var startRowNum = $('#ItemStartRowNum').val();
        if (startRowNum === '') {
            result = false;
            $scope.itemErrorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
        }
        else if (parseInt(startRowNum) > $scope.sheetDataItem.dataList.length) {
            result = false;
            $scope.itemErrorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
        }

        return result;
    };

    //3.验证关键字段不为空（发票代码，发票号码）
    var KeyColumnsEmptyValidIncomeInvoiceItem = function (inputInvoiceItemList) {
        var result = true;
        //#region 定义错误信息

        //发票信息
        var invoiceInfoEmptyCheckMsg = '';
        var invoiceInfoEmptyCheckCount = 0;

        //金额
        var amountNumberCheckMsg = '';
        var amountNumberCheckCount = 0;
        //税额
        var taxAmountNumberCheckMsg = '';
        var taxAmountNumberCheckCount = 0;
        //税率
        var taxRateNumberCheckMsg = '';
        var taxRateNumberCheckCount = 0;

        //数据范围超出范围
        var numOutRangeCheckMsg = '';
        var numOutRangeCheckCount = 0;

        //字符长度过长验证
        var stringOverLengthCheckMsg = '';
        var stringOverLengthCheckCount = 0;
        //#endregion

        //#region 进行验证操作

        inputInvoiceItemList.forEach(function (m) {
            //发票信息
            if (PWC.isNullOrEmpty(m.InvoiceCode) || PWC.isNullOrEmpty(m.InvoiceNumber)) {
                invoiceInfoEmptyCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceItemInfoEmptyCheckErrorMsg') + ';<br />';
                invoiceInfoEmptyCheckCount++;
            }
            else {
                //发票代码过长超过50个字符
                if (PWC.getStringLength(m.InvoiceCode) > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceFPDM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
                //发票号码过长超过50个字符
                if (PWC.getStringLength(m.InvoiceNumber) > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceFPHM') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            //判断金额是否为数字
            if (isNaN(parseFloat(m.Amount))) {
                amountNumberCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('AmountNumberCheckErrorMsg') + ';<br />';
                amountNumberCheckCount++;
            }
                //如果在规定的数值范围外，则提示错误
            else if (parseFloat(m.Amount) < constant.startNum || parseFloat(m.Amount) > constant.endNum) {
                numOutRangeCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceJE') + $translate.instant('NumOverLengthMsg') + ';<br />';
                numOutRangeCheckCount++;
            }
            else {
                m.Amount = PWC.round(m.Amount, 2);
            }

            //判断税额是否为数字
            if (isNaN(parseFloat(m.TaxAmount))) {
                taxAmountNumberCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('TaxAmountNumberCheckErrorMsg') + ';<br />';
                taxAmountNumberCheckCount++;
            }
                //如果在规定的数值范围外，则提示错误
            else if (parseFloat(m.TaxAmount) < constant.startNum || parseFloat(m.TaxAmount) > constant.endNum) {
                numOutRangeCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceSE') + $translate.instant('NumOverLengthMsg') + ';<br />';
                numOutRangeCheckCount++;
            }
            else {
                m.TaxAmount = PWC.round(m.TaxAmount, 2);
            }


            //判断税率是否为固定的数字
            if ($.inArray(m.TaxRate, constant.effectiveTaxRate) < 0) {
                taxRateNumberCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('TaxRateNumberCheckErrorMsg') + ';<br />';;
                taxRateNumberCheckCount++;
            }
            else {
                if (m.TaxRate.indexOf('%') > 0) {
                    m.TaxRate = m.TaxRate.substring(0, m.TaxRate.length - 1) * 0.01;
                }
            }

            //判断货物名称长度是否超过50个字符
            if (PWC.getStringLength(m.ProductionName) > constant.validateLength.StringLength_50) {
                stringOverLengthCheckMsg += $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + $translate.instant('InvoiceHWMC') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                stringOverLengthCheckCount++;
            }

        });

        //#endregion

        //#region 组装错误信息

        //push发票信息空信息到错误列表
        if (invoiceInfoEmptyCheckCount > 0) {
            result = false;
            $scope.itemErrorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceItemInfoEmptyCheckErrorType,
                    'errorCount': invoiceInfoEmptyCheckCount,
                    'errorContent': invoiceInfoEmptyCheckMsg
                });
        }
        //push金额错误信息到错误列表
        if (amountNumberCheckCount > 0) {
            result = false;
            $scope.itemErrorMsgMap.push(
                {
                    'errorType': validationErrorType.AmountNumberCheckErrorType,
                    'errorCount': amountNumberCheckCount,
                    'errorContent': amountNumberCheckMsg
                });
        }
        //push税额错误信息到错误列表
        if (taxAmountNumberCheckCount > 0) {
            result = false;
            $scope.itemErrorMsgMap.push(
                {
                    'errorType': validationErrorType.TaxAmountNumberCheckErrorType,
                    'errorCount': taxAmountNumberCheckCount,
                    'errorContent': taxAmountNumberCheckMsg
                });
        }
        //push税率错误信息到错误列表
        if (taxRateNumberCheckCount > 0) {
            result = false;
            $scope.itemErrorMsgMap.push(
                {
                    'errorType': validationErrorType.TaxRateNumberCheckErrorType,
                    'errorCount': taxRateNumberCheckCount,
                    'errorContent': taxRateNumberCheckMsg
                });
        }
        //push数值超出范围的错误信息到错误列表中
        if (numOutRangeCheckCount > 0) {
            result = false;
            $scope.itemErrorMsgMap.push(
                {
                    'errorType': validationErrorType.NumOutRangeErrorType,
                    'errorCount': numOutRangeCheckCount,
                    'errorContent': numOutRangeCheckMsg
                });
        }
        //push字符串长度超过50个字符的错误信息到错误列表中
        if (stringOverLengthCheckCount > 0) {
            result = false;
            $scope.itemErrorMsgMap.push(
                {
                    'errorType': validationErrorType.OutputStringLengthType,
                    'errorCount': stringOverLengthCheckCount,
                    'errorContent': stringOverLengthCheckMsg
                });
        }

        //#endregion
        return result;
    };

    //点击导入按钮时，进行导入操作
    var importInputInvoiceItemData = function (importType) {
        if (!$scope.detailFileName) {
            SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
            return;
        }

        var importType = importType;//0：第一次导入，1：覆盖导入，2：追加导入

        //设置数据导入时的起始行,默认设置从第一行开始
        var startRowNum = 1;
        if ($('#ItemStartRowNum').val()) {
            startRowNum = $('#ItemStartRowNum').val();
        }

        //验证前，将错误数据清空
        $scope.itemErrorMsgMap = [];

        //1：单独导入进项明细表check
        if (!OnlyInvoiceItemCheck()) {
            $('#errorItemListModal').modal('show');
            return;
        }
        //2：判断是否有没有map的必须列和起始行输入格式是否正确
        if (!ColumnsMapCheckIncomeInvoiceItem()) {
            $('#errorItemListModal').modal('show');
            return;
        }


        //将需要导入的数据组装到list中
        var inputInvoiceItemList = [];
        for (var i = startRowNum - 1; i < $scope.sheetDataItem.dataList.length; i++) {
            var invoiceItemInfo = {
                'Index': $scope.sheetDataItem.dataList[i].index,//行号
                'PeriodID': curPeriod,
                'InvoiceCode': $scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceFPDM'), $scope.selectedColumnMapItem)],
                'InvoiceNumber': $scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceFPHM'), $scope.selectedColumnMapItem)],
                'Amount': PWC.isNullOrEmpty($scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceJE'), $scope.selectedColumnMapItem)]) ?
                    0 : $scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceJE'), $scope.selectedColumnMapItem)],
                'TaxAmount': PWC.isNullOrEmpty($scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceSE'), $scope.selectedColumnMapItem)]) ?
                    0 : $scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceSE'), $scope.selectedColumnMapItem)],
                'TaxRate': PWC.isNullOrEmpty($scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceSL'), $scope.selectedColumnMapItem)]) ?
                    0 : $scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceSL'), $scope.selectedColumnMapItem)],
                'ProductionName': $scope.sheetDataItem.dataList[i][$.inArray($translate.instant('InvoiceHWMC'), $scope.selectedColumnMapItem)],
            };
            inputInvoiceItemList.push(invoiceItemInfo);
        }



        //前台数据验证
        FrontEndValidIncomeInvoiceItemData(inputInvoiceItemList);

        if ($scope.itemErrorMsgMap.length > 0) {
            $('#errorItemListModal').modal('show');
            return;
        }
        else {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.detailFileName;
            logDto.OperationObject = $translate.instant('IncomeInvoiceDetail');

            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportInputInvoiceItem');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            }
            else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportInputInvoiceItem');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            }
            else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportInputInvoiceItem');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }

            //如果是覆盖导入,则提示，否则直接导入
            if (importType === enums.vatImportBtnType.CoverImport) {
                swal({
                    title: "warning!",
                    text: $translate.instant('InputInvoiceCoverImportTips'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                }, function (isConfirm) {
                    if (isConfirm) {
                        //数据进库
                        vatImportService.importInputInvoiceItemData(inputInvoiceItemList, importType).success(function (or) {
                            if (or && or.result) {
                                logDto.UpdateState = $translate.instant('ImportSuccess');
                                vatOperationLogService.addOperationLog(logDto);

                                SweetAlert.success($translate.instant('ImportSuccess'));
                                loadIncomeInvoiceItemDataFromDB();
                                $scope.detailFileName = '';
                                vatSessionService.dataChanged = $scope.showInitTable ? false : true;//设置为false表示在切换页面前数据没有变更,不需要提示
                            }
                        }).error(function () {
                            logDto.UpdateState = $translate.instant('ImportFail');
                            vatOperationLogService.addOperationLog(logDto);
                        });
                    }
                });
            }
            else {
                //数据进库
                vatImportService.importInputInvoiceItemData(inputInvoiceItemList, importType).success(function (or) {
                    if (or && or.result) {
                        logDto.UpdateState = $translate.instant('ImportSuccess');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.success($translate.instant('ImportSuccess'));
                        loadIncomeInvoiceItemDataFromDB();
                        $scope.detailFileName = '';
                        vatSessionService.dataChanged = $scope.showInitTable ? false : true;//设置为false表示在切换页面前数据没有变更,不需要提示
                    }
                }).error(function () {
                    logDto.UpdateState = $translate.instant('ImportFail');
                    vatOperationLogService.addOperationLog(logDto);
                });
            }
        }
    };

    //动态设置grid高度
    $scope.getGridItemHeight = function () {
        if ($scope.isLoadInputInvoiceItemComplete) {
            return { height: ($('#input-invoice-item-grid-wrapper').height()) + "px" };
        }
        else {
            return { height: 0 + "px" };
        }
    };

    //刷新发票明细信息（重新验证）
    var refreshInputInvoiceItemData = function () {
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = '';
        logDto.OperationName = $translate.instant('RefreshInputInvoiceItemValidationData');
        logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
        logDto.OperationObject = $translate.instant('IncomeInvoiceDetail');

        vatImportService.validateInputInvoiceItemInfo(curPeriod).success(function () {
            logDto.UpdateState = $translate.instant('RefreshSuccess');
            vatOperationLogService.addOperationLog(logDto);

            SweetAlert.success($translate.instant('RefreshSuccess'));
            loadIncomeInvoiceItemDataFromDB();
        }).error(function () {
            logDto.UpdateState = $translate.instant('RefreshTbFail');
            vatOperationLogService.addOperationLog(logDto);

            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });

        vatSessionService.dataChanged = $scope.showInitTable ? false : true;
    };

    //清除当期发票明细信息
    var clearInputInvoiceItemData = function () {
        swal({
            title: "warning!",
            text: $translate.instant('InputInvoiceItemClearTips'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#DD6B55",
            confirmButtonText: $translate.instant('Yes'),
            cancelButtonText: $translate.instant('No'),
            closeOnConfirm: true,
            closeOnCancel: true
        }, function (isConfirm) {
            if (isConfirm) {
                logDto.ID = PWC.newGuid();
                logDto.CreateTime = new Date();
                logDto.UpdateTime = new Date();
                logDto.OperationContent = '';
                logDto.OperationName = $translate.instant('ClearInputInvoiceItem');
                logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;
                logDto.OperationObject = $translate.instant('IncomeInvoiceDetail');

                vatImportService.clearInputInvoiceItemData(curPeriod).success(function (data) {
                    if (data && data.result) {
                        logDto.UpdateState = $translate.instant('ClearSuccess');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.success($translate.instant('ClearSuccess'));
                        loadIncomeInvoiceItemDataFromDB();
                        $scope.isShowImportItemBtn = true;
                    }
                    else {
                        logDto.UpdateState = $translate.instant('ClearFailed');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.warning($translate.instant('ClearFailed'));
                    }
                }).error(function () {
                    logDto.UpdateState = $translate.instant('ClearFailed');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        });
    };

    //获取发票明细验证信息
    var getInputInvoiceItemValidationList = function () {
        var deferred = $q.defer();

        vatImportService.getValidationDtoInfo(enums.validationType.InputInvoiceItem, curPeriod).success(function (data) {
            if (data.length > 0) {
                var index = 1;
                data.forEach(function (v) {
                    v.index = index++;
                });
                $scope.gridOptionsInputInvoiceItemErrorMsg.data = data;
            }
            else {
                $scope.gridOptionsInputInvoiceItemErrorMsg.data = [];
            }
            deferred.resolve();
        });

        return deferred.promise;
    }

    var showInputInvoiceItemErrTab = function () {
        $scope.InputInvoiceItemImportErrorTab = true;//默认显示顶部block
        $scope.InputInvoiceItemImportErrorTag = true;//默认隐藏下方的错误信息列表
        $scope.inputInvoiceItemErrorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.gridOptionsInputInvoiceItemErrorMsg.data.length });

    };

    $scope.toggleInputInvoiceItemErrorTab = function () {
        $scope.InputInvoiceItemImportErrorTag = !$scope.InputInvoiceItemImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.InputInvoiceItemImportErrorTag) {
            setInputInvoiceItemErrorWrapCssDefault();
        } else {

            if (parseInt($('#input-invoice-item-content-resizer').css('bottom')) < 100) {
                $('#input-invoice-item-content-resizer').css('bottom', '130px');

                $('#input-invoice-item-error-info-wrapper').css('height', '130px');
            }
        }
    };

    var setInputInvoiceItemErrorWrapCssDefault = function () {
        $('#input-invoice-item-content-resizer').css('bottom', '20px');

        $('#input-invoice-item-error-info-wrapper').css('height', '0px');
    };

    //获取发票明细错误信息grid高度
    $scope.getInputInvoiceItemErrorGridHeight = function () {
        if ($scope.isLoadInputInvoiceItemComplete) {
            var y = $("#input-invoice-item-error-info-wrapper").height();

            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: y + "px" };
            } else {

                return { height: '0px' };
            }
        }

        return {};
    };

    //显示图标
    var errorLevelToString = function (errorLevel) {
        if (errorLevel === 0) {
            return '/app-resources/images/vat/error.png';
        }
        if (errorLevel === 1) {
            return '/app-resources/images/vat/warning.png';
        }
        if (errorLevel === 2) {
            return '/app-resources/images/vat/tips.png';
        }
        else {
            return '/app-resources/images/vat/tips.png';
        }
    };

    //显示重复发票明细
    var showInputInvoiceModal = function (typeid, items) {
        var data = JSON.parse(items);
        $scope.devgridDataSource = data;
        //组装列
        var columns = [{ caption: $translate.instant('InvoiceFPDM'), dataField: "InvoiceCode", width: 200 },
                     { caption: $translate.instant('InvoiceFPHM'), dataField: "InvoiceNumber", width: 200 },
                     { caption: $translate.instant('InvoiceKPRQ'), dataField: "InvoiceDate", dataType: "date", width: 120 },
                     { caption: $translate.instant('InvoiceGHFSH'), dataField: "SellerTaxNumber", width: 100 },
                     { caption: $translate.instant('InvoiceJE'), dataField: "Amount", format: { type: 'fixedPoint', precision: 2 }, width: 100 },
                     { caption: $translate.instant('InvoiceSE'), dataField: "TaxAmount", format: { type: 'fixedPoint', precision: 2 }, width: 100 },
                     { caption: $translate.instant('InvoiceRZRQ'), dataField: "CertificationDate", dataType: "date", width: 120 },
                     { caption: $translate.instant('InvoiceRZJG'), dataField: "CertificationResult", width: 100 },
                     { caption: $translate.instant('InvoiceFPLX'), dataField: "InvoiceTypeName", cellTemplate: "translateCellTemplate", width: 100 }];


        $scope.deferStatus = true;
        $scope.filterCondition = ["IsDuplicate", "=", true];

        $scope.gridInputInvoiceDuplicateItemGridOptions = {
            columns: columns,
            bindingOptions: {
                "dataSource.store.data": "devgridDataSource",
                "selection.deferred": "deferStatus",
                "selectionFilter": "filterCondition"
            },
            dataSource: {
                store: {
                    type: "array",
                    key: 'ID'
                }
            },
            selection: {
                selectAllMode: "allPages",
                showCheckBoxesMode: "always",
                mode: "multiple"
            },
            hoverStateEnabled: true,
            paging: {
                pageSize: 10
            }
        }

        $('#inputInvoiceDuplicateItemModal').modal('show');

    };

    //删除重复数据
    var deleteDuplicateData = function () {
        var dataGrid = $('#gridInputInvoiceDuplicateItemGrid').dxDataGrid("instance");
        var deleteList = [];
        dataGrid.getSelectedRowsData().done(function (rowData) {
            for (var i = 0; i < rowData.length; i++) {
                deleteList.push(rowData[i].AcctCode);
            }
        });

        dataGrid.getSelectedRowKeys().done(function (keys) {
            if (keys && keys.length === 0) {
                SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
                return;
            }

            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = deleteList.join(",");
            logDto.OperationName = $translate.instant('DeleteDuplicateData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;
            logDto.OperationObject = $translate.instant('IncomeInvoiceTotal');

            vatImportService.deleteInputInvoiceDuplicateData(keys).success(function (data) {
                if (data && data.result) {
                    //添加删除重复数据日志
                    logDto.UpdateState = $translate.instant('DeleteSuccess');
                    vatOperationLogService.addOperationLog(logDto);

                    //删除数据后重新校验
                    loadIncomeInvoiceDataFromDB();
                    vatImportService.validateInputInvoiceInfo(curPeriod).success(function () {
                        $('#inputInvoiceDuplicateItemModal').modal('hide');
                        SweetAlert.success($translate.instant('DeleteSuccess'));
                        //获取错误列表信息
                        getInputInvoiceValidationList().then(function () {
                            if ($scope.gridOptionsInputInvoiceErrorMsg.data.length > 0) {
                                showInputInvoiceErrTab();
                                $scope.toggleInputInvoiceErrorTab();

                                //当有错误信息时，显示错误信息表
                                $scope.showInputInvoiceErrorTable = true;
                            }
                            else {
                                $scope.InputInvoiceImportErrorTab = false;
                                $scope.InputInvoiceImportErrorTag = false;
                                $scope.showInputInvoiceErrorTable = false;
                            }
                        });

                    });
                }
                else {
                    logDto.UpdateState = $translate.instant('DeleteFailed');
                    vatOperationLogService.addOperationLog(logDto);
                }
            }).error(function () {
                logDto.UpdateState = $translate.instant('DeleteFailed');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        });


    };

    //显示错误税率明细
    var showInputInvoiceItemModal = function (typeid, items) {
        var data = JSON.parse(items);
        $scope.devgridDataSource = data;

        //如果类型为显示汇总和明细金额、税额对比结果
        if (typeid === 66) {
            //组装列
            var columns = [{ caption: $translate.instant('InvoiceFPDM'), dataField: "InvoiceCode", width: '15%' },
                         { caption: $translate.instant('InvoiceFPHM'), dataField: "InvoiceNumber", width: '15%' },
                         { caption: $translate.instant('InvoiceTotalAmount'), dataField: "TotalAmount", format: { type: 'fixedPoint', precision: 2 }, width: '17.5%' },
                         { caption: $translate.instant('InvoiceTotalTaxAmount'), dataField: "TotalTaxAmount", format: { type: 'fixedPoint', precision: 2 }, width: '17.5%' },
                         { caption: $translate.instant('InvoiceItemAmount'), dataField: "ItemAmount", format: { type: 'fixedPoint', precision: 2 }, width: '17.5%' },
                         { caption: $translate.instant('InvoiceItemTaxAmount'), dataField: "ItemTaxAmount", format: { type: 'fixedPoint', precision: 2 }, width: '17.5%' }];


            $scope.gridInputInvoiceAmountCompareGridOptions = {
                columns: columns,
                selection: {
                    mode: "single"
                },
                bindingOptions: {
                    "dataSource": "devgridDataSource"
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                }
            }

            $('#inputInvoiceAmountCompareModal').modal('show');
        }
        else {
            //组装列
            var columns = [{ caption: $translate.instant('InvoiceFPDM'), dataField: "InvoiceCode", width: '15%' },
                         { caption: $translate.instant('InvoiceFPHM'), dataField: "InvoiceNumber", width: '15%' },
                         { caption: $translate.instant('InvoiceJE'), dataField: "Amount", format: { type: 'fixedPoint', precision: 2 }, width: '15%' },
                         { caption: $translate.instant('InvoiceSE'), dataField: "TaxAmount", format: { type: 'fixedPoint', precision: 2 }, width: '15%' },
                         { caption: $translate.instant('InvoiceSL'), dataField: "TaxRate", cellTemplate: "taxRateCellTemplate", width: '15%' },
                         { caption: $translate.instant('InvoiceHWMC'), dataField: "ProductionName", width: '25%' }];


            $scope.gridInputInvoiceItemGridOptions = {
                columns: columns,
                selection: {
                    mode: "single"
                },
                bindingOptions: {
                    "dataSource": "devgridDataSource"
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                }
            }

            $('#inputInvoiceItemModal').modal('show');
        }
    };

    //查看发票日志
    var showOperateLogPop = function () {
        $scope.isShowLog = true;
    };

    //控制明细信息中删除权限
    var getUserPermission = function () {
        var list = [];
        var code = constant.vatPermission.dataImport.inputInvoice.importCode;
        list.push(code);

        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
            $scope.hasEditPermission = data[code];
        });
    };

    var setButtonWrapStyle = function () {
        if ($scope.showImportTable) {
            return { width: "100%" };
        }
    };

    var initPagingControl = function (totalItemsCount) {
        $scope.pagingOptions.totalItems = totalItemsCount;
    };

    $scope.pagingService = {
        refreshInvoiceDataGrid: function () {
            $log.debug("refreshInvoiceDataGrid");
            loadIncomeInvoiceItemDataFromDB();
        },
    };
    /****************************************明细表function end*************************************************/


    (function initialize() {
        $log.debug('VatImportIncomeInvoiceController.ctor()...');

        /****************************************汇总表function start***********************************************/
        $scope.errorMsgMap = [];
        $scope.incomeInvoiceTotalFileName = '';
        $scope.selectedColumnMap = [];
        $scope.incomeInvoiceTotalColumns = [];
        $scope.initIncomeInvoiceTotalColumnsIndex = [];
        $scope.startRowList = [];
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0, topRowNumber: 0 };
        $scope.isShowImportTotalBtn = true;
        $scope.isLoadInputInvoiceComplete = false;
        

        initColumns();
        loadIncomeInvoiceDataFromDB();
        getUserPermission();

        $scope.changeIncomeInvoiceSheet = changeIncomeInvoiceSheet;

        $scope.mappingColumn = mappingColumn;

        $scope.importInputInvoiceData = importInputInvoiceData;

        $scope.clearInputInvoiceData = clearInputInvoiceData;

        $scope.refreshInputInvoiceData = refreshInputInvoiceData;

        $scope.errorLevelToString = errorLevelToString;

        $scope.showInputInvoiceModal = showInputInvoiceModal;

        $scope.deleteDuplicateData = deleteDuplicateData;

        $scope.loadIncomeInvoiceDataFromDB = loadIncomeInvoiceDataFromDB;

        $scope.showOperateLogPop = showOperateLogPop;

        $scope.setButtonWrapStyle = setButtonWrapStyle;

        $scope.$watch('incomeInvoiceTotalFileName', function (newValue, oldValue) {
            if (newValue && newValue !== oldValue) {
                updateIncomeInvoceTotalFileName(newValue);
                doUploadIncomeInvoiceTotalFile($scope.incomeInvoiceTotalFileName);
                $scope.InputInvoiceImportErrorTab = false;
                $scope.InputInvoiceImportErrorTag = false;
                $('#StartRowNum').val('2');
            }
        });

        $scope.gridOptionsIncomeInvoiceTotal = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
              {
                  name: $translate.instant('ImportErrorPopUpNoCol'), width: 100, headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceFPDM'), width: 150, headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceCode}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceFPHM'), width: 150, headerCellClass: 'right',
                  cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.invoiceNumber}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceKPRQ'), width: 150, headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceDate | date:"yyyy-MM-dd"}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceGHFSH'), width: 200, headerCellClass: 'right',
                  cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.sellerTaxNumber}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceJE'), width: 150, headerCellClass: 'right',
                  cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.amount}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceSE'), width: 150, headerCellClass: 'right',
                  cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.taxAmount}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceRZRQ'), width: 150, headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.certificationDate | date:"yyyy-MM-dd"}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceRZJG'), width: 200, headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.certificationResult}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceFPLX'), width: 150, headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceTypeName | translate}}</span></div>'
              }
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiTotal = gridApi;

                $interval(function () {
                    $scope.gridApiTotal.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };


        $scope.gridOptionsInputInvoiceErrorMsg = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
              {
                  name: ' ', width: '5%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
              },
              {
                  name: $translate.instant('ImportErrorPopUpNoCol'), width: '5%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorResult'), width: '35%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
              },
              {
                  name: $translate.instant('ImportErrorPopUpErrorCountCol'), width: '10%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorDetail'), width: '20%',
                  cellTemplate: '<div class="ui-grid-cell-contents">' +
                      '<a ng-if="row.entity.isShowDetail" ng-click="grid.appScope.showInputInvoiceModal(row.entity.erpCheckTypeId, row.entity.validationDetails)">{{"ViewDetails" | translate}}</a>' +
                      '<span ng-if="!row.entity.isShowDetail" title="{{row.entity.validationTips}}" data-ng-bind-html="row.entity.validationTips"><span>' +
                      '</div>'
              },
              {
                  name: $translate.instant('ValidationTips'), width: '25%',
                  cellTemplate: '<div class="ui-grid-cell-contents">' +
                      '<span ng-if="row.entity.isShowDetail" title="{{row.entity.validationTips}}" data-ng-bind-html="row.entity.validationTips"></span>' +
                      '<span ng-if="!row.entity.isShowDetail"></span>' +
                      '</div>'
              }
            ],
            onRegisterApi: function (gridApi) {
                $scope.inputInvoiceErrorGridApi = gridApi;

                $interval(function () {
                    $scope.inputInvoiceErrorGridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        $timeout(function () {
            $scope.isLoadInputInvoiceComplete = true;
        }, 500);
        /****************************************汇总表function end***********************************************/

        $scope.itemErrorMsgMap = [];
        $scope.incomeInvoiceDetailFileName = '';
        $scope.selectedColumnMapItem = [];
        $scope.incomeInvoiceDetailColumns = [];
        $scope.initIncomeInvoiceDetailColumnsIndex = [];
        $scope.startRowListDetail = [];
        $scope.sheetDataItem = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfoDetail = { selectedSheetName: '', selectedSheetIndex: 0, topRowNumber: 0 };
        $scope.isShowImportItemBtn = true;


        initDetailColumns();
        loadIncomeInvoiceItemDataFromDB();

        $scope.changeIncomeInvoiceDetailSheet = changeIncomeInvoiceDetailSheet;

        $scope.mappingDetailColumn = mappingDetailColumn;

        $scope.importInputInvoiceItemData = importInputInvoiceItemData;

        $scope.clearInputInvoiceItemData = clearInputInvoiceItemData;

        $scope.refreshInputInvoiceItemData = refreshInputInvoiceItemData;

        $scope.showInputInvoiceItemModal = showInputInvoiceItemModal;

        $scope.$watch('incomeInvoiceDetailFileName', function (newValue, oldValue) {
            if (newValue && newValue !== oldValue) {
                updateIncomeInvoceDetailFileName(newValue);
                doUploadIncomeInvoiceDetailFile($scope.incomeInvoiceDetailFileName);
                $scope.InputInvoiceItemImportErrorTab = false;
                $scope.InputInvoiceItemImportErrorTag = false;
                $('#ItemStartRowNum').val('2');
            }
        });

        $scope.gridOptionsIncomeInvoiceItem = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
              {
                  name: $translate.instant('ImportErrorPopUpNoCol'), width: '10%', headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceFPDM'), width: '15%', headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceCode}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceFPHM'), width: '15%', headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceNumber}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceJE'), width: '15%', headerCellClass: 'right',
                  cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.amount}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceSE'), width: '15%', headerCellClass: 'right',
                  cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.taxAmount}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceSL'), width: '15%', headerCellClass: 'right',
                  cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{(row.entity.taxRate * 100) + "%"}}</span></div>'
              },
              {
                  name: $translate.instant('InvoiceHWMC'), width: '20%', headerCellClass: '',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.productionName}}</span></div>'
              }
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiItem = gridApi;

                $interval(function () {
                    $scope.gridApiItem.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        $scope.gridOptionsInputInvoiceItemErrorMsg = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
              {
                  name: ' ', width: '5%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
              },
              {
                  name: $translate.instant('ImportErrorPopUpNoCol'), width: '5%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorResult'), width: '35%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
              },
              {
                  name: $translate.instant('ImportErrorPopUpErrorCountCol'), width: '10%',
                  cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorDetail'), width: '20%',
                  cellTemplate: '<div class="ui-grid-cell-contents">' +
                      '<a ng-if="row.entity.isShowDetail" ng-click="grid.appScope.showInputInvoiceItemModal(row.entity.erpCheckTypeId, row.entity.validationDetails)">{{"ViewDetails" | translate}}</a>' +
                      '<span ng-if="!row.entity.isShowDetail" title="{{row.entity.validationTips}}" data-ng-bind-html="row.entity.validationTips"><span>' +
                      '</div>'
              },
              {
                  name: $translate.instant('ValidationTips'), width: '25%',
                  cellTemplate: '<div class="ui-grid-cell-contents">' +
                      '<span ng-if="row.entity.isShowDetail" title="{{row.entity.validationTips}}" data-ng-bind-html="row.entity.validationTips"></span>' +
                      '<span ng-if="!row.entity.isShowDetail"></span>' +
                      '</div>'
              }
            ],
            onRegisterApi: function (gridApi) {
                $scope.inputInvoiceItemErrorGridApi = gridApi;

                $interval(function () {
                    $scope.inputInvoiceItemErrorGridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };


        $timeout(function () {
            $scope.isLoadInputInvoiceItemComplete = true;
        }, 500);

    })();
}]);
vatModule.directive('vatImportIncomeInvoice', ['$log', '$translate',
    function ($log, $translate) {
        'use strict';
        $log.debug('vatImportIncomeInvoice.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/import/vat-import-income-invoice/vat-import-income-invoice.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'VatImportIncomeInvoiceController',
            link: function (scope, element) {
                //切换发票信息汇总和明细清单
                scope.switchTab = function (event) {
                    scope.getGridTotalHeight();
                    scope.getGridItemHeight();
                    
                    $('.nav-tab span').each(function () {
                        $(this).removeClass('active');
                    });

                    $(event.target).addClass('active');

                    if (event.target.innerText == $translate.instant('InvoiceInfoTotalTab')) {
                        $('#tab_total').css('display', 'block');
                        $('#tab_detail').css('display', 'none');
                        //scope.loadIncomeInvoiceDataFromDB();
                    }
                    else {
                        $('#tab_total').css('display', 'none');
                        $('#tab_detail').css('display', 'block');
                    }

                    
                };
            }
        };
    }
]);
vatModule.directive('vatImportJournalEntry', ['$log', 'enums', 'vatSessionService',
    function ($log, enums, vatSessionService) {
        'use strict';
        $log.debug('vatImportJournalEntry.ctor()...');

        return {
            restrict: 'E',
            template: '<import-journal-entry service-type-id="serviceTypeId" period-id="periodId"></import-journal-entry>',
            scope: {},
            link: function (scope, element) {
                scope.periodId = vatSessionService.month;
                scope.serviceTypeId = enums.serviceType.VAT;
            }
        };
    }
]);

vatModule.controller('VatImportLayoutController', ['$scope', '$log', '$translate', '$location', 'loginContext', 'enums', 'vatSessionService', 'vatCommonService',
function ($scope, $log, $translate, $location, loginContext, enums, vatSessionService, vatCommonService) {
    'use strict';
    $log.debug('VatImportLayoutController.ctor()...');

    if ($location.$$url.startWith('/cit/')) {

        return false;
    }

    //获取未对应企业科目数量
    $scope.$on('notMappedCount', function (e, d) {
        $scope.notMappedCount = d;
    });

    $log.debug("$location && $location.absUrl(): " + $location && $location.absUrl());
    //using .replace(';', '<br/>') to text-wrap at exact position as designed in menu 
    if ($location && $location.absUrl().indexOf('previewData') > -1) {
        $scope.nodeDicKey = constant.DictionaryDictKey.DataImport;
        $scope.linkShort = enums.linkShort.PreviewData;
        $scope.menus = [
                {
                    name: 'balanceSheet', permission: constant.vatPermission.dataPreview.balanceSheet.queryCode,
                    text: $translate.instant('balanceSheet'), icon: 'fa fa-bank', show: true
                },
                {
                    name: 'accountVoucher', permission: constant.vatPermission.dataPreview.accountVoucher.queryCode,
                    text: $translate.instant('accountVoucher'), icon: 'fa fa-columns', show: true
                },
                {
                    name: 'outputInvoice', permission: constant.vatPermission.dataPreview.outputInvoice.queryCode,
                    text: $translate.instant('outputInvoice'), icon: 'fa fa-file-text-o', show: true
                },
                {
                    name: 'inputInvoice', permission: constant.vatPermission.dataPreview.inputInvoice.queryCode,
                    text: $translate.instant('inputInvoice'), icon: 'fa fa-file-text-o', show: true
                },
                {
                    name: 'customInvoice', permission: constant.vatPermission.dataPreview.customInvoice.queryCode,
                    text: $translate.instant('customInvoice'), icon: 'fa fa-bookmark', show: true
                }];
    }
    else if ($location && $location.absUrl().indexOf('reductionData') > -1) {
        $scope.nodeDicKey = constant.DictionaryDictKey.DataProcess;
        $scope.linkShort = enums.linkShort.ReductionData;
        $scope.menus = [
                {
                    name: 'caculateData', permission: constant.vatPermission.dataManage.caculateDataCode,
                    text: $translate.instant('caculateData'), icon: 'fa fa-random', show: true
                },
                {
                    name: 'accountMapping', permission: constant.vatPermission.dataManage.accountMappingCode,
                    text: $translate.instant('accountMapping'), icon: 'fa fa-map', show: true
                },
                {
                    name: 'goodsMapping', permission: constant.vatPermission.dataManage.goodsMappingCode,
                    text: $translate.instant('goodsMapping'), icon: 'fa fa-map-signs', show: true
                },
                {
                    name: 'unbilledInvoice', permission: constant.vatPermission.dataManage.unbilledInvoiceCode,
                    text: $translate.instant('unbilledInvoice'), icon: 'fa fa-shield', show: true
                }, ];
    }
    else {
        $scope.nodeDicKey = constant.DictionaryDictKey.DataImport;
        $scope.linkShort = enums.linkShort.ImportData;
        $scope.menus = [{
            name: 'balanceSheet', permission: constant.vatPermission.dataImport.balanceSheet.queryCode,
            text: $translate.instant('balanceSheet'), icon: 'fa fa-bank', show: true
        },
            {
                name: 'journalEntry', permission: constant.vatPermission.dataImport.journalEntry.queryCode,
                text: $translate.instant('journalEntry'), icon: 'fa fa-align-left', show: true
            },
            {
                name: 'erpData', permission: constant.vatPermission.dataImport.erpImport.queryCode,
                text: $translate.instant('erpData'), icon: 'fa fa-list-ul', show: true
            },
            {
                name: 'outputInvoice', permission: constant.vatPermission.dataImport.outputInvoice.queryCode,
                text: $translate.instant('outputInvoice'), icon: 'fa fa-file-text-o', show: true
            },
            {
                name: 'inputInvoice', permission: constant.vatPermission.dataImport.inputInvoice.queryCode,
                text: $translate.instant('inputInvoice'), icon: 'fa fa-file-text-o', show: true
            },
            {
                name: 'customInvoice', permission: constant.vatPermission.dataImport.customInvoice.queryCode,
                text: $translate.instant('customInvoice'), icon: 'fa fa-bookmark', show: true
            },
            {
                name: 'voucherMapping', permission: constant.vatPermission.dataImport.voucherMapping.queryCode,
                text: $translate.instant('voucherMapping'), icon: 'fa fa-columns', show: true
            },
            {
                name: 'invoiceMapping', permission: constant.vatPermission.dataImport.invoiceMapping.queryCode,
                text: $translate.instant('invoiceMapping'), icon: 'fa fa-columns', show: true
            },
            {
                name: 'auditAdjust', permission: constant.vatPermission.dataImport.auditAdjust.queryCode,
                text: $translate.instant('auditAdjust'), icon: 'fa fa-adjust', show: true
            }];
    }



    (function initialize() {
        vatCommonService.isLayoutMenuShow(vatSessionService.project.dbName, vatSessionService.month
                                           , $scope.nodeDicKey, $scope.linkShort, $scope.menus);
    })();

}]);

vatModule.directive('vatImportLayout', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatImportLayout.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/import/vat-import-layout/vat-import-layout.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'VatImportLayoutController',
            link: function ($scope, $element, $attr) {

            }
        };
    }
]);
vatModule.controller('VatImportOutputInvoiceController', ['$scope', '$cookies', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatSessionService', 'loginContext', 'browserService', 'enums', 'vatOperationLogService', 'projectService', 'vatCommonService',
    function ($scope, $cookies, $log, $translate, $timeout, apiInterceptor, Upload, vatImportService, SweetAlert, $q, uiGridConstants, $interval, vatSessionService, loginContext, browserService, enums, vatOperationLogService, projectService, vatCommonService) {
        'use strict';

        var successCount = 0;
        var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
        var apiTokenObj = $cookies.getObject('AtmsApiToken');
        var webHost = apiTokenObj.api_host;
        var chunkSize = 100000;
        var resumable = true;
        var curPeriod = vatSessionService.month;
        var curYear = vatSessionService.project.year;
        var percentList = ['17%', '13%', '11%', '6%', '5%', '3%', '1.5%'];
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        var projectDbName = vatSessionService.project.dbName;

        //写日志
        $scope.period = vatSessionService.month;
        $scope.moduleid = enums.vatModuleEnum.Import_OutputInvoice;
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('OutputInvoiceTitle'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period,
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        $scope.totalData = {
            totalNumber: 0,
            amount: 0,
            taxAmount: 0
        }


        $scope.downloadTemplatePath = webHost + '/Resource/ImportData/销项发票导入模板.xls';
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.invoiceData = [];
        $scope.outputInvoiceList = [];
        $scope.outputInvoiceItemList = [];
        $scope.errorMsgMap = [];
        $scope.totalCount = 0;
        $scope.evidenceTotalCount = '';
        //初始化参数
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false
        $scope.isShowImportTotalBtn = true;

        var validationErrorType = {
            InvoiceInfoEmptyCheckErrorType: $translate.instant('OutputInvoiceErrorType'),
            InvoiceDateErrorType: $translate.instant('InvoiceDateErrorType'),
            DateCheckErrorType: $translate.instant('InvoiceDateRangeCheckErrorType'),
            AmountNumberCheckErrorType: $translate.instant('AmountNumberCheckErrorType'),
            TaxAmountNumberCheckErrorType: $translate.instant('TaxAmountNumberCheckErrorType'),
            AuantityNumberCheckErrorType: $translate.instant('AuantityNumberCheckErrorType'),
            TaxRateCheckErrorType: $translate.instant('TaxRateCheckErrorType'),
            OutputStringLengthType: $translate.instant('OutputStringLengthType'),
            OutputInvoiceTypeErrorType: $translate.instant('OutputInvoiceTypeErrorType'),
        };

        var invoiceTypeEnum = {
            Normal: $translate.instant('Normal'),
            Special: $translate.instant('Special'),
        };

        //根据当前的月份获取当月第一天日期
        var getCurrentMonthFirstDay = function () {
            var curMonth = curPeriod;
            if (curPeriod < 10) {
                curMonth = '0' + curPeriod;
            }
            var oneDay = 1000 * 60 * 60 * 8;
            return new Date(new Date(curYear + '-' + curMonth + '-' + '01') - oneDay)
        };

        //根据当前的月份获取当月的最后一天日期
        var getCurrentMonthLastDay = function () {
            var curMonth = curPeriod;
            if (curPeriod < 10) {
                curMonth = '0' + curPeriod;
            }
            var date = new Date(curYear + '-' + curMonth + '-' + '01');
            var currentMonth = date.getMonth();
            var nextMonth = ++currentMonth;
            var nextMonthFirstDay = new Date(date.getFullYear(), nextMonth, 1);
            //var oneDay = 1000 * 60 * 60 * 16;
            //if (browserService.isIE() || browserService.isEdge())
            //{
            //    return new Date(nextMonthFirstDay);
            //}
            //else{
            //     return new Date(nextMonthFirstDay - oneDay);
            //}     
            return new Date(nextMonthFirstDay);
        };
        //导入方式
        $scope.importEnum = {
            Import: 0, CoverImport: 1, AddImport: 2
        };

        //上传文件
        var uploadfile = function (file) {
            if (file) {
                successCount = 0;
                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();
                    Upload.upload({
                        url: uploadUrl,
                        data: {
                            cancel: false,
                            filename: file.name,
                            tempFileName: tempFileName,
                            file: file
                        },
                        resumeChunkSize: resumable ? chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadSuccess);
                }
            }
        };
        //上传成功
        var uploadSuccess = function (resp) {
            successCount++;
            if (successCount === 1) {
                $scope.tempFileName = resp.data;
                changeSheet(0);
            }
        };

        /****************************************销项发票function start*************************************************/
        //选择sheet
        function changeSheet(selectedSheet) {
            var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
                return num.name === selectedSheet.name;
            })
            $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
            refreshTable();
        };

        //刷新列表
        function refreshTable() {
            $scope.showErrorTable = false;
            if (_.isString($scope.tempFileName)) {
                $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
                $scope.gridOptionsOutputInvoice.data = [];
                vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, 0).success(function (data) {
                    if (data.result === false) {
                        $scope.showInitTable = true;
                        $scope.showImportTable = false;
                        initTableTitle();
                        SweetAlert.warning(data.resultMsg);
                    }
                    else {
                        $scope.showInitTable = false;
                        $scope.showImportTable = true
                    }
                    $scope.sheetData = data;
                    var sheetNameObjectArray = [];
                    data.sheetNameList.forEach(function (v) {
                        sheetNameObjectArray.push({ 'name': v });
                    });
                    $scope.sheetData.sheetNameList = sheetNameObjectArray;
                    $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                    vatSessionService.dataChanged = true;
                    $scope.invoiceData = $scope.sheetData.dataList.slice(1, $scope.sheetData.dataList.length);
                    //加入index序号
                    var index = 1;
                    $scope.invoiceData.forEach(function (v) {
                        v.index = index++;
                    });
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        };

        //切换发票信息汇总和证据文件
        function switchTab(event) {
            $('.nav-tab span').each(function () {
                $(this).removeClass('active');
            });

            $(event.target).addClass('active');

            if (event.target.innerText == $translate.instant('OutputInvoiceTab')) {
                $('#tab_total').css('display', 'block');
                $('#tab_evidence').css('display', 'none');
            }
            else {
                $('#tab_total').css('display', 'none');
                $('#tab_evidence').css('display', 'block');
            }
        };

        //转换发票类型
        function translateInvoiceType(strType) {
            var type = 0;
            switch (strType) {
                case invoiceTypeEnum.Normal:
                    type = 0;
                    break;
                case invoiceTypeEnum.Special:
                    type = 1;
                    break;
                default:
                    type = 10;
            }
            return type;
        }

        //发票类型转换
        $scope.typeToString = function (strType) {
            var type = invoiceTypeEnum.Normal;
            switch (strType) {
                case 0:
                    type = invoiceTypeEnum.Normal;
                    break;
                case 1:
                    type = invoiceTypeEnum.Special;
                    break;
                default:
                    type = "";
            }
            return type;
        }

        //转换百分比
        $scope.decimalToPercent = function (data) {
            return (data * 100).toFixed(0) + "%";
        }

        //百分比转小数
        function translatePercentNum(per) {
            return per.replace(/([0-9.]+)%/, function (a, b) { return +b / 100; })
        }

        //转换没有选中的列值
        function undefinedToNull(inputData) {
            if (PWC.isNullOrEmpty(inputData)) {
                return 0;
            }
            else {
                return inputData;
            }
        }

        //验证导入是否符合模板
        function validationIsImportTemp() {
            //验证前，将错误数据清空
            var isOK = true;
            if ($.trim($scope.sheetData.dataList[0][0]) !== $translate.instant('InvoiceType')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][1]) !== $translate.instant('ClassCode')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][2]) !== $translate.instant('InvoiceNumber')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][3]) !== $translate.instant('BuyerName')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][4]) !== $translate.instant('BuyerTaxNumber')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][5]) !== $translate.instant('BankAccount')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][6]) !== $translate.instant('PhoneNum')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][7]) !== $translate.instant('InvoiceDate')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][8]) !== $translate.instant('CodeVersion')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][9]) !== $translate.instant('DocumentNum')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][10]) !== $translate.instant('ProductName')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][11]) !== $translate.instant('ProductStandar')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][12]) !== $translate.instant('Unit')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][13]) !== $translate.instant('Quantity')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][14]) !== $translate.instant('UnitPrice')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][15]) !== $translate.instant('Amount')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][16]) !== $translate.instant('TaxRate')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][17]) !== $translate.instant('TaxAmount')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][18]) !== $translate.instant('TaxClassCode')) {
                isOK = false;
            }
            return isOK;
        }

        //获取销项发票信息
        function getOutputInvoiceData() {
            var lastInvoiceDto = {};
            lastInvoiceDto.items = [];
            var count = 0;
            var invoiceInfoEmptyCheckMsg = '';
            for (var i = 1; i < $scope.sheetData.dataList.length; i++) {
                var invoiceDto = {};
                //销项
                if ($.trim($scope.sheetData.dataList[i][0]).length > 0 &&
                    $.trim($scope.sheetData.dataList[i][1]).length > 0 &&
                    $.trim($scope.sheetData.dataList[i][2]).length > 0) {
                    invoiceDto.InvoiceID = PWC.newGuid();
                    invoiceDto.InvoiceType = translateInvoiceType($.trim($scope.sheetData.dataList[i][0]));
                    invoiceDto.ClassCode = $scope.sheetData.dataList[i][1];
                    invoiceDto.InvoiceNumber = $scope.sheetData.dataList[i][2];
                    invoiceDto.BuyerName = $scope.sheetData.dataList[i][3];
                    invoiceDto.BuyerTaxNumber = $scope.sheetData.dataList[i][4];
                    invoiceDto.BankAccount = $scope.sheetData.dataList[i][5];
                    invoiceDto.PhoneNum = $scope.sheetData.dataList[i][6];
                    invoiceDto.InvoiceDate = $scope.sheetData.dataList[i][7];
                    invoiceDto.SeqNo = $scope.outputInvoiceList.length + 1;
                    invoiceDto.PeriodID = $scope.period;
                    invoiceDto.Status = 0;
                    invoiceDto.items = [];
                    invoiceDto.Index = i;

                    lastInvoiceDto = invoiceDto;
                    $scope.outputInvoiceList.push(invoiceDto);
                    getInvoiceItemData($scope.sheetData.dataList[i], lastInvoiceDto, i);
                }
                    //明细信息验证
                else if ($.trim($scope.sheetData.dataList[i][0]).length == 0 &&
                    $.trim($scope.sheetData.dataList[i][1]).length == 0 &&
                    $.trim($scope.sheetData.dataList[i][2]).length == 0) {
                    getInvoiceItemData($scope.sheetData.dataList[i], lastInvoiceDto, i);
                }
                else {
                    invoiceInfoEmptyCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: i }) + ')' + $translate.instant('OutputInvoiceErrorMsg') + '<br />';
                    count++;
                }
            }
            //1:发票代码，发票号码，发票类型要么全为空，要么都有数据
            if (count > 0) {
                $scope.errorMsgMap.push({
                    'errorType': validationErrorType.InvoiceInfoEmptyCheckErrorType,
                    'errorCount': count,
                    'errorContent': invoiceInfoEmptyCheckMsg
                });
            }

        }

        //获取明细信息
        function getInvoiceItemData(rowData, invoiceData, index) {
            var invoiceItemDto = {
            };
            //明细信息
            if ($.trim(rowData[10]) !== $translate.instant('Subtotal') && $.trim(rowData[10]) !== $translate.instant('Alltotal')) {
                invoiceItemDto.ItemID = PWC.newGuid();
                invoiceItemDto.ClassCode = invoiceData.ClassCode;
                invoiceItemDto.InvoiceNumber = invoiceData.InvoiceNumber;
                invoiceItemDto.InvoiceID = invoiceData.InvoiceID;
                invoiceItemDto.CodeVersion = rowData[8];
                invoiceItemDto.ProductName = rowData[10];
                invoiceItemDto.DocumentNum = rowData[9];
                invoiceItemDto.ProductStandard = rowData[11];
                invoiceItemDto.Unit = rowData[12];
                invoiceItemDto.Quantity = rowData[13];
                invoiceItemDto.UnitPrice = undefinedToNull(rowData[14]);
                invoiceItemDto.Amount = undefinedToNull(rowData[15]);
                invoiceItemDto.TaxRate = undefinedToNull(rowData[16]);
                invoiceItemDto.TaxAmount = undefinedToNull(rowData[17]);
                invoiceItemDto.SeqNo = invoiceData.items.length + 1;
                invoiceItemDto.TaxClassCode = rowData[18];
                invoiceItemDto.PeriodID = $scope.period;
                invoiceItemDto.Index = index;
                //加入上传列表
                invoiceData.items.push(invoiceItemDto);
                $scope.outputInvoiceItemList.push(invoiceItemDto);
            }
        }

        //销项发票前端验证
        function frontEndValidOutputInvoiceData() {
            //4.开票日期验证，不能为空，且格式正确
            var invoiceDateCheckMsg = '';
            var count1 = 0;
            //开票日期范围
            var invoiceDateRangeCheckMsg = '';
            var count2 = 0;
            //金额
            var amountNumberCheckMsg = '';
            var count3 = 0;
            //税额
            var taxAmountNumberCheckMsg = '';
            var count4 = 0;
            //数量
            var quantityCheckMsg = '';
            var count5 = 0;
            //税率
            var taxRateCheckMsg = '';
            var count6 = 0;
            //发票类别
            var typeMsg = '';
            var typeCount = 0;
            //长度验证
            var stringLengthMsg = '';
            var stringCount = 0;
            //数据长度
            var NumlengthMsg = '';
            var NumLengthCount = 0;
            //数量
            var unitPriceCheckMsg = '';
            var unitPriceCount = 0;

            $scope.outputInvoiceList.forEach(function (m) {
                //开票日期为空
                if (PWC.isNullOrEmpty(m.InvoiceDate)) {
                    invoiceDateCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('InvoiceDateNullMsg') + '<br />';
                    count1++;
                }
                    //日期格式错误
                else if (!PWC.checkDate(m.InvoiceDate)) {
                    invoiceDateCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('InvoiceDateErrorMsg') + '<br />';
                    count1++;
                }
                    //如果日期不在选定期间
                else {
                    if (!(new Date(m.InvoiceDate.replace(/[\.-]/g, '/')) >= getCurrentMonthFirstDay() && new Date(m.InvoiceDate.replace(/[\.-]/g, '/')) < getCurrentMonthLastDay())) {
                        invoiceDateRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('InvoiceDateRangeCheckErrorMsg') + '<br />';
                        count2++;
                    }
                }

                if (m.InvoiceType === 10) {
                    typeMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('OutputInvoiceTypeErrorMsg') + '<br />';
                    typeCount++;
                }
                if (PWC.getStringLength(m.ClassCode) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('ClassCode') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.InvoiceNumber) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('InvoiceNumber') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.BuyerName) > 100) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('BuyerName') + $translate.instant('Output100LengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.BuyerTaxNumber) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('BuyerTaxNumber') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.BankAccount) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('BankAccount') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.PhoneNum) > 100) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('PhoneNum') + $translate.instant('Output100LengthMsg') + '<br />';
                    stringCount++;
                }

            });

            $scope.outputInvoiceItemList.forEach(function (m) {
                if (PWC.getStringLength(m.CodeVersion) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('CodeVersion') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.ProductName) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('ProductName') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.DocumentNum) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('DocumentNum') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.ProductStandard) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('ProductStandar') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.Unit) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('Unit') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.TaxClassCode) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('TaxClassCode') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }

                //判断金额是否为数字
                if (isNaN(parseFloat(m.Amount))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AmountNumberCheckErrorMsg') + '<br />';
                    count3++;
                }
                else if (parseFloat(m.Amount) < constant.startNum || parseFloat(m.Amount) > constant.endNum) {
                    NumlengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('Amount') + $translate.instant('NumOverLengthMsg') + '<br />';
                    NumLengthCount++;
                }
                else {
                    m.Amount = PWC.round(m.Amount, 2);
                }
                //判断税额是否为数字
                if (isNaN(parseFloat(m.TaxAmount))) {
                    taxAmountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('TaxAmountNumberCheckErrorMsg') + '<br />';
                    count4++;
                }
                else if (parseFloat(m.TaxAmount) < constant.startNum || parseFloat(m.TaxAmount) > constant.endNum) {
                    NumlengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('TaxAmount') + $translate.instant('NumOverLengthMsg') + '<br />';
                    NumLengthCount++;
                }
                else {
                    m.TaxAmount = PWC.round(m.TaxAmount, 2);
                }
                //判断单价是否为数字
                if (isNaN(parseFloat(m.UnitPrice))) {
                    unitPriceCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('UnitPriceNumberCheckErrorMsg') + '<br />';
                    unitPriceCount++;
                }
                else if (parseFloat(m.UnitPrice) < constant.startNum || parseFloat(m.UnitPrice) > constant.endNum) {
                    NumlengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('UnitPrice') + $translate.instant('NumOverLengthMsg') + '<br />';
                    NumLengthCount++;
                }
                else {
                    m.UnitPrice = PWC.round(m.UnitPrice, 2);
                }
                //判断数量是否为正整数字
                if (!PWC.isPositiveInteger(m.Quantity)) {
                    quantityCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AuantityNumberCheckErrorMsg') + '<br />';
                    count5++;
                }
                else if (parseFloat(m.Quantity) < 1 || parseFloat(m.Quantity) > 9999) {
                    NumlengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('Quantity') + $translate.instant('QuantityOverLengthMsg') + '<br />';
                    NumLengthCount++;
                }

                if (constant.outputTaxRate.indexOf(m.TaxRate) === -1) {
                    taxRateCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('TaxRateCheckErrorMsg') + '<br />';
                    count6++;
                }
                else {
                    if (percentList.indexOf(m.TaxRate) > -1) {
                        m.TaxRate = translatePercentNum(m.TaxRate);
                    }
                }
            });

            if (typeCount > 0) {
                $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.OutputInvoiceTypeErrorType,
                   'errorCount': typeCount,
                   'errorContent': typeMsg
               });
            }
            if (count1 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceDateErrorType,
                    'errorCount': count1,
                    'errorContent': invoiceDateCheckMsg
                });
            }
            if (count2 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.DateCheckErrorType,
                    'errorCount': count2,
                    'errorContent': invoiceDateRangeCheckMsg
                });
            }
            if (count3 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.AmountNumberCheckErrorType,
                    'errorCount': count3,
                    'errorContent': amountNumberCheckMsg
                });
            }
            if (count4 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.TaxAmountNumberCheckErrorType,
                    'errorCount': count4,
                    'errorContent': taxAmountNumberCheckMsg
                });
            }
            if (count5 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.AuantityNumberCheckErrorType,
                    'errorCount': count5,
                    'errorContent': quantityCheckMsg
                });
            }
            if (count6 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.TaxRateCheckErrorType,
                    'errorCount': count6,
                    'errorContent': taxRateCheckMsg
                });
            }
            if (unitPriceCount > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': $translate.instant('UnitPriceNumberCheckErrorType'),
                    'errorCount': unitPriceCount,
                    'errorContent': unitPriceCheckMsg
                });
            }
            if (stringCount > 0) {
                $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.OutputStringLengthType,
                   'errorCount': stringCount,
                   'errorContent': stringLengthMsg
               });
            }
            if (NumLengthCount > 0) {
                $scope.errorMsgMap.push(
               {
                   'errorType': $translate.instant('NumOutRangeErrorType'),
                   'errorCount': NumLengthCount,
                   'errorContent': NumlengthMsg
               });
            }

        }


        function doImportOutputInvoiceData(importType) {
            $scope.errorMsgMap = [];
            $scope.outputInvoiceList = [];
            $scope.outputInvoiceItemList = [];
            if ($scope.sheetData.dataList.length == 0) {
                SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
                return;
            }
            //1.验证模板
            if (validationIsImportTemp() == false) {
                SweetAlert.error($translate.instant('OutputTempError'));
                return;
            }
            //获取数据
            getOutputInvoiceData();
            //日志对象
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            }
            else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            }
            else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }
            //前台数据验证
            frontEndValidOutputInvoiceData();
            if ($scope.errorMsgMap.length > 0) {
                $('#errorListModal').modal('show');
                return;
            }
            else {
                vatImportService.importOutputInvoiceData($scope.outputInvoiceList, $scope.outputInvoiceItemList, importType).success(function (or) {
                    if (or && or.result) {
                        logDto.UpdateState = $translate.instant('ImportSuccess');
                        vatOperationLogService.addOperationLog(logDto);

                        initInvoiceDataFromDB($scope.period);
                        $scope.fileName = '';
                        vatCommonService.importSetProjectStatus(projectDbName, curPeriod
                            , constant.DictionaryDictKey.WFImportOutputInvoice, enums.FinishStatusEnum.Finished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isOutputInvoiceImport, true);
                        $log.debug("import outputInvoice importOutputInvoiceData: " + vatSessionService.project.importSubStatus.isOutputInvoiceImport);
                        SweetAlert.success($translate.instant('ImportSuccess'));
                    }
                    else {
                        logDto.UpdateState = $translate.instant('ImportFail');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.error($translate.instant('ImportFail'));
                    }
                }).error(function () {
                    logDto.UpdateState = $translate.instant('ImportFail');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        }


        //点击导入按钮时，进行导入操作
        function importOutputInvoiceData(importType) {
            if (vatSessionService.project.projectStatusList[curPeriod] >= constant.ProjectStatusEnum.Generated) {
                swal({
                    title: "warning!",
                    text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[curPeriod]) }),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                function (isConfirm) {
                    if (isConfirm) {
                        doImportOutputInvoiceData(importType);
                    }
                    else {
                        swal.close();
                    }
                });
            }
            else {
                doImportOutputInvoiceData(importType);
            }
        }

        //获取后台验证信息
        function getValidationList() {
            vatImportService.getValidationList(2, $scope.period).success(function (data) {
                if (data.length > 0) {
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.errorList = data;
                    $scope.gridOptionsErrorMsg.data = data;

                    showErrTab();
                    $scope.toggleErrorTab();
                    $scope.showErrorTable = true;
                }
                else {
                    $scope.errorList = [];
                    $scope.gridOptionsErrorMsg.data = [];
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //从数据库获取销项数据
        function initInvoiceDataFromDB(period) {
            $scope.showInitTable = true;
            $scope.showImportTable = false;
            vatSessionService.dataChanged = false;
            $scope.gridOptionsOutputInvoice.data = [];
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            $scope.invoiceData = [];
            vatImportService.getOutputInvoiceList(period).success(function (rsp) {
                if (rsp.data.length > 0) {
                    $scope.totalCount = rsp.returnCode;
                    $scope.isShowImportTotalBtn = false;
                    initPagingControl(rsp.data.length);
                    var skipCount = ($scope.pagingOptions.pageIndex - 1) * $scope.pagingOptions.pageSize;
                    var pagingData = _.chain(rsp.data).rest(skipCount).first($scope.pagingOptions.pageSize).value();

                    getValidationList();

                    var ouputList = pagingData;//rsp.data;
                    var index = 1;
                    var amountSum = 0;
                    var taxAmountSum = 0;
                    ouputList.forEach(function (v) {
                        if (!_.isNaN(parseFloat(v.amount) && !_.isNaN(parseFloat(v.taxAmount)))) {
                            amountSum += v.amount;
                            taxAmountSum += v.taxAmount;
                        }

                        v.index = index++;
                        v.unitPrice = PWC.round(v.unitPrice, 2);
                        v.amount = PWC.round(v.amount, 2);
                        v.taxRate = PWC.round(v.taxRate, 2);
                        v.taxAmount = PWC.round(v.taxAmount, 2);
                    });
                    $scope.gridOptionsOutputInvoice.data = ouputList;
                    $scope.totalData.totalNumber = ouputList.length;
                    $scope.totalData.amount = PWC.round(amountSum, 2);
                    $scope.totalData.taxAmount = PWC.round(taxAmountSum, 2);
                    initTableTitle();
                }
                else {
                    initTableTitle();
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //显示验证信息
        $scope.toggleErrorTab = function () {
            $scope.ImportErrorTag = !$scope.ImportErrorTag;

            // topIcon and content-resize gapBottom 15px
            if (!$scope.ImportErrorTag) {
                setErrorWrapCssDefault();
            } else {

                if (parseInt($('#content-resizer').css('bottom')) < 100) {
                    $('#content-resizer').css('bottom', '150px');

                    $('#topIcon').css({ bottom: '-381px' });

                    $('.error-info-wrapper').css('height', '150px');
                }
            }
        };

        var setErrorWrapCssDefault = function () {
            $('#content-resizer').css('bottom', '10px');

            $('#topIcon').css({ bottom: '-501px' });

            $('.error-info-wrapper').css('height', '0px');
        };

        function showErrTab() {
            $scope.ImportErrorTab = true;
            $scope.ImportErrorTag = true;
            $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

        };

        $scope.getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height() - 20) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };

        $scope.getErrorGridHeight = function () {
            if ($scope.isLoadComplete) {
                var y = $("#error-info-wrapper").height();
                // Enough space
                if (y > constant.UIGrid.gapHeight) {
                    y = y - constant.UIGrid.gapHeight;
                    return { height: y + "px" };
                } else {

                    return { height: '0px' };
                }
            }
            return {};
        };

        //显示图标
        $scope.errorLevelToString = function (errorLevel) {
            if (errorLevel === 0) {
                return '/app-resources/images/vat/error.png';
            }
            if (errorLevel === 1) {
                return '/app-resources/images/vat/warning.png';
            }
            if (errorLevel === 2) {
                return '/app-resources/images/vat/tips.png';
            }
            else {
                return '/app-resources/images/vat/tips.png';
            }
        }

        //显示明细
        var dealDetail = function () {
            return '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">查看明细</a><span></div>' +
                    '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>';
        }

        $scope.gridOptionsOutputInvoice = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,

            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;

                $interval(function () {
                    $scope.gridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        //验证信息数据源
        $scope.gridOptionsErrorMsg = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
            {
                name: $translate.instant('Icon'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
            },
              {
                  name: $translate.instant('SequenceNo'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorResult'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
              },
               {
                   name: $translate.instant('ErrorCount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
               },
              {
                  name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: dealDetail,
                  //cellTemplate: '<div class="ui-grid-cell-contents">' +
                  //   '<a ng-if="row.entity.isShowDetail" ng-click="grid.appScope.dispalyValidation(row.entity.validationDetails)">{{"ViewDetails" | translate}}</a>' +
                  //   '<span ng-if="!row.entity.isShowDetail" title="{{row.entity.validationDetails}}" data-ng-bind-html="row.entity.validationDetails"></span>' +
                  //   '</div>' 
              },
               {
                   name: $translate.instant('ValidationTips'), width: '25%', cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}"><span>{{row.entity.validationTips}}<span></div>'
               },
            ],
            onRegisterApi: function (gridApi) {
                $scope.errorGridApi = gridApi;

                $interval(function () {
                    $scope.errorGridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        //初始化列名
        function initTableTitle() {
            $scope.gridOptionsOutputInvoice.columnDefs = [];
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                    {
                                        name: $translate.instant('ImportErrorPopUpNoCol'), width: 50, headerCellClass: 'center',
                                        cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
                                    });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                   {
                                       name: $translate.instant('InvoiceType'), width: 150, headerCellClass: 'left',
                                       cellTemplate: '<div class="ui-grid-cell-contents"><span>{{grid.appScope.typeToString(row.entity.invoiceType)}}<span></div>'
                                   });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                  {
                                      name: $translate.instant('ClassCode'), width: 150, headerCellClass: 'left',
                                      cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.classCode}}<span></div>'
                                  });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('InvoiceNumber'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceNumber}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('BuyerName'), width: 200, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.buyerName}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('BuyerTaxNumber'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.buyerTaxNumber}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('BankAccount'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.bankAccount}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('PhoneNum'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.phoneNum}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('InvoiceDate'), width: 200, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceDate | date:"yyyy-MM-dd"}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('CodeVersion'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.codeVersion}}</span></div>'
                                 });

            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('DocumentNum'), width: 150, headerCellClass: 'left',
                                             cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.documentNum}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('ProductName'), width: 150, headerCellClass: 'left',
                                             cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.productName}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('ProductStandar'), width: 150, headerCellClass: 'left',
                                             cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.productStandard}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('Unit'), width: 150, headerCellClass: 'left',
                                             cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.unit}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('Quantity'), width: 150, headerCellClass: 'right',
                                             cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.quantity}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('UnitPrice'), width: 150, headerCellClass: 'right',
                                             cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.unitPrice}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('Amount'), width: 150, headerCellClass: 'right',
                                             cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.amount}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('TaxRate'), width: 150, headerCellClass: 'right',
                                             cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{grid.appScope.decimalToPercent(row.entity.taxRate)}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                        {
                                            name: $translate.instant('TaxAmount'), width: 150, headerCellClass: 'right',
                                            cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.taxAmount}}</span></div>'
                                        });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                        {
                                            name: $translate.instant('TaxClassCode'), width: 150, headerCellClass: 'left',
                                            cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.taxClassCode}}</span></div>'
                                        });

        }

        //清空数据
        var deleteOutputData = function () {
            swal({
                title: "warning!",
                text: $translate.instant('DeleteTbDataTip'),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    logDto.ID = PWC.newGuid();
                    logDto.CreateTime = new Date();
                    logDto.UpdateTime = new Date();
                    logDto.OperationContent = '';
                    logDto.OperationName = $translate.instant('ClearOutputInvoice');
                    logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;
                    vatImportService.clearOutputData($scope.period).success(function (data) {
                        if (data && data.result) {

                            $scope.showInitTable = true;
                            $scope.showImportTable = false;
                            $scope.isShowImportTotalBtn = true;
                            $scope.showErrorTable = false;
                            $scope.ImportErrorTab = false;
                            $scope.ImportErrorTag = false;
                            $scope.gridOptionsOutputInvoice.data = [];
                            $scope.totalCount = 0;
                            initTableTitle();
                            logDto.UpdateState = $translate.instant('ClearSuccess');
                            vatOperationLogService.addOperationLog(logDto);
                            vatCommonService.clearProjectStatus(projectDbName, curPeriod
                                , constant.DictionaryDictKey.WFImportOutputInvoice, enums.FinishStatusEnum.NotFinished);
                            vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isOutputInvoiceImport, false);
                            $log.debug("clear outputInvoice importOutputInvoiceData: " + vatSessionService.project.importSubStatus.isOutputInvoiceImport);
                            SweetAlert.success($translate.instant('ClearSuccess'));
                        }
                        else {
                            logDto.UpdateState = $translate.instant('ClearFailed');
                            vatOperationLogService.addOperationLog(logDto);

                            SweetAlert.warning($translate.instant('ClearFailed'));
                        }
                    }).error(function () {
                        logDto.UpdateState = $translate.instant('ClearFailed');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                    });
                }
                else {
                    return;
                }
            });
        }

        //刷新操作
        var refreshOutputData = function () {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = '';
            logDto.OperationName = $translate.instant('RefreshValidationData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
            //刷新数据
            vatImportService.refreshOutputInvoice($scope.period).success(function (data) {
                if (data && data.result) {
                    logDto.UpdateState = $translate.instant('RefreshSuccess');
                    vatOperationLogService.addOperationLog(logDto);

                    initInvoiceDataFromDB($scope.period);
                    SweetAlert.success($translate.instant('RefreshSuccess'));
                }
                else {
                    logDto.UpdateState = $translate.instant('RefreshTbFail');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.warning($translate.instant('RefreshTbFail'));
                }
            }).error(function () {
                logDto.UpdateState = $translate.instant('RefreshTbFail');
                vatOperationLogService.addOperationLog(logDto);

                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //显示税额验证信息
        var displayDifferenceValidation = function (sourcedata) {
            $scope.detailData = sourcedata;
            var dupColumns = [
            {
                caption: $translate.instant('InvoiceType'),
                calculateCellValue: function (data) {
                    return $scope.typeToString(data.InvoiceType);
                }
            },
            { caption: $translate.instant('ClassCode'), dataField: "ClassCode" },
            { caption: $translate.instant('InvoiceNumber'), dataField: "InvoiceNumber" },
            { caption: $translate.instant('Amount'), dataField: "Amount", format: { type: 'fixedPoint', precision: 2 } },
            { caption: $translate.instant('TaxAmount'), dataField: "TaxAmount", format: { type: 'fixedPoint', precision: 2 } },
            {
                caption: $translate.instant('TaxRate'), dataField: "TaxRate",
                calculateCellValue: function (data) {
                    return $scope.decimalToPercent(data.TaxRate);
                }
            },
            //{ caption: $translate.instant('AmountDifference'), dataField: "AmountDifference", format: { type: 'fixedPoint', precision: 2 }, width: 100 }, 
            ];

            $scope.deferStatus = true;
            $scope.filterCondition = ["IsDuplicate", "=", true];
            $scope.gridDifferenceOptions = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource": "detailData"
                },
                hoverStateEnabled: true,
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                paging: {
                    pageSize: 10
                }
            }
            $('#differenceValidationModal').modal('show');
        }

        //显示重复验证明细界面
        var dispalyDuplicatedValidation = function (sourcedata) {
            $scope.detailData = sourcedata;
            var dupColumns = [
            {
                caption: $translate.instant('InvoiceType'), width: 150,
                calculateCellValue: function (data) {
                    return $scope.typeToString(data.InvoiceType);
                }
            },
            { caption: $translate.instant('ClassCode'), dataField: "ClassCode", width: 150 },
            { caption: $translate.instant('InvoiceNumber'), dataField: "InvoiceNumber", width: 150 },
            { caption: $translate.instant('BuyerName'), dataField: "BuyerName", width: 200 },
            { caption: $translate.instant('BuyerTaxNumber'), dataField: "BuyerTaxNumber", width: 200 },
            { caption: $translate.instant('BankAccount'), dataField: "BankAccount", width: 150 },
            { caption: $translate.instant('PhoneNum'), dataField: "PhoneNum", width: 150 },
            { caption: $translate.instant('InvoiceDate'), dataField: "InvoiceDate", dataType: "date", width: 150 }, ];

            $scope.deferStatus = true;
            $scope.filterCondition = ["IsDuplicate", "=", true];
            $scope.gridDuplicatedOptions = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource.store.data": "detailData",
                    "selection.deferred": "deferStatus",
                    "selectionFilter": "filterCondition"
                },
                dataSource: {
                    store: {
                        type: "array",
                        key: 'InvoiceID'
                    }
                },
                selection: {
                    mode: "multiple",
                    selectAllMode: "allPages",
                    showCheckBoxesMode: "always",
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                },
            }
            $('#duplicatedValidationModal').modal('show');
        }

        //验证信息
        $scope.openTab = function (errorType, rowdata) {
            var data = JSON.parse(rowdata);
            if (errorType === 81) {
                displayDifferenceValidation(data);
            }
            else if (errorType === 80) {
                dispalyDuplicatedValidation(data);
            }
        }

        //删除重复数据
        var deleteDupData = function () {
            var dataGrid = $('#gridDuplicatedValidation').dxDataGrid("instance");
            var deleteList = [];
            dataGrid.getSelectedRowsData().done(function (rowData) {
                for (var i = 0; i < rowData.length; i++) {
                    deleteList.push(rowData[i].ClassCode);
                }
            });
            dataGrid.getSelectedRowKeys().done(function (keys) {
                if (keys && keys.length === 0) {
                    SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
                    return;
                }

                logDto.ID = PWC.newGuid();
                logDto.CreateTime = new Date();
                logDto.UpdateTime = new Date();
                logDto.OperationContent = deleteList.join(",");
                logDto.OperationName = $translate.instant('DeleteDuplicateData');
                logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

                vatImportService.deleteOutputDupData(keys).success(function (rsp) {
                    if (rsp && rsp.result) {
                        vatOperationLogService.addOperationLog(logDto);
                        //刷新数据
                        vatImportService.refreshOutputInvoice($scope.period).success(function (data) {
                            if (data && data.result) {
                                $('#duplicatedValidationModal').modal('hide');
                                SweetAlert.success($translate.instant('DeleteSuccess'));
                                initInvoiceDataFromDB($scope.period);
                            }
                            else {
                                SweetAlert.warning($translate.instant('RefreshTbFail'));
                            }
                        }).error(function () {
                            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                        });
                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            });
        }
        //日志
        $scope.showOperateLogPop = function () {
            $scope.isShowLog = true;
        };

        /****************************************证据文件function start*************************************************/
        var evidenceCount = 0;
        var allFilesCount = 0;
        var orderfileName = true;
        var orderperiodId = true;
        var orderfileType = true;
        $scope.chunkEvidenceSize = 10 * 1024 * 1024;
        var uploadEvidenceUrl = apiInterceptor.vatWebApiHostUrl + '/outputInvoiceImport/UploadEvidenceFile';
        //上传文件
        var uploadEvidenceFile = function (files) {
            if (files && files.length) {
                allFilesCount = files.length;
                evidenceCount = 0;
                for (var i = 0; i < files.length; i++) {
                    var file = files[i];
                    if (!file.$error) {
                        var tempFileName = PWC.newGuid() + '.dat';
                        var token = $('input[name="__RequestVerificationToken"]').val();
                        Upload.upload({
                            url: uploadEvidenceUrl,
                            data: {
                                cancel: false,
                                filename: file.name,
                                tempFileName: tempFileName,
                                file: file,
                                period: $scope.period
                            },
                            resumeChunkSize: resumable ? chunkSize : null,
                            headers: {
                                'Access-Control-Allow-Origin': '*',
                                Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken,
                                from: vatSessionService.project.dbName + '@cn.pwc.com'
                            },
                            __RequestVerificationToken: token,
                            withCredentials: true
                        }).then(uploadEvidenceSuccess);
                    }
                }
            }
        };
        //上传成功
        var uploadEvidenceSuccess = function (resp) {
            if (resp.data) {
                evidenceCount++;
                if (evidenceCount === allFilesCount) {
                    addEvidenceLog();
                    SweetAlert.success($translate.instant('UploadFileSuccess'));
                    searchEvidence();
                }
            }
        };

        //上传证据文件日志
        function addEvidenceLog() {
            var filename = ''
            if ($scope.evidenceFile.length > 0) {
                $scope.evidenceFile.forEach(function (m) {
                    filename += m.name + ';';
                });
            }
            //日志对象
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = filename;
            logDto.OperationName = $translate.instant('ImportEvidence');
            logDto.OperationType = enums.vatLogOperationTypeEnum.AddData;
            logDto.UpdateState = $translate.instant('UploadFileSuccess');
            vatOperationLogService.addOperationLog(logDto);
        }

        //删除证据文件日志
        function deleteEvidenceLog(deleteName) {
            //日志对象
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = deleteName;
            logDto.OperationName = $translate.instant('DeleteEvidence');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteData;
            logDto.UpdateState = $translate.instant('DeleteSuccess');
            vatOperationLogService.addOperationLog(logDto);
        }

        //验证导入文件数量和大小
        function validationEvidenceFile(files) {
            var isOk = true;
            $scope.evidenceMsgMap = [];
            var sizeString = '';
            var exString = '';
            var sizeCount = 0;
            var exCount = 0;
            if (files.length > 5) {
                $scope.evidenceMsgMap.push(
                       {
                           'errorType': $translate.instant('OutOfAmountType'),
                           'errorCount': files.length,
                           'errorContent': $translate.instant('OutOfAmount')
                       });
            }
            if (files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    var file = files[i];
                    var fileSize = file.size;
                    var fileExtension = files[i].name.split('.').pop().toLowerCase();
                    //大小不能超过10M
                    if (fileSize > $scope.chunkEvidenceSize) {
                        sizeString += files[i].name + ',';
                        sizeCount++;
                    }
                    if (fileExtension === 'exe') {
                        exString += files[i].name + ',';
                        exCount++;
                    }
                }
                if (sizeString) {
                    $scope.evidenceMsgMap.push(
                      {
                          'errorType': $translate.instant('OutOfSizeType'),
                          'errorCount': sizeCount,
                          'errorContent': $translate.instant('OutOfSize').formatObj({ rows: sizeString.substring(0, sizeString.length - 1) })
                      });
                }
                if (exString) {
                    $scope.evidenceMsgMap.push(
                      {
                          'errorType': $translate.instant('ErrorFileType'),
                          'errorCount': exCount,
                          'errorContent': $translate.instant('ErrorFileMsg'),
                      });
                }
            }
            if ($scope.evidenceMsgMap.length > 0) {
                $('#evidenceErrorListModal').modal('show');
                isOk = false;
            }
            return isOk;
        }

        //查询证据文件
        function searchEvidence() {
            $scope.evidenceList = [];
            var queryParams = {
                queryType: $scope.queryType,
                queryString: $scope.queryString,
                isCurrentPeriod: $scope.isCurrentPeriod,
                periodId: $scope.period
            };
            vatImportService.getEvidenceList(queryParams).success(function (data) {
                if (data.length > 0) {
                    $scope.evidenceList = data;
                    $scope.evidenceTotalCount = '(' + data.length + ')';
                }
                else if (data.length === 0) {
                    $scope.evidenceTotalCount = '';
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //查询文件数量
        function getEvidenceTitle() {
            searchEvidence();
            if ($scope.evidenceList.length > 0) {
                return $translate.instant('EvidenceTab') + '(' + $scope.evidenceList.length + ')';
            }
            else {
                return $translate.instant('EvidenceTab');
            }
        }

        //单击选中文件
        function selectEvidenceFile(evidence) {
            if ($scope.clicked) {
                $scope.cancelClick = true;
                return;
            }
            $scope.clicked = true;
            $timeout(function () {
                if ($scope.cancelClick) {
                    $scope.cancelClick = false;
                    $scope.clicked = false;
                    return;
                }
                evidence.isSelected = !evidence.isSelected;
                //clean up
                $scope.cancelClick = false;
                $scope.clicked = false;
            }, 300);
        }
        //下载
        $scope.openEvidenceFile = function (evidence) {
            var filePath = evidence.filePath;
            var fileName = evidence.fileName;
            $timeout(function (evidence) {
                var queryParams = {
                    filePath: filePath,
                    fileName: fileName
                };
                vatImportService.downloadEvidence(queryParams).success(function (data, status, headers) {
                    var octetStreamMime = 'application/octet-stream';
                    var contentType = headers('content-type') || octetStreamMime;
                    if (window.navigator.msSaveBlob) {

                        var blob = new Blob([data], {
                            type: contentType
                        });
                        navigator.msSaveBlob(blob, fileName);
                    } else {
                        var urlCreator = window.URL || window.webkitURL || window.mozURL || window.msURL;
                        if (urlCreator) {
                            var a = document.createElement('a');
                            var blob = new Blob([data], {
                                type: contentType
                            });
                            var url = urlCreator.createObjectURL(blob);
                            a.href = url;
                            a.target = '_blank';
                            a.download = fileName;
                            document.body.appendChild(a);
                            a.click();
                        }
                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            });
        }

        //删除文件
        function deleteEvidenceFiles() {
            var deleteList = [];
            var deleteName = '';
            $scope.evidenceList.forEach(function (m) {
                if (m.isSelected) {
                    deleteList.push(m.fileID);
                    deleteName += m.fileName + ';';
                }
            });
            if (deleteList.length > 0) {
                SweetAlert.
                swal({
                    title: "warning!",
                    text: $translate.instant('IsDelete'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
              function (isConfirm) {
                  if (isConfirm) {
                      vatImportService.deleteEvidences(deleteList).success(function (data) {
                          if (data) {
                              deleteEvidenceLog(deleteName);
                              searchEvidence();
                          }
                      }).error(function () {
                          SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                      });
                  }
              });
            }
        }

        //排序方法
        var dataType = {
            isPrefixNumber: function (value) {
                var reg = /^\d+/;
                if (reg.test(value)) {
                    return true;
                } else {
                    return false;
                }
            },
            isPrefixChar: function (value) {
                var reg = /^[a-zA-Z]+/;
                if (reg.test(value)) {
                    return true;
                } else {
                    return false;
                }
            },
            isPrefixNumberOrChar: function (value) {
                if (dataType.isPrefixNumber(value)) {
                    return true;
                }
                if (dataType.isPrefixChar(value)) {
                    return true;
                }
                return false;
            }
        }

        var sortByFileName = function (data) {
            if (data && data.length > 0) {

                var charList = [];
                var nocharList = [];

                data.forEach(function (row) {
                    if (dataType.isPrefixNumberOrChar(row.fileName)) {
                        row.nameSort = row.fileName;

                        if (row.nameSort) {
                            row.nameSort = row.nameSort.toLowerCase();
                        }

                        charList.push(row);

                    } else {
                        nocharList.push(row);
                    }

                });

                charList = _.sortBy(charList, 'nameSort');

                nocharList = nocharList.sort(function compareFunction(param1, param2) {
                    return param1.fileName.localeCompare(param2.fileName, 'zh');
                });

                var all = _.union(charList, nocharList);
                return all;
            }
            return data;
        };

        //排序
        function fileSort(i) {
            if ($scope.evidenceList.length > 0) {
                if (i == 0) {
                    if (orderfileName) {
                        orderfileName = false;
                        var list = sortByFileName($scope.evidenceList);
                        //var list = _.sortBy($scope.evidenceList, 'fileName');                       
                        //var list = list.sort(function (x, y) { return x['name'].localeCompare(y['name']) }); 
                        $scope.evidenceList = list;
                    }
                    else {
                        orderfileName = true;
                        //var list = _.sortBy($scope.evidenceList, 'fileName');
                        var list = sortByFileName($scope.evidenceList);
                        $scope.evidenceList = list.reverse();
                    }
                }
                if (i == 1) {
                    if (orderperiodId) {
                        orderperiodId = false;
                        var list = _.sortBy($scope.evidenceList, 'periodID');
                        $scope.evidenceList = list;
                    }
                    else {
                        orderperiodId = true;
                        var list = _.sortBy($scope.evidenceList, 'periodID');
                        $scope.evidenceList = list.reverse();
                    }
                }
                if (i == 2) {
                    if (orderfileType) {
                        orderfileType = false;
                        var list = _.sortBy($scope.evidenceList, 'fileType');
                        $scope.evidenceList = list;
                    }
                    else {
                        orderfileType = true;
                        var list = _.sortBy($scope.evidenceList, 'fileType');
                        $scope.evidenceList = list.reverse();
                    }
                }
            }

        }

        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.outputInvoice.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };

        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        }

        $scope.pagingService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
                initInvoiceDataFromDB($scope.period);
            },
        };

        var setButtonWrapStyle = function () {
            if ($scope.showImportTable) {
                return { width: "100%" };
            }
        };

        //开始
        (function initialize() {
            $log.debug('ImportOutputInvoiceController.ctor()...');
            /****************************************销项发票function start*************************************************/

            $scope.switchTab = switchTab;
            $scope.changeSheet = changeSheet;
            $scope.importOutputInvoiceData = importOutputInvoiceData;
            $scope.refreshOutputData = refreshOutputData;
            $scope.deleteOutputData = deleteOutputData;
            $scope.deleteDupData = deleteDupData;

            getUserPermission();
            initInvoiceDataFromDB($scope.period);
            $scope.$watch('fileNameWrapper', function (newValue, oldValue) {
                if (newValue != null && newValue !== oldValue) {
                    //设置上传文件名
                    var arr = newValue.name.split('.');
                    if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                        SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                        return;
                    }
                    $scope.fileName = newValue.name;
                    uploadfile($scope.fileNameWrapper);
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            });

            /****************************************证据文件function start*************************************************/
            $scope.evidenceList = [];
            $scope.isCurrentPeriod = true;
            $scope.queryType = '';
            $scope.queryString = '';
            $scope.searchEvidence = searchEvidence;
            $scope.selectEvidenceFile = selectEvidenceFile;
            $scope.deleteEvidenceFiles = deleteEvidenceFiles;
            $scope.getEvidenceTitle = getEvidenceTitle;
            $scope.fileSort = fileSort;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            searchEvidence();
            $scope.$watch('evidenceFile', function (newValue, oldValue) {
                if (newValue != null && newValue !== oldValue) {
                    //验证文件数量和大小
                    if (validationEvidenceFile($scope.evidenceFile)) {
                        uploadEvidenceFile($scope.evidenceFile);
                    }
                }
            });

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);

        })();
    }
]);
vatModule.directive('vatImportOutputInvoice', ['$log',
    function ($log) {
        'use strict';
        $log.debug('vatImportOutputInvoice.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/import/vat-import-output-invoice/vat-import-output-invoice.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'VatImportOutputInvoiceController',
            link: function (scope, element) {

            }
        };
    }
]);
vatModule.directive('vatImportTrialBalance', ['$log', 'enums', 'vatSessionService',
    function ($log, enums, vatSessionService) {
        'use strict';
        $log.debug('vatImportTrialBalance.ctor()...');

        return {
            restrict: 'E',
            template: '<import-trial-balance service-type-id="serviceTypeId" period-id="periodId"></import-trial-balance>',
            scope: {},
            link: function (scope, element) {
                scope.periodId = vatSessionService.month;
                scope.serviceTypeId = enums.serviceType.VAT;
            }
        };
         
    }
]); 

vatModule.controller('vatInvoiceMappingController', ['$scope', '$log', '$timeout', '$q', '$interval', '$translate', 'loginContext', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', 'vatImportService', 'vatSessionService', 'uiGridConstants', 'enums', 'vatCommonService', 'vatOperationLogService',
function ($scope, $log, $timeout, $q, $interval, $translate, loginContext, apiInterceptor, Upload, dataImportService, SweetAlert, vatImportService, vatSessionService, uiGridConstants, enums, vatCommonService, vatOperationLogService) {
    'use strict';
    $log.debug('vatInvoiceMappingController.ctor()...');

    var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
    var successCount = 0;
    var resumable = true;
    var period = vatSessionService.month;
    var year = 2017;
    var projectDbName = vatSessionService.project.dbName;
    $scope.chunkSize = 100000;
    $scope.columnNum = 1;
    $scope.showErrorTable = false;
    $scope.showInitTable = false;
    $scope.showImportTable = false
    $scope.period = period;
    $scope.moduleid = enums.vatModuleEnum.Import_InvoiceMapping;
    var logDto = {};
    logDto.ModuleID = $scope.moduleid;
    logDto.CreatorID = vatSessionService.logUser.ID;
    logDto.OperationObject = $translate.instant('invoiceMappingDesc');
    logDto.Comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    logDto.Period = period;

    var validationErrorType = {
        ColumnsMapErrorType: $translate.instant('ColumnsMapErrorType'),
        InvoiceCodeEmptyErrorType: $translate.instant('InvoiceCodeEmptyErrorType'),
        InvoiceNumberEmptyErrorType: $translate.instant('InvoiceNumberEmptyErrorType'),
        TrancodeParseEmptyErrorType: $translate.instant('TrancodeParseEmptyErrorType'),
        NumOutRangeErrorType: $translate.instant('NumOutRangeErrorType'),
        OutputStringLengthType: $translate.instant('OutputStringLengthType'),
        StartRowError: $translate.instant('StartRowError')
    };
    
    var initColumns = function () {

        $scope.allColumns = [
            $translate.instant('PleaseSelectColumn'),
            $translate.instant('tranCode'),
            $translate.instant('invoiceCode'),
            $translate.instant('invoiceNumber')
        ];

        $scope.necessoryColumns = [
            $translate.instant('tranCode'),
            $translate.instant('invoiceCode'),
            $translate.instant('invoiceNumber')
        ];
    };

    var initGrid = function () {

        $scope.gridOptions = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableFullRowSelection: false,
            enableRowSelection: false,
            enableSorting: false,
            enableFiltering: false,
            enableColumnMenus: false,
            enableRowHeaderSelection: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
            columnDefs: [
            {
                field: 'index', name: $translate.instant('ImportErrorPopUpNoCol'), width: '10%', headerCellClass: '', enableFiltering: false,

                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
            },
              {
                  field: 'tranCode', name: $translate.instant('tranCode'), width: '30%', headerCellClass: '',

                  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.tranCode}}">{{row.entity.tranCode}}<span></div>'
              },

              {
                  field: 'invoiceCode', name: $translate.instant('invoiceCode'), width: '30%', headerCellClass: '',

                  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.invoiceCode}}">{{row.entity.invoiceCode}}</span></div>'
              },
              {
                  field: 'invoiceNumber', name: $translate.instant('invoiceNumber'), width: '30%', headerCellClass: '',

                  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.invoiceNumber}}">{{row.entity.invoiceNumber}}</span></div>'
              }
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiTotal = gridApi;
            }
        };

        $scope.gridOptions.noData = false;
    };

    $scope.$on(enums.vatEvent.layoutChanged, function () {
        $scope.gridApiTotal.core.handleWindowResize();
        $scope.errorGridApi.core.handleWindowResize();
    });


    var mapppingList = function () {
        return [{ TranCode: 'A0000001', InvoiceCode: 'ABDJSHS', InvoiceNumber: '201702251000' },
            { TranCode: 'A0000006', InvoiceCode: 'SDFADSS', InvoiceNumber: '201702261020' },
            { TranCode: 'A0000010', InvoiceCode: 'SDFDFES', InvoiceNumber: '201702051006' }];
    }

    //parentIndex：column index
    //index：selecteditem index
    var mappingColumn = function (parentIndex, index, colName) {
        if (colName) {

            var oldColumn = $scope.selectedColumnMap[parentIndex];
            var newColumn = $scope.allColumns[index];

            if (oldColumn === newColumn) {
                return;
            }
            else {
                $scope.selectedColumnMap[parentIndex] = colName;

                if (colName !== $translate.instant('PleaseSelectColumn')) {
                    $scope.allColumns.splice(index, 1);

                    if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                        $scope.allColumns.push(oldColumn);
                    }
                }
                else {
                    if (oldColumn) {
                        $scope.allColumns.push(oldColumn);
                    }
                }
            }
        }
        $log.debug($scope.selectedColumnMap);
    };

    var UploadFile = function (file) {
        if (file) {
            if (!file.name.endsWith('.xls') != 0 && !file.name.endsWith('.xlsx')) {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            };
            $scope.initIncomeInvoiceList = [];
            successCount = 0;
            if (!file.$error) {
                var tempFileName = PWC.newGuid() + '.dat';
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        filename: file.name,
                        tempFileName: tempFileName,
                        file: file
                    },
                    resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                    },
                    __RequestVerificationToken: $scope.token,
                    withCredentials: true
                }).then(function (resp) {
                    successCount++;
                    $scope.fileName = file.name;
                    if (successCount === 1) {
                        $scope.tempFileName = resp.data;
                        changeSheet(0);
                    }
                });
            }
        }
    }

    var resetMappingRow = function () {
        initColumns();
        $scope.selectedColumnMap = [];
    };

    var changeSheet = function (index) {
        $scope.showErrorTable = false;
        $scope.selectedSheet.sheetIndex = index;
        resetMappingRow();
        if (_.isString($scope.tempFileName)) {
            $scope.excelSource = { sheetNameList: [], dataList: [] };
            vatImportService.getFileContent($scope.tempFileName, $scope.selectedSheet.sheetIndex, $scope.selectedSheet.topRowNumber).success(function (data) {
                if (data && data.result === false) {
                    $scope.showInitTable = true;
                    $scope.showImportTable = false;
                    SweetAlert.warning(data.resultMsg);
                    return;
                }
                var index = 1;
                data.dataList.forEach(function (i) {
                    i.index = index++;
                });
                $scope.showInitTable = false;
                $scope.showImportTable = true
                $scope.excelSource = data;
                $scope.firstDataRow = data.dataList[0];
                $scope.columnNum = data.dataList[0].length;
                $scope.startRowList = _.range(data.lastRowIndex);
                $scope.selectedSheet.sheetName = $scope.excelSource.sheetNameList[$scope.selectedSheet.sheetIndex];
                $scope.isImportView = true;
                vatSessionService.dataChanged = true;
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }
    };

    var validatefirst = function () {
        var result = true;
        var notMappedColumns = '';
        $scope.errorMsgMap = [];
        if ($scope.selectedColumnMap.length >= 0) {
            var count1 = 0;
            $scope.necessoryColumns.forEach(function (m) {
                if (m !== $translate.instant('PleaseSelectColumn')) {
                    if ($.inArray(m, $scope.selectedColumnMap) < 0) {
                        notMappedColumns += m + ',';
                        count1++;
                    }
                }
            });
            if (count1) {
                result = false;
                //加入到错误列表中
                $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.ColumnsMapErrorType,
                        'errorCount': count1,
                        'errorContent': $translate.instant('ColumnsMapErrorMsg').formatObj({ columns: notMappedColumns.substring(0, notMappedColumns.length - 1) })
                    });
            }
        }
        //2:判断起始行输入框输入内容是否合理
        var startNumberCheckMsg = '';
        $scope.StartRowNum = $('#StartRowNum').val();
        if ($scope.StartRowNum === '') {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
        }
        else if (parseInt($scope.StartRowNum) > $scope.excelSource.dataList.length) {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
        }
        return result;
    };

    var validateClientSide = function (dataList) {
        var InvoiceCodeEmptyCheckMsg = '';
        var InvoiceCodeEmptyCheckCount = 0;

        var InvoiceNumberEmptyCheckMsg = '';
        var InvoiceNumberEmptyCheckCount = 0;

        var TranCodeEmptyCheckMsg = '';
        var TranCodeEmptyCheckCount = 0;

        var numOutRangeCheckMsg = '';
        var numOutRangeCheckCount = 0;

        var stringOverLengthCheckMsg = '';
        var stringOverLengthCheckCount = 0;

        dataList.forEach(function (m) {
            var curRowInfo = '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' +
                            $translate.instant('tranCode') + ':' + m.TranCode + ',' +
                            $translate.instant('invoiceCode') + ':' + m.InvoiceCode + ',' +
                            $translate.instant('invoiceNumber') + '：' + m.InvoiceNumber + ';<br />';

            if (PWC.isNullOrEmpty(m.InvoiceCode)) {
                //InvoiceCodeEmptyCheckCount++;
                //InvoiceCodeEmptyCheckMsg += curRowInfo;
            }
            else {

                if (m.InvoiceCode.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('invoiceCode') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }


            if (PWC.isNullOrEmpty(m.InvoiceNumber)) {
                InvoiceNumberEmptyCheckCount++;
                InvoiceNumberEmptyCheckMsg += curRowInfo;
            }
            else {

                if (m.InvoiceNumber.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('invoiceNumber') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }

            if (PWC.isNullOrEmpty(m.TranCode)) {
                TranCodeEmptyCheckCount++;
                TranCodeEmptyCheckMsg += curRowInfo;
            }
            else {

                if (m.TranCode.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('tranCode') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }
        });

        if (InvoiceCodeEmptyCheckCount > 0) {
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceCodeEmptyErrorType,
                    'errorCount': InvoiceCodeEmptyCheckCount,
                    'errorContent': InvoiceCodeEmptyCheckMsg
                });
        }
        if (InvoiceNumberEmptyCheckCount > 0) {
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceNumberEmptyErrorType,
                    'errorCount': InvoiceNumberEmptyCheckCount,
                    'errorContent': InvoiceNumberEmptyCheckMsg
                });
        }
        if (TranCodeEmptyCheckCount > 0) {
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.TrancodeParseEmptyErrorType,
                    'errorCount': TranCodeEmptyCheckCount,
                    'errorContent': TranCodeEmptyCheckMsg
                });
        }
        if (stringOverLengthCheckCount > 0) {
            $scope.errorMsgMap.push({
                'errorType': validationErrorType.OutputStringLengthType,
                'errorCount': stringOverLengthCheckCount,
                'errorContent': stringOverLengthCheckMsg
            });
        }

        if (numOutRangeCheckCount > 0) {
            $scope.errorMsgMap.push({
                'errorType': validationErrorType.NumOutRangeErrorType,
                'errorCount': numOutRangeCheckCount,
                'errorContent': numOutRangeCheckMsg
            });
        }
    }

    function doSave2Server(saveType) {
        // saveType 1：override，2：append

        if (!validatefirst()) {
            $('#errorListModal').modal('show');
            return;
        }

        var dataList = [];
        for (var i = $scope.StartRowNum - 1; i < $scope.excelSource.dataList.length; i++) {
            var item = {
                'Index': $scope.excelSource.dataList[i].index,
                'Period': period,
                'InvoiceCode': $scope.excelSource.dataList[i][$.inArray($translate.instant('invoiceCode'), $scope.selectedColumnMap)],
                'InvoiceNumber': $scope.excelSource.dataList[i][$.inArray($translate.instant('invoiceNumber'), $scope.selectedColumnMap)],
                'TranCode': $scope.excelSource.dataList[i][$.inArray($translate.instant('tranCode'), $scope.selectedColumnMap)]
            };
            dataList.push(item);
        }

        validateClientSide(dataList);
        if ($scope.errorMsgMap.length > 0) {
            $('#errorListModal').modal('show');
            return;
        }

        if (dataList.length == 0) {
            SweetAlert.warning($translate.instant('noCurMonthRecordErrorMsg'));
            return;
        }
        else {
            vatImportService.SaveInvoiceMappings(dataList, period, saveType).success(function (data) {
                if (data) {
                    if (data.result) {

                        logDto.ID = PWC.newGuid();
                        logDto.CreateTime = new Date();
                        logDto.UpdateTime = new Date();
                        logDto.OperationContent = $scope.fileName;
                        if (saveType === 2) {
                            logDto.OperationName = $translate.instant('AddImportBtn');
                            logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
                        }
                        else if (saveType === 1) {
                            logDto.OperationName = $translate.instant('ConverImportBtn');
                            logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
                        }
                        logDto.UpdateState = $translate.instant('ImportSuccess');
                        vatOperationLogService.addOperationLog(logDto);

                        $scope.showInitTable = true;
                        $scope.showImportTable = false;
                        $scope.showErrorTable = false;
                        $scope.ImportErrorTab = false;
                        $scope.ImportErrorTag = false;
                        vatCommonService.importSetProjectStatus(projectDbName, period, constant.DictionaryDictKey.WFImportInvoiceMap
                                                                , enums.FinishStatusEnum.Finished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isInvoiceMapImport, true);
                        $log.debug("import invoiceMapping save2Server: " + vatSessionService.project.importSubStatus.isInvoiceMapImport);
                        SweetAlert.success($translate.instant('ImportSuccess'));
                        resetMappingRow();
                        getMappings();
                        $scope.fileName = '';
                    }
                    //else {
                    //    processValidateMsg(data.data);
                    //    if ($scope.errorMsgMap.length > 0) {
                    //        $('#errorListModal').modal('show');
                    //    }
                    //}
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }
    }

    var save2Server = function (saveType) {
        if ($scope.excelSource.sheetNameList.length == 0) {
            SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
            return;
        }

        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Generated) {
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    $timeout(function () { doSave2Server(saveType) }, 300);
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doSave2Server(saveType);
        }
    };

    var buildDataStr = function (p) {
        var empty = '<' + $translate.instant('empty') + '>';
        return $translate.instant('tranCode') + ':' + (PWC.isNullOrEmpty(p.tranCode) ? empty : p.tranCode) + ',' +
               $translate.instant('invoiceCode') + ':' + (PWC.isNullOrEmpty(p.invoiceCode) ? empty : p.invoiceCode) + ',' +
               $translate.instant('invoiceNumber') + ':' + (PWC.isNullOrEmpty(p.invoiceNumber) ? empty : p.invoiceNumber) + ';<br />';
    };
    
    var clear = function () {
        swal({
            title: "warning!",
            text: $translate.instant('ClearTips'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#DD6B55",
            confirmButtonText: $translate.instant('Yes'),
            cancelButtonText: $translate.instant('No'),
            closeOnConfirm: true,
            closeOnCancel: true
        }, function (isConfirm) {
            if (isConfirm) {
                var dataList = [];
                var saveType = 1;//overide
                vatImportService.SaveInvoiceMappings(dataList, period, saveType).success(function (data) {
                    if (data && data.result) {

                        logDto.ID = PWC.newGuid();
                        logDto.CreateTime = new Date();
                        logDto.UpdateTime = new Date();
                        logDto.OperationContent = '';
                        logDto.OperationName = $translate.instant('ClearAll');
                        logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;
                        logDto.UpdateState = $translate.instant('ClearSuccess');
                        vatOperationLogService.addOperationLog(logDto);

                        $scope.showInitTable = true;
                        $scope.showImportTable = false;
                        $scope.showErrorTable = false;
                        $scope.ImportErrorTab = false;
                        $scope.ImportErrorTag = false;
                        vatCommonService.clearProjectStatus(projectDbName, period, constant.DictionaryDictKey.WFImportInvoiceMap
                                                                   , enums.FinishStatusEnum.NotFinished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isInvoiceMapImport, false);
                        $log.debug("clear invoiceMapping clear: " + vatSessionService.project.importSubStatus.isInvoiceMapImport);
                        SweetAlert.success($translate.instant('ClearSuccess'));
                        resetMappingRow();
                        getMappings();
                    }
                });
            }
        }).error(function () {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    };

    var getMappings = function () {
        vatImportService.GetInvoiceMappings(period).success(function (data) {
            if (data.length > 0) {
                GetValidationList();
            }
            else {
                $scope.haveImported = false;
                $scope.showErrorTable = false;
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;
            }
            $scope.excelSource = { sheetNameList: [], dataList: [] };
            $scope.mapppingList = data; var seqNo = 1;
            $scope.mapppingList.forEach(function (i) {
                i.index = seqNo;
                seqNo++;
            });
            //获取发票对应数据
            $scope.gridOptions.data = $scope.mapppingList;
            $scope.gridOptions.noData = $scope.mapppingList.length === 0;
            $scope.isImportView = false;
            $scope.firstDataRow = null;
            vatSessionService.dataChanged = false;
        }).error(function () {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    };

    $scope.$watch('selectedFileName', function (newValue, oldValue) {
        if (newValue && newValue !== oldValue) {
            UploadFile($scope.selectedFileName);
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;
            resetMappingRow();
        }
    });

    $scope.gridOptionsErrorMsg = {
        rowHeight: constant.UIGrid.rowHeight,
        selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
        enableSorting: false,
        enableColumnMenus: false,
        enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
        enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
        columnDefs: [
        {
            name: $translate.instant('Icon'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
        },
          {
              name: $translate.instant('SequenceNo'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
          },
          {
              name: $translate.instant('ErrorResult'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
          },
           {
               name: $translate.instant('ErrorCount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
           },
          {
              name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">查看明细</a><span></div>' +
                '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>'
          },
           {
               name: $translate.instant('ValidationTips'), width: '25%', cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}"><span>{{row.entity.validationTips}}<span></div>'
           },
        ],
        onRegisterApi: function (gridApi) {
            $scope.errorGridApi = gridApi;

        }
    };

    function GetValidationList() {
        $scope.validationType = 10;
        vatImportService.getValidationList($scope.validationType, period).success(function (data) {
            if (data.length > 0) {
                var index = 1;
                data.forEach(function (v) {
                    v.index = index++;
                });
                $scope.errorList = data;
                $scope.gridOptionsErrorMsg.data = data;

                showErrTab();
                $scope.toggleErrorTab();
                $scope.showErrorTable = true;
            }
            else {
                $scope.errorList = [];
                $scope.gridOptionsErrorMsg.data = [];
                $scope.showErrorTable = false;
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;
            }
        });
    }

    $scope.errorLevelToString = function (errorLevel) {
        if (errorLevel === 0) {
            return '/app-resources/images/vat/error.png';
        }
        if (errorLevel === 1) {
            return '/app-resources/images/vat/warning.png';
        }
        if (errorLevel === 2) {
            return '/app-resources/images/vat/tips.png';
        }
        else {
            return '/app-resources/images/vat/tips.png';
        }
    }

    $scope.toggleErrorTab = function () {
        $scope.errorGridApi.core.handleWindowResize();
        $scope.ImportErrorTag = !$scope.ImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.ImportErrorTag) {
            setErrorWrapCssDefault();
        } else {

            if (parseInt($('#content-resizer').css('bottom')) < 100) {
                $('#content-resizer').css('bottom', '190px');

                $('#topIcon').css({ bottom: '-381px' });

                $('.error-info-wrapper').css('height', '190px');
            }
        }
    };

    var dealDetail = function () {
        return '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">查看明细</a><span></div>' +
                '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>';
    }

    $scope.openTab = function (errorType, rowdata) {
        var data = JSON.parse(rowdata);
        if (errorType === 45) {
            dispalyDuplicatedValidation(data);
        }
    }
 
    $scope.deleteDupData = function () {
        var dataGrid = $('#gridDuplicatedValidation').dxDataGrid("instance");
        var deleteList = [];
        dataGrid.getSelectedRowsData().done(function (rowData) {
            for (var i = 0; i < rowData.length; i++) {
                var msg = $translate.instant('tranCode') + ':' + rowData[i].TranCode + ',' +
                                            $translate.instant('period') + ':' + rowData[i].Period + ',' +
                                            $translate.instant('vid') + ':' + rowData[i].VID + ',' +
                                            $translate.instant('vGroup') + ':' + rowData[i].Group + ',' +
                                            $translate.instant('itemID') + '：' + rowData[i].ItemID;
                deleteList.push(msg);
            }
        });
        dataGrid.getSelectedRowKeys().done(function (keys) {
            if (keys && keys.length === 0) {
                SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
                return;
            }

            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = deleteList.join(";");
            logDto.OperationName = $translate.instant('DeleteDuplicateData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

            vatImportService.deleteInvoiceMappings(keys).success(function (rsp) {
                if (rsp) {
                    logDto.UpdateState = $translate.instant('DeleteSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    //刷新数据
                    vatImportService.validDBInvoiceMapping(period).success(function (result) {
                        if (result) {
                            logDto.ID = PWC.newGuid();
                            logDto.CreateTime = new Date();
                            logDto.UpdateTime = new Date();
                            logDto.OperationContent = $translate.instant('invoiceMappingDesc');
                            logDto.OperationName = $translate.instant('RefreshValidationData');
                            logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
                            logDto.UpdateState = $translate.instant('RefreshSuccess');
                            vatOperationLogService.addOperationLog(logDto);

                            $('#duplicatedValidationModal').modal('hide');
                            SweetAlert.success($translate.instant('DeleteSuccess'));
                            getMappings();
                        }
                        else {
                            SweetAlert.warning($translate.instant('RefreshTbFail'));
                        }
                    }).error(function (e) {
                        SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                    });
                }

            }).error(function (e) {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        });
    }

    $scope.refreshData = function () {
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = $translate.instant('invoiceMappingDesc');
        logDto.OperationName = $translate.instant('RefreshValidationData');
        logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
        //刷新数据
        vatImportService.validDBInvoiceMapping(period).success(function (result) {
            if (result) {
                logDto.UpdateState = $translate.instant('RefreshSuccess');
                vatOperationLogService.addOperationLog(logDto);

                getMappings();
                SweetAlert.success($translate.instant('RefreshSuccess'));
            }
            else {
                SweetAlert.warning($translate.instant('RefreshTbFail'));
            }
        }).error(function (e) {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }

    var dispalyDuplicatedValidation = function (sourcedata) {
        $scope.detailData = sourcedata;
        var dupColumns = [
        { caption: $translate.instant('tranCode'), dataField: "TranCode", width: 180 },
        { caption: $translate.instant('period'), dataField: "Period", width: 100 },
        { caption: $translate.instant('vGroup'), dataField: "Group", width: 180 },
        { caption: $translate.instant('vid'), dataField: "VID", width: 180 },
        { caption: $translate.instant('itemID'), dataField: "ItemID", dataType: "date", width: 180 }, ];

        $scope.deferStatus = true;
        $scope.filterCondition = ["IsDuplicate", "=", true];
        $scope.gridDuplicatedOptions = {
            columns: dupColumns,
            bindingOptions: {
                "dataSource.store.data": "detailData",
                "selection.deferred": "deferStatus",
                "selectionFilter": "filterCondition"
            },
            dataSource: {
                store: {
                    type: "array",
                    key: 'ID'
                }
            },
            selection: {
                mode: "multiple",
                selectAllMode: "allPages",
                showCheckBoxesMode: "always",
            },
            hoverStateEnabled: true,
            paging: {
                pageSize: 10
            },
        }
        $('#duplicatedValidationModal').modal('show');
    }

    var setErrorWrapCssDefault = function () {
        $('#content-resizer').css('bottom', '65px');

        $('#topIcon').css({ bottom: '-501px' });

        $('.error-info-wrapper').css('height', '65px');
    };

    function showErrTab() {
        $scope.ImportErrorTab = true;
        $scope.ImportErrorTag = true;
        $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

    };

    $scope.getGridHeight = function () {
        if ($scope.isLoadComplete) {
            return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
        }
        else {
            return { height: 0 + "px" };
        }
    };

    $scope.getErrorGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $("#error-info-wrapper").height();
            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: y + "px" };
            } else {

                return { height: '0px' };
            }
        }
        return {};
    };

    $scope.showOperateLogPop = function () {
        $scope.isShowLog = true;
    };

    //控制明细信息中删除权限
    var getUserPermission = function () {
        var list = [];
        var code = constant.vatPermission.dataImport.invoiceMapping.importCode;
        list.push(code);

        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
            $scope.hasImportPermission = data[code];
        });
    };

    (function initialize() {
        $scope.StartRowNum = 2;
        $scope.isImportView = false;
        $scope.mapppingList = [];
        $scope.mappingRow = null;
        $scope.firstDataRow = null;
        $scope.selectedColumnMap = [];
        $scope.selectedFileName = '';
        $scope.excelSource = { sheetNameList: [], dataList: [] };
        $scope.selectedSheet = { sheetName: '', sheetIndex: 0, topRowNumber: 0 };

        initColumns();
        initGrid();
        getUserPermission();
        $scope.mapppingList = getMappings();
        //$scope.refresh = getMappings;
        $scope.clear = clear;

        $scope.changeSheet = changeSheet;
        $scope.mappingColumn = mappingColumn;
        $scope.save2Server = save2Server;

        $scope.showInitTable = true;
        $scope.showImportTable = false;
        $timeout(function () {
            $scope.isLoadComplete = true;
        }, 500);

    })();
}
]);

vatModule.directive('vatInvoiceMapping', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatInvoiceMapping.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/import/vat-invoice-mapping/vat-invoice-mapping.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'vatInvoiceMappingController',
            link: function ($scope, $element, $attr) {
                $scope.token = $('input[name="__RequestVerificationToken"]').val();
            }
        };
    }
]);

vatModule.controller('vatVoucherMappingController', ['$scope', '$log', '$timeout', '$q', '$interval', '$translate', 'loginContext', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', 'vatImportService', 'vatSessionService', 'uiGridConstants', 'enums', 'vatCommonService', 'vatOperationLogService',
function ($scope, $log, $timeout, $q, $interval, $translate, loginContext, apiInterceptor, Upload, dataImportService, SweetAlert, vatImportService, vatSessionService, uiGridConstants, enums, vatCommonService, vatOperationLogService) {
    'use strict';
    $log.debug('vatVoucherMappingController.ctor()...');

    var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
    var successCount = 0;
    var resumable = true;
    var period = vatSessionService.month;
    var projectDbName = vatSessionService.project.dbName;
    $scope.chunkSize = 100000;
    $scope.columnNum = 1;
    $scope.period = period;

    $scope.showErrorTable = false;
    $scope.showInitTable = false;
    $scope.showImportTable = false;
    $scope.moduleid = enums.vatModuleEnum.Import_VoucherMapping;
    var logDto = {};    
    logDto.ModuleID = $scope.moduleid;
    logDto.CreatorID = vatSessionService.logUser.ID;
    logDto.OperationObject = $translate.instant('voucherMappingDesc');
    logDto.Comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    logDto.Period = period;
    
    var validationErrorType = {
        ColumnsMapErrorType: $translate.instant('ColumnsMapErrorType'),
        JournalEntryVIDEmptyErrorType: $translate.instant('JournalEntryVIDEmptyErrorType'),
        JournalEntryGroupEmptyErrorType: $translate.instant('JournalEntryGroupEmptyErrorType'),
        JournalEntryItemIDEmptyErrorType: $translate.instant('JournalEntryItemIDEmptyErrorType'),
        JournalEntryPeriodFormatErrorType: $translate.instant('JournalEntryPeriodFormatErrorType'),
        TrancodeParseEmptyErrorType: $translate.instant('TrancodeParseEmptyErrorType'),
        NumOutRangeErrorType: $translate.instant('NumOutRangeErrorType'),
        OutputStringLengthType: $translate.instant('OutputStringLengthType'),
        StartRowError: $translate.instant('StartRowError')
    };

    var initColumns = function () {

        $scope.allColumns = [
            $translate.instant('PleaseSelectColumn'),
            $translate.instant('tranCode'),
            $translate.instant('period'),
            $translate.instant('vGroup'),
            $translate.instant('vid'),
            $translate.instant('itemID')
        ];

        $scope.necessoryColumns = [
            $translate.instant('tranCode'),
            $translate.instant('period'),
            $translate.instant('vGroup'),
            $translate.instant('vid'),
            $translate.instant('itemID')
        ];
    };

    var initGrid = function () {

        $scope.gridOptions = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableFullRowSelection: false,
            enableRowSelection: false,
            enableSorting: false,
            enableFiltering: false,
            enableColumnMenus: false,
            enableRowHeaderSelection: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
            columnDefs: [
            {
                field: 'index', name: $translate.instant('ImportErrorPopUpNoCol'), width: '10%', headerCellClass: '', enableFiltering: false,

                cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
            },
              {
                  field: 'tranCode', name: $translate.instant('tranCode'), width: '18%', headerCellClass: '',

                  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.tranCode}}">{{row.entity.tranCode}}<span></div>'
              },

              {
                  field: 'period', name: $translate.instant('period'), width: '18%', headerCellClass: 'right',

                  cellTemplate: '<div class="ui-grid-cell-contents right"><span title="{{row.entity.period}}">{{row.entity.period}}</span></div>'
              },
              {
                  field: 'group', name: $translate.instant('vGroup'), width: '18%', headerCellClass: '',

                  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.group}}">{{row.entity.group}}</span></div>'
              },
              {
                  field: 'vid', name: $translate.instant('vid'), width: '18%', headerCellClass: '',

                  cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.vid}}">{{row.entity.vid}}</span></div>'
              },
               {
                   field: 'itemID', name: $translate.instant('itemID'), width: '18%', headerCellClass: '',

                   cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.itemID}}">{{row.entity.itemID}}</span></div>'
               }
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiTotal = gridApi;
            }
        };

        $scope.gridOptions.noData = false;
    };

    $scope.$on(enums.vatEvent.layoutChanged, function () {
        $scope.gridApiTotal.core.handleWindowResize();
        $scope.errorGridApi.core.handleWindowResize();
    });

    //parentIndex：column index
    //index：selecteditem index
    var mappingColumn = function (parentIndex, index, colName) {
        if (colName) {

            var oldColumn = $scope.selectedColumnMap[parentIndex];
            var newColumn = $scope.allColumns[index];

            if (oldColumn === newColumn) {
                return;
            }
            else {
                $scope.selectedColumnMap[parentIndex] = colName;

                if (colName !== $translate.instant('PleaseSelectColumn')) {
                    $scope.allColumns.splice(index, 1);

                    if (oldColumn && oldColumn !== $translate.instant('PleaseSelectColumn')) {
                        $scope.allColumns.push(oldColumn);
                    }
                }
                else {
                    if (oldColumn) {
                        $scope.allColumns.push(oldColumn);
                    }
                }
            }
        }
        $log.debug($scope.selectedColumnMap);
    };

    var UploadFile = function (file) {
        if (file) {
            if (!file.name.endsWith('.xls') && !file.name.endsWith('.xlsx')) {
                SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                return;
            };
            $scope.initIncomeInvoiceList = [];
            successCount = 0;
            if (!file.$error) {
                var tempFileName = PWC.newGuid() + '.dat';
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        filename: file.name,
                        tempFileName: tempFileName,
                        file: file
                    },
                    resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                    },
                    __RequestVerificationToken: $scope.token,
                    withCredentials: true
                }).then(function (resp) {
                    successCount++;
                    $scope.fileName = file.name;
                    if (successCount === 1) {
                        $scope.tempFileName = resp.data;
                        changeSheet(0);
                    }
                });
            }
        }
    }

    var resetMappingRow = function () {
        initColumns();
        $scope.selectedColumnMap = [];
    };

    var changeSheet = function (index) {
        $scope.showErrorTable = false;
        $scope.selectedSheet.sheetIndex = index;
        resetMappingRow();
        if (_.isString($scope.tempFileName)) {
            $scope.excelSource = { sheetNameList: [], dataList: [] };
            vatImportService.getFileContent($scope.tempFileName, $scope.selectedSheet.sheetIndex, $scope.selectedSheet.topRowNumber).success(function (data) {
                if (data && data.result === false) {
                    $scope.showInitTable = true;
                    $scope.showImportTable = false;
                    SweetAlert.warning(data.resultMsg);
                    return;
                }
                var index = 1;
                data.dataList.forEach(function (i) {
                    i.index = index++;
                });
                $scope.showInitTable = false;
                $scope.showImportTable = true
                $scope.excelSource = data;
                $scope.columnNum = data.dataList[0].length;
                $scope.firstDataRow = data.dataList[0];
                $scope.startRowList = _.range(data.lastRowIndex);
                $scope.selectedSheet.sheetName = $scope.excelSource.sheetNameList[$scope.selectedSheet.sheetIndex];
                vatSessionService.dataChanged = true;
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }
    };

    var validatefirst = function () {
        var result = true;
        var notMappedColumns = '';
        $scope.errorMsgMap = [];
        if ($scope.selectedColumnMap.length >= 0) {
            var count1 = 0;
            $scope.necessoryColumns.forEach(function (m) {
                if (m !== $translate.instant('PleaseSelectColumn')) {
                    if ($.inArray(m, $scope.selectedColumnMap) < 0) {
                        notMappedColumns += m + ',';
                        count1++;
                    }
                }
            });
            if (count1) {
                result = false;
                //加入到错误列表中
                $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.ColumnsMapErrorType,
                        'errorCount': count1,
                        'errorContent': $translate.instant('ColumnsMapErrorMsg').formatObj({ columns: notMappedColumns.substring(0, notMappedColumns.length - 1) })
                    });
            }
        }
        //2:判断起始行输入框输入内容是否合理
        var startNumberCheckMsg = '';
        $scope.StartRowNum = $('#StartRowNum').val();
        if ($scope.StartRowNum === '') {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNull')
                    });
        }
        else if (parseInt($scope.StartRowNum) > $scope.excelSource.dataList.length) {
            result = false;
            $scope.errorMsgMap.push(
                    {
                        'errorType': validationErrorType.StartRowError,
                        'errorCount': 1,
                        'errorContent': $translate.instant('StartRowNumberCheckMsg')
                    });
        }
        return result;
    };

    var validateClientSide = function (dataList) {
        var VIDEmptyCheckMsg = '';
        var VIDEmptyCheckCount = 0;

        var GroupEmptyCheckMsg = '';
        var GroupEmptyCheckCount = 0;

        var ItemIDEmptyCheckMsg = '';
        var ItemIDEmptyCheckCount = 0;

        var TranCodeEmptyCheckMsg = '';
        var TranCodeEmptyCheckCount = 0;

        var PeriodFormatErrorMsg = '';
        var PeriodFormatErrorCount = 0;

        var numOutRangeCheckMsg = '';
        var numOutRangeCheckCount = 0;

        var stringOverLengthCheckMsg = '';
        var stringOverLengthCheckCount = 0;

        dataList.forEach(function (m) {
            var curRowInfo = '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' +
                            $translate.instant('tranCode') + ':' + m.TranCode + ',' +
                            $translate.instant('period') + ':' + m.Period + ',' +
                            $translate.instant('vid') + ':' + m.VID + ',' +
                            $translate.instant('vGroup') + ':' + m.Group + ',' +
                            $translate.instant('itemID') + '：' + m.ItemID + ';<br />';

            if (PWC.isNullOrEmpty(m.VID)) {
                VIDEmptyCheckCount++;
                VIDEmptyCheckMsg += curRowInfo;
            }
            else {

                if (m.VID.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('vid') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }


            if (PWC.isNullOrEmpty(m.Group)) {
                GroupEmptyCheckCount++;
                GroupEmptyCheckMsg += curRowInfo;
            }
            else {

                if (m.Group.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('vGroup') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }


            if (PWC.isNullOrEmpty(m.ItemID)) {
                ItemIDEmptyCheckCount++;
                ItemIDEmptyCheckMsg += curRowInfo;
            }
            else {

                if (m.ItemID.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('itemID') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }


            if (PWC.isNullOrEmpty(m.TranCode)) {
                TranCodeEmptyCheckCount++;
                TranCodeEmptyCheckMsg += curRowInfo;
            }
            else {

                if (m.TranCode.length > constant.validateLength.StringLength_50) {
                    stringOverLengthCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('tranCode') + $translate.instant('OutputStringLengthMsg') + ';<br />';
                    stringOverLengthCheckCount++;
                }
            }


            if (!PWC.isNullOrEmpty(m.Period)) {
                if (!PWC.isPositiveInteger(m.Period)) {
                    PeriodFormatErrorMsg += curRowInfo;
                    PeriodFormatErrorCount++;
                }
                else {
                    if (m.Period < 1 || m.Period > 12) {
                        numOutRangeCheckCount++;
                        numOutRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('period') + $translate.instant('PeriodOverLengthMsg') + ';<br />';
                    }
                }
            }
        });

        if (VIDEmptyCheckCount > 0) {
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryVIDEmptyErrorType,
                    'errorCount': VIDEmptyCheckCount,
                    'errorContent': VIDEmptyCheckMsg
                });
        }
        if (GroupEmptyCheckCount > 0) {
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryGroupEmptyErrorType,
                    'errorCount': GroupEmptyCheckCount,
                    'errorContent': GroupEmptyCheckMsg
                });
        }
        if (ItemIDEmptyCheckCount > 0) {
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.JournalEntryItemIDEmptyErrorType,
                    'errorCount': ItemIDEmptyCheckCount,
                    'errorContent': ItemIDEmptyCheckMsg
                });
        }
        if (TranCodeEmptyCheckCount > 0) {
            $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.TrancodeParseEmptyErrorType,
                    'errorCount': TranCodeEmptyCheckCount,
                    'errorContent': TranCodeEmptyCheckMsg
                });
        }

        if (PeriodFormatErrorCount) {
            $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.JournalEntryPeriodFormatErrorType,
                   'errorCount': PeriodFormatErrorCount,
                   'errorContent': PeriodFormatErrorMsg
               });
        }

        if (stringOverLengthCheckCount > 0) {
            $scope.errorMsgMap.push({
                'errorType': validationErrorType.OutputStringLengthType,
                'errorCount': stringOverLengthCheckCount,
                'errorContent': stringOverLengthCheckMsg
            });
        }

        if (numOutRangeCheckCount > 0) {
            $scope.errorMsgMap.push({
                'errorType': validationErrorType.NumOutRangeErrorType,
                'errorCount': numOutRangeCheckCount,
                'errorContent': numOutRangeCheckMsg
            });
        }
    }

    var validateperiod = function (dataList) {
        var dataListFilter = [];
        $scope.AllDataSamePeriodFlag = true;

        dataList.forEach(function (item) {
            if (parseInt(item.Period) === period) {
                dataListFilter.push(item);
            }
            else {
                $scope.AllDataSamePeriodFlag = false;
            }
        });
        return dataListFilter;
    };

    function doSave2Server(saveType) {
        // saveType 1：override，2：append

        if (!validatefirst()) {
            $('#errorListModal').modal('show');
            return;
        }

        var dataList = [];
        for (var i = $scope.StartRowNum - 1; i < $scope.excelSource.dataList.length; i++) {
            var rowInfo = {
                'Index': $scope.excelSource.dataList[i].index,
                'Period': $.inArray($translate.instant('period'), $scope.selectedColumnMap) > -1 ?
                          $scope.excelSource.dataList[i][$.inArray($translate.instant('period'), $scope.selectedColumnMap)] : period,
                'Group': $scope.excelSource.dataList[i][$.inArray($translate.instant('vGroup'), $scope.selectedColumnMap)],
                'VID': $scope.excelSource.dataList[i][$.inArray($translate.instant('vid'), $scope.selectedColumnMap)],
                'ItemID': $scope.excelSource.dataList[i][$.inArray($translate.instant('itemID'), $scope.selectedColumnMap)],
                'TranCode': $scope.excelSource.dataList[i][$.inArray($translate.instant('tranCode'), $scope.selectedColumnMap)]
            };
            dataList.push(rowInfo);
        }
        
        validateClientSide(dataList);
        if ($scope.errorMsgMap.length > 0) {
            $('#errorListModal').modal('show');
            return;
        }

        var dataListFilter = validateperiod(dataList);
        if (dataListFilter.length == 0) {
            SweetAlert.warning($translate.instant('noCurMonthRecordErrorMsg'));
            return;
        }
        else {
            if (!$scope.AllDataSamePeriodFlag) {
                swal({
                    title: "warning!",
                    text: $translate.instant('PeriodDifferenceTip'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                function (isConfirm) {
                    if (isConfirm) {
                        vatImportService.SaveVourcherMappings(dataListFilter, period, saveType).success(function (data) {
                            if (data) {
                                if (data.result) {

                                    logDto.ID = PWC.newGuid();
                                    logDto.CreateTime = new Date();
                                    logDto.UpdateTime = new Date();
                                    logDto.OperationContent = $scope.fileName;
                                    if (saveType === 2) {
                                        logDto.OperationName = $translate.instant('AddImportBtn');
                                        logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
                                    }
                                    else if (saveType === 1) {
                                        logDto.OperationName = $translate.instant('ConverImportBtn');
                                        logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
                                    }
                                    logDto.UpdateState = $translate.instant('ImportSuccess');
                                    vatOperationLogService.addOperationLog(logDto);

                                    $scope.showInitTable = true;
                                    $scope.showImportTable = false;
                                    $scope.showErrorTable = false;
                                    $scope.ImportErrorTab = false;
                                    $scope.ImportErrorTag = false;
                                    vatCommonService.importSetProjectStatus(projectDbName, period, constant.DictionaryDictKey.WFImportVoucherMap
                                                                            , enums.FinishStatusEnum.Finished);
                                    vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isVoucherMapImport, true);
                                    $log.debug("import voucherMapping save2Server: " + vatSessionService.project.importSubStatus.isVoucherMapImport);
                                    SweetAlert.success($translate.instant('ImportSuccess'));
                                    resetMappingRow();
                                    getMappings();
                                    $scope.fileName = '';
                                }
                                //else {
                                //    processValidateMsg(data.data);
                                //}
                            }
                        }).error(function () {
                            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                        });
                    }
                });
            }
            else {
                vatImportService.SaveVourcherMappings(dataListFilter, period, saveType).success(function (data) {
                    if (data) {
                        if (data.result) {

                            logDto.ID = PWC.newGuid();
                            logDto.CreateTime = new Date();
                            logDto.UpdateTime = new Date();
                            logDto.OperationContent = $scope.fileName;
                            if (saveType === 2) {
                                logDto.OperationName = $translate.instant('AddImportBtn');
                                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
                            }
                            else if (saveType === 1) {
                                logDto.OperationName = $translate.instant('ConverImportBtn');
                                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
                            }
                            logDto.UpdateState = $translate.instant('ImportSuccess');
                            vatOperationLogService.addOperationLog(logDto);

                            $scope.showInitTable = true;
                            $scope.showImportTable = false;
                            $scope.showErrorTable = false;
                            $scope.ImportErrorTab = false;
                            $scope.ImportErrorTag = false;
                            vatCommonService.importSetProjectStatus(projectDbName, period, constant.DictionaryDictKey.WFImportVoucherMap
                                                                    , enums.FinishStatusEnum.Finished);
                            vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isVoucherMapImport, true);
                            $log.debug("import voucherMapping save2Server: " + vatSessionService.project.importSubStatus.isVoucherMapImport);
                            SweetAlert.success($translate.instant('ImportSuccess'));
                            resetMappingRow();
                            getMappings();
                            $scope.fileName = '';
                        }
                        //else {
                        //    processValidateMsg(data.data);
                        //}
                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            };
        }
    }

    var save2Server = function (saveType) {

        if ($scope.excelSource.sheetNameList.length == 0) {
            SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
            return;
        }

        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Generated) {
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    $timeout(function () { doSave2Server(saveType) }, 300);
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doSave2Server(saveType);
        }
    };

    var buildDataStr = function (p) {
        var empty = '<' + $translate.instant('empty') + '>';
        return $translate.instant('tranCode') + ':' + (PWC.isNullOrEmpty(p.tranCode) ? empty : p.tranCode) + ',' +
            $translate.instant('period') + ':' + (PWC.isNullOrEmpty(p.period) ? empty : p.period) + ',' +
            $translate.instant('vid') + ':' + (PWC.isNullOrEmpty(p.vid) ? empty : p.vid) + ',' +
            $translate.instant('vGroup') + ':' + (PWC.isNullOrEmpty(p.group) ? empty : p.group) + ',' +
            $translate.instant('itemID') + ':' + (PWC.isNullOrEmpty(p.itemID) ? empty : p.itemID) + ';<br />';
    };
    
    var clear = function () {
        swal({
            title: "warning!",
            text: $translate.instant('ClearTips'),
            type: "warning",
            showCancelButton: true,
            confirmButtonColor: "#DD6B55",
            confirmButtonText: $translate.instant('Yes'),
            cancelButtonText: $translate.instant('No'),
            closeOnConfirm: true,
            closeOnCancel: true
        }, function (isConfirm) {
            if (isConfirm) {
                var dataList = [];
                var saveType = 1;//overide
                vatImportService.SaveVourcherMappings(dataList, period, saveType).success(function (data) {
                    if (data && data.result) {

                        logDto.ID = PWC.newGuid();
                        logDto.CreateTime = new Date();
                        logDto.UpdateTime = new Date();
                        logDto.OperationContent = '';
                        logDto.OperationName = $translate.instant('ClearAll');
                        logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;
                        logDto.UpdateState = $translate.instant('ClearSuccess');
                        vatOperationLogService.addOperationLog(logDto);

                        $scope.showInitTable = true;
                        $scope.showImportTable = false;
                        $scope.showErrorTable = false;
                        $scope.ImportErrorTab = false;
                        $scope.ImportErrorTag = false;
                        vatCommonService.clearProjectStatus(projectDbName, period, constant.DictionaryDictKey.WFImportVoucherMap
                                                                 , enums.FinishStatusEnum.NotFinished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isVoucherMapImport, false);
                        $log.debug("clear voucherMapping clear: " + vatSessionService.project.importSubStatus.isVoucherMapImport);
                        SweetAlert.success($translate.instant('ClearSuccess'));
                        resetMappingRow();
                        getMappings();
                    }
                });
            }
        }).error(function () {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    };

    var getMappings = function () {
        vatImportService.GetVourcherMappings(period).success(function (data) {
            if (data.length > 0) {
                GetValidationList(); 
            }
            else { 
                $scope.haveImported = false;
                $scope.showErrorTable = false;
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;
            }

            $scope.excelSource = { sheetNameList: [], dataList: [] };
            $scope.mapppingList = data;
            var seqNo = 1;
            $scope.mapppingList.forEach(function (i) {
                i.index = seqNo;
                seqNo++;
            });
            $scope.gridOptions.data = $scope.mapppingList;
            $scope.gridOptions.noData = $scope.mapppingList.length === 0;
            $scope.firstDataRow = null;
            vatSessionService.dataChanged = false;
        }).error(function () {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    };

    $scope.$watch('selectedFileName', function (newValue, oldValue) {
        if (newValue && newValue !== oldValue) {
            UploadFile($scope.selectedFileName);
            $scope.ImportErrorTab = false;
            $scope.ImportErrorTag = false;
            resetMappingRow();
        }
    });

    $scope.gridOptionsErrorMsg = {
        rowHeight: constant.UIGrid.rowHeight,
        selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
        enableSorting: false,
        enableColumnMenus: false,
        enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
        enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
        columnDefs: [
        {
            name: $translate.instant('Icon'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
        },
          {
              name: $translate.instant('SequenceNo'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
          },
          {
              name: $translate.instant('ErrorResult'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
          },
           {
               name: $translate.instant('ErrorCount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
           },
          {
              name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">查看明细</a><span></div>' +
                '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>'
          },
           {
               name: $translate.instant('ValidationTips'), width: '24%', cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}"><span>{{row.entity.validationTips}}<span></div>'
           },
        ],
        onRegisterApi: function (gridApi) {
            $scope.errorGridApi = gridApi;
        }
    };

    function GetValidationList() {
        $scope.validationType = 11;
        vatImportService.getValidationList($scope.validationType, period).success(function (data) {
            if (data.length > 0) {
                var index = 1;
                data.forEach(function (v) {
                    v.index = index++;
                });
                $scope.errorList = data;
                $scope.gridOptionsErrorMsg.data = data;

                showErrTab();
                $scope.toggleErrorTab();
                $scope.showErrorTable = true;
            }
            else {
                $scope.errorList = [];
                $scope.gridOptionsErrorMsg.data = [];
                $scope.showErrorTable = false;
                $scope.ImportErrorTab = false;
                $scope.ImportErrorTag = false;
            }
        });
    }

    $scope.errorLevelToString = function (errorLevel) {
        if (errorLevel === 0) {
            return '/app-resources/images/vat/error.png';
        }
        if (errorLevel === 1) {
            return '/app-resources/images/vat/warning.png';
        }
        if (errorLevel === 2) {
            return '/app-resources/images/vat/tips.png';
        }
        else {
            return '/app-resources/images/vat/tips.png';
        }
    }

    var dealDetail = function () {
        return '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">查看明细</a><span></div>' +
                '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>';
    }

    $scope.openTab = function (errorType, rowdata) {
        var data = JSON.parse(rowdata);
        if (errorType === 45) {
            dispalyDuplicatedValidation(data);
        }
    }
   
    $scope.deleteDupData = function () {
        var dataGrid = $('#gridDuplicatedValidation').dxDataGrid("instance");
        var deleteList = [];
        dataGrid.getSelectedRowsData().done(function (rowData) {
            for (var i = 0; i < rowData.length; i++) {
                var msg = $translate.instant('tranCode') + ':' + rowData[i].TranCode + ',' +
                                            $translate.instant('period') + ':' + rowData[i].Period + ',' +
                                            $translate.instant('vid') + ':' + rowData[i].VID + ',' +
                                            $translate.instant('vGroup') + ':' + rowData[i].Group + ',' +
                                            $translate.instant('itemID') + '：' + rowData[i].ItemID;
                deleteList.push(msg);
            }
        });
        dataGrid.getSelectedRowKeys().done(function (keys) {
            if (keys && keys.length === 0) {
                SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
                return;
            }
            
            
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = deleteList.join(";");
            logDto.OperationName = $translate.instant('DeleteDuplicateData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

            vatImportService.deleteVourcherMappings(keys).success(function (rsp) {
                if (rsp) {
                    logDto.UpdateState = $translate.instant('DeleteSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    //刷新数据
                    vatImportService.validDBVoucherMapping(period).success(function (result) {
                        if (result) {
                            logDto.ID = PWC.newGuid();
                            logDto.CreateTime = new Date();
                            logDto.UpdateTime = new Date();
                            logDto.OperationContent = $translate.instant('invoiceMappingDesc');
                            logDto.OperationName = $translate.instant('RefreshValidationData');
                            logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
                            logDto.UpdateState = $translate.instant('RefreshSuccess');
                            vatOperationLogService.addOperationLog(logDto);

                            $('#duplicatedValidationModal').modal('hide');
                            SweetAlert.success($translate.instant('DeleteSuccess'));
                            getMappings();
                        }
                        else {
                            logDto.UpdateState = $translate.instant('RefreshTbFail');
                            vatOperationLogService.addOperationLog(logDto);

                            SweetAlert.warning($translate.instant('RefreshTbFail'));
                        }
                    }).error(function (e) {
                        SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                    });
                }

            }).error(function (e) {
                logDto.UpdateState = $translate.instant('RefreshTbFail');
                vatOperationLogService.addOperationLog(logDto);

                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        });
    }

    $scope.refreshData = function () {
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = $translate.instant('voucherMappingDesc');
        logDto.OperationName = $translate.instant('RefreshValidationData');
        logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
        //刷新数据
        vatImportService.validDBVoucherMapping(period).success(function (result) {
            if (result) {
                logDto.UpdateState = $translate.instant('RefreshSuccess');
                vatOperationLogService.addOperationLog(logDto);

                getMappings();
                SweetAlert.success($translate.instant('RefreshSuccess'));
            }
            else {
                SweetAlert.warning($translate.instant('RefreshTbFail'));
            }
        }).error(function (e) {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }

    $scope.toggleErrorTab = function () {
        $scope.errorGridApi.core.handleWindowResize();
        $scope.ImportErrorTag = !$scope.ImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.ImportErrorTag) {
            setErrorWrapCssDefault();
        } else {

            if (parseInt($('#content-resizer').css('bottom')) < 100) {
                $('#content-resizer').css('bottom', '190px');

                $('#topIcon').css({ bottom: '-381px' });

                $('.error-info-wrapper').css('height', '190px');
            }
        }
    };

    var dispalyDuplicatedValidation = function (sourcedata) {
        $scope.detailData = sourcedata;
        var dupColumns = [
        { caption: $translate.instant('tranCode'), dataField: "TranCode", width: 180 },
        { caption: $translate.instant('period'), dataField: "Period", width: 100 },
        { caption: $translate.instant('vGroup'), dataField: "Group", width: 180 },
        { caption: $translate.instant('vid'), dataField: "VID", width: 180 },
        { caption: $translate.instant('itemID'), dataField: "ItemID", dataType: "date", width: 180 }, ];

        $scope.deferStatus = true;
        $scope.filterCondition = ["IsDuplicate", "=", true];
        $scope.gridDuplicatedOptions = {
            columns: dupColumns,
            bindingOptions: {
                "dataSource.store.data": "detailData",
                "selection.deferred": "deferStatus",
                "selectionFilter": "filterCondition"
            },
            dataSource: {
                store: {
                    type: "array",
                    key: 'ID'
                }
            },
            selection: {
                mode: "multiple",
                selectAllMode: "allPages",
                showCheckBoxesMode: "always",
            },
            hoverStateEnabled: true,
            paging: {
                pageSize: 10
            },
        }
        $('#duplicatedValidationModal').modal('show');
    }

    var setErrorWrapCssDefault = function () {
        $('#content-resizer').css('bottom', '65px');

        $('#topIcon').css({ bottom: '-501px' });

        $('.error-info-wrapper').css('height', '65px');
    };

    function showErrTab() {
        $scope.ImportErrorTab = true;
        $scope.ImportErrorTag = true;
        $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

    };

    $scope.getGridHeight = function () {
        if ($scope.isLoadComplete) {
            return { height: ($('.balance-ouput-grid-wrapper').height()) + "px" };
        }
        else {
            return { height: 0 + "px" };
        }
    };

    $scope.getErrorGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $("#error-info-wrapper").height();
            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: y + "px" };
            } else {

                return { height: '0px' };
            }
        }
        return {};
    };


    $scope.showOperateLogPop = function () {
        $scope.isShowLog = true;
    };

    //控制明细信息中删除权限
    var getUserPermission = function () {
        var list = [];
        var code = constant.vatPermission.dataImport.voucherMapping.importCode;
        list.push(code);

        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
            $scope.hasImportPermission = data[code];
        });
    };

    (function initialize() {
        $scope.StartRowNum = 2;
        $scope.mapppingList = [];
        $scope.mappingRow = null;
        $scope.firstDataRow = null;
        $scope.selectedColumnMap = [];
        $scope.selectedFileName = '';
        $scope.excelSource = { sheetNameList: [], dataList: [] };
        $scope.selectedSheet = { sheetName: '', sheetIndex: 0, topRowNumber: 0 };      
        //$scope.refresh = getMappings;
        $scope.clear = clear;

        $scope.changeSheet = changeSheet;
        $scope.mappingColumn = mappingColumn;
        $scope.save2Server = save2Server;
        $scope.showInitTable = true;
        $scope.showImportTable = false;
        initColumns();
        initGrid();
        getMappings();
        getUserPermission();

        $timeout(function () {
            $scope.isLoadComplete = true;
        }, 500);
    })();
}
]);

vatModule.directive('vatVoucherMapping', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatVoucherMapping.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/import/vat-voucher-mapping/vat-voucher-mapping.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'vatVoucherMappingController',
            link: function ($scope, $element, $attr) {
                $scope.token = $('input[name="__RequestVerificationToken"]').val();
            }
        };
    }
]);
invoiceModule.controller('InvoiceManageInfrastructureController', ['$scope', '$log', '$q', '$timeout', 'loginContext',
    '$translate', '$location', 'templateGroupService', 'citSessionService', 'vatReportService', '$state',
function ($scope, $log, $q, $timeout, loginContext, $translate, $location, templateGroupService, citSessionService, vatReportService, $state) {
    'use strict';
    $log.debug('InvoiceManageController.ctor()...');

    var loadInvoiceMenu = function () {
        $scope.groups = [];

        $scope.groups.push({
            id: '0',
            name: $translate.instant('OutputInvoiceTitle'),
            sref: '.main',
            isExpand: true,
            children: [
                { id: '1', name: $translate.instant('BillingManagement'), sref: '.billingManage' },
                { id: '2', name: $translate.instant('InvoiceSearch'), sref: '.invoiceQuery' }
            ]
        });


        $scope.groups.push({
            id:'1',
            name: $translate.instant('IncomeInvoiceManage'),
            sref: '.main',
            isExpand: true,
            children: [ 
                { id: '1', name: $translate.instant('NoInvoiceVerify'), sref: '.noInvoiceVerify' },
                { id: '2', name: $translate.instant('PendingReturnInvoice'), sref: '.pendingRefundInvoice' },
                { id: '3', name: $translate.instant('MappingInvoice'), sref: '.mapInvoice' }
            ]
        });
    };

    var toggleGroup = function (group) {
        group.isExpand = !group.isExpand;
    };
    (function initialize() {
        loadInvoiceMenu();
        $scope.expend = true;
        $scope.toggleGroup = toggleGroup;
    })();

}]);
invoiceModule.directive('invoiceManageInfrastructure', ['$log', '$rootScope', '$timeout', 'enums',
    function ($log, $rootScope, $timeout, enums) {
        'use strict';

        $log.debug('invoiceManageInfrastructure.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-infrastructure/invoice-manage-infrastructure.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                state: '='
            },
            controller: 'InvoiceManageInfrastructureController',
            link: function ($scope, $element, $attr) {

                Split(['#vat-report-nav-menu', '#vat-report-content'], {
                    sizes: [15, 85],
                    minSize: [1, 1330],
                    onDragEnd: function () {
                        $timeout(function () {
                            $rootScope.$broadcast(enums.vatEvent.layoutChanged, {});
                        }, 700);
                    }
                })


                $scope.isCollapsed = false;
            }
        };
    }
]);
invoiceModule.directive('invoiceManageMainUploadElectronicInvoice', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('invoiceManageMainUploadPaperInvoice.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-main-upload-electronic-invoice/invoice-manage-main-upload-electronic-invoice.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'invoiceManageMainUploadElectronicInvoiceController',
            link: function (scope, element) {


                $(window).on('resize', function () {
                   
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('invoiceManageMainUploadElectronicInvoiceController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', 'InvoiceManageService', 'Upload',
function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, InvoiceManageService,Upload) {
            'use strict';
        
            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 100,  //总数据
                totalPages: 10,//总页数
                maxSize: 10, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
                pageSizeString: constant.page.pageSizeArrary[1].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage'),
            };

            $scope.searchFilterOptions = [];
            $scope.searchEntity = [];

            $scope.translated = {
                NoData: $translate.instant('NoDataText'),
                pleaseSelect: $translate.instant("ChoosePlaceholder"),
                pleaseInput: $translate.instant('InputPlaceholder'),
            };



            var fileUploadInfo = {
                fileList: [],
                path: "C:\\Users\\admin\\Desktop\\Scan\\Temp",
                strEx: '.jpg',
                userId: '90CEF6C1C1C0762000D2'
            };
            var nResult = -1;

            var chunkSize = 100000;
            var resumable = true;
            var uploadInvoiceUrl = apiInterceptor.webApiHostUrl + '/invoiceManage/UploadInvoiceFile';

            //发票上传
            $scope.invoiceUpload = {
                //加载核心
                loadRecogKenal: function () {
                    nResult = objBillOcr.InitRecogForm(fileUploadInfo.userId);
                    if (nResult != 0) {
                        SweetAlert.warning("核心加载失败,返回值：" + nResult);
                        return false;
                    }
                    return true;
                },
                //释放核心
                freeRecogKenal: function () {
                    objBillOcr.UninitRecogForm();
                },
                //扫描上传
                scanUpload: function () {
                    if (!invoiceUpload.loadRecogKenal())
                        return;
                    //设置要识别的票据类型 
                    objBillOcr.SetFormTypes(document.IDScanRecog.BillType.value, 3);
                    objBillOcr.SetDeviceAdvancedParams(6, 0);
                    objBillOcr.SetDeviceAdvancedParams(10, 10);
                    var bHavePaper = 1;
                    //扫描
                    while (bHavePaper) {
                        var fileItem = {};
                        var dateNow = new Date().toDateString('yyyyMMddHHmmss');
                        var imagePath = fileUploadInfo.path + "\\" + dateNow + fileUploadInfo.strEx;
                        fileItem.filePath = imagePath;
                        fileItem.fileName = dateNow;
                        nResult = objBillOcr.AcquireNewImage(imagePath);
                        if (nResult != 0) {
                            fileItem.message = "扫描失败,返回值:" + nResult;
                            fileItem.status = false;
                        }
                        fileUploadInfo.fileList.push(fileItem);
                        bHavePaper = objBillOcr.IsHavePaper();
                    }
                    //to do
                    invoiceUpload.initFiles();

                    //遍历识别
                    fileUploadInfo.fileList.forEach(function (item) {
                        //对扫描成功的进行识别
                        if (item.status) {
                            nResult = objBillOcr.LoadImages(item.filePath);
                            if (nResult != 0) {
                                item.message = "加载图片不成功,返回值:" + nResult;
                                item.status = false;
                            }
                            nResult = objBillOcr.RecognizeForm();
                            if (nResult != 0) {
                                item.message = "识别不成功,返回值:" + nResult;
                                item.status = false;
                            }
                            else
                                item.status = true;
                            var nFieldNum = objBillOcr.GetRecogCellCount();
                            var itemData = {};
                            if (nFieldNum > 0) {
                                for (var i = 0; i < nFieldNum; ++i) {
                                    var strFieldName = objBillOcr.GetFieldName(i);
                                    strResult += strFieldName;
                                    strResult += ":";
                                    var strResultName = objBillOcr.GetRecognizeResult(i);
                                    if (strFieldName == "票据类型") {
                                        if (strResultName == "1") {
                                            strResultName = "普票";
                                        }
                                        else {
                                            strResultName = "专票";
                                        }

                                    }
                                    itemData[strFieldName] = strResultName;
                                }
                            }
                            item.itemData = itemData;
                            //to do
                            invoiceUpload.updateFileStatus(item);
                        }
                    });
                    invoiceUpload.freeRecogKenal();
                },

                initFiles: function () {
                    //to do
                    //根据文件List更新UI
                },
                updateFileStatus: function (fileItem) {
                    //to do 
                    //根据文件识别情况更新UI
                },
                //上传文件
                uploadInvoiceFile: function (files, inputInvoice) {
                    if (files && files.length) {
                        //allFilesCount = files.length;
                        //evidenceCount = 0;
                        for (var i = 0; i < files.length; i++) {
                            var file = files[i];
                            if (!file.$error) {
                                var tempFileName = PWC.newGuid() + '.dat';
                                var token = $('input[name="__RequestVerificationToken"]').val();
                                Upload.upload({
                                    url: uploadInvoiceUrl,
                                    data: {
                                        cancel: false,
                                        filename: file.name,
                                        tempFileName: tempFileName,
                                        file: file,
                                        inputInvoice: inputInvoice
                                    },
                                    resumeChunkSize: resumable ? chunkSize : null,
                                    headers: {
                                        'Access-Control-Allow-Origin': '*',
                                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken,
                                        from: 'taxAdmin@cn.pwc.com'
                                    },
                                    __RequestVerificationToken: token,
                                    withCredentials: true
                                }).then(uploadInvoiceSuccess);
                            }
                        }
                    }
                },

                //上传成功
                uploadInvoiceSuccess: function (resp) {
                    //to do
                }
            };

             //内部处理
            var memoryService = {
                //发票来源列表构造
                populateInvoiceSourceTypList: function () {
                    $scope.searchFilterOptions.invoiceSourceList = memoryService.translateEnumValue(constant.inputInvoice.invoiceSourceTypeArray);
                },

                repaintInvoiceGrid: function () {
                    $scope.setInvoiceGridHeight();
                },
                //翻译查询的数据源
                translateEnumValue: function (data) {
                    if (!data || data.length == 0) return null;

                    data.forEach(function (item) {
                        item.value = $translate.instant(item.value);
                    });
                    return data;
                },
                //分页下拉
                populatePagingSelection: function () {
                    var pagingSelection = [];
                    var pageArray = constant.page.pageSizeArrary;
                    for (var i = 0 ; i < pageArray.length; i++) {
                        var selection = { id: pageArray[i], value: pageArray[i] };
                        pagingSelection.push(selection);
                    }
                    $scope.pagingOptions.pagingSelection = pagingSelection;
                },
            };



            //搜索框初始化
            var initControlsOptions = function () {

                var valueExpr = "id";
                var displayExpr = "value";

                var isShowClearButton = false;

                $scope.searchEntityOptions = {
                    selectinvoiceSourceTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceSourceType',
                            dataSource: 'searchFilterOptions.invoiceSourceList'
                        },
                        onValueChanged: function (data) {
                            $scope.showPoOptions = false;
                            $scope.showStaffOptions = false;
                            if (data.value == constant.inputInvoice.invoiceSourceType.InvoiceNonRawMaterialPurchase.id) {
                                $scope.showPoOptions = true;
                            }
                            else if (data.value == constant.inputInvoice.invoiceSourceType.InvoiceClaim.id) {
                                $scope.showStaffOptions = true;
                            }
                        },
                        placeholder: $scope.translated.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //全选
                    checkAllOptions: {
                        onValueChanged: function (e) {
                            var row = e.model.template;
                            if (row) {
                                row.isCheckAll = e.value;
                                row.currentInvoiceList.forEach(function (item) {
                                    item.isCheckAll = e.value;
                                });
                            }
                            console.log(e.element);
                        }
                    },
                    //员工编号
                    staffIdOPtions: {
                        bindingOptions: {
                            value: 'searchEntity.staffID',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                    },
                    //po number
                    PoNumberOptions: {
                        bindingOptions: {
                            value: 'searchEntity.poNumber',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                    }
                };
            };

            //完成上传
            $scope.uploadToServer = function () {
                $scope.uploadInvoiceList;
            };

            var initInvoiceList = function () {
                $scope.uploadInvoiceList = [];

                for (var i = 0; i < 3; i++) {

                    var currentInvoiceList = [{
                        id: 0,
                        value: '58913988777',
                        status: constant.uploadStatus.success,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 0,
                        value: '58913988777',
                        status: constant.uploadStatus.success,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 0,
                        value: '58913988777',
                        status: constant.uploadStatus.success,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 0,
                        value: '58913988777',
                        status: constant.uploadStatus.success,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 0,
                        value: '58913988777',
                        status: constant.uploadStatus.success,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 0,
                        value: '58913988777',
                        status: constant.uploadStatus.success,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 1,
                        value: '58913988007',
                        status: constant.uploadStatus.failure,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 2,
                        value: '58913988807',
                        status: constant.uploadStatus.failure,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 3,
                        value: '58213988807',
                        status: constant.uploadStatus.success,
                        time: '2017/08/20 12:30'
                    }, {
                        id: 4,
                        value: '68913988807',
                        status: constant.uploadStatus.duplicate,
                        time: '2017/08/20 12:30'
                    }];

                    var invoice = {
                        id: i,
                        value: i + ' invoice',
                        isCheckAll: false,
                        currentInvoiceList: currentInvoiceList
                    }
                    $scope.uploadInvoiceList.push(invoice);

                }
            };


            (function initialize() {
                $log.debug('invoiceManageMainUploadElectronicInvoiceController.ctor()...');
                initInvoiceList();
                initControlsOptions();
                memoryService.populateInvoiceSourceTypList();
            })();
        }
]);

invoiceModule.controller('invoiceManageMainUploadIndexController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', '$location',
        function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, $location) {
            'use strict';

            var paperInvoiceUrl = "/invoiceManagement/main/uploadPaperInvoice";
            var elecInvoiceUrl = "/invoiceManagement/main/uploadElecInvoice";
            var scannerInvoiceUrl = "/invoiceManagement/main/uploadScanInvoice";
            //上传纸质发票
            $scope.uploadPaperInvoice = function () {
                $location.path(paperInvoiceUrl);
            };

            //上传电子发票
            $scope.uploadElecInvoice = function () {
                $location.path(elecInvoiceUrl);
            };

            //上传电子发票（扫描枪）
            $scope.uploadScannerInvoice = function () {
                $location.path(scannerInvoiceUrl);
            };
       

            (function initialize() {
                $log.debug('invoiceManageMainUploadIndexController.ctor()...');

            })();
        }
]);

invoiceModule.directive('invoiceManageMainUploadIndex', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('invoiceManageMainUploadIndex.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-main-upload-index/invoice-manage-main-upload-index.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'invoiceManageMainUploadIndexController',
            link: function (scope, element) {


                $(window).on('resize', function () {
                   
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('invoiceManageMainUploadPaperInvoiceController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', 'InvoiceManageService',
        function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, InvoiceManageService) {
            'use strict';


            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 100,  //总数据
                totalPages: 10,//总页数
                maxSize: 10, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
                pageSizeString: constant.page.pageSizeArrary[1].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage'),
            };

            $scope.searchFilterOptions = [];
            $scope.searchEntity = [];

            $scope.translated = {
                NoData: $translate.instant('NoDataText'),
                pleaseSelect: $translate.instant("ChoosePlaceholder"),
                pleaseInput: $translate.instant('InputPlaceholder'),
            };


            //内部处理
            var memoryService = {
                //发票来源列表构造
                populateInvoiceSourceTypList: function () {
                    $scope.searchFilterOptions.invoiceSourceList = memoryService.translateEnumValue(constant.inputInvoice.invoiceSourceTypeArray);
                },

                repaintInvoiceGrid: function () {
                    $scope.setInvoiceGridHeight();
                },
                //翻译查询的数据源
                translateEnumValue: function (data) {
                    if (!data || data.length == 0) return null;

                    data.forEach(function (item) {
                        item.value = $translate.instant(item.value);
                    });
                    return data;
                },
                //分页下拉
                populatePagingSelection: function () {
                    var pagingSelection = [];
                    var pageArray = constant.page.pageSizeArrary;
                    for (var i = 0 ; i < pageArray.length; i++) {
                        var selection = { id: pageArray[i], value: pageArray[i] };
                        pagingSelection.push(selection);
                    }
                    $scope.pagingOptions.pagingSelection = pagingSelection;
                },
            };


            
            //搜索框初始化
            var initControlsOptions = function () {

                var valueExpr = "id";
                var displayExpr = "value";

                var isShowClearButton = false;

                $scope.searchEntityOptions = {
                    selectinvoiceSourceTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceSourceType',
                            dataSource: 'searchFilterOptions.invoiceSourceList'
                        },
                        onValueChanged: function (data) {
                            $scope.showPoOptions = false;
                            $scope.showStaffOptions = false;
                            if (data.value == constant.inputInvoice.invoiceSourceType.InvoiceNonRawMaterialPurchase.id)
                            {
                                $scope.showPoOptions = true;
                            }
                            else if (data.value == constant.inputInvoice.invoiceSourceType.InvoiceClaim.id) {
                                $scope.showStaffOptions = true;
                            }
                        },
                        placeholder: $scope.translated.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //全选
                    checkAllOptions: {
                        onValueChanged: function (e) {
                            var row = e.model.template;
                            if (row) {
                                row.isCheckAll = e.value;
                                row.currentInvoiceList.forEach(function (item) {
                                    item.isCheckAll = e.value;
                                });
                            }
                            console.log(e.element);
                        }
                    },
                    //员工编号
                    staffIdOPtions: {
                        bindingOptions: {
                            value: 'searchEntity.staffID',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                    },
                    //po number
                    PoNumberOptions: {
                        bindingOptions: {
                            value: 'searchEntity.poNumber',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                    }
                };
            };

            //完成上传
            $scope.uploadToServer = function () {
                $scope.uploadInvoiceList;
            };

              var initInvoiceList = function () {
                  $scope.uploadInvoiceList = [];

                for (var i = 0; i < 10; i++)
                {
                    var currentInvoiceList = [];

                    for (var j = 0 ; j < 10; j++) {
                        currentInvoiceList.push({ id: j, value: 'invoice' + j });
                    }

                    var invoice = {
                        id: i,
                        value: i + ' invoice',
                        isCheckAll: false,
                        currentInvoiceList: currentInvoiceList
                    }
                    $scope.uploadInvoiceList.push(invoice);

                }
            };
       

            (function initialize() {
                $log.debug('invoiceManageMainUploadPaperInvoice.ctor()...');
                initInvoiceList();
                initControlsOptions();
                memoryService.populateInvoiceSourceTypList();
            })();
        }
]);

invoiceModule.directive('invoiceManageMainUploadPaperInvoice', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('invoiceManageMainUploadPaperInvoice.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-main-upload-paper-invoice/invoice-manage-main-upload-paper-invoice.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'invoiceManageMainUploadPaperInvoiceController',
            link: function (scope, element) {


                $(window).on('resize', function () {
                   
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('invoiceManageMainUploadScanInvoiceController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', 'InvoiceManageService',
        function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, InvoiceManageService) {
            'use strict';

            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 100,  //总数据
                totalPages: 10,//总页数
                maxSize: 10, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
                pageSizeString: constant.page.pageSizeArrary[1].toString(),
                firstPage: $translate.instant('PagingFirstPage'),
                previousPage: $translate.instant('PagingPreviousPage'),
                nextPage: $translate.instant('PagingNextPage'),
                lastPage: $translate.instant('PagingLastPage'),
            };

            //翻译
            $scope.translated = {
                NoData: $translate.instant('NoDataText'),
                pleaseSelect: $translate.instant("ChoosePlaceholder"),
                pleaseInput: $translate.instant('InputPlaceholder'),
                deleteBtn: $translate.instant('BtnDelete'),
                editBtn: $translate.instant('BtnEdit'),
                confirmDeleteMsg: $translate.instant('IsDelete'),
            };

            $scope.searchFilterOptions = {};
            $scope.invoiceEntity = {};
            $scope.datagrid = {};
            $scope.isShowModal = false;
            $scope.uploadInvoiceTotalCount = 0;
            //从系统读取来的invoice 列表
            $scope.existSystemInvoiceList = {};
            $scope.batchDeletedDisabled = false;

            //上传的状态
            var uploadStatusEnum = {
                success: {
                    id: constant.inputInvoice.invoiceUploadStatus.success.id,
                    value: $translate.instant(constant.inputInvoice.invoiceUploadStatus.success.value)
                },
                failure: {
                    id: constant.inputInvoice.invoiceUploadStatus.failure.id,
                    value: $translate.instant(constant.inputInvoice.invoiceUploadStatus.failure.value)
                },
                duplicate: {
                    id: constant.inputInvoice.invoiceUploadStatus.duplicate.id,
                    value: $translate.instant(constant.inputInvoice.invoiceUploadStatus.duplicate.value)
                }
            }



            //获取数据服务
            var getService = {
                //筛选invoice list
                getInputInvoiceList: function () {
                    var deferred = $q.defer();

                    var invoiceParams = {
                        InvoiceQuery: $scope.searchEntity,
                        pagingDto: $scope.pagingOptions,
                    };

                    InvoiceManageService.getInputInvoiceList(invoiceParams).success(function (data) {
                        if (data) {
                            $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                            if (data && data.list) {
                                data.list.forEach(function (item) {
                                    item.statusString = $translate.instant(item.statusString);
                                    item.invoiceEntityTypeString = $translate.instant(item.invoiceEntityTypeString);
                                    item.invoiceSourceType = -1; //$translate.instant(item.invoiceSourceTypeString);
                                    item.invoiceSourceTypeString ='', //$translate.instant(item.invoiceSourceTypeString);
                                    item.invoiceTypeString = $translate.instant(item.invoiceTypeString);
                                    item.uploadTypeString = $translate.instant(item.uploadTypeString);
                                    item.uploadDate = moment(item.uploadDate).format(constant.date.dateFormatUppercase);
                                    item.invoiceDate = moment(item.invoiceDate).format(constant.date.dateFormatUppercase);
                                });
                            }
                            $scope.invoiceGridDataSource = data.list;
                            $scope.invoiceEntity = data.list;
                            deferred.resolve(data);
                        };
                    });
                    return deferred.promise;
                },

                //除去已经失效的invoice，用来做重复验证
                getAllValidInvoiceList: function () {
                    var deferred = $q.defer();
                    InvoiceManageService.getInputInvoiceList(invoiceParams).success(function (data) {
                        if (data)
                        {
                            $scope.existSystemInvoiceList = data;

                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },
            }

            //添加数据服务
            var addService = {
                //上传invoice
                invoiceUploadFromScan: function (invoiceList) {
                    var deferred = $q.defer();
                    InvoiceManageService.invoiceUploadFromScan(invoiceList).success(function (data) {
                        if (data) {
                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },
            };
            //消息弹框
            var messageBox = {
                getMsg: function (resultMsg, hasTranslated) {
                    hasTranslated = hasTranslated || false;
                    var msg = resultMsg;
                    if (!hasTranslated) {
                        msg = $translate.instant(resultMsg);
                    }
                    return msg;
                },

                success: function (resultMsg, hasTranslated) {
                    var msg = this.getMsg(resultMsg, hasTranslated)
                    SweetAlert.success(msg);
                },

                warning: function (resultMsg, hasTranslated) {
                    var msg = this.getMsg(resultMsg, hasTranslated)
                    SweetAlert.warning(msg);
                },

                //有确认和取消按钮
                confirm: function (title, text, customClass) {
                    var deferred = $q.defer();
                    SweetAlert.swal({
                        title: title,
                        text: text,
                        html: true,
                        type: "warning",
                        customClass: customClass || '',
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        allowOutsideClick: false,
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                      function (isConfirm) {
                          deferred.resolve(isConfirm);
                      });

                    return deferred.promise;
                },

                //没有取消按钮
                info: function (title, text, customClass) {
                    var deferred = $q.defer();

                    SweetAlert.swal({
                        title: title,
                        text: text,
                        html: true,
                        type: "warning",
                        customClass: customClass || '',
                        showCancelButton: false,
                        confirmButtonColor: "#DD6B55",
                        allowOutsideClick: false,
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: true,
                        closeOnCancel: false
                    },
                      function (isConfirm) {
                          deferred.resolve(isConfirm);
                      });

                    return deferred.promise;
                },
            };

            //内部处理
            var memoryService = {
                //发票来源列表构造
                populateInvoiceSourceTypList: function () {
                    $scope.searchFilterOptions.invoiceSourceList = memoryService.translateEnumValue(constant.inputInvoice.invoiceSourceTypeArray);
                },

                repaintInvoiceGrid: function () {
                    $scope.setInvoiceGridHeight();
                },
                //翻译查询的数据源
                translateEnumValue: function (data) {
                    if (!data || data.length == 0) return null;

                    data.forEach(function (item) {
                        item.value = $translate.instant(item.value);
                    });
                    return data;
                },
                //分页下拉
                populatePagingSelection: function () {
                    var pagingSelection = [];
                    var pageArray = constant.page.pageSizeArrary;
                    for (var i = 0 ; i < pageArray.length; i++) {
                        var selection = { id: pageArray[i], value: pageArray[i] };
                        pagingSelection.push(selection);
                    }
                    $scope.pagingOptions.pagingSelection = pagingSelection;
                },
            };

            $scope.validationService = {

                duplicateValidation: function (invoiceCode, invoiceNumber) {
                    //当前table验证
                    var data = angular.copy($scope.invoiceGridDataSource);
                    var filterList = _.filter(data, function (item) {
                        return item.invoiceCode == invoiceCode && item.invoiceNumber == invoiceNumber;
                    });
                    if (filterList.length > 0) {
                        return false;//重复
                    }
                    //系统已经存在验证
                    data = angular.copy($scope.existSystemInvoiceList);
                    var filterList = _.filter(data, function (item) {
                        return item.invoiceCode == invoiceCode && item.invoiceNumber == invoiceNumber;
                    });
                    if (filterList.length > 0) {
                        return false;//重复
                    }
                    return true ;//成功
                },

                lengthValidation: function (invoiceCode, invoiceNumber) {
                    if (invoiceCode.length != 8 || invoiceNumber.length != 8) {
                        return false;
                    }
                    return true;
                },

            };
            $scope.eventServie = {
                //手动添加新的invoice弹框
                addNewInvoiceModal: function () {
                    $scope.newInvoiceEntity = {};
                    $scope.newInvoiceUpdated = false;
                    $scope.newInvoiceOperateType = constant.Operation.Add;
                },

                //编辑invoice弹框
                editInvoiceModal: function (data) {
                    $scope.newInvoiceEntity = data;
                    $scope.newInvoiceUpdated = false;
                    $scope.newInvoiceOperateType = constant.Operation.Edit;
                },
                //双向绑定，自动会更新datagrid
                updateInvoiceRow: function (row) {
                
                },
                //datagrid 新增一行数据
                addInvoiceRow: function (row) {
                    var newInvoiceEntity = {
                        id: PWC.newGuid(),
                        invoiceCode: row && row.invoiceCode || '',
                        invoiceNumber: row && row.invoiceNumber || '',
                       // buyerName: row && row.buyerName || '',
                        //sellerTaxNumber: row && row.sellerTaxNumber || '',
                        amount: row && row.amount || 0,
                       // taxAmount: row && row.taxAmount || 0,
                        invoiceDate: row && row.invoiceDate || '',
                        uploadStatus: uploadStatusEnum.success.id,
                    };

                    //长度验证
                    var lengthStatus = $scope.validationService.lengthValidation(newInvoiceEntity.invoiceCode, newInvoiceEntity.invoiceNumber);
                    if (!lengthStatus) {
                         newInvoiceEntity.uploadStatus = uploadStatusEnum.failure.id;
                    }
                    else {
                        //做重复性验证
                        var duplicateStatus = $scope.validationService.duplicateValidation(newInvoiceEntity.invoiceCode, newInvoiceEntity.invoiceNumber);
                        if (!duplicateStatus) {
                            newInvoiceEntity.uploadStatus = uploadStatusEnum.duplicate.id;
                        }
                    }

                    if (!$scope.invoiceGridDataSource) $scope.invoiceGridDataSource = [];
                    $scope.invoiceGridDataSource.push(newInvoiceEntity);
                },


                //解析扫描的七个字符串
                parseScanCode: function (codeData) {
                    //01,10,031001700111,65285505,88.0,20170811,09307379165572922287
                    if (!codeData || codeData.length == 0) return;

                    var arr = codeData.split(',');
                    var dateStr = arr[5];
                    var year = dateStr.substr(0, 4);
                    var month = dateStr.substr(4, 2);
                    var day = dateStr.substr(6, 2);
                    var dateSplit = '-';
                    var invoiceDate = year + dateSplit + month + dateSplit + day;

                    //小数点位数
                    var decimalNumber = 2;

                    var invoiceEntity = {
                        invoiceCode: arr[2],
                        invoiceNumber: arr[3],
                        amount: parseFloat(arr[4]).toFixed(decimalNumber),
                     //  taxAmount: parseFloat(arr[4] * 0.06).toFixed(decimalNumber),
                        invoiceDate: invoiceDate
                    };

                    //添加一行
                    $scope.eventServie.addInvoiceRow(invoiceEntity);
                },

                //完成上传，上传到服务器
                uploadToServer: function () {
                    //到国税局做识别，要么识别成功，识别失败，或者无法识别（假票）
                    //识别成功的直接更新为待匹配（只有扫描枪上传的方式下）
                    var data = $scope.invoiceGridDataSource;
                    var filterFailureList =_.filter(data,function(item){
                        return item.uploadStatus == uploadStatusEnum.failure.id;
                    });
                    if (filterFailureList.length > 0)
                    {
                        messageBox.warning("请修改上传状态失败的数据", true);
                        return false;
                    }

                    var filterDuplicateList = _.filter(data, function (item) {
                        return item.uploadStatus == uploadStatusEnum.duplicate.id;
                    });
                    if (filterDuplicateList.length > 0) {
                        messageBox.warning("请修改上传状态重复的数据", true);
                        return false;
                    }

                    addService.invoiceUploadFromScan($scope.invoiceGridDataSource).then(function (data) {
                        if (data) {
                            messageBox.success("上传成功", true);
                            //清空当前数据源
                            $scope.invoiceGridDataSource = [];
                        }
                    });
                },

                //删除行
                deleteRow:function(row){
                    var tempData = $scope.invoiceGridDataSource;
                    for (var i = 0; i < tempData.length; i++) {
                        if (tempData[i].id === row.id) {
                            tempData.splice(i, 1);
                            break;
                        }
                    }
                    $scope.invoiceGridDataSource = tempData;
                },

                //批量删除
                batchDelete: function () {
                    if (!$scope.invoiceGridDataSource) return;
                    if (!$scope.datagrid.selectedItems || $scope.datagrid.selectedItems.length == 0)
                    {
                        return;
                    }

                    messageBox.confirm($scope.translated.confirmDeleteMsg, '').then(function (isConfirm) {
                        var data = $scope.datagrid.selectedItems;
                        data.forEach(function (item) {
                            $scope.eventServie.deleteRow(item);
                        });
                    });
                },
            };

            //检测弹框有新的invoice添加或者编辑，这里的状态都应该是补录，而不是上传
            $scope.$watch('newInvoiceUpdated', function (newValue, oldValue) {
                if (newValue) {
                    console.log("newInvoiceEntity: " + JSON.stringify($scope.newInvoiceEntity));
                    //$scope.eventServie.addInvoiceRow($scope.newInvoiceEntity);
                    
                    //编辑信息过后，更新状态为已经补录
                    if ($scope.newInvoiceEntity.remarks && $scope.newInvoiceEntity.remarks.length > 0) {
                        $scope.newInvoiceEntity.status = invoiceStatusType.InvoiceHasAddRecord.id;
                    }

                    if ($scope.newInvoiceEntity.operationAction == constant.Operation.Edit) {
                     
                        $scope.eventServie.updateInvoiceRow($scope.newInvoiceEntity);
                    }
                    else if ($scope.newInvoiceEntity.operationAction == constant.Operation.Add) {
                        $scope.eventServie.addInvoiceRow($scope.newInvoiceEntity);
                    }
                
                }
            });
            
            var txtInvoiceSelector = '#txtInvoiceOptions';

            //var e = jQuery.Event("keydown", { keyCode: 13 });
           
            //$(txtInvoiceSelector).on('keydown', function (e) {
            //    if (e.keyCode === 13) {
            //         alert('enter' + $scope.invoiceString);
            //        console.log("$scope.invoiceString:" + $scope.invoiceString);

            //        var invoiceEntity = {
            //            invoiceCode: $scope.invoiceString
            //        }
            //        $scope.eventServie.addInvoiceRow(invoiceEntity);
            //    }
            //});
            //扫描控件初始化
            var initTextBoxOptions = function () {

                var isShowClearButton = true;
                $(txtInvoiceSelector).dxTextBox({
                    bindingOptions: {
                        value: 'invoiceString'
                    },
                    valueChangeEvent: "change",
                    onValueChanged: function (e) {
                        console.log("e:" + e.value);
                        if (!e.value || e.value == '') return;
                        if (e.previousValue !== '') return;
                        try {
                                $scope.invoiceString = e.value;
                                $scope.eventServie.parseScanCode(e.value);

                                $(txtInvoiceSelector).focus();
                        }
                        catch (ex) {

                        }
                        finally {
                            $timeout(function () {
                                e.component.option('value', '');
                                $scope.invoiceString = '';
                            }, 0);
                        }
                    },
  
                    placeholder: '',
                    showClearButton: isShowClearButton,
                });

            };

            //datagrid初始化控件
            var initInvoiceDataGridControl = function () {
                var valueExpr = "id";
                var displayExpr = "value";

                var isShowClearButton = false;

                $scope.scanInvoiceGridOptions = {
                    bindingOptions: {
                        dataSource: 'invoiceGridDataSource'
                    },
                    // keyExpr: "ID",
                    selection: {
                        mode: "multiple",
                        showCheckBoxesMode: 'always'
                    },
                    paging: {
                        enabled: false,
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,
                    showBorders: true,
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    onContentReady: function (e) {
                        $scope.scanInvoiceGridInstance = e.component;
                  
                         $scope.uploadInvoiceTotalCount = e.component.totalCount();
                        
                    },
                    onSelectionChanged: function (data) {
                        $scope.datagrid.selectedItems = data.selectedRowsData;
                        $scope.datagrid.selectedRecourdCount = data.selectedRowsData.length;
                        $scope.selectedItemIDs = _.pluck(data.selectedRowsData, 'id');
                        $scope.batchDeletedDisabled = $scope.selectedItemIDs.length == 0;
                    },
                    columns: [
                            { dataField: 'invoiceCode', caption: $translate.instant('InvoiceFPDM'), },
                            { dataField: 'invoiceNumber', caption: $translate.instant('InvoiceFPHM') },
                            //{ dataField: 'buyerName', caption: $translate.instant('BuyerName') },
                            //{ dataField: 'buyerTaxNumber', caption: $translate.instant('BuyerTaxNumber') },
                            //{ dataField: 'sellerName', caption: $translate.instant('SellerName') },
                           // { dataField: 'sellerTaxNumber', caption: $translate.instant('SellerTaxNumber') },
                            { dataField: 'amount', caption: $translate.instant('FaceTaxAmount') }, //税额合计小写
                          //  { dataField: 'taxAmount', caption: $translate.instant('InvoiceSE') },  //税额
                            { dataField: 'invoiceDate', caption: $translate.instant('InvoiceDate') }, //开票日期
                            {
                                dataField: 'invoiceSourceType', caption: $translate.instant('InvoiceSource'),  //发票来源
                                width: 150,
                                cellTemplate: function (container, options) {
                                    try {

                                        $('<div />').dxSelectBox({
                                            displayExpr: displayExpr,
                                            valueExpr: valueExpr,
                                            dataSource: $scope.searchFilterOptions.invoiceSourceList,
                                            value: options.data.invoiceSourceType,
                                            //bindingOptions: {
                                            //    value: 'invoiceEntity.invoiceSourceType',
                                            //},
                                            onValueChanged: function (data) {
                                                options.data.invoiceSourceType = data.value;
                                                options.component.repaintRows(options.rowIndex);
                                            },
                                            height: 25,
                                            placeholder: $scope.pleaseSelect,
                                            showClearButton: isShowClearButton,
                                            noDataText: $scope.translated.NoData,
                                        }).appendTo(container);
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },
                            {
                                dataField: 'PoOrStaff', caption: '',   //根据发票来源，补充不同的信息
                                width: 150,
                                cellTemplate: function (container, options) {
                                    try {
                                        container.empty();
                                        if (options.data.invoiceSourceType == constant.inputInvoice.invoiceSourceType.InvoiceClaim.id) {
                                            
                                            $('<div class="staff-id" />').dxTextBox({

                                                //bindingOptions: {
                                                //    value: 'invoiceEntity.invoiceSourceType11',
                                                //},
                                                onValueChanged: function (data) {
                                                    options.data.staffID = data.value;
                                                },
                                                height: 25,
                                                placeholder: "输入员工编号",
                                                showClearButton: isShowClearButton,
                                            }).appendTo(container);

                                        }
                                        else if (options.data.invoiceSourceType == constant.inputInvoice.invoiceSourceType.InvoiceNonRawMaterialPurchase.id) {


                                            $('<div class="po-id" />').dxTextBox({

                                                //bindingOptions: {
                                                //    value: 'invoiceEntity.invoiceSourceType11',
                                                //},
                                                onValueChanged: function (data) {
                                                    options.data.poNumber = data.value;
                                                },
                                                height: 25,
                                                placeholder: "输入PO编号",
                                                showClearButton: isShowClearButton,
                                            }).appendTo(container);
                                        }
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },

                            {
                                dataField: 'uploadStatus', caption: $translate.instant('UploadStatus'),  //上传状态
                                alignment: 'left',
                                cellTemplate: function (container, options) {
                                    try {
                                        if (options.data.uploadStatus === uploadStatusEnum.failure.id) {
                                            $("<span class='status-fail span-btn' />")
                                                  .text(uploadStatusEnum.failure.value)
                                                  //.on('click', function () {
                                                  //    //弹框补录信息
                                                  //    $scope.eventServie.editInvoiceModal(options.data);
                                                  //})
                                              .appendTo(container);
                                        } else if (options.data.uploadStatus === uploadStatusEnum.success.id) {
                                            $("<span class='status-nomal' />")
                                                  .text(uploadStatusEnum.success.value)
                                              .appendTo(container);
                                        }
                                        else if (options.data.uploadStatus === uploadStatusEnum.duplicate.id) {
                                            $("<span class='status-duplicate' />")
                                                  .text(uploadStatusEnum.duplicate.value)
                                              .appendTo(container);
                                        }
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },
                            {
                                dataField: 'id', caption: $translate.instant('Operation'), //操作
                                cellTemplate: function (container, options) {
                                    try {
                                        $("<span class='span-btn' />")
                                            .text($scope.translated.editBtn)
                                            .on('click', function () {
                                                //弹框编辑信息
                                                $scope.eventServie.editInvoiceModal(options.data);
                                            })
                                        .appendTo(container);

                                        $("<span class='span-btn' />")
                                            .text($scope.translated.deleteBtn)
                                            .on('click', function () {
                                                //确认删除？
                                                messageBox.confirm($scope.translated.confirmDeleteMsg, '').then(function (isConfirm) {
                                                    $scope.eventServie.deleteRow(options.data);
                                                });
                                            })
                                        .appendTo(container);
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },

                    ],

                };
            };

            var initControl = function () {
                memoryService.populateInvoiceSourceTypList();
                initInvoiceDataGridControl();
                initTextBoxOptions();
            };

            var initData = function () {
                //getService.getInputInvoiceList();
            };

            (function initialize() {
                $log.debug('invoiceManageMainUploadScanInvoiceController.ctor()...');
                initControl();
                initData();
            })();
        }
]);

invoiceModule.directive('invoiceManageMainUploadScanInvoice', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('invoiceManageMainUploadPaperInvoice.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-main-upload-scan-invoice/invoice-manage-main-upload-scan-invoice.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'invoiceManageMainUploadScanInvoiceController',
            link: function (scope, element) {


                $(window).on('resize', function () {
                   
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('invoiceManageMainController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', 'InvoiceManageService', '$location', 'Upload',
        function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, InvoiceManageService, $location, Upload) {
            'use strict';
  
            var parentSelector = '.invoice-manage-main';

            $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
            $scope.pleaseInput = $translate.instant('InputPlaceholder'),

            //分页的设置
            $scope.pagingOptions = { 
                pageIndex: 1,  //当前页码
                totalItems: 100,  //总数据
                pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
            };

            $scope.searchEntity = {};
            $scope.datagrid = {};
            $scope.hasShowMoreSearchBox = false;
            $scope.selectedRecourdCount = 0;

            var uploadIndexPageUrl = "/invoiceManagement/main/uploadIndex";


            $scope.translated = {
                NoData: $translate.instant('NoDataText'),
                pleaseSelect: $translate.instant("ChoosePlaceholder"),
                pleaseInput: $translate.instant('InputPlaceholder'),
            };


            //消息弹框
            var messageBox = {
                getMsg: function (resultMsg, hasTranslated) {
                    hasTranslated = hasTranslated || false;
                    var msg = resultMsg;
                    if (!hasTranslated) {
                        msg = $translate.instant(resultMsg);
                    }
                    return msg;
                },

                success: function (resultMsg, hasTranslated) {
                    var msg = this.getMsg(resultMsg, hasTranslated)
                    SweetAlert.success(msg);
                },

                warning: function (resultMsg, hasTranslated) {
                    var msg = this.getMsg(resultMsg, hasTranslated)
                    SweetAlert.warning(msg);
                },

                //有确认和取消按钮
                confirm: function (title, text, customClass) {
                    var deferred = $q.defer();
                    SweetAlert.swal({
                        title: title,
                        text: text,
                        html: true,
                        type: "warning",
                        customClass: customClass || '',
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        allowOutsideClick: false,
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                      function (isConfirm) {
                          deferred.resolve(isConfirm);
                      });

                    return deferred.promise;
                },

                //没有取消按钮
                info: function (title, text, customClass) {
                    var deferred = $q.defer();

                    SweetAlert.swal({
                        title: title,
                        text: text,
                        html: true,
                        type: "warning",
                        customClass: customClass || '',
                        showCancelButton: false,
                        confirmButtonColor: "#DD6B55",
                        allowOutsideClick: false,
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: true,
                        closeOnCancel: false
                    },
                      function (isConfirm) {
                          deferred.resolve(isConfirm);
                      });

                    return deferred.promise;
                },
            };

            //模态框
            var createModalInstance = function (templateUrl, windowClass) {
                var thisModalService = new Object();
                var parentElem = parentSelector ? angular.element($document[0].querySelector(parentSelector)) : undefined;

                thisModalService.open = function () {
                    var modalInstance = $uibModal.open({
                        animation: true,
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        backdrop: 'static',  //点击父页面不会自动关闭 
                        templateUrl: templateUrl, //模板
                        windowClass: windowClass, //弹框页面的css
                        scope: $scope,
                        appendTo: parentElem,
                    });

                    thisModalService.modalInstance = modalInstance;
                };

                thisModalService.close = function (result) {
                    if (thisModalService.modalInstance) {
                        thisModalService.modalInstance.close(result);
                    }
                };

                thisModalService.cancel = function () {
                    if (thisModalService.modalInstance) {
                        thisModalService.modalInstance.dismiss('cancel');
                    }
                }
                return thisModalService;
            };

            //弹框服务
            $scope.modalService = {
                //打开发票认证模态框
                invoiceVerify:{
                    open:function(){
                        $scope.verifyInvoiceModalInstance = createModalInstance('uploadInvoiceVerify.html', 'importVerifyInvoiceModal');
                        $scope.verifyInvoiceModalInstance.open();
                    },
                    save: function () {
                        uploadService.uplodFile();
                    },
                    cancel:function(){
                        $scope.verifyInvoiceModalInstance.cancel();
                    },
                },

                invoiceDetail: {
                    open: function () {
                        $scope.invoiceDetailTableInstance = createModalInstance('invoiceDetailTable.html', 'invoice-table-dialog');
                        $scope.invoiceDetailTableInstance.open();
                    },
                    save: function () {
                        $scope.invoiceDetailTableInstance.cancel();
                    },
                    cancel: function () {
                        $scope.invoiceDetailTableInstance.cancel();
                    },
                }
            };

            //上传认证清单
            var uploadService = {
                 resumable : true,
                 uploadUrl: apiInterceptor.webApiHostUrl + '/invoiceManage/UploadInvoiceVerifyFile',
                 uplodFile: function () {
                     var verifyFile = $scope.$$childTail.invoiceVerifyfile;
                     var fileName = verifyFile && $scope.$$childTail.invoiceVerifyfile.name;
                     if (!fileName) {
                         messageBox.warning("请先选择文件", true);
                         return;
                     }

                     var tempFileName = PWC.newGuid() + '.dat';
         
                     var token = $('input[name="__RequestVerificationToken"]').val();
                     Upload.upload({
                         url: uploadService.uploadUrl,
                         data: {
                             cancel: false,
                             filename: fileName,
                             tempFileName: tempFileName,
                         },
                         file: verifyFile,
                         resumeChunkSize: uploadService.resumable ? $scope.chunkSize : null,
                         headers: {
                             'Access-Control-Allow-Origin': '*',
                             Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken,
                             __RequestVerificationToken: token,
                             withCredentials: true
                         }, withCredentials: true
                     }).then(function (resp) {
                         if (resp.data.result) {
                             messageBox.success('文件上传成功');
                             $scope.verifyInvoiceModalInstance.close();
                             //刷新table
                             $scope.eventService.refreshInvoiceDataGrid();
                         }
                         else {
                             messageBox.warning(resp.data.resulMsg, true);
                         }
                     });
                 },

            };

            //获取数据服务
            var getService = {
                //查询的数据源准备
                getInvoiceFilterBasicData: function () {
                    var deferred = $q.defer();
                    InvoiceManageService.getInvoiceFilterBasicData().success(function (data) {
                        if (data) {
                            if (!$scope.searchFilterOptions) {
                                $scope.searchFilterOptions = {};
                            }
                            // console.log('data' + JSON.stringify(data));
                            $scope.searchFilterOptions = {
                                invoiceStatusList: memoryService.translateEnumValue(data.invoiceStatusList),
                                invoiceEntityList: memoryService.translateEnumValue(data.invoiceEntityList),
                                invoiceTypeList: memoryService.translateEnumValue(data.invoiceTypeList),
                                invoiceSourceList: memoryService.translateEnumValue(data.invoiceSourceList),
                                invoiceUploadTypeList: memoryService.translateEnumValue(data.invoiceUploadTypeList),
                            };
                            //退票理由
                            $scope.refundReasons = memoryService.translateEnumValue(data.invoiceRefundReasonList);

                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },

                //筛选invoice list
                getInputInvoiceList: function () {
                    var deferred = $q.defer();

                    var invoiceParams = {
                        InvoiceQuery: $scope.searchEntity,
                        pagingDto: $scope.pagingOptions,
                    };

                    InvoiceManageService.getInputInvoiceList(invoiceParams).success(function (data) {
                        if (data) {
                            $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                            if (data && data.list) {
                                data.list.forEach(function (item) {
                                    item.statusString = $translate.instant(item.statusString);
                                    item.invoiceEntityTypeString = $translate.instant(item.invoiceEntityTypeString);
                                    item.invoiceSourceTypeString = $translate.instant(item.invoiceSourceTypeString);
                                    item.invoiceTypeString = $translate.instant(item.invoiceTypeString);
                                    item.uploadTypeString = $translate.instant(item.uploadTypeString);
                                    item.uploadDate = moment(item.uploadDate).format(constant.date.dateFormatUppercase);
                                    item.invoiceDate = moment(item.invoiceDate).format(constant.date.dateFormatUppercase);
                                });
                            }
                            $scope.invoiceGridDataSource = data.list;
                            deferred.resolve(data);
                        };
                    });
                    return deferred.promise;
                },

            };

            //更新数据服务
            var updateService = {
                //发票识别,手动识别
                invoiceManualRecognize: function (invoiceIDList) {
                    var deferred = $q.defer();
                    InvoiceManageService.invoiceManualRecognize(invoiceIDList).success(function (data) {
                        if (data) {
                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },
                //发票验真
                invoiceExamination: function (invoiceIDList) {
                    var deferred = $q.defer();
                    InvoiceManageService.invoiceExamination(invoiceIDList).success(function (data) {
                        if (data) {
                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },
                //变更发票状态
                updateInvoiceStatus: function (invoiceIDList,invoiceStatusID) {
                    var deferred = $q.defer();
                    InvoiceManageService.updateInvoiceStatus(invoiceStatusID, invoiceIDList).success(function (data) {
                        if (data) {
                            deferred.resolve(data);
                        }
                    });
                    return deferred.promise;
                },
            };

    
            //内部处理
            var memoryService = {
                repaintInvoiceGrid: function () {
                    $scope.setInvoiceGridHeight();
                },
                //翻译查询的数据源
                translateEnumValue: function (data) {
                    if (!data || data.length == 0) return null;

                    data.forEach(function (item) {
                        item.value = $translate.instant(item.value);
                    });
                    return data;
                },
            };

            //button的事件
            $scope.eventService = {
                //上传
                gotoUploadIndexPage: function () {
                    $location.path(uploadIndexPageUrl);
                },

                checkHasItemSelected: function () {
                    if (!$scope.datagrid.selectedItems || $scope.datagrid.selectedItems.length == 0)
                    {
                        messageBox.warning("请至少选择一条记录", true);
                        return false;
                    }
                    return true;
                },

                //发票识别,已上传、已补录：识别
                invoiceManualRecognize: function () {

                    if (!$scope.eventService.checkHasItemSelected()) {
                        return false;
                    }

                    //只有已上传、已补录，可以做识别
                    var filterResult = _.filter($scope.datagrid.selectedItems, function (item) {
                        return item.status !== constant.inputInvoice.statusType.InvoiceHasUpload.id 
                            && item.status !== constant.inputInvoice.statusType.InvoiceHasAddRecord.id
                    });

                    if (filterResult.length > 0) {
                        messageBox.warning("只有已上传或者已补录的发票可以做发票识别", true);
                        return;
                    }
                    var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');

                    updateService.invoiceManualRecognize(selectedInvoiceIDList).then(function (data) {
                        if (data) {
                            messageBox.success("发票识别成功", true);
                        }
                    });
                },

                //发票验真,只有识别成功的才可以做验真。
                invoiceExamination: function () {
                    if (!$scope.eventService.checkHasItemSelected()) {
                        return false;
                    }
                    //只有识别成功的才可以做验真。
                    var filterResult = _.filter($scope.datagrid.selectedItems, function (item) {
                        return item.status !== constant.inputInvoice.statusType.InvoiceRecognizeSuccess.id;
                    });

                    if (filterResult.length > 0) {
                        messageBox.warning("只有识别成功的发票可以做验真", true);
                        return;
                    }
                    var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');

                    updateService.invoiceExamination(selectedInvoiceIDList).then(function (data) {
                        if (data) {
                            messageBox.success("发票验真成功", true);
                        }
                    });
                },

                //退票
                refundInovice: function () {
                    //弹框
                    if (!$scope.eventService.checkHasItemSelected()) {
                        return false;
                    }
                    $scope.selectedItemIDs = _.pluck($scope.datagrid.selectedItems, 'id');
                    $scope.showRefundModal = true;
                },

                //发票认证
                verifyInvoice: function () {
                    //上传excel
                },

                //失效
                expireInvoice: function () {
                    if (!$scope.eventService.checkHasItemSelected()) {
                        return false;
                    }
                    var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');
                    var status = stant.inputInvoice.statusType.InvoiceHasExpired.id;
                    messageBox.confirm("确认要把选中的发票进行失效处理吗？", '').then(function (isConfirm) {
                        if (isConfirm) {
                            updateService.updateInvoiceStatus(selectedInvoiceIDList, status).then(function (data) {
                                if (data) {
                                    messageBox.success("处理成功", true);
                                }
                            });
                        }
                    });
                },

                refreshInvoiceDataGrid: function () {
                    getService.getInputInvoiceList().then(function (data) {
                        $timeout(function () {
                            memoryService.repaintInvoiceGrid();
                        }, 100);
                    });
                },
            }

            //datagrid内部的事件
            $scope.dataGridService = {
                //发票识别
                manualRecognizInvoice: function (data) {

                    var selectedInvoiceIDList = [];
                    if (data)
                    {
                        selectedInvoiceIDList.push(data.id);
                    }
                    if (selectedInvoiceIDList.length > 0) {
                        updateService.invoiceManualRecognize(selectedInvoiceIDList).then(function (data) {
                            if (data) {
                                messageBox.success("发票识别成功", true);
                            }
                        });
                    }
                },

                //发票手动验真
                invoiceExamination: function (data) {
                    var selectedInvoiceIDList = [];
                    if (data) {
                        selectedInvoiceIDList.push(data.id);
                    }
                    if (selectedInvoiceIDList.length > 0) {
                        updateService.invoiceExamination(selectedInvoiceIDList).then(function (data) {
                            if (data) {
                                messageBox.success("发票验真成功", true);
                            }
                        });
                    }
                },

                //退票
                refundInovice: function (data) {
                    //弹框
                    var selectedInvoiceIDList = [];
                    if (data) {
                        selectedInvoiceIDList.push(data.id);
                    }
                    $scope.selectedItemIDs = selectedInvoiceIDList;
                    $scope.showRefundModal = true;
                },
                //票账匹配
                matchTicketAccount: function (data) {

                },
                //手动验真
                invoiceManualExamination: function (data) {
                    //弹框
                    $scope.isShowExaminationModal = true;
                    $scope.selectedInvoiceEntity = data;
                },
            }

            //搜索框的处理
            $scope.searchboxService = {
                //隐藏或者展示搜索框
                showOrHideSearchBox: function () {
                    $scope.hasShowMoreSearchBox = !$scope.hasShowMoreSearchBox;
                   // $scope.eventService.refreshInvoiceDataGrid();
                    $timeout(function () {
                        memoryService.repaintInvoiceGrid();
                    }, 50);
                  
                },
                
                //根据条件搜索发票
                searchInvoice: function () {
                    console.log('searchEntity:' + JSON.stringify($scope.searchEntity));
                    $scope.pagingOptions.pageIndex = 1;
                    $scope.eventService.refreshInvoiceDataGrid();
               
                },
            }

             //初始化invoice datagrid data
            var loadInvoiceGridData = function () {

                $scope.eventService.refreshInvoiceDataGrid();
            }

            //初始化invoice datagrid 树
            var InitInvoiceGrid = function () {

                var allowFilter = false;
                $scope.invoiceGridOptions = {
                    bindingOptions: {
                        dataSource: 'invoiceGridDataSource',
                    },
                    headerFilter: {
                        visible: true,
                        texts: {
                            cancel: $translate.instant('Cancel'),
                            ok: $translate.instant('Confirm'),
                            emptyValue: $translate.instant('Empty'),
                            selectAllText: '全选'//$translate.instant('SelectAll'),
                        }
                    },
                   // keyExpr: "ID",
                    selection: {
                        mode: "multiple",
                        showCheckBoxesMode: 'always'
                    },
                    paging: {
                        enabled: false,
                    },
                    hoverStateEnabled: true,
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                   //rowAlternationEnabled: true,
                    showBorders: true,
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),

                    onContentReady: function (e) {
                        $scope.invoiceGridInstance = e.component;
                    },
                    onCellPrepared: function (e) {
                        //已退票,已失效不显示checkbox
                        if (e.rowType === "data" & e.column.command === 'select' &&
                            (e.data.status === constant.inputInvoice.statusType.InvoiceHasRefund.id
                            || e.data.status === constant.inputInvoice.statusType.InvoiceHasExpired.id)) {
                            e.cellElement.find('.dx-select-checkbox').hide();
                            //e.cellElement.find('.dx-select-checkbox').addClass('dx-state-disabled');
                            e.cellElement.off();
                        }
                    },
                    onSelectionChanged: function (data) {
                        $scope.datagrid.selectedItems = data.selectedRowsData;
                        $scope.selectedRecourdCount = data.selectedRowsData.length;
                        //$scope.selectedItemIDs = _.pluck(data.selectedRowsData, 'id');
                        //$scope.selectedPlaceholder = data.selectedRowsData.length;
                        //$scope.disabled = !$scope.selectedItemIDs.length;
                    },
                    columns: [
                            { dataField: 'invoiceCode', caption: $translate.instant('InvoiceFPDM'), allowHeaderFiltering: allowFilter },
                            {
                                dataField: 'invoiceNumber', caption: $translate.instant('InvoiceFPHM'),allowHeaderFiltering: allowFilter,
                                cellTemplate: function (container, options) {
                                    try {
                                        $('<a class="invoiceNumber-link">').text(options.value)
                                           .on('click', function () {
                                               $scope.selectedInvoice = options.data;
                                               $scope.modalService.invoiceDetail.open();
                                           })
                                          .appendTo(container);
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },
                            { dataField: 'statusString', caption: $translate.instant('InvoiceStatus'), allowHeaderFiltering: true },
                            { dataField: 'buyerName', caption: $translate.instant('BuyerName'), width: 100, allowHeaderFiltering: allowFilter },
                            { dataField: 'buyerTaxNumber', caption: $translate.instant('BuyerTaxNumber'), width: 100, allowHeaderFiltering: allowFilter },
                            { dataField: 'sellerName', caption: $translate.instant('SellerName'), width: 100, allowHeaderFiltering: allowFilter },
                            { dataField: 'sellerTaxNumber', caption: $translate.instant('SellerTaxNumber'), width: 100, allowHeaderFiltering: allowFilter },
                            { dataField: 'amount', caption: $translate.instant('FaceTaxAmount'), width: 60, allowHeaderFiltering: allowFilter }, //税额合计小写
                            { dataField: 'taxAmount', caption: $translate.instant('InvoiceSE'), allowHeaderFiltering: allowFilter },  //税额
                            { dataField: 'invoiceDate', caption: $translate.instant('InvoiceDate'), allowHeaderFiltering: allowFilter }, //开票日期
                            { dataField: 'invoiceEntityTypeString', caption: $translate.instant('InvoiceEntity'), allowHeaderFiltering: allowFilter },
                            { dataField: 'invoiceTypeString', caption: $translate.instant('InvoiceFPLX'), allowHeaderFiltering: allowFilter },
                            { dataField: 'uploadDate', caption: $translate.instant('UploadDate'), allowHeaderFiltering: allowFilter },
                            { dataField: 'invoiceSourceTypeString', caption: $translate.instant('InvoiceSource'), allowHeaderFiltering: allowFilter }, //发票来源
                            { dataField: 'uploadTypeString', caption: $translate.instant('UploadType'), allowHeaderFiltering: allowFilter },
                            { dataField: 'statusString', caption: $translate.instant('InvoiceStatus'), allowHeaderFiltering: true },
                            {
                                dataField: 'id', caption: $translate.instant('Operation'),allowHeaderFiltering: allowFilter,
                                cellTemplate: function (container, options) {
                                    try {
                                        var data = options.data;
                                        var invoiceStatusType = constant.inputInvoice.statusType;
                                        //已上传、已补录：识别
                                        if (data.status == invoiceStatusType.InvoiceHasUpload.id || data.status == invoiceStatusType.InvoiceHasAddRecord.id) {
                                            $("<span class='span-btn' />")
                                                .text('识别')
                                                .on('click', function () {
                                                    $scope.dataGridService.manualRecognizInvoice(data);
                                                })
                                            .appendTo(container);
                                        }
                                            //识别成功：验真
                                        else if (data.status == invoiceStatusType.InvoiceRecognizeSuccess.id) {
                                            $("<span class='span-btn' />")
                                                .text('验真')
                                                .on('click', function () {
                                                    $scope.dataGridService.invoiceExamination(data);
                                                })
                                            .appendTo(container);
                                        }
                                            //无法识别：退票或者重新识别
                                        else if (data.status == invoiceStatusType.InvoiceUnrecognize.id) {
                                            $("<span class='span-btn' />")
                                                .text('退票')
                                                .on('click', function () {
                                                    $scope.dataGridService.refundInovice(data);
                                                })
                                            .appendTo(container);

                                            $("<span class='span-btn' />")
                                                .text('重新识别')
                                                .on('click', function () {
                                                    $scope.dataGridService.manualRecognizInvoice(data);
                                                })
                                            .appendTo(container);

                                        }
                                            //识别失败：退票
                                        else if (data.status == invoiceStatusType.InvoiceRecognizeFailure.id) {
                                            $("<span class='span-btn' />")
                                                .text('退票')
                                                .on('click', function () {
                                                    $scope.dataGridService.refundInovice(data);
                                                })
                                            .appendTo(container);
                                        }

                                            //验真失败：手动验真
                                        else if (data.status == invoiceStatusType.InvoiceVerifyFailure.id) {
                                            $("<span class='span-btn' />")
                                                .text('手动验真')
                                                .on('click', function () {
                                                    $scope.dataGridService.invoiceManualExamination(data);
                                                })
                                            .appendTo(container);
                                        }
                                            //待匹配：票账匹配，退票 
                                        else if (data.status == invoiceStatusType.InvoicePendingMatch.id) {
                                            $("<span class='span-btn' />")
                                            .text('票账匹配')
                                            .on('click', function () {
                                                $scope.dataGridService.matchTicketAccount(data);
                                            })
                                            .appendTo(container);

                                            $("<span class='span-btn' />")
                                                .text('退票')
                                                .on('click', function () {
                                                    $scope.dataGridService.refundInovice(data);
                                                })
                                            .appendTo(container);
                                        }
                                    }
                                    catch (e) {
                                        $log.error(e);
                                    }
                                }
                            },
                           ],

                    masterDetail: {
                        enabled: true,
                        template: "detail"
                    },
                    detailGridOptions: function (invoiceID) {
                        return {
                            dataSource: new DevExpress.data.DataSource({
                                load: function (loadOptions) {
                                    var deferred = $q.defer();
                                   return InvoiceManageService.getInputInvoiceItemList(invoiceID).success(function (response) {
                                       deferred.resolve({ data: response, totalCount: response.length });
                                   }).error(function () {
                                       deferred.reject("Data Loading Error");
                                   });
                                    return deferred.promise;
                    }
                            }),
                            noDataText: $translate.instant('NoDataText'),
                            columnAutoWidth: true,
                            //showBorders: true,
                            allowColumnResizing: true,
                            columns: [
                                {
                                    dataField: 'productionName',
                                    caption: $translate.instant('ProductAndService')
                                },
                            {
                                dataField: 'specification',
                                caption: $translate.instant('Specifications')
                            },
                            {
                                dataField: 'unit',
                                caption: $translate.instant('Unit')
                            },
                             {
                                 dataField: 'quantity',
                                 caption: $translate.instant('Quantity')
                             },
                              {
                                  dataField: 'unitPrice',
                                  caption: $translate.instant('UnitPrice')
                              },
                               {
                                   dataField: 'amount',
                                   caption: $translate.instant('Amount')

                               },
                               {
                                   dataField: 'taxRate',
                                   caption: $translate.instant('TaxRate')
                               },
                               {
                                   dataField: 'taxAmount',
                                   caption: $translate.instant('TaxAmount')
                               },
                               {
                                   dataField: 'remark',
                                   caption: $translate.instant('Remark')
                               }
                            ]
                        }
                    }
                };
            };

            var initDatePicker = function () {
                $('#invoiceDatePicker,#uploadDatepicker').datepicker({
                    language: region
                });
            };

            //搜索框初始化
            var initSearchBoxContorls = function () {

                var valueExpr = "id";
                var displayExpr = "value";

                var isShowClearButton = true;
                
                $scope.searchEntityOptions = {
                    //1. 购买方
                    selectboxBuyerNameOptions: {
                        bindingOptions: {
                            value: 'searchEntity.buyerName',
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //2. 销售方
                    txtSellerNameBoxOptions: {
                        bindingOptions: {
                            value: 'searchEntity.sellerName',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                        //onValueChanged: function (data) {
                        //    $scope.searchEntity.sellerName = data.value;
                        //}
                    },
                    //3. 发票号码
                    txtInvoiceNumberOptions: {
                        bindingOptions: {
                            value: 'searchEntity.invoiceNumber',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                    },
                    //4.发票状态，已经上传，已补录。。
                    selectstatusOptions: {
                     
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.status',
                            dataSource: 'searchFilterOptions.invoiceStatusList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //5.开票日期，目前是boostrap控件
                    //invoiceDateFrom,invoiceDateTo
                    //6.发票来源
                    selectinvoiceSourceTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceSourceType',
                            dataSource: 'searchFilterOptions.invoiceSourceList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //7.发票类型,普票和专票
                    selectInvoiceTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceType',
                            dataSource: 'searchFilterOptions.invoiceTypeList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //8. UploadDate,   upload 日期，目前是boostrap控件, uploadDateFrom,uploadDateTo
                    //9. amount
                    txtAmountOptions: {
                        bindingOptions: {
                            value: 'searchEntity.amount',
                        },
                        placeholder: $scope.pleaseInput,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //10/发票实体，纸票或者电子票
                    selectInvoiceEntityTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceEntityType',
                            dataSource: 'searchFilterOptions.invoiceEntityList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                    //11/发票上传方式，pdf,或者扫描
                    selectInvoiceUploadTypeOptions: {
                        displayExpr: displayExpr,
                        valueExpr: valueExpr,
                        bindingOptions: {
                            value: 'searchEntity.invoiceUploadType',
                            dataSource: 'searchFilterOptions.invoiceUploadTypeList'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                        noDataText: $scope.translated.NoData,
                    },
                };
            };

            //初始化控件
            var initControls = function () {
                initDatePicker();
                initSearchBoxContorls();
                InitInvoiceGrid();
            };

            //初始化数据
            var initData = function () {
                $scope.searchFilterOptions = {};
                $scope.hasShowMoreSearchBox =true;
                $scope.searchboxService.showOrHideSearchBox();
                loadInvoiceGridData();
                getService.getInvoiceFilterBasicData();
            };

            (function initialize() {
                $log.debug('invoiceManageMainController.ctor()...');

                initControls();
                initData();

            })();
        }
    ]);

invoiceModule.directive('invoiceManageMain', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('invoiceManageMain.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-main/invoice-manage-main.html' + '?_=' + Math.random(),
            scope:
            {
                 
            },
            controller: 'invoiceManageMainController',
            link: function (scope, element) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var invoiceDataGridSelector = '#invoiceGridContainer';
                    var pageWrapSelector = ".invoice-manage-main";
                    var menuSelector = ".header-title";
                    var contentHeader = '.content-container .header';
                    var contentbody = '.content-container .body';
                    var buttonRow = '.content-container .buttom-row';
                    var pageFooter = '.invoice-manage-main .page-footer';
                    var dxGridSelector = pageWrapSelector + " .grid-container";

                    var pageHeight = $(document).height();// 810; 
                    var menuHeight = $(menuSelector).outerHeight(); 

                    var contentHeaderHeight = $(contentHeader).outerHeight(); 
                    var buttonRowHeight = $(buttonRow).outerHeight(); 
                    var pageFooterHeight = $(pageFooter).outerHeight(); //parseInt($(pageFooter).css('height').replace('px', ''));
                
                    var contentbodyHeight = pageHeight - menuHeight - contentHeaderHeight ;
                    var height = contentbodyHeight -buttonRowHeight- pageFooterHeight -50 + 'px';
                    $(contentbody).css('height', contentbodyHeight+'px');
                    $(dxGridSelector).css('height', height);
                    $(invoiceDataGridSelector).css('max-height', '100%');

                    try {
                        $(invoiceDataGridSelector).dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        //console.log(e);
                    }
                };


                $(window).on('resize',function () {
                    scope.setInvoiceGridHeight();
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('invoiceManageMapController', ['InvoiceManageService', '$scope', '$log', '$timeout', 'SweetAlert', '$translate', 'uiGridConstants', 'apiInterceptor', '$interval', '$q',
        function (InvoiceManageService, $scope, $log, $timeout, SweetAlert, $translate, uiGridConstants, apiInterceptor, $interval, $q) {
            'use strict';
            //当前页面的常量
            //分页的设置
            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 100,  //总数据
                totalPages: 10,//总页数
                maxSize: 10, //分页数字的限制。
                pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
                pageSizeString: constant.page.pageSizeArrary[1].toString(),
            };

            $scope.translated = {
                NoData: $translate.instant('NoDataText'),
                pleaseSelect: $translate.instant("ChoosePlaceholder"),
                pleaseInput: $translate.instant('InputPlaceholder'),
            };
            $scope.relevanceType = -1;
            $scope.isFour = false;
            $scope.isShowModal = false;
            $scope.queryParam = {};
            $scope.selectedInvoice = null; //当前选中的发票
            var yeaOrNoSelectItem = [{ 'id': 1, 'value': '是' }, { 'id': 0, 'value': '否' }];

            var relevanceDataSource = new DevExpress.data.CustomStore({
                load: function (loadOptions) {
                    var pagingDto = { totalCount: null };
                    pagingDto.pageSize = $scope.pagingOptions.pageSize || 10;
                    pagingDto.pageIndex = $scope.pagingOptions.pageIndex;

                    //$scope.queryParam.isIncludedInTaxAmount = $scope.queryParam.isIncludedInTaxAmount === null ? null :
                    //    ($scope.queryParam.isIncludedInTaxAmount === 1 ? true : false);

                    var pagingQueryParams = {
                        QueryParam: $scope.queryParam,
                        PagingDto: $scope.pagingOptions,
                    };
                    var deferred = $q.defer();
                    InvoiceManageService.getInvoiceRelevanceDisplayList(pagingQueryParams).success(function (data) {
                        if (data) {
                            $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                            if (data.list && data.list.length > 0) {
                                //将重复的字段设置为空
                                var newOrderIdentifier = '';
                                var counter = 0;
                                newOrderIdentifier = data.list[0].orderIdentifier;
                                for (var i = 0; i < data.list.length; i++) {
                                    //将发票来源不是“原料”的订单数据设置为—————
                                    if (data.list[i].invoiceSourceType !== 1) {
                                        data.list[i].sellerName = '————';
                                        data.list[i].buyerName = '————';
                                        data.list[i].orderAmount = '————';
                                        data.list[i].orderDate = '————';
                                        data.list[i].acceptNO = '————';
                            }
                                    data.list[i].statusString = $translate.instant(data.list[i].statusString);
                                    data.list[i].invoiceSourceTypeString = $translate.instant(data.list[i].invoiceSourceTypeString);
                                    data.list[i].invoiceTypeString = $translate.instant(data.list[i].invoiceTypeString);
                                    data.list[i].productionTypeString = $translate.instant(data.list[i].productionTypeString);
                                    data.list[i].invoiceDate = moment(data.list[i].invoiceDate).format(constant.date.dateFormatUppercase);
                                    data.list[i].isIncludedInTaxAmountString = data.list[i].isIncludedInTaxAmount == null ? '' : (data.list[i].isIncludedInTaxAmount == 1 ? '是' : '否');

                                    if (i > 0) {
                                        if (newOrderIdentifier === data.list[i].orderIdentifier) {
                                            //如果最新行的订单识别号跟当前行比较，相等，则counter++,将发票主数据部分字段设置为空
                                            data.list[i].orderIdentifier = '';
                                            data.list[i].sellerName = '';
                                            data.list[i].buyerName = '';
                                            data.list[i].orderAmount = '';
                                            data.list[i].orderDate = '';

                                            if (data.list[i].invoiceSourceType != 1) {
                                                data.list[i].acceptNO = '';
                                            }

                                            counter++;
                                        }
                                        else {
                                            //如果最新行跟当前行比较，不相等，则重置counter为0
                                            counter = 0;
                                            newOrderIdentifier = data.list[i].orderIdentifier;
                                        }
                                    }

                                }

                            }
                            deferred.resolve(data.list);
                        }
                    })
                    .error(function () {
                        deferred.reject("Data Loading Error");
                    });
                    return deferred.promise;

                }
            });

            //页面中的DXGrid事件
            $scope.thisDXGridService = {
                //初始化DataGrid DX控件，查询结果
                initDXGridData: function () {
                    $("#invoiceManageMapList").dxDataGrid({
                        dataSource: {
                            store: relevanceDataSource
                        },
                        selection: {
                            mode: "single"
                        },
                        paging: {
                            enabled: false,
                        },
                        hoverStateEnabled: true,
                        //showRowLines: true,
                        //showColumnLines: true,
                        //rowAlternationEnabled: true,
                        showBorders: true,
                        allowColumnResizing: true,
                        columnResizingMode: "widget",
                        columnAutoWidth: true,
                        noDataText: $translate.instant('NoDataText'),
                        columns: [
                            { caption: $translate.instant('OrderIdentifier'), dataField: 'orderIdentifier' },
                            { caption: $translate.instant('VendorName'), dataField: "sellerName" },
                            { caption: $translate.instant('BuyerName'), dataField: "buyerName" },
                            { caption: $translate.instant('OrderAmount'), dataField: "orderAmount" },
                            { caption: $translate.instant('PurchaseDate'), dataField: "orderDate", dateType: "date" },
                            { caption: $translate.instant('AcceptNO'), dataField: "acceptNO" },
                            { caption: $translate.instant('invoiceCode'), dataField: "invoiceCode" },
                            { caption: $translate.instant('invoiceNumber'), dataField: "invoiceNumber" },
                            { caption: $translate.instant('FaceTaxAmount'), dataField: "amount" },
                            { caption: $translate.instant('InvoiceKPRQ'), dataField: "invoiceDate" },
                            { caption: $translate.instant('InvoiceFPLX'), dataField: "invoiceTypeString" },
                            { caption: $translate.instant('InvoiceStatus'), dataField: "statusString" },
                            { caption: $translate.instant('InvoiceSource'), dataField: "invoiceSourceTypeString" },
                            { caption: $translate.instant('ProductionType'), dataField: "productionTypeString" },
                            { caption: $translate.instant('VoucherNO'), dataField: "voucherNO" },
                            { caption: $translate.instant('IsIncludedInTaxAmount'), dataField: "isIncludedInTaxAmountString" }],
                        onSelectionChanged: function (selectedItems) {
                            if (selectedItems) {
                            $scope.selectedInvoice = selectedItems.selectedRowsData[0];
                            $scope.relevanceType = $scope.selectedInvoice.invoiceSourceType;
                                $scope.isFour = true;
                        }
                        }
                    });

                    $timeout(function () {
                        $scope.thisDXGridService.repaintInvoiceGrid();
                    }, 300);
                
                },
                //重绘发票dataGrid高度
                repaintInvoiceGrid: function () {
                    $timeout(function () {
                    $scope.setInvoiceGridHeight();
                    }, 100);
                  
                },
                //重新刷新dataGrid数据(在点击查询按钮或者点击页码的时候执行)
                refreshTable: function () {
                    var grid = $('#invoiceManageMapList').dxDataGrid('instance');
                    grid.clearSelection();
                    grid.refresh();
                    $scope.thisDXGridService.repaintInvoiceGrid();
                }
            };


            //当前页面的service
            var thisPageService = {
                //初始化查询条件DX控件
                initQueryCondition: function () {
                    var isShowClearButton = true;
                    var valueExpr = "id";
                    var displayExpr = "value";

                    $scope.searchEntityOptions = {
                        //订单识别号
                        txtOrderIdentifierOptions: {
                            bindingOptions: {
                                value: 'queryParam.OrderIdentifier',
                            },
                            placeholder: $translate.instant('PleaseInputOrderIdentifierTips')
                        },
                        //订单金额
                        txtStartOrderAmountOptions: {
                            bindingOptions: {
                                value: 'queryParam.orderAmountStart',
                            }
                        },
                        txtEndOrderAmountOptions: {
                            bindingOptions: {
                                value: 'queryParam.orderAmountEnd',
                            }
                        },
                        //供应商名称
                        txtVendorNameOptions: {
                            bindingOptions: {
                                value: 'queryParam.sellerName',
                            },
                            placeholder: $translate.instant('PleaseInputVendorNameTips'),
                        },
                        //采购日期
                        txtStartOrderDateOptions: {
                            bindingOptions: {
                                value: 'queryParam.orderDateStart',
                            }
                        },
                        txtEndOrderDateOptions: {
                            bindingOptions: {
                                value: 'queryParam.orderDateEnd',
                            },
                        },
                        //是否计入进项税额
                        selectboxIsIncludedInTaxAmountOptions: {
                            displayExpr: displayExpr,
                            valueExpr: valueExpr,
                            bindingOptions: {
                                value: 'queryParam.isIncludedInTaxAmount',
                                dataSource: 'searchFilterOptions.isIncludedInTaxAmountList'
                            },
                            placeholder: $scope.pleaseSelect,
                            showClearButton: isShowClearButton,
                            noDataText: $scope.translated.NoData
                        },
                        //收货单号
                        txtAcceptNOOptions: {
                            bindingOptions: {
                                value: 'queryParam.acceptNO',
                            },
                            placeholder: $translate.instant('PleaseInputAcceptNO'),
                        },
                        //票面金额(含税)
                        txtStartAmountOptions: {
                            bindingOptions: {
                                value: 'queryParam.totalPriceLowerCaseStart',
                            },
                            placeholder: "",
                        },
                        txtEndAmountOptions: {
                            bindingOptions: {
                                value: 'queryParam.totalPriceLowerCaseEnd',
                            },
                            placeholder: "",
                        },
                        //购方名称
                        txtBuyerNameOptions: {
                            bindingOptions: {
                                value: 'queryParam.buyerName',
                            },
                            placeholder: $translate.instant('PleaseInputBuyerName')
                        },
                        //开票日期
                        txtStartInvoiceDateOptions: {
                            bindingOptions: {
                                value: 'queryParam.invoiceDateStart',
                            },
                            placeholder: "",
                        },
                        txtEndInvoiceDateOptions: {
                            bindingOptions: {
                                value: 'queryParam.invoiceDateEnd',
                            },
                            placeholder: "",
                        },
                        //发票状态
                        selectboxInvoiceStatusOptions: {
                            displayExpr: displayExpr,
                            valueExpr: valueExpr,
                            bindingOptions: {
                                value: 'queryParam.invoiceStatus',
                                dataSource: 'searchFilterOptions.invoiceStatusList'
                            },
                            placeholder: $scope.pleaseSelect,
                            showClearButton: isShowClearButton,
                            noDataText: $scope.translated.NoData
                        },
                        //发票号码
                        txtInvoiceNumberOptions: {
                            bindingOptions: {
                                value: 'queryParam.invoiceNumber',
                            },
                            placeholder: $translate.instant('PleaseInputInvoiceNumber'),
                        },
                        //发票来源
                        selectboxInvoiceSourceOptions: {
                            displayExpr: displayExpr,
                            valueExpr: valueExpr,
                            bindingOptions: {
                                value: 'queryParam.invoiceSourceType',
                                dataSource: 'searchFilterOptions.invoiceSourceList'
                            },
                            placeholder: $scope.pleaseSelect,
                            showClearButton: isShowClearButton,
                            noDataText: $scope.translated.NoData
                        },
                        //发票类型
                        selectboxInvoiceTypeOptions: {
                            displayExpr: displayExpr,
                            valueExpr: valueExpr,
                            bindingOptions: {
                                value: 'queryParam.invoiceType',
                                dataSource: 'searchFilterOptions.invoiceTypeList'
                            },
                            placeholder: $scope.pleaseSelect,
                            showClearButton: isShowClearButton,
                            noDataText: $scope.translated.NoData
                        },
                        //商品种类
                        selectboxProductTypeOptions: {
                            displayExpr: displayExpr,
                            valueExpr: valueExpr,
                            bindingOptions: {
                                value: 'queryParam.productionType',
                                dataSource: 'searchFilterOptions.invoiceProductionTypeList'
                            },
                            placeholder: $scope.pleaseSelect,
                            showClearButton: isShowClearButton,
                            noDataText: $scope.translated.NoData
                        },
                        //凭证单号
                        txtVoucherNOOptions: {
                            bindingOptions: {
                                value: 'queryParam.voucherNO',
                            },
                            placeholder: $translate.instant('PleaseInputVoucherNO')
                        }
                    };
                },
                //打开关联管理模态框
                openRelevanceModal: function () {
                    if (!$scope.selectedInvoice) {
                        SweetAlert.swal('请先选择一条发票信息！');
                        return;
                    }

                    if ($scope.selectedInvoice.status !== 7) {
                        SweetAlert.swal('当前选择的发票不能进行票帐匹配，只能选择状态为[待匹配]的发票！');
                        return;
                    }

                    $scope.isShowModal = true;
                },
                //toggle查询条件显示区域
                toggleQueryCondition: function () {
                    $scope.expandAllQueryCondition = !$scope.expandAllQueryCondition;
                    $scope.thisDXGridService.repaintInvoiceGrid();
                },
                //获取关联数据列表
                loadRelevanceDataList: function () {
                    $scope.thisDXGridService.refreshTable();
                },
                //翻译查询的数据源
                translateEnumValue: function (data) {
                    if (!data || data.length == 0) return null;

                    data.forEach(function (item) {
                        item.value = $translate.instant(item.value);
                    });
                    return data;
                },
                //查询的数据源准备
                getInvoiceFilterBasicData: function () {
                    InvoiceManageService.getInvoiceFilterBasicData().success(function (data) {
                        if (data) {
                            if (!$scope.searchFilterOptions) {
                                $scope.searchFilterOptions = {};
                            }
                            $scope.searchFilterOptions = {
                                invoiceStatusList: thisPageService.translateEnumValue(data.invoiceStatusList),
                                invoiceTypeList: thisPageService.translateEnumValue(data.invoiceTypeList),
                                invoiceSourceList: thisPageService.translateEnumValue(data.invoiceSourceList),
                                invoiceProductionTypeList: thisPageService.translateEnumValue(data.invoiceProductionTypeList),
                                isIncludedInTaxAmountList: yeaOrNoSelectItem
                            };


                        }
                    });
                }
            };

            //分页里面的处理
            //$scope.pagingSercice = {
            //    setPage: function (pageNo) {
            //    },

            //    //分页下拉
            //    populatePagingSelection: function () {
            //        var pagingSelection = [];
            //        var pageArray = constant.page.pageSizeArrary;
            //        for (var i = 0 ; i < pageArray.length; i++) {
            //            var selection = { id: pageArray[i], value: pageArray[i] };
            //            pagingSelection.push(selection);
            //        }
            //        $scope.pagingOptions.pagingSelection = pagingSelection;
            //    },

            //    //分页的时候改变数字
            //    pageIndexChanging: function () {
            //        if ($scope.pagingOptions.pageIndex > $scope.pagingOptions.totalPages) {
            //            $scope.pagingOptions.pageIndex = $scope.pagingOptions.totalPages;
            //        }
            //        if ($scope.pagingOptions.pageIndex <= 0) {
            //            $scope.pagingOptions.pageIndex = 1;
            //        }

            //        $log.log('Page changed to: ' + $scope.pagingOptions.pageIndex);
            //        thisDXGridService.refreshTable();
            //    },

            //    //每页显示的数据下拉改变
            //    pageSizeSelectionChanged: function () {
            //        $scope.pagingOptions.pageSize = parseInt($scope.pagingOptions.pageSizeString);
            //        thisDXGridService.refreshTable();
            //    },
            //};

            //初始化页面
            var initPage = function () {
                thisPageService.initQueryCondition();
                $scope.thisDXGridService.initDXGridData();
                thisPageService.getInvoiceFilterBasicData();
             //   $scope.pagingSercice.populatePagingSelection();
            };

            (function initialize() {
                $scope.expandAllQueryCondition = false;

                $log.debug('invoiceManageMapController.ctor()...');

                initPage();

                $scope.showRevelanceModal = thisPageService.openRelevanceModal;

                $scope.toggleQueryCondition = thisPageService.toggleQueryCondition;

                $scope.queryRelevanceDataList = thisPageService.loadRelevanceDataList;

                $scope.thisDXGridService.repaintInvoiceGrid();
            })();
        }
]);

invoiceModule.directive('invoiceManageMap', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('invoiceManageMap.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-map/invoice-manage-map.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'invoiceManageMapController',
            link: function (scope, element) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var invoiceDataGridSelector = '#invoiceManageMapList';
                    var pageWrapSelector = ".invoice-manage-map";
                    var queryCondition = '.invoice-manage-map .query-condition-wrapper';
                    var contentbody = '.invoice-manage-map .search-result-wrapper';
                    var buttonRow = '.invoice-manage-map .operation-btn-row';
                    var pageFooter = '.invoice-manage-map .page-footer';
                    var dxGridSelector = ".invoice-manage-map .gridContainer";

                    var pageHeight = $(document).height();
                    var queryConditionHeight = $(queryCondition).outerHeight();

                    var buttonRowHeight = $(buttonRow).outerHeight();
                    var pageFooterHeight = $(pageFooter).outerHeight();

                    var contentbodyHeight = pageHeight - queryConditionHeight - buttonRowHeight - pageFooterHeight - 100;
                    var height = contentbodyHeight + 'px';
                    $(contentbody).css('height', contentbodyHeight + 'px');
                    $(dxGridSelector).css('height', height);
                    $(invoiceDataGridSelector).css('max-height', '100%');

                    try {
                        $(invoiceDataGridSelector).dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };


                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('invoiceManageRefundController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q', '$interval', 'region', '$timeout', 'InvoiceManageService',
function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, $interval, region, $timeout, InvoiceManageService) {
    'use strict';

    $scope.hasShowMoreSearchBox = false;
    $scope.selectedPlaceholder = 0;
    $scope.translated = {
        NoData: $translate.instant('NoDataText'),
        pleaseSelect: $translate.instant("ChoosePlaceholder"),
        pleaseInput: $translate.instant('InputPlaceholder'),
    };
    $scope.filterStatusIDList = [3, 4, 7];

    //消息弹框
    var messageBox = {
        getMsg: function (resultMsg, hasTranslated) {
            hasTranslated = hasTranslated || false;
            var msg = resultMsg;
            if (!hasTranslated) {
                msg = $translate.instant(resultMsg);
            }
            return msg;
        },

        success: function (resultMsg, hasTranslated) {
            var msg = this.getMsg(resultMsg, hasTranslated)
            SweetAlert.success(msg);
        },

        warning: function (resultMsg, hasTranslated) {
            var msg = this.getMsg(resultMsg, hasTranslated)
            SweetAlert.warning(msg);
        },

        //有确认和取消按钮
        confirm: function (title, text, customClass) {
            var deferred = $q.defer();
            SweetAlert.swal({
                title: title,
                text: text,
                html: true,
                type: "warning",
                customClass: customClass || '',
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                allowOutsideClick: false,
                confirmButtonText: $translate.instant('Confirm'),
                cancelButtonText: $translate.instant('Cancel'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
              function (isConfirm) {
                  deferred.resolve(isConfirm);
              });

            return deferred.promise;
        },

        //没有取消按钮
        info: function (title, text, customClass) {
            var deferred = $q.defer();

            SweetAlert.swal({
                title: title,
                text: text,
                html: true,
                type: "warning",
                customClass: customClass || '',
                showCancelButton: false,
                confirmButtonColor: "#DD6B55",
                allowOutsideClick: false,
                confirmButtonText: $translate.instant('Confirm'),
                cancelButtonText: $translate.instant('Cancel'),
                closeOnConfirm: true,
                closeOnCancel: false
            },
              function (isConfirm) {
                  deferred.resolve(isConfirm);
              });

            return deferred.promise;
        },
    };

    //模态框
    var modalService = {
        modalInstance: null,
        open: function () {
            var parentElem = parentSelector ? angular.element($document[0].querySelector(parentSelector)) : undefined;

            var modalInstance = $uibModal.open({
                animation: true,
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                templateUrl: 'template.html', //模板
                windowClass: 'pupupModal', //弹框页面的css
                scope: $scope,
                appendTo: parentElem,
            });

            thisModalService.modalInstance = modalInstance;
        },
        close: function (result) {
            if (thisModalService.modalInstance) {
                thisModalService.modalInstance.close(result);
            }
        },
        cancel: function () {
            if (thisModalService.modalInstance) {
                thisModalService.modalInstance.dismiss('cancel');
            }
        }
    };


    //获取数据服务
    var getService = {
        //查询的数据源准备
        getInvoiceFilterBasicData: function () {
            var deferred = $q.defer();
            InvoiceManageService.getInvoiceFilterBasicData().success(function (data) {
                if (data) {
                    if (!$scope.searchFilterOptions) {
                        $scope.searchFilterOptions = {};
                    }
                    // console.log('data' + JSON.stringify(data));
                    var statusList = _.filter(data.invoiceStatusList, function (item) {
                        return $scope.filterStatusIDList.indexOf(item.id) > -1;
                    });
                    memoryService.translateDictionary(statusList);
                    memoryService.translateDictionary(data.invoiceRefundReasonList);
                    memoryService.translateDictionary(data.invoiceEntityList);
                    memoryService.translateDictionary(data.invoiceTypeList);
                    memoryService.translateDictionary(data.invoiceSourceList);
                    memoryService.translateDictionary(data.invoiceUploadTypeList);
                    //退票理由
                    $scope.refundReasons = data.invoiceRefundReasonList;

                    $scope.searchFilterOptions = {
                        invoiceStatusList: statusList,
                        invoiceEntityList: data.invoiceEntityList,
                        invoiceTypeList: data.invoiceTypeList,
                        invoiceSourceList: data.invoiceSourceList,
                        invoiceUploadList: data.invoiceUploadTypeList
                    };

                    deferred.resolve(data);
                }
            });
            return deferred.promise;
        },
        recognizeInvoice: function () {
            InvoiceManageService.invoiceManualRecognize($scope.selectedItem).success(function () {

            }).error(function () {
                SweetAlert.error("", $translate.instant("CommonFail"));
            });
        }
    };


    //内部处理
    var memoryService = {
        repaintInvoiceGrid: function () {
            $timeout(function () { 
                $scope.setInvoiceGridHeight();
            }, 100);
            //var grid = $('#invoiceRefundGrid').dxDataGrid('instance');
            //if ($scope.hasShowMoreSearchBox) {
            //    grid.option({ height: '300px' });
            //} else {
            //    grid.option({ height: '400px' });
            //}
            //grid.repaint();
        },
        translateDictionary: function (list) {
            _.each(list, function (item) {
                item.value = $translate.instant(item.value);

            });
        }
       
    };

    //button的事件
    $scope.eventService = {

        //发票识别
        manualRecognize: function () {
            //排除待匹配状态
            var notFitList = _.where($scope.selectedItem,  {
                status:7
            });
            if (notFitList && notFitList.length > 0) {
                var message = $translate.instant('NotMappingCondition').replace('@', notRecognizationList.length);
                SweetAlert.warning('', message);
            }else
            {
                getService.recognizeInvoice();
            }
        },
        //退票
        refundInovice: function () {
            $scope.showRefundModal = true;
        },
        refreshTable: function () {           
            var grid = $('#invoiceRefundGrid').dxDataGrid('instance');
            grid.clearSelection();
            grid.refresh();
            memoryService.repaintInvoiceGrid();
        }

    };

    //搜索框的处理
    $scope.searchboxService = {
        //隐藏或者展示搜索框
        showOrHideSearchBox: function () {
            $scope.hasShowMoreSearchBox = !$scope.hasShowMoreSearchBox;
            memoryService.repaintInvoiceGrid();
        },

        //根据条件搜索发票
        searchInvoice: function () {
            //set page index, avoid the pageIndex not 1
            $scope.paging.pagingOptions.pageIndex = 1;
            $scope.eventService.refreshTable();
        },
    };

    //分页的设置
    $scope.paging = {
        pagingOptions : {
            pageIndex: 1,  //当前页码
            totalItems: 100,  //总数据
            totalPages: 10,//总页数
            maxSize: 10, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
            pageSizeString: constant.page.pageSizeArrary[1].toString(),
        },
    };
       
  
 
    var InitInvoiceGrid = function () {
        var refundDataSource = new DevExpress.data.CustomStore({
            load: function (loadOptions) {
                var pagingDto = { totalCount: null };
                pagingDto.pageSize = $scope.paging.pagingOptions.pageSize || 10;
                pagingDto.pageIndex = $scope.paging.pagingOptions.pageIndex;

                var invoiceParams = {
                    InvoiceQuery: $scope.searchEntity,
                    pagingDto: pagingDto,
                };
                var deferred = $q.defer();
                InvoiceManageService.getInputInvoiceRefundList(invoiceParams).success(function (result) {
                    if (result) {                        
                        // deferred.resolve({ data: result.list, totalCount: result.pageInfo.totalCount });
                        $scope.paging.pagingOptions.totalItems = result.pageInfo && result.pageInfo.totalCount;
                        deferred.resolve(result.list);

                    };

                })
                .error(function () {
                    deferred.reject("Data Loading Error");
                });
                return deferred.promise;

            },
            key: 'id'           
        });
        $scope.invoiceRefundGridOptions = {
            //height:"400px",
            dataSource: {
                store: refundDataSource
            },           
            selection: {
                mode: "multiple",
                //selectAllMode: "page",
                showCheckBoxesMode: "always"
            },
            loadPanel: {
                enabled: false
            },
            paging: {
                enabled: false                
            },
            hoverStateEnabled: true,
            ////dx paging
            //remoteOperations: {
            //    sorting: true,
            //    paging: true
            //},
            //paging: {
            //    enabled: true,
            //    pageSize: 10
            //},
            //pager: {
            //    showPageSizeSelector: true,
            //    allowedPageSizes: [5, 10, 20],
            //    showInfo: false
            //},
            allowColumnResizing: true,
            columnAutoWidth: true,
            showRowLines: true,
            showColumnLines: true,
            rowAlternationEnabled: false,
            showBorders: true,
            noDataText: $translate.instant('NoDataText'),
            onSelectionChanged: function (data) {
                $scope.selectedItem = data.selectedRowsData;
                $scope.selectedItemIDs = _.pluck(data.selectedRowsData, 'id');
                $scope.selectedPlaceholder = data.selectedRowsData.length;
                $scope.disabled = !$scope.selectedItemIDs.length;
            },
            //onRowPrepared: function (info) {
            //    if (info.rowType != 'header' && info.data.status !==4) {
            //        $(info.columns[0]).attr('disabled', true);
            //    }


            //},
            onCellPrepared: function (e) {
                if (e.rowType === "data" & e.column.command === 'select' && e.data.status === constant.inputInvoice.statusType.InvoiceHasRefund.id) {
                    e.cellElement.find('.dx-select-checkbox').hide();
                    e.cellElement.off();
                }
            },
            columns: [
                   {
                       dataField: 'invoiceCode', caption: $translate.instant('InvoiceFPDM'),
                   },
                    { dataField: 'invoiceNumber', caption: $translate.instant('InvoiceFPHM') },
                    { dataField: 'buyerName', caption: $translate.instant('BuyerName') },
                    { dataField: 'buyerTaxNumber', caption: $translate.instant('BuyerTaxNumber') },
                    { dataField: 'sellerName', caption: $translate.instant('SellerName') },
                    { dataField: 'sellerTaxNumber', caption: $translate.instant('SellerTaxNumber') },
                    { dataField: 'totalPriceLowerCase ', caption: $translate.instant('FaceTaxAmount') }, //税额合计小写
                    { dataField: 'taxAmount', caption: $translate.instant('InvoiceSE') },  //税额
                    { dataField: 'invoiceDate', caption: $translate.instant('InvoiceDate') }, //开票日期
                    {
                        dataField: 'invoiceEntityType', caption: $translate.instant('InvoiceEntity'),
                        calculateDisplayValue: function (data) {
                            return $translate.instant(data.invoiceEntityTypeString);
                        }
                    },
                    {
                        dataField: 'invoiceType', caption: $translate.instant('InvoiceFPLX'),
                        calculateDisplayValue: function (data) {
                            return $translate.instant(data.invoiceTypeString);
                        }

                    },
                    {
                        dataField: 'UploadType', caption: $translate.instant('InvoiceModeWay'),
                        calculateDisplayValue: function (data) {
                            return $translate.instant(data.uploadTypeString);
                        }

                    },
                    { dataField: 'uploadDate', caption: $translate.instant('UploadDate') },
                    {
                        dataField: 'invoiceSourceType', caption: $translate.instant('InvoiceSource'),
                        calculateDisplayValue: function (data) {
                            return $translate.instant(data.invoiceSourceTypeString);
                        }
                    }, //发票来源
                    {
                        dataField: 'status', caption: $translate.instant('InvoiceStatus'),
                        calculateDisplayValue: function (data) {
                            return $translate.instant(data.statusString);
                        }
                    }
            ]

        };
    };

    var initDatePicker = function () {
        $('#invoiceDatePicker,#uploadDatepicker').datepicker({
            language: region
        });
    };

    //搜索框初始化
    var initSearchBoxContorls = function () {

        $scope.searchEntity = {};

        var isShowClearButton = true;
        var dxHeight = "30px";
        $scope.searchEntityOptions = {
            //1. 购买方
            selectboxBuyerNameOptions: {
                bindingOptions: {
                    value: 'searchEntity.buyerName',
                },
                placeholder: $scope.pleaseSelect,
                showClearButton: isShowClearButton,
                noDataText: $scope.translated.NoData,
                height: dxHeight
            },
            //2. 销售方
            txtSellerNameBoxOptions: {
                bindingOptions: {
                    value: 'searchEntity.sellerName',
                },
                placeholder: $scope.pleaseInput,
                showClearButton: isShowClearButton,
                height: dxHeight
                //onValueChanged: function (data) {
                //    $scope.searchEntity.sellerName = data.value;
                //}
            },
            //3. 发票号码
            txtInvoiceNumberOptions: {
                bindingOptions: {
                    value: 'searchEntity.invoiceNumber',
                },
                placeholder: $scope.pleaseInput,
                showClearButton: isShowClearButton,
                height: dxHeight
            },
            //4.发票状态，已经上传，已补录。。
            selectstatusOptions: {

                displayExpr: "value",
                valueExpr: "id",
                bindingOptions: {
                    value: 'searchEntity.status',
                    dataSource: 'searchFilterOptions.invoiceStatusList'
                },
                placeholder: $scope.pleaseSelect,
                showClearButton: isShowClearButton,
                noDataText: $scope.translated.NoData,
                height: dxHeight
            },
            //5.开票日期，目前是boostrap控件
            //invoiceDateFrom,invoiceDateTo
            //6.发票来源
            selectinvoiceSourceTypeOptions: {
                displayExpr: "value",
                valueExpr: "id",
                bindingOptions: {
                    value: 'searchEntity.invoiceSourceType',
                    dataSource: 'searchFilterOptions.invoiceSourceList'
                },
                placeholder: $scope.pleaseSelect,
                showClearButton: isShowClearButton,
                noDataText: $scope.translated.NoData,
                height: dxHeight
            },
            //7.发票类型,普票和专票
            selectInvoiceTypeOptions: {
                displayExpr: "value",
                valueExpr: "id",
                bindingOptions: {
                    value: 'searchEntity.invoiceType',
                    dataSource: 'searchFilterOptions.invoiceTypeList'
                },
                placeholder: $scope.pleaseSelect,
                showClearButton: isShowClearButton,
                noDataText: $scope.translated.NoData,
                height: dxHeight
            },
            //8. UploadDate,   upload 日期，目前是boostrap控件, uploadDateFrom,uploadDateTo
            //9. amount
            txtAmountOptions: {
                bindingOptions: {
                    value: 'searchEntity.amount',
                },
                placeholder: $scope.pleaseInput,
                showClearButton: isShowClearButton,
                noDataText: $scope.translated.NoData,
                height: dxHeight
            },
            //10/发票实体，纸票或者电子票
            selectInvoiceEntityTypeOptions: {
                displayExpr:  'value',

                valueExpr: "id",
                bindingOptions: {
                    value: 'searchEntity.invoiceEntityType',
                    dataSource: 'searchFilterOptions.invoiceEntityList'
                },
                placeholder: $scope.pleaseSelect,
                showClearButton: isShowClearButton,
                noDataText: $scope.translated.NoData,
                height: dxHeight
            },
            selectInvoiceUploadOptions: {
                displayExpr: "value",
                valueExpr: "id",
                bindingOptions: {
                    value: 'searchEntity.invoiceUploadType',
                    dataSource: 'searchFilterOptions.invoiceUploadList'
                },
                placeholder: $scope.pleaseSelect,
                showClearButton: isShowClearButton,
                noDataText: $scope.translated.NoData,
                height: dxHeight
            },
            faceTaxFromOptions: {
                bindingOptions: {
                    value: 'searchEntity.AmountFrom'
                },
                height: dxHeight
            },
            faceTaxToOptions: {
                bindingOptions: {
                    value: 'searchEntity.AmountTo'
                },
                height: dxHeight
            }

        };
    };

    //初始化控件
    var initControls = function () {
        initDatePicker();
        initSearchBoxContorls();
        InitInvoiceGrid();
    };

    //初始化数据
    var initData = function () {
        $scope.searchFilterOptions = {};
        getService.getInvoiceFilterBasicData();

        //搜索框的处理
        $scope.hasShowMoreSearchBox =true;
        $scope.searchboxService.showOrHideSearchBox();
    };

    (function initialize() {
        $log.debug('invoiceManageRefundController.ctor()...');
        $scope.disabled = true;
        $scope.showRefundModal = false;
        initControls();
        initData();

    })();
}

]);

invoiceModule.directive('invoiceManageRefund', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('invoiceManageMain.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-refund/invoice-manage-refund.html' + '?_=' + Math.random(),
            scope:
            {
                 
            },
            controller: 'invoiceManageRefundController',
            link: function (scope, element) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var invoiceDataGridSelector = '#invoiceRefundGrid';
                    var pageWrapSelector = ".invoice-manage-refund";
                   // var menuSelector = ".header-title";
                    var contentHeader = pageWrapSelector + ' .header';
                    var contentbody = '.content';
                    var buttonRow = '.content .btn-row';
                    var pageFooter = '.content .page-footer';
                    var dxGridSelector = pageWrapSelector + " .grid-container";

                    var pageHeight = $(document).height();// 810; 
                   // var menuHeight = $(menuSelector).outerHeight();

                    var contentHeaderHeight = $(contentHeader).outerHeight();
                    var buttonRowHeight = $(buttonRow).outerHeight();
                    var pageFooterHeight = $(pageFooter).outerHeight(); //parseInt($(pageFooter).css('height').replace('px', ''));

                    var contentbodyHeight = pageHeight  - contentHeaderHeight-45;
                    var height = contentbodyHeight - buttonRowHeight - pageFooterHeight - 35 + 'px';
                    $(contentbody).css('height', contentbodyHeight + 'px');
                    $(dxGridSelector).css('height', height);
                    $(invoiceDataGridSelector).css('max-height', '100%');

                    try {
                        $(invoiceDataGridSelector).dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };


                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('invoiceManageVerifyController', ['$scope', '$log', '$document', 'SweetAlert', '$uibModal', '$translate', 'uiGridConstants', 'apiInterceptor', '$interval', 'region', 'InvoiceManageService',
        function ($scope, $log, $document, SweetAlert, $uibModal, $translate, uiGridConstants, apiInterceptor, $interval, region, InvoiceManageService) {
            'use strict';
            var initDatePicker = function () {
                $('#invoiceDatepicker').datepicker({
                    language: region,
                    format: $translate.instant('dateFormat4YearMonthDay')
                });
            };
            //页面加载初始化控件
            var initControl = function () {
                initDatePicker();
                $scope.verifyManagement = {
                    buyerNameOptions: {
                        bindingOptions: {
                            dataSource: 'searchFilterOptions.invoiceBuyerList'
                        },
                        displayExpr: "value",
                        valueExpr: "id",
                        placeholder: $translate.instant('ChoosePlaceholder'),
                        showClearButton: true,
                        height: '30px'
                    },
                    textBoxOptions: {
                        height: '30px',
                        placeholder: $translate.instant('InputPlaceholder'),
                    },
                    faceTaxOptions: {
                        //min: 0,
                        value: null,
                        height: '30px'
                    },
                    invoiceTypeOptions: {
                        displayExpr: "value",
                        valueExpr: "id",
                        bindingOptions: {
                            dataSource: 'searchFilterOptions.invoiceTypeList'
                        },
                        placeholder: $translate.instant('ChoosePlaceholder'),
                        showClearButton: true,
                        height: '30px'
                    },
                    buttonQueryOptions: {
                        text: $translate.instant('Query'),
                        //height: 34,
                        //width: 195,
                        onClick: function () {
                            $scope.eventService.refreshTable();
                        }
                    },
                    buttonGetVerifyListOptions: {
                        text: $translate.instant('GetNotVerifyInvoice'),
                        //height: 34,
                        //width: 195,
                        onClick: function () {
                            $scope.NotVerifyManage.getAllNotVerifyList();
                        }
                    },
                    buttonClearOptions: {
                        text: $translate.instant('CertificationClearning'),
                        //height: 34,
                        //width: 195,
                        onClick: function () {
                            $scope.NotVerifyManage.UpdateVerifyList();
                        },
                        bindingOptions: {
                            disabled: "disabled"
                        }
                    },
                    verifyDataGridOptions: {
                        bindingOptions: {
                            'dataSource': 'verifyList'
                        },
                        selection: {
                            mode: "multiple"
                        },
                        hoverStateEnabled: true,
                        noDataText: $translate.instant('NoDataAvailable'),
                        columnAutoWidth: true,
                        showBorders: true,
                        allowColumnResizing: true,
                        onSelectionChanged: function (data) {
                            $scope.selectedItems = data.selectedRowsData;
                            $scope.disabled = !$scope.selectedItems.length;
                        },
                        //pager: {
                        //    showPageSizeSelector: true,
                        //    allowedPageSizes: [5, 10, 20],
                        //    showInfo: false
                        //},
                        //paging: {
                        //    enabled: false,
                        //    pageSize: 10
                        //},
                        columns: [
                                {
                                    dataField: 'invoiceCode', caption: $translate.instant('InvoiceFPDM'),
                                    cellTemplate: 'invoiceCodeTemplate', alignment: 'left'
                                },
                                { dataField: 'invoiceNumber', caption: $translate.instant('InvoiceFPHM') },
                                { dataField: 'buyerName', caption: $translate.instant('BuyerName') },
                                { dataField: 'buyerTaxNumber', caption: $translate.instant('BuyerTaxNumber') },
                                { dataField: 'sellerName', caption: $translate.instant('SellerName') },
                                { dataField: 'sellerTaxNumber', caption: $translate.instant('SellerTaxNumber') },
                                { dataField: 'totalPriceLowerCase', caption: $translate.instant('FaceTaxAmount') },
                                { dataField: 'taxAmount', caption: $translate.instant('InvoiceSE') },
                                { dataField: 'invoiceDate', caption: $translate.instant('InvoiceDate') },
                                { dataField: 'invoiceEntityType', caption: $translate.instant('InvoiceEntity') },
                                { dataField: 'invoiceType', caption: $translate.instant('InvoiceFPLX') }
                        ],
                        showInvoiceTable: function (invoice) {
                            $scope.selectedInvoice = invoice.data;
                            $scope.verifyManagement.verifyDataGridOptions.thisModalService.open();
                        },
                        thisModalService: {
                            modalInstance: null,
                            open: function () {
                                var parentSelector = '.invoice-manage-verify';
                                var parentElem = parentSelector ? angular.element($document[0].querySelector(parentSelector)) : undefined;

                                var modalInstance = $uibModal.open({
                                    animation: true,
                                    ariaLabelledBy: 'modal-title',
                                    ariaDescribedBy: 'modal-body',
                                    templateUrl: 'invoiceTable.html',
                                    windowClass: 'invoice-table-dialog',
                                    scope: $scope,
                                    appendTo: parentElem,
                                });

                                $scope.verifyManagement.verifyDataGridOptions.thisModalService.modalInstance = modalInstance;
                            },
                            close: function (result) {
                                if ($scope.verifyManagement.verifyDataGridOptions.thisModalService.modalInstance) {
                                    $scope.verifyManagement.verifyDataGridOptions.thisModalService.modalInstance.close(result);
                                }
                            },
                            cancel: function () {
                                if ($scope.verifyManagement.verifyDataGridOptions.thisModalService.modalInstance) {
                                    $scope.verifyManagement.verifyDataGridOptions.thisModalService.modalInstance.dismiss('cancel');
                                }
                            }

                        }
                    }
                };

            };

            //页面加载初始化数据
            var initData = function () {
                $scope.searchFilterOptions = {};
                $scope.NotVerifyManage.getVerifyFilterBasicData();
              //  $scope.paging.populatePagingSelection();
                $scope.fullData = [
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉南京工厂",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "XX玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 137310.07,
     "taxAmount": 23342.71,
     "invoiceDate": "2017-04-10",
     "invoiceEntityType": "电子票",
     "invoiceType": "普票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "原料采购",
     "invoiceStatus": "已补录",
     "invoiceName": "上海增值税普通发票",
     "totalPriceUpperCase": "四百壹拾柒元整",
    
     "items": [
         {
             productionName: "餐饮费", specification: "", unit: "项", quantity: 1, unitPrice: 404.85437,
             amount: 404.85437, taxRate: 0.03, taxAmount: 12.15,
         },
         {
             productionName: "住宿费", specification: "", unit: "项", quantity: 2, unitPrice: 404.85437,
             amount: 404.85437, taxRate: 0.03, taxAmount: 12.15,
         },
         {
             productionName: "交通及电话费用", specification: "", unit: "项", quantity: 3, unitPrice: 404.85437,
             amount: 404.85437, taxRate: 0.03, taxAmount: 12.15,
         },
     ]
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉南京工厂",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "XX玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 137310.07,
     "taxAmount": 23342.71,
     "invoiceDate": "2017-4-10",
     "invoiceEntityType": "电子票",
     "invoiceType": "普票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "原料采购",
     "invoiceStatus": "待匹配"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉南京工厂",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "XX玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 137310.07,
     "taxAmount": 23342.71,
     "invoiceDate": "2017-4-10",
     "invoiceEntityType": "电子票",
     "invoiceType": "普票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "原料采购",
     "invoiceStatus": "已匹配"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉南京工厂",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "XX玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 49,
     "taxAmount": 8.33,
     "invoiceDate": "2016-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "专票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "非原料集中采购",
     "invoiceStatus": "识别成功"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉镇江工厂",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "XX玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 25,
     "taxAmount": 4.25,
     "invoiceDate": "2016-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "专票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "非原料集中采购",
     "invoiceStatus": "已清理"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉镇江工厂",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "XX玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 295,
     "taxAmount": 50.15,
     "invoiceDate": "2016-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "专票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "非原料集中材料",
     "invoiceStatus": "无法识别"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉镇江工厂",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "嘉吉有限公司",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 36,
     "taxAmount": 6.12,
     "invoiceDate": "2016-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "普票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "原料采购",
     "invoiceStatus": "待匹配"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉有限公司",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "嘉吉南京工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 25,
     "taxAmount": 4.25,
     "invoiceDate": "2016-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "普票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "原料采购",
     "invoiceStatus": "验真失败"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉有限公司",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "哈哈玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 4870,
     "taxAmount": 827.9,
     "invoiceDate": "2017-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "普票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "非原料集中采购",
     "invoiceStatus": "待匹配"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉有限公司",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "uu玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 295,
     "taxAmount": 50.15,
     "invoiceDate": "2017-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "专票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "非原料集中材料",
     "invoiceStatus": "已认证"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉有限公司",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "XX玉米加工厂",
     "sellerTaxNumber": 660260601108002,
     "totalPriceLowerCase": 18230.98,
     "taxAmount": 3099.27,
     "invoiceDate": "2017-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "专票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "原料采购",
     "invoiceStatus": "无法认证"
 },
 {
     "invoiceCode": 1101432450,
     "invoiceNumber": 60118002,
     "buyerName": "嘉吉有限公司",
     "buyerTaxNumber": 660200601108002,
     "sellerName": "XX玉米加工厂",
     "sellerTaxNumber": 660200601108002,
     "totalPriceLowerCase": 18230.98,
     "taxAmount": 3099.27,
     "invoiceDate": "2017-4-10",
     "invoiceEntityType": "纸票",
     "invoiceType": "专票",
     "uploadDate": "2017-5-6",
     "invoiceSource": "原料采购",
     "invoiceStatus": "待认证 "
 }
                ];

                $scope.verifyList = $scope.fullData;
                $scope.paging.pagingOptions.totalItems = $scope.verifyList.length;
            };
            //内部处理
            var memoryService = {
                translateDictionary: function (list) {
                    _.each(list, function (item) {
                        item.value = $translate.instant(item.value);

                    });
                },
                copyDataFromFull: function () {
                    return angular.copy($scope.fullData);
                }
            };
            //button的事件
            $scope.eventService = {
                refreshTable: function () {
                    //
                    //var grid = $('#verifyManagementGrid').dxDataGrid('instance');
                    //grid.clearSelection();
                    // grid.refresh(); 
                    var allData = $scope.NotVerifyManage.queryList();
                    $scope.paging.pagingOptions.totalItems = allData.length;
                    if (allData.length > 0) {
                        var pageSize = $scope.paging.pagingOptions.pageSize;
                        var pageIndex = $scope.paging.pagingOptions.pageIndex;
                        $scope.verifyList = _.filter(allData, function (item, index) {
                            return (pageIndex - 1) * pageSize <= index && index < pageIndex * pageSize;
                        });
                        
                    }else
                    {
                        $scope.verifyList = [];                       
                    }
                },


            };
            //分页的设置
            $scope.paging = {
                pagingOptions: {
                    pageIndex: 1,  //当前页码
                    totalItems: 100,  //总数据
                    totalPages: 10,//总页数
                    maxSize: 10, //分页数字的限制。
                    pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
                    pageSizeString: constant.page.pageSizeArrary[1].toString(),
                },
            };
            //同一个控件的所有操作最好放在一个$scope函数里
            //例如工作流，有添加工作流，修改，删除，添加（删除）用户，添加（删除）角色
            $scope.NotVerifyManage = {
                getAllNotVerifyList: function () {

                },
                updateVerifyList: function () {
                    //$.each($scope.selectedItems, function () {
                    //    $scope.verifyList.remove(this);
                    //});
                    $("#verifyManagementGrid").dxDataGrid("instance").refresh();
                },               
                queryList: function (allData) {
                    var queryAvailableList = memoryService.copyDataFromFull();
                    _.each($scope.query, function (item, key) {
                        if (item) {                           
                            switch (key) {
                                case "buyerNameQuery":                                   
                                    queryAvailableList = _.where(queryAvailableList, { buyerName: item });
                                    break;
                                case "sellerNameQuery":                                   
                                    queryAvailableList = _.filter(queryAvailableList, function (record) {
                                        return record.sellerName.indexOf(item) > -1;
                                    });
                                    break;
                                case "invoiceDateQueryStart":
                                    queryAvailableList = _.filter(queryAvailableList, function (record) {
                                        return record.invoiceDate>=item;
                                    });
                                    break;
                                case "invoiceDateQueryEnd":
                                    queryAvailableList = _.filter(queryAvailableList, function (record) {
                                        return record.invoiceDate <= item;
                                    });
                                    break;
                                case "totalPriceLowerCaseStartQuery":                                   
                                    queryAvailableList = _.filter(queryAvailableList, function (record) {
                                        return record.totalPriceLowerCase >= item;
                                    });
                                    break;
                                case "totalPriceLowerCaseEndQuery":
                                    queryAvailableList = _.filter(queryAvailableList, function (record) {
                                        return record.totalPriceLowerCase <= item;
                                    });
                                    break;
                                case "invoiceNumberQuery":                                   
                                    queryAvailableList = _.filter(queryAvailableList, function (record) {
                                        return record.invoiceNumber.indexOf(item) > -1;
                                    });
                                    break;
                                case "invoiceTypeQuery":                                   
                                    queryAvailableList = _.where(queryAvailableList, { invoiceType: item });                                   
                                    break;

                            }
                           
                        }
                    });
                    return queryAvailableList;
                },
                getVerifyFilterBasicData: function () {
                    InvoiceManageService.getVerifyFilterBasicData().success(function (res) {
                        if (res.result) {
                            memoryService.translateDictionary(res.data.invoiceTypeList);
                            $scope.searchFilterOptions.invoiceTypeList = res.data.invoiceTypeList;
                        }
                    }).error(function () {
                        SweetAlert.error('', $translate.instant('CommonFail'));
                    });
                }
            };
            $scope.query = {
                buyerNameQuery: null,
                sellerNameQuery: null,
                invoiceDateQueryStart: null,
                invoiceDateQueryEnd: null,
                totalPriceLowerCaseStartQuery: null,
                totalPriceLowerCaseEndQuery: null,
                invoiceNumberQuery: null,
                invoiceTypeQuery: null
            };
            (function initialize() {
                $log.debug('invoiceManageVerifyController.ctor()...');
                $scope.selectedItems = [];
                $scope.disabled = true;
                $scope.selectedInvoice = null;
                $scope.fullData = [];
                initData();
                initControl();
            })();

        }
]);

invoiceModule.directive('invoiceManageVerify', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('invoiceManageMain.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/invoice/invoice-manage-verify/invoice-manage-verify.html' + '?_=' + Math.random(),
            scope:
            {
                 
            },
            controller: 'invoiceManageVerifyController'
        };
    }
]);
invoiceModule.controller('amountCheckManualInputController', ['$scope', '$log', '$timeout', '$translate',
    'messagebox', 'vatOutputInvoiceManageService',
function ($scope, $log, $timeout, $translate, messagebox, vatOutputInvoiceManageService) {

    var initControls = function () {
        $scope.configOptions = {
            finalAmountOption: {
                width: "100%",
                //placeholder: $translate.instant("InputPlaceholder"),
                bindingOptions: {
                    value: 'editModel.finalAmount'
                },
                onFocusIn: function () {
                    if ($scope.editModel.finalAmount && !isNaN($scope.editModel.finalAmount.replace(/,/g, '')) && $scope.editModel.finalAmount != 'NaN') {
                        $scope.editModel.finalAmount = $scope.editModel.finalAmount.replace(/,/g, '');
                    }
                },
                onFocusOut: function () {
                    if (!isNaN($scope.editModel.finalAmount) && $scope.editModel.finalAmount != 'NaN') {
                        $scope.editModel.finalAmount = ($scope.editModel.finalAmount * 1).formatAmount(2);
                    }
                },
                onInitialized: function () {
                    if ($scope.editModel.finalAmount && !isNaN($scope.editModel.finalAmount) && $scope.editModel.finalAmount != 'NaN') {
                        $scope.editModel.finalAmount = ($scope.editModel.finalAmount * 1).formatAmount(2);
                    }
                }
            },
            reasonOption: $scope.reasonDataSource
        };

        $scope.validateOption = {};
        $scope.validateOption.finalAmountOption = {
            validationRules: [{
                type: "required",
                message: $translate.instant('FinalAmountRequired')
            }, {
                type: 'custom',
                validationCallback: $scope.checkFinalAmountCustom
            }]
        };
    };

    $scope.checkFinalAmountCustom = function (options) {
        if (isNaN(options.value.replace(/,/g, '')) || options.value == 'NaN') {
            options.rule.message = $translate.instant('FinalAmountShouldBeNumber');
            return false;
        } else if (options.value.replace(/,/g, '') * 1 <= 0 || options.value.replace(/,/g, '') * 1 >= $scope.invoiceQuota / 1.17) {
            options.rule.message = $translate.instant('FinalAmountRangeCheck');
            return false;
        } else {
            return true;
        }
    }

    //关闭弹窗口
    $scope.hidePopPanel = function () {
        $scope.$parent.isOpen = false;
        $scope.$dismiss({ $value: 'cancel' });
    };

    var tempValue = "";
    $scope.checkFinalAmountKeyUp = function () {
        if ($scope.isShowInput && isNaN($scope.editModel.finalAmount)) {
            $scope.editModel.finalAmount = tempValue;
            return;
        } else {
            tempValue = $scope.editModel.finalAmount;
        }
    };

    
    $scope.checkFinalAmountKeyPress = function () {
        if ($scope.isShowInput && isNaN($scope.editModel.finalAmount)) {
            $scope.editModel.finalAmount = tempValue;
            return;
        }
    };

    //保存
    $scope.saveManualInput = function () {
        var dxResult = DevExpress.validationEngine.validateGroup($('#finalAmountForm').dxValidationGroup("instance")).isValid;
        if (!dxResult) {
            return;
        }

        if (_.isEmpty($scope.editModel.reasonList)) {
            messagebox.warning('ReasonRequired');
            return;
        }

        var reasonList = _.chain($scope.editModel.reasonList).pairs().filter(function (x) {
            return x[1] === true;
        }).pluck('0').value();

        if (_.isEmpty(reasonList)) {
            messagebox.warning('ReasonRequired');
            return;
        }

        if (_.isEmpty($scope.editModel.evidenceFiles)) {
            messagebox.warning('EvidenceFilesRequired');
            return;
        }

        $scope.$parent.model.manualInput = {
            finalAmount: $scope.editModel.finalAmount.replace(/,/g, ''),
            reasonList: reasonList,
            evidenceFiles: $scope.editModel.evidenceFiles
        };
        
        if ($scope.isShowInput) {
            $scope.$parent.model.finalAmount = Number(Number($scope.editModel.finalAmount.replace(/,/g, '')).toFixed(2));
        } else {
            $scope.$parent.model.finalAmount = $scope.$parent.model.shipmentAmount;
        }
        if (_.isFunction($scope.refreshParent)) {
            $scope.refreshParent();
        }
        $scope.$parent.isOpen = false;
        $scope.$dismiss({ $value: 'cancel' });
    };

    $scope.$watch('$parent.$parent.$parent.uploadFileOption.files', function (newValue, oldValue) {
        if (newValue && newValue != oldValue) {
            $scope.editModel.evidenceFiles = $scope.$parent.$parent.$parent.uploadFileOption.files;
        }
    });

    //上传文件
    $scope.uploadFile = function () {
        $scope.$parent.$parent.$parent.uploadFileType = 'multiple';
        $scope.$parent.$parent.$parent.uploadFileOption = {
            title: 'Upload Evidence Document',
            uploadButtonText: 'Select Upload Files',
            files: $scope.editModel.evidenceFiles || []
        };
    }

    //删除证据文件
    $scope.deleteEvidenceFile = function (fileId) {
        var fileList = [fileId];
        vatOutputInvoiceManageService.deleteEvidenceFile(fileList).then(function () {
            $scope.$parent.$parent.$parent.uploadFileOption.files = _.filter($scope.$parent.$parent.$parent.uploadFileOption.files, function (item) {
                return item.data.fileID != fileId;
            });
        });
    }

    $scope.$watch('model', function (newVal, oldVal) {
        if (newVal.manualInput && !_.isEmpty(newVal.manualInput.reasonList)) {
            $scope.editModel.finalAmount = newVal.manualInput.finalAmount;
            $scope.editModel.reasonList = {};
            //for (var i = 0; i < newVal.manualInput.reasonList.length; i++) {
            //    //$scope.editModel.reasonList[newVal.manualInput.reasonList[i]] = true;
            //    $scope.editModel.selectedReasonId = newVal.manualInput.reasonList[0];
            //}
            $scope.editModel.selectedReasonId = newVal.manualInput.reasonList[0];
            $scope.editModel.evidenceFiles = newVal.manualInput.evidenceFiles;
            $scope.isShowInput = $scope.editModel.reasonList[$scope.configOptions.reasonOption[0].id] || $scope.editModel.reasonList[$scope.configOptions.reasonOption[2].id];
            //$scope.editModel.evidenceFiles = null;
        }
        else {
            $scope.editModel = {
                finalAmount: '',
                reasonList: {},
                evidenceFiles: null
            };
        }
    });

    $scope.isShowInput = false;
    $scope.toggleInput = function (reasonName, id) {
        for (var key in $scope.editModel.reasonList) {
            $scope.editModel.reasonList[key] = false;
        }
        $scope.editModel.reasonList[id] = true;
        $scope.isShowInput = $scope.editModel.reasonList[$scope.configOptions.reasonOption[0].id] || $scope.editModel.reasonList[$scope.configOptions.reasonOption[3].id];
    };

    (function initialize() {
        $log.debug('amountCheckManualInputController.ctor()...');
        $scope.editModel = {
            finalAmount: '',
            reasonList: {},
            evidenceFiles: null
        };

        vatOutputInvoiceManageService.getInvoiceQuota().then(function (data) {
            if (data && data.data && data.data.data) {
                $scope.invoiceQuota = data.data.data;
            } else {
                $scope.invoiceQuota = 10000000;
            }
        });

        initControls();
    })();
}]);
invoiceModule.directive('amountCheckManualInput', ['$log', '$document', '$uibModal',
function ($log, $document, $uibModal) {
    'use strict';

    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/amount-check-manual-input/amount-check-manual-input.html' + '?_=' + Math.random(),
        scope:
        {
            isOpen: '=',
            reasonDataSource: '=',
            model: '=',
            parentElement: "@",
            refreshParent:"&"
        },
        link: function (scope, element) {
            $log.debug('amountCheckManualInput.ctor()...');

            scope.$watch('isOpen', function (newVal, oldVal) {
                if (newVal) {
                    scope.eventService.open();
                }
            });

            var parentElement = scope.parentElement
                ? $document[0].querySelector(scope.parentElement) : element[0];

            scope.eventService = {
                open: function () {
                    var modalInstance = $uibModal.open({
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        backdrop: 'static',
                        templateUrl: 'amount-check-manual-input-template.html',
                        controller: 'amountCheckManualInputController',
                        windowClass: 'amount-check-manual-input-popup center-popup',
                        appendTo: angular.element(parentElement),
                        scope: scope
                    });
                }
            };
        }
    };
}]);
invoiceModule.controller('bdViewByVINController', ['$log', '$timeout', '$scope', '$translate', 'vatOutputInvoiceManageService',
    'SweetAlert', 'enums', 'modalAdapterService', '$document', '$uibModal', "$q",
    function ($log, $timeout, $scope, $translate, vatOutputInvoiceManageService, SweetAlert, enums,
        modalAdapterService, $document, $uibModal, $q) {

        //Define the globle Variable of the page. -->start
        var dateFormat = 'yyyy-MM-dd';
        var isShowClearButton = true;
        var revertStatusList = _.invert(enums.GDBDStatusEnum);
        var revertGDStatusList = _.invert(enums.GDInvoiceStatusEnum);
        $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
        $scope.pleaseInput = $translate.instant('InputPlaceholder');
        $scope.noDataText = $translate.instant('NoDataText');
        $scope.masterDetailHeader = {
            invoiceNo: $translate.instant('InvoiceNo'),
            invoiceCode: $translate.instant('InvoiceCode'),
            invoiceCaseNum: $translate.instant('InvoiceCase'),
            issuedDate: $translate.instant('IssuedDate'),
            buyer: $translate.instant('Buyer'),
            amount: $translate.instant('Amount'),
            taxAmount: $translate.instant('TaxAmount'),
            totalAmount: $translate.instant('TotalAmount'),
            gdStatus: $translate.instant('GDStatus'),
            status: $translate.instant('Status')
        };

        $scope.pagingOptions = {
            pageIndex: 1,  //当前页码
            totalItems: 0,  //总数据
            pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
        };

        $scope.bdVinSearchEntity = {};
        $scope.selectedIssuedInvoiceCount = 0;
        $scope.selectedIssuedInvoiceAmount = 0;
        //Define the globle Variable of the page. -->end

        
        $scope.searchOptions = {
            //The define of search field. -->start
            InvoiceNo:{
                width: "100%",
                placeholder: $translate.instant('InputPlaceholder'),
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'bdVinSearchEntity.invoiceNo',
                }
            },
            VIN:{
                width: "100%",
                placeholder: $translate.instant('InputPlaceholder'),
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'bdVinSearchEntity.VIN',
                }
            },
            InvoiceCode: {
                width: "100%",
                placeholder: $translate.instant('InputPlaceholder'),
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'bdVinSearchEntity.invoiceCode',
                }
            },
            VehicleModel:{
                width: "100%",
                placeholder: $translate.instant("ChoosePlaceholder"),
                showClearButton: isShowClearButton,
                displayExpr: 'name',
                valueExpr: 'id',
                //items: ['Salesforce', 'Smart Tax', 'Local'],
                bindingOptions: {
                    value: 'bdVinSearchEntity.vehicleModel',
                    dataSource: 'VehicleModelNameList'
                }
            },
            CaseNumber: {
                width: "100%",
                placeholder: $translate.instant('InputPlaceholder'),
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'bdVinSearchEntity.caseNumber',
                }
            },//The define of search field. -->end
            

            //The define of Grid options. -->start
            bdVinGridOptions: {
                bindingOptions: {
                    dataSource: 'vinList',
                    'height': 'height'
                },
                keyExpr: 'vin',
                noDataText: $scope.noDataText,
                columnAutoWidth: true,
                showRowLines: true,
                showBorders: true,
                columnChooser: {
                    enabled: true
                },
                paging: {
                    enabled: false
                },
                columns: [
                    { dataField: 'vin', caption: $translate.instant('VIN'), allowHeaderFiltering: false },
                    { dataField: 'vehicleModel', caption: $translate.instant('VehicleModel'), allowHeaderFiltering: false },
                    { dataField: 'count', caption: $translate.instant('InvoiceCount'), allowHeaderFiltering: false },
                    {
                        dataField: 'totalTaxAmount', caption: $translate.instant('DrilldownTotalTaxAmount'),
                        format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                    },
                    {
                        dataField: 'totalEffectiveAmount', caption: $translate.instant('TotalEffectiveAmount'),
                        format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                    },
                ],
                masterDetail: {
                    enabled: true,
                    template: "gdInvoiceTemplate"
                },
                bdView: function (bdInvoices) {
                    bdInvoices.forEach(function (item) {
                        item.invoiceNo = item.invoiceNumber;
                        item.invoiceCase = '';
                        item.issuedDate = item.bdIssuedDate ? (new Date(item.bdIssuedDate)).dateTimeToString('yyyyMMdd') : '';
                        item.caseCollectionDate = item.caseCollectionDate ? (new Date(item.caseCollectionDate)).dateTimeToString('yyyyMMdd') : '';
                        item.issuranceType = $translate.instant(PWC.getEnumKeyByValue(enums.IssuanceType, item.issuranceType));
                        if (!item.cabinConfiguration) {
                            item.cabinConfiguration = $translate.instant('FiveSeatInterior');
                        }
                    });
                    return {
                        keyExpr: 'id',
                        dataSource: bdInvoices,
                        noDataText: $scope.noDataText,
                        columnAutoWidth: true,
                        selection: {
                            mode: 'multiple',
                            showCheckBoxesMode: 'always'
                        },
                        onSelectionChanged: function (e) {
                            if (e && e.selectedRowsData) {
                                $scope.selectedIssuedInvoiceCount = e.selectedRowsData.length;
                                $scope.selectedIssuedInvoiceData = e.selectedRowsData;
                                var amount = 0;
                                _.each(e.selectedRowsData, function (item) {
                                    if (item.subtotalforFinalPayment) {
                                        amount += item.subtotalforFinalPayment;
                                    }
                                });
                                $scope.selectedIssuedInvoiceAmount = amount.formatAmount(2);
                            }
                        },
                        showBorders: true,
                        columns: [
                          { dataField: 'invoiceNo', caption: $scope.masterDetailHeader.invoiceNo, allowHeaderFiltering: false },
                          { dataField: 'invoiceCode', caption: $scope.masterDetailHeader.invoiceCode, allowHeaderFiltering: false },
                          { dataField: 'caseNumber', caption: $scope.masterDetailHeader.invoiceCaseNum, allowHeaderFiltering: false },
                          {
                              dataField: 'issuedDate', caption: $scope.masterDetailHeader.issuedDate,
                              dataType: 'date', format: dateFormat, allowHeaderFiltering: false
                          },
                          { dataField: 'registrationLocalName', caption: $scope.masterDetailHeader.buyer, allowHeaderFiltering: false },
                          {
                              dataField: 'excludeTaxPrice', caption: $scope.masterDetailHeader.amount,
                               format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                          },
                          {
                              dataField: 'vatTax', caption: $scope.masterDetailHeader.taxAmount,
                              format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                          },
                          {
                              dataField: 'subtotalforFinalPayment', caption: $scope.masterDetailHeader.totalAmount,
                               format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                               //calculateDisplayValue: function (rowData) {
                               //    var r = 0;
                               //    if (_.isNumber(rowData.subtotalforFinalPayment)) {
                               //        r += rowData.subtotalforFinalPayment;
                               //    }
                               //    if (_.isNumber(rowData.taxableSubtotal)) {
                               //        r += rowData.taxableSubtotal;
                               //    }
                               //    return r;
                               //}
                           },
                           {
                                dataField: 'bdStatus', caption: $scope.masterDetailHeader.status,
                                calculateDisplayValue: function (rowData) {
                                    return $translate.instant(PWC.getEnumKeyByValue(enums.BDStatusEnum, rowData.bdStatus));
                                }
                           },
                           {
                                caption: $translate.instant('Action'), alignment: 'left', cellTemplate: function (ele, info) {
                                    $('<a/>').css({ 'color': '#6699cc', 'cursor': 'pointer' }).text($translate.instant('View')).on('dxclick', function () {
                                        $scope.invoiceOperateType = constant.Operation.Query;
                                        $scope.invoiceModel = info.data;
                                    }).appendTo(ele);

                                    var checkDateStart = new Date().dateAdd('d', -1 * (new Date().getDate() + 180)).dateTimeToString('yyyyMMdd');
                                    var checkDateEnd = new Date().dateAdd('d', -1 * new Date().getDate()).dateTimeToString('yyyyMMdd');
                                    if (info.data.bdStatus != enums.BDStatusEnum.RedLettered && info.data.bdStatus != enums.BDStatusEnum.Cancelled &&
                                        info.data.issuedDate >= checkDateStart && info.data.issuedDate <= checkDateEnd) {
                                        var element = $('<a/>');
                                        element.css({ 'color': '#6699cc', 'cursor': 'pointer', 'margin-left': '10px' }).text($translate.instant('Red Letter')).on('dxclick', function () {
                                            $scope.redLetterBdUserInvoice(info.data, element);
                                        }).appendTo(ele);
                                    }
                                }
                            }]

                    };

                }
            }//The define of Grid options. -->end
        };

        //Red letter BD-User fapiao. -->start
        $scope.redLetterBdUserInvoice = function (data, element) {

            var redLetterBdUserPopController = function ($scope) {
                $scope.redLetterData = {};
                $scope.redLetterData.needReasonRdio = 1;

                $scope.redLetterData.inputReasonOption = {
                    width: '100%',
                    height: 60,
                    bindingOptions: {
                        value: 'redLetterData.inputReason'
                    }
                };
                $scope.validateOption = {};
                $scope.validateOption.inputReasonOption = {
                    validationRules: [{
                        type: "required",
                        message: $translate.instant('BdUserRedLetterWarningInfoInputRequired')
                    }, {
                        type: 'stringLength',
                        max: 500,
                        message: $translate.instant('BdUserRedLetterWarningInfoInputLengthCheck')
                    }]
                };

                var addBdUserRedLetterReason = function (files) {
                    var reasonData = {};
                    reasonData.invoicingReasonIndex = $scope.redLetterData.needReasonRdio;
                    if ($scope.redLetterData.needReasonRdio == 2) {
                        reasonData.inputReason = $scope.redLetterData.inputReason;
                    }
                    reasonData.isRecievingAll = $scope.redLetterData.isRevievingAll ? 1 : 0;
                    reasonData.invoiceID = data.id;
                    reasonData.caseNumber = data.caseNumber;

                    //用户首字母大写
                    var tmpChar = loginContext.userName.substring(0, 1).toUpperCase();
                    var postString = loginContext.userName.substring(1, loginContext.userName.length);
                    var tmpStr = tmpChar + postString;
                    reasonData.createBy = tmpStr;

                    //设置附件
                    if (files && files.length > 0) {
                        var fileIds = [];
                        _.each(files, function (item) {
                            fileIds.push(item.data.fileID);
                        });
                        reasonData.evidenceDocuments = fileIds.join(',');
                    }

                    var deffered = $q.defer();
                    vatOutputInvoiceManageService.addBdUserRedLetterReason(reasonData).success(function (data) {
                        deffered.resolve(data);
                    });
                    return deffered.promise;
                };

                //BD红冲检查。
                var checkDataAvailable = function (files) {
                    if ($scope.redLetterData.needReasonRdio == 2) {

                        var dxResult = DevExpress.validationEngine.validateGroup($('#reasonModalForm').dxValidationGroup("instance")).isValid;
                        if (!dxResult) {
                            return;
                        }

                        if (!$scope.redLetterData.inputReason) {
                            SweetAlert.warning($translate.instant('BdUserRedLetterWarningInfoInputRequired'));
                            return false;
                        } else if ($scope.redLetterData.inputReason.length > 500) {
                            SweetAlert.warning($translate.instant('BdUserRedLetterWarningInfoInputLengthCheck'));
                            return false;
                        }
                    }
                    if (!files || files.length < 1 || !$scope.redLetterData.isRevievingAll) {
                        //检查证明文件
                        if (!files || files.length < 1) {
                            $('#UploadFileCheckTipId').show();
                        } else {
                            $('#UploadFileCheckTipId').hide();
                        }
                        if (!$scope.redLetterData.isRevievingAll) {
                            $('#CancelDialogTextTipId').show();
                        } else {
                            $('#CancelDialogTextTipId').hide();
                        }
                        return false;
                    } else {
                        $('#UploadFileCheckTipId').hide();
                        $('#CancelDialogTextTipId').hide();
                    }
                    return true;
                };

                $scope.$watch('$parent.uploadFileOption.files', function (newValue, oldValue) {
                    if (newValue && newValue != oldValue) {
                        var files = $scope.$parent.uploadFileOption.files;
                    }
                });

                //上传文件
                $scope.uploadFile = function () {
                    $scope.$parent.uploadFileType = 'multiple';
                    $scope.$parent.uploadFileOption = {
                        title: 'Upload Evidence Document',
                        uploadButtonText: 'Select Upload Files',
                        files: $scope.$parent.uploadFileOption.files || []
                    };
                }

                //关闭弹窗口
                $scope.hidePopPanel = function () {
                    $scope.$parent.uploadFileOption = {};
                    $scope.$dismiss({ $value: 'cancel' });
                };

                //删除证据文件
                $scope.deleteEvidenceFile = function (fileId) {
                    var fileList = [fileId];
                    vatOutputInvoiceManageService.deleteEvidenceFile(fileList).then(function () {
                        $scope.$parent.uploadFileOption.files = _.filter($scope.$parent.uploadFileOption.files, function (item) {
                            return item.data.fileID != fileId;
                        });
                    });
                }

                //下载证据文件
                $scope.downloadEvidenceFile = function (data) {
                    var queryDto = {};
                    queryDto.fileName = data.fileName;
                    queryDto.filePath = data.filePath;
                    vatOutputInvoiceManageService.downloadEvidenceFile(queryDto);
                };

                //执行红冲发票
                $scope.confirmRedLetterInvoice = function (files) {
                    if (checkDataAvailable(files)) {
                        //调用红冲接口
                        vatOutputInvoiceManageService.redLetterInvoice(data.id).then(function () {
                            //保存红冲原因及附件。
                            var promise = addBdUserRedLetterReason(files);
                            promise.then(function (data) {
                                //红冲结束隐藏红冲按钮。
                                element.hide();
                                $scope.$parent.uploadFileOption = {};
                                $scope.$dismiss({ $value: 'cancel' });
                                $scope.eventService.refreshInvoiceDataGrid();
                            });
                        });
                    }
                };

            };

            var parentElem = angular.element($document[0].querySelector('#red-letter-bd-user-pop'));
            var modalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'red-letter-bd-user-page.html',
                controller: redLetterBdUserPopController,
                windowClass: 'data-table',
                appendTo: parentElem,
                scope: $scope
            });
        };//Red letter BD-User fapiao. -->end

        $scope.cancelCore = function () {
            //调用取消发票接口执行取消发票功能。
            var promiss = [];
            var data = $scope.selectedIssuedInvoiceData;
            _.each(data, function (item) {
                var cancelPromiss = vatOutputInvoiceManageService.cancelInvoice(item.id, $scope.isReprint);
                promiss.push(cancelPromiss);
            });
            $q.all(promiss).then(function () {
                modalAdapterService.close(constant.OutputInvoiceCancalDialog, "bd-vin-view");
                $scope.eventService.refreshInvoiceDataGrid();
            });
        };

        //取消发票
        $scope.CancelInvoice = function (data, reprint) {
            if (!data || data.length < 1) {
                SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                return;
            }

            //已红冲和已取消的发票不能再做取消操作。
            var canCancelDatas = [];
            var negativeDatas = [];
            _.each(data, function (item) {
                if (item.bdStatus == enums.BDStatusEnum.Cancelled || item.bdStatus == enums.BDStatusEnum.RedLettered) {
                    canCancelDatas.push(item);
                }
            });

            _.each(data, function (item) {
                if (item.subtotalforFinalPayment < 0) {
                    negativeDatas.push(item);
                }
            });
            if (canCancelDatas.length > 0) {
                SweetAlert.warning($translate.instant('BDFapiaoCancelCheck')
                    .replace('{0}', _.pluck(canCancelDatas, 'invoiceNumber').join(',')));
                return;
            }

            if (negativeDatas.length > 0) {
                SweetAlert.warning($translate.instant('NegativeFapiaoCheck')
                    .replace('{0}', _.pluck(negativeDatas, 'invoiceNumber').join(',')));
                return;
            }

            $scope.title = reprint ? $translate.instant("CancelReprintInvoiceBDTitle") : $translate.instant("CancelInvoiceBDTitle")
            $scope.isReprint = reprint ? reprint : false;
            modalAdapterService.open(constant.OutputInvoiceCancalDialog, "bd-vin-view");
        };

        //The define of page event. -->start
        $scope.eventService = {
            refreshInvoiceDataGrid: function () {
                var dataDto = {
                    queryParam: $scope.bdVinSearchEntity,
                    pagingParam: $scope.pagingOptions
                }
                vatOutputInvoiceManageService.getBDDetailGroupByVIN(dataDto).success(function (response) {
                    $scope.vinList = response.list;
                    $scope.pagingOptions.totalItems = response.pageInfo.totalCount;
                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },

            toggleSearchContent: function () {
                if ($("#toggle-search-tr").css("display") == "none") {
                    $(".hide-search-btn").addClass("fa-angle-up").html('&nbsp;&nbsp;Collapse');
                    $(".hide-search-btn").removeClass("fa-angle-down");
                } else {
                    $(".hide-search-btn").addClass("fa-angle-down").html('&nbsp;&nbsp;Expand');
                    $(".hide-search-btn").removeClass("fa-angle-up");
                }
                $("#toggle-search-tr").toggle(200);
                $timeout(function () {
                    $scope.setInvoiceGridHeight();
                }, 300);
            }
        };//The define of page event. -->end

        (function () {
            $scope.eventService.refreshInvoiceDataGrid();
            $scope.hasShowMoreSearchBox = false;
            $scope.uploadFileOption = {};

            //fixed bug 13761, 测试说这个要跟vat drilldown相同。以前是取自printed表，现在改为取自imported表。
            //vatOutputInvoiceManageService.getVehicleModelNameList().success(function (result) {
            //    $scope.VehicleModelNameList = result;
            //});
            vatOutputInvoiceManageService.getModelSeries().success(function (response) {
                if (response && response.length > 0) {
                    $scope.VehicleModelNameList = _.map(response, function (item) {
                        return { id: item, name: item };
                    });
                }
            }).error(function (err) {
                SweetAlert.error('', $translate.instant('CommonFail'));
            });
            //设置表格高度
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 500);
        })();


    }]);
invoiceModule.directive('bdViewByVin', ['$log', function ($log) {
    'use strict';
    $log.debug('BDViewByVIN.ctor()...');
    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/bd-view-by-vin/bd-view-by-vin.html' + '?_=' + Math.random(),
        scope:
        {

        },
        controller: 'bdViewByVINController',
        link: function (scope, element) {
            //计算datagrid的高度
            scope.setInvoiceGridHeight = function () {
                var pageHeight = $(document).height();
                var topTitleHeight = $('.header-title').outerHeight();
                var pageSearchHeight = $('.query-panel').outerHeight();
                var pageFastSearchHeight = $('.data-grid-container').outerHeight();
                var dataGridPagerHeight = $('.page-footer').outerHeight();
                if (dataGridPagerHeight === 0) dataGridPagerHeight = 60;
                var subHeight = pageHeight - topTitleHeight - pageSearchHeight - pageFastSearchHeight - dataGridPagerHeight;
                scope.height = subHeight - 30;

                try {
                    $('#bdVinGrid').dxDataGrid('instance').repaint();
                }
                catch (e) {
                    console.log(e);
                }
            };

            $(window).on('resize', function () {
                scope.setInvoiceGridHeight();
            });
        }
    };
}]);
vatModule.service('outputCommonService', ['$log',
    function ($log) {
        var transferReconciliationSpecial = function (data) {
            if (data && data.startWith('#') && data.endsWith('#')) {
                var t = data.substr(1, data.length - 2);
                return { type: constant.specialText[t], text: t };
            } else {
                return { type: constant.specialText.Other, text: data };
            }
        };
        return {
            transferReconciliationSpecial: transferReconciliationSpecial
        };
}]);
invoiceModule.controller('invoiceDetailVehicleController', ['$log', '$scope', '$translate', '$document', '$uibModal', '$timeout',
    'vatOutputInvoiceManageService', 'SweetAlert', 'enums',
    function ($log, $scope, $translate, $document, $uibModal, $timeout, vatOutputInvoiceManageService, SweetAlert, enums) {
        var revertStatusList = _.invert(enums.GDBDStatusEnum);
        $scope.redLettered = enums.GDBDStatusEnum.redLettered;
        $scope.hasUpdate = false;
        $scope.detailDialog = {
            modalInstance: null,
            open: function () {
                var parentElem = $scope.parentElement ?
                            angular.element($document[0].querySelector('.' + $scope.parentElement)) : undefined;
                $scope.detailDialog.modalInstance = $uibModal.open({
                    animation: false,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'myModalContent.html',
                    windowClass: 'GD-Vechicle-detail',
                    scope: $scope,
                    appendTo: parentElem
                });


            },
            cancel: function () {
                $scope.detailDialog.modalInstance.dismiss('cancel');
                if ($scope.hasUpdate&&_.isFunction($scope.parentRefresh)) {
                    $scope.parentRefresh();
                }
                $scope.hasUpdate = false;
            }
        };
        $scope.vehicleDetailOptions = {
            bindingOptions: {
                dataSource: 'invoiceDetail.details'
            },
            width: '99%',
            noDataText: $translate.instant('NoData'),
            columnAutoWidth: true,
            showBorders: true,
            showRowLines: true,
            columns: [
                { dataField: 'vin', caption: $translate.instant('VIN') },
                { dataField: 'vehicleModel', caption: $translate.instant('VehicleModel') },
                { dataField: 'quantity', caption: $translate.instant('Quantity'), alignment: 'left' },
                {
                    dataField: 'price', caption: $translate.instant('UnitPrice'),
                    alignment: 'right', format: { type: 'fixedPoint', precision: 2 }
                },
                {
                    dataField: 'amount', caption: $translate.instant('Amount'),
                    alignment: 'right', format: { type: 'fixedPoint', precision: 2 }
                },
                {
                    dataField: 'taxRate', caption: $translate.instant('TaxRate'),
                    alignment: 'right',
                    calculateDisplayValue: function (rowData) {
                        // return rowData.taxRate.formatRate(0);
                        var num = (rowData.taxRate * 100).formatAmount(0);
                        return num + "%";
                    }
                },
                {
                    dataField: 'taxAmount', caption: $translate.instant('TaxAmount'),
                    alignment: 'right', format: { type: 'fixedPoint', precision: 2 }
                },
                {
                    dataField: 'gdBdStatus', caption: $translate.instant('Status'),
                    calculateDisplayValue: function (rowData) {
                        //fix 12875
                        //if ($scope.invoiceStatus === enums.GDInvoiceStatusEnum.cancelled) {
                        //    return $translate.instant(revertStatusList[enums.GDBDStatusEnum.cancelled]);
                        //}
                        return $translate.instant(revertStatusList[rowData.status]);
                    }
                },
                {
                    caption: $translate.instant('Action'), width: '120px',
                    cellTemplate: 'redLetterTemplate'
                }

            ],
            onRowPrepared: function (e) {
                if (e.rowType === 'totalFooter') {
                    var instance = e.component;
                    var grandTotal = instance.getTotalSummaryValue('totalAmount') + instance.getTotalSummaryValue('totalTaxAmount');
                    if (_.isNumber(grandTotal)) {
                        grandTotal = grandTotal.formatAmount(2);
                    }
                    var grandStr = $translate.instant('GrandTotal');
                    var trStr = "<tr class='dx-row' role='row'>"
                        + '<td role="gridcell" aria-label="Column VIN, Value undefined" style="text-align: left;">' 
                        + '<div class="dx-datagrid-summary-item dx-datagrid-text-content" >'
                        + grandStr +'&nbsp;'+ grandTotal+'</div></td>'
                        + '<td role="gridcell" aria-label="Column Vehicle Model, Value undefined" style="text-align: left;"></td>'
                        + '<td role="gridcell" aria-label="Column 数量, Value undefined" style="text-align: left;"></td>'
                        + '<td role="gridcell" aria-label="Column Price, Value undefined" style="text-align: right;"></td>'
                        + '<td role="gridcell" aria-label="Column Amount, Value undefined" style="text-align: right;"></td>'
                        + '<td role="gridcell" aria-label="Column 税率, Value undefined" style="text-align: left;"></td>'
                        + '<td role="gridcell" aria-label="Column 税额, Value undefined" style="text-align: left;"></td>'
                        + '<td role="gridcell" aria-label="Column Status, Value undefined" style="text-align: left;"></td>'
                        + '<td role="gridcell" aria-label="Column , Value undefined" style="text-align: left;"></td>'
                       + "</tr>"
                    e.rowElement.after(trStr);
                }
            },
            summary: {
                totalItems: [
                     {
                         column: 'price',
                         customizeText: function (item) {
                             return $translate.instant('TotalPrice');
                         }
                     },
                    {
                        name: 'totalAmount',
                        column: 'amount',
                        summaryType: 'sum',
                        customizeText: function (data) {
                            return data.value.formatAmount(2);
                        }
                    },
                    {
                        name: 'totalTaxAmount',
                        column: 'taxAmount',
                        summaryType: 'sum',
                        customizeText: function (data) {
                            return data.value.formatAmount(2);
                        }
                    }
                ]
            }

        };


        $scope.eventService = {            
            LoadData: function () {
                if ($scope.detailKey) {
                    vatOutputInvoiceManageService.getGBInvoiceDetail($scope.detailKey).success(function (response) {
                        if (response.result) {
                            $scope.invoiceDetail = response.data;
                           
                            $scope.needHide = $scope.hideAction;
                          
                            //invoiceStatus
                            //GD发票是红冲或者取消状态，就不能操作
                            //或者车辆本身已经红冲过的就不能操作
                            if ($scope.invoiceStatus) {
                                //has value
                                $scope.needHide = $scope.needHide||$scope.invoiceDetail.isRedInvoice || $scope.invoiceStatus === enums.GDInvoiceStatusEnum.cancelled ||
                                    $scope.invoiceStatus === enums.GDInvoiceStatusEnum.redLettered;
                                
                            }
                            //红冲-除去当月往前退180，如果开票日期在这里面的就可以红冲
                            var currentDate = new Date();
                            var currentMonth = currentDate.getMonth();
                            var endDate = new Date(currentDate.getFullYear(), currentMonth, 1);
                            var one_day = 1000 * 60 * 60 * 24;
                            var startDate = new Date(endDate.getTime() - one_day * 180);
                            var iDate = new Date($scope.invoiceDetail.gdIssuedDate);
                            $scope.needHide = $scope.needHide ||iDate < startDate|| iDate > endDate
                          
                            $scope.detailDialog.open();
                        } else {
                            SweetAlert.error('', $translate.instant(response.resultMsg));
                        }

                    }).error(function () {
                        SweetAlert.error('', $translate.instant('CommonFail'));
                    });
                }

            },
            confirmRedLetter: function (rowData) {
                SweetAlert.swal({
                    title: $translate.instant('RedLetterConfirmTitle'),
                    text: $translate.instant('RedLetterConfirmText'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Confirm'),
                    cancelButtonText: $translate.instant('ENCancel'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                function (isConfirm) {
                    if (isConfirm) {
                        $scope.eventService.toRedLetter(rowData);
                    }
                });
            },
            toRedLetter: function (rowData) {
                var id = rowData.detailID;               
                //to connect baiwang interface and update the printed ID GB-BD status
                vatOutputInvoiceManageService.gdRedLetter(id).success(function (response) {
                    if (response&&response.result) {
                        //返回的是GD-BD发票的状态
                        $scope.invoiceStatus = response.resultMsg;
                        rowData.status = $scope.redLettered;
                        $scope.needHide = $scope.invoiceStatus === enums.GDInvoiceStatusEnum.cancelled ||
                                  $scope.invoiceStatus === enums.GDInvoiceStatusEnum.redLettered;
                        
                        $('#vehicleDetail').dxDataGrid('instance').refresh();
                        $scope.hasUpdate = true;

                    } else {
                        var msg = response ? response.resultMsg : "NotFindItem";
                        SweetAlert.error('', $translate.instant(msg));
                    }

                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },
            loadDataAfterReady: function () {
                $timeout(function () {
                    $scope.eventService.LoadData();
                }, 600);
            }

        };

    }
])
invoiceModule.directive('invoiceDetailVehicle', ['$log', function ($log) {
    'use strict';
    $log.debug('invoiceDetailVehicle.ctor()...');
    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/GD-BD-invoice-detail/GD-BD-invoice-detail.html' + '?_=' + Math.random(),
        scope:
        {   //[dbo].[OutputInvoiceGDIssued].id       
            detailKey: "=",
            invoiceStatus:"=?",
            parentPage: "@",
            parentElement: "@",
            parentRefresh: "&",
            //in order view gd detail from by vin page
            hideAction: "=?"
        },
        controller: 'invoiceDetailVehicleController',
        link: function ($scope, $element) {
            $scope.$on('openGDDetailDialog', function () {
                $scope.eventService.loadDataAfterReady();                
            });
        }
    };
}]);
invoiceModule.controller('gdInvoicePrintController', ['$log', '$scope', '$translate', '$document', '$uibModal', '$timeout',
    'vatOutputInvoiceManageService', 'SweetAlert', 'enums', '$state', 'loginContext', 'orgService',
    function($log, $scope, $translate, $document, $uibModal, $timeout, vatOutputInvoiceManageService, SweetAlert, enums, $state, loginContext, orgService) {
        'use strict';


        var mainModule = {
            InvoiceList: [],

            PrintInvoiceList: [],

            CurrentIndex: 0,

            LimitAmount: 0,

            main: function() {
                mainModule.getBDList();

                $scope.canDelete = true;

                // mainModule.test();
                $scope.currentModel = {
                    carList: []
                };

                mainModule.init();
                $scope.previousPage = mainModule.previousPage;
                $scope.nextPage = mainModule.nextPage;

                $scope.deleteCarsComfirm = mainModule.deleteCarsComfirm;

                $scope.printAll = function() {

                    if (mainModule.PrintInvoiceList && mainModule.PrintInvoiceList.length > 0) {

                        // 从零开始打印
                        // $scope.invoiceConfirmModel = {
                        //     type: 2,
                        //     taxControlDiskID: $scope.editModel.taxControlDisk.id,
                        // };

                        // $scope.invoiceConfirmType = constant.Operation.Open;

                        // $scope.invoiceConfirmFunction = function(param) {
                        //     mainModule.printReverse(0);
                        // };

                        mainModule.printReverse(0);
                    }
                };

                $scope.cancelPrintGDInvoice = function() {
                    $state.go("outputInvoiceManage.issuedInvoiceGdView");
                };

                $scope.setSelectBuyerInfo = mainModule.setSelectBuyerInfo;
                $scope.remarkChkChanged = mainModule.remarkChkChanged;

                $scope.progress = 0;
            },

            // 重新设置选中采购
            setSelectBuyerInfo: function() {

                if ($scope.currentModel.selectBuyer && $scope.currentModel) {
                    $scope.currentModel.buyerOrganizationName = $scope.currentModel.selectBuyer.name;
                    $scope.currentModel.buyerOrganizationEnglishName = $scope.currentModel.selectBuyer.englishName;
                    $scope.currentModel.buyerOrganizationTaxId = $scope.currentModel.selectBuyer.taxPayerNumber;
                    $scope.currentModel.buyerOrganizationCode = $scope.currentModel.selectBuyer.code;
                    $scope.currentModel.vrl = $scope.currentModel.selectBuyer.vehicleroutinglocation;
                    $scope.currentModel.buyerId = $scope.currentModel.selectBuyer.id
                    $scope.currentModel.buyerAddress = $scope.currentModel.selectBuyer.manufactureAddress;
                    $scope.currentModel.buyerPhoneNo = $scope.currentModel.selectBuyer.phoneNumber;
                    $scope.currentModel.buyerBankName = $scope.currentModel.selectBuyer.bankAccountName;

                    // 此为银行账号
                    $scope.currentModel.buyerACNo = $scope.currentModel.selectBuyer.bankAccountNumber;
                }

            },

            // 获取单张发票的限制额度
            getinvoiceQuota: function() {
                vatOutputInvoiceManageService.getInvoiceQuota().success(function(result) {
                    if (result.result) {
                        var str = result.data;
                        mainModule.LimitAmount = parseInt(result.data);
                        mainModule.dataParse();
                        mainModule.setCurrentModel(0);
                    }
                });
            },

            // 获取BD列表
            getBDList: function() {
                orgService.getBdList().success(function(res) {
                    $scope.bdDataSource = res;
                    mainModule.getinvoiceQuota();
                });
            },

            // 设置 页数
            setCurrentModel: function(index) {

                if (mainModule.PrintInvoiceList && mainModule.PrintInvoiceList.length > 0) {

                    if (mainModule.PrintInvoiceList.length <= index) {
                        index = mainModule.PrintInvoiceList.length - 1;
                    }

                    if (index < 0) {
                        index = 0;
                    }

                    mainModule.CurrentIndex = index;
                    $scope.currentModel = mainModule.PrintInvoiceList[mainModule.CurrentIndex];
                } else {
                    $scope.currentModel = {
                        carList: [],
                        remarkDisabled: true,
                    };
                }

                if (mainModule.CurrentIndex < mainModule.PrintInvoiceList.length - 1) {
                    $scope.canNext = true;
                } else {
                    $scope.canNext = false;
                }

                if (mainModule.CurrentIndex > 0) {
                    $scope.canPrevious = true;
                } else {
                    $scope.canPrevious = false;
                }

                $timeout(function() {

                    $scope.gridHeight = 52 + $scope.currentModel.carList.length * 34;

                    $scope.setInvoiceGridHeight();
                }, 50);

            },
            init: function() {
                $scope.currentModel.remarkReadOnly = true;

                $scope.currentModel.remarkDisabled = true;

                $scope.dxOptions = {
                    buyerTaxIDOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerOrganizationTaxId',
                        },
                        maxLength: 50
                    },

                    categoriesOpt: {
                        bindingOptions: {
                            value: 'currentModel.category',
                        },
                        maxLength: 50
                    },

                    buyerAddressOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerAddress',
                        },
                        maxLength: 50
                    },

                    buyerPhoneNoOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerPhoneNo',
                        },
                        maxLength: 50
                    },

                    bankNameOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerBankName',
                        },
                        maxLength: 50
                    },
                    buyerACNoOpt: {
                        bindingOptions: {
                            value: 'currentModel.buyerACNo',
                        },
                        maxLength: 50
                    },

                    invocieTypeOpt: {
                        bindingOptions: {
                            value: 'currentModel.invoiceType',
                        },
                        maxLength: 50
                    },
                    remarksOpt: {
                        bindingOptions: {
                            value: 'currentModel.remarks',
                            // readOnly: 'currentModel.remarkReadOnly',
                            disabled: 'currentModel.remarkDisabled'
                        },
                        activeStateEnabled: true,
                        maxLength: 255
                    },
                    entityOptions: {
                        bindingOptions: {
                            'value': 'currentModel.buyerId',
                            'dataSource': 'bdDataSource'
                        },
                        onSelectionChanged: function(args) {
                            $scope.currentModel.selectBuyer = args.selectedItem;
                            mainModule.setSelectBuyerInfo();
                        },
                        // showClearButton: true,
                        displayExpr: 'name',
                        valueExpr: 'id'
                    },
                    receiverOpt: {
                        bindingOptions: {
                            value: 'currentModel.receiver',
                        },
                        maxLength: 50
                    },
                    reviewerOpt: {
                        bindingOptions: {
                            value: 'currentModel.reviewer',
                        },
                        maxLength: 50
                    },
                    drawerOpt: {
                        bindingOptions: {
                            value: 'currentModel.drawer',
                        },
                        maxLength: 50
                    }
                };

                mainModule.initGrid();
            },

            // 上一页
            previousPage: function() {

                if ($scope.canPrevious) {
                    mainModule.CurrentIndex--;
                    mainModule.setCurrentModel(mainModule.CurrentIndex);
                }
            },

            // 下一页
            nextPage: function() {

                if ($scope.canNext) {
                    mainModule.CurrentIndex++;
                    mainModule.setCurrentModel(mainModule.CurrentIndex);
                }

            },
            initGrid: function() {
                $scope.invoiceGridOptions = {
                    bindingOptions: {
                        dataSource: 'currentModel.carList'
                    },
                    keyExpr: "outputInvoicePrintedID",
                    selection: {
                        mode: "multiple",
                        showCheckBoxesMode: 'always'
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    rowAlternationEnabled: true,
                    showBorders: true,
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    onContentReady: function(e) {
                        $scope.invoiceGridInstance = e.component;
                    },
                    onSelectionChanged: function(data) {
                        $scope.currentModel.deleteCarKeys = data.selectedRowKeys;
                        mainModule.onselectCars(data);
                    },
                    columns: [
                        { dataField: 'name', caption: $translate.instant('ItemName') },
                        { dataField: 'vin', caption: $translate.instant('Specifications') },
                        { dataField: 'unit', caption: $translate.instant('Unit') },
                        { dataField: 'quantity', caption: $translate.instant('Quantity') },
                        { dataField: 'price', caption: $translate.instant('UnitPrice'), format: { type: 'fixedPoint', precision: 2 } },
                        { dataField: 'amount', caption: $translate.instant('Amount'), format: { type: 'fixedPoint', precision: 2 } },
                        { dataField: 'taxRateData', caption: $translate.instant('TaxRate') }, //税额合计小写
                        { dataField: 'taxAmount', caption: $translate.instant('TaxAmount'), format: { type: 'fixedPoint', precision: 2 } }, //税额
                    ],
                    summary: {
                        totalItems: [{
                                column: 'price',
                                customizeText: function(item) {
                                    return $translate.instant('TotalPrice');
                                }
                            },
                            {
                                name: 'totalAmount',
                                column: 'amount',
                                summaryType: 'sum',
                                customizeText: function(data) {
                                    return data.value.formatAmount(2);
                                }
                            },
                            {
                                name: 'totalTaxAmount',
                                column: 'taxAmount',
                                summaryType: 'sum',
                                customizeText: function(data) {
                                    return data.value.formatAmount(2);
                                }
                            }
                        ]
                    }
                };
            },

            onselectCars: function(data) {
                // if (data.selectedRowKeys && $scope.currentModel.carList && data.selectedRowKeys.length === $scope.currentModel.carList.length) {
                //     // 不能点击
                //     $scope.canDelete = false;
                // } else {
                //     $scope.canDelete = true;
                // }
            },

            test: function() {
                var str = '[{\"id\":\"2c0ed51c-dc4b-4e26-bb01-22facaf8b0e8\",\"bdFapiaoEntity\":\"2066\",\"registrationLocalName\":\"tom li\",\"organizationCode\":\"2066\",\"companyVATIDTaxID\":\"234826348762384\",\"issuranceType\":\"SalesForce\",\"category\":\"小轿车\",\"vehicleModel\":\"Model S\",\"cabinConfiguration\":\"5\",\"caseNumber\":null,\"producingPlace\":\"美国\",\"certificateNumber\":\"\",\"importCertificateNumber\":\"H34234234234\",\"ciqNumber\":\"A234234234\",\"motorNumber\":\"T937459834\",\"vin\":\"5Y837438743743\",\"subtotalforFinalPayment\":650000,\"subtotalforFinalPaymentCH\":\"陆拾伍万\",\"invoiceCode\":\"\",\"invoiceNumber\":\"\",\"salesUnitName\":\"特斯拉汽车销售服务（xx）有限公司\",\"salesUnitPhoneNumber\":\"020-37253253\",\"salesTaxPayerNumber\":\"977277237575276354\",\"salesAccount\":\"23123123123\",\"salesAddress\":null,\"salesBankName\":\"花旗银行\",\"vatRateorLevyRate\":\"\",\"taxableSubtotal\":650000,\"mainTaxAuthoritiesCode\":\"XXX市 9274387293874\",\"excludeTaxPrice\":650000,\"taxPaymentCertificateNumber\":\"123123213\",\"tonnage\":null,\"limitPassengers\":null,\"productCompanyName\":\"tesla\",\"invoiceStatus\":0,\"createTime\":\"2017-08-28T18:10:08.277+08:00\",\"updateTime\":\"2017-09-01T15:07:15.9+08:00\",\"bdStatus\":\"Normal\",\"gdBdStatus\":\"Need Red-letter\",\"gdIssuedId\":null,\"caseCollectionDate\":\"2017-08-30\",\"bdIssuedDate\":\"2017-08-28T18:10:08.277+08:00\",\"gdTotalAmount\":null,\"gdInvoiceCode\":null,\"gdInvoiceNumber\":null,\"gdIssuedDate\":null,\"buyerOrganizationCode\":null,\"reasonList\":null,\"invoiceNo\":\"\",\"invoiceCase\":\"\",\"issuedDate\":\"2017-08-28\",\"amount\":650000,\"buyer\":\"tom li\"}]';

                mainModule.InvoiceList = JSON.parse(str);
            },

            getTax: function(data) {
                var rateStr = data.vatRateorLevyRate.replace('%', '');

                var taxRateDecimal = parseInt(rateStr);
                data.taxRateDecimal = taxRateDecimal / 100;

                var tax = data.amountAdjusted * taxRateDecimal;

                tax = tax / 100;
                return tax;
            },
            dataParse: function() {
                // 数据转换
                var salesUnitNameList = _.uniq(_.pluck(mainModule.InvoiceList, 'salesUnitName'));

                var printInvoiceList = [];
                if (salesUnitNameList && salesUnitNameList.length > 0) {
                    salesUnitNameList.forEach(function(row) {
                        var list = _.filter(mainModule.InvoiceList, function(t) {

                            return t.salesUnitName === row;
                        });

                        var first = list[0];

                        var carList = [];

                        var sumAmount = 0;
                        var totalTax = 0;
                        var count = 0;

                        // 选中BD
                        var obj = _.find($scope.bdDataSource, function(row) {
                            return row.name === first.salesUnitName;
                        });
                        var item = {

                            // 右边是 BD - user的角度
                            // 而这个页面是GD - BD角度，所以 买卖双方是看情况的
                            buyerOrganizationName: first.salesUnitName,
                            buyerOrganizationEnglishName: obj ? obj.englishName : null,
                            buyerOrganizationTaxId: first.salesTaxPayerNumber,
                            category: first.category,
                            buyerId: obj ? obj.id : null,
                            officer: loginContext.userName,
                            buyerAddress: first.salesAddress,
                            buyerPhoneNo: first.salesUnitPhoneNumber,
                            buyerBankName: first.salesBankName,
                            buyerACNo: obj ? obj.bankAccountNumber : null,
                            invoiceType: $translate.instant('SpecialVATInvoice'),
                            remarks: '',
                            carList: [],
                            issuanceDate: new Date().formatDateTime('yyyy-MM-dd'),
                            totalAmount: 0,
                            buyerOrganizationCode: obj ? obj.code : null,
                            totalTaxAmount: 0,
                            vrl: obj ? obj.vehicleroutinglocation : null,
                            selectBuyer: obj,
                            remarkDisabled: true
                        };

                        list.forEach(function(l) {

                            var taxCompute = mainModule.getTax(l);
                            var addsumAmount = sumAmount + totalTax + l.amountAdjusted + taxCompute;

                            if (count === 9 || addsumAmount > mainModule.LimitAmount) {
                                // 一张发票最多8条记录，且不能超过限制额度
                                var copyItem = angular.copy(item);
                                copyItem.totalAmount = sumAmount;
                                copyItem.totalTaxAmount = totalTax;
                                copyItem.totalAllAmount = copyItem.totalAmount + copyItem.totalTaxAmount;
                                copyItem.totalAllAmountData = copyItem.totalAllAmount.formatAmount();
                                copyItem.carList = carList;
                                printInvoiceList.push(copyItem);
                                count = 0;
                                sumAmount = 0;
                                totalTax = 0;
                                carList = [];
                            }

                            sumAmount += l.amountAdjusted;
                            totalTax += taxCompute;
                            var car = {
                                outputInvoicePrintedID: l.id,
                                name: l.brandandModelNumber,
                                vin: l.vin,
                                unit: '辆',
                                quantity: 1,
                                price: l.amountAdjusted,
                                priceData: l.amountAdjusted.formatAmount(),
                                amount: l.amountAdjusted,
                                amountData: l.amountAdjusted.formatAmount(),
                                taxRateData: l.vatRateorLevyRate,
                                taxRate: l.taxRateDecimal,
                                taxAmount: taxCompute,
                                taxAmountData: taxCompute.formatAmount()
                            };

                            if (!_.isEmpty(l.manualInput)) {
                                car.manualInputReasons = l.manualInput.reasonList.join(',');
                                car.manualInputEvidenceFiles = l.manualInput.evidenceFiles;
                            }

                            carList.push(car);
                            count++;
                        });


                        if (count > 0) {
                            var copyItem = angular.copy(item);
                            copyItem.totalAmount = sumAmount;
                            copyItem.totalTaxAmount = totalTax;
                            copyItem.totalAllAmount = copyItem.totalAmount + copyItem.totalTaxAmount;
                            copyItem.totalAllAmountData = copyItem.totalAllAmount.formatAmount();
                            copyItem.carList = carList;
                            printInvoiceList.push(copyItem);
                            count = 0;
                            sumAmount = 0;
                            totalTax = 0;
                            carList = [];
                        }

                    });
                }

                mainModule.PrintInvoiceList = printInvoiceList;
            },

            // 打印
            printReverse: function(index) {
                var thisObj = mainModule.PrintInvoiceList[index];
                var length = mainModule.PrintInvoiceList.length;

                var count = index + 1;
                // 无 车辆列表的 就不打印了
                if (!thisObj.carList || thisObj.carList.length === 0) {
                    if (index !== length - 1) {

                        $scope.progress = window.PWC.round((count / mainModule.PrintInvoiceList.length) * 100, 0);
                    } else {
                        $scope.progress = 100;

                        // 打印完成， 跳转已经打印列表
                        $state.go('outputInvoiceManage.issuedInvoiceSpecial');
                        return;
                    }

                    index++;
                    if (index < mainModule.PrintInvoiceList.length) {
                        mainModule.printReverse(index);
                    }

                    return;
                }

                thisObj.detailList = angular.copy(thisObj.carList);
                thisObj.detailList.forEach(function(r) {

                    var array = [];
                    if (r.manualInputEvidenceFiles && r.manualInputEvidenceFiles.length > 0) {
                        r.manualInputEvidenceFiles.forEach(function(m) {
                            array.push(m.data);
                        });

                        // r.manualInputEvidenceFiles = JSON.stringify(array);

                        // 上传文件暂时不存，解决报错的问题
                        r.manualInputEvidenceFiles = null;
                    }

                });

                vatOutputInvoiceManageService.printGDInvoice(thisObj).success(function(ret) {

                    if (ret.result) {
                        if (index !== length - 1) {
                            $scope.progress = window.PWC.round((count / mainModule.PrintInvoiceList.length) * 100, 0);
                        } else {
                            $scope.progress = 100;

                            // 打印完成， 跳转已经打印列表
                            $state.go('outputInvoiceManage.issuedInvoiceSpecial');
                            return;
                        }
                    }

                    index++;
                    if (index < mainModule.PrintInvoiceList.length) {
                        mainModule.printReverse(index);
                    }

                });
            },

            // 删除一行车辆发票
            deleteCars: function() {
                if ($scope.currentModel && $scope.currentModel.carList) {

                    var existsCarList = _.filter($scope.currentModel.carList, function(row) {
                        return $scope.currentModel.deleteCarKeys.indexOf(row.outputInvoicePrintedID) === -1;
                    });

                    if (existsCarList == null || existsCarList.length === 0) {
                        // celine:删除一张发票中所有item后直接将该发票删除，直接跳转到下一张发票。
                        // 如仅有一张则回到GD view界面，如为最后一张则跳转到前一张

                        mainModule.PrintInvoiceList.splice(mainModule.CurrentIndex, 1);


                        if (mainModule.PrintInvoiceList.length === 0) {
                            // 跳转到选择之前
                            SweetAlert.warning($translate.instant('DeleteSuccess'));
                            $state.go("outputInvoiceManage.issuedInvoiceGdView");
                        } else {
                            if (mainModule.CurrentIndex < mainModule.PrintInvoiceList.length) {
                                mainModule.setCurrentModel(mainModule.CurrentIndex);
                            } else {
                                var tempIndex = mainModule.CurrentIndex - 1;
                                mainModule.setCurrentModel(tempIndex);
                            }

                            SweetAlert.warning($translate.instant('DeleteSuccess'));
                        }

                        return;
                    }

                    $scope.currentModel.carList = existsCarList;

                    var sumAmount = 0;

                    var totalTax = 0;
                    $scope.currentModel.carList.forEach(function(row) {
                        sumAmount += row.amount;
                        totalTax += row.taxAmount;
                    });

                    $scope.currentModel.totalAmount = sumAmount;
                    $scope.currentModel.totalTaxAmount = totalTax;

                    $scope.currentModel.totalAllAmount = $scope.currentModel.totalAmount + $scope.currentModel.totalTaxAmount;
                    $scope.currentModel.totalAllAmountData = $scope.currentModel.totalAllAmount.formatAmount();

                    SweetAlert.warning($translate.instant('DeleteSuccess'));

                }
            },
            deleteCarsComfirm: function() {

                if (!$scope.currentModel.deleteCarKeys || $scope.currentModel.deleteCarKeys.length === 0) {
                    SweetAlert.warning($translate.instant('SelectAtLeastOne'));
                    return;
                }

                SweetAlert.swal({
                        title: $translate.instant('Confirm') + " " + $translate.instant('Delete') + '?',
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function(isConfirm) {
                        if (isConfirm) {
                            mainModule.deleteCars();
                        }
                    });
            },

            // 备注选项修改
            remarkChkChanged: function() {
                if ($scope.currentModel.remarkChk) {
                    $scope.currentModel.remarkReadOnly = false;
                    $scope.currentModel.remarkDisabled = false;
                } else {
                    $scope.currentModel.remarkReadOnly = true;
                    $scope.currentModel.remarkDisabled = true;
                }
            }
        };

        (function initialize() {

            $log.debug('gdInvoicePrintController.ctor()...');

            if ($state.params.invoiceList) {
                mainModule.InvoiceList = $state.params.invoiceList;
            }

            mainModule.main();

        })();
    }
])
invoiceModule.directive('gdInvoicePrint', ['$log', function ($log) {
    'use strict';

    console.log('gdInvoicePrint.ctor()...');
    $log.debug('gdInvoicePrint.ctor()...');
    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/gd-invoice-print/gd-invoice-print.html' + '?_=' + Math.random(),
        scope:
        {

        },
        controller: 'gdInvoicePrintController',
        link: function (scope, element) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                   var contentbody = '.gdprint-grid-container';
                    var pageHeight = $(document).height();// 810; // parseInt($(pageWrapSelector).css('height').replace('px', ''));
                    var contentbodyHeight = pageHeight -520;
                     
                    var height = contentbodyHeight;

                    // if (scope.gridHeight < contentbodyHeight - 34){
                    //     height = scope.gridHeight + 34;
                    // } 

                    $(contentbody).css('height', height);
                    // $(dxGridSelector).css('height', height);
                    //$(invoiceDataGridSelector).css('max-height', '100%');

                    try {
                        var option = $('#invoiceGdPrintGridContainer').dxDataGrid('option');
                        option.height = height - 34;
                        // option.height = 400;
                        $('#invoiceGdPrintGridContainer').dxDataGrid('option', option);
                        // $('#invoiceGdPrintGridContainer').dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };


                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
        }
    };
}]);
invoiceModule.controller('gdViewByVINController', ['$log', '$timeout', '$scope', '$translate', 'vatOutputInvoiceManageService',
    'SweetAlert', 'enums', 'modalAdapterService',
    function ($log, $timeout, $scope, $translate, vatOutputInvoiceManageService, SweetAlert, enums,
        modalAdapterService) {
        var dateFormat = 'yyyy-MM-dd';
        var revertStatusList = _.invert(enums.GDBDStatusEnum);
        var revertGDStatusList = _.invert(enums.GDInvoiceStatusEnum);
        $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
        $scope.pleaseInput = $translate.instant('InputPlaceholder');
        $scope.noDataText = $translate.instant('NoDataText');
        $scope.masterDetailHeader = {
            invoiceNo: $translate.instant('InvoiceNo'),
            invoiceCode: $translate.instant('InvoiceCode'),
            invoiceCaseNum: $translate.instant('InvoiceCase'),
            issuedDate: $translate.instant('IssuedDate'),
            buyer: $translate.instant('Buyer'),
            amount: $translate.instant('Amount'),
            taxAmount: $translate.instant('TaxAmount'),
            totalAmount: $translate.instant('TotalAmount'),
            gdStatus: $translate.instant('GDInvoiceStatus'),
            status: $translate.instant('VehicleStatus')
        };
        $scope.pagingOptions = {
            pageIndex: 1,  //当前页码
            totalItems: 0,  //总数据
            pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
        };
        $scope.gdVinDetailVariables = {
            selectedTableRows: [],
            pageName: $translate.instant('GDVinView'),
            selectedGDInvoice: null

        };
        $scope.gdVinSearchEntity = {
            invoiceNumberVaule: null,
            invoiceCodeVaule: null,
            vinValue: null,
            caseNumberValue: null,
            vehicleModelValue:null

        };
        $scope.gdVinInvoice = {
            invoiceNumberOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.invoiceNumberVaule'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            invoiceCodeOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.invoiceCodeVaule'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            vinOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.vinValue'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            caseNumberOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.caseNumberValue'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            vehicleModelColonOptions: {
                bindingOptions: {
                    'value': 'gdVinSearchEntity.vehicleModelValue',
                    'dataSource': 'vehicleModelSource'
                },
                showClearButton: true,
                displayExpr: 'name',
                valueExpr: 'id',
                placeholder: $scope.pleaseSelect
            },
            gdVinGridOptions: {
                bindingOptions: {
                    dataSource: 'vinList',
                    'height': 'height'
                },
                keyExpr: 'vin',
                noDataText: $scope.noDataText,
                columnAutoWidth: true,
                showRowLines: true,
                showBorders: true,
                columnChooser: {
                    enabled: true
                },
                paging: {
                    enabled: false
                },
                loadPanel: {
                    enabled: false,
                },
                //selection: {
                //    mode: 'multiple',
                //    showCheckBoxesMode: 'always'
                //},
                //onSelectionChanged: function (e) {
                //    var selectedVin = e.selectedRowsData; 
                //    var mainTable = $('#gdVinGrid').dxDataGrid('instance');
                //    _.each(selectedVin,function(item){
                //        $scope.gdVinDetailVariables.selectedTableRows.concat(item.gdInvoices);
                //        if (mainTable.isAdaptiveDetailRowExpanded(item.vin)) {
                //            $("#vin-" + key).dxDataGrid("instance").selectAll();
                //        }
                //    });

                //},
                //onRowExpanded:function(e){
                //    var key = e.key;
                //    var mainTable = $('#gdVinGrid').dxDataGrid('instance');
                //    if (mainTable.isRowSelected(key)) {
                //        $("#vin-" + key).dxDataGrid("instance").selectAll();
                //    }
                //    //deselectRows(keys)
                //},
                columns: [
                    { dataField: 'vin', caption: $translate.instant('VIN'), allowHeaderFiltering: false },
                    { dataField: 'vehicleModel', caption: $translate.instant('VehicleModel'), allowHeaderFiltering: false },
                    { dataField: 'count', caption: $translate.instant('InvoiceCount'), allowHeaderFiltering: false },
                    {
                        dataField: 'totalTaxAmount', caption: $translate.instant('TotalTaxAmount'),
                        format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                    },
                    {
                        dataField: 'totalEffectiveAmount', caption: $translate.instant('TotalEffectiveAmount'),
                        format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                    },
                ],
                masterDetail: {
                    enabled: true,
                    template: "gdInvoiceTemplate"
                },
                gdView: function (gdInvoices) {
                    return {
                        dataSource: gdInvoices,
                        noDataText: $scope.noDataText,
                        columnAutoWidth: true,
                        //showRowLines: true,
                        selection: {
                            mode: 'multiple',
                            showCheckBoxesMode: 'always'
                        },
                        onSelectionChanged: function (e) {
                            var selectedVin = e.currentSelectedRowKeys;
                            var deSelectArray = e.currentDeselectedRowKeys;
                            // var select
                            if (deSelectArray.length > 0) {
                                $scope.gdVinDetailVariables.selectedTableRows = _.difference($scope.gdVinDetailVariables.selectedTableRows, deSelectArray);
                            }
                            if (selectedVin.length > 0) {
                                $scope.gdVinDetailVariables.selectedTableRows = $scope.gdVinDetailVariables.selectedTableRows.concat(selectedVin);
                            }

                        },
                        showBorders: true,
                        columns: [
                          { dataField: 'gdInvoiceNumber', caption: $scope.masterDetailHeader.invoiceNo, allowHeaderFiltering: false },
                          { dataField: 'gdInvoiceCode', caption: $scope.masterDetailHeader.invoiceCode, allowHeaderFiltering: false },
                            {
                                dataField: 'gdStatus', caption: $scope.masterDetailHeader.gdStatus,
                                calculateDisplayValue: function (rowData) {
                                    return $translate.instant(revertGDStatusList[rowData.gdStatus]);
                                }
                            },
                          { dataField: 'invoiceCase', caption: $scope.masterDetailHeader.invoiceCaseNum, allowHeaderFiltering: false },
                          {
                              dataField: 'gdIssuedDate', caption: $scope.masterDetailHeader.issuedDate,
                              dataType: 'date', format: dateFormat, allowHeaderFiltering: false
                          },
                          { dataField: 'buyerOrganizationName', caption: $scope.masterDetailHeader.buyer, allowHeaderFiltering: false },
                           {
                               dataField: 'amount', caption: $scope.masterDetailHeader.amount,
                               format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                           },
                          {
                              dataField: 'taxAmount', caption: $scope.masterDetailHeader.taxAmount,
                              format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                          },
                           {
                               dataField: 'totalAmount', caption: $scope.masterDetailHeader.totalAmount,
                               format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false,
                               calculateDisplayValue: function (rowData) {
                                   var r = 0;
                                   if (_.isNumber(rowData.amount)) {
                                       r += rowData.amount;
                                   }
                                   if (_.isNumber(rowData.taxAmount)) {
                                       r += rowData.taxAmount;
                                   }
                                   return r;
                               }
                           },
                            {
                                dataField: 'gdBdStatus', caption: $scope.masterDetailHeader.status,
                                calculateDisplayValue: function (rowData) {
                                    //fix 12875
                                    //if ($scope.invoiceStatus === enums.GDInvoiceStatusEnum.cancelled) {
                                    //    return $translate.instant(revertStatusList[enums.GDBDStatusEnum.cancelled]);
                                    //}
                                    return $translate.instant(revertStatusList[rowData.gdBdStatus]);
                                }
                            },
                            {
                                caption: $translate.instant('Details'),
                                cellTemplate: 'detailTemplate', allowHeaderFiltering: false
                            }

                        ]

                    };

                }
            }
        };

        $scope.eventService = {
            //隐藏或者展示搜索框
            showOrHideSearchBox: function () {
                $scope.hasShowMoreSearchBox = !$scope.hasShowMoreSearchBox;
                // $scope.eventService.refreshInvoiceDataGrid();
                $timeout(function () {
                    $scope.setInvoiceGridHeight();
                }, 500);
            },
            refreshInvoiceDataGrid: function () {
                var dataDto = {
                    parameters: $scope.gdVinSearchEntity,
                    pagingInfo: $scope.pagingOptions
                }
                vatOutputInvoiceManageService.getGDDetailByVin(dataDto).success(function (response) {
                    $scope.vinList = response.list;
                    $scope.pagingOptions.totalItems = response.pageInfo.totalCount;
                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },
            checkBeforCancel: function () {
                var list = $scope.gdVinDetailVariables.selectedTableRows;
                //过月的不能cancel
                var currentMonth = new Date().getMonth();//1-12
                var notValidMonthCount = 0;
                var notValidStatus = true;
                var isRed = false;
                _.each(list, function (item) {
                    var m = new Date(item.gdIssuedDate).getMonth();
                    notValidMonthCount = m === currentMonth ? notValidMonthCount : ++notValidMonthCount;
                    if (item.gdStatus !== enums.GDInvoiceStatusEnum.issued) {
                        notValidStatus = false;
                    }
                    if (item.isRedInvoice) {
                        //红票不能cancel
                        isRed = true;
                    }

                });
                var result = {
                    pass: notValidMonthCount === 0 && notValidStatus && !isRed,
                    notMatchMonth: notValidMonthCount,
                    notValidStatus: notValidStatus,
                    isRedInvoice: isRed
                }
                return result;
            },
            cancelInvoiceCore: function () {
                //只用了ID
                var gdIDs = _.map($scope.gdVinDetailVariables.selectedTableRows, function (item) {
                    return { id: item.gdInvoiceID };
                });
                var dto = {
                    items: gdIDs,
                    reprint: $scope.isReprint,
                    userName: null,
                    userID: null
                }
                //need call baiwang jie kou
                vatOutputInvoiceManageService.cancelGDInvoice(dto).success(function (response) {
                    if (response.result) {
                        //_.each($scope.gdVinDetailVariables.selectedTableRows, function (item) {
                        //    item.status = enums.GDInvoiceStatusEnum.cancelled;
                        //});
                        modalAdapterService.close(constant.OutputInvoiceCancalDialog, 'gd-vin-view');
                        $scope.eventService.refreshInvoiceDataGrid();
                    }
                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },
            cancelFapiao: function (reprint) {
                if (!$scope.gdVinDetailVariables.selectedTableRows || $scope.gdVinDetailVariables.selectedTableRows.length < 1) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                }
                var result = $scope.eventService.checkBeforCancel();
                if (result.pass) {
                    $scope.title = reprint ? $translate.instant("CancelReprintInvoiceGDTitle") : $translate.instant("CancelInvoiceGDTitle")
                    $scope.isReprint = reprint ? reprint : false;
                    modalAdapterService.open(constant.OutputInvoiceCancalDialog, 'gd-vin-view');
                } else {
                    var message = result.notMatchMonth === 0 ? "" : $translate.instant('HasNotMatchMonth') + result.notMatchMonth + $translate.instant('Separator');
                    message = result.notValidStatus ? message : message + $translate.instant('HasNotMatchStatus');
                    message = result.isRedInvoice ? message + $translate.instant('RedInvoiceWarrning') : message;
                    SweetAlert.warning('', message);
                }

            },
            cancelandPrintFapiao: function () {
                $scope.eventService.cancelFapiao(true);
            },
            showDetail: function (rowData) {
                $scope.gdVinDetailVariables.selectedGDInvoice = rowData;
                $scope.$broadcast("openGDDetailDialog");
            },
            redLetterCheck: function () {
                var pass = true;
                var message = "";
                //已经red letter的不能操作
                var limitedRecords = _.where($scope.gdVinDetailVariables.selectedTableRows, { gdBdStatus: enums.GDBDStatusEnum.redLettered });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('HasRedVehicleWarrning');
                }
                limitedRecords = _.where($scope.gdVinDetailVariables.selectedTableRows, { isRedInvoice: true });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('RedInvoiceWarrning');
                }
                limitedRecords = _.where($scope.gdVinDetailVariables.selectedTableRows, { gdStatus: enums.GDInvoiceStatusEnum.redLettered });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('HasRedInvoiceWarrning');
                }
                limitedRecords = _.where($scope.gdVinDetailVariables.selectedTableRows, { gdStatus: enums.GDInvoiceStatusEnum.cancelled });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('HasCancelInvoiceWarrning');
                }

                //红冲-除去当月往前退180，如果开票日期在这里面的就可以红冲
                var currentDate = new Date();
                var currentMonth = currentDate.getMonth();
                var endDate = new Date(currentDate.getFullYear(), currentMonth, 1);
                var one_day = 1000 * 60 * 60 * 24;
                var startDate = new Date(endDate.getTime() - one_day * 180);
               
                limitedRecords = _.filter($scope.gdVinDetailVariables.selectedTableRows, function (item) {
                    var iDate = new Date(item.gdIssuedDate);
                    return iDate < startDate || iDate > endDate
                });
                if (limitedRecords && limitedRecords.length > 0) {
                    pass = false;
                    message += $translate.instant('HasUnmatchRedTimeLimit');
                }
                return {
                    pass: pass,
                    msg: message
                }
            },
            confirmRedLetter: function () {
                if (!$scope.gdVinDetailVariables.selectedTableRows || $scope.gdVinDetailVariables.selectedTableRows.length < 1) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                }
                var result = $scope.eventService.redLetterCheck();
                if (result.pass)
                {
                    SweetAlert.swal({
                        title: $translate.instant('RedLetterConfirmTitle'),
                        text: $translate.instant('RedLetterConfirmText'),
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('ENCancel'),
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            $scope.eventService.toRedLetter();
                        }
                    });
                }
                else
                {
                    SweetAlert.warning('', result.msg);
                }

            },
            toRedLetter: function () {
                //只用了detail id
                var detailIDs = _.pluck($scope.gdVinDetailVariables.selectedTableRows, 'detialID');
                //to connect baiwang interface and update the printed ID GB-BD status
                vatOutputInvoiceManageService.gdMultipleRedLetter(detailIDs).success(function (response) {
                    if (response.result) {
                        //refresh table
                        $scope.eventService.refreshInvoiceDataGrid();
                    } else {
                        SweetAlert.error('', $translate.instant(response.resultMsg));
                    }

                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },
            getQueryBasic: function () {
                vatOutputInvoiceManageService.getModelSeries().success(function (response) {
                    if (response && response.length > 0) {
                        $scope.vehicleModelSource = _.map(response, function (item) {
                            return { id: item, name: item };
                        });
                    }
                }).error(function (err) {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            }
        };

        (function () {
            $scope.eventService.getQueryBasic();
            $scope.eventService.refreshInvoiceDataGrid();
            $scope.hasShowMoreSearchBox = false;
            //设置表格高度
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 500);
           
        })();


    }]);
invoiceModule.directive('gdViewByVin', ['$log', function ($log) {
    'use strict';
    $log.debug('GDViewByVIN.ctor()...');
    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/gd-view-by-vin/gd-view-by-vin.html' + '?_=' + Math.random(),
        scope:
        {

        },
        controller: 'gdViewByVINController',
        link: function (scope, element) {
            //计算datagrid的高度
            scope.setInvoiceGridHeight = function () {
                var pageHeight = $(document).height();
                //var smallTitleHeight = $('#litterTitle').outerHeight();
                var topTitleHeight = $('.header-title').outerHeight();
                var pageSearchHeight = $('.query-panel').outerHeight();
                var pageFastSearchHeight = $('.action-row').outerHeight();
                //var dataGridLineHeight = $('.grid-container .prompt-line').outerHeight();
                var dataGridPagerHeight = $('.page-footer').outerHeight();
                if (dataGridPagerHeight === 0) dataGridPagerHeight = 60;
                var subHeight = pageHeight - topTitleHeight - pageSearchHeight - pageFastSearchHeight - dataGridPagerHeight;
                scope.height = subHeight - 50;

                try {
                    $('#gdVinGrid').dxDataGrid('instance').repaint();
                }
                catch (e) {
                    console.log(e);
                }
            };

            $(window).on('resize', function () {
                scope.setInvoiceGridHeight();
            });
        }
    };
}]);
invoiceModule.controller('importShipmentListController', ['$scope', '$log', '$document', '$uibModal', 'messagebox',
    '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', '$location', 'InvoiceManageService',
    'vatOutputInvoiceManageService', 'userService', '$state', 'SweetAlert', 'Upload',
    function($scope, $log, $document, $uibModal, messagebox, $translate, $q, apiInterceptor, $interval, region,
        $timeout, $location, InvoiceManageService, vatOutputInvoiceManageService, userService, $state, SweetAlert, Upload) {
        'use strict';

        var thisConstant = {
            Company: $translate.instant('Company'),
            PgiWeek: $translate.instant('PgiWeek'),
            ConfirmationNumber: $translate.instant('ConfirmationNumber'),
            VIN: $translate.instant('VIN'),
            CarType: $translate.instant('CarType'),
            IsMarketingCar: $translate.instant('IsMarketingCar'),
            TaxableSubtotal: $translate.instant('TaxableSubtotal'),
            VehiclePriceafterDiscounts: $translate.instant('VehiclePriceafterDiscounts'),
            VAT: $translate.instant('VAT'),
            Revenue: $translate.instant('Revenue'),
            Discounts: $translate.instant('Discounts'),
            Subsidy: $translate.instant('Subsidy'),
            Cost: $translate.instant('Cost'),
            GDRevenue: $translate.instant('GDRevenue'),
            GDVAT: $translate.instant('GDVAT'),
            GDCost: $translate.instant('GDCost'),
            Inventory: $translate.instant('Inventory'),
            OrginalbeforeIntercompany: $translate.instant('OrginalbeforeIntercompany'),
            Notes: $translate.instant('Notes')
        };


        var mainModule = {

            main: function() {
                $scope.importDataModal = mainModule.importDataModal;
                $scope.chunkSize = 10 * 1024 * 1024;
                mainModule.initControls();

                $scope.toggleTriggerSyncHistory = mainModule.toggleTriggerSyncHistory;
                $scope.closeTriggerSyncHistory = mainModule.closeTriggerSyncHistory;

                mainModule.loadInvoiceData();

            },
            toggleTriggerSyncHistory: function(event) {

                vatOutputInvoiceManageService.getOutputInvoiceImportShipmentSyncHistory().success(function(data) {

                    if (data && data.length > 0) {
                        _.each(data, function(item) {
                            item.createTime = (new Date(item.createTime)).dateTimeToString('yyyyMMdd hh:mm');
                        });
                    }

                    $scope.syncHistoryList = data;

                    var mouseX = event.clientX;
                    var mouseY = event.clientY;
                    if (mouseX && mouseY) {
                        $('#shipmenthistory-pop-container').css({ 'top': mouseY - 32 + 'px', 'left': mouseX - 180 + 'px' }).css("display", 'block');
                    }

                });

            },

            closeTriggerSyncHistory: function() {
                $('#shipmenthistory-pop-container').hide(500);
            },

            // 初始化一些控件配置参数
            initControls: function() {

                $scope.searchEntity = {};
                var isShowClearButton = true;
                $scope.pagingOptions = {
                    pageIndex: 1, //当前页码
                    totalItems: 0, //总数据
                    pageSize: constant.page.pageSizeArrary[1], //每页多少条数据 
                };

                $scope.searchEntityOptions = {
                    //1. entity name
                    txtVINOptions: {
                        bindingOptions: {
                            value: 'searchEntity.vin',
                        },
                        // placeholder: $scope.pleaseSelect,
                        showClearButton: isShowClearButton,
                    }

                };


                $scope.loadInvoiceData = mainModule.loadInvoiceData;

                mainModule.initInvoiceGrid();
            },

            // 导入数据模态框
            importDataModal: function() {

                var editModel = {};

                $scope.editModel = editModel;

                var parent = angular.element($document[0].querySelector('#output-invoice-container'));
                var modalInstance = $uibModal.open({
                    animation: true,
                    // ariaLabelledBy: 'modal-title',
                    // ariaDescribedBy: 'modal-body',
                    templateUrl: 'importshipmentModal.html',
                    // windowClass: 'import-shipment-list-wrapper',
                    // appendTo: parent,
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                }, function() {
                    $scope.operateType = null;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });

                // 确定
                $scope.overlayUpload = function() {
                    mainModule.importData(modalInstance);
                };

                // 取消
                $scope.cancel = function() {
                    modalInstance.dismiss('cancel');
                };
            },

            // 覆盖导入
            overlayUpload: function() {
                mainModule.importData();
            },

            // 导入
            importData: function(modalInstance) {
                if (!$scope.editModel.file || !$scope.editModel.file.name) {

                    SweetAlert.info($translate.instant('SelectCustomerFileRequired'));
                    return;
                }

                var deferred = $q.defer();

                var tempFileName = PWC.newGuid() + '.dat';
                var token = $('input[name="__RequestVerificationToken"]').val();

                var uploadUrl = apiInterceptor.webApiHostUrl + '/outputInvoiceImportShipment/importShipment';

                $('#busy-indicator-container').show();
                Upload.upload({
                    url: uploadUrl,
                    data: {
                        cancel: false,
                        filename: $scope.editModel.file.name,
                        tempFileName: tempFileName
                    },
                    file: $scope.editModel.file,
                    resumeChunkSize: $scope.chunkSize,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken,
                        __RequestVerificationToken: token,
                        withCredentials: true
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(function(resp) {
                    var ret = resp.data;
                    $('#busy-indicator-container').hide();
                    deferred.resolve();
                    if (ret.result) {
                        // 全部导入成功
                        SweetAlert.success($translate.instant('ImportSuccess'));
                        modalInstance.close(ret);
                        mainModule.loadInvoiceData();
                    } else {

                        if (ret.resultMsg && ret.resultMsg.length > 0) {
                            SweetAlert.warning($translate.instant(ret.resultMsg));
                        } else {
                            SweetAlert.warning($translate.instant("ImportFailed"));
                        }
                    }

                }, function(resp) {
                    deferred.resolve();

                    if (resp.statusText === 'HttpRequestValidationException') {
                        SweetAlert.warning($translate.instant('HttpRequestValidationException'));
                    } else {
                        SweetAlert.warning('SaveFail');
                    }

                    console.log('Error status: ' + resp.status);
                }, function(evt) {
                    deferred.resolve();
                    var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                    $log.debug('progress: ' + progressPercentage + '% ' + evt.config.data.filename);
                });
            },

            // 初始化发票表
            initInvoiceGrid: function() {

                $scope.invoiceGridDataSource = [];
                $scope.invoiceEditGridOptions = {
                    bindingOptions: {
                        dataSource: 'invoiceGridDataSource'
                    },
                    // keyExpr: "ID",
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    // rowAlternationEnabled: true,
                    showBorders: true,
                    // height: '400px',
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    allowColumnReordering: true,
                    height: 400,
                    paging:{
                        enabled:false
                    },
                    onContentReady: function(e) {
                        $scope.invoiceGridInstance = e.component;
                    },
                    onSelectionChanged: function(data) {
                        mainModule.SelectedInvoiceList = data.selectedRowsData;
                    },
                    columns: [{
                            caption: "",
                            columns: [{
                                caption: "",
                                columns: [{ dataField: 'pgIweek', caption: thisConstant.PgiWeek }]
                            }]
                        },

                        {
                            caption: 'Step 3- From BD to Final Customer',
                            alignment: 'center',
                            columns: [{
                                    caption: "",
                                    columns: [
                                        { dataField: 'company', caption: thisConstant.Company },
                                        { dataField: 'companyVloolup', caption: thisConstant.Company }
                                    ]
                                },
                                {
                                    caption: "Account Code",
                                    columns: [
                                        { dataField: 'confirmationNumber', caption: thisConstant.ConfirmationNumber }
                                    ]
                                },
                                {
                                    caption: "",
                                    columns: [
                                        { dataField: 'vin', caption: thisConstant.VIN },
                                        { dataField: 'carType', caption: thisConstant.CarType },
                                        { dataField: 'isMarketingCar', caption: thisConstant.IsMarketingCar },
                                        { dataField: 'taxableSubtotal', caption: thisConstant.TaxableSubtotal, format: { type: 'fixedPoint', precision: 2 } }
                                    ]
                                },
                                {
                                    caption: "120000",
                                    columns: [
                                        { dataField: 'vehiclePriceafterDiscounts', caption: thisConstant.VehiclePriceafterDiscounts, format: { type: 'fixedPoint', precision: 2 } }
                                    ]
                                },
                                {
                                    caption: "220143",
                                    columns: [
                                        { dataField: 'vat', caption: thisConstant.VAT, format: { type: 'fixedPoint', precision: 2 } }
                                    ]
                                },
                                {
                                    caption: "400005",
                                    columns: [
                                        { dataField: 'revenue', caption: thisConstant.Revenue, format: { type: 'fixedPoint', precision: 2 } }
                                    ]
                                },
                                {
                                    caption: "400005",
                                    columns: [
                                        { dataField: 'discounts', caption: thisConstant.Discounts, format: { type: 'fixedPoint', precision: 2 } }
                                    ]
                                },
                                {
                                    caption: "472000 US/ 640990 CN",
                                    columns: [
                                        { dataField: 'subsidy', caption: thisConstant.Subsidy }
                                    ]
                                },
                                {
                                    caption: "502000",
                                    columns: [
                                        { dataField: 'cost', caption: thisConstant.Cost, format: { type: 'fixedPoint', precision: 2 } }
                                    ]
                                }
                            ]
                        },
                        {
                            caption: "Step 2- From GD to BD Intercompany",
                            columns: [{
                                    caption: "For GD 2060 Fapiao Issue",
                                    columns: [
                                        { dataField: 'gdRevenue', caption: thisConstant.GDRevenue, format: { type: 'fixedPoint', precision: 2 } },
                                        { dataField: 'gdvat', caption: thisConstant.GDVAT, format: { type: 'fixedPoint', precision: 2 } }
                                    ]
                                },
                                {
                                    caption: "",
                                    columns: [{ dataField: 'gdCost', caption: thisConstant.GDCost, format: { type: 'fixedPoint', precision: 2 } }]
                                }

                            ]

                        },
                        {
                            caption: "Current Invontory",
                            columns: [{
                                    caption: "130450",
                                    columns: [{ dataField: 'inventory', caption: thisConstant.Inventory, format: { type: 'fixedPoint', precision: 2 } }]
                                },
                                {
                                    caption: "Warehouse in WD",
                                    columns: [{ dataField: 'orginalbeforeIntercompany', caption: thisConstant.OrginalbeforeIntercompany }]
                                }
                            ]
                        },
                        {
                            caption: "",
                            columns: [{
                                caption: "",
                                columns: [{ dataField: 'notes', caption: thisConstant.Notes }]
                            }]
                        }
                    ]

                    // columns

                };
            },

            // 获取编辑发票数据
            loadInvoiceData: function() {

                var model = {
                    queryParam: $scope.searchEntity,
                    pagingParam: $scope.pagingOptions
                };


                var numberList = ['discounts', 'gdRevenue', 'gdvat', 'gdCost','subsidy'];
                var parseViewModel = function(r) {

                    numberList.forEach(function(column) {
                        if (r[column]) {

                            var value = r[column];
                            try {
                                if (value.indexOf('(') > -1 && value.indexOf(')') > -1) {
                                    value = value.replace(/[^\d.]/g, '');
                                    value = '(' + parseFloat(value).formatAmount() + ')';
                                } else if (value === '-') {

                                }  else if (value === '#N/A'){
                                    
                                }
                                else {
                                    value = value.replace(/[^\d.]/g, '');
                                    value = parseFloat(value).formatAmount();
                                }

                                r[column] = value;
                            } catch (e) {
                                $log.debug(e +'data:'  + value);
                            }
                        }
                    });
                    return r;
                };


                vatOutputInvoiceManageService.getImportShipmentList(model).success(function(data) {

                    if (data.list && data.list.length > 0) {
                        data.list.forEach(function(r) {
                            r = parseViewModel(r);
                        });
                    }
                    $scope.invoiceGridDataSource = data.list;
                    $scope.pagingOptions.totalItems = data.pageInfo.totalCount;

                    $timeout(function() {
                        $scope.setInvoiceGridHeight();
                    }, 50);
                });
            },

            // 转换时间格式
            parseData: function(result) {
                if (result && result.length > 0) {
                    result.forEach(function(row) {

                        if (row.lastModifiedBy) {
                            var d = window.PWC.parseFromLocalTimeString(row.lastModifiedBy);
                            row.lastModifiedBy = d.formatDateTime('yyyy-MM-dd');
                        }

                        var driverLicenseOrgCode = '';
                        if (row.driverLicense) {
                            driverLicenseOrgCode += row.driverLicense;
                        }

                        if (row.organizationCode) {
                            driverLicenseOrgCode += '/' + row.organizationCode;
                        }

                        row.driverLicenseOrgCode = driverLicenseOrgCode;

                        if (row.operateStatus === 0) {
                            row.status = "normal";
                        } else if (row.operateStatus === 1) {
                            row.status = "issued";
                        }
                    });
                }

                return result;
            },

            // 获取用户所属机构
            loadOwnerOrg: function() {
                userService.getUserOwnerOrganization().success(function(data) {
                    mainModule.OwnerOrgModel = data;
                });
            },
        };


        (function initialize() {
            $log.debug('importShipmentListController.ctor()...');
            mainModule.main();

        })();
    }
]);
invoiceModule.directive('importShipmentList', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('importShipmentList.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/import-shipment-list/import-shipment-list.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'importShipmentListController',
            link: function (scope, element) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var invoiceDataGridSelector = '#importShipmentListGridContainer';
                    var pageWrapSelector = ".import-shipment-list-wrapper";
                    var menuSelector = ".import-shipment-list-wrapper .header-title";
                    var contentHeader = '.import-shipment-content-container .header';
                    var contentbody = '.import-shipment-content-container .body';
                    var buttonRow = '.import-shipment-content-container .buttom-row';
                    var pageFooter = '.import-shipment-list-wrapper .page-footer';
                    var dxGridSelector = ".import-shipment-grid-container";

                    var pageHeight = $(document).height();// 810; // parseInt($(pageWrapSelector).css('height').replace('px', ''));

                    var menuHeight = $(menuSelector).outerHeight(); //parseInt($(menuSelector).css('height').replace('px', ''));

                    var contentHeaderHeight = $(contentHeader).outerHeight(); //parseInt($(contentHeader).css('height').replace('px', ''));
                    // var pageFooterHeight = $(pageFooter).outerHeight(); //parseInt($(pageFooter).css('height').replace('px', ''));

                    var pageFooterHeight = 0;
                    var contentbodyHeight = pageHeight - menuHeight - contentHeaderHeight;
                    var height = contentbodyHeight  - pageFooterHeight - 60 - 75 + 'px';
                    $(contentbody).css('height', contentbodyHeight);
                    // $(dxGridSelector).css('height', height);
                    //$(invoiceDataGridSelector).css('max-height', '100%');

                    try {

                        var option = $('#importShipmentListGridContainer').dxDataGrid('option');
                        option.height = height;
                        $('#importShipmentListGridContainer').dxDataGrid('option', option);
                        $(invoiceDataGridSelector).dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };


                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('outputInvoiceInfrastructureController', ['$scope', '$log', '$q', '$timeout', 'loginContext',
    '$translate', '$location', 'templateGroupService', 'citSessionService', 'vatReportService', '$state', 'vatSessionService',
function ($scope, $log, $q, $timeout, loginContext, $translate, $location, templateGroupService, citSessionService, vatReportService, $state, vatSessionService) {
    'use strict';
    $log.debug('outputInvoiceInfrastructureController.ctor()...');

    vatSessionService.clearSelectProject();

    var loadInvoiceMenu = function (permissionMap) {
        $scope.groups = [];
        var tempPermission = constant.vatPermission.outputInvoice;

        var outputInvoiceManagement = {
            id: '0',
            name: $translate.instant('OutputInvoiceManagement'),

            isExpand: true,
            children: [
            ]
        };

        if (permissionMap[tempPermission.importVehicelCase.queryCode]) {
            outputInvoiceManagement.children.push({ id: '1', name: $translate.instant('VehicleCaseIssuing'), sref: '.imported' });
        }

        if (permissionMap[tempPermission.bdInvoice.queryCode]) {
            outputInvoiceManagement.children.push({ id: '2', name: $translate.instant('EditFapiaoDetails'), sref: '.outputInvoiceEdit', className: 'sub-menu' });
            outputInvoiceManagement.children.push({ id: '3', name: $translate.instant('IssuedInvoicelist') + ' - ' + $translate.instant('BDView'), sref: '.issuedInvoiceBdView' });
            outputInvoiceManagement.children.push({ id: '8', name: $translate.instant('BDVinView'), sref: '.bdViewByVin' });
        }

        if (permissionMap[tempPermission.gdInvoice.queryCode]) {
            outputInvoiceManagement.children.push({ id: '5', name: $translate.instant('IssuedInvoicelist') + ' - ' + $translate.instant('GDView'), sref: '.issuedInvoiceGdView' });
        }


        if (permissionMap[tempPermission.gdShipment.queryCode]) {
            outputInvoiceManagement.children.push({ id: '6', name: $translate.instant('ImportShipmentListGd'), sref: '.importShipmentList', className: 'sub-menu' });
        }

        if (permissionMap[tempPermission.taxControlDisk.queryCode]) {
            outputInvoiceManagement.children.push({ id: '4', name: $translate.instant('TaxControlDisk') + ' - ' + $translate.instant('View'), sref: '.taxControlDisk' });
        }

        if (permissionMap[tempPermission.gdInvoice.queryCode]) {
            outputInvoiceManagement.children.push({ id: '7', name: $translate.instant('IssuedInvoiceSpecial'), sref: '.issuedInvoiceSpecial' });
            outputInvoiceManagement.children.push({ id: '8', name: $translate.instant('GDVinView'), sref: '.GDViewByVIN' });
        }


        if (outputInvoiceManagement.children && outputInvoiceManagement.children.length > 0) {
            $scope.groups.push(outputInvoiceManagement);
        }

        var reconciliationConfigGroup = {
            id: '1',
            name: $translate.instant('ReconciliationConfig'),

            isExpand: false,
            children: [

            ]
        };

        if (permissionMap[tempPermission.outputReconciliationOverview.queryCode]) {
            reconciliationConfigGroup.children.push({ id: '9', name: $translate.instant('OutputReconciliationOverview'), sref: '.outputReconciliationOverview' });
        }

        if (permissionMap[tempPermission.reconciliationConfig.queryCode]) {
            reconciliationConfigGroup.children.push({ id: '10', name: $translate.instant('OutputReconciliationConfiguration'), sref: '.outputReconciliationConfiguration' });
        }

        if (reconciliationConfigGroup.children && reconciliationConfigGroup.children.length > 0) {
            $scope.groups.push(reconciliationConfigGroup);
        }
    };

    var toggleGroup = function (group) {
        group.isExpand = !group.isExpand;
    };

    $scope.broadCastMenuClickEvent = function (sref) {
        if (sref.indexOf('issuedInvoiceBdView') > -1) {
            $scope.$broadcast('teslaOutputInvoiceMenuClick', {});
        }
        return true;
    };


    //检查用户机构权限
    var checkUserOrganizationPermissionList = function () {
        var list = [];
        var tempPermission = constant.vatPermission.outputInvoice;
        list.push(tempPermission.importVehicelCase.queryCode);
        list.push(tempPermission.bdInvoice.queryCode);
        list.push(tempPermission.gdInvoice.queryCode);
        list.push(tempPermission.gdShipment.queryCode);
        list.push(tempPermission.reconciliationConfig.queryCode);
        list.push(tempPermission.outputReconciliationOverview.queryCode);
        list.push(tempPermission.taxControlDisk.queryCode);
        $scope.$root.checkUserPermissionList(list).success(function (data) {

            console.log(JSON.stringify(data));
            var permissionMap = data;
            loadInvoiceMenu(permissionMap);
        });
    };


    (function initialize() {
        checkUserOrganizationPermissionList();
        $scope.expend = true;
        $scope.toggleGroup = toggleGroup;
    })();

}]);
invoiceModule.directive('outputInvoiceInfrastructure', ['$log', '$rootScope', '$timeout', 'enums',
    function ($log, $rootScope, $timeout, enums) {
        'use strict';

        $log.debug('invoiceInfrastructure.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/infrastructure/output-invoice-infrastructure.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                state: '='
            },
            controller: 'outputInvoiceInfrastructureController',
            link: function ($scope, $element, $attr) {

                Split(['#vat-report-nav-menu', '#vat-report-content'], {
                    sizes: [15, 85],
                    minSize: [10, 1330],
                    onDragEnd: function () {
                        $timeout(function () {
                            $rootScope.$broadcast(enums.vatEvent.layoutChanged, {});
                        }, 700);
                    }
                })


                $scope.isCollapsed = false;
            }
        };
    }
]);
invoiceModule.controller('invoiceConfirmController', ['$log', '$scope', '$translate', '$document', '$uibModal', '$timeout',
    'vatOutputInvoiceManageService', 'SweetAlert', 'enums', '$state', 'loginContext', 'orgService',
    function($log, $scope, $translate, $document, $uibModal, $timeout, vatOutputInvoiceManageService, SweetAlert, enums, $state, loginContext, orgService) {
        'use strict';


        var mainModule = {


            main: function() {
                $scope.editModel = {};

                mainModule.watchCollection();
            },

            getBdInvoiceInventory: function() {
                if (!$scope.model.taxControlDiskID) {
                    return;
                }



                var dataParse = function(data) {
                    var obj = {};

                    if ($scope.model.type === 1) {
                        obj.title = $translate.instant('ManualIssuingConfirm');
                        obj.text = $translate.instant('BDInvoiceConfirmText');
                        obj.secondTitle = $translate.instant('BDInvoiceConfirmSecondText');
                        obj.invoiceType = $translate.instant('TslCarInvoiceVehicle');

                    } else {
                        obj.title = $translate.instant('GDIssuingConfirm');
                        obj.text = $translate.instant('GDInvoiceConfirmText');
                        obj.secondTitle = $translate.instant('GDInvoiceConfirmSecondText');
                        obj.invoiceType = $translate.instant('TslOutInvoiceSpecial');
                    }

                    obj.list = [];
                    obj.list.push({ name: $translate.instant('InvoiceTypeColon'), value: obj.invoiceType });
                    obj.list.push({ name: $translate.instant('InvoiceInventoryColon'), value: data.inventory });
                    obj.list.push({ name: $translate.instant('NextInvoiceCodeColon'), value: data.nextInvoiceCode });
                    obj.list.push({ name: $translate.instant('NextInvoiceNoColon'), value: data.nextInvoiceNo });


                    if (data.inventory === 0) {

                        obj.inventoryType = 1;

                    } else if (data.inventory < data.thresholdValue) {

                        obj.inventoryType = 2;
                    } else {

                        obj.inventoryType = 3;
                    }

                    return obj;
                };

                vatOutputInvoiceManageService.getBdInvoiceInventory($scope.model.taxControlDiskID).then(function(data) {
                    if (data && data.data && data.data.data) {
                        $scope.preIssueEntity = data.data.data;
                    } else {
                        $scope.preIssueEntity.inventory = 0;
                        $scope.preIssueEntity.thresholdValue = 20;
                    }

                    var editModel = dataParse($scope.preIssueEntity);

                    mainModule.open(editModel);
                });
            },

            open: function(editModel) {

                $scope.editModel = editModel;

                var modalInstance = $uibModal.open({
                    animation: false,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'invoiceConfirmTemplate.html',
                    //windowClass: 'printInvoiceListModal',
                    size: 'invoice-confirm-size',
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    $scope.operateType = null;
                }, function() {
                    $scope.operateType = null;
                });


                $scope.confirm = function() {
                    if ($scope.onConfirm && $scope.editModel.inventoryType > 1) {
                        var obj = {

                            param: {},
                        };

                        $scope.onConfirm(obj);
                    }

                    modalInstance.close({});
                };

                // 取消
                $scope.cancel = function() {

                    modalInstance.dismiss('cancel');
                };
            },
            watchCollection: function() {
                $scope.$watch('operateType', function(newValue, oldValue) {
                    if (newValue) {

                        if (newValue === constant.Operation.Open) {
                            mainModule.getBdInvoiceInventory();
                        }
                    }
                });
            },

        };

        (function initialize() {
            mainModule.main();

        })();
    }
])
invoiceModule.directive('invoiceConfirm', ['$log', function ($log) {
    'use strict';

    console.log('gdInvoicePrint.ctor()...');
    $log.debug('gdInvoicePrint.ctor()...');
    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/invoiceConfirm/invoice-confirm.html' + '?_=' + Math.random(),
        scope:
        {
            model:'=',
            operateType: '=',
            onConfirm:'&',
        },
        controller: 'invoiceConfirmController',
        link: function (scope, element) {

        }
    };
}]);
invoiceModule.controller('issuedInvoiceBdViewController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate',
    '$q', 'apiInterceptor', '$interval', 'region', '$timeout', '$location', 'vatOutputInvoiceManageService', 'enums', '$state',
    'loginContext', 'modalAdapterService', 'Upload',
    function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout,
        $location, vatOutputInvoiceManageService, enums, $state, loginContext, modalAdapterService, Upload) {
        'use strict';

        //-----------------搜索对象定义-----------------//start
        var isShowClearButton = true;
        $scope.searchOptions = {};
        $scope.searchEntity = {};

        var gdStatusList = _.chain(enums.GDBDStatusEnum)
            .invert().pairs().map(function (x) {
                return [x[0], $translate.instant(x[1])];
            }).value();

        $scope.searchOptions.InvoiceNo = {
            width: "100%",
            placeholder: $translate.instant('InputPlaceholder'),
            showClearButton: isShowClearButton,
            bindingOptions: {
                value: 'searchEntity.invoiceNo',
            }
        };

        $scope.searchOptions.VIN = {
            width: "100%",
            placeholder: $translate.instant('InputPlaceholder'),
            showClearButton: isShowClearButton,
            bindingOptions: {
                value: 'searchEntity.VIN',
            }
        };

        $scope.searchOptions.IssuedPeriodStart = {
            type: 'date',
            width: "100%",
            placeholder: $translate.instant("ChoosePlaceholder"),
            showClearButton: isShowClearButton,
            bindingOptions: {
                value: 'searchEntity.startTime',
            },
            displayFormat: 'yyyy-MM-dd',
        };

        $scope.searchOptions.IssuedPeriodEnd = {
            type: 'date',
            width: '100%',
            placeholder: $translate.instant("ChoosePlaceholder"),
            showClearButton: isShowClearButton,
            bindingOptions: {
                value: 'searchEntity.endTime',
            },
            displayFormat: 'yyyy-MM-dd',
        };

        //$scope.searchOptions.VehicleModel = {
        //    width: "100%",
        //    placeholder: $translate.instant('InputPlaceholder'),
        //    showClearButton: isShowClearButton,
        //    bindingOptions: {
        //        value: 'searchEntity.vehicleModel'
        //    }
        //};

        $scope.searchOptions.gdStatus = {
            dataSource: gdStatusList,
            displayExpr: '1',
            valueExpr: '0',
            multiline: false,
            width: "100%",
            placeholder: $translate.instant("ChoosePlaceholder"),
            showDropButton: true,
            showClearButton: isShowClearButton,
            bindingOptions: {
                value: 'searchEntity.gdStatus'
            }
        },

        $scope.searchOptions.IssuanceType = {
            width: "100%",
            valueExpr: 'id',
            displayExpr: 'name',
            placeholder: $translate.instant("ChoosePlaceholder"),
            showClearButton: isShowClearButton,
            items: [{ name: '' }, { id: 1, name: 'Salesforce' }, { id: 2, name: 'Smart Tax' }, { id: 3, name: 'Local' }],
            bindingOptions: {
                value: 'searchEntity.issuanceType',
            }
        };

        $scope.toggleSearchContent = function () {
            if ($("#toggle-search-tr").css("display") == "none") {
                $(".hide-search-btn").addClass("fa-angle-up").html('&nbsp;&nbsp;Collapse');
                $(".hide-search-btn").removeClass("fa-angle-down");
            } else {
                $(".hide-search-btn").addClass("fa-angle-down").html('&nbsp;&nbsp;Expand');
                $(".hide-search-btn").removeClass("fa-angle-up");
            }
            $("#toggle-search-tr").toggle(200);
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 300);
        };
        //-----------------搜索对象定义-----------------//end

        //-----------------表格对象定义-----------------//start
        $scope.selectedIssuedInvoiceCount = 0;
        $scope.selectedIssuedInvoiceData = [];
        $scope.selectedIssuedInvoiceAmount = '0.00';

        $scope.dataGridOption = {
            keyExpr: 'id',
            showRowLines: true,
            showColumnLines: true,
            showBorders: true,
            allowColumnResizing: true,
            columnAutoWidth: true,
           // hoverStateEnabled: true,
            //rowAlternationEnabled: true,
           // allowColumnReordering: true,
            columnFixing: {
                enabled: true
            },
            paging: {
                enabled: false
            },
            columnChooser: {
                enabled: true
            },
            selection: {
                mode: 'multiple',
                showCheckBoxesMode: 'always'
            },
            bindingOptions: {
                dataSource: 'invoiceGridDataSource',
                height: 'dataGridHeight'
            },
            onSelectionChanged: function (e) {
                if (e && e.selectedRowsData) {
                    $scope.selectedIssuedInvoiceCount = e.selectedRowsData.length;
                    $scope.selectedIssuedInvoiceData = e.selectedRowsData;
                    var amount = 0;
                    _.each(e.selectedRowsData, function (item) {
                        if (item.subtotalforFinalPayment) {
                            amount += item.subtotalforFinalPayment;
                        }
                    });
                    $scope.selectedIssuedInvoiceAmount = amount.formatAmount(2);
                }
            }
        };

        $scope.dataGridOption.columns = [
            { dataField: 'invoiceNo', caption: $translate.instant('InvoiceNo'),fixed:true },
            { dataField: 'invoiceCode', caption: $translate.instant('InvoiceCode'), fixed: true },
            { dataField: 'vin', caption: $translate.instant('VIN') },
            { dataField: 'caseNumber', caption: $translate.instant('InvoiceCaseNum') },
            { dataField: 'vehicleModel', caption: $translate.instant('ModelSeriesG') },
            { dataField: 'cabinConfiguration', caption: $translate.instant('CabinConfig') },
            { dataField: 'registrationLocalName', caption: $translate.instant('RegistrationLocalName') },
            { dataField: 'issuedDate', caption: $translate.instant('IssuedDate')},
            {
                dataField: 'subtotalforFinalPayment', caption: $translate.instant('SubtotalForFinalPayment'),
                format: { type: 'fixedPoint', precision: 2 }
            },
            { dataField: 'issuranceType', caption: $translate.instant('IssuranceType') },
            { dataField: 'bdStatus', caption: $translate.instant('BDStatus')},
            {
                dataField: 'gdBdStatus', caption: $translate.instant('GDBDStatus'),
                cellTemplate: function (ele, info) {
                    if (info && info.value) {
                        if (info.value === 'Issued') {
                            $('<span>')
                                .html(info.value + '&nbsp;&nbsp;<i style="color: #b22;font-size: 22px; vertical-align: middle; cursor: pointer;" class="fa fa-arrow-circle-o-left"></i>')
                                .appendTo(ele)
                                .on('dxclick', function (e) {
                                    //执行红冲GD-BD发票操作
                                    if (e.target.localName === 'i') {
                                        $scope.redLetterGdBdInvoice(info.data);
                                    }
                                });
                        } else {
                            $('<span>').text(info.value).appendTo(ele);
                        }
                    }
                }
            },
            {
                caption: $translate.instant('Action'), alignment: 'left', cellTemplate: function (ele, info) {
                    $('<a/>').css({ 'color': '#6699cc', 'cursor': 'pointer' }).text($translate.instant('View')).on('dxclick', function () {
                        $scope.invoiceOperateType = constant.Operation.Query;
                        $scope.invoiceModel = info.data;
                    }).appendTo(ele);

                    var checkDateStart = new Date().dateAdd('d', -1 * (new Date().getDate() + 180)).dateTimeToString('yyyyMMdd');
                    var checkDateEnd = new Date().dateAdd('d', -1 * new Date().getDate()).dateTimeToString('yyyyMMdd');

                    if (info.data.bdStatus != 'Red-lettered' && info.data.bdStatus != 'Cancelled' &&
                        info.data.issuedDate >= checkDateStart && info.data.issuedDate <= checkDateEnd) {
                        var element = $('<a/>');
                        element.css({ 'color': '#6699cc', 'cursor': 'pointer', 'margin-left': '10px' }).text($translate.instant('Red Letter')).on('dxclick', function () {
                            $scope.redLetterBdUserInvoice(info.data, element);
                        }).appendTo(ele);
                    }
                }
            }
        ];

        //获取数据服务
        $scope.getOutputInvoicePrintedList = function () {
            var deferred = $q.defer();

            var invoiceParams = {
                QueryParam: $scope.searchEntity,
                PagingParam: $scope.pagingOptions,
            };

            vatOutputInvoiceManageService.getIssuedVehicleBdList(invoiceParams).success(function (data) {
                if (data && data.list) {
                    $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                    data.list.forEach(function (item) {
                        item.invoiceNo = item.invoiceNumber;
                        item.invoiceCase = '';
                        item.issuedDate = item.bdIssuedDate ? (new Date(item.bdIssuedDate)).dateTimeToString('yyyyMMdd') : '';
                        item.caseCollectionDate = item.caseCollectionDate ? (new Date(item.caseCollectionDate)).dateTimeToString('yyyyMMdd') : '';
                        item.issuranceType = $translate.instant(PWC.getEnumKeyByValue(enums.IssuanceType, item.issuranceType));
                        item.bdStatus = $translate.instant(PWC.getEnumKeyByValue(enums.BDStatusEnum, item.bdStatus));
                        if (PWC.getEnumKeyByValue(enums.GDBDStatusEnum, item.gdBdStatus) === 'readyToIssue') {
                            item.gdBdStatus = '';
                        }else{
                            item.gdBdStatus = $translate.instant(PWC.getEnumKeyByValue(enums.GDBDStatusEnum, item.gdBdStatus));
                        }
                        if (!item.cabinConfiguration) {
                            item.cabinConfiguration = $translate.instant('FiveSeatInterior');
                        }
                    });
                   
                    $scope.invoiceGridDataSource = data.list;
                    //清除选中状态
                    $("#dxIssuedInvoiceDataGridContainer").dxDataGrid('instance').clearSelection();
                    deferred.resolve(data);
                };
            });
            return deferred.promise;
        };

        //设置dataGrid分页
        $scope.pagingOptions = {
            pageIndex: 1,  //当前页码
            totalItems: 100,  //总数据
            totalPages: 10,//总页数
            maxSize: 10, //分页数字的限制。
            pageSize: 20,  //每页多少条数据 
            pageSizeString: '20',
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //分页里面的处理
        $scope.pagingService = {
            setPage: function (pageNo) {

            },
            //分页的时候改变数字
            pageIndexChanging: function () {
                if ($scope.pagingOptions.pageIndex > $scope.pagingOptions.totalPages) {
                    $scope.pagingOptions.pageIndex = $scope.pagingOptions.totalPages;
                }

                $log.log('Page changed to: ' + $scope.pagingOptions.pageIndex);
                $scope.getOutputInvoicePrintedList();
            },

            //每页显示的数据下拉改变
            pageSizeSelectionChanged: function () {
                $scope.pagingOptions.pageSize = parseInt($scope.pagingOptions.pageSizeString);
                $scope.getOutputInvoicePrintedList();
            }
        };

        //-----------------表格对象定义-----------------//end

        //-----------------发票操作定义-----------------//start

        //红冲BD-User Invoice
        $scope.redLetterBdUserInvoice = function (data,element) {

            var redLetterBdUserPopController = function ($scope) {
                $scope.redLetterData = {};
                $scope.redLetterData.needReasonRdio = 1;

                $scope.redLetterData.inputReasonOption = {
                    width: '100%',
                    height: 60,
                    bindingOptions: {
                        value: 'redLetterData.inputReason'
                    }
                };
                $scope.validateOption = {};
                $scope.validateOption.inputReasonOption = {
                    validationRules: [{
                        type: "required",
                        message: $translate.instant('BdUserRedLetterWarningInfoInputRequired')
                    }, {
                        type: 'stringLength',
                        max: 500,
                        message: $translate.instant('BdUserRedLetterWarningInfoInputLengthCheck')
                    }]
                };

                var addBdUserRedLetterReason = function (files) {
                    var reasonData = {};
                    reasonData.invoicingReasonIndex = $scope.redLetterData.needReasonRdio;
                    if ($scope.redLetterData.needReasonRdio == 2) {
                        reasonData.inputReason = $scope.redLetterData.inputReason;
                    }
                    reasonData.isRecievingAll = $scope.redLetterData.isRevievingAll ? 1 : 0;
                    reasonData.invoiceID = data.id;
                    reasonData.caseNumber = data.caseNumber;

                    //用户首字母大写
                    var tmpChar = loginContext.userName.substring(0, 1).toUpperCase();
                    var postString = loginContext.userName.substring(1, loginContext.userName.length);
                    var tmpStr = tmpChar + postString;
                    reasonData.createBy = tmpStr;

                    //设置附件
                    if (files && files.length > 0) {
                        var fileIds = [];
                        _.each(files, function (item) {
                            fileIds.push(item.data.fileID);
                        });
                        reasonData.evidenceDocuments = fileIds.join(',');
                    }

                    var deffered = $q.defer();
                    vatOutputInvoiceManageService.addBdUserRedLetterReason(reasonData).success(function (data) {
                        deffered.resolve(data);
                    });
                    return deffered.promise;
                };

                //BD红冲检查。
                var checkDataAvailable = function (files) {
                    if ($scope.redLetterData.needReasonRdio == 2) {

                        var dxResult = DevExpress.validationEngine.validateGroup($('#reasonModalForm').dxValidationGroup("instance")).isValid;
                        if (!dxResult) {
                            return;
                        }

                        if (!$scope.redLetterData.inputReason) {
                            SweetAlert.warning($translate.instant('BdUserRedLetterWarningInfoInputRequired'));
                            return false;
                        } else if ($scope.redLetterData.inputReason.length > 500) {
                            SweetAlert.warning($translate.instant('BdUserRedLetterWarningInfoInputLengthCheck'));
                            return false;
                        }
                    }
                    if (!files || files.length < 1 || !$scope.redLetterData.isRevievingAll) {
                        //检查证明文件
                        if (!files || files.length < 1) {
                            $('#UploadFileCheckTipId').show();
                        } else {
                            $('#UploadFileCheckTipId').hide();
                        }
                        if (!$scope.redLetterData.isRevievingAll) {
                            $('#CancelDialogTextTipId').show();
                        } else {
                            $('#CancelDialogTextTipId').hide();
                        }
                        return false;
                    } else {
                        $('#UploadFileCheckTipId').hide();
                        $('#CancelDialogTextTipId').hide();
                    }
                    return true;
                };

                $scope.$watch('$parent.uploadFileOption.files', function (newValue, oldValue) {
                    if (newValue && newValue != oldValue) {
                        var files = $scope.$parent.uploadFileOption.files;
                    }
                });

                //上传文件
                $scope.uploadFile = function () {
                    $scope.$parent.uploadFileType = 'multiple';
                    $scope.$parent.uploadFileOption = {
                        title: 'Upload Evidence Document',
                        uploadButtonText: 'Select Upload Files',
                        files: $scope.$parent.uploadFileOption.files || []
                    };
                }

                //关闭弹窗口
                $scope.hidePopPanel = function () {
                    $scope.$parent.uploadFileOption = {};
                    $scope.$dismiss({ $value: 'cancel' });
                };

                //删除证据文件
                $scope.deleteEvidenceFile = function (fileId) {
                    var fileList = [fileId];
                    vatOutputInvoiceManageService.deleteEvidenceFile(fileList).then(function () {
                        $scope.$parent.uploadFileOption.files = _.filter($scope.$parent.uploadFileOption.files, function (item) {
                            return item.data.fileID != fileId;
                        });
                    });
                }

                //下载证据文件
                $scope.downloadEvidenceFile = function (data) {
                    var queryDto = {};
                    queryDto.fileName = data.fileName;
                    queryDto.filePath = data.filePath;
                    vatOutputInvoiceManageService.downloadEvidenceFile(queryDto);
                };

                //执行红冲发票
                $scope.confirmRedLetterInvoice = function (files) {
                    if (checkDataAvailable(files)) {
                        //调用红冲接口
                        vatOutputInvoiceManageService.redLetterInvoice(data.id).then(function () {
                            //保存红冲原因及附件。
                            var promise = addBdUserRedLetterReason(files);
                            promise.then(function (data) {
                                //红冲结束隐藏红冲按钮。
                                element.hide();
                                $scope.$parent.uploadFileOption = {};
                                $scope.$dismiss({ $value: 'cancel' });
                                $scope.getOutputInvoicePrintedList();
                            });
                        });
                    }
                };

            };

            var parentElem = angular.element($document[0].querySelector('#red-letter-bd-user-pop'));
            var modalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'red-letter-bd-user-page.html',
                controller: redLetterBdUserPopController,
                windowClass: 'data-table',
                appendTo: parentElem,
                scope: $scope
            });
        };


        //红冲GD-BD Invoice (只改GD-BD发票中的该车的状态为Pending For Approval)
        $scope.redLetterGdBdInvoice = function (data) {
            //vatOutputInvoiceManageService.sendEmail(data.vin);
            //vatOutputInvoiceManageService.receiveEmail();
            var redLetterGdBdInvoiceController = function ($scope) {
                $scope.data = data;
                if (data.vin) {
                    vatOutputInvoiceManageService.getOutputInvoiceImportedByVin(data.vin).success(function (result) {
                        //排除自己
                        result = _.filter(result, function (item) {
                            return item.bdFapiaoEntity != data.bdFapiaoEntity ||
                                   item.registrationLocalName != data.registrationLocalName ||
                                   item.companyVATIDTaxID != data.companyVATIDTaxID ||
                                   item.organizationCode != data.organizationCode;
                        });
                        $scope.data.BDList = result;
                    });
                }


                $scope.data = data;
                //关闭弹窗口
                $scope.hidePopPanel = function () {
                    $scope.$dismiss({ $value: 'cancel' });
                };

                //执行更新GD-BD车辆 invoice status
                $scope.confirmRedLetterInvoice = function () {
                    vatOutputInvoiceManageService.updateInvoiceVichelGdBdStatus(data.id, enums.GDBDStatusEnum.pendingForApproval).success(function () {
                        $scope.$dismiss({ $value: 'cancel' });
                        $scope.getOutputInvoicePrintedList();
                        vatOutputInvoiceManageService.sendEmail(data.vin,data.id);
                    });
                };

                $scope.dataGridGdBdOptions = {
                    showRowLines: true,
                    showColumnLines: true,
                    showBorders: true,
                    allowColumnResizing: true,
                    hoverStateEnabled: true,
                    rowAlternationEnabled: true,
                    bindingOptions: {
                        dataSource: 'data.BDList'
                    },
                    columns: [
                                { dataField: 'bdFapiaoEntity', caption: 'Entity', width: '25%' },
                                { dataField: 'registrationLocalName', caption: 'Customer name', width: '25%' },
                                { dataField: 'companyVATIDTaxID', caption: 'Customer tax ID or National ID', width: '25%' },
                                { dataField: 'organizationCode', caption: 'Organization Code (if applicable)', width: '25%' }
                    ]
                };

                $timeout(function () {
                    $scope.dataGridGdBdOptions.height = 130;
                }, 500);

            };

            var parentElem = angular.element($document[0].querySelector('#red-letter-gd-bd-pop'));
            var modalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'red-letter-gd-bd-page.html',
                controller: redLetterGdBdInvoiceController,
                windowClass: 'data-table',
                appendTo: parentElem,
                scope: $scope
            });
        };

        $scope.cancelCore = function () {
            //调用取消发票接口执行取消发票功能。
            var promiss = [];
            var data = $scope.selectedIssuedInvoiceData;

            //已红冲和已取消的发票不能再做取消操作。
            var canCancelDatas = [];
            var negativeDatas = [];
            _.each(data, function (item) {
                if (item.bdStatus == enums.BDStatusEnum.Cancelled || item.bdStatus == enums.BDStatusEnum.RedLettered) {
                    canCancelDatas.push(item);
                }
            });

            _.each(data, function (item) {
                if (item.subtotalforFinalPayment < 0) {
                    negativeDatas.push(item);
                }
            });
            if (canCancelDatas.length > 0) {
                SweetAlert.warning($translate.instant('BDFapiaoCancelCheck')
                    .replace('{0}', _.pluck(canCancelDatas, 'invoiceNumber').join(',')));
                return;
            }

            if (negativeDatas.length > 0) {
                SweetAlert.warning($translate.instant('NegativeFapiaoCheck')
                    .replace('{0}', _.pluck(negativeDatas, 'invoiceNumber').join(',')));
                return;
            }

            _.each(data, function (item) {
                var cancelPromiss = vatOutputInvoiceManageService.cancelInvoice(item.id, $scope.isReprint);
                promiss.push(cancelPromiss);
            });
            $q.all(promiss).then(function () {
                modalAdapterService.close(constant.OutputInvoiceCancalDialog, "issued-invoice-bd-view-container");
                $scope.getOutputInvoicePrintedList();                
            },
            //可能有错误的时候
            function (err) {
                SweetAlert.error('', $translate.instant('CommonFail'));
            });
        };
        //取消发票
        $scope.CancelInvoice = function (data, reprint) {
            if (!data || data.length < 1) {
                SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                return;
            }
            $scope.title = reprint ? $translate.instant("CancelReprintInvoiceBDTitle") : $translate.instant("CancelInvoiceBDTitle")
            $scope.isReprint = reprint ? reprint : false;
            modalAdapterService.open(constant.OutputInvoiceCancalDialog, "issued-invoice-bd-view-container");
        };

        //-----------------发票操作定义-----------------//end

        //Upload Vin file define -->start
        var resumable = true;
        $scope.chunkSize = 500 * 1024;
        $scope.uploadOption = {};
        $scope.uploadOption.uploadFiles = [];
        $scope.$watch('uploadOption.uploadFiles', function (newValue, oldValue) {
            if (newValue && newValue !== oldValue) {
                uploadfile($scope.uploadOption.uploadFiles);
            }
        });

        //执行上传文件操作。
        var uploadfile = function (file) {
            if (file) {
                var uploadSuccessCallBack = function (data) {
                    var result = data;
                };

                var uploadSuccess = function (data) {
                    //根据上传的vin勾选发票
                    var result = data;
                    var gridInstance = $('#dxIssuedInvoiceDataGridContainer').dxDataGrid('instance');
                    var selectedInvoices = _.filter($scope.invoiceGridDataSource, function (item) {
                        return result.data.indexOf(item.vin) >= 0;
                    });
                    var selectedKeys = _.pluck(selectedInvoices, 'id');
                    gridInstance.selectRows(selectedKeys,true);
                };

                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();
                    Upload.upload({
                        url: apiInterceptor.webApiHostUrl + '/outputInvoicePrinted/uploadVinFile',
                        data: {
                            cancel: false,
                            filename: file.name,
                            tempFileName: tempFileName,
                            file: file,
                            period: $scope.period
                        },
                        resumeChunkSize: resumable ? $scope.chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadSuccess, uploadSuccessCallBack);
                }
            }
        };//Upload Vin file define -->end

        $scope.$on('teslaOutputInvoiceMenuClick', function (event, data) {
            //设置表格高度
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 500);
        });


        $scope.printGDInvoice = function () {

            if (!$scope.selectedIssuedInvoiceData || $scope.selectedIssuedInvoiceData.length === 0) {
                SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));

                return;
            };

            $state.go('outputInvoiceManage.gdInvoicePrint', { invoiceList: $scope.selectedIssuedInvoiceData });
        };

        (function () {
            var promise = $scope.getOutputInvoicePrintedList();
            $scope.uploadFileType = null;
            $scope.uploadFileOption = {};


            promise.then(function () {
                //设置表格高度
                $timeout(function () {
                    $scope.setInvoiceGridHeight();
                }, 500);
            });
        })();
    }
]);
invoiceModule.directive('issuedInvoiceBdView', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('issuedInvoiceBdView.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/issued-Invoice-Bd-View/issued-Invoice-Bd-View.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'issuedInvoiceBdViewController',
            link: function (scope, element) {

                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var pageHeight = $(document).height();
                    var pageSearchHeight = $('.page-search-container').outerHeight();
                    var pageFastSearchHeight = $('.page-fast-search-container').outerHeight();
                    var dataGridPagerHeight = $('.page-footer').outerHeight();
                    var subHeight = pageHeight - pageSearchHeight - pageFastSearchHeight - dataGridPagerHeight;
                    scope.dataGridHeight = subHeight - 80;

                    try {
                        $('#dxIssuedInvoiceDataGridContainer').dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };

                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('issuedInvoiceGdViewController', ['$scope', '$log', '$document', '$uibModal', '$translate',
    '$q', '$interval', '$timeout', '$location', '$state', 'SweetAlert', 'orgService', 'vatOutputInvoiceManageService',
    'enums', 'messagebox',
    function ($scope, $log, $document, $uibModal, $translate, $q, $interval, $timeout, $location, $state, SweetAlert,
        orgService, vatOutputInvoiceManageService, enums, messagebox) {
        'use strict';
        var maxValueLimit = 1000000000.00;
        var bdOptionTemplate = {
            displayExpr: 'displayName',
            valueExpr: 'code',
            width: "100%",
            placeholder: $translate.instant("ChoosePlaceholder"),
            bindingOptions: {
                value: 'searchEntity.bd'
            },
            itemTemplate: 'bdList',
            showClearButton: true
        };

        var bdEntityList = [];

        var vrlOptionTemplate = {
            displayExpr: 'name',
            valueExpr: 'name',
            width: "100%",
            placeholder: $translate.instant("ChoosePlaceholder"),
            bindingOptions: {
                value: 'searchEntity.vrl'
            },
            itemTemplate: 'vrlList'
        };

        var init = function () {
            $scope.selectedItems = [];
            $scope.selectedTotalAmount = 0;
            $scope.invoiceMarkupRatioEntity = {};
            $scope.invoiceQuotaEntity = {};
            $scope.preIssueEntity = {};
            $scope.selectedGDInvoiceID = null;

            thisService.getinvoiceQuota();
        };

        //-----------------搜索对象定义-----------------//start
        var isShowClearButton = true;
        var gdStatusList = _.chain(enums.GDBDStatusEnum)
            .invert().pairs().map(function (x) {
                return [x[0], $translate.instant(x[1])];
            }).value();
        var bdStatusList = _.chain(enums.BDStatusEnum)
            .invert().pairs().map(function (x) {
                return [x[0], $translate.instant(x[1])];
            }).value();
        $scope.searchEntity = {};
        $scope.searchOptions = {
            invoiceNo: {
                width: "100%",
                placeholder: $translate.instant("InputPlaceholder"),
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'searchEntity.invoiceNo'
                }
            },
            vin: {
                width: "100%",
                placeholder: $translate.instant("InputPlaceholder"),
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'searchEntity.vin'
                }
            },
            gdStatus: {
                dataSource: gdStatusList,
                displayExpr: '1',
                valueExpr: '0',
                multiline: false,
                width: "100%",
                placeholder: $translate.instant("ChoosePlaceholder"),
                showDropButton: true,
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'searchEntity.gdStatus'
                }
            },
            bdStatus: {
                dataSource: bdStatusList,
                displayExpr: '1',
                valueExpr: '0',
                multiline: false,
                width: "100%",
                placeholder: $translate.instant("ChoosePlaceholder"),
                showDropButton: true,
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'searchEntity.bdStatus'
                }
            },
            issuedPeriodStart: {
                type: 'date',
                width: "100%",
                placeholder: $translate.instant("ChoosePlaceholder"),
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'searchEntity.startTime'
                },
                displayFormat: 'yyyy-MM-dd',
            },
            issuedPeriodEnd: {
                type: 'date',
                width: "100%",
                placeholder: $translate.instant("ChoosePlaceholder"),
                showClearButton: isShowClearButton,
                bindingOptions: {
                    value: 'searchEntity.endTime',
                },
                displayFormat: 'yyyy-MM-dd',
            },
            markupRatio: 0,
            invoiceQuota: 10000000
        };

        $scope.toggleSearchContent = function () {
            if ($(".toggle-search-tr").css("display") == "none") {
                $(".hide-search-btn").addClass("fa-angle-up").html('&nbsp;&nbsp;Collapse');
                $(".hide-search-btn").removeClass("fa-angle-down");
            } else {
                $(".hide-search-btn").addClass("fa-angle-down").html('&nbsp;&nbsp;Expand');
                $(".hide-search-btn").removeClass("fa-angle-up");
            }
            $(".toggle-search-tr").toggle(200);
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 300);
        };

        //-----------------搜索对象定义-----------------//end

        //-----------------表格对象定义-----------------//start
        $scope.dataGridOption = {
            keyExpr: 'id',
            showRowLines: true,
            showColumnLines: true,
            showBorders: true,
            allowColumnReordering: true,
            allowColumnResizing: true,
            columnAutoWidth: true,
            hoverStateEnabled: true,
            columnFixing: {
                enabled: true
            },
            columnChooser: {
                enabled: true
            },
            paging: {
                enabled: false
            },
            selection: {
                mode: 'multiple',
                showCheckBoxesMode: 'always'
            },
            bindingOptions: {
                dataSource: 'invoiceGridDataSource',
                height: 'dataGridHeight'
            },
            onSelectionChanged: function (s) {
                $scope.selectedItems = s.selectedRowsData;
                $scope.selectedTotalAmount = _.reduce(s.selectedRowsData, function (memo, item) {
                    return memo + item.amountAdjusted;
                }, 0);
            }
        };

        $scope.dataGridOption.columns = [
            { dataField: 'entityName', caption: $translate.instant('BDName'), alignment: 'left' },
            { dataField: 'vehicleroutinglocation', caption: $translate.instant('VRL'), alignment: 'left' },
            { dataField: 'vin', caption: $translate.instant('VIN'), alignment: 'left' },
            { dataField: 'invoiceNumber', caption: $translate.instant('InvoiceNo'), alignment: 'left', visible: false },
            { dataField: 'invoiceCode', caption: $translate.instant('InvoiceCode'), alignment: 'left', visible: false },
            { dataField: 'bdIssuedDate', caption: $translate.instant('IssuedDate'), alignment: 'left' },
            {
                dataField: 'amount', format: 'currency', precision: 2,
                caption: $translate.instant('SubtotalForFinalPayment'), alignment: 'right'
            },
            {
                dataField: 'amountAdjusted', format: 'currency', precision: 2,
                caption: $translate.instant('AmountAdjusted'), alignment: 'right'
            },
            { dataField: 'deliveryStatus', caption: $translate.instant('DeliveryStatus'), alignment: 'left' },
            {
                dataField: 'gdBdStatusStr', caption: $translate.instant('GDStatus'), alignment: 'left'
            },
            {
                caption: $translate.instant('ViewGDBDFapiao'), alignment: 'left',
                cellTemplate: function (ele, info) {
                    if (info.data.buyerOrganizationCode && info.data.gdIssuedId) {
                        $('<a/>').css({ 'color': '#923', 'cursor': 'pointer' })
                            .text($translate.instant('IssuedTo') + info.data.buyerOrganizationCode)
                            .on('dxclick', function () {
                                dataService.showGdInvoice(info.data.gdIssuedId, info.data.gdBdStatus);
                            }).appendTo(ele);
                    }
                }
            },
            { dataField: 'bdStatusStr', caption: $translate.instant('BDStatus'), alignment: 'left' },
            {
                caption: $translate.instant('BDFapiao'), alignment: 'left',
                cellTemplate: function (ele, info) {
                    $('<a/>').css({ 'color': '#923', 'cursor': 'pointer' })
                        .text($translate.instant('View'))
                        .on('dxclick', function () {
                            $scope.invoiceOperateType = constant.Operation.Query;
                            $scope.invoiceModel = info.data;
                        }).appendTo(ele);
                }
            },
            { dataField: 'caseNumber', caption: $translate.instant('InvoiceCaseNo'), alignment: 'left', visible: false },
            { dataField: 'vehicleModel', caption: $translate.instant('VehicleModel'), alignment: 'left', visible: false }
           /* { dataField: 'caseCollectionDate', caption: $translate.instant('CaseCollectionDate'), alignment: 'left', visible: false } */
        ];
        //-----------------表格对象定义-----------------//end

        //-----------------数据服务-----------------//start
        var dataService = {
            //筛选invoice list
            search: function () {
                var deferred = $q.defer();

                var invoiceParams = {
                    queryParam: $scope.searchEntity,
                    pagingParam: $scope.pagingOptions,
                };

                vatOutputInvoiceManageService.getIssuedInvoiceGdList(invoiceParams).success(function (data) {
                    if (data && data.list) {
                        $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                        data.list.forEach(function (item) {
                            var entity = _.findWhere(bdEntityList, { code: item.bdFapiaoEntity });

                            item.gdIssuedDate = item.gdIssuedDate ? (new Date(item.gdIssuedDate)).dateTimeToString('yyyyMMdd') : '';
                            item.bdIssuedDate = item.bdIssuedDate ? (new Date(item.bdIssuedDate)).dateTimeToString('yyyyMMdd') : '';
                            item.caseCollectionDate = item.caseCollectionDate ? (new Date(item.caseCollectionDate)).dateTimeToString('yyyyMMdd') : '';
                            item.entityName = entity ? (entity.code + ' ' + entity.name) : '';
                            item.amount = item.subtotalforFinalPayment;

                            if (item.printedType == 2) {
                                item.amountAdjusted = null;
                            } else {
                                item.amountAdjusted = (1 - $scope.searchOptions.markupRatio) * item.taxableSubtotal;
                            }

                            item.bdStatusStr = $translate.instant(PWC.getEnumKeyByValue(enums.BDStatusEnum, item.bdStatus));
                            item.gdBdStatusStr = $translate.instant(PWC.getEnumKeyByValue(enums.GDBDStatusEnum, item.gdBdStatus));
                            //fix bug 12828
                            if (item.gdBdStatus === enums.GDBDStatusEnum.readyToIssue) {
                                if (item.bdStatus !== enums.BDStatusEnum.NormalStatus
                                    && item.bdStatus !== enums.BDStatusEnum.Matched
                                    //fix bug 13668
                                    && item.bdStatus !== enums.BDStatusEnum.Duplicated) {
                                    item.gdBdStatusStr = "";
                                }
                                if (item.isBDRed) {
                                    item.gdBdStatusStr = "";
                                }
                            }


                        });
                        var source = data.list;
                        //fix bug13147
                        //这里使用==而不使用===，是因为$scope.searchEntity.gdStatus这个是字符串，enums.GDBDStatusEnum.readyToIssue这个是数字
                        //故"3"==3 true "3"===3 false 这里需要"3"==3
                        //if ($scope.searchEntity.readyToIssue || $scope.searchEntity.gdStatus == enums.GDBDStatusEnum.readyToIssue) {
                        //    source = _.filter(source, function (item) {
                        //        return item.gdBdStatusStr !== "";
                        //    });
                        //}
                        $scope.invoiceGridDataSource = source;
                        deferred.resolve(data);
                    };
                });
                return deferred.promise;
            },

            getBdList: function () {
                return orgService.getBdList().then(function (data) {
                    if (data && data.data) {
                        //data.data.unshift({
                        //    id: '',
                        //    name: '',
                        //    code: '',
                        //    vehicleroutinglocation: ''
                        //});

                        _.each(data.data, function (x) {
                            x.displayName = x.code + ' ' + x.name;
                        });
                        return $q.when(data.data);
                    }
                    else {
                        return $q.when(null);
                    }
                }).then(function (data) {
                    bdEntityList = data;
                    $scope.searchOptions.bd = _.extend(bdOptionTemplate, {
                        dataSource: data
                    });

                    // Get VRL list
                    var vrlList = _.chain(data).reject(function (x) {
                        return _.isEmpty(x.vehicleroutinglocation);
                    }).map(function (x) {
                        return { name: x.vehicleroutinglocation };
                    }).sortBy(function (x) {
                        return x.name;
                    }).uniq(true, function (x) {
                        return x.name;
                    }).value();
                    vrlList.unshift({ name: '' });

                    $scope.searchOptions.vrl = _.extend(vrlOptionTemplate, {
                        dataSource: vrlList
                    });

                    return $q.when(data);
                });
            },

            showGdInvoice: function (id, gdStatus) {
                $scope.selectedGDInvoiceID = id;
                $scope.selectedGDInvoiceStatus = gdStatus;
                $scope.$broadcast("openGDDetailDialog");
            },

            checkStatusBeforeIssue: function () {
                if (!$scope.selectedItems || $scope.selectedItems.length === 0) {
                    messagebox.warning('SelectBdInvoiceCheck');
                    return false;
                };
                //BD 红票不能开GD票
                var redInvoice = _.where($scope.selectedItems, { isBDRed: true });
                if (redInvoice && redInvoice.length > 0) {
                    messagebox.warning('RedInvoiceWarrning');
                    return false;
                }
                var unmatched = _.where($scope.selectedItems, { bdStatus: enums.BDStatusEnum.Unmatched });
                if (!_.isEmpty(unmatched)) {
                    SweetAlert.warning($translate.instant('BDStatusUnmatched')
                        .replace('{0}', _.pluck(unmatched, 'vin').join(',')));
                    return false;
                }

                var cancelledOrRedLettered = _.filter($scope.selectedItems, function (x) {
                    return x.bdStatus === enums.BDStatusEnum.Cancelled || x.bdStatus === enums.BDStatusEnum.RedLettered;
                });
                if (!_.isEmpty(cancelledOrRedLettered)) {
                    SweetAlert.warning($translate.instant('BDStatusCancelled')
                        .replace('{0}', _.pluck(cancelledOrRedLettered, 'vin').join(',')));
                    return false;
                }

                var gdNotReadyToIssue = _.filter($scope.selectedItems, function (x) {
                    return x.gdBdStatus !== enums.GDBDStatusEnum.readyToIssue
                        && x.gdBdStatus !== enums.GDBDStatusEnum.redLettered
                        && x.gdBdStatus !== enums.GDBDStatusEnum.cancelled;
                });
                if (!_.isEmpty(gdNotReadyToIssue)) {
                    SweetAlert.warning($translate.instant('GDStatusNotReady')
                        .replace('{0}', _.pluck(gdNotReadyToIssue, 'vin').join(',')));
                    return false;
                }

                return true;
            }
        };
        //-----------------数据服务-----------------//end

        //--------------设置发票折扣率--------------//start
        //红冲BD-User Invoice
        $scope.setInvoiceMarkupRatio = function () {

            var setInvoiceMarkupRatioController = ['$scope', function (scope) {
                scope.invoiceMarkupRatioEntity = scope.$parent.invoiceMarkupRatioEntity || {};
                scope.validateOption = {};
                scope.markupRatioOption = {
                    width: 230,
                    bindingOptions: {
                        value: 'invoiceMarkupRatioEntity.rate'
                    }
                };
                scope.validateOption.markupRatioOption = {
                    validationRules: [{
                        type: "required",
                        message: $translate.instant('MarkUpRateRequire')
                    }, {
                        type: 'numeric', message: $translate.instant('MarkupRatioInputFormatCheckInfo')
                    }, {
                        type: 'range',
                        min: 0, max: 99.99, message: $translate.instant('MarkupRatioInputFormatCheckInfo')
                    }]
                };

                scope.effectiveDateOption = {
                    width: 230,
                    type: 'date',
                    min: new Date(),
                    invalidDateMessage: $translate.instant('EffectiveDateSpellCheck'),
                    bindingOptions: {
                        value: 'invoiceMarkupRatioEntity.effectiveDate'
                    },
                    spellcheck: true,
                    onInput: function (e) {
                        scope.inputEffectiveDate = e.component.field().val();
                    },
                    displayFormat: 'yyyy-MM-dd',
                }

                scope.validateOption.effectiveDateOption = {
                    validationRules: [{
                        type: "required",
                        message: $translate.instant('MarkUpEffectiveDateRequire')
                    }]
                };

                //关闭弹窗口
                scope.hidePopPanel = function () {
                    scope.invoiceMarkupRatioEntity.rate = null;
                    scope.invoiceMarkupRatioEntity.effectiveDate = null;
                    scope.$dismiss({ $value: 'cancel' });
                };

                //输入数据检查
                scope.inputEffectiveDate;
                var checkSaveData = function () {
                    var dxResult = DevExpress.validationEngine.validateGroup($('#rateModalForm').dxValidationGroup("instance")).isValid;
                    if (!dxResult) {
                        return;
                    }
                    if (scope.invoiceMarkupRatioEntity.rate && scope.invoiceMarkupRatioEntity.effectiveDate) {
                        var rate = scope.invoiceMarkupRatioEntity.rate;
                        if (scope.invoiceMarkupRatioEntity.rate < 0 || scope.invoiceMarkupRatioEntity.rate >= 100) {
                            messagebox.warning('MarkupRatioInputFormatCheckInfo');
                            return false;
                        }

                        if (scope.inputEffectiveDate && new Date(scope.inputEffectiveDate).dateTimeToString('yyyyMMdd').indexOf('NaN') >= 0) {
                            messagebox.warning('EffectiveDateFormatCheckInfo');
                            return false;
                        }
                        if (scope.inputEffectiveDate && new Date(scope.inputEffectiveDate).dateTimeToString('yyyyMMdd') < new Date().dateTimeToString('yyyyMMdd')) {
                            messagebox.warning('EffectiveDateTimeCheckInfo');
                            return false;
                        }
                        scope.inputEffectiveDate = "";
                    } else {
                        messagebox.warning('MarkupRatioRequired');
                        return false;
                    }
                    return true;
                }

                //执行红冲发票
                scope.confirmSetInvoiceMarkupRatio = function () {
                    if (!checkSaveData()) {
                        return;
                    }

                    scope.invoiceMarkupRatioEntity.rate /= 100;
                    //保存折扣率
                    vatOutputInvoiceManageService.saveMarkupRatio(scope.invoiceMarkupRatioEntity).success(function (result) {
                        if (result && result.data) {
                            scope.invoiceMarkupRatioEntity = result.data;
                            if (result.data.currentRate) {
                                scope.searchOptions.markupRatio = result.data.currentRate;
                            } else {
                                scope.searchOptions.markupRatio = 0;
                            }
                            scope.$parent.invoiceMarkupRatioEntity = scope.invoiceMarkupRatioEntity;
                        }
                        scope.$dismiss({ $value: 'cancel' });
                        scope.invoiceMarkupRatioEntity.rate = null;
                        scope.invoiceMarkupRatioEntity.effectiveDate = null;

                        dataService.search();
                    });
                };

            }];

            var parentElem = angular.element($document[0].querySelector('#setup-mark-up-ratio-pop'));
            var modalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'setup-mark-up-ratio-page.html',
                controller: setInvoiceMarkupRatioController,
                windowClass: 'data-table',
                appendTo: parentElem,
                scope: $scope
            });
        };
        //--------------设置发票折扣率--------------//end

        //--------------设置发票限额--------------//start
        //设置发票限额
        $scope.setInvoiceQuota = function () {

            var setInvoiceQuotaController = ['$scope', function (scope) {
                scope.invoiceQuotaEntity = {};

                if (!_.isEmpty(scope.$parent.invoiceQuotaEntity)) {
                    _.extend(scope.invoiceQuotaEntity, scope.$parent.invoiceQuotaEntity);
                }

                scope.maxValueOption = {
                    width: 230,
                    bindingOptions: {
                        value: 'invoiceQuotaEntity.maxValue'
                    },
                    onFocusOut: function (e) {
                        var data = scope.invoiceQuotaEntity.maxValue;
                        var ele = e.component;
                        var result = PWC.AccountToFloat(scope.invoiceQuotaEntity.maxValue);
                       // var formatExp = /^[+-]?\d+(\.\d+)?$/;
                        //先验证是否是数字
                        if (result&&result.isNumber) {
                            var n = parseFloat(result.value);
                            //验证金额
                            if (n > maxValueLimit) {
                                ele.option("isValid", false);
                                ele.option("validationError", { message: $translate.instant('MaximumValueLengthCheckInfo') });
                                return;
                            }
                            //变成Account
                            scope.invoiceQuotaEntity.maxValue = n.formatAmount(2);
                            ele.option("isValid", true);
                            ele.option("validationError", { message: '' });
                        }
                        else
                        {
                            ele.option("isValid", false);
                            ele.option("validationError", { message: $translate.instant('MaximumValueFormatCheckInfo') });
                        }
                       
                    }
                };
                scope.maxValueOptionValid = {
                    validationRules: [
                        {
                            type: 'required',
                            message: $translate.instant('MaximumValueRequired')
                        },
                        //{
                        //    type: 'stringLength',
                        //    min:1,
                        //    max: 9,
                        //    message: $translate.instant('MaximumValueLengthCheckInfo')
                        //}
                    ]
                };

                //关闭弹窗口
                scope.hidePopPanel = function () {
                    scope.$dismiss({ $value: 'cancel' });
                };

                //输入数据检查
                var checkSaveData = function () {
                    if (scope.invoiceQuotaEntity.maxValue) {
                        var formatExp = /^\d+$/;
                        if (!formatExp.test(scope.invoiceQuotaEntity.maxValue)) {
                            messagebox.warning('MaximumValueFormatCheckInfo');
                            return false;
                        }
                        else if (scope.invoiceQuotaEntity.maxValue.length > 9) {
                            messagebox.warning('MaximumValueLengthCheckInfo');
                            return false;
                        }
                    } else {
                        messagebox.warning('MaximumValueRequired');
                        return false;
                    }
                    return true;
                }

                //保存限额设置
                scope.confirmSetInvoiceQuota = function () {
                    //if (!checkSaveData()) {
                    //    return;
                    //}
                    var dxResult = DevExpress.validationEngine.validateGroup($('#setupGroup').dxValidationGroup("instance")).isValid;
                    if (!dxResult) {
                        return;
                    }
                    var ele = $('#max-value').dxTextBox('instance');
                    var result = PWC.AccountToFloat(scope.invoiceQuotaEntity.maxValue);
                    if (result && !result.isNumber) {
                        ele.option("isValid", false);
                        ele.option("validationError", { message: $translate.instant('MaximumValueFormatCheckInfo') });
                        return;
                    }
                    var data = result.value;
                    //验证长度
                    if (data >=maxValueLimit) {
                        ele.option("isValid", false);
                        ele.option("validationError", { message: $translate.instant('MaximumValueLengthCheckInfo') });
                        return;
                    }
                   
                    vatOutputInvoiceManageService.saveInvoiceQuota(data).success(function (result) {
                        if (result && result.data) {
                            scope.invoiceQuotaEntity.maxValue = parseFloat(result.data).formatAmount(2);
                            scope.searchOptions.invoiceQuota = result.data;
                            scope.$parent.invoiceQuotaEntity = scope.invoiceQuotaEntity;
                        }
                        scope.$dismiss({ $value: 'cancel' });
                    });
                };

            }];

            var parentElem = angular.element($document[0].querySelector('#setup-quota-pop'));
            var modalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'setup-quota-page.html',
                controller: setInvoiceQuotaController,
                windowClass: 'data-table',
                appendTo: parentElem,
                scope: $scope
            });
        };
        //--------------设置发票限额--------------//end

        //--------------打印前确认--------------//start
        //打印前确认
        $scope.selectedManualInput;
        $scope.popupPreIssue = function () {
            if (!dataService.checkStatusBeforeIssue()) {
                return;
            }

            var preIssueController = ['$scope', function (scope) {
                scope.preIssueEntity = scope.$parent.preIssueEntity || {};
                scope.preIssueEntity.page = 0;

                scope.uploadFileType = null;
                scope.uploadFileOption = null;

                scope.preIssueEntity.manualInputReasons = scope.manualInputReasons;

                scope.dataGridOption = {
                    height: 250,
                    showRowLines: true,
                    showColumnLines: true,
                    showBorders: true,
                    allowColumnReordering: false,
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    hoverStateEnabled: false,
                    columnFixing: {
                        enabled: true
                    },
                    paging: {
                        enabled: false
                    },
                    selection: {
                        mode: 'none'
                    },
                    bindingOptions: {
                        dataSource: 'shipmentDataSource'
                    }
                };

                scope.dataGridOption.columns = [
                    //{ dataField: 'vehicleroutinglocation', caption: $translate.instant('VRL'), alignment: 'left' },
                    { dataField: 'vin', caption: $translate.instant('VIN'), alignment: 'left' },
                    {
                        dataField: 'vehicleAmount', format: 'currency', precision: 2,
                        caption: $translate.instant('ShipmentVehicleAmount') + ' (A)', alignment: 'right',
                        headerCellTemplate: function (header, info) {
                            $("<div>").html(info.column.caption.replace(/\n/g, "<br/>")).appendTo(header);
                        }
                    },
                    {
                        dataField: 'shipmentAmount', format: 'currency', precision: 2,
                        caption: $translate.instant('ShipmentShipmentAmount') + ' (B)', alignment: 'right',
                        headerCellTemplate: function (header, info) {
                            $("<div>").html(info.column.caption.replace(/\n/g, "<br/>")).appendTo(header);
                        }
                    },
                    {
                        caption: $translate.instant('PriceCheck') + '\n(A-B)', alignment: 'right',
                        cellTemplate: function (ele, info) {
                            var checkResult = '';
                            if (_.isNumber(info.data.vehicleAmount) && _.isNumber(info.data.shipmentAmount)) {
                                var diff = info.data.vehicleAmount - info.data.shipmentAmount;
                                if (diff === 0) {
                                    checkResult = $translate.instant('Equal');
                                }
                                else {
                                    checkResult = diff.formatAmount();
                                }
                            }
                            else {
                                checkResult = '/';
                            }

                            ele.text(checkResult);
                        },
                        headerCellTemplate: function (header, info) {
                            $("<div>").html(info.column.caption.replace(/\n/g, "<br/>")).appendTo(header);
                        }
                    },
                    {
                        caption: $translate.instant('State'), alignment: 'left',
                        cellTemplate: function (ele, info) {
                            if (info.data.state === enums.ShipmentCheckStatusEnum.Normal) { // (!_.isNumber(info.data.vehicleAmount) || !_.isNumber(info.data.shipmentAmount)) {
                                ele.text($translate.instant('NormalStatus')).append('&nbsp;<i class="fa fa-check-circle" style="color: green;" aria-hidden="true"></i>');
                            }
                            else if (info.data.state === enums.ShipmentCheckStatusEnum.Unbalance) { // (info.data.vehicleAmount !== info.data.shipmentAmount) {
                                ele.text($translate.instant('Unbalance')).append('&nbsp;<i class="fa fa-exclamation-circle" style="color: red;" aria-hidden="true"></i>');
                            }
                            else {
                                ele.text($translate.instant('CantFind')).append('&nbsp;<i class="fa fa-question-circle" style="color: grey;" aria-hidden="true"></i>');
                            }
                        }
                    },
                    {
                        dataField: 'finalAmount', format: 'currency', precision: 2,
                        caption: $translate.instant('FinalAmount'), alignment: 'right'
                    },
                    {
                        caption: $translate.instant('Action'), alignment: 'left',
                        cellTemplate: function (ele, info) {
                            if (info.data.state === enums.ShipmentCheckStatusEnum.Normal) {
                                // Nothing to do.
                            }
                            else {
                                $('<a/>').css({ 'color': '#923', 'cursor': 'pointer' })
                                    .text($translate.instant('ManualInput'))
                                    .on('dxclick', function () {
                                        scope.$parent.selectedManualInput = info.data;
                                        scope.manualInput(info.data);
                                    }).appendTo(ele);
                            }
                        }
                    }
                ];

                scope.deleteFromIssuingList = function (data) {
                    messagebox.confirm($translate.instant('ConfirmDeleteVehicle'), '').then(function (isConfirm) {
                        if (isConfirm) {
                            var idx = _.findIndex(scope.shipmentDataSource, { vin: data.vin });
                            scope.shipmentDataSource.splice(idx, 1);
                        }
                    });
                };

                scope.manualInput = function (data) {
                    scope.manualInputModel = scope.$parent.manualInputModel = data;
                    scope.preIssueEntity.isOpenManualInput = true;
                };

                //关闭弹窗口
                scope.hidePopPanel = function () {
                    scope.$dismiss({ $value: 'cancel' });
                };

                //确认并进入下一页
                scope.next = function () {
                    scope.preIssueEntity.page = 1;
                };

                scope.prev = function () {
                    scope.preIssueEntity.page = 0;
                };

                scope.confirm = function () {

                    scope.printGDInvoice();
                    scope.$close();
                };

            }];

            $q.all([
                vatOutputInvoiceManageService.getGdInvoiceInventory(),
                vatOutputInvoiceManageService.getCheckShipmentList(_.pluck($scope.selectedItems, 'vin')),
            ]).then(function (data) {
                if (data) {
                    if (data[0] && data[0].data && data[0].data.data) {
                        $scope.preIssueEntity = data[0].data.data;
                    } else {
                        $scope.preIssueEntity.inventory = 0;
                        $scope.preIssueEntity.thresholdValue = 100;
                        $scope.preIssueEntity.thresholdScale = 0.1;
                    }

                    if (data[1] && data[1].data) {
                        $scope.shipmentDataSource = _.map($scope.selectedItems, function (x) {
                            var shipment = _.findWhere(data[1].data, { vin: x.vin });
                            return {
                                vin: x.vin,
                                vehicleAmount: x.amountAdjusted,
                                shipmentAmount: _.isEmpty(shipment) ? '/' : shipment.vehiclePriceafterDiscounts,
                                state: _.isEmpty(shipment) ? enums.ShipmentCheckStatusEnum.CantFind
                                    : (Math.abs(shipment.vehiclePriceafterDiscounts - x.amountAdjusted) < 1 ? enums.ShipmentCheckStatusEnum.Normal
                                      : enums.ShipmentCheckStatusEnum.Unbalance),
                                finalAmount: _.isEmpty(shipment) ? '/'
                                    : (Math.abs(shipment.vehiclePriceafterDiscounts - x.amountAdjusted) < 1 ? x.amountAdjusted : null)
                            };
                        });
                    } else {
                        messagebox.warning('PleaseContactAdministrator');
                        return;
                    }
                }
                else {
                    messagebox.warning('PleaseContactAdministrator');
                    return;
                }

                var parentElem = angular.element($document[0].querySelector('#pre-issue-pop'));
                var modalInstance = $uibModal.open({
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    backdrop: 'static',
                    templateUrl: 'pre-issue-page.html',
                    controller: preIssueController,
                    windowClass: 'pre-issue-popup',
                    appendTo: parentElem,
                    scope: $scope
                });
            });
        };

        $scope.refreshIssueGDBD = function () {
            var reasonId = $scope.manualInputModel.manualInput.reasonList[0];
            var reason = _.where($scope.manualInputReasons, { id: reasonId });
            if (reason && reason[0].dictionaryKey == 'ManualInputReason2') {
                var idx = _.findIndex($scope.shipmentDataSource, { vin: $scope.selectedManualInput.vin });
                $scope.shipmentDataSource.splice(idx, 1);
            }
        }
        //--------------打印前确认--------------//end

        $scope.importShipmentList = function () {
            $state.go('outputInvoiceManage.importShipmentList');
        };

        //设置dataGrid分页
        $scope.pagingOptions = {
            pageIndex: 1,  //当前页码
            totalItems: 100,  //总数据
            totalPages: 10,//总页数
            maxSize: 10, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
            pageSizeString: constant.page.pageSizeArrary[1].toString()
        };

        //分页里面的处理
        $scope.pagingService = {
            setPage: function (pageNo) {

                //$scope.currentPage = pageNo;
            },
            //分页的时候改变数字
            pageIndexChanging: function () {
                if ($scope.pagingOptions.pageIndex > $scope.pagingOptions.totalPages) {
                    $scope.pagingOptions.pageIndex = $scope.pagingOptions.totalPages;
                }

                $log.log('Page changed to: ' + $scope.pagingOptions.pageIndex);
                dataService.search();
            },

            //每页显示的数据下拉改变
            pageSizeSelectionChanged: function () {
                $scope.pagingOptions.pageSize = parseInt($scope.pagingOptions.pageSizeString);
                dataService.search();
            }
        };
        $scope.refreshTable = function () {
            dataService.search();
        };
        $scope.printGDInvoice = function () {

            // TODO: Save reasons for each VIN amount adjusting

            if (!$scope.shipmentDataSource || $scope.shipmentDataSource.length === 0) {
                messagebox.warning('SelectBdInvoiceCheck');
                return;
            }

            var selectedItems = _.chain($scope.selectedItems).filter(function (x) {
                return _.some($scope.shipmentDataSource, { vin: x.vin });
            }).map(function (x) {
                var rtn = angular.copy(x);
                var s = _.findWhere($scope.shipmentDataSource, { vin: rtn.vin });
                if (!_.isEmpty(s)) {
                    rtn.amountAdjusted = s.finalAmount;
                    if (!_.isEmpty(s.manualInput)) {
                        rtn.manualInput = s.manualInput;
                    }
                }

                return rtn;
            }).value();

            if (_.some(selectedItems, function (x) { return !_.isNumber(x.amountAdjusted); })) {
                messagebox.warning('FinalAmountEmpty');
                return;
            }

            if (selectedItems && selectedItems.length > 0) {

                for (var i = 0; i < selectedItems.length; i++) {
                    var row = selectedItems[i];

                    var tax = thisService.getTax(row);
                    var totalAmount = tax + row.amountAdjusted;

                    if (totalAmount > thisService.LimitAmount) {
                        var str = 'Issuing amount out of setting quota (' + thisService.LimitAmount.formatAmount() + ').';
                        messagebox.warning(str);
                        return;
                    }
                }

            }

            $state.go('outputInvoiceManage.gdInvoicePrint', { invoiceList: selectedItems });
        };


        var thisService = {
            LimitAmount: 0,

            getinvoiceQuota: function () {
                vatOutputInvoiceManageService.getInvoiceQuota().success(function (result) {
                    if (result.result) {
                        var str = result.data;
                        thisService.LimitAmount = parseInt(result.data);

                    }
                });
            },
            getTax: function (data) {
                var rateStr = data.vatRateorLevyRate.replace('%', '');

                var taxRateDecimal = parseInt(rateStr);
                data.taxRateDecimal = taxRateDecimal / 100;

                var tax = data.amountAdjusted * taxRateDecimal;

                tax = tax / 100;
                return tax;
            },
        };

        (function () {
            init();
            //获取折扣率,之后刷新列表
            vatOutputInvoiceManageService.getMarkupRatio().then(function (data) {
                if (data && data.data) {
                    if (data.data.currentRate) {
                        $scope.searchOptions.markupRatio = data.data.currentRate;
                    } else {
                        $scope.searchOptions.markupRatio = 0;
                    }

                    $scope.invoiceMarkupRatioEntity = data.data;
                    $scope.invoiceMarkupRatioEntity.rate = null;
                    $scope.invoiceMarkupRatioEntity.effectiveDate = null;
                } else {
                    $scope.searchOptions.markupRatio = 0;
                }
            })
            .then(vatOutputInvoiceManageService.getInvoiceQuota)
            .then(function (data) {
                var quotaValue;
                if (data && data.data && data.data.data) {
                    $scope.searchOptions.invoiceQuota = data.data.data;
                    //这里需要显示成account
                    quotaValue = data.data.data;
                } else {
                    $scope.searchOptions.invoiceQuota = quotaValue = 10000000;
                }
                $scope.invoiceQuotaEntity.maxValue = parseFloat(quotaValue).formatAmount(2);
            })
            .then(dataService.getBdList)
            .then(dataService.search)
            .then(function () {
                $scope.setInvoiceGridHeight();
            });

            vatOutputInvoiceManageService.getAmountCheckManualInputReason().then(function (data) {
                if (data && data.data) {
                    $scope.manualInputReasons = data.data;
                }
                else {
                    $scope.manualInputReasons = [];
                }
            });

            $scope.search = dataService.search;
        })();
    }
]);
invoiceModule.directive('issuedInvoiceGdView', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('issuedInvoiceGdView.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/issued-invoice-gd-view/issued-invoice-gd-view.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'issuedInvoiceGdViewController',
            link: function (scope, element) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var pageHeight = $(document).height();
                    var pageSearchHeight = $('.page-search-container').outerHeight();
                    var pageFastSearchHeight = $('.page-fast-search-container').outerHeight();
                    var dataGridPagerHeight = $('.issued-invoice-gd-view-container .page-footer').outerHeight();
                    var subHeight = pageHeight - pageSearchHeight - pageFastSearchHeight - dataGridPagerHeight;
                    scope.dataGridHeight = subHeight > 60 ? (subHeight - 60) : 1;

                    try {
                        $('#dxIssuedInvoiceGdContainer').dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };

                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }
        };
    }
]);
/// <reference path="output-invoice-imported.ctrl.js" />
invoiceModule.controller('outputInvoiceImportedController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate', '$q',
    'apiInterceptor', '$interval', 'region', '$timeout', '$location', '$state', 'InvoiceManageService', 'vatOutputInvoiceManageService',
    'loginContext', 'orgService', 'messagebox','Upload',
    function($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout, $location, $state,
        InvoiceManageService, vatOutputInvoiceManageService, loginContext, orgService, messagebox, Upload) {
        'use strict';

        var parentSelector = '.invoice-manage-main';
        var issuedStatus = [
            { displayName: 'Normal', value: 1 },
            { displayName: 'Occupied', value: 2 },
            { displayName: 'Duplicated', value: 3 },
            { displayName: 'Prohibit', value: 4 },
            { displayName: 'On Hold', value: 5 }
        ];
        $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
        $scope.pleaseInput = $translate.instant('InputPlaceholder');
        $scope.currentVRL = '';

        //分页的设置
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            pageSize: constant.page.pageSizeArrary[1], //每页多少条数据 
        };

        $scope.searchEntity = {};
        $scope.datagrid = {};
        $scope.hasShowMoreSearchBox = false;

        var uploadIndexPageUrl = "/invoiceManagement/main/uploadIndex";

        $scope.translated = {
            NoData: $translate.instant('NoDataText'),
            pleaseSelect: $translate.instant("ChoosePlaceholder"),
            pleaseInput: $translate.instant('InputPlaceholder'),
        };

        //显示手工导入数据历史记录
        $scope.openTriggerSyncHistory = function(event) {
            var mouseX = event.clientX;
            var mouseY = event.clientY;
            if (mouseX && mouseY) {
                $('#history-pop-container').css({ 'top': mouseY - 32 + 'px', 'left': mouseX - 180 + 'px' }).show(500);
            }
        };

        //关闭手工导入数据历史记录
        $scope.closeTriggerSyncHistory = function() {
            $('#history-pop-container').hide(500);
        };

        //toggle手工导入数据历史记录
        $scope.toggleTriggerSyncHistory = function() {
            var mouseX = event.clientX;
            var mouseY = event.clientY;
            if (mouseX && mouseY) {
                $('#history-pop-container').css({ 'top': mouseY - 32 + 'px', 'left': mouseX - 180 + 'px' }).toggle(500);
            }
        };

        $scope.toggleSearchContent = function() {
            if ($("#toggle-search-tr").css("display") == "none") {
                $(".hide-search-btn").addClass("fa-angle-up").html('&nbsp;&nbsp;Collapse');
                $(".hide-search-btn").removeClass("fa-angle-down");
            } else {
                $(".hide-search-btn").addClass("fa-angle-down").html('&nbsp;&nbsp;Expand');
                $(".hide-search-btn").removeClass("fa-angle-up");
            }
            $("#toggle-search-tr").toggle(200);
            $timeout(function() {
                $scope.setInvoiceGridHeight();
            }, 300);
        };

        //获取手工导入数据历史记录
        var getSyncHistory = function() {
            vatOutputInvoiceManageService.getSyncHistory().success(function(result) {
                if (result && result.length > 0) {
                    _.each(result, function(item) {
                        item.createTime = (new Date(item.createTime)).dateTimeToString('yyyyMMdd hh:mm');
                    });
                    $scope.syncHistoryList = result;
                }
            });
        };

        //模态框
        var modalService = {
            modalInstance: null,
            open: function() {
                var parentElem = parentSelector ? angular.element($document[0].querySelector(parentSelector)) : undefined;

                var modalInstance = $uibModal.open({
                    animation: true,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'template.html', //模板
                    windowClass: 'pupupModal', //弹框页面的css
                    scope: $scope,
                    appendTo: parentElem,
                });

                thisModalService.modalInstance = modalInstance;
            },
            close: function(result) {
                if (thisModalService.modalInstance) {
                    thisModalService.modalInstance.close(result);
                }
            },
            cancel: function() {
                if (thisModalService.modalInstance) {
                    thisModalService.modalInstance.dismiss('cancel');
                }
            }
        };


        //获取数据服务
        var getService = {
            //查询的数据源准备
            //getInvoiceFilterBasicData: function () {
            //    var deferred = $q.defer();
            //    InvoiceManageService.getInvoiceFilterBasicData().success(function (data) {
            //        if (data) {
            //            if (!$scope.searchFilterOptions) {
            //                $scope.searchFilterOptions = {};
            //            }
            //            // console.log('data' + JSON.stringify(data));
            //            $scope.searchFilterOptions = {
            //                invoiceStatusList: memoryService.translateEnumValue(data.invoiceStatusList),
            //                invoiceEntityList: memoryService.translateEnumValue(data.invoiceEntityList),
            //                invoiceTypeList: memoryService.translateEnumValue(data.invoiceTypeList),
            //                invoiceSourceList: memoryService.translateEnumValue(data.invoiceSourceList),
            //                invoiceUploadTypeList: memoryService.translateEnumValue(data.invoiceUploadTypeList),
            //            };

            //            deferred.resolve(data);
            //        }
            //    });
            //    return deferred.promise;
            //},

            //筛选invoice list
            getInputInvoiceList: function() {
                var deferred = $q.defer();

                var importedParams = {
                    QueryParam: $scope.searchEntity,
                    PagingParam: $scope.pagingOptions,
                };

                var HoldedStatus = $translate.instant('HoldedStatus');

                vatOutputInvoiceManageService.getOutputImportedList(importedParams).success(function(data) {
                    if (data) {
                        $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                        var dataList = data.list;
                        angular.forEach(dataList, function(item, index) {
                            if (item.lastModifiedBy) {
                                var d = window.PWC.parseFromLocalTimeString(item.lastModifiedBy);
                                item.lastModifiedBy = d.formatDateTime('yyyy-MM-dd');
                            }

                            if (item.statusName === 'Holded') {
                                item.statusName = HoldedStatus;
                            }

                            if (index === 0) {
                                $scope.currentVRL = item.vehicleroutinglocation;
                            }
                        });
                        //if ($scope.hideValidation) {
                        //    dataList = _.filter(dataList, function (item) {
                        //        return item.validationInforamtion.length<1;
                        //    });
                        //}
                        $scope.importedGridDataSource = dataList;

                        deferred.resolve(data);
                    };
                });
                return deferred.promise;
            },

        };

        //更新数据服务
        var updateService = {
            //发票识别,手动识别
            invoiceManualRecognize: function(invoiceIDList) {
                var deferred = $q.defer();
                InvoiceManageService.invoiceManualRecognize(invoiceIDList).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
            //发票验真
            invoiceExamination: function(invoiceIDList) {
                var deferred = $q.defer();
                InvoiceManageService.invoiceExamination(invoiceIDList).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
            //变更发票状态
            updateInvoiceStatus: function(invoiceIDList, invoiceStatusID) {
                var deferred = $q.defer();
                InvoiceManageService.updateInvoiceStatus(invoiceIDList, invoiceStatusID).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
        };

        //内部处理
        var memoryService = {
            repaintInvoiceGrid: function() {
                $scope.setInvoiceGridHeight();
            },
            //翻译查询的数据源
            translateEnumValue: function(data) {
                if (!data || data.length == 0) return null;

                data.forEach(function(item) {
                    item.value = $translate.instant(item.value);
                });
                return data;
            },
            //分页下拉
            populatePagingSelection: function() {
                var pagingSelection = [];
                var pageArray = constant.page.pageSizeArrary;
                for (var i = 0; i < pageArray.length; i++) {
                    var selection = { id: pageArray[i], value: pageArray[i] };
                    pagingSelection.push(selection);
                }
                $scope.pagingOptions.pagingSelection = pagingSelection;
            }
        };

        //button的事件
        $scope.eventService = {
            //显示Mapping 界面
            showMapping: function() {
                $scope.isOpenMapping = true;
            },
            // 挂起
            holdVechicle: function() {

                var list = $scope.datagrid.selectedItems;
                if (!list || list.length === 0) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                };

                var msg = $translate.instant('Confirm') + ' ' + $translate.instant('HoldVechicle') + '?';

                messagebox.confirm(msg, '', constant.teslaConfirmClassName).then(function(isConfirm) {
                    if (isConfirm) {
                        var list = $scope.datagrid.selectedItems;
                        vatOutputInvoiceManageService.holdRecordList(list).success(function(ret) {
                            if (ret.result) {
                                SweetAlert.success($translate.instant('SaveSuccess'));
                                loadGridData();
                            } else {
                                swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                            }
                        });
                    }
                });

                //SweetAlert.swal({
                //    title: $translate.instant('Confirm') + ' ' + $translate.instant('HoldVechicle') + '?',
                //    text: $translate.instant('Confirm') + ' ' + $translate.instant('HoldVechicle'),
                //    type: "warning",
                //    showCancelButton: true,
                //    confirmButtonColor: '#B4122A',
                //    confirmButtonText: $translate.instant('Confirm'),
                //    cancelButtonText: $translate.instant('Cancel'),
                //    closeOnConfirm: false,
                //    closeOnCancel: true
                //},
                //    function (isConfirm) {
                //        if (isConfirm) {
                //            var list = $scope.datagrid.selectedItems;


                //            vatOutputInvoiceManageService.holdRecordList(list).success(function (ret) {
                //                if (ret.result) {
                //                    SweetAlert.success($translate.instant('SaveSuccess'));
                //                    loadGridData();
                //                } else {
                //                    swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                //                }
                //            });
                //        }

                //    });

            },

            //Trigger Issuance (Preview) 进入待开票状态
            triggerIssuance: function() {
                var list = $scope.datagrid.selectedItems;

                if (!list || list.length === 0) {
                    SweetAlert.warning("", $translate.instant('SelectBdInvoiceCheck'));

                    return;
                };
                //task12471 基于salesforce的验证没有通过的数据不能完成具体的发票开具
                var notValidDatas = _.filter(list, function(record) {
                    return record.validationInforamtion !== null && record.validationInforamtion.length > 0
                });
                if (notValidDatas && notValidDatas.length > 0) {
                    //include validation fail record
                    SweetAlert.warning("", $translate.instant('ValidationFailToPrint'));
                    return;
                }
                //fix bug 13216,on hold 状态不能开票
                notValidDatas = _.where(list, { recordStatus: issuedStatus[4].value });
                if (notValidDatas && notValidDatas.length > 0) {
                    //include validation fail record
                    SweetAlert.warning("", $translate.instant('NotTriggerIssurance'));
                    return;
                }
                //当需要开票的车辆为Prohibit状态时，需要发送红冲提示邮件
                //_.each(list, function(data) {
                //    if (data.statusName === "Prohibit") {
                //        vatOutputInvoiceManageService.sendEmail(data.vin,data.id);
                //        vatOutputInvoiceManageService.pendingForApprovalGdBdInvoice(data.vin);
                //    }
                //});

                vatOutputInvoiceManageService.triggerIssuanceList(list).success(function(ret) {
                    if (ret.result) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                        //loadGridData();
                        $state.go('outputInvoiceManage.outputInvoiceEdit');
                    } else if (ret.resultMsg) {
                        var baseMsg = 'AddModelMappingFirst';
                        var idx = ret.resultMsg.indexOf(baseMsg + ':');
                        if (idx >= 0) {
                            var msg = ret.resultMsg.substring(idx + baseMsg.length + 1);
                            ret.resultMsg = $translate.instant(baseMsg).replace('{0}', msg);
                        } else {
                            ret.resultMsg = $translate.instant(ret.resultMsg);
                        }

                        swal(ret.resultMsg, '', 'warning');
                    } else {
                        swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                    }
                });
            },

            fapiaoByManual: function() {
                $scope.invoiceOperateType = constant.Operation.Add;
                $scope.invoiceModel = {};
            },

            // 解挂
            unholdVechicle: function() {

                var list = $scope.datagrid.selectedItems;

                var myList = list;
                if (list && list.length > 0) {
                    myList = _.filter(list, function(row) {
                        return row.updateBy && row.updateBy.toLowerCase() === thisConstant.userId;
                    });
                }

                if (!myList || myList.length === 0) {
                    swal($translate.instant('SaveFail'), $translate.instant('OnlyUnholdMySelf'), 'warning');
                }

                vatOutputInvoiceManageService.unHoldRecordByList(myList).success(function(ret) {
                    if (ret.result) {
                        SweetAlert.success($translate.instant('SaveSuccess'));
                        loadGridData();
                    } else {
                        swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                    }
                });
            },

            showReassignModal: function() {
                showReassignModal();
            }

        };

        $scope.issuedPrompt = {
            instance: null,
            open: function() {
                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'issuedStatus-prompt.html',
                    windowClass: 'to-be-issued-prompt',
                    scope: $scope,
                    appendTo: $('.output-invoice-imported')
                });
                $scope.issuedPrompt.instance = modalInstance;

            },
            cancel: function() {
                $scope.issuedPrompt.instance.dismiss('cancel');
            }
        };

        var showReassignModal = function() {
            $scope.reassignItems = $scope.datagrid.selectedItems;
            if (!$scope.reassignItems || $scope.reassignItems.length === 0) {

                SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                // swal($translate.instant('SelectWarning'), $translate.instant('AtleastOne'), 'warning');
                return;
            }
           var notValidDatas = _.where($scope.reassignItems, { recordStatus: issuedStatus[4].value });
            if (notValidDatas && notValidDatas.length > 0) {
                //include validation fail record
                SweetAlert.warning("", $translate.instant('OnHoldToPrint'));
                return;
            }
            //Controller
            var reassignMappingController = function($scope) {
                $log.debug($scope);

                orgService.getBdList().success(function(data) {
                    var allBDVRL = _.filter(_.uniq(_.pluck(data, 'vehicleroutinglocation')),
                        function(item) { return item !== null && item !== $scope.currentVRL });

                    $scope.BDListOptions = {
                        items: allBDVRL,
                        searchEnabled: false,
                        bindingOptions: {
                            value: 'newVRL',
                        },
                        placeholder: $scope.pleaseSelect
                    };

                });

                //保存新分配数据VRL
                $scope.saveReassignWindow = function() {
                    //$log.log($scope.reassignItems);


                    var reasonIdList = [];
                   
                    if (!$scope.newVRL || !$scope.reasonList || !$scope.reassignItems) {
                        swal($translate.instant('SelectWarning'), $translate.instant('ReAssignWarning'), 'warning');
                        return;
                    }
                    //排除false
                    var selectReason = _.filter($scope.reasonList, function (item) { return item });
                    if (!selectReason || selectReason.length < 1) {
                        swal($translate.instant('SelectWarning'), $translate.instant('ReAssignWarning'), 'warning');
                        return;
                    }
                    for (var obj in $scope.reasonList) {
                        reasonIdList.push(parseInt(obj));
                    }
                    if (reasonIdList.length === 0) {
                        swal($translate.instant('SelectWarning'), $translate.instant('AtleastOneReason'), 'warning');
                        return;
                    }

                    var param = { selectedCaseList: $scope.reassignItems, newVRLName: $scope.newVRL, reasonList: reasonIdList };

                    vatOutputInvoiceManageService.reassignCase(param).success(function(data) {
                        loadGridData();
                        $scope.$dismiss({ $value: 'cancel' });
                    });
                };

                //关闭弹窗口
                $scope.hidePopPanel = function() {
                    $scope.$dismiss({ $value: 'cancel' });
                };

            };

            var reassignModalInstance = $uibModal.open({
                ariaLabelledBy: 'modal-title',
                ariaDescribedBy: 'modal-body',
                backdrop: 'static',
                templateUrl: 'reassign-modal-template.html',
                controller: reassignMappingController,
                windowClass: 'data-table',
                appendTo: angular.element($document[0].querySelector('#reassign-modal-template')),
                scope: $scope,

            });
        };

        //搜索框的处理
        $scope.buttonService = {
            //查询数据
            searchByFilter: function() {
                loadGridData();
            },
            //手工拉取数据
            manualUpdateSFData: function() {
                var deferred = $q.defer();
                //添加手工拉取数据的历史记录，并刷新历史记录
                var data = {
                    createBy: loginContext.userName
                };
                vatOutputInvoiceManageService.saveSyncHistory(data).then(function() {
                    getSyncHistory();
                });

                vatOutputInvoiceManageService.manualUpdateSFData().success(function(data) {
                    deferred.resolve({ data: data });
                }).error(function() {
                    deferred.reject("Data Loading Error");
                });
                return deferred.promise;
            }
        }

        //分页里面的处理
        $scope.pagingSercice = {
            setPage: function(pageNo) {

                //$scope.currentPage = pageNo;
            },
            //分页的时候改变数字
            pageIndexChanging: function() {
                if ($scope.pagingOptions.pageIndex > $scope.pagingOptions.totalPages) {
                    $scope.pagingOptions.pageIndex = $scope.pagingOptions.totalPages;
                }

                $log.log('Page changed to: ' + $scope.pagingOptions.pageIndex);
                getService.getInputInvoiceList();
            },

            //每页显示的数据下拉改变
            pageSizeSelectionChanged: function() {
                $scope.pagingOptions.pageSize = parseInt($scope.pagingOptions.pageSizeString);
                getService.getInputInvoiceList();
            },
        };

        var loadGridData = function() {
            getService.getInputInvoiceList($scope.searchEntity);
            $timeout(function() {
                memoryService.repaintInvoiceGrid();
            }, 50);
        }

        $scope.$watch('importedGridDataSource', function () {
            $timeout(function () {
                if ($scope.uploadVins && $scope.importedGridDataSource) {
                    var gridInstance = $('#invoiceGridContainer').dxDataGrid('instance');//$('#invoiceGridContainer').dxDataGrid('instance');
                    var selectedInvoices = _.filter($scope.importedGridDataSource, function (item) {
                        return $scope.uploadVins.indexOf(item.vin) >= 0;
                    });
                    var selectedKeys = _.pluck(selectedInvoices, 'id');
                    gridInstance.selectRows(selectedKeys, true);
                }
            }, 200);

        });

        //初始化invoice datagrid 树
        var InitInvoiceGrid = function() {

            var setHoldStatus = function(data) {
                // 没有选的时候默认值
                $scope.showUnHoldBtn = false;
                $scope.showHoldBtn = true;
                if (data.selectedRowsData && data.selectedRowsData.length > 0) {
                    var list = _.uniq(_.pluck(data.selectedRowsData, 'recordStatus'));

                    var dataList = data.selectedRowsData;

                    var holdList = _.filter(dataList, function(row) {
                        // body...
                        return row.updateBy && row.updateBy.toLowerCase() === thisConstant.userId && row.recordStatus === constant.CaseImportedStatusEnum.Holded;
                    });

                    var unholdList = _.filter(dataList, function(row) {
                        // body...
                        return  row.recordStatus != constant.CaseImportedStatusEnum.Holded;
                    });

                    if (holdList.length === dataList.length ){
                        // 纯挂起的，则可以解挂
                        $scope.showUnHoldBtn = true;
                        $scope.showHoldBtn = false;
                    } else if (unholdList.length === dataList.length) {

                        // 纯解挂的，可以挂起
                         $scope.showUnHoldBtn = false;
                        $scope.showHoldBtn = true;
                    } else{
                        // 其他情况，不可以挂起也不可以解挂
                        $scope.showUnHoldBtn = false;
                        $scope.showHoldBtn = false;
                    }
                }

               
            };
            var validationMessage = function(validation) {
                var message = '';
                _.each(validation, function(item) {
                    //first split 换行符
                    var rowArray = item.validMessage.split("\n");
                    _.each(rowArray, function(row) {
                        if (row) {
                            var mArray = row.split(constant.splitValidation);
                            _.each(mArray, function(item) {
                                message += $translate.instant(item) + ' ';
                            });
                            message += ","
                        }
                    });

                });
                return message.substring(0, message.length - 1);
            };
            var valiationDisplay = function(cellInfo, field) {
                var val = cellInfo.value == null || cellInfo.value == '' ? '&nbsp;' : cellInfo.value;
                var htmlStr = ' <div><span>' + val + '</span></div>';
                if (cellInfo.data.validationInforamtion) {
                    var validation = _.where(cellInfo.data.validationInforamtion, { fieldName: field });
                    if (validation && validation.length > 0) {
                        var msg = validationMessage(validation);
                        htmlStr = '<div class="noteTips" title="' + msg + '"><span>' + val + '</span></div>';
                    }
                }
                return htmlStr;
            };
            $scope.invoiceGridOptions = {
                bindingOptions: {
                    dataSource: 'importedGridDataSource',
                    height: 'dataGridHeight'
                },
                // keyExpr: "ID",
                selection: {
                    mode: "multiple",
                    showCheckBoxesMode: 'always'
                },
                loadPanel: {
                    enabled: false,
                },
                paging: {
                    enabled: false,
                },
                keyExpr: 'id',
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                // rowAlternationEnabled: true,
                showBorders: true,
                allowColumnReordering: true,
                columnChooser: {
                    enabled: true,
                    emptyPanelText: $translate.instant('DragInformation'),

                },
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                onContentReady: function (e) {
                    $scope.invoiceGridInstance = e.component;
                },
                onCellPrepared: function(e) {
                    //已退票,已失效不显示checkbox
                    if (e.rowType === "data" & e.column.command === 'select' &&
                        (e.data.status === constant.inputInvoice.statusType.InvoiceHasRefund.id ||
                            e.data.status === constant.inputInvoice.statusType.InvoiceHasExpired.id)) {
                        e.cellElement.find('.dx-select-checkbox').hide();
                        //e.cellElement.find('.dx-select-checkbox').addClass('dx-state-disabled');
                        e.cellElement.off();
                    }

                    if (e.rowType === "data") {
                        var data = e.data;

                        if (data.recordStatus === constant.CaseImportedStatusEnum.Holded) {
                            // 挂起状态， 设置为灰色的行, 不可选
                            e.cellElement.css('background-color', '#F2F2F2');
                            // e.cellElement.find('.dx-select-checkbox').hide();
                            // e.cellElement.off();
                        }
                    }
                },
                onSelectionChanged: function(data) {
                    $scope.datagrid.selectedItems = data.selectedRowsData;
                    setHoldStatus(data);
                    //$scope.selectedItemIDs = _.pluck(data.selectedRowsData, 'id');
                    //$scope.selectedPlaceholder = data.selectedRowsData.length;
                    //$scope.disabled = !$scope.selectedItemIDs.length;
                },
                columns: [
                    { dataField: 'vehicleroutinglocation', caption: $translate.instant('VRL'), fixed: true },
                    {
                        dataField: 'vin',
                        caption: $translate.instant('VinNumber'),
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'VIN');
                            cellElement.append(htmlStr);
                        }
                    },
                    {
                        dataField: 'caseNumber',
                        caption: $translate.instant('CaseNumber'),
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'CaseNumber');
                            cellElement.append(htmlStr);
                        }
                    },
                    { dataField: 'modelSeries', caption: $translate.instant('ModelSeries') },
                    { dataField: 'cabinConfiguration', caption: $translate.instant('CabinConfig'), visible: false }, //发票来源
                    // make and model
                    { dataField: 'updateByUserName', caption: $translate.instant('LastModifiedBy'), visible: false },
                    { dataField: 'lastModifiedBy', caption: $translate.instant('LastModifiedDate'), visible: false },
                    {
                        dataField: 'subtotalforFinalPayment',
                        caption: $translate.instant('SubtotalForFinalPayment'),
                        cellTemplate: function(container, options) {
                            try {
                                var data = options.data;
                                var divEle = $('<div/>');
                                var spanEle = $('<span/>');

                                if (data.isRelatedBD && data.bdSubtotalforFinalPayment === null) {
                                    spanEle.addClass('span-is-related-bd cursor-pointer')
                                        .text(data.subtotalforFinalPayment.formatAmount(2))
                                        .on('click', function() {
                                            // 变价
                                            $scope.updateIsRelatedBDPrice(data);
                                        });

                                } else {
                                    spanEle.text(data.subtotalforFinalPayment.formatAmount(2));
                                }

                                if (data.validationInforamtion) {
                                    var validation = _.findWhere(data.validationInforamtion, { fieldName: 'SubtotalforFinalPayment' });
                                    if (validation && validation.length > 0) {
                                        var msg = validationMessage(validation);
                                        divEle.addClass('noteTips').attr('title', msg);
                                    }
                                }
                                spanEle.appendTo(divEle);
                                divEle.appendTo(container);
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    },
                    {
                        dataField: 'registrationLocalName',
                        caption: $translate.instant('RegistrationLocalName'),
                        visible: true,
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'RegistrationLocalName');
                            cellElement.append(htmlStr);
                        }
                    },
                    {
                        dataField: 'driverLicense',
                        caption: $translate.instant('DriverLicense'),
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'DriverLicense');
                            cellElement.append(htmlStr);
                        }
                    }, //税额合计小写
                    {
                        dataField: 'organizationCode',
                        caption: $translate.instant('OrganizationCode'),
                        visible: false,
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'OrganizationCode');
                            cellElement.append(htmlStr);
                        }
                    },
                    {
                        dataField: 'companyVATIDTaxID',
                        caption: $translate.instant('CompanyTaxID'),
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'CompanyVATIDTaxID');
                            cellElement.append(htmlStr);
                        }
                    }, //税额
                    {
                        dataField: 'importCertificateNumber',
                        caption: $translate.instant('ImportCertificate'),
                        visible: false,
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'ImportCertificateNumber');
                            cellElement.append(htmlStr);
                        }
                    }, //开票日期
                    { dataField: 'motorNumber', caption: $translate.instant('MotorNumber'), visible: false },
                    {
                        dataField: 'ciqNumber',
                        caption: $translate.instant('CIQNumber'),
                        visible: false,
                        cellTemplate: function(cellElement, cellInfo) {
                            var htmlStr = valiationDisplay(cellInfo, 'CIQNumber');
                            cellElement.append(htmlStr);
                        }

                    },
                    { dataField: 'deliveryStatus', caption: $translate.instant('DeliveryStatus'), visible: false },
                    {
                        dataField: 'statusName',
                        caption: $translate.instant('toBeIssuedStatus'),
                        cellTemplate: function(container, options) {
                            try {
                                var data = options.data;
                                //Prohibit
                                if (data.statusName === "Prohibit") {
                                    $("<span class='glyphicon glyphicon-remove cursor-pointer' />").appendTo(container);
                                    $("<span class='cursor-pointer' />")
                                        .text(data.statusName)
                                        .on('click', function() {
                                            $scope.issusedStatus = {
                                                selectedVIN: data.vin,
                                                icon: '<i  class="glyphicon glyphicon-remove" ></i>',
                                                status: data.statusName,
                                                information: $translate.instant('ProhibitInformation'),
                                                BDInformation: $translate.instant('BDColon') + " " + data.otherBDs
                                            };
                                            $scope.issuedPrompt.open();
                                        })
                                        .appendTo(container);
                                    //Opccupied
                                } else if (data.statusName === "Occupied") {
                                    $("<span class='glyphicon glyphicon-alert cursor-pointer' />").appendTo(container);
                                    $("<span class='cursor-pointer' />")
                                        .text(data.statusName)
                                        .on('click', function() {
                                            // $scope.updateIsRelatedBDPrice(data);
                                            $scope.issusedStatus = {
                                                selectedVIN: data.vin,
                                                icon: '<i  class="glyphicon glyphicon-alert" ></i>',
                                                status: data.statusName,
                                                information: $translate.instant('OccupiedInformation'),
                                                BDInformation: $translate.instant('OtherBDColon') + " " + data.otherBDs
                                            };
                                            $scope.issuedPrompt.open();
                                        })
                                        .appendTo(container);
                                    //Duplicated
                                } else if (data.statusName === "Duplicated") {
                                    $("<span class='glyphicon glyphicon-ban-circle cursor-pointer' />").appendTo(container);
                                    $("<span class='cursor-pointer'/>")
                                        .text(data.statusName)
                                        .on('click', function() {
                                            //  $scope.updateIsRelatedBDPrice(data);
                                            $scope.issusedStatus = {
                                                selectedVIN: data.vin,
                                                icon: '<i  class="glyphicon glyphicon-ban-circle" ></i>',
                                                status: data.statusName,
                                                information: $translate.instant('DuplicatedInformation'),
                                                BDInformation: $translate.instant('BDColon') + " " + data.otherBDs
                                            };
                                            $scope.issuedPrompt.open();
                                        })
                                        .appendTo(container);
                                } else {
                                    $("<span class='glyphicon glyphicon-ban-circle cursor-pointer visibility-hidden-before' />").appendTo(container);
                                    $("<span class='cursor-pointer'/>")
                                        .text('' + data.statusName)
                                        .appendTo(container);
                                }
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    },
                    { dataField: 'otherItem1', caption: $translate.instant('otherItem1'), visible: false },
                    { dataField: 'otherItem1Amount', caption: $translate.instant('otherItem1Amount'), visible: false },
                    { dataField: 'otherItem2', caption: $translate.instant('otherItem2'), visible: false },
                    { dataField: 'otherItem2Amount', caption: $translate.instant('otherItem2Amount'), visible: false },
                    { dataField: 'otherItem3', caption: $translate.instant('otherItem3'), visible: false },
                    { dataField: 'otherItem3Amount', caption: $translate.instant('otherItem3Amount'), visible: false },
                    /*
                    {
                        dataField: 'id', caption: $translate.instant('Action'),
                        cellTemplate: function (container, options) {
                            try {
                                var data = options.data;
                                $('<a href="javascript:void(0)" />')
                                    .text('Re-assign')
                                    .on('click', function () {
                                    //  $scope.updateIsRelatedBDPrice(data);
                                    showReassignModal(data.id);
                                    })
                                    .appendTo(container);
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    },      
                    */
                    { dataField: 'commissionableStore', caption: $translate.instant('CommissionableStore'), visible: false },
                    { dataField: 'financePartner', caption: $translate.instant('FinancePartner'), visible: false },

                ],
                masterDetail: {
                    enabled: true,
                    template: "paymentDetail"
                },
                paymentDetailOptions: function(payments) {
                    return {
                        dataSource: payments,
                        columnAutoWidth: true,
                        showBorders: true,
                        width: '92%',
                        height: '95%',
                        noDataText: $translate.instant('NoDataText'),
                        columns: [{
                                dataField: 'paymentAmount',
                                caption: $translate.instant('PaymentAmount'),
                                format: { type: 'fixedPoint', precision: 2 }
                            },
                            {
                                dataField: 'paymentDate',
                                caption: $translate.instant('PaymentDate'),
                                dataType: 'date',
                                format: 'yyyy-MM-dd'
                            },
                            { dataField: 'payorName', caption: $translate.instant('PayorName') }
                            /*
                            {
                                dataField: 'UpdateTime',
                                dataType: 'date',
                                format: 'yyyy-MM-dd',
                                caption: $translate.instant('UpdateTime')
                            }
                            */
                        ]
                    }
                }
            };
        };

        var initDatePicker = function() {
            $('#lastModifiedDateDatePicker').datepicker({
                language: region
            });
        };

        //搜索框初始化
        var initSearchBoxContorls = function() {

            var valueExpr = "id";
            var displayExpr = "value";

            var isShowClearButton = true;

            $scope.searchEntityOptions = {
                //1. VIN
                txtVINBoxOptions: {
                    bindingOptions: {
                        value: 'searchEntity.VIN',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //2. Last Modified Date
                dateLastModifiedDataOptions: {
                    type: 'date',
                    width: 230,
                    bindingOptions: {
                        value: 'searchEntity.LastModifiedData',
                    },
                    placeholder: $scope.pleaseSelect,
                    showClearButton: isShowClearButton,
                    displayFormat: 'yyyy-MM-dd',
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //3. txtCommissionableStoreBoxOptions
                txtCommissionableStoreBoxOptions: {
                    bindingOptions: {
                        value: 'searchEntity.commissionableStore',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //4. txtFinancePartnerOptions
                txtFinancePartnerOptions: {
                    bindingOptions: {
                        value: 'searchEntity.financePartner',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //5. txtCaseNumberBoxOptions
                txtCaseNumberBoxOptions: {
                    bindingOptions: {
                        value: 'searchEntity.caseNumber',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    //onValueChanged: function (data) {
                    //$log.debug(data);
                    //loadGridData();
                    //}
                },

                //5. issuedStatus
                selectIssuedStatusOptions: {
                    placeholder: $scope.pleaseSelect,
                    showClearButton: isShowClearButton,
                    showDropButton: true,
                    multiline: false,
                    showSelectionControls: true,
                    applyValueMode: "useButtons",
                    displayExpr: 'displayName',
                    valueExpr: 'value',
                    width: "100%",
                    bindingOptions: {
                        value: 'searchEntity.issuedStatus'
                    },
                    items: issuedStatus
                },

            };
        };

        //初始化控件
        var initControls = function() {
            initDatePicker();
            initSearchBoxContorls();
            InitInvoiceGrid();
        };

        //初始化数据
        var initData = function() {
            $scope.searchFilterOptions = {};
            memoryService.populatePagingSelection();
            loadGridData();
            // getService.getInvoiceFilterBasicData();
        };

        // 修改变价
        $scope.updateIsRelatedBDPrice = function(data) {
            $scope.invoicePriceOperateType = constant.Operation.Edit;
            $scope.invoicePriceModel = {
                subtotalforFinalPayment: data.subtotalforFinalPayment,
                bdSubtotalforFinalPayment: '',
                id: data.id
            };
        };

        // 价格变动后，重新刷新数据
        $scope.closePriceModal = function(param) {
            $scope.buttonService.searchByFilter();
        };


        $scope.closeInvoiceModal = function(param) {
            $scope.buttonService.searchByFilter();
        };

        $scope.displayOrShowValidation = function() {
            //if ($scope.searchEntity.hideValidation) {
            //    $scope.importedGridDataSource = _.filter($scope.importedGridDataSource, function (item) {
            //        return item.validationInforamtion.length<1;
            //    });
            //}
            getService.getInputInvoiceList();

        };
        // 本页面的常量
        var thisConstant = {
            userId: null,
        };

        //Upload Vin file define -->start
        var resumable = true;
        $scope.chunkSize = 500 * 1024;
        $scope.uploadOption = {};
        $scope.uploadOption.uploadFiles = [];
        $scope.uploadVins = "";
        $scope.$watch('uploadOption.uploadFiles', function (newValue, oldValue) {
            if (newValue && newValue !== oldValue) {
                uploadfile($scope.uploadOption.uploadFiles);
            }
        });

        //执行上传文件操作。
        var uploadfile = function (file) {
            $("#busy-indicator-container").show();
            if (file) {
                var uploadSuccessCallBack = function (data) {
                    var result = data;
                };

                var uploadSuccess = function (result) {
                    //根据上传的vin勾选发票
                    if (result) {
                        SweetAlert.success($translate.instant('UploadVinSuccess'));
                        $scope.uploadVins = result.data;
                        $scope.searchEntity.uploadVins = result.data;
                        var gridInstance = $('#invoiceGridContainer').dxDataGrid('instance');
                        var selectedInvoices = _.filter($scope.importedGridDataSource, function (item) {
                            return result.data.indexOf(item.vin) >= 0;
                        });
                        var selectedKeys = _.pluck(selectedInvoices, 'id');
                        gridInstance.selectRows(selectedKeys, true);
                    }
                    $("#busy-indicator-container").hide();
                };

                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();
                    Upload.upload({
                        url: apiInterceptor.webApiHostUrl + '/outputInvoicePrinted/uploadVinFile',
                        data: {
                            cancel: false,
                            filename: file.name,
                            tempFileName: tempFileName,
                            file: file,
                            period: $scope.period
                        },
                        resumeChunkSize: resumable ? $scope.chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadSuccess, uploadSuccessCallBack);
                }
            }
        };//Upload Vin file define -->end


        (function initialize() {
            $log.debug('invoiceManageMainController.ctor()...');

            thisConstant.userId = loginContext.userId.toLowerCase();
            $scope.showUnHoldBtn = false;
            $scope.showHoldBtn = true;
            $scope.isOpenMapping = false;
            $scope.hideValidation = false;
            initControls();
            initData();
            getSyncHistory();
        })();
    }
]);
invoiceModule.directive('outputInvoiceImported', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('outputInvoiceMain.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/issued-invoice-imported/output-invoice-imported.html' + '?_=' + Math.random(),
            scope:
            {
                 
            },
            controller: 'outputInvoiceImportedController',
            link: function (scope, element) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var pageHeight = $(document).height();
                    var pageSearchHeight = $('.page-search-container').outerHeight();
                    var rowHeight = $('.output-invoice-imported .content-container .buttom-row').outerHeight();
                    var subHeight = pageHeight - pageSearchHeight - rowHeight - 45;
                    scope.dataGridHeight = subHeight > 60 ? (subHeight - 60) : 1;
                    try {
                        $('#invoiceGridContainer').dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };

                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('modelMappingAddEditController', ['$scope', '$log', '$q', '$translate', 'messagebox',
    'vatOutputInvoiceManageService', 'refreshFunc', 'model',
function ($scope, $log, $q,$translate, messagebox, vatOutputInvoiceManageService, refreshFunc, model) {
    var isEdit = !_.isEmpty(model);
    var pleaseSelect = $translate.instant("ChoosePlaceholder");
    var pleaseInput = $translate.instant('InputPlaceholder');
    var initSelectBoxes = function () {
        return $q.all([
            vatOutputInvoiceManageService.getModelSeries(),
            vatOutputInvoiceManageService.getCabinConfiguration()
        ]).then(function (result) {
            if (result && result[0] && result[0].data) {
                $scope.modelSeriesList = result[0].data;
            }
            else {
                $scope.modelSeriesList = [];
            }

            if (result && result[1] && result[1].data) {
                //$scope.cabinConfigurationList = _.map(result[1].data, function (x) {
                //    return _.isEmpty(x) ? 'NA' : x;
                //});
                //fix bug13211
                $scope.cabinConfigurationList = _.filter(result[1].data, function (x) {
                    return !_.isEmpty(x);
                });
               
            }
            else {
                $scope.cabinConfigurationList = [];
            }

            $scope.modelSeriesOption = {
                items: $scope.modelSeriesList,
                bindingOptions: {
                    value: 'model.modelSeries'
                },
                placeholder: pleaseSelect
            };

            $scope.cabinConfigurationOption = {
                items: $scope.cabinConfigurationList,
                bindingOptions: {
                    value: 'model.cabinConfiguration'
                },
                placeholder: pleaseSelect
            };
        });
    };

    //关闭弹窗口
    $scope.hidePopPanel = function () {
        $scope.$dismiss({ $value: 'cancel' });
    };

    $scope.saveModel = function () {
        if (_.isEmpty($scope.model.modelSeries)) {
            messagebox.warning('ModelSeriesRequired');
            return;
        }

        if (_.isEmpty($scope.model.cabinConfiguration)) {
            messagebox.warning('CabinConfigurationRequired');
            return;
        }

        if (_.isEmpty($scope.model.makeAndModel)) {
            messagebox.warning('MakeAndModelRequired');
            return;
        }

        var promise;
        if (isEdit) {
            promise = vatOutputInvoiceManageService.updateModelMappingConfig($scope.model);
        }
        else {
            promise = vatOutputInvoiceManageService.addModelMappingConfig($scope.model);
        }

        return promise.then(function (data) {
            if (!data || !data.data) {
                messagebox.warning('UnknownError');
            }
            else if (!data.data.result) {
                messagebox.warning(_.isEmpty(data.data.resultMsg) ? 'UnknownError' : data.data.resultMsg);
            }
            else {
                $scope.hidePopPanel();
                refreshFunc();
            }
        });
    };

    $scope.$watch('model.makeAndModel', function (newVal, oldVal) {
        var rtn = '';
        if (!_.isEmpty(newVal)) {
            var strs = newVal.split(' ');
            $scope.model.category = strs[0];
        }
        else {
            $scope.model.category = '';
        }
    });

    (function initialize() {
        $log.debug('modelMappingAddEditController.ctor()...');

        $scope.title = isEdit ? 'EditMapping' : 'AddNewMapping';
        var localModel = model ? angular.copy(model) : {};
        if (_.isEmpty(localModel.cabinConfiguration)) {
            localModel.cabinConfiguration = '';
        }

        $scope.model = localModel;
        initSelectBoxes();
        $log.debug($scope.model);
    })();
}]);
invoiceModule.controller('modelMappingConfigurationController', ['$scope', '$log', '$timeout', '$translate',
    'messagebox', 'vatOutputInvoiceManageService',
function ($scope, $log, $timeout, $translate, messagebox, vatOutputInvoiceManageService) {
    var mappingGridInstance = null;
  
    //初始化mapping datagrid 树
    var initMappingGrid = function () {
        $scope.dataMappingGridOptions = {
            keyExpr: "id",
            height: '300px',
            showRowLines: true,
            showColumnLines: true,
            showBorders: true,
            allowColumnResizing: true,
            allowColumnReordering: false,
            columnAutoWidth: true,
            hoverStateEnabled: true,
            bindingOptions: {
                dataSource: 'mappingDataSource'
            },
            selection: {
                mode: "single"
            },
            sorting: {
                mode: 'none'
            },
            paging: {
                enabled: false,
            },
            onSelectionChanged: function (data) {
                $scope.selectedItem = data.selectedRowsData;
            },
            onContentReady: function (e) {
                mappingGridInstance = e.component;
            },
            columns: [
                { dataField: 'id', visible: false },
                { dataField: 'modelSeries', visible: false },
                { dataField: 'cabinConfiguration', visible: false },
                {
                    caption: $translate.instant('ModelSeries') + ' - '
                        + $translate.instant('CabinConfiguration'),
                    alignment: 'center',
                    calculateCellValue: function (data) {
                        return data.modelSeries + '-' + data.cabinConfiguration;
                    }
                },
                {
                    dataField: 'makeAndModel',
                    caption: $translate.instant('MakeAndModel'),
                    alignment: 'center'
                },
            ]
        };
    };

    var refreshDataSource = function () {
        return vatOutputInvoiceManageService.getModelMappingConfig().then(function (data) {
            if (data && data.data) {
                $scope.mappingDataSource = data.data;
            }
            else {
                $scope.mappingDataSource = [];
            }

            $timeout(function () {
                $scope.selectedItem = mappingGridInstance.getSelectedRowsData();
            }, 100);
        });
    };

    //关闭弹窗口
    $scope.hidePopPanel = function () {
        $scope.$parent.isOpen = false;
        $scope.$dismiss({ $value: 'cancel' });
    };

    $scope.addMapping = function () {
        $scope.eventService.addOrEdit(refreshDataSource);
    };

    $scope.editMapping = function () {
        if (_.isEmpty($scope.selectedItem) || _.isEmpty($scope.selectedItem[0])) {
            messagebox.warning('SelectMappingCheck');
            return;
        }

        $scope.eventService.addOrEdit(refreshDataSource, $scope.selectedItem[0]);
    };

    $scope.deleteMapping = function () {
        if (_.isEmpty($scope.selectedItem) || _.isEmpty($scope.selectedItem[0])) {
            messagebox.confirm('SelectMappingCheck');
            return;
        }

        messagebox.confirm($translate.instant('ConfirmCancelMapping'), '', constant.teslaConfirmClassName).then(function (isConfirm) {
            if (isConfirm) {
                vatOutputInvoiceManageService.deleteModelMappingConfig($scope.selectedItem[0].id)
                    .then(function (data) {
                        if (!data || !data.data) {
                            messagebox.warning('UnknownError');
                        }
                        else if (!data.data.result) {
                            messagebox.warning(_.isEmpty(data.data.resultMsg) ? 'UnknownError' : data.data.resultMsg);
                        }
                        else {
                            refreshDataSource();
                        }
                    });
            }
        });
    };

    (function initialize() {
        $log.debug('modelMappingConfigurationController.ctor()...');

        $scope.selectedItem = null;
        initMappingGrid();
        refreshDataSource();
    })();
}]);
invoiceModule.directive('modelMappingConfiguration', ['$log', '$document', '$uibModal',
function ($log, $document, $uibModal) {
    'use strict';

    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/model-mapping-configuration/model-mapping-configuration.html' + '?_=' + Math.random(),
        scope:
        { 
            isOpen: '=',
            parentElement: "@"
        },
        link: function (scope, element) {
            $log.debug('modelMappingConfiguration.ctor()...');

            scope.$watch('isOpen', function (newVal, oldVal) {
                if (newVal) {
                    scope.eventService.open();
                }
            });

            var parentElement = scope.parentElement
                ? $document[0].querySelector(scope.parentElement) : element[0];

            scope.eventService = {
                open: function () {
                    var modalInstance = $uibModal.open({
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        backdrop: 'static',
                        templateUrl: 'view-mapping-template.html',
                        controller: 'modelMappingConfigurationController',
                        windowClass: 'model-mapping-popup center-popup',
                        appendTo: angular.element(parentElement),
                        scope: scope
                    });
                },
                addOrEdit: function (refreshFunc, model) {
                    var modalInstance = $uibModal.open({
                        ariaLabelledBy: 'modal-title',
                        ariaDescribedBy: 'modal-body',
                        backdrop: 'static',
                        templateUrl: 'add-edit-mapping-template.html',
                        controller: 'modelMappingAddEditController',
                        windowClass: 'add-mapping-popup center-popup',
                        appendTo: angular.element(parentElement),
                        scope: scope,
                        resolve: {
                            refreshFunc: function () {
                                return refreshFunc;
                            },
                            model: function () {
                                return model;
                            }
                        }
                    });
                }
            };
        }
    };
}]);
invoiceModule.controller('outputInvoiceEditController', ['$scope', '$log', '$document', '$uibModal', 'messagebox',
    '$translate', '$q', 'apiInterceptor', '$interval', 'region', '$timeout', '$location', 'InvoiceManageService',
    'vatOutputInvoiceManageService', 'userService', '$state', 'SweetAlert', 'enums',
    function($scope, $log, $document, $uibModal, messagebox, $translate, $q, apiInterceptor, $interval, region,
        $timeout, $location, InvoiceManageService, vatOutputInvoiceManageService, userService, $state, SweetAlert, enums) {
        'use strict';

        var parentSelector = '.output-invoice-edit-wrapper';

        $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
        $scope.pleaseInput = $translate.instant('InputPlaceholder');


        //分页的设置
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 100, //总数据
            totalPages: 10, //总页数
            maxSize: 10, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[1], //每页多少条数据 
            pageSizeString: constant.page.pageSizeArrary[1] + '',
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        $scope.searchEntity = {};
        $scope.datagrid = {};
        $scope.hasShowMoreSearchBox = false;


        var uploadIndexPageUrl = "/invoiceManagement/main/uploadIndex";


        $scope.translated = {
            NoData: $translate.instant('NoDataText'),
            pleaseSelect: $translate.instant("ChoosePlaceholder"),
            pleaseInput: $translate.instant('InputPlaceholder'),
        };

        //模态框
        var modalService = {
            modalInstance: null,
            open: function() {
                var parentElem = parentSelector ? angular.element($document[0].querySelector(parentSelector)) : undefined;

                var modalInstance = $uibModal.open({
                    animation: true,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'template.html', //模板
                    windowClass: 'pupupModal', //弹框页面的css
                    scope: $scope,
                    appendTo: parentElem,
                });

                thisModalService.modalInstance = modalInstance;
            },
            close: function(result) {
                if (thisModalService.modalInstance) {
                    thisModalService.modalInstance.close(result);
                }
            },
            cancel: function() {
                if (thisModalService.modalInstance) {
                    thisModalService.modalInstance.dismiss('cancel');
                }
            }
        };


        //获取数据服务
        var getService = {
            //查询的数据源准备
            getInvoiceFilterBasicData: function() {
                var deferred = $q.defer();
                InvoiceManageService.getInvoiceFilterBasicData().success(function(data) {
                    if (data) {
                        if (!$scope.searchFilterOptions) {
                            $scope.searchFilterOptions = {};
                        }
                        // console.log('data' + JSON.stringify(data));
                        $scope.searchFilterOptions = {
                            invoiceStatusList: memoryService.translateEnumValue(data.invoiceStatusList),
                            invoiceEntityList: memoryService.translateEnumValue(data.invoiceEntityList),
                            invoiceTypeList: memoryService.translateEnumValue(data.invoiceTypeList),
                            invoiceSourceList: memoryService.translateEnumValue(data.invoiceSourceList),
                            invoiceUploadTypeList: memoryService.translateEnumValue(data.invoiceUploadTypeList),
                        };

                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },

            //筛选invoice list
            getInputInvoiceList: function() {
                var deferred = $q.defer();

                var invoiceParams = {
                    InvoiceQuery: $scope.searchEntity,
                    pagingDto: $scope.pagingOptions,
                };

                InvoiceManageService.getInputInvoiceList(invoiceParams).success(function(data) {
                    if (data) {
                        $scope.pagingOptions.totalItems = data.pageInfo && data.pageInfo.totalCount;
                        if (data && data.list) {
                            data.list.forEach(function(item) {
                                item.statusString = $translate.instant(item.statusString);
                                item.invoiceEntityTypeString = $translate.instant(item.invoiceEntityTypeString);
                                item.invoiceSourceTypeString = $translate.instant(item.invoiceSourceTypeString);
                                item.invoiceTypeString = $translate.instant(item.invoiceTypeString);
                                item.uploadTypeString = $translate.instant(item.uploadTypeString);
                                item.uploadDate = moment(item.uploadDate).format(constant.date.dateFormatUppercase);
                                item.invoiceDate = moment(item.invoiceDate).format(constant.date.dateFormatUppercase);
                            });
                        }
                        $scope.invoiceGridDataSource = data.list;
                        deferred.resolve(data);
                    };
                });
                return deferred.promise;
            }

        };

        //添加数据服务
        var addService = {

        };

        //更新数据服务
        var updateService = {
            //发票识别,手动识别
            invoiceManualRecognize: function(invoiceIDList) {
                var deferred = $q.defer();
                InvoiceManageService.invoiceManualRecognize(invoiceIDList).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
            //发票验真
            invoiceExamination: function(invoiceIDList) {
                var deferred = $q.defer();
                InvoiceManageService.invoiceExamination(invoiceIDList).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
            //变更发票状态
            updateInvoiceStatus: function(invoiceIDList, invoiceStatusID) {
                var deferred = $q.defer();
                InvoiceManageService.updateInvoiceStatus(invoiceIDList, invoiceStatusID).success(function(data) {
                    if (data) {
                        deferred.resolve(data);
                    }
                });
                return deferred.promise;
            },
        };

        //删除数据服务
        var deleteService = {

        };

        //内部处理
        var memoryService = {
            repaintInvoiceGrid: function() {
                $scope.setInvoiceGridHeight();
            },
            //翻译查询的数据源
            translateEnumValue: function(data) {
                if (!data || data.length == 0) return null;

                data.forEach(function(item) {
                    item.value = $translate.instant(item.value);
                });
                return data;
            },
            //分页下拉
            populatePagingSelection: function() {
                var pagingSelection = [];
                var pageArray = constant.page.pageSizeArrary;
                for (var i = 0; i < pageArray.length; i++) {
                    var selection = { id: pageArray[i], value: pageArray[i] };
                    pagingSelection.push(selection);
                }
                $scope.pagingOptions.pagingSelection = pagingSelection;
            },
        };

        //button的事件
        $scope.eventService = {
            //上传
            gotoUploadIndexPage: function() {
                $location.path(uploadIndexPageUrl);
            },

            checkHasItemSelected: function() {
                if (!$scope.datagrid.selectedItems || $scope.datagrid.selectedItems.length == 0) {
                    messagebox.warning("请至少选择一条记录", true);
                    return false;
                }
                return true;
            },

            //发票识别,已上传、已补录：识别
            invoiceManualRecognize: function() {

                if (!$scope.eventService.checkHasItemSelected()) {
                    return false;
                }

                //只有已上传、已补录，可以做识别
                var filterResult = _.filter($scope.datagrid.selectedItems, function(item) {
                    return item.status !== constant.inputInvoice.statusType.InvoiceHasUpload.id &&
                        item.status !== constant.inputInvoice.statusType.InvoiceHasAddRecord.id
                });

                if (filterResult.length > 0) {
                    messagebox.success("只有已上传或者已补录的发票可以做发票识别", true);
                    return;
                }
                var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');

                updateService.invoiceManualRecognize(selectedInvoiceIDList).then(function(data) {
                    if (data) {
                        messagebox.success("发票识别成功", true);
                    }
                });
            },
            //发票验真,只有识别成功的才可以做验真。
            invoiceExamination: function() {
                if (!$scope.eventService.checkHasItemSelected()) {
                    return false;
                }
                //只有识别成功的才可以做验真。
                var filterResult = _.filter($scope.datagrid.selectedItems, function(item) {
                    return item.status !== constant.inputInvoice.statusType.InvoiceIdentifySuccess.id;
                });

                if (filterResult.length > 0) {
                    messagebox.success("只有识别成功的发票可以做验真", true);
                    return;
                }
                var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');

                updateService.invoiceExamination(selectedInvoiceIDList).then(function(data) {
                    if (data) {
                        messagebox.success("发票验真成功", true);
                    }
                });
            },
            //退票
            refundInovice: function() {
                if (!$scope.eventService.checkHasItemSelected()) {
                    return false;
                }
                var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');
                var status = stant.inputInvoice.statusType.InvoiceHasRefund.id;
                messagebox.confirm("确认要把选中的发票进行退票处理吗？", '').then(function(isConfirm) {
                    if (isConfirm) {
                        updateService.updateInvoiceStatus(selectedInvoiceIDList, status).then(function(data) {
                            if (data) {
                                messagebox.success("退票成功", true);
                            }
                        });
                    }
                });

            },
            //发票认证
            verifyInvoice: function() {
                //上传excel
            },
            //失效
            expireInvoice: function() {
                if (!$scope.eventService.checkHasItemSelected()) {
                    return false;
                }
                var selectedInvoiceIDList = _.pluck($scope.datagrid.selectedItems, 'id');
                var status = stant.inputInvoice.statusType.InvoiceHasExpired.id;
                messagebox.confirm("确认要把选中的发票进行失效处理吗？", '').then(function(isConfirm) {
                    if (isConfirm) {
                        updateService.updateInvoiceStatus(selectedInvoiceIDList, status).then(function(data) {
                            if (data) {
                                messagebox.success("处理成功", true);
                            }
                        });
                    }
                });
            },
            //显示Mapping 界面
            showMapping: function() {
                $scope.isOpenMapping = true;
            }
        }

        //datagrid内部的事件
        $scope.dataGridService = {
            //发票识别
            manualRecognizInvoice: function(data) {

                var selectedInvoiceIDList = [];
                if (data) {
                    selectedInvoiceIDList.push(data.id);
                }
                if (selectedInvoiceIDList.length > 0) {
                    updateService.invoiceManualRecognize(selectedInvoiceIDList).then(function(data) {
                        if (data) {
                            messagebox.success("发票识别成功", true);
                        }
                    });
                }
            },
            //发票验真
            invoiceExamination: function(data) {
                var selectedInvoiceIDList = [];
                if (data) {
                    selectedInvoiceIDList.push(data.id);
                }
                if (selectedInvoiceIDList.length > 0) {
                    updateService.invoiceExamination(selectedInvoiceIDList).then(function(data) {
                        if (data) {
                            messagebox.success("发票验真成功", true);
                        }
                    });
                }
            },
            //手动验真
            manualVerifyInvoice: function(data) {},
            //退票
            refundInovice: function() {
                var selectedInvoiceIDList = [];
                if (data) {
                    selectedInvoiceIDList.push(data.id);
                }
                if (selectedInvoiceIDList.length > 0) {
                    var status = stant.inputInvoice.statusType.InvoiceHasRefund.id;
                    messagebox.confirm("确认要把选中的发票进行退票处理吗？", '').then(function(isConfirm) {
                        if (isConfirm) {
                            updateService.updateInvoiceStatus(selectedInvoiceIDList, status).then(function(data) {
                                if (data) {
                                    messagebox.success("退票成功", true);
                                }
                            });
                        }
                    });
                }
            },
            //票账匹配
            matchTicketAccount: function(data) {

            },
            //手动验真
            invoiceManualExamination: function(data) {

            },
        }

        //搜索框的处理
        $scope.buttonService = {
            //手工拉取数据
            manualUpdateSFData: function() {
                var deferred = $q.defer();
                vatOutputInvoiceManageService.ManualUpdateSFData().success(function(data) {
                    deferred.resolve({ data: data });
                }).error(function() {
                    deferred.reject("Data Loading Error");
                });
                return deferred.promise;
            }
        }

        //分页里面的处理
        $scope.pagingSercice = {
            setPage: function(pageNo) {

                //$scope.currentPage = pageNo;
            },
            //分页的时候改变数字
            pageIndexChanging: function() {
                if ($scope.pagingOptions.pageIndex > $scope.pagingOptions.totalPages) {
                    $scope.pagingOptions.pageIndex = $scope.pagingOptions.totalPages;
                }

                $log.log('Page changed to: ' + $scope.pagingOptions.pageIndex);
                mainModule.loadInvoiceData();
            },

            //每页显示的数据下拉改变
            pageSizeSelectionChanged: function() {
                $scope.pagingOptions.pageSize = parseInt($scope.pagingOptions.pageSizeString);
                // getService.getInputInvoiceList();
                mainModule.loadInvoiceData();
            },
        };


        var loadInvoiceGridData = function() {


            getService.getInputInvoiceList($scope.searchEntity);

            $timeout(function() {
                memoryService.repaintInvoiceGrid();
            }, 50);

        }

        //初始化invoice datagrid 树
        var InitInvoiceGrid = function() {
            $scope.invoiceGridOptions = {
                bindingOptions: {
                    dataSource: 'invoiceGridDataSource'
                },
                // keyExpr: "ID",
                selection: {
                    mode: "multiple",
                    showCheckBoxesMode: 'always'
                },
                paging: {
                    enabled: false,
                },
                columnFixing: {
                    enabled: true
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                rowAlternationEnabled: true,
                hoverStateEnabled: true,
                showBorders: true,
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                onContentReady: function(e) {
                    $scope.invoiceGridInstance = e.component;
                },
                onCellPrepared: function(e) {
                    //已退票,已失效不显示checkbox
                    if (e.rowType === "data" & e.column.command === 'select' &&
                        (e.data.status === constant.inputInvoice.statusType.InvoiceHasRefund.id ||
                            e.data.status === constant.inputInvoice.statusType.InvoiceHasExpired.id)) {
                        e.cellElement.find('.dx-select-checkbox').hide();
                        //e.cellElement.find('.dx-select-checkbox').addClass('dx-state-disabled');
                        e.cellElement.off();
                    }
                },
                onSelectionChanged: function(data) {
                    $scope.datagrid.selectedItems = data.selectedRowsData;
                    //$scope.selectedItemIDs = _.pluck(data.selectedRowsData, 'id');
                    //$scope.selectedPlaceholder = data.selectedRowsData.length;
                    //$scope.disabled = !$scope.selectedItemIDs.length;
                },
                columns: [
                    { dataField: 'invoiceCode', caption: $translate.instant('InvoiceFPDM'), },
                    { dataField: 'invoiceNumber', caption: $translate.instant('InvoiceFPHM') },
                    { dataField: 'buyerName', caption: $translate.instant('BuyerName') },
                    { dataField: 'buyerTaxNumber', caption: $translate.instant('BuyerTaxNumber') },
                    { dataField: 'sellerName', caption: $translate.instant('SellerName') },
                    { dataField: 'sellerTaxNumber', caption: $translate.instant('SellerTaxNumber') },
                    { dataField: 'amount', caption: $translate.instant('FaceTaxAmount') }, //税额合计小写
                    { dataField: 'taxAmount', caption: $translate.instant('InvoiceSE') }, //税额
                    { dataField: 'invoiceDate', caption: $translate.instant('InvoiceDate') }, //开票日期
                    { dataField: 'invoiceEntityTypeString', caption: $translate.instant('InvoiceEntity') },
                    { dataField: 'invoiceTypeString', caption: $translate.instant('InvoiceFPLX') },
                    { dataField: 'uploadDate', caption: $translate.instant('UploadDate') },
                    { dataField: 'invoiceSourceTypeString', caption: $translate.instant('InvoiceSource') }, //发票来源
                    { dataField: 'uploadTypeString', caption: $translate.instant('UploadType') },
                    { dataField: 'statusString', caption: $translate.instant('InvoiceStatus') },
                    {
                        dataField: 'id',
                        caption: $translate.instant('Operation'),
                        cellTemplate: function(container, options) {
                            try {
                                var data = options.data;
                                var invoiceStatusType = constant.inputInvoice.statusType;
                                //已上传、已补录：识别
                                if (data.status == invoiceStatusType.InvoiceHasUpload.id || data.status == invoiceStatusType.InvoiceHasAddRecord.id) {
                                    $("<span class='span-btn' />")
                                        .text('识别')
                                        .on('click', function() {
                                            $scope.dataGridService.manualRecognizInvoice(data);
                                        })
                                        .appendTo(container);
                                }
                                //识别成功：验真
                                else if (data.status == invoiceStatusType.InvoiceIdentifySuccess.id) {
                                    $("<span class='span-btn' />")
                                        .text('验真')
                                        .on('click', function() {
                                            $scope.dataGridService.invoiceExamination(data);
                                        })
                                        .appendTo(container);
                                }
                                //无法识别：退票
                                else if (data.status == invoiceStatusType.InvoiceUnrecognize.id) {
                                    $("<span class='span-btn' />")
                                        .text('退票')
                                        .on('click', function() {
                                            $scope.dataGridService.refundInovice(data);
                                        })
                                        .appendTo(container);
                                }
                                //验真失败：手动验真
                                else if (data.status == invoiceStatusType.InvoiceVerifyFailure.id) {
                                    $("<span class='span-btn' />")
                                        .text('手动验真')
                                        .on('click', function() {
                                            $scope.dataGridService.invoiceManualExamination(data);
                                        })
                                        .appendTo(container);
                                }
                                //待匹配：票账匹配，退票 
                                else if (data.status == invoiceStatusType.InvoicePendingMatch.id) {
                                    $("<span class='span-btn' />")
                                        .text('票账匹配')
                                        .on('click', function() {
                                            $scope.dataGridService.matchTicketAccount(data);
                                        })
                                        .appendTo(container);

                                    $("<span class='span-btn' />")
                                        .text('退票')
                                        .on('click', function() {
                                            $scope.dataGridService.refundInovice(data);
                                        })
                                        .appendTo(container);
                                }
                            } catch (e) {
                                $log.error(e);
                            }
                        }
                    },
                ],

                masterDetail: {
                    enabled: true,
                    template: "detail"
                },
                detailGridOptions: function(invoiceID) {
                    return {
                        dataSource: new DevExpress.data.DataSource({
                            load: function(loadOptions) {
                                var deferred = $q.defer();
                                return InvoiceManageService.getInputInvoiceItemList(invoiceID).success(function(response) {
                                    deferred.resolve({ data: response, totalCount: response.length });
                                }).error(function() {
                                    deferred.reject("Data Loading Error");
                                });
                                return deferred.promise;
                            }
                        }),
                        noDataText: $translate.instant('NoDataText'),
                        columnAutoWidth: true,
                        //showBorders: true,
                        allowColumnResizing: true,
                        columns: [{
                                dataField: 'productionName',
                                caption: $translate.instant('ProductAndService')
                            },
                            {
                                dataField: 'specification',
                                caption: $translate.instant('Specifications')
                            },
                            {
                                dataField: 'unit',
                                caption: $translate.instant('Unit')
                            },
                            {
                                dataField: 'quantity',
                                caption: $translate.instant('Quantity')
                            },
                            {
                                dataField: 'unitPrice',
                                caption: $translate.instant('UnitPrice')
                            },
                            {
                                dataField: 'amount',
                                caption: $translate.instant('Amount')

                            },
                            {
                                dataField: 'taxRate',
                                caption: $translate.instant('TaxRate')
                            },
                            {
                                dataField: 'taxAmount',
                                caption: $translate.instant('TaxAmount')
                            },
                            {
                                dataField: 'remark',
                                caption: $translate.instant('Remark')
                            },
                            {
                                dataField: 'id',
                                caption: $translate.instant('Operation'),
                                cellTemplate: function(container, options) {
                                    try {
                                        var data = options.data;
                                        // 打印预览
                                        $("<span class='span-btn' />")
                                            .text('Preview')
                                            .on('click', function() {
                                                $scope.preview(data);
                                            })
                                            .appendTo(container);


                                    } catch (e) {
                                        $log.error(e);
                                    }
                                }
                            }

                        ]
                    }
                }
            };
        };

        var initDatePicker = function() {
            $('#invoiceDatePicker,#uploadDatepicker').datepicker({
                language: region
            });
        };

        //搜索框初始化
        var initSearchBoxContorls = function() {

            var valueExpr = "id";
            var displayExpr = "value";

            var isShowClearButton = true;


            $scope.minDate = new Date(2000, 0, 1);
            $scope.maxDate = new Date(2029, 11, 31);
            $scope.searchEntityOptions = {
                //1. entity name
                txtEntityNameOptions: {
                    bindingOptions: {
                        value: 'searchEntity.entityName',
                    },
                    // placeholder: $scope.pleaseSelect,
                    showClearButton: isShowClearButton,
                    noDataText: $scope.translated.NoData,
                },
                //2. last 
                lastModifiedDateOptions: {
                    min: $scope.minDate,
                    max: $scope.maxDate,
                    bindingOptions: {
                        value: 'searchEntity.lastModifiedBy'
                    }
                },
                txtVINOptions: {
                    bindingOptions: {
                        value: 'searchEntity.vin',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    noDataText: $scope.translated.NoData,
                },

                txtInvoiceCaseNumberOptions: {
                    bindingOptions: {
                        value: 'searchEntity.caseNumber',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    noDataText: $scope.translated.NoData,
                },
                txtCommissionableStoreOptions: {
                    bindingOptions: {
                        value: 'searchEntity.commissionableStore',
                    },
                    placeholder: $scope.pleaseInput,
                    showClearButton: isShowClearButton,
                    noDataText: $scope.translated.NoData,
                },
            };
        };

        //初始化控件
        var initControls = function() {
            initDatePicker();
            initSearchBoxContorls();
            // InitInvoiceGrid();
        };

        //初始化数据
        var initData = function() {
            $scope.searchFilterOptions = {};

            $scope.invoiceOperateType = null;
            // memoryService.populatePagingSelection();
            // loadInvoiceGridData();
            // getService.getInvoiceFilterBasicData();
        };

        $scope.test = function() {
            // $scope.invoicePriceOperateType = constant.Operation.Edit;
            // $scope.invoicePriceModel = {
            //     subtotalforFinalPayment: 12
            // };

            $scope.invoiceOperateType = constant.Operation.Add;
            $scope.invoiceModel = {};
        };

        var mainModule = {
            OutputInvoiceEditedList: [],
            DetailsText: $translate.instant('Details'),
            Unstarted: $translate.instant('Waiting'),
            Completed: $translate.instant('Completed'),
            Processing: $translate.instant('Processing'),

            // 用户所属机构
            OwnerOrgModel: null,

            SalesOrgModel: {},

            TaxControlDiskModel: {},
            // 选中的发票列表
            SelectedInvoiceList: [],
            main: function() {
                initSearchBoxContorls();
                mainModule.initInvoiceGrid();

                mainModule.loadInvoiceData();

                memoryService.populatePagingSelection();

                $scope.searchList = mainModule.loadInvoiceData;

                $scope.preview = mainModule.preview;

                $scope.openSelectSalesInfoAndTaxControlDisk = mainModule.openSelectSalesInfoAndTaxControlDisk;

                $scope.cancelPrintBDInvoice = mainModule.cancelPrintBDInvoice;

                mainModule.loadOwnerOrg();
            },

            // 初始化发票表
            initInvoiceGrid: function() {

                $scope.invoiceGridDataSource = [];
                $scope.invoiceEditGridOptions = {
                    bindingOptions: {
                        dataSource: 'invoiceGridDataSource'
                    },
                    // keyExpr: "ID",
                    selection: {
                        mode: "multiple",
                        showCheckBoxesMode: 'always'
                    },
                    paging: {
                        enabled: true,
                    },
                    columnFixing: {
                        enabled: true
                    },
                    allowColumnResizing: true,
                    columnAutoWidth: true,
                    showRowLines: true,
                    showColumnLines: true,
                    // rowAlternationEnabled: true,
                    showBorders: true,
                    // height: '400px',
                    noDataText: $translate.instant('NoDataText'),
                    selectAllText: $translate.instant('SelectAll'),
                    columnChooser: {
                        enabled: true
                    },
                    onContentReady: function(e) {
                        $scope.invoiceGridInstance = e.component;
                    },
                    onSelectionChanged: function(data) {
                        mainModule.SelectedInvoiceList = data.selectedRowsData;
                    },
                    columns: [
                        { dataField: 'vehicleroutinglocation', caption: $translate.instant('VehicleroutinglocationText') },
                        { dataField: 'vin', caption: $translate.instant('VinNumber') },
                        { dataField: 'caseNumber', caption: $translate.instant('InvoiceCaseNumberText') },
                        { dataField: 'modelSeries', caption: $translate.instant('ModelSeries') },
                        { dataField: 'cabinConfiguration', caption: $translate.instant('CabinConfig') }, //发票来源
                        { dataField: 'brandandModelNumber', caption: $translate.instant('MakeAndModel') },
                        { dataField: 'commissionableStore', caption: $translate.instant('CommissionableStore') },
                        { dataField: 'registrationLocalName', caption: $translate.instant('RegistrationLocalName') },
                        { dataField: 'companyVATIDTaxID', caption: $translate.instant('CompanyTaxID'), visible: false }, //税额
                        {
                            dataField: 'subtotalforFinalPayment',
                            caption: $translate.instant('SubtotalForFinalPayment'),
                            format: { type: 'fixedPoint', precision: 2 }
                        },
                        {
                            dataField: 'id',
                            caption: $translate.instant('DetailsText'),
                            cellTemplate: function(container, options) {
                                try {
                                    var data = options.data;
                                    var invoiceStatusType = constant.inputInvoice.statusType;
                                    // 打印预览

                                    $("<span class='span-btn' />")
                                        .text(mainModule.DetailsText)
                                        .on('click', function() {
                                            $scope.preview(data);
                                        })
                                        .appendTo(container);


                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        { dataField: 'importCertificateNumber', caption: $translate.instant('ImportCertificate'), visible: false }, //开票日期
                        { dataField: 'motorNumber', caption: $translate.instant('MotorNumber'), visible: false },
                        { dataField: 'ciqNumber', caption: $translate.instant('CIQNumber'), visible: false },
                        { dataField: 'lastModifiedBy', caption: $translate.instant('LastModifiedBy'), width: 90, visible: false },
                        { dataField: 'otherItem1', caption: $translate.instant('otherItem1'), visible: false },
                        { dataField: 'otherItem1Amount', caption: $translate.instant('otherItem1Amount'), visible: false },
                        { dataField: 'otherItem2', caption: $translate.instant('otherItem2'), visible: false },
                        { dataField: 'otherItem2Amount', caption: $translate.instant('otherItem2Amount'), visible: false },
                        { dataField: 'otherItem3', caption: $translate.instant('otherItem3'), visible: false },
                        { dataField: 'otherItem3Amount', caption: $translate.instant('otherItem3Amount'), visible: false },
                        // { dataField: 'status', caption: $translate.instant('Status') },
                        { dataField: 'bdFapiaoEntity', caption: $translate.instant('VehicleroutinglocationText'), visible: false },
                        { dataField: 'driverLicenseOrgCode', caption: $translate.instant('DriverLicense'), visible: false }, //税额合计小写

                    ],
                    masterDetail: {
                        enabled: true,
                        template: "paymentDetail"
                    },
                    paymentDetailOptions: function(payments) {
                        return {
                            dataSource: payments,
                            columnAutoWidth: true,
                            showBorders: true,
                            width: '92%',
                            height: '95%',
                            noDataText: $translate.instant('NoDataText'),
                            columns: [
                                { dataField: 'paymentAmount', caption: $translate.instant('PaymentAmount') },
                                {
                                    dataField: 'paymentDate',
                                    caption: $translate.instant('PaymentDate'),
                                    dataType: 'date',
                                    format: 'yyyy-MM-dd'
                                },
                                { dataField: 'payorName', caption: $translate.instant('PayorName') },
                                {
                                    dataField: 'UpdateTime',
                                    dataType: 'date',
                                    format: 'yyyy-MM-dd',
                                    caption: $translate.instant('UpdateTime')
                                }
                            ]
                        }
                    }

                };
            },

            // 获取编辑发票数据
            loadInvoiceData: function() {
                var model = {};
                vatOutputInvoiceManageService.getOutputInvoiceEditedList(model).success(function(data) {
                    mainModule.OutputInvoiceEditedList = mainModule.parseData(data);
                    // mainModule.computePageInfo(data);

                    mainModule.searchList(mainModule.OutputInvoiceEditedList);

                    $timeout(function() {
                        memoryService.repaintInvoiceGrid();
                    }, 50);
                });
            },

            showList: function(data) {
                $scope.invoiceGridDataSource = data;
                // $timeout(function() {
                //     $scope.invoiceGridDataSource = data;
                //     // memoryService.repaintInvoiceGrid();
                // }, 50);
            },
            // 计算分页信息
            computePageInfo: function(data) {
                if (!data) {
                    data = [];
                }

                $scope.pagingOptions.totalItems = data.length;
                var totalCount = data.length;
                var totalPage = parseInt(totalCount / $scope.pagingOptions.pageSize);
                totalPage = totalCount % $scope.pagingOptions.pageSize == 0 ? totalPage : totalPage + 1;
                $scope.pagingOptions.totalPages = totalPage;

                if ($scope.pagingOptions.pageIndex > totalPage) {
                    $scope.pagingOptions.pageIndex = totalPage;
                }

                if ($scope.pagingOptions.pageIndex < 1) {
                    $scope.pagingOptions.pageIndex = 1;
                }

                var startIndex = ($scope.pagingOptions.pageIndex - 1) * $scope.pagingOptions.pageSize;

                var endIndex = $scope.pagingOptions.pageIndex * $scope.pagingOptions.pageSize;

                if (endIndex > totalCount) {
                    endIndex = totalCount;
                }


                var result = data.slice(startIndex, endIndex);

                $timeout(function() {
                    $scope.invoiceGridDataSource = result;
                    memoryService.repaintInvoiceGrid();
                }, 10);
            },

            // 查找list
            searchList: function() {

                var filterFunction = function(row, field, searchText) {
                    if (searchText) {
                        searchText = searchText.trim().toLowerCase();

                        var temp = '';
                        if (row[field]) {
                            temp = row[field].trim().toLowerCase();
                        }

                        if (temp.indexOf(searchText) === -1) {
                            return false;
                        }
                    }

                    return true;
                };

                var result = _.filter(mainModule.OutputInvoiceEditedList, function(row) {

                    if (!filterFunction(row, 'vin', $scope.searchEntity.vin)) {
                        return false;
                    }

                    if (!filterFunction(row, 'caseNumber', $scope.searchEntity.caseNumber)) {
                        return false;
                    }

                    if (!filterFunction(row, 'commissionableStore', $scope.searchEntity.commissionableStore)) {
                        return false;
                    }

                    return true;
                });

                mainModule.showList(result);

            },

            // 转换时间格式
            parseData: function(result) {
                if (result && result.length > 0) {
                    result.forEach(function(row) {

                        if (row.lastModifiedBy) {
                            var d = window.PWC.parseFromLocalTimeString(row.lastModifiedBy);
                            row.lastModifiedBy = d.formatDateTime('yyyy-MM-dd');
                        }

                        var driverLicenseOrgCode = '';
                        if (row.driverLicense) {
                            driverLicenseOrgCode += row.driverLicense;
                        }

                        if (row.organizationCode) {
                            driverLicenseOrgCode += '/' + row.organizationCode;
                        }

                        row.driverLicenseOrgCode = driverLicenseOrgCode;

                        if (row.operateStatus === 0) {
                            row.status = "normal";
                        } else if (row.operateStatus === 1) {
                            row.status = "issued";
                        }
                    });
                }

                return result;
            },

            // 打印预览
            preview: function(data) {
                // body...
                $scope.invoiceModel = mainModule.parsePrintData(data);

                $scope.invoiceOperateType = constant.Operation.Edit;

                $scope.closeInvoiceModal = function(param) {
                    $state.go('outputInvoiceManage.issuedInvoiceBdView');
                };

                // 取消的时候，如果改变了数据，则重新刷新
                $scope.changeInvoiceModal = function(param) {
                    mainModule.loadInvoiceData();
                };
            },

            // 购房名称及身份证号码，组织机构代码
            getBuyerInfo: function(data) {

                var str = '';

                if (!data) {
                    return str;
                }

                // if (data.registrationLocalName) {
                //     str = data.registrationLocalName;
                // }

                if (data.driverLicense) {
                    str += data.driverLicense;
                }

                if (data.organizationCode) {
                    str += data.organizationCode;
                }

                return str;

            },

            // 转换为打印数据
            parsePrintData: function(data) {
                var invoiceModel = {
                    editInvoiceId: data.id,
                    buyerInfo: data.buyerInfo,
                    registrationLocalName: data.registrationLocalName,
                    buyerIDOrCode: '',
                    companyVATIDTaxID: data.companyVATIDTaxID,
                    category: '',
                    cabinConfiguration: data.cabinConfiguration,
                    producingPlace: data.producingPlace,
                    certificateNumber: data.certificateNumber,
                    importCertificateNumber: data.importCertificateNumber,
                    ciqNumber: data.ciqNumber,
                    motorNumber: data.motorNumber,
                    vin: data.vin,
                    subtotalforFinalPaymentCH: '',
                    subtotalforFinalPayment: data.subtotalforFinalPayment,
                    invoiceCode: '',
                    invoiceNumber: '',
                    salesUnitName: data.salesUnitName,
                    salesUnitPhoneNumber: data.salesUnitPhoneNumber,
                    salesTaxPayerNumber: data.salesTaxPayerNumber,
                    salesAccount: data.salesAccount,
                    salesAddress: data.salesAddress,
                    salesBankName: data.salesBankName,
                    vatRateorLevyRate: data.vatRateorLevyRate,
                    taxableSubtotal: data.taxableSubtotal,
                    mainTaxAuthoritiesCode: '',
                    excludeTaxPrice: null,
                    taxPaymentCertificateNumber: '',
                    organizationCode: data.organizationCode,
                    driverLicense: data.driverLicense,
                    deliveryStatus: data.deliveryStatus,
                    vehicleroutinglocation: data.vehicleroutinglocation,
                    caseNumber: data.caseNumber,
                    // 吨位
                    tonnage: data.tonnage,

                    // 限乘人数
                    capacity: data.capacity,

                    // 生产企业名称
                    manufacturer: '拓速乐佛利蒙总装厂',
                    governmentClassification: data.governmentClassification,
                    brandandModelNumber: data.brandandModelNumber,
                    reasonIDList: data.reasonIDList,
                    sameVehicleroutinglocationList: mainModule.OwnerOrgModel.sameVehicleroutinglocationList,

                    taxControlDisk: mainModule.TaxControlDiskModel
                };

                if (mainModule.SalesOrgModel) {
                    invoiceModel.salesUnitName = mainModule.SalesOrgModel.name;
                    invoiceModel.salesUnitPhoneNumber = mainModule.SalesOrgModel.phoneNumber;
                    invoiceModel.salesTaxPayerNumber = mainModule.SalesOrgModel.taxPayerNumber;
                    invoiceModel.salesAccount = mainModule.SalesOrgModel.bankAccountNumber;
                    invoiceModel.salesAddress = mainModule.SalesOrgModel.manufactureAddress;
                    invoiceModel.salesBankName = mainModule.SalesOrgModel.bankAccountName;
                }

                if (!invoiceModel.producingPlace) {
                    invoiceModel.producingPlace = '美国';
                }



                invoiceModel.subtotalforFinalPaymentCH = window.PWC.convertChineseCurrency(data.subtotalforFinalPayment);

                invoiceModel.buyerIDOrCode = mainModule.getBuyerInfo(data);

                return invoiceModel;
            },

            getBdInvoiceInventory: function() {
                if (!mainModule.SelectedInvoiceList || mainModule.SelectedInvoiceList.length === 0) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                }

                if (!mainModule.TaxControlDiskModel || !mainModule.TaxControlDiskModel.id) {
                    return;
                }


                vatOutputInvoiceManageService.getBdInvoiceInventory(mainModule.TaxControlDiskModel.id).then(function(data) {
                    if (data && data.data && data.data.data) {
                        $scope.preIssueEntity = data.data.data;
                    } else {
                        $scope.preIssueEntity.inventory = 0;
                        $scope.preIssueEntity.thresholdValue = 20;
                    }

                    var promise;
                    var result = true;

                    if ($scope.preIssueEntity.inventory === 0) {
                        // promise = messagebox.info($translate.instant("PaperInvoiceRunnOut"), '');
                        result = false;

                        // Paper 已经用完了
                        $scope.inventoryType = 1;
                        promise = $q.when(result);
                    } else if ($scope.preIssueEntity.inventory < $scope.preIssueEntity.thresholdValue) {
                        // promise = messagebox.info($translate.instant("PaperInvoiceRunningOut"), '');
                        promise = $q.when(result);

                        // Paper快完了
                        $scope.inventoryType = 2;
                    } else {

                        // paper 充足
                        $scope.inventoryType = 3;
                        promise = $q.when(result);
                    }

                    return promise;
                }).then(function() {

                    // 弹出选择框
                    // mainModule.openSelectSalesInfoAndTaxControlDisk();
                });
            },

            openSelectSalesInfoAndTaxControlDisk: function() {

                if (!mainModule.SelectedInvoiceList || mainModule.SelectedInvoiceList.length === 0) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                }

                $scope.inventoryType = 0;
                mainModule.SalesOrgModel = {};
                mainModule.TaxControlDiskModel = {};

                var editModel = {};
                $scope.editModel = editModel;

                var defaultSalesId = null;
                if (mainModule.OwnerOrgModel.sameVehicleroutinglocationList && mainModule.OwnerOrgModel.sameVehicleroutinglocationList.length === 1) {
                    mainModule.SalesOrgModel = mainModule.OwnerOrgModel.sameVehicleroutinglocationList[0];
                    defaultSalesId = mainModule.OwnerOrgModel.sameVehicleroutinglocationList[0].id;
                }

                $scope.selectSalesOrg = {};

                $scope.selectTaxControlDisk = {};

                var SalesChanged = function(data) {
                    $scope.selectSalesOrg = data;

                    $scope.selectTaxControlDisk = {};

                    if (data.taxControlDiskList && data.taxControlDiskList.length > 0) {
                        data.taxControlDiskList.forEach(function(row) {
                            row.name = row.taxControlDiskSerialNumber + row.taxControlDiskDescribe;
                        });

                        if (data.taxControlDiskList.length === 1) {
                            $scope.selectTaxControlDisk = data.taxControlDiskList[0];
                            mainModule.TaxControlDiskModel = $scope.selectTaxControlDisk;
                        }
                    }

                };


                var taxControlDiskChanged = function(model) {

                    mainModule.TaxControlDiskModel = model;
                    mainModule.getBdInvoiceInventory();
                };

                $scope.mainDxOptions = {
                    selectTaxControlDiskOptions: {
                        bindingOptions: {
                            dataSource: 'selectSalesOrg.taxControlDiskList',
                            value: 'selectTaxControlDisk.id',
                        },
                        onSelectionChanged: function(args) {
                            // mainModule.TaxControlDiskModel = args.selectedItem;

                            taxControlDiskChanged(args.selectedItem);
                        },
                        noDataText: $translate.instant('NoDataText'),
                        valueExpr: 'id',
                        displayExpr: 'name'
                    },
                    selectSalesOptions: {
                        dataSource: mainModule.OwnerOrgModel.sameVehicleroutinglocationList,
                        onSelectionChanged: function(args) {
                            mainModule.SalesOrgModel = args.selectedItem;
                            SalesChanged(args.selectedItem);
                        },
                        value: defaultSalesId,
                        valueExpr: 'id',
                        displayExpr: 'name'
                    },
                };


                $scope.mainDxValidateOptions = {
                    selectTaxControlDiskOptions: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('TaxControlDiskRequire')
                        }]
                    },

                    selectSalesOptions: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('BDRequire')
                        }]
                    },
                };


                var modalInstance = $uibModal.open({
                    animation: false,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'fapiaoIssuingConfirmModal.html',
                    //windowClass: 'printInvoiceListModal',
                    size: 'selectEntityDisk',
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    // $scope.templateModel = data;
                    $scope.isUpdate = true;
                    $scope.isReadOnly = true;
                    // $scope.onClosed({ model: data });
                    $scope.operateType = null;
                }, function() {
                    $scope.operateType = null;
                    $scope.isReadOnly = true;
                    $scope.isUpdate = false;
                    //$log.info('Modal dismissed at: ' + new Date());
                });


                $scope.saveIssuing = function() {
                    var dxResult = DevExpress.validationEngine.validateGroup($('#IssuingFapiaoConfirmForm').dxValidationGroup("instance")).isValid;
                    if (!dxResult) {
                        return;
                    }

                    modalInstance.close($scope.editModel);

                    mainModule.openPrintProgressModal();
                };

                // 取消
                $scope.cancel = function() {

                    modalInstance.dismiss('cancel');
                };

            },

            // 弹框打印列表
            openPrintProgressModal: function() {
                // 弹框打印列表

                var taskList = [];
                mainModule.SelectedInvoiceList.forEach(function(row) {

                    var vinStr = row.vin ? '/' + row.vin : '';
                    var item = {
                        text: mainModule.Unstarted,
                        status: 'Unstarted',
                        name: row.modelSeries + vinStr
                    };

                    item.data = mainModule.parsePrintData(row);

                    taskList.push(item);

                    if (row.isNeedSendEmail == enums.IsNeedSendEmailEnum.Need) {
                        vatOutputInvoiceManageService.sendEmail(row.vin, row.id);
                        vatOutputInvoiceManageService.pendingForApprovalGdBdInvoice(row.vin);
                    }
                });

                var editModel = {};
                editModel.tasks = taskList;

                $scope.editModel = editModel;

                var modalInstance = $uibModal.open({
                    animation: false,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'printInvoiceListModal.html',
                    windowClass: 'printInvoiceListModal',
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    // $scope.templateModel = data;
                    $scope.isUpdate = true;
                    $scope.isReadOnly = true;
                    // $scope.onClosed({ model: data });
                    $scope.operateType = null;
                }, function() {
                    $scope.operateType = null;
                    $scope.isReadOnly = true;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });


                var saveData = function(model) {

                    modalInstance.close(model);
                };

                // 保存
                $scope.save = function() {
                    var model = $scope.editModel;

                    saveData(model);
                };

                // 取消
                $scope.cancel = function() {

                    $scope.editModel.isCancel = true;
                    modalInstance.dismiss('cancel');
                };

                var successCount = 0;

                // 循环打印到完成
                var printFunction = function(index) {

                    if ($scope.editModel.isCancel) {
                        return;
                    }

                    var row = $scope.editModel.tasks[index];
                    row.status = 'Processing';
                    row.text = mainModule.Processing;
                    row.deferTemp = $q.defer();
                    // primistList.push(row.deferTemp.promise);

                    vatOutputInvoiceManageService.addOutputInvoicePrinted(row.data, false).success(function(ret) {

                        if (ret.result) {
                            row.status = 'Completed';
                            row.text = mainModule.Completed;
                            successCount++;
                        } else {
                            row.status = 'Error';
                            row.text = $translate.instant(ret.resultMsg);
                        }

                        index++;
                        if (index === $scope.editModel.tasks.length) {
                            // 已经打印到最后一个,页面跳转

                            if (successCount === $scope.editModel.tasks.length) {
                                modalInstance.close();
                                $state.go('outputInvoiceManage.issuedInvoiceBdView');
                            }

                        } else {
                            printFunction(index);
                        }

                        // row.deferTemp.resolve(ret);
                    });
                };

                if ($scope.editModel.tasks && $scope.editModel.tasks.length > 0) {
                    printFunction(0);
                }


            },

            // 获取用户所属机构
            loadOwnerOrg: function() {
                userService.getUserOwnerOrganization().success(function(data) {

                    if (data) {
                        if (data.taxControlDiskList && data.taxControlDiskList.length > 0) {
                            data.taxControlDiskList.forEach(function(row) {

                                row.name = row.taxControlDiskSerialNumber + row.taxControlDiskDescribe;
                            });
                        }
                    }

                    mainModule.OwnerOrgModel = data;
                });
            },

            // 取消发票
            cancelPrintBDInvoice: function() {

                if (!mainModule.SelectedInvoiceList || mainModule.SelectedInvoiceList.length === 0) {
                    messageBox.warning('NoDataText', false);
                    return;
                }

                var msg = $translate.instant('Confirm') + ' ' + $translate.instant('Cancel') + '?';

                messagebox.confirm(msg, '', constant.teslaConfirmClassName).then(function(isConfirm) {
                    if (isConfirm) {

                        vatOutputInvoiceManageService.cancelBDEditList(mainModule.SelectedInvoiceList).success(function(ret) {
                            if (ret.result) {
                                SweetAlert.success($translate.instant('SaveSuccess'));
                                mainModule.loadInvoiceData();
                            } else {
                                swal($translate.instant('SaveFail'), $translate.instant('SaveFail'), 'warning');
                            }
                        });
                    }
                });

            }

        };


        (function initialize() {
            $log.debug('outputInvoiceEditController.ctor()...');
            mainModule.main();

        })();
    }
]);
invoiceModule.directive('outputInvoiceEdit', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('outputInvoiceEdit.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/output-invoice-edit/output-invoice-edit.html' + '?_=' + Math.random(),
            scope:
            {

            },
            controller: 'outputInvoiceEditController',
            link: function (scope, element) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var invoiceDataGridSelector = '#invoiceEditGridContainer';
                    var pageWrapSelector = ".output-invoice-edit-wrapper";
                    var menuSelector = ".output-invoice-edit-wrapper .header-title";
                    var contentHeader = '.edit-content-container .header';
                    var contentbody = '.edit-content-container .body';
                    var buttonRow = '.edit-content-container .buttom-row';
                    var pageFooter = '.output-invoice-edit-wrapper .page-footer';
                    var dxGridSelector = ".edit-grid-container";

                    var pageHeight = $(document).height();// 810; // parseInt($(pageWrapSelector).css('height').replace('px', ''));
                    
                    var menuHeight = $(menuSelector).outerHeight(); //parseInt($(menuSelector).css('height').replace('px', ''));

                    var contentHeaderHeight = $(contentHeader).outerHeight(); //parseInt($(contentHeader).css('height').replace('px', ''));
                    var buttonRowHeight = $(buttonRow).outerHeight();  //parseInt($(buttonRow).css('height').replace('px', ''));
                    // var pageFooterHeight = $(pageFooter).outerHeight(); //parseInt($(pageFooter).css('height').replace('px', ''));

                    var pageFooterHeight = 0;
                    var contentbodyHeight = pageHeight - menuHeight - contentHeaderHeight;
                    var height = contentbodyHeight - buttonRowHeight - pageFooterHeight - 40 + 'px';
                    $(contentbody).css('height', contentbodyHeight);
                    // $(dxGridSelector).css('height', height);
                    //$(invoiceDataGridSelector).css('max-height', '100%');

                    try {

                        var option = $('#invoiceEditGridContainer').dxDataGrid('option');
                        option.height = height;
                        $('#invoiceEditGridContainer').dxDataGrid('option', option);
                        $(invoiceDataGridSelector).dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };


                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('outputReconciliationOverviewController', ['$scope', '$log', '$document', '$uibModal', 'SweetAlert', '$translate',
    '$q', 'apiInterceptor', '$interval', 'region', '$timeout', '$location', 'vatOutputInvoiceManageService', 'enums', '$state',
    'loginContext', 'modalAdapterService', 'outputReconciliationService',
    function ($scope, $log, $document, $uibModal, SweetAlert, $translate, $q, apiInterceptor, $interval, region, $timeout,
        $location, vatOutputInvoiceManageService, enums, $state, loginContext, modalAdapterService, outputReconciliationService) {
        'use strict';
        //-----------------SearchOption定义-------------------------//start
        var isShowClearButton = true;
        $scope.searchEntity = {};
        $scope.searchOptions = {};
        $scope.searchOptions.Entity = {
            showClearButton: isShowClearButton,
            placeholder: $translate.instant('InputPlaceholder'),
            bindingOptions: {
                value: 'searchEntity.entityName'
            }
        };

        $scope.searchOptions.PeriodStart = {
            type: 'date',
            placeholder: $translate.instant("ChoosePlaceholder"),
            showClearButton: isShowClearButton,
            bindingOptions: {
                value: 'searchEntity.periodStart',
            },
            displayFormat: function (value) {
                return value.dateTimeToString('yyyyMMdd');
            }
        };

        $scope.searchOptions.PeriodEnd = {
            type: 'date',
            placeholder: $translate.instant("ChoosePlaceholder"),
            showClearButton: isShowClearButton,
            bindingOptions: {
                value: 'searchEntity.periodEnd',
            },
            displayFormat: function (value) {
                return value.dateTimeToString('yyyyMMdd');
            }
        };

        var searchService = {
            getIncomeAxList: function () {
                var incomeAxParams = {
                    QueryParam: $scope.searchEntity,
                    PagingParam: $scope.pagingOptions1,
                };

                outputReconciliationService.getIncomeAxList(incomeAxParams).success(function (data) {
                    $scope.pagingOptions1.totalItems = data.pageInfo && data.pageInfo.totalCount;
                    $scope.incomeAxReportGridDataSource = data.list;
                });
            },
            getTaxFaPiaoList: function () {
                var taxFapiaoParams = {
                    QueryParam: $scope.searchEntity,
                    PagingParam: $scope.pagingOptions2,
                };

                outputReconciliationService.getTaxFaPiaoList(taxFapiaoParams).success(function (data) {
                    $scope.pagingOptions2.totalItems = data.pageInfo && data.pageInfo.totalCount;
                    $scope.taxFapiaoGridDataSource = data.list;
                });
            }
        };

        $scope.searchEvent = function () {
            searchService.getIncomeAxList();
            searchService.getTaxFaPiaoList();
        };

        //-----------------SearchOption定义-------------------------//end

        //-----------------incomeAxReportOption定义-----------------//start
        $scope.incomeAxReportOption = {
            keyExpr: 'id',
            showRowLines: true,
            showColumnLines: true,
            showBorders: true,
            allowColumnResizing: true,
            columnAutoWidth: true,
            hoverStateEnabled: true,
            rowAlternationEnabled: true,
            allowColumnReordering: true,
            columnFixing: {
                enabled: true
            },
            paging: {
                enabled: false
            },
            columnChooser: {
                enabled: true
            },
            bindingOptions: {
                dataSource: 'incomeAxReportGridDataSource',
                height: 'incomeAxReportGridHeight'
            }
        };

        $scope.incomeAxReportOption.columns = [
            { caption: '', columns: [{ dataField: 'entity', caption: 'Entity' }] },
            {
                caption: 'Un-invoiced tax income till last mo. end', columns: [
                  { caption: '17%', dataField: 'a1' },
                  { caption: '6%', dataField: 'a2' },
                  { caption: '5%', dataField: 'a3' },
                  { caption: '2%', dataField: 'a4' }
                ]
            },
            {
                caption: 'Un-invoiced tax income this month', columns: [
                  { caption: '17%', dataField: 'b1' },
                  { caption: '6%', dataField: 'b2' },
                  { caption: '5%', dataField: 'b3' },
                  { caption: '2%', dataField: 'b4' }
                ]
            },
            {
                caption: 'Prev. un-invoiced income invoiced this mo', columns: [
                  { caption: '17%', dataField: 'c1' },
                  { caption: '6%', dataField: 'c2' },
                  { caption: '5%', dataField: 'c3' },
                  { caption: '2%', dataField: 'c4' }
                ]
            },
            {
                caption: 'Un-invoiced taxable income till this mo. end', columns: [
                  { caption: '17%', dataField: 'd1' },
                  { caption: '6%', dataField: 'd2' },
                  { caption: '5%', dataField: 'd3' },
                  { caption: '2%', dataField: 'd4' }
                ]
            },
            {
                caption: 'Filing Current month num', columns: [
                  { caption: 'Income', dataField: 'e1' },
                  { caption: 'Check', dataField: 'e2' }
                ]
            },
            { caption: 'Check Result', columns: [{ dataField: 'incomeCheck', caption: 'Income - Check' }] }
        ];

        //-----------------incomeAxReportOption定义-----------------//end

        //-----------------taxFapiaoOption定义----------------------//start
        $scope.taxFapiaoOption = {
            keyExpr: 'id',
            showRowLines: true,
            showColumnLines: true,
            showBorders: true,
            allowColumnResizing: true,
            columnAutoWidth: true,
            hoverStateEnabled: true,
            rowAlternationEnabled: true,
            allowColumnReordering: true,
            columnFixing: {
                enabled: true
            },
            paging: {
                enabled: false
            },
            columnChooser: {
                enabled: true
            },
            bindingOptions: {
                dataSource: 'taxFapiaoGridDataSource',
                height: 'taxFapiaoGridHeight'
            }
        };

        $scope.taxFapiaoOption.columns = [
            { caption: 'Entity', columns: [{ caption: '', dataField: 'entity' }] },
            { caption: 'Rate', columns: [{caption: '', dataField: 'rate'}] },
            { caption: 'Total issued tax amount', columns: [{ caption: 'a1', dataField: 'a1' }] },
            { caption: 'Total recorded but not issued tax amount', columns: [{ caption: 'a2', dataField: 'a2' }] },
            { caption: 'Reported un-issued tax amount', columns: [{ caption: 'a3', dataField: 'a3' }] },
            { caption: 'Un-issued maintenance fee tax amount', columns: [{ caption: 'a4', dataField: 'a4' }] },
            { caption: 'Total to-report tax amount', columns: [{ caption: 'A=a1+a2+a3+a4', dataField: 'a' }] },
            { caption: 'Last period reported tax amount total', columns: [{ caption: 'B-input', dataField: 'b' }] },
            { caption: 'This period to- report tax amount', columns: [{ caption: 'C=A-B', dataField: 'c' }] },
            { caption: 'This period to-report taxable revenue', columns: [{ caption: 'D=C/Rate', dataField: 'd' }] },
            { caption: 'Fapiao car and special tax amount', columns: [{ caption: 'e1', dataField: 'e1' }] },
            { caption: 'Fapiao general tax amount', columns: [{ caption: 'e2', dataField: 'e2' }] },
            { caption: 'This month fapiao total', columns: [{ caption: 'E=e1+e2', dataField: 'e' }] },
            { caption: 'This month un-issued tax amount', columns: [{ caption: 'F=C-E', dataField: 'f' }] },
            { caption: 'This month un-issued revenue total', columns: [{ caption: 'G=F/Rate', dataField: 'g' }] },
            { caption: 'Tax', columns: [{ caption: 'Total=G(17%)+G(6%)', dataField: 'Total' }] },
            { caption: 'Check Result', columns: [{ caption: 'Income-Tax', dataField: 'check' }] }
        ];

        //-----------------taxFapiaoOption定义----------------------//end

        //-----------------分页定义---------------------------------//end

        //设置dataGrid分页
        $scope.pagingOptions1 = {
            pageIndex: 1,  //当前页码
            totalItems: 100,  //总数据
            totalPages: 10,//总页数
            maxSize: 5, //分页数字的限制。
            pageSize: 10,  //每页多少条数据 
            pageSizeString: '20',
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //设置dataGrid分页
        $scope.pagingOptions2 = {
            pageIndex: 1,  //当前页码
            totalItems: 100,  //总数据
            totalPages: 10,//总页数
            maxSize: 5, //分页数字的限制。
            pageSize: 10,  //每页多少条数据 
            pageSizeString: '20',
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        //分页里面的处理
        $scope.pagingService1 = {
            setPage: function (pageNo) {

            },
            //分页的时候改变数字
            pageIndexChanging: function () {
                if ($scope.pagingOptions1.pageIndex > $scope.pagingOptions1.totalPages) {
                    $scope.pagingOptions1.pageIndex = $scope.pagingOptions1.totalPages;
                }

                $log.log('Page changed to: ' + $scope.pagingOptions1.pageIndex);
                searchService.getIncomeAxList();
            },

            //每页显示的数据下拉改变
            pageSizeSelectionChanged: function () {
                $scope.pagingOptions1.pageSize = parseInt($scope.pagingOptions1.pageSizeString);
                searchService.getIncomeAxList();
            }
        };

        //分页里面的处理
        $scope.pagingService2 = {
            setPage: function (pageNo) {

            },
            //分页的时候改变数字
            pageIndexChanging: function () {
                if ($scope.pagingOptions2.pageIndex > $scope.pagingOptions2.totalPages) {
                    $scope.pagingOptions2.pageIndex = $scope.pagingOptions2.totalPages;
                }

                $log.log('Page changed to: ' + $scope.pagingOptions2.pageIndex);
                searchService.getTaxFaPiaoList();
            },

            //每页显示的数据下拉改变
            pageSizeSelectionChanged: function () {
                $scope.pagingOptions2.pageSize = parseInt($scope.pagingOptions2.pageSizeString);
                searchService.getTaxFaPiaoList();
            }
        };
        //-----------------分页定义---------------------------------//end

        $scope.$on('teslaOutputInvoiceMenuClick', function (event, data) {
            //设置表格高度
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 500);
        });

        (function () {
            searchService.getIncomeAxList();
            searchService.getTaxFaPiaoList();
            //设置表格高度
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 500);

        })();
    }]);
invoiceModule.directive('outputReconciliationOverview', ['$log', 'SweetAlert', '$translate',
    function ($log, SweetAlert, $translate) {
        'use strict';
        $log.debug('outputReconciliationOverview.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/output-reconciliation-overview/output-reconciliation-overview.html' + '?_=' + Math.random(),
            scope:{},
            controller: 'outputReconciliationOverviewController',
            link: function (scope, element) {

                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var pageHeight = $(document).height();
                    var pageSearchHeight = $('.page-search-container').outerHeight();
                    var subHeight = pageHeight - pageSearchHeight;
                    scope.incomeAxReportGridHeight = (subHeight - 160) / 2;
                    scope.taxFapiaoGridHeight = scope.incomeAxReportGridHeight;

                    try {
                        $('#income-ax-report-grid-container').dxDataGrid('instance').repaint();
                        $('#tax-fapiao-grid-container').dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };

                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }//# end of link
        };
    }
]);
invoiceModule.controller('outputReconciliationConfigurationEditController', ['$scope', '$log', 'uiGridConstants', 'SweetAlert', '$translate', 'stdAccountService', '$interval', 'orgService', '$timeout', '$q', 'commonWebService', 'loginContext', '$uibModal', 'outputReconciliationConfiguration',
    function($scope, $log, uiGridConstants, SweetAlert, $translate, stdAccountService, $interval, orgService, $timeout, $q, commonWebService, loginContext, $uibModal, outputReconciliationConfiguration) {
        'use strict';

        var Resources = {
            Aggregation: $translate.instant('Aggregation'),
            MonthlyTotal: $translate.instant('MonthlyTotal'),
            Auto: $translate.instant('Auto'),
            Manual: $translate.instant('Manual'),
            EndYearMonthValidateMsg: $translate.instant('EndYearMonthValidateMsg'),
            BeginYearMonthRequire: $translate.instant('BeginYearMonthRequire')
        };


        var InputType = {
            NotAvailable: 2,
            OtherType: 1,
            NullInput: 0
        };

        var InputTypeValue = {
            NotAvailable: '#N/A#',
            NullInput: '#NULL#'
        };


        var thisConstant = {
            semicolonEnglist: ';'
        };


        var entityModule = {
            OrganizationList: [],

            allOrgs: $translate.instant('AllOrganization'),
            name: 'name',
            id: 'id',
            uiOrgID: 'ApplyingEntitesControls',
            orgText: $translate.instant('AllOrganization'),

            // 选中机构ID列表
            selectOrgList: [],
            selectOrgMap: {},


            // 有效的机构列表,包括所有机构,id,name,parentID,expanded
            orgList: [],
            main: function() {

                $scope.openEntityModal = function() {

                    if ($scope.editModel.type === 'query' || $scope.editModel.type === 'edit' || $scope.editModel.type === 'copy') {
                        entityModule.openEditModal($scope.editModel.applyEntities);
                    } else {
                        entityModule.openModal();
                    }
                }
            },

            loadData: function() {
                orgService.getOrganizationFilterList().success(function(data) {

                    entityModule.OrganizationList = data;
                    entityModule.orgList = entityModule.getOrgDropDownList();

                });
            },

            openModal: function() {

                var editModel = {

                };

                $scope.editEntityModel = editModel;

                mainModule.initModalControls();

                var parnet = $('#outputReconciliationConfigurationEditModalBody');

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'ApplyingEntitesDetailsModal.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'entity-size',
                    appendTo: parnet,
                    resolve: {
                        editModel: $scope.editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    // 确定关闭
                }, function() {
                    // 取消关闭
                });

                $scope.saveApplyingEntitesDetailsModal = function() {

                    $scope.editModel.selectOrgList = entityModule.selectOrgList;
                    modalInstance.close({});
                };

                $scope.cancelApplyingEntitesDetailsModal = function() {
                    modalInstance.dismiss('cancel');
                };

                $timeout(function() {
                    entityModule.drawOrgDropDownList(entityModule.orgList);
                }, 100);
            },

            openEditModal: function(selectOrgList) {

                var orgIdList = _.pluck(selectOrgList, 'organizationID');

                var data = angular.copy(entityModule.orgList);

                data.forEach(function(r) {

                    if (orgIdList.indexOf(r.id) > -1) {
                        r.selected = true;
                    } else {
                        r.selected = false;
                    }

                    if ($scope.editModel.isReadOnly) {
                        r.disabled = true;
                    }

                });

                var editModel = {

                };

                $scope.editEntityModel = editModel;

                mainModule.initModalControls();

                var parnet = $('#outputReconciliationConfigurationEditModalBody');

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'ApplyingEntitesDetailsModal.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'entity-size',
                    appendTo: parnet,
                    resolve: {
                        editModel: $scope.editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    // 确定关闭
                }, function() {
                    // 取消关闭
                });

                $scope.saveApplyingEntitesDetailsModal = function() {

                    $scope.editModel.selectOrgList = entityModule.selectOrgList;
                    modalInstance.close({});
                };

                $scope.cancelApplyingEntitesDetailsModal = function() {
                    modalInstance.dismiss('cancel');
                };

                $timeout(function() {
                    entityModule.drawOrgDropDownList(data);
                }, 100);
            },

            filterDropDownOrgList: function(orgList, selectIDList, idCol) {
                if (!orgList || orgList.length === 0) {
                    return orgList;
                }

                // 什么都没有选
                if (!selectIDList) {
                    return orgList;
                }

                // 按照条件进行过滤
                orgList = _.filter(orgList, function(row) {

                    return selectIDList.indexOf(row[idCol]) > -1;
                });

                return orgList;
            },


            filterOrgs: function() {
                if (entityModule.OrganizationList && entityModule.OrganizationList.length > 0) {

                    // 只要启用的和有权限的机构
                    var filter = _.filter(entityModule.OrganizationList, function(row) {
                        return row.isActive;
                    });


                    return filter;

                } else {
                    return [];
                }
            },

            // 获取机构drop down的list
            getOrgDropDownList: function() {
                var showList = entityModule.filterOrgs();
                showList = angular.copy(showList);
                for (var i = 0; i < showList.length; i++) {
                    var item = showList[i];
                    item.selected = false;
                    item.expanded = true;


                    if (item.parentID === null) {
                        continue;
                    }

                    var parentNode = _.find(showList, function(num) {
                        return num.id === item.parentID
                    });

                    if (parentNode) {
                        continue;
                    }

                    item.parentID = getParentID(item, entityModule.OrganizationList, showList);
                }

                var idList = _.pluck(showList, 'id');

                $scope.selectedOrganizationList = idList;

                return showList;
            },

            // 机构drop down list
            drawOrgDropDownList: function(data) {

                entityModule.selectOrgList = _.pluck(data, 'id');

                $scope.onChanged({ model: entityModule.selectOrgList });

                var syncTreeViewSelection = function(treeView, value, isReady) {

                    if (isReady) {
                        $scope.selectedOrganizationList = entityModule.selectOrgList;
                        $scope.onChanged({ model: entityModule.selectOrgList });
                    } else {
                        $scope.selectedOrganizationList = value;
                        $scope.onChanged({ model: value });
                    }
                };


                entityModule.orgDropDownInstantce = $("#" + entityModule.uiOrgID).dxDropDownBox({
                    value: '',
                    showClearButton: false,
                    contentTemplate: function(e) {
                        var value = e.component.option("value"),
                            $treeView = $("<div>").dxTreeView({
                                dataSource: data,
                                dataStructure: "plain",
                                keyExpr: "id",
                                parentIdExpr: "parentIDStr",
                                selectionMode: "multiple",
                                displayExpr: "name",
                                selectByClick: true,
                                noDataText: '',
                                height: 300,
                                itemTemplate: function(itemData, itemIndex, itemElement) {

                                    var str = itemData.code + ' ' + itemData.name;
                                    itemElement.append("<span title='" + str + "'>" + str + "</span>");
                                },
                                onContentReady: function(args) {},
                                selectNodesRecursive: false,
                                expandAllEnabled: true,
                                showCheckBoxesMode: "selectAll",
                                selectAllText: entityModule.allOrgs,
                                onItemSelectionChanged: function(args) {

                                },
                                onSelectionChanged: function(args) {
                                    var value = args.component.getSelectedNodesKeys();
                                    var text = '';
                                    if (value && value.length === data.length) {
                                        text = entityModule.allOrgs;
                                    } else {
                                        text = '选中' + value.length + '个机构';
                                    }

                                    entityModule.selectOrgList = value;
                                    e.component.option("value", text);
                                    entityModule.orgText = text;
                                    syncTreeViewSelection(entityModule.orgTreeView, value, false);
                                }
                            });

                        entityModule.orgTreeView = $treeView.dxTreeView("instance");
                        entityModule.orgText = e.component.option("text");


                        return $treeView;
                    }
                });
            }

        };


        var mainModule = {

            TagList: [
                { id: constant.TagRule.Aggregation, name: Resources.Aggregation },
            ],

            main: function() {

                // 设置一个默认
                $scope.editModel = {
                    preVoucherNumberType: 0
                };

                mainModule.watchCollection();

                entityModule.main();
            },

            initModalControls: function() {


                $scope.modalControls = {};


                $scope.editModel.TagList = mainModule.TagList;

                $scope.editModel.TaxRateList = ["17%", "6%"];

                $scope.modalControls.dxOptions = {
                    ruleNoOpt: {
                        bindingOptions: {
                            value: 'editModel.ruleNo',
                            // readOnly: 'editModel.isReadOnly',
                        },
                        readOnly: true,
                        maxLength: 50
                    },

                    tagOpt: {
                        bindingOptions: {
                            'value': 'editModel.tag',
                            'dataSource': 'editModel.TagList',
                            readOnly: 'editModel.isReadOnly',
                        },
                        onSelectionChanged: function(args) {

                        },
                        displayExpr: 'name',
                        valueExpr: 'id'
                    },
                    categoryOpt: {
                        bindingOptions: {
                            value: 'editModel.category',
                            readOnly: 'editModel.isReadOnly',
                        },
                        maxLength: 50
                    },
                    preVoucherNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.preVoucherNumberText',
                            readOnly: 'editModel.voucherNumberTypeReadOnly',
                        },
                        maxLength: 50
                    },
                    postedByOpt: {
                        bindingOptions: {
                            value: 'editModel.postedByText',
                            readOnly: 'editModel.postedByTypeReadOnly',
                        },
                        maxLength: 50
                    },
                    journalKeywordsOpt: {
                        bindingOptions: {
                            value: 'editModel.journalKeywordsText',
                            readOnly: 'editModel.isReadOnly',
                        },
                        disabled: true,
                        maxLength: 250
                    },
                    vehicleNumberOpt: {
                        bindingOptions: {
                            value: 'editModel.vehicleNumberText',
                            readOnly: 'editModel.vehicleNumberReadOnly',
                        },
                        maxLength: 50
                    },
                    taxRateOpt: {
                        bindingOptions: {
                            'value': 'editModel.taxRateValue',
                            'dataSource': 'editModel.TaxRateList',
                            readOnly: 'editModel.isReadOnly',
                        },
                        onSelectionChanged: function(args) {

                        },
                    },

                    fapiaoTaxRateOpt: {
                        bindingOptions: {
                            'value': 'editModel.fapiaoTaxRateValue',
                            'dataSource': 'editModel.TaxRateList',
                            readOnly: 'editModel.isReadOnly',
                        },
                        onSelectionChanged: function(args) {

                        },
                    },
                    fapiaoKeywordsOpt: {
                        bindingOptions: {
                            value: 'editModel.fapiaoKeywordsText',
                            readOnly: 'editModel.isReadOnly',
                        },
                        maxLength: 250
                    },
                    beginYearMonthOptions: {
                        type: 'date',
                        width: 326,
                        bindingOptions: {
                            value: 'editModel.activeStartTime',
                            readOnly: 'editModel.isReadOnly',
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: false,
                        displayFormat: "yyyy-MM",
                        maxZoomLevel: 'year'
                    },
                    endYearMonthOptions: {
                        type: 'date',
                        width: 326,
                        bindingOptions: {
                            value: 'editModel.activeEndTime',
                            readOnly: 'editModel.isReadOnly',
                            min: 'editModel.activeStartTime'
                        },
                        placeholder: $scope.pleaseSelect,
                        showClearButton: true,
                        displayFormat: "yyyy-MM",
                        maxZoomLevel: 'year',
                        dateOutOfRangeMessage: Resources.EndYearMonthValidateMsg,
                        invalidDateMessage: Resources.EndYearMonthValidateMsg
                    }
                };


                $scope.modalControls.validateOption = {
                    ruleNoOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('RuleNoRequire')
                        }]
                    },

                    categoryOpt: {
                        validationRules: [{
                            type: "required",
                            message: $translate.instant('CategoryRequire')
                        }]
                    },

                    beginYearMonthOptions: {
                        validationRules: [{
                            type: "required",
                            message: Resources.BeginYearMonthRequire
                        }]
                    }
                }

                // mainModule.generateKeywordsList('journalKeywords');


                // mainModule.generateKeywordsList('fapiaoKeywords');
            },

            parseDBKeywords: function(list) {
                if (!list) {
                    list = [];
                }

                var valueList = _.pluck(list, 'value');

                var str = valueList.join(thisConstant.semicolonEnglist);

                return str;
            },

            parseViewKeywords: function(str) {
                if (!str) {
                    return [];
                }

                var array = str.split(/;/g);

                array = _.filter(array, function(row) {

                    return row;
                });

                var result = [];
                array.forEach(function(r) {
                    result.push({

                        id: window.PWC.newGuid(),
                        value: r,
                        prefix: ';'
                    });
                });

                if (result && result.length > 0) {
                    result[0].prefix = '';
                }

                return result;
            },

            parseDBField: function(type, value) {
                if (value) {
                    return value;
                } else {
                    if (type === InputType.NotAvailable) {
                        return InputTypeValue.NotAvailable;
                    } else {
                        return InputTypeValue.NullInput;
                    }
                }
            },

            parseViewField: function(value) {
                var obj = {
                    type: InputType.NotAvailable,
                    text: null
                };

                if (value === InputTypeValue.NotAvailable) {
                    obj.type = InputType.NotAvailable;
                } else if (value === InputTypeValue.NullInput) {
                    obj.type = InputType.NullInput;
                } else {
                    obj.type = InputType.OtherType;
                    obj.text = value;
                }

                return obj;
            },

            getPercent: function(value) {

                if (value) {
                    var str = parseInt(value.replace('%', '')) / 100;
                    return str;
                }
            },

            parseDBModel: function(editModel) {

                editModel = angular.copy(editModel);

                editModel.preVoucherNumber = mainModule.parseDBField(editModel.preVoucherNumberType, editModel.preVoucherNumberText);

                editModel.postedBy = mainModule.parseDBField(editModel.postedByType, editModel.postedByText);

                editModel.vehicleNumber = mainModule.parseDBField(editModel.vehicleNumberType, editModel.vehicleNumberText);

                editModel.purchaserTesla = parseInt(editModel.purchaserTesla);
                editModel.sellerTesla = parseInt(editModel.sellerTesla);

                editModel.journalKeywords = mainModule.parseDBKeywords(editModel.journalKeywordsList);
                editModel.fapiaoKeywords = mainModule.parseDBKeywords(editModel.fapiaoKeywordsList);

                editModel.taxRate = mainModule.getPercent(editModel.taxRateValue);
                editModel.fapiaoTaxRate = mainModule.getPercent(editModel.fapiaoTaxRateValue);

                if (!editModel.applyEntities) {
                    editModel.applyEntities = [];
                }

                editModel.dxOptions = null;
                editModel.validateOption = null;


                if (editModel.activeStartTime) {
                    editModel.activeStartTime = editModel.activeStartTime.formatDateTime('yyyy-MM-dd');
                }

                if (editModel.activeEndTime) {
                    editModel.activeEndTime = editModel.activeEndTime.formatDateTime('yyyy-MM-dd');
                } else {
                    editModel.activeEndTime = null;
                }

                if (editModel.applyEntities && editModel.applyEntities.length > 0) {

                    editModel.applyEntities.forEach(function(r) {
                        r.outputReconciliationConfigurationID = $scope.editModel.id;
                    });
                }

                return editModel;
            },
            parseViewModel: function(dbModel) {
                var viewModel = angular.copy(dbModel);
                viewModel.ruleNo = dbModel.ruleNO;

                var obj = mainModule.parseViewField(dbModel.preVoucherNumber);
                viewModel.preVoucherNumberType = obj.type;
                viewModel.preVoucherNumberText = obj.text;

                obj = mainModule.parseViewField(dbModel.postedBy);
                viewModel.postedByType = obj.type;
                viewModel.postedByText = obj.text;

                obj = mainModule.parseViewField(dbModel.vehicleNumber);
                viewModel.vehicleNumberType = obj.type;
                viewModel.vehicleNumberText = obj.text;

                viewModel.fapiaoKeywordsList = mainModule.parseViewKeywords(dbModel.fapiaoKeywords);

                viewModel.journalKeywordsList = mainModule.parseViewKeywords(dbModel.journalKeywords);

                viewModel.taxRateValue = dbModel.taxRate * 100 + '%';

                viewModel.fapiaoTaxRateValue = dbModel.fapiaoTaxRate * 100 + '%';

                viewModel.selectOrgList = _.pluck(dbModel.applyEntities, 'organizationID');

                viewModel.activeStartTime = new Date(viewModel.activeStartTime);

                if (viewModel.activeEndTime) {
                    viewModel.activeEndTime = new Date(viewModel.activeEndTime);
                }

                return viewModel;

            },

            openEditModal: function() {

                var editModel = $scope.configModel;

                $scope.editModel = mainModule.parseViewModel(editModel);

                $scope.editModel.isReadOnly = true;
                $scope.editModel.postedByTypeReadOnly = true;
                $scope.editModel.voucherNumberTypeReadOnly = true;
                $scope.editModel.vehicleNumberReadOnly = true;

                $scope.editModel.type = 'query';

                mainModule.initModalControls();

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'outputReconciliationConfigurationEdit.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'output-reconciliation-configuration-edit',
                    resolve: {
                        editModel: $scope.editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    $scope.isUpdate = true;
                    $scope.operateType = null;

                    if ($scope.onChanged) {
                        $scope.onChanged();
                    }
                }, function() {
                    $scope.operateType = null;
                    $log.info('Modal dismissed at: ' + new Date());
                });

                $scope.edit = function() {

                    $scope.editModel.isReadOnly = false;
                    $scope.editModel.type = "edit";
                };

                $scope.saveAs = function() {

                    //var newModel = mainModule.parseViewModel($scope.configModel);
                    //newModel.id = null;
                    //newModel.category = null;
                    //newModel.ruleNo = null;
                    //newModel.type = "copy";
                    //newModel.isReadOnly = false;
                    //$scope.editModel = newModel;

                    outputReconciliationConfiguration.getNextRuleNo().success(function(data) {
                        if (data && data.result) {
                            $scope.editModel.id = null;
                            $scope.editModel.category = null;
                            $scope.editModel.ruleNo = data.data;
                            $scope.editModel.type = "copy";
                            $scope.editModel.isReadOnly = false;
                        }
                    });
                };


                $scope.update = function() {

                    var model = $scope.editModel;

                    model = mainModule.parseDBModel(model);

                    var dxResult = DevExpress.validationEngine.validateGroup($('#outputReconciliationConfigurationEditForm').dxValidationGroup("instance")).isValid;
                    if (!dxResult) {
                        return;
                    }

                    console.log(JSON.stringify(model));
                    outputReconciliationConfiguration.update(model).success(function(ret) {
                        // console.log(JSON.stringify(ret));
                        //  modalInstance.close({});
                        if (ret) {
                            if (ret.result) {
                                modalInstance.close({});
                            } else {
                                SweetAlert.warning($translate.instant(ret.resultMsg));
                            }
                        }
                    });
                };

                $scope.cancel = function() {
                    modalInstance.dismiss('cancel');
                };

                $scope.save = function() {
                    var model = $scope.editModel;

                    model = mainModule.parseDBModel(model);

                    var dxResult = DevExpress.validationEngine.validateGroup($('#outputReconciliationConfigurationEditForm').dxValidationGroup("instance")).isValid;
                    if (!dxResult) {
                        return;
                    }

                    console.log(JSON.stringify(model));
                    outputReconciliationConfiguration.add(model).success(function(ret) {
                        // console.log(JSON.stringify(ret));
                        // modalInstance.close({});

                        if (ret) {
                            if (ret.result) {
                                modalInstance.close({});
                            } else {
                                SweetAlert.warning($translate.instant(ret.resultMsg));
                            }
                        }
                    });
                };

                entityModule.loadData();

            },
            openModal: function() {

                var editModel = {
                    status: true,
                    preVoucherNumberType: InputType.NotAvailable,
                    postedByType: InputType.NotAvailable,
                    ruleNo: mainModule.nexRuleNo,
                    vehicleNumberType: InputType.NotAvailable,
                    purchaserTesla: '2',
                    sellerTesla: '2',
                    journalKeywordsType: '2',
                    journalKeywordsText: 'test',
                    fapiaoKeywordsType: '2',
                    taxRateValue: '17%',
                    fapiaoTaxRateValue: '17%',
                    tag: constant.TagRule.Aggregation,
                    type: 'add',
                    journalKeywordsList: [],
                    fapiaoKeywordsList: [],
                    voucherNumberTypeReadOnly: true,
                    postedByTypeReadOnly: true
                };

                $scope.editModel = editModel;

                mainModule.initModalControls();

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'outputReconciliationConfigurationEdit.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'output-reconciliation-configuration-edit',
                    resolve: {
                        editModel: $scope.editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    $scope.isUpdate = true;
                    $scope.operateType = null;
                    if ($scope.onChanged) {
                        $scope.onChanged();
                    }
                }, function() {
                    $scope.operateType = null;
                    $log.info('Modal dismissed at: ' + new Date());
                });

                $scope.save = function() {
                    var model = $scope.editModel;

                    model = mainModule.parseDBModel(model);

                    var dxResult = DevExpress.validationEngine.validateGroup($('#outputReconciliationConfigurationEditForm').dxValidationGroup("instance")).isValid;
                    if (!dxResult) {
                        return;
                    }

                    console.log(JSON.stringify(model));
                    outputReconciliationConfiguration.add(model).success(function(ret) {
                        console.log(JSON.stringify(ret));

                        if (ret) {
                            if (ret.result) {
                                modalInstance.close({});
                            } else {
                                SweetAlert.warning($translate.instant(ret.resultMsg));
                            }
                        }

                    });
                };

                $scope.cancel = function() {
                    modalInstance.dismiss('cancel');
                };


                $scope.addJournalKeywords = function() {
                    mainModule.addKeywords('journalKeywords');
                };

                $scope.deleteJournalKeywords = mainModule.deleteJournalKeywords;

                entityModule.loadData();
            },
            watchCollection: function() {
                $scope.$watch('operateType', function(newValue, oldValue) {
                    if (newValue) {

                        if (newValue === constant.Operation.Add) {

                            outputReconciliationConfiguration.getNextRuleNo().success(function(data) {

                                if (data && data.result) {
                                    mainModule.nexRuleNo = data.data;
                                    mainModule.openModal();
                                }
                            });
                        } else if (newValue === constant.Operation.Edit) {

                            mainModule.openEditModal();
                        } else if (newValue === constant.Operation.Query) {
                            mainModule.openEditModal();
                        }
                    }
                });


                // $scope.$watch('editModel.preVoucherNumberType', function(newValue, oldValue) {
                //     if (newValue) {

                //         if ($scope.editModel.preVoucherNumberType === 1 && !$scope.editModel.isReadOnly) {
                //             $scope.editModel.voucherNumberTypeReadOnly = false;
                //         } else {
                //             $scope.editModel.voucherNumberTypeReadOnly = true;
                //         }
                //     }
                // });


                $scope.preVoucherNumberTypeChange = function() {

                    if (!$scope.editModel.isReadOnly) {
                        if ($scope.editModel.preVoucherNumberType == 1) {
                            $scope.editModel.voucherNumberTypeReadOnly = false;
                        } else {
                            $scope.editModel.voucherNumberTypeReadOnly = true;
                            $scope.editModel.preVoucherNumberText = null;
                        }
                    }

                }


                $scope.postedByTypeChange = function() {

                    if (!$scope.editModel.isReadOnly) {
                        if ($scope.editModel.postedByType == 1) {
                            $scope.editModel.postedByTypeReadOnly = false;
                        } else {
                            $scope.editModel.postedByTypeReadOnly = true;
                            $scope.editModel.postedByText = null;
                        }
                    }

                }


                 $scope.vehicleNumberTypeChange = function() {

                    if (!$scope.editModel.isReadOnly) {
                        if ($scope.editModel.vehicleNumberType == 1) {
                            $scope.editModel.vehicleNumberReadOnly = false;
                        } else {
                            $scope.editModel.vehicleNumberReadOnly = true;
                            $scope.editModel.vehicleNumberText = null;
                        }
                    }
                }
            }
        };

        (function initializa() {

            mainModule.main();

            $log.debug('outputReconciliationConfigurationEditController.ctor()...');


        })();
    }
]);
invoiceModule.directive('outputReconciliationConfigurationEdit', ['$log',
    function($log) {
        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/outputReconciliationConfiguration/output-reconciliation-configuration-edit.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                operateType: '=',
                configModel: '=?',
                onClosed: '&',
                onChanged: '&'
            },
            controller: 'outputReconciliationConfigurationEditController',
            link: function(scope, element, attr) {

            }
        }
    }
]);

invoiceModule.controller('outputReconciliationConfigurationController', ['$log', '$scope', '$q', '$timeout',
    '$translate', 'outputReconciliationConfiguration', 'SweetAlert', 'outputCommonService', 'messagebox', '$state',
    function ($log, $scope, $q, $timeout, $translate, outputReconciliationConfiguration, SweetAlert, outputCommonService, messagebox, $state) {
        var tagRevertArray = _.invert(constant.TagRule);
        var purchaserSellerArray = _.invert(constant.purchaserSeller);
        var dateFormat = 'yyyy-MM-dd';


        var initGrid = function () {
            $scope.reconciliationGrid = {
                bindingOptions: {
                    height: 'gridTable',
                },
                dataSource: new DevExpress.data.CustomStore({
                    key: "id",
                    load: function (loadOptions) {
                        return outputReconciliationConfiguration.load()
                            .then(function (res) {


                                res.data.data.forEach(function (r) {
                                    r.rowCss = "dx-row dx-data-row dx-row-lines dx-column-lines ui-state-disabled";
                                    if (r.tag === 2) {

                                        if ($scope.hasReSortPermission) {
                                            r.tdCss = "index";
                                            r.rowCss = "dx-row dx-data-row dx-row-lines dx-column-lines sortRow";
                                        } else {
                                            r.rowCss = "dx-row dx-data-row dx-row-lines dx-column-lines";
                                        }
                                    }
                                });

                                if ($scope.hasReSortPermission) {
                                    $timeout(function () {
                                        setSortable();
                                    }, 1000);
                                }


                                return { data: res.data.data, totalCount: res.data.data.length };
                            }, function (response) {
                                return $q.reject($translate.instant("DataLoadingError"));
                            });
                    }
                }),
                noDataText: $translate.instant('NoDataText'),
                columnAutoWidth: true,
                showRowLines: true,
                showBorders: true,
                columnChooser: {
                    enabled: true
                },
                searchPanel: {
                    placeholder: $translate.instant("SearchHintText"),
                    visible: true,
                },
                loadPanel: {
                    enabled: false
                },
                onToolbarPreparing: function (e) {
                    var toolbarItems = e.toolbarOptions.items;
                    toolbarItems.unshift({
                        location: "before",
                        template: "add"
                    }, {
                        location: "before",
                        template: "delete"
                    }, {
                        location: "before",
                        template: "saveSort"
                    });
                },
                selection: {
                    mode: "single"
                },
                onSelectionChanged: function (e) {
                    $scope.selectedRows = e.selectedRowsData;
                },
                //rowTemplate: 'rowTemplateName',

                columns: [
                    {
                        dataField: 'ruleNO', caption: $translate.instant('RuleNo'),
                        cellTemplate: function (container, options) {

                            var data = options.data;

                            try {
                                if (data.tag === 2) {
                                    //$(container).addClass("index");

                                    if ($scope.hasReSortPermission) {
                                        $("<span class='rule-id' dataid=" + data.id + ">").text(data.ruleNO).appendTo(container);
                                        $(container).parent().addClass('sortRow');
                                    } else {
                                        $("<span>").text(data.ruleNO).appendTo(container);
                                    }

                                } else {
                                    $("<span>").text(data.ruleNO).appendTo(container);
                                    $(container).parent().addClass('ui-state-disabled');
                                }
                            } catch (e) {
                                $log.debug(e);
                            }
                        }
                    },
                    { dataField: 'category', caption: $translate.instant('Category') },
                    {
                        dataField: 'journalKeywords',
                        caption: $translate.instant('JournalKeywords'),
                        calculateDisplayValue: function (rowData) {
                            return rowData.journalKeywords;
                        }
                    },
                    {
                        dataField: 'preVoucherNumber',
                        caption: $translate.instant('PreVoucherNumber'),
                        calculateDisplayValue: function (rowData) {
                            return outputCommonService.transferReconciliationSpecial(rowData.preVoucherNumber).text;
                        }
                    },
                     {
                         dataField: 'vehicleNumber', caption: $translate.instant('VehicleNumber'),
                         calculateDisplayValue: function (rowData) {
                             return outputCommonService.transferReconciliationSpecial(rowData.vehicleNumber).text;
                         }
                     },
                    {
                        dataField: 'postedBy',
                        caption: $translate.instant('PostedBy'),
                        calculateDisplayValue: function (rowData) {
                            return outputCommonService.transferReconciliationSpecial(rowData.postedBy).text;
                        }
                    },
                    {
                        dataField: 'fapiaoKeywords',
                        caption: $translate.instant('FapiaoKeywords'),
                        calculateDisplayValue: function (rowData) {
                            return rowData.fapiaoKeywords;
                        }
                    },
                    {
                        dataField: 'taxRate',
                        caption: $translate.instant('TaxRate'),
                        calculateDisplayValue: function (rowData) {
                            // return rowData.taxRate.formatRate(0);
                            var num = (rowData.taxRate * 100).formatAmount(0);
                            return num + "%";
                        }
                    },
                    {
                        dataField: 'purchaserTesla',
                        caption: $translate.instant('PurchaserTesla'),
                        alignment: 'left',
                        calculateDisplayValue: function (rowData) {
                            return $translate.instant(purchaserSellerArray[rowData.purchaserTesla]);
                        }
                    },
                    {
                        dataField: 'sellerTesla',
                        caption: $translate.instant('SellerTesla'),
                        alignment: 'left',
                        calculateDisplayValue: function (rowData) {
                            return $translate.instant(purchaserSellerArray[rowData.sellerTesla]);
                        }
                    },
                    {
                        dataField: 'activeStartTime',
                        caption: $translate.instant('ActiveStartTime'),
                        dataType: 'date',
                        format: dateFormat,
                        visible: false
                    },
                    {
                        dataField: 'activeEndTime',
                        caption: $translate.instant('ActiveEndTime'),
                        dataType: 'date',
                        format: dateFormat,
                        visible: false
                    },
                    {
                        dataField: 'tag',
                        caption: $translate.instant('Tag'),
                        alignment: 'left',
                        calculateDisplayValue: function (rowData) {
                            return $translate.instant(tagRevertArray[rowData.tag]);
                        }
                    },
                    { dataField: 'status', caption: $translate.instant('RuleStatus') },
                    {
                        caption: $translate.instant('Action'),
                        cellTemplate: 'details'
                    }
                ]
            };
        };


        $scope.eventService = {
            refreshTable: function () {
                $('#reconciliation-grid').dxDataGrid('instance').refresh();
            },
            deleteRule: function () {
                if (!$scope.selectedRows || $scope.selectedRows.length < 1) {
                    SweetAlert.warning($translate.instant('SelectCheck'));
                    return;
                }

                var msg = $translate.instant('Confirm') + ' ' + $translate.instant('Delete') + '?';

                messagebox.confirm(msg, '', constant.teslaConfirmClassName).then(function (isConfirm) {
                    if (isConfirm) {
                        var id = $scope.selectedRows[0].id;
                        outputReconciliationConfiguration.deleteRule(id).success(function (response) {
                            if (response.result) {
                                $("#reconciliation-grid").dxDataGrid('instance').refresh();
                            }
                        }).error(function () {
                            SweetAlert.error($translate.instant('CommonFail'));
                        });
                    }
                });

            },
            addOutputReconciliationConfiguration: function () {
                $scope.editType = constant.Operation.Add;

                $scope.editModel = {};
            },
            showRule: function (rule) {
                $scope.editModel = rule;
                $scope.editType = constant.Operation.Query;
            },
            saveSort: function () {
                var ruleIdList = $('.rule-id');
                var list = [];
                $('.rule-id').each(function () {
                    var obj = this;
                    list.push($(obj).attr('dataid'));
                });

                outputReconciliationConfiguration.saveSort(list).success(function (data) {
                    if (data && data.result) {

                        messagebox.success('SaveSuccess');
                        $scope.eventService.refreshTable();
                    }
                });
            }
        };

        var setSortable = function () {
            var fixHelperModified = function (e, tr) {
                var $originals = tr.children();
                var $helper = tr.clone();
                $helper.children().each(function (index) {
                    $(this).width($originals.eq(index).width())
                });
                return $helper;
            };

            var updateIndex = function (e, ui) {

                var prefix = "RN";
                $('.rule-id', ui.item.parent()).each(function (i) {

                    var obj = this;
                    var no = i + 2;

                    $(obj).text(prefix + no);
                });
            };

            //#reconciliation-grid .dx-datagrid-rowsview tbody
            $('#reconciliation-grid .dx-datagrid-rowsview tbody').sortable({
                helper: fixHelperModified,
                stop: updateIndex,
                //cancel: ".ui-state-disabled"
                items: '.sortRow'
                //items: 'tr:not(.ui-state-disabled)',
            });

            $("#reconciliation-grid .sortRow").disableSelection();
        };

        //检查用户机构权限
        var checkUserOrganizationPermissionList = function () {
            var tempPermission = constant.vatPermission.outputInvoice.reconciliationConfig;
            var list = [];
            list.push(tempPermission.queryCode);
            list.push(tempPermission.deleteCode);
            list.push(tempPermission.addCode);
            list.push(tempPermission.editCode);

            list.push(tempPermission.reSortCode);

            $scope.hasDeletePermission = false;
            $scope.hasAddPermission = false;
            $scope.hasEditPermission = false;
            $scope.hasReSortPermission = false;

            $scope.$root.checkUserPermissionList(list).success(function (data) {
                var permissionMap = data;

                if (!data[tempPermission.queryCode]) {
                    $state.go('noPermissionPage');
                    return;
                }

                if (data[tempPermission.reSortCode]) {
                    $scope.hasReSortPermission = true;
                }

                if (data[tempPermission.deleteCode]) {
                    $scope.hasDeletePermission = true;
                }

                if (data[tempPermission.addCode]) {
                    $scope.hasAddPermission = true;
                }

                if (data[tempPermission.editCode]) {
                    $scope.hasEditPermission = true;
                }

                initGrid();

                //设置表格高度
                $timeout(function () {
                    $scope.setInvoiceGridHeight();
                }, 500);
            });
        };

        (function () {

            // 加权限
            checkUserOrganizationPermissionList();




        })();
    }
]);
invoiceModule.directive('outputReconciliationConfiguration', ['$log',
    function ($log) {
        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/outputReconciliationConfiguration/output-reconciliation-configuration.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'outputReconciliationConfigurationController',
            link: function (scope, element, attr) {


                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var pageHeight = $(document).height();
                    //var smallTitleHeight = $('#litterTitle').outerHeight();
                    var topTitleHeight = $('.menu-header').outerHeight();
                    //var pageSearchHeight = $('.query-panel').outerHeight();
                    //var pageFastSearchHeight = $('.action-row').outerHeight();
                    ////var dataGridLineHeight = $('.grid-container .prompt-line').outerHeight();
                    //var dataGridPagerHeight = $('.page-footer').outerHeight();
                    //if (dataGridPagerHeight === 0) dataGridPagerHeight = 60;
                    //var subHeight = pageHeight - topTitleHeight - pageSearchHeight - pageFastSearchHeight - dataGridPagerHeight;
                    //scope.height = subHeight - 50;
                    var containerHeight = $('.content-container').outerHeight();
                    if (containerHeight === 0) dataGridPagerHeight = 660;
                    scope.gridTable = containerHeight - 30;
                    try {

                        $('#reconciliation-grid').dxDataGrid('instance').repaint();
                    }
                    catch (e) {
                        console.log(e);
                    }
                };

                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }
        }
    }]);
invoiceModule.controller('outputReconciliationEntitiesController', ['$scope', '$log', 'uiGridConstants', 'SweetAlert', '$translate', 'stdAccountService', '$interval', 'orgService', '$timeout', '$q', 'commonWebService', 'loginContext', '$uibModal', 'outputReconciliationConfiguration',
    function($scope, $log, uiGridConstants, SweetAlert, $translate, stdAccountService, $interval, orgService, $timeout, $q, commonWebService, loginContext, $uibModal, outputReconciliationConfiguration) {
        'use strict';


        var entityModule = {
            OrganizationList: [],

            allOrgs: $translate.instant('AllOrganization'),
            name: 'name',
            id: 'id',
            // uiOrgID: 'ApplyingEntitesControls',
            uiOrgID: window.PWC.newGuid(),
            orgText: $translate.instant('AllOrganization'),

            // 选中机构ID列表
            selectOrgList: [],
            selectOrgMap: {},


            // 有效的机构列表,包括所有机构,id,name,parentID,expanded
            orgList: [],
            main: function() {

                $scope.uiOrgID = entityModule.uiOrgID;
                $scope.openEntityModal = function() {

                    if ($scope.editModel.type === 'query' || $scope.editModel.type === 'edit' || $scope.editModel.type === 'copy') {
                        entityModule.openEditModal($scope.editModel.applyEntities);
                    } else {
                        entityModule.openModal();
                    }
                };

                $scope.add = function() {
                    entityModule.openEditModal($scope.selectList);
                };
            },

            loadData: function() {
                orgService.getOrganizationFilterList().success(function(data) {

                    entityModule.OrganizationList = data;
                    entityModule.orgList = entityModule.getOrgDropDownList();

                    mainModule.parseViewList();
                });
            },

            openModal: function() {

                var editModel = {

                };

                $scope.editEntityModel = editModel;

                mainModule.initModalControls();

                var parnet = $('#outputReconciliationConfigurationEditModalBody');

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'ApplyingEntitesDetailsModal.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'entity-size',
                    appendTo: parnet,
                    resolve: {
                        editModel: $scope.editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    // 确定关闭
                }, function() {
                    // 取消关闭
                });

                $scope.saveApplyingEntitesDetailsModal = function() {

                    $scope.editModel.selectOrgList = entityModule.selectOrgList;
                    modalInstance.close({});
                };

                $scope.cancelApplyingEntitesDetailsModal = function() {
                    modalInstance.dismiss('cancel');
                };

                $timeout(function() {
                    entityModule.drawGridList(entityModule.orgList);
                }, 100);
            },

            openEditModal: function(selectOrgList) {

                var orgIdList = _.pluck(selectOrgList, 'organizationID');

                var data = angular.copy(entityModule.orgList);

                var index = 0;

                data.forEach(function(r) {

                    if (orgIdList.indexOf(r.id) > -1) {
                        r.isSelected = true;
                    } else {
                        r.isSelected = false;
                    }

                    r.viewName = r.code + ' ' + r.name;
                    r.index = index;
                    index ++;

                });

                var editModel = {

                };

                $scope.editEntityModel = editModel;

                // mainModule.initModalControls();

                var parnet = $('#outputReconciliationConfigurationEditModalBody');

                var modalInstance = $uibModal.open({
                    animation: true,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'ApplyingEntitesDetailsModal.html',
                    windowClass: 'edit-invoice-modal-wrapper',
                    scope: $scope,
                    size: 'entity-size',
                    appendTo: parnet,
                    resolve: {
                        editModel: $scope.editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    // 确定关闭
                }, function() {
                    // 取消关闭
                });

                $scope.saveApplyingEntitesDetailsModal = function() {

                    // $scope.editModel.selectOrgList = entityModule.selectOrgList;

                    var selectOrgTempList = [];

                    if (!entityModule.selectOrgList || entityModule.selectOrgList.length === 0) {
                        entityModule.selectOrgList = [];

                        selectOrgTempList = [];
                    } else {
                        selectOrgTempList = entityModule.selectOrgList;
                    }

                    var result = [];

                    selectOrgTempList.forEach(function(r) {

                        var item = {};

                        item.organizationID = r.id;
                        item.organizationCode = r.code;

                        result.push(item);
                    });

                    $scope.selectList = result;

                    mainModule.parseViewList();

                    modalInstance.close({});
                };

                $scope.cancelApplyingEntitesDetailsModal = function() {
                    modalInstance.dismiss('cancel');
                };

                $timeout(function() {
                    console.log('open');
                    entityModule.drawGridList(data);
                    console.log('open end');
                }, 100);
            },

            filterDropDownOrgList: function(orgList, selectIDList, idCol) {
                if (!orgList || orgList.length === 0) {
                    return orgList;
                }

                // 什么都没有选
                if (!selectIDList) {
                    return orgList;
                }

                // 按照条件进行过滤
                orgList = _.filter(orgList, function(row) {

                    return selectIDList.indexOf(row[idCol]) > -1;
                });

                return orgList;
            },


            filterOrgs: function() {
                if (entityModule.OrganizationList && entityModule.OrganizationList.length > 0) {

                    // 只要启用的和有权限的机构
                    var filter = _.filter(entityModule.OrganizationList, function(row) {
                        return row.isActive;
                    });


                    return filter;

                } else {
                    return [];
                }
            },

            // 获取机构drop down的list
            getOrgDropDownList: function() {
                var showList = entityModule.filterOrgs();
                showList = angular.copy(showList);
                for (var i = 0; i < showList.length; i++) {
                    var item = showList[i];
                    item.selected = false;
                    item.expanded = true;


                    if (item.parentID === null) {
                        continue;
                    }

                    var parentNode = _.find(showList, function(num) {
                        return num.id === item.parentID
                    });

                    if (parentNode) {
                        continue;
                    }

                    item.parentID = getParentID(item, entityModule.OrganizationList, showList);
                }

                var idList = _.pluck(showList, 'id');

                $scope.selectedOrganizationList = idList;

                return showList;
            },

            drawGridList: function(data) {
                if (!$scope.selectList) {
                    $scope.selectList = [];
                }

                var selectKeyIDs = _.pluck($scope.selectList, 'organizationCode');
                $("#" + entityModule.uiOrgID).dxDataGrid({
                    dataSource: data,
                    keyExpr: 'code',
                    height: 400,
                    selectAllText: $translate.instant('SelectAll'),
                    // rowAlternationEnabled: true,
                    selectedRowKeys: selectKeyIDs,
                    paging: {
                        enabled: false
                    },
                    columns: [
                        { dataField: 'viewName', caption: $translate.instant('SelectAll') }
                    ],
                    showBorders: true,
                    selection: {
                        mode: 'multiple',
                        showCheckBoxesMode: "always"
                    },
                    onSelectionChanged: function(args) {
                        entityModule.selectOrgList = args.selectedRowsData;
                    }
                });

                // $timeout(function(){
                //     $("#" + entityModule.uiOrgID).dxDataGrid('instance').selectRows(selectKeyIDs, false);
                // },10);


                // $("#" + entityModule.uiOrgID).dxDataGrid({
                //     "dataSource": [{
                //             "ID": 1,
                //             "CompanyName": "Super Mart of the West",
                //             "City": "Bentonville",
                //             "State": "Arkansas"
                //         },
                //         {
                //             "ID": 2,
                //             "CompanyName": "Electronics Depot",
                //             "City": "Atlanta",
                //             "State": "Georgia"
                //         },
                //         {
                //             "ID": 3,
                //             "CompanyName": "K&S Music",
                //             "City": "Minneapolis",
                //             "State": "Minnesota"
                //         },
                //         {
                //             "ID": 4,
                //             "CompanyName": "Tom's Club",
                //             "City": "Issaquah",
                //             "State": "Washington"
                //         },
                //         {
                //             "ID": 5,
                //             "CompanyName": "E-Mart",
                //             "City": "Hoffman Estates",
                //             "State": "Illinois"
                //         }
                //     ],
                //     "keyExpr": "ID",
                //     "selectedRowKeys": [
                //         1,
                //         2,
                //         3
                //     ],
                //     "selection": {
                //         "mode": "multiple",
                //         "showCheckBoxesMode": "always"
                //     }
                // });



            
            },
            drawOrgTreeList: function(data) {

                // var getShowData = function(){

                //     var data = angular.copy(entityModule.orgList);
                //     if (data && $scope.selectList && $scope.selectList.length > 0){

                //         $scope.selectList.forEach(function(s){

                //             var find = _.find(data, function(d){
                //                 return d.id === s.organizationID;
                //             });

                //             find.selected = true;
                //         });
                //     }

                //     return data;
                // };


                // var showData = getShowData();




                $("#" + entityModule.uiOrgID).dxTreeView({
                    dataSource: data,
                    dataStructure: "plain",
                    keyExpr: "id",
                    parentIdExpr: "parentIDStr",
                    selectionMode: "multiple",
                    displayExpr: "name",
                    selectByClick: true,
                    noDataText: '',
                    // height: 300,
                    itemTemplate: function(itemData, itemIndex, itemElement) {

                        var str = itemData.code + ' ' + itemData.name;
                        itemElement.append("<span title='" + str + "'>" + str + "</span>");
                    },
                    onContentReady: function(args) {},
                    selectNodesRecursive: false,
                    expandAllEnabled: true,
                    showCheckBoxesMode: "selectAll",
                    selectAllText: entityModule.allOrgs,
                    onItemSelectionChanged: function(args) {

                    },
                    onSelectionChanged: function(args) {
                        entityModule.selectOrgList = args.component.getSelectedNodesKeys();
                    }
                });

            },

            // 机构drop down list
            drawOrgDropDownList: function(data) {

                entityModule.selectOrgList = _.pluck(data, 'id');

                $scope.onChanged({ model: entityModule.selectOrgList });

                var syncTreeViewSelection = function(treeView, value, isReady) {

                    if (isReady) {
                        $scope.selectedOrganizationList = entityModule.selectOrgList;
                        $scope.onChanged({ model: entityModule.selectOrgList });
                    } else {
                        $scope.selectedOrganizationList = value;
                        $scope.onChanged({ model: value });
                    }
                };


                entityModule.orgDropDownInstantce = $("#" + entityModule.uiOrgID).dxDropDownBox({
                    value: '',
                    showClearButton: false,
                    contentTemplate: function(e) {
                        var value = e.component.option("value"),
                            $treeView = $("<div>").dxTreeView({
                                dataSource: data,
                                dataStructure: "plain",
                                keyExpr: "id",
                                parentIdExpr: "parentIDStr",
                                selectionMode: "multiple",
                                displayExpr: "name",
                                selectByClick: true,
                                noDataText: '',
                                height: 300,
                                itemTemplate: function(itemData, itemIndex, itemElement) {

                                    var str = itemData.code + ' ' + itemData.name;
                                    itemElement.append("<span title='" + str + "'>" + str + "</span>");
                                },
                                onContentReady: function(args) {},
                                selectNodesRecursive: false,
                                expandAllEnabled: true,
                                showCheckBoxesMode: "selectAll",
                                selectAllText: entityModule.allOrgs,
                                onItemSelectionChanged: function(args) {

                                },
                                onSelectionChanged: function(args) {
                                    var value = args.component.getSelectedNodesKeys();
                                    var text = '';
                                    if (value && value.length === data.length) {
                                        text = entityModule.allOrgs;
                                    } else {
                                        text = '选中' + value.length + '个机构';
                                    }

                                    entityModule.selectOrgList = value;
                                    e.component.option("value", text);
                                    entityModule.orgText = text;
                                    syncTreeViewSelection(entityModule.orgTreeView, value, false);
                                }
                            });

                        entityModule.orgTreeView = $treeView.dxTreeView("instance");
                        entityModule.orgText = e.component.option("text");


                        return $treeView;
                    }
                });
            }

        };



        var mainModule = {

            main: function() {

                if (!$scope.selectList) {
                    $scope.selectList = [];
                }

                entityModule.loadData();
                entityModule.main();

                // $scope.add = mainModule.add;

                $scope.delete = mainModule.delete;
            },

            parseViewList: function() {
                $scope.selectList.forEach(function(r) {
                    var org = _.find(entityModule.orgList, function(o) {

                        return o.id === r.organizationID;
                    });

                    if (org) {
                        r.value = org.code + ' ' + org.name;
                    }

                    r.suffix = ';';
                });


                if ($scope.selectList && $scope.selectList.length > 0) {

                    var length = $scope.selectList.length - 1;
                    $scope.selectList[length].suffix = '';
                }
            },
            add: function() {
                var length = $scope.selectList.length;

                var prefixStr = '';
                if (length !== 0) {
                    prefixStr = ';';
                }

                var obj = {
                    id: window.PWC.newGuid(),
                    value: '',
                    suffix: prefixStr,
                };

                $scope.selectList.push(obj);
            },

            delete: function(obj) {
                if ($scope.selectList && $scope.selectList.length > 0) {

                    var findIndex = _.indexOf($scope.selectList, obj);

                    if (findIndex > -1) {
                        $scope.selectList.splice(findIndex, 1);
                    }

                    if (findIndex === 0 && $scope.selectList.length >= 0) {
                        $scope.selectList[0].prefix = '';
                    }
                }
            },

        };

        (function initializa() {

            mainModule.main();

            $log.debug('outputReconciliationKeywordsController.ctor()...');


        })();
    }
]);
invoiceModule.directive('outputReconciliationEntities', ['$log',
    function ($log) {
        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/outputReconciliationConfiguration/output-reconciliation-entities.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                selectList: "=",
                isReadonly: '=',
            },
            controller: 'outputReconciliationEntitiesController',
            link: function (scope, element, attr) {

            }
        }
    }
]);

invoiceModule.controller('outputReconciliationKeywordsController', ['$scope', '$log', 'uiGridConstants', 'SweetAlert', '$translate', 'stdAccountService', '$interval', 'orgService', '$timeout', '$q', 'commonWebService', 'loginContext', '$uibModal', 'outputReconciliationConfiguration',
    function ($scope, $log, uiGridConstants, SweetAlert, $translate, stdAccountService, $interval, orgService, $timeout, $q, commonWebService, loginContext, $uibModal, outputReconciliationConfiguration) {
        'use strict';

     
        var mainModule = {

            main: function () {

                if (!$scope.keywordsList) {
                    $scope.keywordsList = [];
                }
                $scope.addKeywords = mainModule.addKeywords;

                $scope.deleteKeywords = mainModule.deleteKeywords;
            },
            addKeywords: function () {
                var length = $scope.keywordsList.length;

                if (length >= 5) {
                    SweetAlert.warning($translate.instant('LimitKeyWords'));
                    return;
                };

                var prefixStr = '';
                if (length !== 0) {
                    prefixStr = ';';
                }

                var obj = {
                    id: window.PWC.newGuid(),
                    value: '',
                    prefix: prefixStr,
                };

                $scope.keywordsList.push(obj);
            },

            deleteKeywords: function (obj) {
                if ($scope.keywordsList && $scope.keywordsList.length > 0) {

                    var findIndex = _.indexOf($scope.keywordsList, obj);

                    if (findIndex > -1) {
                        $scope.keywordsList.splice(findIndex, 1);
                    }

                    if (findIndex === 0 && $scope.keywordsList.length >= 0) {
                        $scope.keywordsList[0].prefix = '';
                    }
                }
            },

        };

        (function initializa() {

            mainModule.main();

            $log.debug('outputReconciliationKeywordsController.ctor()...');


        })();
    }
]);
invoiceModule.directive('outputReconciliationKeywords', ['$log',
    function ($log) {
        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/outputReconciliationConfiguration/output-reconciliation-keywords.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                keywordsList: "=",
                isReadonly: '='
            },
            controller: 'outputReconciliationKeywordsController',
            link: function (scope, element, attr) {

            }
        }
    }
]);

vatModule.controller('specialVatInvoiceController', ['$log', '$timeout', '$scope', '$translate', 'vatOutputInvoiceManageService',
    'SweetAlert', 'orgService', 'enums', 'modalAdapterService',
    function ($log, $timeout, $scope, $translate, vatOutputInvoiceManageService, SweetAlert,
        orgService, enums, modalAdapterService) {
        //分页的设置
        var dateFormat = 'yyyy-MM-dd';
        $scope.pleaseSelect = $translate.instant("ChoosePlaceholder");
        $scope.pleaseInput = $translate.instant('InputPlaceholder');
        $scope.pagingOptions = {
            pageIndex: 1,  //当前页码
            totalItems: 0,  //总数据
            pageSize: constant.page.pageSizeArrary[1],  //每页多少条数据 
        };
        $scope.specialSearchEntity = {
            invoiceNumberVaule: null,
            VRLValue: null,
            issuedPeriodFromValue: null,
            issuedPeriodToValue: null,
            entityCodeValue: null,
            statusValue: [],
            revertStatusList:[]
        };
        $scope.specialInvoiceVariables = {
            selectedTableRows: [],
            selectedTotalAmount: 0.00,
            pageName: $translate.instant('IssuedInvoiceSpecial'),
            selectedInvoice:null
           
        };
        $scope.specialInvoice = {
            invoiceNumberOptions: {
                bindingOptions: {
                    'value': 'specialSearchEntity.invoiceNumberVaule'
                },
                showClearButton: true,
                placeholder: $scope.pleaseInput
            },
            VRLOptions: {
                bindingOptions: {
                    'dataSource': 'allDBVRL',
                    'value': 'specialSearchEntity.VRLValue'
                },
                showClearButton: true,
                placeholder: $scope.pleaseSelect
            },
            issuedPeriodFromOptions: {
                type: "date",
                dateSerializationFormat:dateFormat,
                displayFormat: dateFormat,
                bindingOptions: {
                    'value': 'specialSearchEntity.issuedPeriodFromValue'
                },
                width: '100%',
                showClearButton: true,
                placeholder: $scope.pleaseSelect
            },
            issuedPeriodToOptions: {
                type: "date",
                dateSerializationFormat: dateFormat,
                displayFormat: dateFormat,
                bindingOptions: {
                    'value': 'specialSearchEntity.issuedPeriodToValue'
                },
                width: '100%',
                showClearButton: true,
                placeholder: $scope.pleaseSelect
            },
            entityOptions:{
                bindingOptions: {
                    'value': 'specialSearchEntity.entityCodeValue',
                    'dataSource':'entitySource'
                },
                showClearButton: true,
                displayExpr: 'name',
                valueExpr: 'id',
                placeholder: $scope.pleaseSelect
            },
            statusOptions:{
                bindingOptions: {
                    'value': 'specialSearchEntity.statusValue',
                    'dataSource': 'specialStatus'
                },
                showClearButton: true,
                showDropButton: true,
                multiline: false,
                showSelectionControls: true,
                applyValueMode: "useButtons",
                displayExpr: 'name',
                valueExpr: 'id',
                //fieldTemplate: function (selectedItems, fieldElement) {                   
                //    selectedItems = Array.isArray(selectedItems) ? selectedItems : [selectedItems];
                   
                //    var selCount = selectedItems.length,
                //         $textBox = $('<div>', { class: "input-field" }).dxTextBox({});
                   
                //    var $field = $("<div>", { class: "tag-container" }).text(
                //        selCount > 1 ? selCount + " selected" : selCount===1?selectedItems[0].name:null
                //    );

                //    return fieldElement.append($field).append($textBox);
                //},              
                placeholder: $scope.pleaseSelect
            },
            specialGridContainer: {
                //height:'260px',
                bindingOptions: {
                    dataSource: 'specialInvoiceList',
                    'height': 'height'
                },
                loadPanel: {
                    enabled: false,
                },
                noDataText:$translate.instant('NoDataText'),
                columnAutoWidth:true,
                showRowLines: true,
                showBorders: true,
                columnChooser: {
                    enabled: true
                },
                paging: {
                    enabled: false
                },
                selection:{
                    mode: 'multiple',
                    showCheckBoxesMode: 'always'
                },
                onSelectionChanged: function (e) {
                    $scope.specialInvoiceVariables.selectedTotalAmount = 0.00;
                    $scope.specialInvoiceVariables.selectedTableRows = e.selectedRowsData;
                    _.each(e.selectedRowsData, function (item) {
                        $scope.specialInvoiceVariables.selectedTotalAmount += item.totalAmount;
                    });
                },
                headerFilter:{
                    visible: false,
                    texts: {
                        cancel: $translate.instant('ENCancel'),
                        emptyValue: $translate.instant('Blank'),
                        ok:$translate.instant('Confirm')
                    }
                },
                columns: [
                    { dataField: 'vrl', caption: $translate.instant('VRL'),allowHeaderFiltering:false,visible:false },
                    { dataField: 'buyerOrganizationCode', caption: $translate.instant('Entity'), allowHeaderFiltering: false },
                    { dataField: 'gdInvoiceNumber', caption: $translate.instant('InvoiceNo'), allowHeaderFiltering: false },
                    { dataField: 'gdInvoiceCode', caption: $translate.instant('InvoiceCode'), allowHeaderFiltering: false },
                    { dataField: 'buyerOrganizationName', caption: $translate.instant('BuyerName'), allowHeaderFiltering: false },
                    { dataField: 'buyerOrganizationTaxID', caption: $translate.instant('BuyerTaxID'), allowHeaderFiltering: false },
                    {
                        dataField: 'totalAmount', caption: $translate.instant('Amount'),
                        format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                    },
                     {
                         dataField: 'totalTaxAmount', caption: $translate.instant('TaxAmount'),
                         format: { type: 'fixedPoint', precision: 2 }, allowHeaderFiltering: false
                     },
                    {
                        dataField: 'gdIssuedDate', caption: $translate.instant('IssuedDate'),
                        dataType: 'date', format: dateFormat, allowHeaderFiltering: false
                    },
                    {
                        dataField: 'status', caption: $translate.instant('Status'),
                        calculateDisplayValue: function (rowData) {
                            return $translate.instant($scope.specialSearchEntity.revertStatusList[rowData.status]);
                        }
                        //headerFilter: {
                        //    dataSource: {
                        //        load: function () {
                        //           return _.map(enums.GDInvoiceStatusEnum, function (item, key) {                                       
                        //               return {
                        //                   text: $translate.instant(key),
                        //                   value: ["status", "=", item]
                        //               };
                        //            });
                        //        }
                        //    }
                        //}
                    },
                    {
                        caption: $translate.instant('Details'),
                        cellTemplate: 'detailTemplate', allowHeaderFiltering: false
                    }

                ]
            }
        };


        $scope.eventService = {
            checkBeforCancel: function () {
                var list = $scope.specialInvoiceVariables.selectedTableRows;
                //过月的不能cancel
                var currentMonth = new Date().getMonth();//1-12
                var notValidMonthCount = 0;
                var notValidStatus = true;
                var isRed = false;
                _.each(list, function (item) {
                    var m = new Date(item.gdIssuedDate).getMonth();
                    notValidMonthCount = m === currentMonth ? notValidMonthCount : ++notValidMonthCount;
                    if (item.status !== enums.GDInvoiceStatusEnum.issued) {
                        notValidStatus = false;
                    } 
                    if (item.isRedInvoice) {
                        //红票不能cancel
                        isRed = true;
                    }
                    
                });
                var result = {
                    pass: notValidMonthCount === 0 && notValidStatus && !isRed,
                    notMatchMonth: notValidMonthCount,
                    notValidStatus: notValidStatus,
                    isRedInvoice: isRed
                }
                return result;
            },
            cancelInvoiceCore: function () {
                var dto = {
                    items: $scope.specialInvoiceVariables.selectedTableRows,
                    reprint: $scope.isReprint,
                    userName: null,
                    userID: null
                }
                //need call baiwang jie kou
                vatOutputInvoiceManageService.cancelGDInvoice(dto).success(function (response) {
                    if (response.result) {
                        //_.each($scope.specialInvoiceVariables.selectedTableRows, function (item) {
                        //    item.status = enums.GDInvoiceStatusEnum.cancelled;
                        //});
                        modalAdapterService.close(constant.OutputInvoiceCancalDialog, 'special-vat-page');
                        $scope.eventService.refreshInvoiceDataGrid();
                    }
                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
            },
            cancelFapiao: function (reprint) {
                if (!$scope.specialInvoiceVariables.selectedTableRows || $scope.specialInvoiceVariables.selectedTableRows.length < 1) {
                    SweetAlert.warning($translate.instant('SelectBdInvoiceCheck'));
                    return;
                }
                var result=$scope.eventService.checkBeforCancel();
                if (result.pass) {
                    $scope.title = reprint ? $translate.instant("CancelReprintInvoiceGDTitle") : $translate.instant("CancelInvoiceGDTitle")
                   $scope.isReprint = reprint ? reprint : false;
                   modalAdapterService.open(constant.OutputInvoiceCancalDialog, 'special-vat-page');
                }else
                {
                    var message =result.notMatchMonth===0?"": $translate.instant('HasNotMatchMonth') + result.notMatchMonth + $translate.instant('Separator');
                    message = result.notValidStatus ? message : message + $translate.instant('HasNotMatchStatus');
                    message = result.isRedInvoice ? message + $translate.instant('RedInvoiceWarrning') : message;
                    SweetAlert.warning('', message);
                }
               
            },
            cancelandPrintFapiao:function(){
                $scope.eventService.cancelFapiao(true);
            },
            getQueryBasicData: function () {
                $scope.specialStatus = _.map(enums.GDInvoiceStatusEnum, function (item, key) {
                    return { id: item, name: $translate.instant(key) };
                });
                orgService.getBdList().success(function (res) {
                    $scope.entitySource=  _.map(res,function(item){
                        return { id: item.code, name: item.code + item.name };
                    });
                    $scope.allDBVRL = _.filter(_.uniq(_.pluck(res, 'vehicleroutinglocation')),
                        function (item) { return item !== null });
                });
                
            },
            refreshInvoiceDataGrid: function () {
                var dataDto = {
                    parameters:$scope.specialSearchEntity,
                        pagingInfo: $scope.pagingOptions
                }
                vatOutputInvoiceManageService.getSpecailGBInvoiceList(dataDto).success(function (response) {
                    $scope.specialInvoiceList = response.list;
                    $scope.pagingOptions.totalItems = response.pageInfo.totalCount;
                }).error(function () {
                    SweetAlert.error('', $translate.instant('CommonFail'));
                });
     
            },
            showDetail: function (rowData) {
                $scope.specialInvoiceVariables.selectedInvoice = rowData;
                $scope.$broadcast("openGDDetailDialog");
            },
            //隐藏或者展示搜索框
            showOrHideSearchBox: function () {
                $scope.hasShowMoreSearchBox = !$scope.hasShowMoreSearchBox;
                // $scope.eventService.refreshInvoiceDataGrid();
                $timeout(function () {
                    $scope.setInvoiceGridHeight();
                }, 500);

            }
        };

      
        (function () {
            $scope.specialSearchEntity.revertStatusList = _.invert(enums.GDInvoiceStatusEnum);
            $scope.eventService.getQueryBasicData();
            $scope.eventService.refreshInvoiceDataGrid();
            $scope.hasShowMoreSearchBox = false;
            //设置表格高度
            $timeout(function () {
                $scope.setInvoiceGridHeight();
            }, 500);
        })();
    }
])
vatModule.directive('specialVatInvoice', ['$log', function ($log) {
    'use strict';
    $log.debug('issuedInvoiceBdView.ctor()...');
    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/special-vat-invoice/special-vat-invoice.html' + '?_=' + Math.random(),
        scope:
        {

        },
        controller: 'specialVatInvoiceController',
        link: function (scope, element) {
            //计算datagrid的高度
            scope.setInvoiceGridHeight = function () {
                var pageHeight = $(document).height();
                //var smallTitleHeight = $('#litterTitle').outerHeight();
                var topTitleHeight = $('.header-title').outerHeight();
                var pageSearchHeight = $('.query-panel').outerHeight();
                var pageFastSearchHeight = $('.action-row').outerHeight();
                //var dataGridLineHeight = $('.grid-container .prompt-line').outerHeight();
                var dataGridPagerHeight = $('.page-footer').outerHeight();
                if (dataGridPagerHeight === 0) dataGridPagerHeight = 60;
                var subHeight = pageHeight  - topTitleHeight - pageSearchHeight - pageFastSearchHeight  - dataGridPagerHeight;
                scope.height = subHeight - 50;

                try {
                    $('#specialGrid').dxDataGrid('instance').repaint();
                }
                catch (e) {
                    console.log(e);
                }
            };

            $(window).on('resize', function () {
                scope.setInvoiceGridHeight();
            });
        }
    };
}]);
vatModule.controller('taxControlDiskController', ['$log', '$scope', '$q', '$timeout',
    '$translate', 'SweetAlert', 'outputCommonService', 'messagebox', '$state', 'vatOutputInvoiceManageService', '$uibModal',
    function($log, $scope, $q, $timeout, $translate, SweetAlert, outputCommonService, messagebox, $state, vatOutputInvoiceManageService, $uibModal) {

        var thisConstant = {
            DiskType: {
                1: $translate.instant('BaiWang'),
                2: $translate.instant('HangXing'),
            }
        };

        var replaceService = {
            nameReplace:function(value){

                if (value){
                    value=value.replace(/[^\(\)（）\w\u4e00-\u9fa5]/g,'')
                }

                return value;
            },
            codeReplace:function(value){
             
                if (value){
                    value=value.replace(/[^\w]/g,'')
                }

                return value;
            }
        };

        var editAlertService = {
            open: function() {
                var editModel = {};

                if ($scope.selectedRows && $scope.selectedRows.length === 1) {
                    $scope.editModel = angular.copy($scope.selectedRows[0]);
                } else {
                    return;
                }

                var modalInstance = $uibModal.open({
                    animation: false,
                    backdrop: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'EditTaxControlDiskConfirmModal.html',
                    windowClass: 'EditTaxControlDiskConfirmModal',
                    size: 'edit-taxcontrol',
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                $scope.dxOptions={
                    mainTaxAuthoritiesName: {
                        valueChangeEvent: "keyup",
                        maxLength: 50,
                        onValueChanged: function (e) {
                            $scope.editModel.mainTaxAuthoritiesName=replaceService.nameReplace(e.value);
                        }
                    },
                    mainTaxAuthoritiesCode: {
                        valueChangeEvent: "keyup",
                        maxLength: 50,
                        onValueChanged: function (e) {
                            $scope.editModel.mainTaxAuthoritiesCode=replaceService.codeReplace(e.value);
                        }
                    },

                }

                modalInstance.result.then(function(data) {

                }, function() {

                });


                $scope.saveDisk = function() {

                    var model = $scope.editModel;
                    vatOutputInvoiceManageService.updateTaxControlDisk(model).success(function(data) {

                        if (data && data.result) {
                            messagebox.info($translate.instant("SaveSuccess"));
                            modalInstance.close($scope.editModel);

                            $scope.eventService.refreshTable();
                        } else {
                            messagebox.warning(data.resultMsg, true);
                        }
                    });

                };

                // 取消
                $scope.cancel = function() {

                    modalInstance.dismiss('cancel');
                };
            }
        };

        var mainModule = {
            main: function() {
                mainModule.initControl();

                mainModule.bindEvent();

                mainModule.loadData();

                $scope.showEditBtn = false;

                //设置表格高度
                $timeout(function() {
                    $scope.setInvoiceGridHeight();
                }, 500);
            },
            initControl: function() {

                $scope.taxControlDiskData = [];
                $scope.taxControlDiskGrid = {
                    bindingOptions: {
                        height: 'gridTable',
                        dataSource: 'taxControlDiskData'
                    },
                    // dataSource: new DevExpress.data.CustomStore({
                    //     key: "id",
                    //     load: function(loadOptions) {

                    //         var model = {};
                    //         return vatOutputInvoiceManageService.getTaxControlDiskList(model, false)
                    //             .then(function(res) {

                    //                 var list = res.data.list;

                    //                 if (list && list.length > 0) {

                    //                     list.forEach(function(r) {
                    //                         r.taxControlStatusBool = r.taxControlStatus === 1;
                    //                     });
                    //                 }

                    //                 $scope.taxControlDiskData = list;

                    //                 return { data: list, totalCount: res.data.list.length };
                    //             }, function(response) {
                    //                 return $q.reject($translate.instant("DataLoadingError"));
                    //             });
                    //     }
                    // }),
                    onToolbarPreparing: function(e) {
                        var toolbarItems = e.toolbarOptions.items;
                        toolbarItems.unshift({
                            location: "before",
                            template: "checkStatusTempl"
                        });
                    },
                    noDataText: $translate.instant('NoDataText'),
                    columnAutoWidth: true,
                    showRowLines: true,
                    showBorders: true,
                    columnFixing: {
                        enabled: true
                    },
                    columnChooser: {
                        enabled: true
                    },
                    searchPanel: {
                        placeholder: $translate.instant("SearchHintText"),
                        visible: true,
                    },
                    loadPanel: {
                        enabled: false
                    },
                    selection: {
                        mode: "single"
                    },
                    onSelectionChanged: function(e) {
                        $scope.selectedRows = e.selectedRowsData;

                        if ($scope.selectedRows && $scope.selectedRows.length > 0) {
                            $scope.showEditBtn = true;
                        }
                    },
                    columns: [
                        { dataField: 'kpjh', caption: $translate.instant('KPJH'), visible: false },
                        { dataField: 'qymc', caption: $translate.instant('qymc'), visible: false },
                        { dataField: 'qysh', caption: $translate.instant('qysh'), visible: false },
                        { dataField: 'jmbbh', caption: $translate.instant('jmbbh'), visible: false },
                        { dataField: 'dzfpFlag', caption: $translate.instant('dzfpFlag'), visible: false },
                        { dataField: 'sfjyzs', caption: $translate.instant('sfjyzs'), visible: false },
                        { dataField: 'swjgdm', caption: $translate.instant('swjgdm'), visible: false },
                        { dataField: 'jssz', caption: $translate.instant('jssz'), visible: false },
                        { dataField: 'jspbh', caption: $translate.instant('jspbh'), visible: false },
                        { dataField: 'equipmentSupplier', caption: $translate.instant('equipmentSupplier'), visible: false },
                        { dataField: 'organizationName', caption: $translate.instant('Entity') },
                        { dataField: 'organizationCode', caption: $translate.instant('EntityCode') },
                        { dataField: 'taxControlDiskSerialNumber', caption: $translate.instant('TaxControlDiskSerialNumber') },
                        { cellTemplate: 'statusTempl', caption: $translate.instant('TaxControlStatus'), alignment: 'center', width: '120' },
                        { dataField: 'diskTyeText', caption: $translate.instant('Type') },
                        { dataField: 'mainTaxAuthoritiesName', caption: $translate.instant('MainTaxAuthoritiesName') },
                        { dataField: 'mainTaxAuthoritiesCode', caption: $translate.instant('MainTaxAuthoritiesCode') },
                        { dataField: 'topMargin', caption: $translate.instant('Top') },
                        { dataField: 'leftMargin', caption: $translate.instant('Left') },
                        { dataField: 'taxControlDiskNo', caption: $translate.instant('TaxControlDiskNo') },
                        { dataField: 'taxControlDiskDescribe', caption: $translate.instant('TaxControlDiskDescribe') },
                        { dataField: 'taxControlDiskUser', caption: $translate.instant('TaxControlDiskUser') },
                        { dataField: 'department', caption: $translate.instant('Department') },
                        { dataField: 'mobile', caption: $translate.instant('Mobile') },
                        { dataField: 'email', caption: $translate.instant('Email') },
                        { dataField: 'taxControlUrl', caption: $translate.instant('TaxControlUrl') },

                    ]
                };

            },

            loadData: function() {
                // body...
                var model = {};

                var parseViewData = function(r) {
                    if (r) {
                        r.taxControlStatusBool = r.taxControlStatus === 1;
                        r.diskTyeText = thisConstant.DiskType[r.diskType];
                    }

                    return r;
                };

                vatOutputInvoiceManageService.getTaxControlDiskList(model, false)
                    .then(function(res) {

                        var list = res.data.list;

                        if (list && list.length > 0) {

                            list.forEach(function(r) {
                                r = parseViewData(r);
                            });
                        }

                        $scope.taxControlDiskData = list;

                    }, function(response) {
                        // return $q.reject($translate.instant("DataLoadingError"));
                    });
            },
            bindEvent: function() {
                $scope.eventService = {
                    checkStatus: function() {

                        // 正在查询
                        if ($scope.Checking) {
                            return;
                        }

                        var dataList = $scope.taxControlDiskData;

                        var dataLength = dataList.length;

                        $scope.Checking = true;
                        var testStatusFunction = function(i) {

                            if (i < dataLength) {
                                var row = dataList[i];
                                row.isTest = true;
                                // row.failMsg="Testing";
                                $scope.taxControlDiskData = dataList;
                                vatOutputInvoiceManageService.testIsActive(row, false).then(function(res) {
                                    row.isTest = false;
                                    var data = res.data;
                                    if (data && data.result) {
                                        $scope.eventService.refreshTable();
                                    }

                                    if (i === dataLength - 1) {
                                        // 最后一个
                                        $scope.Checking = false;
                                    } else {
                                        i++;
                                        testStatusFunction(i);
                                    }


                                });

                            }
                        }

                        testStatusFunction(0);
                    },
                    refreshTable: function() {
                        // $('#taxControlDiskGridID').dxDataGrid('instance').refresh();

                        mainModule.loadData();
                    },
                    updateAlert: function() {
                        editAlertService.open();
                    },



                };
            }
        };




        (function() {

            mainModule.main();

        })();
    }
]);
vatModule.directive('taxControlDisk', ['$log',
    function ($log) {
        return {
            restrict: 'E',
            templateUrl: '/app/vat/output-invoice/taxControlDisk/tax-control-disk.html' + '?_=' + Math.random(),
            replace: true,
            scope: {

            },
            controller: 'taxControlDiskController',
            link: function (scope, element, attr) {
                //计算datagrid的高度
                scope.setInvoiceGridHeight = function () {
                    var containerHeight = $('.content-container').outerHeight();
                    scope.gridTable = containerHeight - 30;
                };

                $(window).on('resize', function () {
                    scope.setInvoiceGridHeight();
                });
            }
        }
    }
]);

vatModule.controller('uploadFileModalController', ['$scope', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload', '$uibModal',
    'vatOutputInvoiceManageService',
    function ($scope, $log, $translate, $timeout, apiInterceptor, Upload, $uibModal, vatOutputInvoiceManageService) {

        var uploadFileController = function () {
            $scope.uploadOption = {};
            $scope.uploadOption.uploadFiles = null;

            $scope.confirmUpload = function () {
                $scope.uploadFileOption.files = $scope.files;
                $scope.modalInstance.dismiss('confirm');
                $scope.uploadFileType = null;

            };

            $scope.concelUpload = function () {
                $scope.modalInstance.dismiss('cancel');

                $scope.uploadFileType = null;
            };

            $scope.$watch('uploadOption.uploadFiles', function (newValue, oldValue) {
                if (newValue && newValue !== oldValue) {
                    doUploadFile();
                }
            });
        };

        $scope.chunkSize = 10 * 1024 * 1024;
        $scope.success = false;

        var resumable = true;
        var allFilesCount = 0;
        var successCount = 0;

        var updateProgressToZero = function () {
            $scope.percentNumber = '0%';
            $scope.showLoading = false;
        };

        $scope.files = [];
        var uploadSuccess = function (resp) {
            successCount++;
            $scope.files.push(resp);
            if (successCount === allFilesCount) {
                $scope.showLoading = false;
            }
        };

        var changeloadingTitle = function (title) {
            $scope.loadingTitle = $translate.instant(title);
        };

        var doUploadFile = function () {
            changeloadingTitle('fileUploading');
            uploadfile($scope.uploadOption.uploadFiles);
            $scope.uploadOption.uploadFiles = null;
        };

        //更新滚动条
        var updateProgress = function (evt) {
            $scope.showLoading = true;


            // console.log(evt.loaded + '/' + evt.total);
            var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);

            // 不知道为什么evt.loaded有可能比evt.total还要大---julius 2017/11/7
            if (progressPercentage > 100){
                progressPercentage = 100;
            }

            $scope.percentNumber = progressPercentage + '%';
        };

        //执行上传文件操作。
        var uploadfile = function (files) {
            if (files && files.length) {
                allFilesCount = files.length;
                successCount = 0;
                var uploadSuccessCallBack = function () {
                    updateProgressToZero();
                }
                for (var i = 0; i < files.length; i++) {
                    var file = files[i];

                    if (!file.$error) {
                        var tempFileName = PWC.newGuid() + '.dat';
                        var token = $('input[name="__RequestVerificationToken"]').val();
                        updateProgressToZero();
                        Upload.upload({
                            url: apiInterceptor.webApiHostUrl + '/outputInvoicePrinted/uploadEvidenceFile',
                            data: {
                                cancel: false,
                                filename: file.name,
                                tempFileName: tempFileName,
                                file: file,
                                period: $scope.period
                            },
                            resumeChunkSize: resumable ? $scope.chunkSize : null,
                            headers: {
                                'Access-Control-Allow-Origin': '*',
                                Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken
                            },
                            __RequestVerificationToken: token,
                            withCredentials: true
                        }).then(uploadSuccess, uploadSuccessCallBack, updateProgress);
                    }
                }
            }
        };

        //删除证据文件
        $scope.deleteEvidenceFile = function (fileId) {
            var fileList = [fileId];
            vatOutputInvoiceManageService.deleteEvidenceFile(fileList).then(function () {
                $scope.files = _.filter($scope.files, function (item) {
                    return item.data.fileID != fileId;
                });
            });
        }

        //下载证据文件
        $scope.downloadEvidenceFile = function (data) {
            var queryDto = {};
            queryDto.fileName = data.fileName;
            queryDto.filePath = data.filePath;
            vatOutputInvoiceManageService.downloadEvidenceFile(queryDto);
        }

        $scope.$watch('uploadFileType', function (newValue,oldValue) {
            if (newValue) {
                if (newValue === 'multiple') {
                    $scope.isMultiple = true;
                } else {
                    $scope.isMultiple = false;
                }
                $scope.files = [];
                if ($scope.uploadFileOption.files) {
                    _.each($scope.uploadFileOption.files, function (item) {
                        $scope.files.push(item);
                    });
                }

                var parentElem = angular.element($('#upload-file-modal-wrapper'));
                $scope.modalInstance = $uibModal.open({
                    backdrop: 'static',
                    templateUrl: 'uploadFileModal.html',
                    controller: uploadFileController,
                    appendTo: parentElem,
                    scope: $scope
                });
            }
        });
    }]);
vatModule.directive('uploadFileModal', ['$log',
function ($log) {
    return {
        restrict: 'E',
        templateUrl: '/app/vat/output-invoice/upload-file-modal/upload-file-modal.html' + '?_=' + Math.random(),
        scope: {
            uploadFileOption: '=',
            uploadFileType: '=',
            uploadFileWebApiUrl: '='
        },
        controller: 'uploadFileModalController',
        link: function ($scope, $element, $attr) {

        }
    }
}]);
vatModule.controller('ProductItemPreviewController', ['$scope', '$log', '$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'productService', 'browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($scope, $log, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, productService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');
        $scope.startMonth = vatSessionService.month;
        $scope.endMonth = vatSessionService.month;

        var minDate = [1, vatSessionService.project.year];
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];

        //发票类型
        var invoiceTypeEnum = {
            VATInvoice: $translate.instant('VATInvoice'),
            FreightTransport: $translate.instant('FreightTransport'),
            MotorVehicle: $translate.instant('MotorVehicle'),
            AgriculturalProduct: $translate.instant('AgriculturalProduct')
        };

        $scope.monthList = [$translate.instant('Month01'),
                            $translate.instant('Month02'),
                            $translate.instant('Month03'),
                            $translate.instant('Month04'),
                            $translate.instant('Month05'),
                            $translate.instant('Month06'),
                            $translate.instant('Month07'),
                            $translate.instant('Month08'),
                            $translate.instant('Month09'),
                            $translate.instant('Month10'),
                            $translate.instant('Month11'),
                            $translate.instant('Month12')
        ];


        //发票类型
        $scope.invoiceTypeList = [
            { id: 999, name: '未选择' },
            { id: 1, name: '1' },
            { id: 2, name: '2' },
            { id: 3, name: '0/空' },
        ];


        $scope.InvoiceType = {};
        $scope.CertificationStatus = {};

        //初始化期间
        var initPeriods = function () {
            var curMonth = new Date().getMonth() + 1;


            $scope.queryParams = {
                pageInfo: {}
                //periodStart: '',
                //periodEnd: '',
                //certificationDateStart: null,
                //certificationDateEnd: null,
                //invoiceCode: '',
                //invoiceNumber: '',
                //sellerTaxNumber: '',
                //amountStart: null,
                //amountEnd: null,
                //invoiceType: null,
                //taxAmountStart: null,
                //taxAmountEnd: null,
                //certificationStatus: null
            };
        };

        //从数据库中load数据
        var loadIncomeInvoiceItemDataFromDB = function (pageIndex) {
            initIncomeInvoiceItemPagination();

            $scope.curIncomeInvoiceItemPage = pageIndex;

            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount,
                pageIndex: pageIndex,
                pageSize: $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize,
                totalPage: 0,
            };

            productService.getProductItemListByPage($scope.queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.gridOptions.data = data.list;
                    $scope.queryIncomeInvoiceItemResult.pageInfo = data.pageInfo;
                    computeIncomeInvoiceItemPage();
                }
            });
        };

        //点击任意一页加载数据事件
        var loadIncomeInvoiceDataByPage = function (pageIndex) {
            loadIncomeInvoiceItemDataFromDB(pageIndex);
        };

        //计算页数，创建分页栏
        var computeIncomeInvoiceItemPage = function () {

            if ($scope.queryIncomeInvoiceItemResult.pageInfo && $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount > 0) {

                var totalPage = parseInt($scope.queryIncomeInvoiceItemResult.pageInfo.totalCount / $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize);
                totalPage = $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount % $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;

                //计算本页记录数
                if ($scope.queryIncomeInvoiceItemResult.pageInfo.pageIndex === totalPage) {
                    $scope.curPageItemCount = $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount % $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize;
                }

                $scope.queryIncomeInvoiceItemResult.pageInfo.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.curIncomeInvoiceItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadIncomeInvoiceDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.curIncomeInvoiceItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadIncomeInvoiceDataByPage(p);
                    }
                });

                //如果查询结果为0，则直接设置本页记录数为0
                $scope.curPageItemCount = 0;

                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };

        //初始化分页信息
        var initIncomeInvoiceItemPagination = function () {
            $scope.queryIncomeInvoiceItemResult = {
                list: [],
                pageInfo: {
                    totalCount: -1,
                    pageIndex: 1,
                    pageSize: constant.pagesize,
                    totalPage: 0,
                }
            }

            $scope.curIncomeInvoiceItemPage = 1;
        };


        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {

            ////初始化已选择的发票类型和认证结果
            //$scope.InvoiceType.selected = _.find($scope.invoiceTypeList, function (v) {
            //    return v.id == $scope.queryParams.invoiceType;
            //})

        };

        (function initialize() {
            $log.debug('VatPreviewInputInvoiceController.ctor()...');
            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,//['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
             .on('datePicker.done', function (e, result) {
                 //开始月份
                 var startMonth = result[0][0];
                 //结束月份
                 var endMonth = result[1][0];
                 $scope.startMonth = startMonth;
                 $scope.endMonth = endMonth;

                 //$scope.queryParams.periodStart = startMonth;
                 //$scope.queryParams.periodEnd = endMonth;

                 loadIncomeInvoiceItemDataFromDB(1);
             });


            $scope.gridOptions = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                enableSorting: false,
                enableColumnMenus: false,
                columnDefs: [
                 { name: '序号', width: '6%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>' },
                 { name: '产品编号', width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetCode}}<span></div>' },
                 { name: '产品名称', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetName}}<span></div>' },
                 { name: '科目代码', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctCode}}<span></div>' },
                 { name: '科目名称', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctName}}</span></div>' },
                 { name: '科目类别', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctClass}}</span></div>' },
                 { name: '科目性质', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctAttr}}</span></div>' },
                 { name: '卖出金额汇总', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fcjje}}</span></div>' },
                 { name: '计税基数余额', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.bjsjzye}}</span></div>' },
                 { name: '应税状态', width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fyszt}}</span></div>' },
                 { name: '期间', width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.year + "-" + (row.entity.month < 10 ? "0" + row.entity.month : row.entity.month)}}</span></div>' }
                ],
                onRegisterApi: function (gridApi) {
                    $scope.gridApi = gridApi;

                    $interval(function () {
                        $scope.gridApi.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);
                }
            };

            $scope.showPopover = showPopover;

            initPeriods();
            initIncomeInvoiceItemPagination();
            //初始化查询条件-期间范围
            //$scope.queryParams.periodStart = vatSessionService.month;
            //$scope.queryParams.periodEnd = vatSessionService.month;
            loadIncomeInvoiceItemDataFromDB(1);

        })();
    }
]);





vatModule.directive('productItemPreview', ['$log', 'browserService', '$translate', 'region', '$timeout',
    function ($log, browserService, $translate, region, $timeout) {
        $log.debug('productItemPreview.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/preview/product-item-preview/product-item-preview.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'ProductItemPreviewController',
            link: function ($scope, element) {

            }
        }
    }
]);
vatModule.controller('vatPreviewAccountVoucherController', ['$scope', 'vatSessionService',
    function ($scope, vatSessionService) {
        'use strict';

        $scope.vatProject = vatSessionService.project;
        $scope.month = vatSessionService.month;
    }
]);

vatModule.directive('vatPreviewAccountVoucher', ['$log','browserService','$translate',
    function ($log, browserService, $translate) {
        $log.debug('vatPreviewAccountVoucher.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/preview/vat-preview-accountVoucher/vat-preview-accountVoucher.html' + '?_=' + Math.random(),
            scope: {                                
            },
            controller: 'vatPreviewAccountVoucherController',
            link: function ($scope, element) {                                      
            }
        };
    }
]); 



 vatModule.controller('vatPreviewBalanceSheetController', ['$scope', 'vatSessionService',
    function ($scope, vatSessionService) {
        'use strict';

        $scope.vatProject = vatSessionService.project;
        $scope.month = vatSessionService.month;

    }
]);
vatModule.directive('vatPreviewBalanceSheet', ['$log','browserService','$translate',
    function ($log, browserService, $translate) {
        $log.debug('vatPreviewBalanceSheet.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/preview/vat-preview-balanceSheet/vat-preview-balanceSheet.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'vatPreviewBalanceSheetController',
            link: function ($scope, element) {
               
            
            }
        };
    }
]);




vatModule.controller('vatPreviewCustomInvoiceSheetController', ['$scope', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', '$q', 'uiGridConstants', 'projectService', 'uiGridGroupingConstants', 'vatImportService', 'i18nService', 'browserService', '$interval', 'region', 'vatSessionService', 'vatExportService',
    function ($scope, $log, $translate, $timeout, apiInterceptor, Upload, dataImportService, SweetAlert, $q, uiGridConstants, projectService, uiGridGroupingConstants, vatImportService, i18nService, browserService, $interval, region, vatSessionService,vatExportService) {
        'use strict';

        $scope.currentEditingValue = "";

        // **********************************************************************
        //Date range picker:
        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');

        var minDate = [1, vatSessionService.project.year];
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];

        //Date range picker:
        // **********************************************************************

        $scope.filterData = {
            periodFrom: 0,
            periodTo: 0,
            invoiceStartDate: null,
            invoiceEndDate: null,
            payNum: null,
            taxAmountFrom: null,
            taxAmountTo: null,
            invoiceAmountFrom: null,
            invoiceAmountTo: null

        };

        $scope.criteriaList = [];

        // current CATEGORY:


        $scope.monthList = [$translate.instant('Month01'),
                            $translate.instant('Month02'),
                            $translate.instant('Month03'),
                            $translate.instant('Month04'),
                            $translate.instant('Month05'),
                            $translate.instant('Month06'),
                            $translate.instant('Month07'),
                            $translate.instant('Month08'),
                            $translate.instant('Month09'),
                            $translate.instant('Month10'),
                            $translate.instant('Month11'),
                            $translate.instant('Month12')
        ];


        $scope.filterData.periodFrom = vatSessionService.month;
        $scope.filterData.periodTo = vatSessionService.month;


        // NEW STUFF:
        $scope.pagination = {
            totalCount: 0,
            pageIndex: 1,
            pageSize: 100
        };


        // ****************************************************************************************
        //************ EXCEL EXPORT FUNCTION ***************/


        //导出进项发票数据
        var downloadCustomInvoice = function () {


            if ($scope.filterData !== null && $scope.filterData !== "") {

               var criteria = JSON.stringify($scope.filterData);
                if (browserService.isIE() || browserService.isEdge())
                    criteria = encodeURIComponent(criteria);
            }
            else
                criteria = "";

            vatImportService.getExportCustomInvoiceList(criteria).success(function (data, status, headers) {
                if(status===204){
                    SweetAlert.warning("没有数据可以下载");
                    return;
                }
                vatExportService.exportToExcel(data, status, headers, 'CustomInvoice.xlsx');
            });
        };
        //************ EXCEL EXPORT FUNCTION ***************/
        // ****************************************************************************************
        


        // ************************************************************************************************
        // function to get data from Backend
        $scope.getDataFromDatabase = function (from, to, criteria, paginationInformation) {
          
 
                // always Jsonized the pagination:
                if (paginationInformation !== null && paginationInformation !== "") {
                    var pagination = JSON.stringify(paginationInformation);
                    if (browserService.isIE() || browserService.isEdge())
                        pagination = encodeURIComponent(pagination);
                }
                else
                    pagination = "";
            

            if (criteria !== null && criteria !== "") {

                criteria = JSON.stringify($scope.filterData);
                if (browserService.isIE() || browserService.isEdge())
                    criteria = encodeURIComponent(criteria);
            }
            else
                criteria = "";


            vatImportService.getCustomsInvoiceDataForDisplay(from, to, criteria, pagination).success(function (customInvoices) {
                var newData = JSON.parse(customInvoices);

                    $scope.gridOptions.data = newData.List;


                    $scope.pagination.totalCount = newData.PageInfo.TotalCount;
                    $scope.pagination.pageIndex = newData.PageInfo.PageIndex;
                    $scope.pagination.pageSize = newData.PageInfo.PageSize;

                    computeIncomeInvoiceItemPage();

                    $('.filter-button').popover("hide");
                
            });
        };


        $scope.updateACustomPrice = function (customId, invoiceAmount) {

            
            vatImportService.updateACustomPrice(customId, invoiceAmount).success(function (customInvoices) {

                SweetAlert.success($translate.instant('UpdateSuccess'));
            });
        };

        // function to get data from Backend
        // ************************************************************************************************


        // ************************************************************************************************
        // SETUP UI GRID TREE:
        var treeData;

        // 国际化；
        // i18nService.setCurrentLang("zh-cn");

        $scope.gridOptions = {
            rowHeight: 50,
            selectionRowHeaderWidth: 50,
            enableFullRowSelection: false,
            enableRowSelection: false,
            enableSorting: false,
            enableFiltering: false,
            enableColumnMenus: false,
            enableRowHeaderSelection: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
            enableGridMenu: false,
            enableSelectAll: false,
            exporterLinkLabel: 'get it here',
            exporterCsvFilename: 'CustomInvoices.csv',
            exporterOlderExcelCompatibility: true,

            exporterHeaderFilterUseName: true,
            exportCsvLinkElement: angular.element(document.querySelectorAll(".custom-csv-link-location")),
            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;

                $scope.gridApiTotal = gridApi;

                //updating cell: price
                gridApi.edit.on.afterCellEdit($scope, function (rowEntity, colDef, newValue, oldValue) {

                    var invoiceAmount = PWC.stringNumberFormat(newValue);
                    if (newValue === oldValue) {

                    }

                    else if (invoiceAmount.trim() !== "" && !isNaN(parseFloat(invoiceAmount)) && isFinite(invoiceAmount)) {
                        $scope.updateACustomPrice(rowEntity.customsId, invoiceAmount);
                        $scope.$apply();
                    }
                    else {
                        //gridApi.edit.raise.cancelCellEdit(rowEntity, colDef);
                        //gridApi.edit.on.cancelCellEdit(rowEntity, colDef);
                        SweetAlert.warning($translate.instant('UpdateFailed'));
                        $scope.getDataFromDatabase($scope.filterData.periodFrom, $scope.filterData.periodTo, $scope.filterData, $scope.pagination);
                    }
                });

                $interval(function () {
                    $scope.gridApiTotal.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            },

            columnDefs: [
            {

                field: 'recordNumber', name: $translate.instant('ImportErrorPopUpNoCol'), enableCellEdit: false, width: '100',
                cellTemplate: '<div class="paddingLeft"><span>{{row.entity.recordNumber}}<span></div>'
            },
            {
                field: 'periodId', name: $translate.instant('PeriodId'), headerCellClass: 'alignCenter', enableCellEdit: false,
                cellTemplate: '<div class="alignCenter"><span>{{row.entity.periodId}}</span></div>'
            },
             {
                 field: 'issueDate', name: $translate.instant('CustomsIssueDate'), enableCellEdit: false,
                 cellTemplate: '<div class="paddingLeft"><span>{{row.entity.issueDate}}<span></div>'
             },


            {
                field: 'payNum', name: $translate.instant('CustomsPayNum'), enableCellEdit: false,
                cellTemplate: '<div class="paddingLeft"><span>{{row.entity.payNum}}<span></div>'
            },
             {
                 field: 'invoiceAmount', enableCellEdit: true, enableCellEditOnFocus: true, name: $translate.instant('Amount'), headerCellClass: 'alignRight', width: '150',
                 cellTemplate: '<div class="alignRight"><span>{{row.entity.invoiceAmount}}</span></div>'
             },

              {
                  field: 'invoiceTaxAmount', enableCellEdit: false, name: $translate.instant('InvoiceSE'), headerCellClass: 'alignRight',
                  cellTemplate: '<div class="alignRight"><span>{{row.entity.invoiceTaxAmount}}</span></div>'
              },

              {
                  field: 'auditResult', name: $translate.instant('CustomsAuditResult'), enableCellEdit: false,
                  cellTemplate: '<div class="paddingLeft"><span>{{row.entity.auditResult}}</span></div>'
              }


            ]
        };
        // SETUP UI GRID TREE:
        // ************************************************************************************************


        // Get initial Data from Backend to fill the UI grid Tree:
        $scope.getDataFromDatabase($scope.filterData.periodFrom, $scope.filterData.periodTo, "", $scope.pagination);


        // ************************************************************************************************
        // Export Data Gird To CSV
        //$scope.export = function () {
        //    var myElement = angular.element(document.querySelectorAll(".custom-csv-link-location"));
        //    $scope.gridApi.exporter.csvExport("all", "visible", myElement);
        //};
        // Export Data Gird To CSV
        // ************************************************************************************************

       
        // ************************************************************************************************
        // Reset Data Filter:
        $scope.doDataFilterReset = function () {
            var from = $scope.filterData.periodFrom;
            var to = $scope.filterData.periodTo;


            $scope.filterData = {
                periodFrom: from,
                periodTo: to,
                invoiceStartDate: null,
                invoiceEndDate: null,
                payNum: null,
                taxAmountFrom: null,
                taxAmountTo: null,
                invoiceAmountFrom: null,
                invoiceAmountTo: null

            };
            // $scope.criteriaList = [];

            //$scope.pagination.pageIndex = 1;
            //$scope.getDataFromDatabase($scope.filterData.periodFrom,$scope.filterData.periodTo, $scope.filterData, $scope.pagination);


        }
        // Reset Data Filter:
        // ************************************************************************************************


        // NEW STUFF

        //计算页数，创建分页栏
        var computeIncomeInvoiceItemPage = function () {

            $scope.curPageItemCount = 0;
            if ($scope.pagination && $scope.pagination.totalCount > 0) {

                
                var totalPage = parseInt($scope.pagination.totalCount / $scope.pagination.pageSize);
                totalPage = $scope.pagination.totalCount % $scope.pagination.pageSize == 0 ? totalPage : totalPage + 1;


                if ($scope.pagination.pageIndex === totalPage) {
                    $scope.curPageItemCount = $scope.pagination.totalCount % $scope.pagination.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.pagination.pageSize;
                }



                $scope.pagination.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.pagination.pageIndex,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        $scope.pagination.pageIndex = p;
                        $scope.getDataFromDatabase($scope.filterData.periodFrom, $scope.filterData.periodTo, $scope.filterData, $scope.pagination);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.pagination.pageIndex,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        $scope.pagination.pageIndex = p;
                        $scope.getDataFromDatabase($scope.filterData.periodFrom, $scope.filterData.periodTo, $scope.filterData, $scope.pagination);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };


        //初始化分页信息
        var initIncomeInvoiceItemPagination = function () {
            $scope.queryIncomeInvoiceItemResult = {
                list: [],
                pageInfo: {
                    totalCount: -1,
                    pageIndex: 1,
                    pageSize: 10,
                    totalPage: 0,
                }
            }

            $scope.curIncomeInvoiceItemPage = 1;
        };


        // NEW STUFF

        // ************************************************************************************************
        // Perform Data filter


        var prepareSummary = function () {
            // do something before show popover
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        $scope.doDataFilter = function (removeData) {

            //$scope.filterData.periodFrom = $scope.monthFrom.selected.id;
            //$scope.filterData.periodTo = $scope.monthTo.selected.id;


            if ($scope.filterData.periodFrom > $scope.filterData.periodTo) {
                $scope.filterData.periodTo = $scope.filterData.periodFrom;
            }

            // Filter number validations:
            // fixed a bug when the amount has illegal chars:
            $scope.filterData.taxAmountFrom = (!PWC.isNullOrEmpty($scope.filterData.taxAmountFrom)) ?  PWC.stringNumberFormat($scope.filterData.taxAmountFrom) : "";
            $scope.filterData.taxAmountTo = (!PWC.isNullOrEmpty($scope.filterData.taxAmountTo)) ? PWC.stringNumberFormat($scope.filterData.taxAmountTo) : "";
            $scope.filterData.invoiceAmountFrom = (!PWC.isNullOrEmpty($scope.filterData.invoiceAmountFrom)) ?  PWC.stringNumberFormat($scope.filterData.invoiceAmountFrom) : "";
            $scope.filterData.invoiceAmountTo = (!PWC.isNullOrEmpty($scope.filterData.invoiceAmountTo)) ?  PWC.stringNumberFormat($scope.filterData.invoiceAmountTo) : "";



            // Filter validations:
            if (!PWC.isNullOrEmpty($scope.filterData.taxAmountFrom) && !PWC.isNullOrEmpty($scope.filterData.taxAmountTo) &&
                $scope.filterData.taxAmountFrom > $scope.filterData.taxAmountTo)
            {
                swal({ title: "", text: $translate.instant('AmountWarningSearch'), type: "warning", confirmButtonText: $translate.instant('Confirm') },
                    function(isConfirm){
                        if (isConfirm) {
                            $("#filterButton").click();
                        }

                    });
 
            }
            else if (!PWC.isNullOrEmpty($scope.filterData.invoiceAmountFrom) && !PWC.isNullOrEmpty($scope.filterData.invoiceAmountTo) &&
                $scope.filterData.invoiceAmountFrom > $scope.filterData.invoiceAmountTo) {
                
                swal({ title: "", text: $translate.instant('AmountWarningSearch'), type: "warning", confirmButtonText: $translate.instant('Confirm') },
                     function (isConfirm) {
                         if (isConfirm) {
                             $("#filterButton").click();
                         }

                     });
            }

            else if (!PWC.isNullOrEmpty($scope.filterData.invoiceStartDate) && !PWC.isNullOrEmpty($scope.filterData.invoiceEndDate) &&
                $scope.filterData.invoiceStartDate > $scope.filterData.invoiceEndDate)
            {
   
                swal({ title: "", text: $translate.instant('DateWarningSearch'), type: "warning", confirmButtonText: $translate.instant('Confirm') },
                    function (isConfirm) {
                        if (isConfirm) {
                            $("#filterButton").click();
                        }

                    });
            }
            else {


                //设置需要去掉的查询条件的值为空
                if (!PWC.isNullOrEmpty(removeData)) {
                    var removeItem = removeData.split("|");
                    removeItem.forEach(function (v) {
                        $scope.filterData[v] = null;

                    });
                }

                //********************************************************************************
                // add to Criteria List for display on top of the grid:
                var crits = $scope.filterData;

                $scope.criteriaList = [];



                var crit = [];
                if (!PWC.isNullOrEmpty(crits.payNum)) {
                    crit = new Object;
                    crit.name = $translate.instant('CustomsPayNum');
                    crit.valueFrom = crits.payNum;
                    crit.propertyName = "payNum";

                    $scope.criteriaList.push(crit);
                }

                if (!PWC.isNullOrEmpty(crits.invoiceStartDate) || !PWC.isNullOrEmpty(crits.invoiceEndDate)) {
                    if (new Date(crits.invoiceStartDate.replace(/[\.-]/g, '/')) > new Date(crits.invoiceEndDate.replace(/[\.-]/g, '/'))) {
                        $scope.criteriaList = [];
                        SweetAlert.warning($translate.instant('InvoiceDateQueryError'));
                        return;
                    }
                    crit = new Object;
                    crit.name = $translate.instant('CustomsIssueDate');
                    crit.valueFrom = crits.invoiceStartDate;
                    crit.valueTo = crits.invoiceEndDate;
                    crit.propertyName = "invoiceStartDate|invoiceEndDate";

                    $scope.criteriaList.push(crit);
                }

                if (!PWC.isNullOrEmpty(crits.taxAmountFrom) || !PWC.isNullOrEmpty(crits.taxAmountTo)) {
                    crit = new Object;
                    crit.name = $translate.instant('InvoiceSE');
                    crit.valueFrom = crits.taxAmountFrom + "";
                    crit.valueTo = crits.taxAmountTo + "";
                    crit.propertyName = "taxAmountFrom|taxAmountTo";

                    $scope.criteriaList.push(crit);
                }

                if (!PWC.isNullOrEmpty(crits.invoiceAmountFrom) || !PWC.isNullOrEmpty(crits.invoiceAmountTo)) {
                    crit = new Object;
                    crit.name = $translate.instant('Amount');
                    crit.valueFrom = crits.invoiceAmountFrom + "";
                    crit.valueTo = crits.invoiceAmountTo + "";
                    crit.propertyName = "invoiceAmountFrom|invoiceAmountTo";

                    $scope.criteriaList.push(crit);
                }


                // add to Criteria List for display on top of the grid:
                //********************************************************************************



                //var criteria = JSON.stringify($scope.filterData);
                //if (browserService.isIE() || browserService.isEdge())
                //    criteria = encodeURIComponent(criteria);
                $scope.pagination.pageIndex = 1;
                $scope.getDataFromDatabase($scope.filterData.periodFrom, $scope.filterData.periodTo, $scope.filterData, $scope.pagination);
            }
        };


        // Perform Data filter
        // ************************************************************************************************

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };
        //初始化时间控件
        var initDatePickers = function () {
            //认证开始时间

            var ele1 = $("#customInvoiceDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.filterData.invoiceStartDate);
            //认证结束时间
            var ele2 = $("#customInvoiceDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            })
            ele2.datepicker("setDate", $scope.filterData.invoiceEndDate);



        };


        //开始
        (function initialize() {

            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,//['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
                .on('datePicker.show', function (ev, picker) {

                    $('.filter-button').popover("hide");
                })

             .on('datePicker.done', function (e, result) {
                 //开始月份
                 var startMonth = result[0][0];
                 //结束月份
                 var endMonth = result[1][0];
                 $scope.filterData.periodFrom = startMonth;
                 $scope.filterData.periodTo = endMonth;

                 $scope.pagination.pageIndex = 1;
                 $scope.getDataFromDatabase($scope.filterData.periodFrom, $scope.filterData.periodTo, $scope.filterData, $scope.pagination);
             });


            $scope.downloadCustomInvoice = downloadCustomInvoice;



            // Reposition Header when the window is resized
            $(window).on('resize', function () {
                // SetUiGridHeader();
            });

            $scope.showPopover = showPopover;

        })();
    }
]);

//vatModule.directive('onFinishRender', ['$timeout', function ($timeout) {
//    return {
//        restrict: 'A',
//        link: function (scope, element, attr) {
//            if (scope.$last === true) {
//                $timeout(function () {
//                    scope.$emit(attr.onFinishRender);
//                }, 500);
//            }
//        }
//    }
//}]);
vatModule.directive('vatPreviewCustomInvoiceSheet', ['$log', 'browserService', '$translate',
    function ($log, browserService, $translate) {
        $log.debug('vatPreviewCustomInvoiceSheet.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/preview/vat-preview-customInvoice-sheet/vat-preview-customInvoice-sheet.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'vatPreviewCustomInvoiceSheetController',
            link: function ($scope, element) {
               
                
            }
        };
    }
]);





vatModule.controller('VatPreviewInputInvoiceController', ['$scope', '$log', '$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatPreviewService', 'browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($scope, $log, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, vatPreviewService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');
        $scope.startMonth = vatSessionService.month;
        $scope.endMonth = vatSessionService.month;

        var minDate = [1, vatSessionService.project.year];
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];

        //发票类型
        var invoiceTypeEnum = {
            VATInvoice: $translate.instant('VATInvoice'),
            FreightTransport: $translate.instant('FreightTransport'),
            MotorVehicle: $translate.instant('MotorVehicle'),
            AgriculturalProduct: $translate.instant('AgriculturalProduct')
        };

        $scope.monthList = [$translate.instant('Month01'),
                            $translate.instant('Month02'),
                            $translate.instant('Month03'),
                            $translate.instant('Month04'),
                            $translate.instant('Month05'),
                            $translate.instant('Month06'),
                            $translate.instant('Month07'),
                            $translate.instant('Month08'),
                            $translate.instant('Month09'),
                            $translate.instant('Month10'),
                            $translate.instant('Month11'),
                            $translate.instant('Month12')
        ];

        //认证结果
        $scope.cetificationResultList = [
            { id: 999, name: $translate.instant('AllTheItems') },
            { id: 1, name: $translate.instant('CertificationPass') },
            { id: 2, name: $translate.instant('CertificationNotPass') }
        ];

        //发票类型
        $scope.invoiceTypeList = [
            { id: 999, name: $translate.instant('AllTheItems') },
            { id: enums.invoiceType.VATInvoice, name: $translate.instant('VATInvoice') },
            { id: enums.invoiceType.FreightTransport, name: $translate.instant('FreightTransport') },
            { id: enums.invoiceType.MotorVehicle, name: $translate.instant('MotorVehicle') },
            { id: enums.invoiceType.AgriculturalProduct, name: $translate.instant('AgriculturalProduct') }
        ];


        $scope.InvoiceType = {};
        $scope.CertificationStatus = {};

        //初始化期间
        var initPeriods = function () {
            var curMonth = new Date().getMonth() + 1;


            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                certificationDateStart: null,
                certificationDateEnd: null,
                invoiceCode: '',
                invoiceNumber: '',
                sellerTaxNumber: '',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null,
                certificationStatus: null
            };
        };

        //从数据库中load数据
        var loadIncomeInvoiceItemDataFromDB = function (pageIndex) {
            initIncomeInvoiceItemPagination();

            $scope.curIncomeInvoiceItemPage = pageIndex;

            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount,
                pageIndex: pageIndex,
                pageSize: $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize,
                totalPage: 0,
            };



            vatPreviewService.queryInputInvoiceList($scope.queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                        v.amount = PWC.round(v.amount, 2);
                        v.taxAmount = PWC.round(v.taxAmount, 2);
                    });
                    $scope.gridOptions.data = data.list;
                    $scope.queryIncomeInvoiceItemResult.pageInfo = data.pageInfo;
                    computeIncomeInvoiceItemPage();
                }
            });
        };

        //点击任意一页加载数据事件
        var loadIncomeInvoiceDataByPage = function (pageIndex) {
            loadIncomeInvoiceItemDataFromDB(pageIndex);
        };

        //计算页数，创建分页栏
        var computeIncomeInvoiceItemPage = function () {

            if ($scope.queryIncomeInvoiceItemResult.pageInfo && $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount > 0) {

                var totalPage = parseInt($scope.queryIncomeInvoiceItemResult.pageInfo.totalCount / $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize);
                totalPage = $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount % $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;

                //计算本页记录数
                if ($scope.queryIncomeInvoiceItemResult.pageInfo.pageIndex === totalPage) {
                    $scope.curPageItemCount = $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount % $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize;
                }

                $scope.queryIncomeInvoiceItemResult.pageInfo.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.curIncomeInvoiceItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadIncomeInvoiceDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.curIncomeInvoiceItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadIncomeInvoiceDataByPage(p);
                    }
                });

                //如果查询结果为0，则直接设置本页记录数为0
                $scope.curPageItemCount = 0;

                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };

        //初始化分页信息
        var initIncomeInvoiceItemPagination = function () {
            $scope.queryIncomeInvoiceItemResult = {
                list: [],
                pageInfo: {
                    totalCount: -1,
                    pageIndex: 1,
                    pageSize: constant.pagesize,
                    totalPage: 0,
                }
            }

            $scope.curIncomeInvoiceItemPage = 1;
        };

        //将选择了的查询条件显示在grid上方
        var doDataFilter = function (removeData) {
            if ($scope.queryParams.periodStart > $scope.queryParams.periodEnd) {
                $scope.queryParams.periodEnd = $scope.queryParams.periodStart;
            }

            //设置需要去掉的查询条件的值为空
            if (!PWC.isNullOrEmpty(removeData)) {
                var removeItem = removeData.split("|");
                removeItem.forEach(function (v) {
                    $scope.queryParams[v] = null;

                    //如果去掉了发票代码的查询条件，则将查询条件设置为''，因为是字符串，设置为null会导致查询结果错误
                    if ($scope.queryParams.invoiceCode === null) {
                        $scope.queryParams.invoiceCode = '';
                    }
                    //如果去掉了发票号码的查询条件，则将查询条件设置为''，因为是字符串，设置为null会导致查询结果错误
                    if ($scope.queryParams.invoiceNumber === null) {
                        $scope.queryParams.invoiceNumber = '';
                    }
                    //如果去掉了供货方税号的查询条件，则将查询条件设置为''，因为是字符串，设置为null会导致查询结果错误
                    if ($scope.queryParams.sellerTaxNumber === null) {
                        $scope.queryParams.sellerTaxNumber = '';
                    }


                    if ($scope.queryParams.invoiceType === null) {
                        $scope.InvoiceType.selected = undefined;
                    }

                    if ($scope.queryParams.certificationStatus === null) {
                        $scope.CertificationStatus.selected = undefined;
                    }
                });
            }

            //设置发票类型和认证结果
            if ($scope.InvoiceType.selected !== undefined)
                $scope.queryParams.invoiceType = $scope.InvoiceType.selected.id;
            else
                $scope.queryParams.invoiceType = null;
            if ($scope.CertificationStatus.selected !== undefined)
                $scope.queryParams.certificationStatus = $scope.CertificationStatus.selected.id;
            else
                $scope.queryParams.certificationStatus = null;

            // 将查询条件加入到grid上方
            var crits = $scope.queryParams;

            //定义查询条件数组用于存放已选的查询条件
            $scope.criteriaList = [];

            var crit = [];

            //认证日期
            if (!PWC.isNullOrEmpty(crits.certificationDateStart) && !PWC.isNullOrEmpty(crits.certificationDateEnd)) {
                if (new Date(crits.certificationDateStart.replace(/[\.-]/g, '/')) > new Date(crits.certificationDateEnd.replace(/[\.-]/g, '/'))) {
                    $scope.criteriaList = [];
                    SweetAlert.warning($translate.instant('InvoiceDateQueryError'));
                    return;
                }
                crit = new Object;
                crit.name = $translate.instant('InvoiceRZRQQuery') + crits.certificationDateStart + "-" + crits.certificationDateEnd;;
                crit.fullName = $translate.instant('InvoiceRZRQQuery') + crits.certificationDateStart + "-" + crits.certificationDateEnd;
                crit.valueFrom = crits.certificationDateStart;
                crit.valueTo = crits.certificationDateEnd;
                crit.propertyName = "certificationDateStart|certificationDateEnd";

                $scope.criteriaList.push(crit);
            } else if (!PWC.isNullOrEmpty(crits.certificationDateStart) && PWC.isNullOrEmpty(crits.invoiceDateEnd)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceRZRQQuery') + crits.certificationDateStart + $translate.instant('After');
                crit.fullName = $translate.instant('InvoiceRZRQQuery') + crits.certificationDateStart + $translate.instant('After');
                crit.valueFrom = crits.certificationDateStart;
                crit.valueTo = crits.certificationDateEnd;
                crit.propertyName = "certificationDateStart|certificationDateEnd";

                $scope.criteriaList.push(crit);
            }
            else if (PWC.isNullOrEmpty(crits.certificationDateStart) && !PWC.isNullOrEmpty(crits.certificationDateEnd)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceRZRQQuery') + crits.certificationDateEnd + $translate.instant('Before');
                crit.fullName = $translate.instant('InvoiceRZRQQuery') + crits.certificationDateEnd + $translate.instant('Before');
                crit.valueFrom = crits.certificationDateStart;
                crit.valueTo = crits.certificationDateEnd;
                crit.propertyName = "certificationDateStart|certificationDateEnd";
                $scope.criteriaList.push(crit);
            }


            //发票代码
            if (!PWC.isNullOrEmpty(crits.invoiceCode)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceFPDMQuery') + PWC.limitString(crits.invoiceCode, 10);
                crit.fullName = $translate.instant('InvoiceFPDMQuery') + crits.invoiceCode;
                crit.valueFrom = crits.invoiceCode;
                crit.propertyName = "invoiceCode";

                $scope.criteriaList.push(crit);
            }

            //发票号码
            if (!PWC.isNullOrEmpty(crits.invoiceNumber)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceFPHMQuery') + PWC.limitString(crits.invoiceNumber, 10);
                crit.fullName = $translate.instant('InvoiceFPHMQuery') + crits.invoiceNumber;
                crit.valueFrom = crits.invoiceNumber;
                crit.propertyName = "invoiceNumber";

                $scope.criteriaList.push(crit);
            }

            //销方识别号
            if (!PWC.isNullOrEmpty(crits.sellerTaxNumber)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceGHFSHQuery') + PWC.limitString(crits.sellerTaxNumber, 10);
                crit.fullName = $translate.instant('InvoiceGHFSHQuery') + crits.sellerTaxNumber;
                crit.valueFrom = crits.sellerTaxNumber;
                crit.propertyName = "sellerTaxNumber";

                $scope.criteriaList.push(crit);
            }

            //金额
            if (!PWC.isNullOrEmpty(crits.amountStart) && !PWC.isNullOrEmpty(crits.amountEnd)) {
                if (Number(crits.amountStart) > Number(crits.amountEnd)) {
                    SweetAlert.warning($translate.instant('AmountQueryError'));
                    return;
                }
                crit = new Object;
                crit.name = $translate.instant('InvoiceJEQuery') + PWC.limitString(crits.amountStart, 5) + ' - ' + PWC.limitString(crits.amountEnd, 5);
                crit.fullName = $translate.instant('InvoiceJEQuery') + crits.amountStart + ' - ' + crits.amountEnd;
                crit.valueFrom = crits.amountStart;
                crit.valueTo = crits.amountEnd;
                crit.propertyName = "amountStart|amountEnd";
                $scope.criteriaList.push(crit);
            }
            else if (!PWC.isNullOrEmpty(crits.amountStart) && PWC.isNullOrEmpty(crits.amountEnd)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceJEQuery') + PWC.limitString(crits.amountStart, 5) + $translate.instant('MoreThan');
                crit.fullName = $translate.instant('InvoiceJEQuery') + crits.amountStart + $translate.instant('MoreThan');
                crit.valueFrom = crits.amountStart;
                crit.valueTo = crits.amountEnd;
                crit.propertyName = "amountStart|amountEnd";
                $scope.criteriaList.push(crit);
            }
            else if (PWC.isNullOrEmpty(crits.amountStart) && !PWC.isNullOrEmpty(crits.amountEnd)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceJEQuery') + PWC.limitString(crits.amountEnd, 5) + $translate.instant('LessThan');
                crit.fullName = $translate.instant('InvoiceJEQuery') + crits.amountEnd + $translate.instant('LessThan');
                crit.valueFrom = crits.amountStart;
                crit.valueTo = crits.amountEnd;
                crit.propertyName = "amountStart|amountEnd";
                $scope.criteriaList.push(crit);
            }


            //税额
            if (!PWC.isNullOrEmpty(crits.taxAmountStart) && !PWC.isNullOrEmpty(crits.taxAmountEnd)) {
                if (Number(crits.taxAmountStart) > Number(crits.taxAmountEnd)) {
                    SweetAlert.warning($translate.instant('TaxAmountQueryError'));
                    return;
                }
                crit = new Object;
                crit.name = $translate.instant('InvoiceSEQuery') + PWC.limitString(crits.taxAmountStart, 5) + ' - ' + PWC.limitString(crits.taxAmountEnd, 5);
                crit.fullName = $translate.instant('InvoiceSEQuery') + crits.taxAmountStart + ' - ' + crits.taxAmountEnd;
                crit.valueFrom = crits.taxAmountStart;
                crit.valueTo = crits.taxAmountEnd;
                crit.propertyName = "taxAmountStart|taxAmountEnd";

                $scope.criteriaList.push(crit);
            }
            else if (!PWC.isNullOrEmpty(crits.taxAmountStart) && PWC.isNullOrEmpty(crits.taxAmountEnd)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceSEQuery') + PWC.limitString(crits.taxAmountStart, 5) + $translate.instant('MoreThan');
                crit.fullName = $translate.instant('InvoiceSEQuery') + crits.taxAmountStart + $translate.instant('MoreThan');
                crit.valueFrom = crits.taxAmountStart;
                crit.valueTo = crits.taxAmountEnd;
                crit.propertyName = "taxAmountStart|taxAmountEnd";

                $scope.criteriaList.push(crit);
            }
            else if (PWC.isNullOrEmpty(crits.taxAmountStart) && !PWC.isNullOrEmpty(crits.taxAmountEnd)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceSEQuery') + PWC.limitString(crits.taxAmountEnd, 5) + $translate.instant('LessThan');
                crit.fullName = $translate.instant('InvoiceSEQuery') + crits.taxAmountEnd + $translate.instant('LessThan');
                crit.valueFrom = crits.taxAmountStart;
                crit.valueTo = crits.taxAmountEnd;
                crit.propertyName = "taxAmountStart|taxAmountEnd";

                $scope.criteriaList.push(crit);
            }

            //发票类型
            if (!PWC.isNullOrEmpty(crits.invoiceType)) {
                crit = new Object;
                crit.valueFrom = _.find($scope.invoiceTypeList, function (v) {
                    return v.id === crits.invoiceType;
                }).name;

                crit.name = $translate.instant('InvoiceFPLXQuery') + crit.valueFrom;
                crit.fullName = $translate.instant('InvoiceFPLXQuery') + crit.valueFrom;
                crit.propertyName = "invoiceType";

                $scope.criteriaList.push(crit);
            }

            //认证结果
            if (!PWC.isNullOrEmpty(crits.certificationStatus)) {
                crit = new Object;
                crit.valueFrom = _.find($scope.cetificationResultList, function (v) {
                    return v.id === crits.certificationStatus;
                }).name;
                crit.name = $translate.instant('InvoiceRZJGQuery') + crit.valueFrom;
                crit.fullName = $translate.instant('InvoiceRZJGQuery') + crit.valueFrom;
                crit.propertyName = "certificationStatus";

                $scope.criteriaList.push(crit);
            }

            // add to Criteria List for display on top of the grid:
            //********************************************************************************

            var criteria = JSON.stringify($scope.queryParams);
            if (browserService.isIE() || browserService.isEdge())
                criteria = encodeURIComponent(criteria);

            loadIncomeInvoiceItemDataFromDB(1);
            if ($scope.criteriaList.length > 6) {
                $scope.criteriaListFirstRow = $scope.criteriaList.slice(0, 6);
                $scope.criteriaListSecondRow = $scope.criteriaList.slice(6, $scope.criteriaList.length);
            }
            else {
                $scope.criteriaListFirstRow = $scope.criteriaList.slice(0, $scope.criteriaList.length);
            }
            $('.filter-button').popover("hide");
        };

        //去掉所有的查询条件，重新load数据
        var doDataFilterReset = function () {
            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                certificationDateStart: null,
                certificationDateEnd: null,
                invoiceCode: '',
                invoiceNumber: '',
                sellerTaxNumber: '',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null,
                certificationStatus: null
            };
            $scope.criteriaList = [];
            $scope.queryParams.periodStart = $scope.startMonth;
            $scope.queryParams.periodEnd = $scope.endMonth;
            loadIncomeInvoiceItemDataFromDB(1);
            $('.filter-button').popover("hide");
        };

        var prepareSummary = function () {
            // do something before show popover
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {
            //认证开始时间
            var ele1 = $("#certificationDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.queryParams.certificationDateStart);
            //认证结束时间
            var ele2 = $("#certificationDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            })
            ele2.datepicker("setDate", $scope.queryParams.certificationDateEnd);


            //初始化已选择的发票类型和认证结果
            $scope.InvoiceType.selected = _.find($scope.invoiceTypeList, function (v) {
                return v.id == $scope.queryParams.invoiceType;
            })

            $scope.CertificationStatus.selected = _.find($scope.cetificationResultList, function (v) {
                return v.id == $scope.queryParams.certificationStatus;
            })
        };

        //发票类型转换
        $scope.typeToString = function (strType) {
            var type = invoiceTypeEnum.VATInvoice;
            switch (strType) {
                case 1:
                    type = invoiceTypeEnum.VATInvoice;
                    break;
                case 2:
                    type = invoiceTypeEnum.FreightTransport;
                    break;
                case 3:
                    type = invoiceTypeEnum.MotorVehicle;
                    break;
                case 4:
                    type = invoiceTypeEnum.AgriculturalProduct;
                    break;
                default:
                    type = "";
            }
            return type;
        };

        //导出进项发票数据
        var downloadInputInvoice = function () {
            vatPreviewService.getExportInputInvoiceList($scope.queryParams).success(function (data, status, headers) {
                if(status===204){
                    SweetAlert.warning("没有数据可以下载");
                    return;
                }
                vatExportService.exportToExcel(data, status, headers, '进项发票信息.xlsx');
            });
        };


        (function initialize() {
            $log.debug('VatPreviewInputInvoiceController.ctor()...');
            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,//['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
             .on('datePicker.done', function (e, result) {
                 //开始月份
                 var startMonth = result[0][0];
                 //结束月份
                 var endMonth = result[1][0];
                 $scope.startMonth = startMonth;
                 $scope.endMonth = endMonth;

                 $scope.queryParams.periodStart = startMonth;
                 $scope.queryParams.periodEnd = endMonth;

                 loadIncomeInvoiceItemDataFromDB(1);
             });


            $scope.gridOptions = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                expandableRowTemplate: '<div ui-grid="row.entity.subGridOptions" style="height:150px;"></div>',
                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                enableSorting: false,
                enableColumnMenus: false,
                columnDefs: [
                 { name: $translate.instant('ImportErrorPopUpNoCol'), width: '7%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>' },
                 { name: $translate.instant('InvoiceQJ'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodID}}<span></div>' },
                 { name: $translate.instant('InvoiceKPRQ'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceDate | date:"yyyy-MM-dd"}}<span></div>' },
                 { name: $translate.instant('InvoiceFPDM'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.invoiceCode}}">{{row.entity.invoiceCode}}</span></div>' },
                 { name: $translate.instant('InvoiceFPHM'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.invoiceNumber}}">{{row.entity.invoiceNumber}}</span></div>' },
                 { name: $translate.instant('InvoiceGHFSH'), width: '12%', cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.sellerTaxNumber}}">{{row.entity.sellerTaxNumber}}</span></div>' },
                 { name: $translate.instant('InvoiceFPLX'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.sellerTaxName}}">{{grid.appScope.typeToString(row.entity.invoiceType)}}</span></div>' },
                 { name: $translate.instant('InvoiceJE'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.amount}}</span></div>' },
                 { name: $translate.instant('InvoiceSE'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.taxAmount}}</span></div>' },
                 { name: $translate.instant('InvoiceRZRQ'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.certificationDate  | date:"yyyy-MM-dd"}}</span></div>' },
                 { name: $translate.instant('InvoiceRZJG'), width: '10.5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.certificationResult}}</span></div>' }
                ],
                onRegisterApi: function (gridApi) {
                    $scope.gridApi = gridApi;

                    //定义子table属性
                    gridApi.expandable.on.rowExpandedStateChanged($scope, function (row) {
                        if (row.isExpanded) {
                            row.entity.subGridOptions = {
                                rowHeight: constant.UIGrid.rowHeight,
                                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                                enableSorting: false,
                                enableColumnMenus: false,
                                columnDefs: [
                                { name: $translate.instant('ImportErrorPopUpNoCol'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>' },
                                { name: $translate.instant('InvoiceHWMC'), width: '23%', cellTemplate: '<div class="ui-grid-cell-contents"><span title="{{row.entity.productionName}}">{{row.entity.productionName}}<span></div>' },
                                { name: $translate.instant('InvoiceJE'), width: '23%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.amount}}<span></div>' },
                                { name: $translate.instant('InvoiceSL'), width: '23%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{(row.entity.taxRate*100).formatAmount(2)}}%<span></div>' },
                                { name: $translate.instant('InvoiceSE'), width: '23%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.taxAmount}}<span></div>' }
                                ]
                            };

                            //获取子table数据
                            vatPreviewService.queryInputInvoiceItemList(row.entity.id).success(function (data) {
                                if (data) {
                                    var index = 1;
                                    data.forEach(function (v) {
                                        v.index = index++;
                                        v.amount = PWC.round(v.amount, 2);
                                        v.taxAmount = PWC.round(v.taxAmount, 2);
                                    });
                                    row.entity.subGridOptions.data = data;
                                }
                            });
                        }
                    });

                    $interval(function () {
                        $scope.gridApi.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);
                }
            };

            $scope.doDataFilter = doDataFilter;
            $scope.doDataFilterReset = doDataFilterReset;
            $scope.prepareSummary = prepareSummary;
            $scope.showPopover = showPopover;
            $scope.downloadInputInvoice = downloadInputInvoice;

            initPeriods();
            initIncomeInvoiceItemPagination();
            //初始化查询条件-期间范围
            $scope.queryParams.periodStart = vatSessionService.month;
            $scope.queryParams.periodEnd = vatSessionService.month;
            loadIncomeInvoiceItemDataFromDB(1);

        })();
    }
]);





vatModule.directive('vatPreviewInputInvoice', ['$log', 'browserService', '$translate', 'region', '$timeout',
    function ($log, browserService, $translate, region, $timeout) {
        $log.debug('vatPreviewInputInvoice.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/preview/vat-preview-input-invoice/vat-preview-input-invoice.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'VatPreviewInputInvoiceController',
            link: function ($scope, element) {

            }
        }
    }
]);
vatModule.controller('vatPreviewOutputInvoiceController', ['$scope', '$log', '$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatPreviewService', 'vatSessionService', 'browserService', 'enums','region','vatExportService',
    function ($scope, $log, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, vatPreviewService, vatSessionService, browserService, enums, region, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');
        $scope.curPageItemCount = 0;
        var startMonth = vatSessionService.month;
        var endMonth = vatSessionService.month;
        var minDate = [1, vatSessionService.project.year];
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];
        //发票类型
        var invoiceTypeEnum = {
            Normal: $translate.instant('Normal'),
            Special: $translate.instant('Special')
        };
        //区间
        $scope.monthList = [$translate.instant('Month01'),
                      $translate.instant('Month02'),
                      $translate.instant('Month03'),
                      $translate.instant('Month04'),
                      $translate.instant('Month05'),
                      $translate.instant('Month06'),
                      $translate.instant('Month07'),
                      $translate.instant('Month08'),
                      $translate.instant('Month09'),
                      $translate.instant('Month10'),
                      $translate.instant('Month11'),
                      $translate.instant('Month12')
        ];
        //发票类型
        $scope.invoiceTypeList = [
            { id: 999, name: $translate.instant('AllTheItems') },
            { id: enums.outputInvoiceType.Normal, name: $translate.instant('Normal') },
            { id: enums.outputInvoiceType.Special, name: $translate.instant('Special') },
        ];

        $scope.PeriodStart = {};
        $scope.PeriodEnd = {};
        $scope.InvoiceType = {};

        //初始化期间
        var initPeriods = function () {
            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                invoiceDateStart: null,
                invoiceDateEnd: null,
                classCode: '',
                invoiceNumber: '',
                buyerName: '',
                productName:'',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null
            };
            $scope.queryParams.periodStart = vatSessionService.month;
            $scope.queryParams.periodEnd = vatSessionService.month;
        };

        //从数据库中load数据
        var loadOutputInvoiceDataFromDB = function (pageIndex) {
            initOutputInvoicePagination();

            $scope.curOutputInvoiceItemPage = pageIndex;
            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.queryOutputInvoiceResult.pageInfo.totalCount,
                pageIndex: pageIndex,
                pageSize: $scope.queryOutputInvoiceResult.pageInfo.pageSize,
                totalPage: 0,
            }

            vatPreviewService.queryOutputInvoiceList($scope.queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                        v.amount = PWC.round(v.amount, 2);
                        v.taxAmount = PWC.round(v.taxAmount, 2);
                    });
                    $scope.gridOptions.data = data.list;
                    $scope.queryOutputInvoiceResult.pageInfo = data.pageInfo;
                    computeOutputInvoiceItemPage();
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //点击任意一页加载数据事件
        var loadOutputInvoiceDataByPage = function (pageIndex) {
            loadOutputInvoiceDataFromDB(pageIndex);
        };

        //计算页数，创建分页栏
        var computeOutputInvoiceItemPage = function () {

            if ($scope.queryOutputInvoiceResult.pageInfo && $scope.queryOutputInvoiceResult.pageInfo.totalCount > 0) {

                var totalPage = parseInt($scope.queryOutputInvoiceResult.pageInfo.totalCount / $scope.queryOutputInvoiceResult.pageInfo.pageSize);
                totalPage = $scope.queryOutputInvoiceResult.pageInfo.totalCount % $scope.queryOutputInvoiceResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;

                if ($scope.queryOutputInvoiceResult.pageInfo.pageIndex === totalPage) {
                    $scope.curPageItemCount = $scope.queryOutputInvoiceResult.pageInfo.totalCount % $scope.queryOutputInvoiceResult.pageInfo.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.queryOutputInvoiceResult.pageInfo.pageSize;
                }

                $scope.queryOutputInvoiceResult.pageInfo.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.curOutputInvoiceItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadOutputInvoiceDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.curOutputInvoiceItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadOutputInvoiceDataByPage(p);
                    }
                });
                $scope.curPageItemCount = 0;
                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };


        //初始化分页信息
        var initOutputInvoicePagination = function () {
            $scope.queryOutputInvoiceResult = {
                list: [],
                pageInfo: {
                    totalCount: 0,
                    pageIndex: 1,
                    pageSize: 100,
                    totalPage: 0,
                }
            }
            $scope.curOutputInvoiceItemPage = 1;
        };

        //发票类型转换
        $scope.typeToString = function (strType) {
            var type = invoiceTypeEnum.Normal;
            switch (strType) {
                case 0:
                    type = invoiceTypeEnum.Normal;
                    break;
                case 1:
                    type = invoiceTypeEnum.Special;
                    break;
                default:
                    type = "";
            }
            return type;
        }

        //将选择了的查询条件显示在grid上方
        var doDataFilter = function (removeData) {

            //设置起止期间
            if ($scope.queryParams.periodStart > $scope.queryParams.periodEnd) {
                $scope.queryParams.periodEnd = $scope.queryParams.periodStart;
            }

            //设置需要去掉的查询条件的值为空
            if (!PWC.isNullOrEmpty(removeData)) {
                var removeItem = removeData.split("|");
                removeItem.forEach(function (v) {
                    $scope.queryParams[v] = null;

                    if ($scope.queryParams.invoiceType === null) {
                        $scope.InvoiceType.selected = undefined;
                    }
                });
            }

            //设置发票类型和认证结果
            if ($scope.InvoiceType.selected !== undefined)
                $scope.queryParams.invoiceType = $scope.InvoiceType.selected.id;
            else
                $scope.queryParams.invoiceType = null;

            // 将查询条件加入到grid上方
            var crits = $scope.queryParams;
            //定义查询条件数组用于存放已选的查询条件
            $scope.criteriaList = [];

            var crit = [];

            //日期
            if (!PWC.isNullOrEmpty(crits.invoiceDateStart) && !PWC.isNullOrEmpty(crits.invoiceDateEnd)) {
                if (new Date(crits.invoiceDateStart.replace(/[\.-]/g, '/')) > new Date(crits.invoiceDateEnd.replace(/[\.-]/g, '/'))) {
                    $scope.criteriaList = [];
                    SweetAlert.warning($translate.instant('InvoiceDateQueryError'));
                    return;
                }
                crit = new Object;
                crit.name = $translate.instant('InvoiceDate')+":" + crits.invoiceDateStart + "-" + crits.invoiceDateEnd;
                crit.valueFrom = crits.invoiceDateStart;
                crit.valueTo = crits.invoiceDateEnd;
                crit.propertyName = "invoiceDateStart|invoiceDateEnd";

                $scope.criteriaList.push(crit);
            }
            else if (!PWC.isNullOrEmpty(crits.invoiceDateStart) && PWC.isNullOrEmpty(crits.invoiceDateEnd)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceDate') + ":" + crits.invoiceDateStart + $translate.instant('After');
                crit.valueFrom = crits.invoiceDateStart;
                crit.valueTo = crits.invoiceDateEnd;
                crit.propertyName = "invoiceDateStart|invoiceDateEnd";

                $scope.criteriaList.push(crit);
            }
            else if (PWC.isNullOrEmpty(crits.invoiceDateStart) && !PWC.isNullOrEmpty(crits.invoiceDateEnd)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceDate') + ":" + crits.invoiceDateEnd + $translate.instant('Before');
                crit.valueFrom = crits.invoiceDateStart;
                crit.valueTo = crits.invoiceDateEnd;
                crit.propertyName = "invoiceDateStart|invoiceDateEnd";
                $scope.criteriaList.push(crit);
            }

            //发票代码
            if (!PWC.isNullOrEmpty(crits.classCode)) {
                crit = new Object;
                crit.name = $translate.instant('ClassCode') + ":" + PWC.limitString(crits.classCode, 10);
                crit.valueFrom = crits.classCode;
                crit.propertyName = "classCode";

                $scope.criteriaList.push(crit);
            }

            //发票号码
            if (!PWC.isNullOrEmpty(crits.invoiceNumber)) {
                crit = new Object;
                crit.name = $translate.instant('InvoiceNumber') + ":" + PWC.limitString(crits.invoiceNumber, 10);
                crit.valueFrom = crits.invoiceNumber;
                crit.propertyName = "invoiceNumber";

                $scope.criteriaList.push(crit);
            }

            //购方名称
            if (!PWC.isNullOrEmpty(crits.buyerName)) {
                crit = new Object;
                crit.name = $translate.instant('BuyerName') + ":" + PWC.limitString(crits.buyerName, 10);
                crit.valueFrom = crits.buyerName;
                crit.propertyName = "buyerName";

                $scope.criteriaList.push(crit);
            }

            //产品名称
            if (!PWC.isNullOrEmpty(crits.productName)) {
                crit = new Object;
                crit.name = $translate.instant('ProductName') + ":" + PWC.limitString(crits.productName, 10);
                crit.valueFrom = crits.productName;
                crit.propertyName = "productName";

                $scope.criteriaList.push(crit);
            }

            //发票类型
            if (!PWC.isNullOrEmpty(crits.invoiceType)) {
                crit = new Object;
                crit.valueFrom = _.find($scope.invoiceTypeList, function (v) {
                    return v.id === crits.invoiceType;
                }).name;
                crit.name = $translate.instant('InvoiceType') + ":" + crit.valueFrom;
                crit.propertyName = "invoiceType";

                $scope.criteriaList.push(crit);
            }

            //金额
            if (!PWC.isNullOrEmpty(crits.amountStart) && !PWC.isNullOrEmpty(crits.amountEnd)) {
                if (Number(crits.amountStart) > Number(crits.amountEnd)) {
                    $scope.criteriaList = [];
                    SweetAlert.warning($translate.instant('AmountQueryError'));
                    return;
                }
                crit = new Object;
                crit.name = $translate.instant('Amount') + ":" + PWC.limitString(crits.amountStart, 5) + "-" + PWC.limitString(crits.amountEnd, 5);
                crit.valueFrom = crits.amountStart;
                crit.valueTo = crits.amountEnd;
                crit.propertyName = "amountStart|amountEnd";

                $scope.criteriaList.push(crit);
            }
            else if (!PWC.isNullOrEmpty(crits.amountStart) && PWC.isNullOrEmpty(crits.amountEnd)) {
                crit = new Object;
                crit.name = $translate.instant('Amount') + ":" + PWC.limitString(crits.amountStart, 5) + $translate.instant('MoreThan');
                crit.valueFrom = crits.amountStart;
                crit.valueTo = crits.amountEnd;
                crit.propertyName = "amountStart|amountEnd";

                $scope.criteriaList.push(crit);
            }
            else if (PWC.isNullOrEmpty(crits.amountStart) && !PWC.isNullOrEmpty(crits.amountEnd)) {
                crit = new Object;
                crit.name = $translate.instant('Amount') + ":" + PWC.limitString(crits.amountEnd, 5) + $translate.instant('LessThan');
                crit.valueFrom = crits.amountStart;
                crit.valueTo = crits.amountEnd;
                crit.propertyName = "amountStart|amountEnd";

                $scope.criteriaList.push(crit);
            }

            //税额
            if (!PWC.isNullOrEmpty(crits.taxAmountStart) && !PWC.isNullOrEmpty(crits.taxAmountEnd)) {
                if (Number(crits.taxAmountStart) > Number(crits.taxAmountEnd)) {
                    $scope.criteriaList = [];
                    SweetAlert.warning($translate.instant('TaxAmountQueryError'));
                    return;
                }
                crit = new Object;
                crit.name = $translate.instant('TaxAmount') + ":" + PWC.limitString(crits.taxAmountStart, 5) + "-" + PWC.limitString(crits.taxAmountEnd, 5);
                crit.valueFrom = crits.taxAmountStart;
                crit.valueTo = crits.taxAmountEnd;
                crit.propertyName = "taxAmountStart|taxAmountEnd";

                $scope.criteriaList.push(crit);
            }
            else if (!PWC.isNullOrEmpty(crits.taxAmountStart) && PWC.isNullOrEmpty(crits.taxAmountEnd)) {
                crit = new Object;
                crit.name = $translate.instant('TaxAmount') + ":" + PWC.limitString(crits.taxAmountStart, 5) + $translate.instant('MoreThan');
                crit.valueFrom = crits.taxAmountStart;
                crit.valueTo = crits.taxAmountEnd;
                crit.propertyName = "taxAmountStart|taxAmountEnd";

                $scope.criteriaList.push(crit);
            }
            else if (!PWC.isNullOrEmpty(crits.taxAmountStart) && PWC.isNullOrEmpty(crits.taxAmountEnd)) {
                crit = new Object;
                crit.name = $translate.instant('TaxAmount') + ":" + PWC.limitString(crits.taxAmountEnd, 5) + $translate.instant('LessThan');
                crit.valueFrom = crits.taxAmountStart;
                crit.valueTo = crits.taxAmountEnd;
                crit.propertyName = "taxAmountStart|taxAmountEnd";

                $scope.criteriaList.push(crit);
            }

            // add to Criteria List for display on top of the grid:
            //********************************************************************************
            var criteria = JSON.stringify($scope.queryParams);
            if (browserService.isIE() || browserService.isEdge())
                criteria = encodeURIComponent(criteria);

            loadOutputInvoiceDataFromDB(1);
            $('.filter-button').popover("hide");
        };

        //去掉所有的查询条件，重新load数据
        var doDataFilterReset = function () {
            $scope.queryParams = {
                pageInfo: {},
                periodStart: '',
                periodEnd: '',
                invoiceDateStart: null,
                invoiceDateEnd: null,
                classCode: '',
                invoiceNumber: '',
                buyerName: '',
                productName: '',
                amountStart: null,
                amountEnd: null,
                invoiceType: null,
                taxAmountStart: null,
                taxAmountEnd: null
            };
            $scope.criteriaList = [];
            $scope.queryParams.periodStart = startMonth;
            $scope.queryParams.periodEnd = endMonth;
            loadOutputInvoiceDataFromDB(1);
            $('.filter-button').popover("hide");
        };

        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {
            //开票开始时间
            var ele1 = $("#invoiceDateStart");
            ele1.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            });
            ele1.datepicker("setDate", $scope.queryParams.invoiceDateStart);
            //开票结束时间
            var ele2 = $("#invoiceDateEnd");
            ele2.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: true,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            })
            ele2.datepicker("setDate", $scope.queryParams.invoiceDateEnd);


            //初始化已选择的发票类型和认证结果
            $scope.InvoiceType.selected = _.find($scope.invoiceTypeList, function (v) {
                return v.id == $scope.queryParams.invoiceType;
            })
        };

        //转换百分比
        $scope.decimalToPercent = function (data) {
            return (data * 100).toFixed(0) + "%";
        }

        //导出
        var doExport = function ()
        {
            vatPreviewService.getExportOutputInvoiceList($scope.queryParams).success(function (data, status, headers) {
                if(status===204){
                    SweetAlert.warning("没有数据可以下载");
                    return;
                }
                vatExportService.exportToExcel(data, status, headers, '销项发票信息.xlsx');
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //$scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
        //    export_table_to_excel('exportTable', 'OutputInvoice', 'xlsx', '');
        //});

        $scope.gridOptionsColumnDefs = [
            {
                name: $translate.instant('ImportErrorPopUpNoCol'), width: '5%',
                cellTemplate: '<div class="ui-grid-cell-contents" ><span>{{row.entity.index}}<span></div>'
            },
              {
                  name: $translate.instant('PeriodId'), width: '5%',
                  cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.periodID}}"><span>{{row.entity.periodID}}<span></div>'
              },
               {
                   name: $translate.instant('InvoiceDate'), width: '10%',
                   cellTemplate: '<div class="ui-grid-cell-contents" ><span>{{row.entity.invoiceDate | date:"yyyy-MM-dd"}}</span></div>'
               },
                 {
                     name: $translate.instant('InvoiceType'), width: '10%',
                     cellTemplate: '<div class="ui-grid-cell-contents" title="{{grid.appScope.typeToString(row.entity.invoiceType)}}"><span>{{grid.appScope.typeToString(row.entity.invoiceType)}}<span></div>'
                 },
              {
                  name: $translate.instant('ClassCode'), width: '10%',
                  cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.classCode}}"><span>{{row.entity.classCode}}<span></div>'
              },
              {
                  name: $translate.instant('InvoiceNumber'), width: '10%',
                  cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.invoiceNumber}}"><span>{{row.entity.invoiceNumber}}</span></div>'
              },
              {
                  name: $translate.instant('BuyerName'), width: '15%',
                  cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.buyerName}}"><span>{{row.entity.buyerName}}</span></div>'
              },
              {
                  name: $translate.instant('BuyerTaxNumber'), width: '15%',
                  cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.buyerTaxNumber}}"><span>{{row.entity.buyerTaxNumber}}</span></div>'
              },
              //{
              //    name: $translate.instant('BankAccount'), width: '10%',
              //    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.bankAccount}}"><span>{{row.entity.bankAccount}}</span></div>'
              //},
              //{
              //    name: $translate.instant('PhoneNum'), width: '8%',
              //    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.phoneNum}}"><span>{{row.entity.phoneNum}}</span></div>'
              //},
           {
               name: $translate.instant('Amount'), width: '8%', headerCellClass: 'right',
               cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.amount}}"><span>{{row.entity.amount}}</span></div>'
           },
            {
                name: $translate.instant('TaxAmount'), width: '8%', headerCellClass: 'right',
                cellTemplate: '<div class="ui-grid-cell-contents right"  title="{{row.entity.taxAmount}}"><span>{{row.entity.taxAmount}}</span></div>'
            }
        ];

        $scope.subGridOptionsColumnDefs = [
                {
                    name: $translate.instant('ImportErrorPopUpNoCol'), width: '5%',
                    cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.seqNo}}</span></div>'
                },
                {
                    name: $translate.instant('ProductName'),
                    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.productName}}"><span>{{row.entity.productName}}</span></div>'
                },
                {
                    name: $translate.instant('Quantity'),   headerCellClass: 'right',
                    cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.quantity}}"><span>{{row.entity.quantity}}</span></div>'
                },
                {
                    name: $translate.instant('UnitPrice'),   headerCellClass: 'right',
                    cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.unitPrice}}"><span>{{row.entity.unitPrice}}</span></div>'
                },
                {
                    name: $translate.instant('Amount'),   headerCellClass: 'right',
                    cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.amount}}"><span>{{row.entity.amount}}</span></div>'
                },
                {
                    name: $translate.instant('TaxRate'),  headerCellClass: 'right',
                    cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.taxRate}}"><span>{{((row.entity.taxRate) * 100).toFixed(0) + "%"}}</span></div>'
                },
                {
                    name: $translate.instant('TaxAmount'),  headerCellClass: 'right',
                    cellTemplate: '<div class="ui-grid-cell-contents right" title="{{row.entity.taxAmount}}"><span>{{row.entity.taxAmount}}</span></div>'
                },
             //{
             //    name: $translate.instant('CodeVersion'), width: '8%',
             //    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.codeVersion}}"><span>{{row.entity.codeVersion}}</span></div>'
             //},
             //{
             //    name: $translate.instant('DocumentNum'), width: '8%',
             //    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.documentNum}}"><span>{{row.entity.documentNum}}</span></div>'
             //},

             //{
             //    name: $translate.instant('ProductStandar'), width: '8%',
             //    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.productStandard}}"><span>{{row.entity.productStandard}}</span></div>'
             //},
             //{
             //    name: $translate.instant('Unit'), width: '8%',
             //    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.unit}}"><span>{{row.entity.unit}}</span></div>'
             //},
             //{
             //    name: $translate.instant('TaxClassCode'), width: '15%',
             //    cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.taxClassCode}}"><span>{{row.entity.taxClassCode}}</span></div>'
             //}
        ];

        (function initialize() {
            $log.debug('vatPreviewOutputInvoiceController.ctor()...');
            $scope.periodId = vatSessionService.month;

            //初始化month-picker
            $('#output-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
             .on('datePicker.done', function (e, result) {
                 //开始月份
                 startMonth = result[0][0];
                 //结束月份
                 endMonth = result[1][0];
                 $scope.queryParams.periodStart = startMonth;
                 $scope.queryParams.periodEnd = endMonth;

                 loadOutputInvoiceDataFromDB(1);
             });

            $scope.gridOptions = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                expandableRowTemplate: '<div ui-grid="row.entity.subGridOptions" style="height:150px;"></div>',
                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                enableSorting: false,
                enableColumnMenus: false,
                columnDefs: $scope.gridOptionsColumnDefs,

                onRegisterApi: function (gridApi) {
                    $scope.gridApi = gridApi;

                    //定义子table属性
                    gridApi.expandable.on.rowExpandedStateChanged($scope, function (row) {
                        if (row.isExpanded) {
                            row.entity.subGridOptions = {
                                rowHeight: constant.UIGrid.rowHeight,
                                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                                enableSorting: false,
                                enableColumnMenus: false,
                                columnDefs: $scope.subGridOptionsColumnDefs,
                            };
                            //获取子table数据
                            vatPreviewService.queryOutputInvoiceItemList(row.entity.invoiceID).success(function (data) {
                                if (data) {
                                    data.forEach(function (v) {
                                        v.unitPrice = PWC.round(v.unitPrice, 2);
                                        v.amount = PWC.round(v.amount, 2);
                                        v.taxRate = PWC.round(v.taxRate, 2);
                                        v.taxAmount = PWC.round(v.taxAmount, 2);
                                    });
                                    row.entity.subGridOptions.data = data;
                                }
                            });
                        }
                    });

                    $interval(function () {
                        $scope.gridApi.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);
                }
            };
            $scope.doDataFilter = doDataFilter;
            $scope.doDataFilterReset = doDataFilterReset;
            $scope.doExport = doExport;
            $scope.showPopover = showPopover;
            initPeriods();
            initOutputInvoicePagination();
            loadOutputInvoiceDataFromDB(1);
        })();
    }
]);
vatModule.directive('vatPreviewOutputInvoice', ['$log',
    function ($log) {
        'use strict';
        $log.debug('vatImportOutputInvoice.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/preview/vat-preview-output-invoice/vat-preview-output-invoice.html' + '?_=' + Math.random(),
            scope: {},
            controller: 'vatPreviewOutputInvoiceController',
            link: function (scope, element) {

            }
        };
    }
]);
vatModule.controller('vatAccountMappingController', ['$scope', '$log', '$timeout',
    '$q', '$translate', '$interval', 'loginContext', 'apiInterceptor', 'SweetAlert',
    'vatReductionService', 'vatSessionService', 'uiGridConstants', 'enums',
    'i18nService', 'BSPLService', 'vatCommonService', '$uibModal', 'commonWebService', 'vatOperationLogService',
    'vatImportService',
function ($scope, $log, $timeout, $q, $translate, $interval, loginContext, apiInterceptor,
    SweetAlert, vatReductionService, vatSessionService, uiGridConstants, enums,
    i18nService, BSPLService, vatCommonService, $uibModal, commonWebService, vatOperationLogService, vatImportService) {
    'use strict';
    $log.debug('vatAccountMappingController.ctor()...');
    var period = vatSessionService.month; //period < 0 覆盖导入时会删除所有数据
    var projectRuleId = 2; //todo: 应该在vatSessionService.project中获取
    var projectDbName = vatSessionService.project.dbName;
    var selectedRemapType = -1;
    //写日志
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    $scope.moduleid = enums.vatModuleEnum.Import_AccountMapping;
    $scope.periodId = vatSessionService.month;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        OperationObject: '',
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.periodId,
    };

    var stdDto = {
        id: '',
        acctProp: '',
        code: '',
        direction: '',
        fullName: '',
        hasChildren: false,
        name: '',
        parent: ''
    };

    //添加企业科目过滤下拉列表
    var InitFilterAccount = function () {
        var data = constant.espAccountFilter.data;
        data.forEach(function (row) {
            row.value = $translate.instant(row.value);
        });

        $scope.accountFilterList = data;
    };

    $scope.isSelected = function (id) {
        return $scope.filter.selected.indexOf(id) >= 0;
    };


    var showOperateLogPop = function () {
        $scope.isShowLog = true;
    }

    //检查用户机构权限
    var checkUserOrganizationPermissionList = function () {
        var list = [];
        var userManageTemp = constant.vatPermission.dataManage.accountMapping;
        list.push(userManageTemp.importCode);
        $scope.hasImportPermission = false;
        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
            $scope.hasImportPermission = data[userManageTemp.importCode];
        });
    };

    //初始化企业科目数据列表
    var InitEnterpriseSubject = function () {
        vatReductionService.mapStdCodeRecursiveByAccountList(period).success(function (or) {
            if (or.result) {
                var data = or.data;
                if (data === null) return;
                data.forEach(function (row) {
                    //row.directionStr = _.find($scope.directionList, function (num) {
                    //    return num.id === row.direction;
                    //}).name;
                    if (row.acctProp) {

                    }
                    if (row.acctLevel != null) {
                        row.$$treeLevel = parseInt(row.acctLevel - 1);
                    }

                    row.stdResult = getStdResult(row.stdCode, row.stdFullName);
                });

                $log.debug("InitEnterpriseSubject success");
                $log.debug(data);
                $scope.gridOptionsSubjectList.data = data;
                $scope.EnterpriceAccountList = data;
            }
        });
    };


    //切换筛选条件的时候，ng-check event will be triggered
    var stateChanged = function ($event, data) {
        $scope.filter.selected = [];
        $scope.filterConditionDesc = '';
        var checkbox = $event.target;
        if (checkbox.checked && $scope.filter.selected.indexOf(data.key) < 0) {
            $scope.filter.selected.push(data.key);
            $scope.filterConditionDesc = data.value;
        }

        accountFilterChanged();
    };

    //根据不同的状态过滤，未对应，已对应，借贷方向不一致等
    var accountFilterChanged = function () {
        var selectArr = $scope.filter.selected;
        var data = $scope.EnterpriceAccountList;
        var tempData = [];
        var key = $scope.filter.selected[0] || constant.espAccountFilter.key_0;

        switch (key) {
            //所有对应状态,取默认值
            case constant.espAccountFilter.key_0:
                tempData = data;
                break;
                //未对应
            case constant.espAccountFilter.key_1:
                tempData = _.filter(data, function (item) {
                    return item.stdCode == null;
                });
                break;
                //已对应
            case constant.espAccountFilter.key_2:
                tempData = _.filter(data, function (item) {
                    return item.stdCode != null;
                });
                break;
                //借贷方向不一致
            case constant.espAccountFilter.key_3:
                tempData = _.filter(data, function (item) {
                    return item.stdCode != null && item.stdCode != "-" && item.direction != 0
                        && item.stdDirection != null && item.directionDescription != item.stdDirection;
                });
                break;
                //科目类型不一致
            case constant.espAccountFilter.key_4:
                tempData = _.filter(data, function (item) {
                    return item.stdCode != null && item.stdCode != "-" && item.enterAcctProp != 0 && item.enterAcctProp != item.stdAcctProp;
                });
                break;
        }

        $scope.gridOptionsSubjectList.data = tempData;
    };


    ///根据标准科目code和name获取最终界面上应该显示的内容
    var getStdResult = function (stdCode, stdName) {
        var stdResult = stdCode === null ? $translate.instant('Unmapped') : (stdCode === "0000" ? "-" : stdCode + "-" + stdName);
        return stdResult;
    }

    //初始数据
    var InitNgData = function () {
        $scope.stdCollapsed = true;
        $scope.accountFilterList = [];
        //初始化选择器为空
        $scope.filter = {};
        $scope.filter.selected = [];
        //初始化企业科目筛选列表
        InitFilterAccount();
        //设置默认过滤条件为:所有对应状态
        var allMappStatus = constant.espAccountFilter.data[0];
        $scope.filter.selected.push(allMappStatus.key);
        $scope.filterConditionDesc = $translate.instant('AllMappingStatus');

        $timeout(function () {
            $scope.isLoadComplete = true;
        }, 500);
    }

    var getUITreeScope = function (uiTreeID) {
        return angular.element(document.getElementById(uiTreeID)).scope();
    };

    //如果没有全部展开，return false.
    var isExpandAll = function (uiTreeID) {
        var childNodes = getUITreeScope(uiTreeID).childNodes();

        var isCollapsed = function (c) {
            if (c.collapsed)
                return true;

            var childs = c.childNodes();

            for (var i = 0; i < childs.length; i++) {
                if (isCollapsed(childs[i])) {
                    return true;
                }
            }
            return false;
        }

        return !_.some(childNodes, isCollapsed);
    };


    //标准科目，单独展开或折叠
    var toggle1 = function (scope) {
        scope.toggle();
        if (scope.collapsed) {
            $scope.stdCollapsed = true;
        }
        else {
            //如果全部展开，最顶层也要展开
            if (isExpandAll('tree-root')) {
                $scope.stdCollapsed = false;
            }
        }
    };

    //标准科目，全部展开或折叠
    var toggleStdSubject = function () {
        $scope.stdCollapsed = !$scope.stdCollapsed;
        commonWebService.expandCollapseAll('vatStadardAccountTreeTable', $scope.stdCollapsed);
    }

    var updateParentEnterpriseAccount = function (parentMapingDict) {
        for (var key in parentMapingDict) {
            $scope.gridApiSubject.grid.rows.forEach(function (row) {
                if (row.entity.code === key) {
                    row.entity['stdCode'] = parentMapingDict[key][0];
                    row.entity['stdName'] = parentMapingDict[key][1];
                    row.entity['stdResult'] = getStdResult(parentMapingDict[key][0], parentMapingDict[key][2]);
                }
            });
        }
    };

    //当在取消或者手动对应之后更新界面
    //selectedRows: uigrid中当前选中的行集合
    //codeToUpdate: 需要将旧的代码设置为该code
    //nameToUpdate: 需要将旧的科目名称设置为该name
    var updateChildrenEnterpriseAccount = function (selectedRows, codeToUpdate, nameToUpdate) {
        //codeToUpdate = null && nameToUpdate = '': 取消对应
        if (!_.isNull(codeToUpdate) && nameToUpdate != '') {
            getStdCodeListRescurive();
        }

        var stdDto = _.where($scope.stdAccountList, { code: codeToUpdate })[0];
        selectedRows.forEach(function (v) {
            v['stdCode'] = codeToUpdate;
            v['stdName'] = nameToUpdate;
            v['stdResult'] = getStdResult(codeToUpdate, nameToUpdate);
            if (!_.isUndefined(stdDto)) {
                v['stdAcctProp'] = parseInt(stdDto.acctProp);
                v['stdCodeName'] = codeToUpdate + '/' + stdDto.fullName;
                v['stdDirection'] = stdDto.direction === "1" ? $translate.instant('StandardAccountDebit') : $translate.instant('StandardAccountCredit');
                v['stdFullName'] = stdDto.fullName;
            }

            //取消对应
            if (_.isNull(codeToUpdate) && nameToUpdate === '') {
                v['stdAcctProp'] = null;
                v['stdCodeName'] = null;
                v['stdDirection'] = null;
                v['stdFullName'] = null;
            }


            //找出该选中节点的所有子节点，然后复制，避免再次从数据库获取数据
            $scope.gridApiSubject.grid.rows.forEach(function (row) {
                if (row.entity.parent === v.code) {
                    row.entity['stdCode'] = codeToUpdate;
                    row.entity['stdName'] = nameToUpdate;
                    row.entity['stdResult'] = getStdResult(codeToUpdate, nameToUpdate);

                    //再次更新该row下面的子节点如果存在的话
                    updateChildrenMappedCodeNameRecursive($scope.gridApiSubject.grid.rows, row.entity['code'], codeToUpdate, nameToUpdate);
                }
            });
        });
    };

    var updateChildrenMappedCodeNameRecursive = function (rows, filterCode, codeToUpdate, nameToUpdate) {
        $scope.gridApiSubject.grid.rows.forEach(function (row) {
            if (row.entity.parent === filterCode) {
                row.entity['stdCode'] = codeToUpdate;
                row.entity['stdName'] = nameToUpdate;
                row.entity['stdResult'] = getStdResult(codeToUpdate, nameToUpdate);

                //再次更新该row下面的子节点如果存在的话
                updateChildrenMappedCodeNameRecursive($scope.gridApiSubject.grid.rows, row.entity['code'], codeToUpdate, nameToUpdate);
            }
        });
    }

    function getStatusByCurrentStatus(isSubmit) {
        if (!isSubmit &&
            (_.isEqual(vatSessionService.project.projectStatusList[period], constant.ProjectStatusEnum.Imported)
            || _.isEqual(vatSessionService.project.projectStatusList[period], constant.ProjectStatusEnum.AccountMapSubmitted))) {
            return constant.ProjectStatusEnum.Imported;
        }

        if (isSubmit &&
           (_.isEqual(vatSessionService.project.projectStatusList[period], constant.ProjectStatusEnum.Imported)
           || _.isEqual(vatSessionService.project.projectStatusList[period], constant.ProjectStatusEnum.AccountMapSubmitted))) {
            return constant.ProjectStatusEnum.AccountMapSubmitted;
        }

        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Generated) {
            return vatSessionService.project.projectStatusList[period];
        }
    }

    function doAutoMap() {
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = "";
        logDto.OriginalState = "";
        logDto.OperationName = $translate.instant('AutoMapping');
        logDto.OperationType = enums.vatLogOperationTypeEnum.AM_AutoMapping;

        vatReductionService.autoMap(projectRuleId, period).success(function (or) {
            if (or != null && or != undefined) {
                if (or.result) {
                    getEnterpriseAccountNotMapped();
                    var status = getStatusByCurrentStatus(false);
                    vatCommonService.setProjectStatus(projectDbName, period, status, constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.NotFinished);
                    logDto.UpdateState = $translate.instant('AccountMapSuccess');
                    vatOperationLogService.addOperationLog(logDto);
                    // mapping success
                    SweetAlert.success($translate.instant('AccountMapSuccess'));
                    InitEnterpriseSubject();
                }
                else {
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }
            }
            else {
                logDto.UpdateState = $translate.instant('AccountMapFailed');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.warning($translate.instant('AccountMapFailed'));
            }
        });
    }

    //自动对应
    var autoMap = function () {
        if (vatSessionService.project.projectStatusList[period] < constant.ProjectStatusEnum.Imported) {
            SweetAlert.warning($translate.instant('AutoMapWarning'));
        }

        if (vatSessionService.project.projectStatusList[period] === constant.ProjectStatusEnum.Imported) {
            doAutoMap();
        }

        if (vatSessionService.project.projectStatusList[period] > constant.ProjectStatusEnum.Imported) {
            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('IsConfirmToReMap').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doAutoMap();
                }
                else {
                    swal.close();
                }
            });
        }
    };


    function doClearMap() {
        var clearEnterpriseAccountCodes = [];
        var selectedRows = $scope.gridApiSubject.selection.getSelectedRows();
        var orignalStdCodeName = [];
        if (selectedRows.length === 0) {
            SweetAlert.warning($translate.instant('SelectOneAccountToClearMap'));
            return;
        }

        selectedRows.forEach(function (v) {
            clearEnterpriseAccountCodes.push(v['code']);
            orignalStdCodeName.push(v.stdResult);
        });


        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OriginalState = orignalStdCodeName.join(",");
        logDto.UpdateState = "";
        logDto.OperationContent = "";
        logDto.OperationName = $translate.instant('CancelMapping');
        logDto.OperationObject = clearEnterpriseAccountCodes.join(",");
        logDto.OperationType = enums.vatLogOperationTypeEnum.AM_CancelMapping;



        vatReductionService.clearMap(period, clearEnterpriseAccountCodes).success(function (or) {
            if (or != null && or != undefined) {
                if (or.result) {
                    getEnterpriseAccountNotMapped();
                    var status = getStatusByCurrentStatus(false);
                    vatCommonService.setProjectStatus(projectDbName, period, status, constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.NotFinished);
                    // clear mapping success
                    SweetAlert.success($translate.instant('ClearMapSuccess'));
                    //如果重新从数据库加载，数据会重新绑定然后感觉界面被刷新
                    updateChildrenEnterpriseAccount(selectedRows, null, '');
                    updateParentEnterpriseAccount(or.data);
                    //清除所有checkbox
                    $scope.gridApiSubject.selection.clearSelectedRows();
                    vatOperationLogService.addOperationLog(logDto);
                }
                else {
                    logDto.UpdateState = $translate.instant('ClearMapFailed');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }
            }
            else {
                logDto.UpdateState = $translate.instant('ClearMapFailed');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.warning($translate.instant('ClearMapFailed'));
            }
        });
    }

    //取消对应
    var ClearMap = function () {
        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.AccountMapSubmitted) {
            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('IsConfirmCancelMap').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doClearMap();
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            SweetAlert.warning($translate.instant('CancelMapWarning'));
            //doClearMap();
        }
    };

    function doMapStdAccount(code, name, acctProp, direction) {
        if (!$scope.hasImportPermission || $scope.isSubmitted) {
            if ($scope.isSubmitted) {
                $timeout(function () {
                    SweetAlert.warning($translate.instant('UndoAccountMapToMap'));
                }, 300)

            }
            return false;
        }
        var accountMap = {};
        var rowIndexArray = [];
        var isMapped = false;
        var isAcctPropMatched = false;
        var isDirectionMatched = false;

        accountMap.enterpriseAccountCodes = [];
        accountMap.standardAccountCode = code;

        var selectedRows = $scope.gridApiSubject.selection.getSelectedRows();
        if (selectedRows.length === 0) {
            SweetAlert.warning($translate.instant('SelectOneAccountToMap'));
            return;
        }

        var stdAcctProp = acctProp;
        var stdDirection = direction;
        var orignalStdCodeName = [];
        selectedRows.forEach(function (v) {
            accountMap.enterpriseAccountCodes.push(v['code']);
            var rowIndex = findIndexByKeyValue($scope.gridOptionsSubjectList.data, "code", v['code']);
            rowIndexArray.push(rowIndex);
            orignalStdCodeName.push(v.stdResult);
            var stdCode = v['stdCode'];
            var acctProp = v['enterAcctProp'].toString();
            var direction = v['direction'].toString();

            //判断企业科目是否已有对应的标准科目，如果有isMapped=true
            isMapped = !_.isNull(stdCode) ? true : false;

            //判断企业科目和标准科目的类型否一致，如果不一致，isAcctPropMatched=false
            if (acctProp !== -1 && !_.isNull(acctProp) && stdAcctProp !== acctProp) {
                isAcctPropMatched = false;
            }
            else {
                isAcctPropMatched = true;
            }

            //判断企业科目和标准科目的借贷方是否一致，如果不一致，isDirectionMatched=false
            if (stdDirection !== direction) {
                isDirectionMatched = false;
            }
            else {
                isDirectionMatched = true;
            }
        });

        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OriginalState = orignalStdCodeName.join(",");
        logDto.UpdateState = code + "-" + name;
        logDto.OperationContent = code;
        logDto.OperationName = $translate.instant('HandleMapping');
        logDto.OperationObject = accountMap.enterpriseAccountCodes.join(",");
        logDto.OperationType = enums.vatLogOperationTypeEnum.AM_ManualMapping;


        //如果已经map过
        if (isMapped) {
            msgboxOptions.text = $translate.instant('ComfirmToReMap');
            msgboxOptions.closeOnConfirm = isAcctPropMatched && isDirectionMatched ? true : false;
            SweetAlert.swal(msgboxOptions, function (isConfirm) {
                if (isConfirm) {
                    //如果科目类型不一致
                    if (!isAcctPropMatched) {
                        msgboxOptions.text = $translate.instant('ConfirmToMapForDiffAcctProp');
                        msgboxOptions.closeOnConfirm = isDirectionMatched ? true : false;
                        SweetAlert.swal(msgboxOptions, function (isConfirm) {
                            if (isConfirm) {
                                //如果科目类型一致，则判断借贷方向是否一致
                                if (!isDirectionMatched) {
                                    msgboxOptions.text = $translate.instant('ConfirmToMapForDiffDirection');
                                    msgboxOptions.closeOnConfirm = true;
                                    SweetAlert.swal(msgboxOptions, function (isConfirm) {
                                        if (isConfirm) {
                                            mapAccountParentChild(selectedRows, accountMap, code, name, logDto);
                                        } else {
                                            swal.close();
                                        }
                                    });
                                } else {
                                    mapAccountParentChild(selectedRows, accountMap, code, name, logDto);
                                }
                            } else {
                                swal.close();
                            }
                        });
                    }
                    else {
                        //如果借贷方向不一致
                        if (!isDirectionMatched) {
                            msgboxOptions.text = $translate.instant('ConfirmToMapForDiffDirection');
                            msgboxOptions.closeOnConfirm = true;
                            SweetAlert.swal(msgboxOptions, function (isConfirm) {
                                if (isConfirm) {
                                    mapAccountParentChild(selectedRows, accountMap, code, name, logDto);
                                } else {
                                    swal.close();
                                }
                            });
                        }
                        else {
                            mapAccountParentChild(selectedRows, accountMap, code, name, logDto);
                        }
                    }
                } else {
                    swal.close();
                }
            });
        }
        else {
            //如果没有map过，则判断科目类型是否一致
            if (!isAcctPropMatched) {
                msgboxOptions.text = $translate.instant('ConfirmToMapForDiffAcctProp');
                msgboxOptions.closeOnConfirm = isDirectionMatched ? true : false;
                SweetAlert.swal(msgboxOptions, function (isConfirm) {
                    if (isConfirm) {
                        //如果科目类型一致，则判断借贷方向是否一致
                        if (!isDirectionMatched) {
                            msgboxOptions.text = $translate.instant('ConfirmToMapForDiffDirection');
                            msgboxOptions.closeOnConfirm = true;
                            SweetAlert.swal(msgboxOptions, function (isConfirm) {
                                if (isConfirm) {
                                    mapAccountParentChild(selectedRows, accountMap, code, name, logDto);
                                } else {
                                    swal.close();
                                }
                            });
                        } else {
                            mapAccountParentChild(selectedRows, accountMap, code, name, logDto);
                        }
                    } else {
                        swal.close();
                    }
                });
            }
            else {
                //如果借贷方向不一致
                if (!isDirectionMatched) {
                    msgboxOptions.text = $translate.instant('ConfirmToMapForDiffDirection');
                    msgboxOptions.closeOnConfirm = true;
                    SweetAlert.swal(msgboxOptions, function (isConfirm) {
                        if (isConfirm) {
                            mapAccountParentChild(selectedRows, accountMap, code, name, logDto);
                        } else {
                            swal.close();
                        }
                    });
                } else {
                    mapAccountParentChild(selectedRows, accountMap, code, name, logDto);
                }
            }
        }
    };


    //手动对应，双击页面右侧的标准科目列表执行该事件
    var mapStdAccount = function (code, name, acctProp, direction) {
        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Imported) {
            if ($scope.manualMapAlter) {
                swal({
                    title: $translate.instant('WarningTitle'),
                    text: $translate.instant('IsConfirmToReMap').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
               function (isConfirm) {
                   if (isConfirm) {
                       $scope.manualMapAlter = false;
                       $timeout(function () {
                           doMapStdAccount(code, name, acctProp, direction);
                       }, 300);

                   }
                   else {
                       swal.close();
                   }
               });
            }
            else {
                $timeout(function () {
                    doMapStdAccount(code, name, acctProp, direction);
                }, 300);

            }

        }
        else {
            //doMapStdAccount(code, name, acctProp, direction);
            SweetAlert.warning($translate.instant('ManualMapWarning'));
        }
    };


    var findIndexByKeyValue = function (arrayToSearch, key, valueToSearch) {
        for (var i = 0; i < arrayToSearch.length; i++) {
            if (arrayToSearch[i][key] == valueToSearch) {
                return i;
            }
        }
        return null;
    };

    //弹出框的默认配置项
    var msgboxOptions = {
        title: $translate.instant('ConfirmToContinue'),
        text: $translate.instant('ComfirmToReMap'),
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#DD6B55",
        confirmButtonText: $translate.instant('Confirm'),
        cancelButtonText: $translate.instant('Cancel'),
        closeOnConfirm: false,
        closeOnCancel: true
    };

    var mapAccountParentChild = function (selectedRows, accountMap, code, name, logDtoValue) {
        vatReductionService.mapAccount(accountMap.standardAccountCode, period, accountMap.enterpriseAccountCodes).success(function (or) {
            if (or.result === true) {
                getEnterpriseAccountNotMapped();
                $scope.gridApiSubject.selection.clearSelectedRows();

                //如果重新从数据库加载，数据会重新绑定然后感觉界面被刷新
                updateChildrenEnterpriseAccount(selectedRows, code, name);
                //更新父级科目的状态
                updateParentEnterpriseAccount(or.data);
                var status = getStatusByCurrentStatus(false);
                vatCommonService.setProjectStatus(projectDbName, period, status, constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.NotFinished);
                if (!_.isNull(logDtoValue)) {
                    vatOperationLogService.addOperationLog(logDtoValue);
                }
                //SweetAlert.success($translate.instant('AccountMapSuccess'));
            }
            else {
                logDtoValue.UpdateState = $translate.instant('AccountMapFailed');
                if (!_.isNull(logDtoValue)) {
                    vatOperationLogService.addOperationLog(logDtoValue);
                }
                SweetAlert.warning($translate.instant(or.resultMsg).formatObj({ code: or.data.standardAccountCode }));
            }
        });
    };

    $scope.getGridHeight = function () {
        if ($scope.isLoadComplete) {
            return {
                height: $(".subject-corresponding-container #enterprizeAccount .subject-list-grid-warp").height() + "px"
            };
        }
    };


    //动态设定重分类明细grid的高度
    var getReclassificationItemGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $("#reclassification-item-wrapper").height();

            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return { height: (y - $('#topMenu').height()) + "px" };
            } else {
                return { height: '0px' };
            }
        }

        return {};
    };

    //单击企业科目代码，显示重分类grid明细
    var toggleReclassificationGridTab = function () {
        $scope.ImportErrorTag = !$scope.ImportErrorTag;

        // topIcon and content-resize gapBottom 15px
        if (!$scope.ImportErrorTag) {
            setErrorWrapCssDefault();
        } else {

            if (parseInt($('#content-resizer').css('bottom')) < 100) {
                $('#content-resizer').css('bottom', '130px');
                $('.reclassification-item-wrapper').css('height', '130px');
            }
        }
    };

    //重置重分类明细的位置
    var setErrorWrapCssDefault = function () {
        $('#content-resizer').css('bottom', '0px');
        $('.reclassification-item-wrapper').css('height', '0px');
    };

    //点击手工重分类事件
    var manualReclassificate = function () {
        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Imported) {
            $log.debug("start manualReclassificate");
            setAutoCompleteDataSource("reMapCustStdAutoComplete");
            selectedRemapType = enums.vatReMapType.ReMapCust;
            var selectedRows = $scope.gridApiSubject.selection.getSelectedRows();
            if (selectedRows.length !== 1) {
                SweetAlert.warning($translate.instant('SelectOneAccountToManualReclassificate'));
                return;
            }

            if (!isEnterpriseCodeLeafAcct()) {
                SweetAlert.warning($translate.instant('NotLeafEnterpriseCode'));
                return;
            }

            $scope.enterpriseCode = selectedRows[0].code;
            $scope.processTypeId = enums.processType.Add;
            initReMapCustModel(constant.Operation.Add, -1, null);
            logDto.OperationName = $translate.instant('AddCustRemap');
            logDto.OperationType = enums.vatLogOperationTypeEnum.AM_AddManualClass;
            logDto.OriginalState = "";
            $scope.remapTitle = $translate.instant('AccountMappingTitle') + "  " + selectedRows[0].codeNameDesc;
            resetCustRemapValidation();
            //$("#reMapCustStdAutoComplete").dxAutocomplete("instance").option("value", "");
            $scope.selectedStdCode = "";
            $('#manualReclassificationModal').modal('show');
        }
        else {
            SweetAlert.warning($translate.instant('RemapClickWarning'));
        }
    };

    //点击凭证重分类按钮事件
    var voucherReclassificate = function () {
        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Imported) {
            $log.debug("start voucherReclassificate");
            selectedRemapType = enums.vatReMapType.ReMapVoucher;
            setAutoCompleteDataSource("reMapStdAutoComplete");
            var selectedRows = $scope.gridApiSubject.selection.getSelectedRows();
            if (selectedRows.length !== 1) {
                SweetAlert.warning($translate.instant('SelectOneAccountToVoucherReclassificate'));
                return;
            }

            if (!isEnterpriseCodeLeafAcct()) {
                SweetAlert.warning($translate.instant('NotLeafEnterpriseCode'));
                return;
            }


            //清空重分类明细选择项
            $scope.gridApiReclassificationItem.selection.clearSelectedRows();
            $scope.enterpriseCode = selectedRows[0].code;
            $scope.processTypeId = enums.processType.Add;
            initReMapVoucherModel(constant.Operation.Add, null, -1);
            $scope.isSearching = true;
            logDto.OperationName = $translate.instant('AddVoucherReMap');
            logDto.OperationType = enums.vatLogOperationTypeEnum.AM_AddVoucherClass;
            logDto.OriginalState = "";
            $scope.remapTitle = $translate.instant('VoucherReclassificationTitle') + "  " + selectedRows[0].codeNameDesc;
            resetVoucerRemapValidation();
            //$("#reMapStdAutoComplete").dxAutocomplete("instance").option("value", "");        
            $scope.selectedStdCode = "";
            $('#voucherReclassificationModal').modal('show');
        }
        else {
            SweetAlert.warning($translate.instant('RemapClickWarning'));
        }
    };

    //企业科目单击事件
    var showReclassificationItemGrid = function (etsRow) {
        $log.debug("start showReclassificationItemGrid");
        if (parseInt($('#content-resizer').css('bottom')) < 100) {
            $('#content-resizer').css('bottom', '20px');
            $('.reclassification-item-wrapper').css('height', '20px');
        }

        initReMapVoucherModel(constant.Operation.Add, null, -1);
        initReMapCustModel(constant.Operation.Add, -1, null);
        var selectedRows = $scope.gridApiSubject.selection.getSelectedRows();
        $scope.enterpriseCode = selectedRows[0].code;
        getReMapItemByCode(etsRow.code);
    };


    function doSaveManualReclassification() {
        $log.debug("start saveManualReclassification");
        constructReMapCustModel(selectedRemapType);
        $log.debug($scope.editManualRModel);


        var stdDto = _.where($scope.stdAccountList, { code: $scope.editManualRModel.stdCode })[0];
        var updateStateStr = "";
        if (!_.isNull(stdDto)) {
            //var directStr = stdDto.direction === "1" ? $translate.instant('StandardAccountDebit') : $translate.instant('StandardAccountCredit');
            updateStateStr = stdDto.code + "-" + stdDto.fullName + ":"
                            + $translate.instant('AccountVoucher_Debit') + ":" + $scope.editManualRModel.reMapDebit + "  "
                            + $translate.instant('AccountVoucher_Credit') + ":" + $scope.editManualRModel.reMapCredit;
        }
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationObject = $scope.enterpriseCode;
        logDto.OperationContent = $scope.editManualRModel.reMapName;
        logDto.UpdateState = updateStateStr;


        vatReductionService.saveManualReclassification($scope.editManualRModel).success(function (or) {
            if (!_.isNull(or) && !_.isUndefined(or)) {
                if (or.result) {
                    $('#manualReclassificationModal').modal('hide');
                    getReMapItemByCode($scope.editManualRModel.code);
                    var status = getStatusByCurrentStatus(false);
                    vatCommonService.setProjectStatus(projectDbName, period, status, constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.NotFinished);
                    vatOperationLogService.addOperationLog(logDto);
                    InitEnterpriseSubject();
                    SweetAlert.success($translate.instant('CustReMappingSuccess'));
                }
                else {
                    logDto.UpdateState = $translate.instant('AccountReMappingFail');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }
            }
            else {
                logDto.UpdateState = $translate.instant('AccountReMappingFail');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.warning($translate.instant('AccountReMappingFail'));
            }

        });
    }

    //保存手工重分类数据
    var saveManualReclassification = function () {
        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.AccountMapSubmitted) {
            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('IsConfirmManualReClassify').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doSaveManualReclassification();
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doSaveManualReclassification();
        }
    };


    function doSaveVoucherReclassification() {
        $log.debug("start saveVoucherReclassification ");
        $scope.isSearching = false;
        constructReMapVoucherModel($scope.selectedVouchers, selectedRemapType, $scope.processTypeId);
        $log.debug($scope.editVoucherRModel);
        $log.debug($scope.selectedVouchers);

        var stdDto = _.where($scope.stdAccountList, { code: $scope.editVoucherRModel.stdCode })[0];
        var updateStateStr = "";
        if (!_.isNull(stdDto)) {
            //var directStr = stdDto.direction === "1" ? $translate.instant('StandardAccountDebit') : $translate.instant('StandardAccountCredit');
            updateStateStr = stdDto.code + "-" + stdDto.fullName + ":"
                            + $translate.instant('AccountVoucher_Debit') + ":" + $scope.editVoucherRModel.reMapDebit + "  "
                            + $translate.instant('AccountVoucher_Credit') + ":" + $scope.editVoucherRModel.reMapCredit;
        }
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationObject = $scope.enterpriseCode;
        logDto.OperationContent = $scope.editVoucherRModel.reMapName;
        logDto.UpdateState = updateStateStr;

        vatReductionService.saveVoucherReclassification($scope.editVoucherRModel).success(function (or) {
            if (!_.isNull(or) && !_.isUndefined(or)) {
                if (or.result) {
                    $('#voucherReclassificationModal').modal('hide');
                    getReMapItemByCode($scope.editVoucherRModel.code);
                    var status = getStatusByCurrentStatus(false);
                    vatCommonService.setProjectStatus(projectDbName, period, status, constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.NotFinished);
                    vatOperationLogService.addOperationLog(logDto);
                    InitEnterpriseSubject();
                    SweetAlert.success($translate.instant('VoucherReMappingSuccess'));
                }
                else {
                    logDto.UpdateState = $translate.instant('AccountReMappingFail');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }
            }
            else {
                logDto.UpdateState = $translate.instant('AccountReMappingFail');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.warning($translate.instant('AccountReMappingFail'));
            }
        });
    }

    //保存凭证重分类数据
    var saveVoucherReclassification = function () {
        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.AccountMapSubmitted) {
            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('IsConfirmVoucherReClassify').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    doSaveVoucherReclassification();
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            doSaveVoucherReclassification();
        }
    };


    //编辑重对应记录
    var editReMapItem = function () {
        $log.debug("editReMapItem");
        $log.debug($scope.selectedVouchers);
        $scope.isSearching = false;
        $scope.processTypeId = enums.processType.Edit;

        var selectedRows = $scope.gridApiReclassificationItem.selection.getSelectedRows();
        if (!_.isNull(selectedRows) && !_.isUndefined(selectedRows)) {
            if (selectedRows.length === 0) {
                SweetAlert.warning($translate.instant('AccountReMappingSelectOne'));
                return false;
            }
            $log.debug(selectedRows);
            var selectedRemapItem = selectedRows[0];
            var reMapTypeId = selectedRemapItem.reMappTypeId;
            if (reMapTypeId === enums.vatReMapType.ReMapVoucher) {
                $log.debug("edit voucher remap");
                $scope.isSearching = true;
                setAutoCompleteDataSource("reMapStdAutoComplete");
                if (_.isNull($scope.selectedVouchers) || $scope.selectedVouchers.length === 0) {
                    $scope.selectedVouchers = selectedRemapItem.vouchers;
                }

                var vStdDto = _.where($scope.stdAccountList, { code: selectedRemapItem.stdCode })[0];
                var vOriginalState = "";
                if (!_.isNull(vStdDto)) {
                    vOriginalState = vStdDto.code + "-" + vStdDto.fullName + ":"
                            + $translate.instant('AccountVoucher_Debit') + ":" + selectedRemapItem.remapDebit + "  "
                            + $translate.instant('AccountVoucher_Credit') + ":" + selectedRemapItem.remapCredit;
                }

                logDto.OperationName = $translate.instant('EditVoucherReMap');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AM_EditVoucherClass;
                logDto.OriginalState = vOriginalState;

                $log.debug($scope.selectedVouchers);
                $('#voucherReclassificationModal').modal('show');
            }

            if (reMapTypeId === enums.vatReMapType.ReMapCust) {
                $log.debug("edit cust remap");
                setAutoCompleteDataSource("reMapCustStdAutoComplete");
                initReMapCustModel(constant.Operation.Edit, enums.vatReMapType.ReMapCust, selectedRemapItem);

                var vCustStdDto = _.where($scope.stdAccountList, { code: selectedRemapItem.stdCode })[0];
                var vCustOriginalState = "";
                if (!_.isNull(vStdDto)) {
                    vCustOriginalState = vCustStdDto.code + "-" + vCustStdDto.fullName + ":"
                            + $translate.instant('AccountVoucher_Debit') + ":" + selectedRemapItem.remapDebit + "  "
                            + $translate.instant('AccountVoucher_Credit') + ":" + selectedRemapItem.remapCredit;
                }

                logDto.OperationName = $translate.instant('EditCustRemap');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AM_EditManualClass;
                logDto.OriginalState = vCustOriginalState;

                $('#manualReclassificationModal').modal('show');
            }
        }
    }

    //删除重对应记录
    var deleteReMapItem = function () {
        $log.debug("deleteReMapItem");
        var selectedRows = $scope.gridApiReclassificationItem.selection.getSelectedRows();
        $scope.processTypeId = enums.processType.Delete;
        if (selectedRows.length === 0) {
            SweetAlert.warning($translate.instant('AccountReMappingSelectOne'));
            return false;
        }

        if (!_.isNull(selectedRows) && !_.isUndefined(selectedRows)) {
            var selectedRemapItem = selectedRows[0];
            $log.debug(selectedRemapItem);
            deleteReMappingRecords(selectedRemapItem);
        }

    }


    //提交科目对应
    var submitAccountMap = function () {
        if (vatSessionService.project.projectStatusList[period] < constant.ProjectStatusEnum.Imported) {
            SweetAlert.warning($translate.instant('NotAllowSubmitAccountMap'));
            return false;
        }
        vatReductionService.submitAccountMapping(enums.vatReMapType.ReMapVoucher, enums.vatReMapType.ReMapCust).success(function (ret) {
            if (ret.result) {
                BSPLService.GenerateBSPL(vatSessionService.project.id, vatSessionService.month).success(function () {
                    $scope.isSubmitted = true;
                    var status = getStatusByCurrentStatus(true);
                    vatCommonService.setProjectStatus(projectDbName, period, constant.ProjectStatusEnum.AccountMapSubmitted
                                                      , constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.Finished);
                    SweetAlert.success($translate.instant('AccountMappingSubmitComplete'));
                }).error(function () {
                    SweetAlert.error('生成报表失败');
                });
            }
            else {
                SweetAlert.error($translate.instant('CallbackError').formatObj({ errorMsg: ret.resultMsg }));
            }
        });
    };


    //撤销科目对应
    var undoAccountMap = function () {

        //已提交状态时不用提醒直接撤销
        if (vatSessionService.project.projectStatusList[period] === constant.ProjectStatusEnum.AccountMapSubmitted) {
            $scope.isSubmitted = false;
            var status = getStatusByCurrentStatus(false);
            vatCommonService.setProjectStatus(projectDbName, period, status, constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.NotFinished);
            SweetAlert.success($translate.instant('UndoAccountMappingComplete'));
        }


        //到底已生成之后需要提醒确认之后再撤销
        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Generated) {
            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('IsConfirmUndoMap').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    $scope.isSubmitted = false;
                    var status = getStatusByCurrentStatus(false);
                    vatCommonService.setProjectStatus(projectDbName, period, status, constant.DictionaryDictKey.WFAccountMap, enums.FinishStatusEnum.NotFinished);
                    SweetAlert.success($translate.instant('UndoAccountMappingComplete'));
                }
                else {
                    swal.close();
                }
            });
        }
        else {
            $scope.isSubmitted = false;
        }
    }

    var onReMapGridRowSelectionChanged = function (entity) {
        $log.debug("onReMapGridRowSelectionChanged");
        $scope.reMappId = entity.remapId;
        $scope.reMapItem = entity;
        if (entity.reMappTypeId === enums.vatReMapType.ReMapVoucher) {
            selectedRemapType = enums.vatReMapType.ReMapVoucher;
            var selectedReMapRow = $scope.gridApiReclassificationItem.selection.getSelectedRows()[0];
            $log.debug(selectedReMapRow);
            if (!_.isNull(selectedReMapRow) && !_.isUndefined(selectedReMapRow)) {
                $scope.selectedVouchers = selectedReMapRow.vouchers;//当前选择的重对应记录关联的vouchers
                $log.debug($scope.selectedVouchers);
            }
            initReMapVoucherModel(constant.Operation.Edit, selectedReMapRow, enums.vatReMapType.ReMapVoucher);

        }

        if (entity.reMappTypeId === enums.vatReMapType.ReMapCust) {
            selectedRemapType = enums.vatReMapType.ReMapCust;
            initReMapCustModel(constant.Operation.Add, -1, null);
        }
    }


    var closeModal = function (e) {
        var buttonId = e.target.id;
        if (!_.isUndefined(buttonId) && !_.isNull(buttonId)) {
            if (_.isEqual(buttonId, "btnCloseStdReMapResult")) {
                $('#stdReMapResultModal').modal('hide');
            }

            if (_.isEqual(buttonId, "btnCloseVoucherRemap")) {
                $scope.isSearching = false;
            }

            if (_.isEqual(buttonId, "btnCloseVouchersDetail")) {
                $('#voucherDetailModal').modal('hide');
            }
        }
    }


    //获取标准科目重对应结果
    var getStdRemapResult = function () {
        //todo: period = -1 is only for test
        vatReductionService.getStdRemapResult(period).success(function (or) {
            if (!_.isUndefined(or) && !_.isNull(or)) {
                if (or.result) {
                    $log.debug("getStdRemapResult success");
                    if (!_.isUndefined(or.data) && !_.isNull(or.data)) {
                        $log.debug(or.data);
                        $scope.gridOptionsStdReMapResult.data = or.data;
                        $('#stdReMapResultModal').modal('show');
                    }
                }
                else {
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }

            }
            else {
                SweetAlert.warning($translate.instant('AccountReMappingFail'));
            }
        });
    }


    function setStdAccountIsLeaf(e) {
        var selectedCode = !_.isUndefined(e.selectedItem.code) ? e.selectedItem.code : e.selectedItem;
        var stdAccount = _.where($scope.stdAccountList, { code: selectedCode })[0];
        if (!_.isUndefined(stdAccount)) {
            $scope.stdAccountIsLeaf = !stdAccount.hasChildren;
        }
    }

    function isStdCodeLeafNode(codeValue) {
        var stdAccount = _.where($scope.stdAccountList, { code: codeValue })[0];
        if (!_.isUndefined(stdAccount)) {
            $scope.stdAccountIsLeaf = !stdAccount.hasChildren;
        }
    }

    function onSelectionChangedHandlerVoucherRemap(e) {
        setStdAccountIsLeaf(e);
        $scope.selectedStdCode = !_.isUndefined(e.selectedItem.code) ? e.selectedItem.code : e.selectedItem;
    }

    function onSelectionChangedHandlerCustRemap(e) {
        setStdAccountIsLeaf(e);
        $scope.selectedStdCode = !_.isUndefined(e.selectedItem.code) ? e.selectedItem.code : e.selectedItem;
    }


    function calcVoucherDebitCredit(vocuhers) {
        var sumDebit = 0.00;
        var sumCredit = 0.00;
        $.each(vocuhers, function (index, element) {
            sumDebit += PWC.parseFloatRound(element.debit, 2);
            sumCredit += PWC.parseFloatRound(element.credit, 2);
        });

        $scope.editVoucherRModel.reMapDebit = PWC.parseFloatRound(sumDebit.toString(), 2);
        $scope.editVoucherRModel.reMapCredit = PWC.parseFloatRound(sumCredit.toString(), 2);
    }


    //提交之前构建editVoucherRModel
    function constructReMapVoucherModel(selectedVouchers, reMapType, processTypeId) {
        var selectedRemapItem = $scope.gridApiReclassificationItem.selection.getSelectedRows()[0];
        var stdCode = "";
        if (!_.isNull(selectedRemapItem) && !_.isUndefined(selectedRemapItem)) {
            switch (processTypeId) {
                case enums.processType.Add:
                    stdCode = "";
                    break;
                case enums.processType.Edit:
                    stdCode = selectedRemapItem.stdCode;
                    break;
            }
        }

        $scope.editVoucherRModel = {
            //reMapId: !_.isUndefined(selectedRemapItem) ? selectedRemapItem.remapId : PWC.newGuid(),
            remapBatchId: !_.isUndefined(selectedRemapItem) ? selectedRemapItem.remapBatchId : PWC.newGuid(),
            code: $scope.enterpriseCode,
            stdCode: $scope.selectedStdCode,//$("#reMapStdAutoComplete").dxAutocomplete("instance").option("value"),
            reMapStdCode: stdCode,
            reMapName: $("#voucherName").val(),
            reMapDebit: PWC.round($("#voucherDebit").val(), 2),
            reMapCredit: PWC.round($("#voucherCredit").val(), 2),
            reMapReason: $("#voucherReason").val(),
            reMapTypeId: reMapType,
            reMapDateTime: new Date(),
            period: period,
            reMapProcessTypeId: processTypeId,
            vouchers: selectedVouchers
        };
    }

    //初始化凭证重分类的model:editVoucherRModel
    function initReMapVoucherModel(operation, reMapModel, reMapType) {
        $log.debug("initReMapVoucherModel");
        if (_.isEqual(operation, constant.Operation.Add)) {
            $scope.editVoucherRModel = {
                //reMapId: PWC.newGuid(),
                remapBatchId: PWC.newGuid(),
                code: $scope.enterpriseCode,
                stdCode: "",
                reMapStdCode: "",
                reMapName: "",
                reMapDebit: 0.00,
                reMapCredit: 0.00,
                reMapReason: "",
                reMapTypeId: reMapType,
                reMapDateTime: new Date(),
                period: period,
                reMapProcessTypeId: $scope.processTypeId,
                vouchers: _.isNull(reMapModel) || _.isUndefined(reMapModel) ? null : reMapModel.vouchers
            };
            $scope.selectedVouchers = null;
        }

        if (_.isEqual(operation, constant.Operation.Edit)) {
            $scope.editVoucherRModel = {
                //reMapId: reMapModel.remapId,
                remapBatchId: reMapModel.remapBatchId,
                code: $scope.enterpriseCode,
                stdCode: reMapModel.stdCode,
                reMapStdCode: reMapModel.stdCode,
                reMapName: reMapModel.reMappName,
                reMapDebit: reMapModel.remapDebit,
                reMapCredit: reMapModel.remapCredit,
                reMapReason: reMapModel.reMappReason,
                reMapTypeId: reMapType,
                reMapDateTime: new Date(),
                period: period,
                reMapProcessTypeId: $scope.processTypeId,
                vouchers: _.isNull(reMapModel) || _.isUndefined(reMapModel) ? null : reMapModel.vouchers
            };
            //$("#reMapStdAutoComplete").dxAutocomplete("instance").option("value", reMapModel.stdCode);
            $scope.selectedStdCode = reMapModel.stdCode;
        }
    }


    function constructReMapCustModel(reMapType) {
        $scope.editManualRModel = {
            code: $scope.enterpriseCode,
            stdCode: $scope.selectedStdCode,//$("#reMapCustStdAutoComplete").dxAutocomplete("instance").option("value"),
            reMapName: $("#manualName").val(),
            reMapDebit: PWC.round($("#manualDebitBal").val(), 2),
            reMapCredit: PWC.round($("#manualCreditBal").val(), 2),
            reMapReason: $("#manualReason").val(),
            reMapTypeId: reMapType,
            period: period
        };
    }


    //初始化手动重分类的model:editManualRModel
    //operation: 操作类型。 constant.Operation.Add: 添加操作； constant.Operation.Edit：编辑操作
    //reMapType: 重对应类型。永远为2
    //reMapItem: 选中的重对应数据。Add操作时为NULL
    function initReMapCustModel(operation, reMapType, reMapItem) {
        if (_.isEqual(operation, constant.Operation.Add)) {
            $scope.editManualRModel = {
                code: "",
                stdCode: "",
                reMapName: "",
                reMapDebit: 0.00,
                reMapCredit: 0.00,
                reMapReason: "",
                reMapTypeId: reMapType,
                period: period
            }
            $scope.selectedVouchers = null;
        }

        if (_.isEqual(operation, constant.Operation.Edit) && !_.isNull(reMapItem)) {
            $scope.editManualRModel = {
                code: reMapItem.acctCode,
                stdCode: reMapItem.stdCode,
                reMapName: reMapItem.reMappName,
                reMapDebit: reMapItem.remapDebit,
                reMapCredit: reMapItem.remapCredit,
                reMapReason: reMapItem.reMappReason,
                reMapTypeId: reMapType,
                period: period
            }
            //$("#reMapCustStdAutoComplete").dxAutocomplete("instance").option("value", reMapItem.stdCode);
            $scope.selectedStdCode = reMapItem.stdCode;
        }

    }


    //获取重对应结果（包含凭证信息）
    function getReMapItemByCode(estCode) {
        vatReductionService.getClassificationList(estCode).success(function (or) {
            if (!_.isNull(or) && !_.isUndefined(or)) {
                if (or.result) {
                    $log.debug(or.data);
                    $scope.gridOptionsReclassificationItem.data = or.data;
                    $log.debug("getReMapItemByCode assigned value finished");
                    $log.debug($scope.gridOptionsReclassificationItem.data);
                }
                else {
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }
            }
            else {
                SweetAlert.warning($translate.instant('AccountReMappingFail'))
            }

        });
    }


    function deleteReMappingRecords(model) {
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationObject = $scope.enterpriseCode;
        logDto.OperationContent = model.reMappName;
        logDto.OriginalState = "";

        var vStdDto = _.where($scope.stdAccountList, { code: model.stdCode })[0];
        var vUpdateState = "";
        if (!_.isNull(vStdDto) && !_.isUndefined(vStdDto)) {
            vUpdateState = vStdDto.code + "-" + vStdDto.fullName + ":"
                    + $translate.instant('AccountVoucher_Debit') + ":" + model.remapDebit + "  "
                    + $translate.instant('AccountVoucher_Credit') + ":" + model.remapCredit;
        }
        logDto.UpdateState = vUpdateState;

        if (model.reMappTypeId === enums.vatReMapType.ReMapVoucher) {
            logDto.OperationType = enums.vatLogOperationTypeEnum.AM_DeleteVoucherClass;
            logDto.OperationName = $translate.instant('DeleteVoucherRemap');
        }


        if (model.reMappTypeId === enums.vatReMapType.ReMapCust) {
            logDto.OperationType = enums.vatLogOperationTypeEnum.AM_DeleteManualClass;
            logDto.OperationName = $translate.instant('DeleteCustRemap');
        }

        vatReductionService.deleteReMappingRecords(model).success(function (or) {
            if (!_.isNull(or) && !_.isUndefined(or)) {
                if (or.result) {
                    getReMapItemByCode(model.acctCode);
                    vatOperationLogService.addOperationLog(logDto);
                    InitEnterpriseSubject();
                    SweetAlert.success($translate.instant('AccountReMappingSuccess'));

                }
                else {
                    logDto.UpdateState = $translate.instant('AccountReMappingFail');
                    vatOperationLogService.addOperationLog(logDto);
                    SweetAlert.warning($translate.instant(or.resultMsg));
                }
            }
            else {
                logDto.UpdateState = $translate.instant('AccountReMappingFail');
                vatOperationLogService.addOperationLog(logDto);
                SweetAlert.warning($translate.instant('AccountReMappingFail'));
            }
        });
    }


    function showReMapVouchers(entity) {
        $log.debug("showReMapVouchers");
        $log.debug(entity);
        if (!_.isUndefined(entity) && !_.isNull(entity)) {
            //重分类明细选中凭证
            if (!_.isNull(entity.vouchers) && !_.isUndefined(entity.vouchers)) {
                var remapVouchers = _.filter(entity.vouchers, function (v) {
                    var chk = _.find(entity.remapIdes, function (id) { return id === v.remapId; });
                    return chk;
                });
                $scope.gridOptionsVouchersDetail.data = remapVouchers;//entity.vouchers;
                $('#voucherDetailModal').modal('show');
            }
            else { //企业科目列表选中凭证                     
                vatReductionService.getVouchersByCode(entity.code, period).success(function (or) {
                    if (!_.isNull(or) && !_.isUndefined(or)) {
                        if (or.result) {
                            $scope.gridOptionsVouchersDetail.data = or.data;
                            $('#voucherDetailModal').modal('show');
                        }
                        else {
                            SweetAlert.warning($translate.instant(or.resultMsg));
                        }
                    }
                    else {
                        SweetAlert.warning($translate.instant('GetVoucherDetailsFail'));
                    }
                });

            }

        }
    }

    function getAllStdCodes(id) {
        var tree = $("#vatStadardAccountTreeTable").fancytree("getTree");
        var treeSourceData = tree.toDict(true);
        $scope.stdAccountList = [];
        $.each(treeSourceData.children, function (index, item) {
            $.each(item.children, function (index1, item1) {
                getChildStdCodes(item1, $scope.stdAccountList);
            })
        });
        $("#" + id).dxAutocomplete("instance").option("dataSource", $scope.stdAccountList);
    }

    function getChildStdCodes(stdParent, stdLists) {
        stdParent.data.directionDesc = stdParent.data.direction === "1" ? $translate.instant('AccountVoucher_Direction_Debit')
                                       : $translate.instant('AccountVoucher_Direction_Credit');
        stdLists.push(stdParent.data);
        if (!_.isNull(stdParent.children) && !_.isUndefined(stdParent.children)) {
            $.each(stdParent.children, function (index, item) {
                item.data.directionDesc = item.direction === "1" ? $translate.instant('AccountVoucher_Direction_Debit')
                   : $translate.instant('AccountVoucher_Direction_Credit');
                getChildStdCodes(item, stdLists);
            })
        }
    };

    function getStdCodeListRescurive() {
        var tree = $("#vatStadardAccountTreeTable").fancytree("getTree");
        var treeSourceData = tree.toDict(true);
        if ($scope.stdAccountList.length === 0) {
            $scope.stdAccountList = [];
            $.each(treeSourceData.children, function (index, item) {
                $.each(item.children, function (index1, item1) {
                    getChildStdCodes(item1, $scope.stdAccountList);
                })
            });
        }
    }

    function setAutoCompleteDataSource(id) {
        getStdCodeListRescurive();
        $("#" + id).dxAutocomplete("instance").option("dataSource", $scope.stdAccountList);
    }

    //获取未对应企业科目数量
    function getEnterpriseAccountNotMapped() {
        vatReductionService.getEnterpriseAccountNotMapped(vatSessionService.month).success(function (data) {
            $scope.notMappedCount = vatSessionService.enterpriseAccountNotMappedCount = data;
            $scope.$emit('notMappedCount', $scope.notMappedCount);
        });
    };


    //获取TB、ERP导入类型
    function getPeriodInfor() {
        vatImportService.getImportType(vatSessionService.project.id, period).success(function (data) {
            $scope.importTypeId = data;
            vatImportService.IsImportAuditAdjustOnly(vatSessionService.project.id, period).success(function (or) {
                if (or.result) {
                    $scope.isImportAuditAdjust = or.data;

                }
            });
        });
    }

    function isEnterpriseCodeLeafAcct() {
        var selectedRow = $scope.gridApiSubject.selection.getSelectedRows()[0];
        if (!_.isNull(selectedRow) && !_.isUndefined(selectedRow)) {
            if (selectedRow.isLeaf === 1) {
                return true;
            }
            else {
                return false;
            }
        }
    }

    //重置凭证重对应的valudation results
    function resetVoucerRemapValidation() {
        $scope.stdAccountIsLeaf = true;
        $scope.addVoucherReclassificationItem.$setPristine();
    }

    //重置手工重对应的valudation results
    function resetCustRemapValidation() {
        $scope.stdAccountIsLeaf = true;
        $scope.addReclassificationItem.$setPristine();
    }


    //通过科目的$$treeLevel来决定使用哪个class
    //cellTemplate :'<div class="text-align-left-padding ui-grid-cell-contents {{grid.appScope.rowLevel(row.entity)}}"><span>{{row.entity.codeNameDesc}}<span></div>'
    function rowLevel(row) {
        var cls = '';
        cls = 'rowLevel-' + row.$$treeLevel;
        return cls;
    }

    function getExportData() {
        var temp = [];
        var data = $scope.gridOptionsSubjectList.data;
        data.forEach(function (d) {
            var item = {};
            item.code = d.code;
            item.stdCode = d.stdCode;
            item.fullName = d.fullName;
            item.stdFullName = d.stdFullName;
            item.directionDescription = d.directionDescription;
            item.stdDirection = d.stdDirection;
            temp.push(item);
        });

        $scope.exportDataList = temp;
        $log.debug($scope.exportDataList);
    }


    function exportData() {
        getExportData();
        $scope.isToPrint = true;
    }


    (function initialize() {
        //初始化右侧标准科目的树,使用jquery fancytree的方式来显示树，所以需要用到ajax的方式
        var stdAccountUrl = '/AccountMapping/stdAccounts/getStdAccountHierarchy';
        commonWebService.initVATFancyTreeAjax('vatStadardAccountTreeTable', stdAccountUrl, mapStdAccount);
        getEnterpriseAccountNotMapped();

        $scope.stdAccountsCategories = [];
        $scope.stdAccountList = [];
        // i18nService.setCurrentLang("zh-cn");
        //默认显示科目重分类grid
        $scope.ImportErrorTag = true;
        //借贷方向
        $scope.directionList = [
                { id: 1, name: $translate.instant('StandardAccountDebit') },
                { id: -1, name: $translate.instant('StandardAccountCredit') }
        ];

        //标准科目类别
        $scope.acctPropList = [
            { id: 0, name: 'UnKnow' },
            { id: 1, name: $translate.instant('StandardAccountAcctPropAsset') },
            { id: 2, name: $translate.instant('StandardAccountAcctPropDebt') },
            { id: 3, name: $translate.instant('StandardAccountAcctPropCommon') },
            { id: 4, name: $translate.instant('StandardAccountAcctPropInterest') },
            { id: 5, name: $translate.instant('StandardAccountAcctPropCost') },
            { id: 6, name: $translate.instant('StandardAccountAcctPropProfitAndLoss') }
        ];

        //操作菜单选择框
        $scope.processMenuList = [
            //{ key: 'UnSelected', name: $translate.instant('AccountMappingMenuUnSelect') },
            { key: constant.AccountMappingProcessKey.Submit, name: $translate.instant('AccountMappingSubmit') },
            { key: constant.AccountMappingProcessKey.Undo, name: $translate.instant('AccountMappingUndo') }
        ];

        $scope.currentProcess = {};
        $scope.currentProcess.selected = {
            key: constant.AccountMappingProcessKey.UnSelected, name: $translate.instant('AccountMappingMenuUnSelect')
        };

        //********start 重对应autocomplete scope变量定义********

        $scope.maxStdCodeLength = constant.ReMapMaxLength.MaxStdCodeLength;
        $scope.autocompletePlaceholder = $translate.instant('MaxLengthTips').formatObj({ maxLength: $scope.maxStdCodeLength }) + "  "
                                         + $translate.instant("TypeStandardCode");
        $scope.autocompleteSearchModeStartsWith = "startswith";
        $scope.autocompleteSearchModeContains = "contains";
        $scope.maxTextLength = constant.ReMapMaxLength.MaxTextLength;
        $scope.maxRemarkLength = constant.ReMapMaxLength.MaxRemarkLength;
        $scope.regexNum = "/^(\-)?\d+(\.\d{1,2})?$/"; //带1-2位小数的正数或负数 需要在开头和结尾加'/'，不然会报Lexer error  
        $scope.stdAccountIsLeaf = true; //默认不展示错误提示
        $scope.onSelectionChangedHandlerCustRemap = onSelectionChangedHandlerCustRemap;
        $scope.onSelectionChangedHandlerVoucherRemap = onSelectionChangedHandlerVoucherRemap;


        //********end 重对应autocomplete scope变量定义********




        //企业科目列表grid
        $scope.gridOptionsSubjectList = {
            virtualizationThreshold: 50,
            enableColumnResizing: true,
            enableRowSelection: false,
            enableSelectAll: true,
            rowHeight: constant.UIGrid.rowHeight,
            enableRowHeaderSelection: true,
            modifierKeysToMultiSelect: true, //按住Ctrl才能多选 
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: true,
            enableFiltering: false,
            showTreeExpandNoChildren: false,
            enableFullRowSelection: false, //是否点击行任意位置后选中,默认为false
            multiSelect: true,// 是否可以选择多个,默认为true;
            columnDefs: [
                {
                    name: $translate.instant('CITProject'), headerCellClass: '', width: '25%', pinnedLeft: true,
                    cellTemplate: '<div class="text-align-left-padding ui-grid-cell-contents"><span>{{row.entity.codeNameDesc}}<span></div>'
                },
                {
                    name: $translate.instant('SubjectDirectionCol'), headerCellClass: '', width: '10%', pinnedLeft: true,
                    cellTemplate: '<div class="text-align-left-padding">'
                                  + '<span>{{row.entity.directionDescription}}</span></div>'
                },
                {
                    name: $translate.instant('SubjectTypeCol'), headerCellClass: '', width: '10%',
                    cellTemplate: '<div class="text-align-left-padding">'
                                 + ' <span>{{row.entity.acctPropStr}}</span></div>'
                },
                {
                    name: $translate.instant('DebitRelevantAmtCol'), headerCellClass: '', width: '20%',
                    cellTemplate: '<div class="text-align-right-padding">'
                                 + ' <span>{{row.entity.debitBal}}</span></div>'
                },
                {
                    name: $translate.instant('CreditRelevantAmtCol'), headerCellClass: '', width: '20%',
                    cellTemplate: '<div class="text-align-right-padding">'
                                 + ' <span>{{row.entity.creditBal}}</span></div>'
                },
                {
                    name: $translate.instant('DebitReclassificationCol'), headerCellClass: '', width: '15%',
                    cellTemplate: '<div class="text-align-right-padding">'
                                 + ' <span>{{row.entity.remapDebit}}</span></div>'
                },
                {
                    name: $translate.instant('CreditReclassificationCol'), headerCellClass: '', width: '15%',
                    cellTemplate: '<div class="text-align-right-padding">'
                                 + ' <span>{{row.entity.remapCredit}}</span></div>'
                },
                {
                    name: $translate.instant('StandardSubjectCol'), headerCellClass: '', width: '20%',
                    cellTemplate: '<div class="text-align-left-padding"><span title="{{row.entity.stdResult}}"><i class="material-icons map-status-flag" ng-if="row.entity.stdCode == null">flag</i>{{row.entity.stdResult}}</span></div>'
                },
                {
                    name: $translate.instant('RelatedVoucherCol'), headerCellClass: '', width: '10%',
                    cellTemplate: '<div class="text-align-left-padding" ng-click="grid.appScope.showReMapVouchers(row.entity)">'
                                  + ' <i class="fa fa-clipboard" style="color:#E84100;" aria-hidden="true" ng-if="row.entity.isShowVoucher"></i></div>'
                },
                {
                    name: $translate.instant('IsLeafCol'), headerCellClass: '', width: '15%', visible: false,
                    cellTemplate: '<div class="text-align-right-padding"><span>{{row.entity.isLeaf}}</span></div>'
                },
                {
                    name: $translate.instant('StdAcctPropCol'), headerCellClass: '', width: '15%', visible: false,
                    cellTemplate: '<div class="text-align-right-padding"><span>{{row.entity.stdAcctProp}}</span></div>'
                },
                {
                    name: $translate.instant('EnterAcctPropCol'), headerCellClass: '', width: '15%', visible: false,
                    cellTemplate: '<div class="text-align-right-padding"><span>{{row.entity.enterAcctProp}}</span></div>'
                },
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiSubject = gridApi;
                $scope.gridSelectCount = $scope.gridApiSubject.selection.getSelectedRows().length;
                var onRowsRenderedOff = gridApi.core.on.rowsRendered(null, function () {
                    onRowsRenderedOff(); // run once
                    PWC.triggerRowSelectOnClick('#etsGrid'); // requires '.ui-grid-canvas'
                });
                // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                //$interval(function () {
                //    $scope.gridApiSubject.core.handleWindowResize();
                //}, 500, 60 * 60 * 8);

                $interval(function () {
                    $scope.gridApiSubject.core.handleWindowResize();
                }, 500, 60 * 60 * 8);

                $scope.gridApiSubject.selection.on.rowSelectionChanged($scope, function (row) {
                    var msg = 'row selected ' + row.isSelected;
                    $log.debug(msg);
                    $log.debug(row);
                    if (row.isSelected) {
                        $scope.showReclassificationItemGrid(row.entity);
                    }
                });
            }
        };

        //重分类明细grid
        $scope.gridOptionsReclassificationItem = {
            virtualizationThreshold: 50,
            enableColumnResizing: true,
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
            enableRowSelection: true,
            enableSelectAll: false,
            enableRowHeaderSelection: false,
            enableFiltering: false,
            showTreeExpandNoChildren: false,
            multiSelect: false,
            columnDefs: [
                {
                    name: $translate.instant('ReclassificationIdCol'), headerCellClass: '', visible: false,
                    cellTemplate: '<div class="text-align-left-padding" ng-show = "false"><span>{{row.entity.remapId}}<span></div>'
                },
                {
                    name: $translate.instant('ReclassificationBatchIdCol'), headerCellClass: '', visible: false,
                    cellTemplate: '<div class="text-align-left-padding" ng-show = "false"><span>{{row.entity.remapBatchId}}<span></div>'
                },
                {
                    name: $translate.instant('ImportErrorPopUpNoCol'), width: '5%', headerCellClass: '',
                    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.num}}<span></div>'
                },
                {
                    name: $translate.instant('ReclassificationNameCol'), width: '15%', headerCellClass: '',
                    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.reMappName}}</span></div>'
                },
                {
                    name: $translate.instant('AdjustmentReasonCol'), width: '15%', headerCellClass: '',
                    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.reMappReason}}</span></div>'
                },
                {
                    name: $translate.instant('AccountReMappingCustomerCode'), headerCellClass: '', visible: false,
                    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.customerCode}}</span></div>'
                },
                {
                    name: $translate.instant('AccountReMappingDebit'), width: '15%', headerCellClass: '',
                    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.remapDebit}}</span></div>'
                },
                {
                    name: $translate.instant('AccountReMappingCredit'), width: '15%', headerCellClass: '',
                    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.remapCredit}}</span></div>'
                },
                {
                    name: $translate.instant('STANDARDProject'), width: '15%', headerCellClass: 'text-align-center',
                    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.stdCode}}</span></div>'
                    //cellTemplate: '<div class="text-align-left-padding"><span><i class="material-icons map-status-flag" ng-if="row.entity.etsCode === null">flag</i>{{row.entity.etsCode === null ? "未对应" : (row.entity.etsCode + "-" + row.entity.etsName)}}</span></div>'
                },
                {
                    name: $translate.instant('AccountReMappingType'), width: '10%', headerCellClass: 'text-align-center',
                    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.reMappTypeDesc}}</span></div>'
                    //cellTemplate: '<div class="text-align-left-padding"><span><i class="material-icons map-status-flag" ng-if="row.entity.etsCode === null">flag</i>{{row.entity.etsCode === null ? "未对应" : (row.entity.etsCode + "-" + row.entity.etsName)}}</span></div>'
                },
                {
                    name: $translate.instant('RelatedVoucherCol'), width: '10%', headerCellClass: '',
                    cellTemplate: '<div class="text-align-left-padding" ng-click="grid.appScope.showReMapVouchers(row.entity)"><span></span>'
                        + ' <i class="fa fa-clipboard" style="color:#E84100;" aria-hidden="true" ng-if = "row.entity.vouchers != null" ></i></div>'
                },
                //{
                //    name: $translate.instant('RelatedAttachmentCol'), width: '5%', headerCellClass: '',
                //    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.attachments}}</span></div>'
                //}
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiReclassificationItem = gridApi;
                // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                //$interval(function () {
                //    $scope.gridApiReclassificationItem.core.handleWindowResize();
                //}, 500, 60 * 60 * 8);


                $scope.gridApiReclassificationItem.selection.on.rowSelectionChanged($scope, function (row) {
                    var msg = 'row selected ' + row.isSelected;
                    $log.debug(msg);
                    $log.debug(row);
                    if (row.isSelected) {
                        $scope.onReMapGridRowSelectionChanged(row.entity);
                    }
                });

            }
        };


        //标准科目对应结果
        $scope.gridOptionsStdReMapResult = {
            virtualizationThreshold: 50,
            enableColumnResizing: true,
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            enableRowSelection: true,
            enableSelectAll: false,
            enableRowHeaderSelection: false,
            enableFiltering: false,
            showTreeExpandNoChildren: false,
            multiSelect: false,
            columnDefs: [
               {
                   name: $translate.instant('STANDARDProject'), headerCellClass: '', width: '15%',
                   cellTemplate: '<div class="text-align-left-padding" ><span>{{row.entity.stdCodeAndStdName}}</span></div>'
               },
               {
                   name: $translate.instant('FinalDebit'), headerCellClass: '', width: '15%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.stdDebitStr}}</span></div>'
               },
               {
                   name: $translate.instant('FinalCredit'), headerCellClass: '', width: '15%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.stdCreditStr}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_DataGrid_ColAcctCodeAndNameShow'), headerCellClass: '', width: '10%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.acctCodeAndAcctName}}</span></div>'
               },
               {
                   name: $translate.instant('DebitRelevantAmtCol'), headerCellClass: '', width: '10%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.debitStr}}</span></div>'
               },
               {
                   name: $translate.instant('CreditRelevantAmtCol'), headerCellClass: '', width: '10%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.creditStr}}</span></div>'
               },
               {
                   name: $translate.instant('DebitReclassificationCol'), headerCellClass: '', width: '10%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.remapDebitStr}}</span></div>'
               },
               {
                   name: $translate.instant('CreditReclassificationCol'), headerCellClass: '', width: '10%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.remapCreditStr}}</span></div>'
               },
               {
                   name: $translate.instant('ConfirmDebit'), headerCellClass: '', width: '10%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.acctRealDebitStr}}</span></div>'
               },
               {
                   name: $translate.instant('ConfirmCredit'), headerCellClass: '', width: '10%',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.acctRealCreditStr}}</span></div>'
               }
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiStdMapResult = gridApi;
                // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                $interval(function () {
                    $scope.gridApiStdMapResult.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        }


        //凭证信息
        $scope.gridOptionsVouchersDetail = {
            virtualizationThreshold: 50,
            enableColumnResizing: true,
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.NEVER,
            enableRowSelection: false,
            enableSelectAll: false,
            enableRowHeaderSelection: false,
            enableFiltering: false,
            showTreeExpandNoChildren: false,
            multiSelect: false,
            columnDefs: [
               {
                   name: $translate.instant('JournalQJ'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding" ><span>{{row.entity.period}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_DataGrid_ColDate'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.date | date:"yyyy-MM-dd"}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_DataGrid_ColGroup'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.group}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_DataGrid_ColVID'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.vid}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_DataGrid_ColSummary'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.summary}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_DataGrid_ColAcctCodeAndNameShow'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding" ><span>{{row.entity.acctCodeAndNameShow}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_DataGrid_ColStdCodeAndNameShow'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.stdCodeAndNameShow}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_Debit'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.debit}}</span></div>'
               },
               {
                   name: $translate.instant('AccountVoucher_Credit'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.credit}}</span></div>'
               },
               {
                   name: $translate.instant('AccountReMappingCustomerCode'), headerCellClass: '',
                   cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.customerCode}}</span></div>'
               }
               //{
               //    name: $translate.instant('itemID'), headerCellClass: '',
               //    cellTemplate: '<div class="text-align-left-padding"><span>{{row.entity.itemID}}</span></div>'
               //}                                         
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiVouchersDetail = gridApi;
                //$scope.gridApiVouchersDetail.core.handleWindowResize();
                // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                $interval(function () {
                    $scope.gridApiVouchersDetail.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        }



        //var editorValue = ko.observable("").extend({
        //    dxValidator: {
        //        validationRules: [{
        //            type: 'required',
        //            message: 'Specify this value'
        //        }]
        //    }
        //});

        //重对应 autocomplete配置
        $scope.dxAutocompleteOptions = {
            CustRemapAutocomplete: {
                dataSource: $scope.stdAccountList,
                minSearchLength: 1,
                maxItemCount: 7,
                searchTimeout: 50,
                placeholder: $scope.autocompletePlaceholder,
                valueExpr: 'code',
                searchExpr: 'code',
                focusStateEnabled: true,
                itemTemplate: 'acStdItemTemplate',
                //validationError: editorValue.dxValidator.validationError,
                onSelectionChanged: $scope.onSelectionChangedHandlerCustRemap,
                bindingOptions: {
                    maxLength: 'maxStdCodeLength',
                    searchMode: 'autocompleteSearchModeContains',
                    value: 'selectedStdCode'
                    //disabled: "!queryParams.selectors.accountCode.selected.id",                   

                }

            },

            VoucherRemapAutoComplete: {
                dataSource: $scope.stdAccountList,
                minSearchLength: 1,
                maxItemCount: 7,
                searchTimeout: 50,
                placeholder: $scope.autocompletePlaceholder,
                valueExpr: 'code',
                searchExpr: 'code',
                focusStateEnabled: true,
                itemTemplate: 'acStdItemTemplate',
                //validationError: editorValue.dxValidator.validationError,
                onSelectionChanged: $scope.onSelectionChangedHandlerVoucherRemap,
                bindingOptions: {
                    maxLength: 'maxStdCodeLength',
                    searchMode: 'autocompleteSearchModeContains',
                    value: 'selectedStdCode'
                    //disabled: "!queryParams.selectors.accountCode.selected.id",                   

                }
            }
        }


        $scope.popTheParentCode = function () {
            $scope.isShowStdFilter = true;
            $scope.selectedStdCode = "";
        }

        InitEnterpriseSubject();
        InitNgData();
        //默认隐藏重分类明细grid
        setErrorWrapCssDefault();
        getPeriodInfor();
        $scope.manualMapAlter = true; //手工对应时，“是否重新对应”的提示只出现一次

        $scope.stateChanged = stateChanged;

        $scope.autoMap = autoMap;

        $scope.ClearMap = ClearMap;

        $scope.toggle1 = toggle1;

        $scope.toggleStdSubject = toggleStdSubject;

        $scope.mapStdAccount = mapStdAccount;

        $scope.getReclassificationItemGridHeight = getReclassificationItemGridHeight;

        $scope.toggleReclassificationGridTab = toggleReclassificationGridTab;

        $scope.manualReclassificate = manualReclassificate;

        $scope.voucherReclassificate = voucherReclassificate;

        $scope.showReclassificationItemGrid = showReclassificationItemGrid;

        $scope.saveManualReclassification = saveManualReclassification;

        $scope.saveVoucherReclassification = saveVoucherReclassification;

        $scope.getStdRemapResult = getStdRemapResult;

        $scope.closeModal = closeModal;

        $scope.submitAccountMap = submitAccountMap;

        $scope.undoAccountMap = undoAccountMap;

        $scope.showOperateLogPop = showOperateLogPop;


        checkUserOrganizationPermissionList();
        initReMapVoucherModel(constant.Operation.Add, null, -1);
        initReMapCustModel(constant.Operation.Add, -1, null);

        $scope.showReMapVouchers = showReMapVouchers;
        $scope.rowLevel = rowLevel;
        $scope.editReMapItem = editReMapItem;
        $scope.deleteReMapItem = deleteReMapItem;
        $scope.onReMapGridRowSelectionChanged = onReMapGridRowSelectionChanged;
        $scope.enterpriseCode;//选中的企业科目代码    
        $scope.selectedVouchers;//凭证对应时选中的分录
        $scope.reMappId;//重对应明细记录的id
        $scope.isSubmitted = vatSessionService.project.projectStatusList[vatSessionService.month] <= constant.ProjectStatusEnum.Imported
                             ? false : true;
        $scope.isSearching = false;
        $scope.remapTitle = "";
        $scope.processTypeId = enums.processType.UnDefined;
        $scope.userId = vatSessionService.logUser.id;
        $scope.exportData = exportData;
        $scope.isToPrint = false;
        $scope.exportDataList = [];


        //watch $scope.selectedVouchers的长度变化
        $scope.$watch('selectedVouchers.length', function (newValue, oldValue) {
            $log.debug("start to watch selectedVouchers");
            $log.debug($scope.selectedVouchers);
            calcVoucherDebitCredit($scope.selectedVouchers);
        });

        $scope.$watch('selectedStdCode', function (newValue, oldValue) {
            isStdCodeLeafNode(newValue);
        });

        //执行exportData(),table: exportTable ng-repeat绘制完成后执行
        $scope.$on('ngRepeatFinished', function (ngRepeatFinishedEvent) {
            if ($scope.isToPrint) {
                export_table_to_excel('exportTable', 'AccountMapping', 'xlsx', '');
            }
            $scope.isToPrint = false;
        });


    })();
}
]);
vatModule.directive('vatAccountMapping', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatAccountMapping.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/reduction/vat-account-mapping/vat-account-mapping.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'vatAccountMappingController',
            link: function ($scope, $element, $attr) {
                Split(['#left-container', '#right-container'], {
                    //An array of initial sizes of the elements, specified as percentage values. Example: Setting the initial sizes to 25% and 75%.
                    sizes: [78, 22],
                    //An array of minimum sizes of the elements, specified as pixel values. Example: Setting the minimum sizes to 100px and 300px, respectively.
                    minSize: [750, 250],
                    onDragEnd: function () {
                        //$timeout(function () {
                        //    $rootScope.$broadcast(enums.vatEvent.layoutChanged, {});
                        //}, 700);
                    }
                });
                $scope.token = $('input[name="__RequestVerificationToken"]').val();

                //企业科目列表和标准科目列表切换
                $scope.SwitchAccount = function () {
                    $('.subject-corresponding-container').toggle();
                    $('.std-subject-container').toggle();
                };

                $(".filter-select").on("click", function (e) {
                    e.stopPropagation();
                });

                $scope.showFilter = function () {
                    if ($('.filter-select').is(":hidden")) {
                        $(".filter-select").show();
                    } else {
                        $(".filter-select").hide();
                    }

                    $(document).one("click", function () {
                        $(".filter-select").hide();
                    });
                    event.stopPropagation();
                };
            }
        };
    }
]);

vatModule.controller('vatCaculateDataController', ['$scope', '$log', '$timeout', '$q', '$translate', 'loginContext',
    'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', 'vatReductionService', 'vatSessionService', 'uiGridConstants',
    'enums', 'modelConfigurationService', 'vatReportService', 'vatCommonService', 'BSPLService', 'vatOperationLogService',
    'vatWorkflowService',
    function ($scope, $log, $timeout, $q, $translate, loginContext, apiInterceptor, Upload, dataImportService, SweetAlert,
        vatReductionService, vatSessionService, uiGridConstants, enums, modelConfigurationService, vatReportService, vatCommonService
        , BSPLService, vatOperationLogService, vatWorkflowService) {
        'use strict';
        $log.debug('vatCaculateDataController.ctor()...');

        var taskList = [];
        var fixedRef = [];
        $scope.period = vatSessionService.month;
        $scope.moduleid = enums.vatModuleEnum.Import_CalculateData;


        var initTasks = function () {

            var task = function (id, status, name) {
                this.id = id;
                this.name = _.isEmpty(name) ? $translate.instant(id) : name;
                this.status = status;
                this.text = $translate.instant(status);
            };
            task.prototype.doTask = function () {
                var _this = this;

                switch (_this.id) {
                    case 'GenerateStdTb':
                        //$q.all().then(function () {
                        //    var data = { result: true };
                        //    updateProgress(data, _this);
                        //}, function () {
                        //    taskError(_this);
                        //});
                        vatReductionService.submitAccountMappingNoLoading(enums.vatReMapType.ReMapVoucher, enums.vatReMapType.ReMapCust).success(function (data) {
                            updateProgress(data, _this);
                        }).error(function () {
                            taskError(_this);
                        });
                        break;
                    case 'GenerateFinanceReport':
                        //$q.all().then(function () {
                        //    var data = { result: true };
                        //    updateProgress(data, _this);
                        //}, function () {
                        //    taskError(_this);
                        //});
                        BSPLService.GenerateBSPLWithoutLoading(vatSessionService.project.id, vatSessionService.month).success(function () {
                            var data = { result: true };
                            updateProgress(data, _this);
                        }).error(function () {
                            taskError(_this);
                        });
                        break;
                    case 'CompareUnbilled':
                        //$q.all().then(function () {
                        //    var data = { result: true };
                        //    updateProgress(data, _this);
                        //}, function () {
                        //    taskError(_this);
                        //});
                        vatReductionService.CompareOutputInvoice(vatSessionService.month).success(function (data) {
                            data.result = true;
                            updateProgress(data, _this);
                        }).error(function () {
                            taskError(_this);
                        });
                        break;
                    case 'CaculateUnbilled':
                        //$q.all().then(function () {
                        //    var data = { result: true };
                        //    updateProgress(data, _this);
                        //}, function () {
                        //    taskError(_this);
                        //});
                        vatReductionService.CaculateUnbilled(vatSessionService.month, vatSessionService.project).success(function (data) {
                            data.result = true;
                            updateProgress(data, _this);
                        }).error(function () {
                            taskError(_this);
                        });
                        break;
                    case 'CaculateBuildinModel':
                        //$q.all().then(function () {
                        //    var data = { result: true };
                        //    updateProgress(data, _this);
                        //}, function () {
                        //    taskError(_this);
                        //});
                        modelConfigurationService.getModelResult(vatSessionService.project.id, enums.serviceType.VAT, vatSessionService.month).success(function (data) {
                            data.result = true;
                            updateProgress(data, _this);
                        }).error(function () {
                            taskError(_this);
                        });
                        break;
                    case 'CollectBuildinModelResult':
                        //$q.all().then(function () {
                        //    var data = { result: true };
                        //    updateProgress(data, _this);
                        //}, function () {
                        //    taskError(_this);
                        //});
                        modelConfigurationService.migrateModelResult(vatSessionService.project.organizationID, vatSessionService.project.year, vatSessionService.project.id, vatSessionService.project.serviceTypeID).success(function (data) {
                            data.result = true;
                            updateProgress(data, _this);
                        }).error(function () {
                            taskError(_this);
                        });
                        break;

                    case 'UpdateReportConfig':
                        //$q.all().then(function () {
                        //    var data = { result: true };

                        //    updateProgress(data, _this);

                        //}, function () {
                        //    taskError(_this);
                        //});
                        vatReportService.updateConfig(vatSessionService.project.id, true, vatSessionService.month).success(function (data) {
                            var data = { result: true };
                            updateProgress(data, _this);
                            //vatReportService.getTemplateReferences(vatSessionService.month).then(function (refData) {
                            //    if (refData && refData.data) {
                            //        // 初始化resolve列表
                            //        var newRefData = _.chain(refData.data).reject(function (x) {
                            //            return _.isEmpty(x.referenceFromTemplateID) || _.isEmpty(x.referenceToTemplateID);
                            //        }).map(function (x) {
                            //            return {
                            //                referFrom: x.referenceFromTemplateID,
                            //                referTo: x.referenceToTemplateID,
                            //                resolved: x.isResolved
                            //            };
                            //        }).value();
                            //        $scope.resolveRef.push.apply($scope.resolveRef, newRefData);
                            //    }

                            //    return $q.when(data);
                            //}).then(function () {
                            //    updateProgress(data, _this);
                            //});
                        }).error(function () {

                            taskError(_this);
                        });
                        break;
                    case 'CalculateKeyValue':
                        //$q.all().then(function () {
                        //    var data = { result: true };
                        //    updateProgress(data, _this);
                        //}, function () {
                        //    taskError(_this);
                        //});
                        vatReportService.calculateKeyValue(vatSessionService.project.id, vatSessionService.month).success(function (data) {
                            updateProgress(data, _this);
                        }).error(function () {
                            taskError(_this);
                        });
                        break;
                    default:
                        //$q.all().then(function () {
                        //    var data = { result: true };
                        //    updateProgress(data, _this);
                        //}, function () {
                        //    taskError(_this);
                        //});
                        //vatReportService.generate(vatSessionService.project.id, _this.id, true, vatSessionService.month, vatSessionService.logUser.ID).success(function (data) {
                        //    updateProgress(data, _this);
                        //}).error(function () {
                        //    taskError(_this);
                        //});
                        if (_.some($scope.resolveRef, function (x) {
                            return x.referFrom === _this.id || x.referTo === _this.id;
                        })) {
                            $q.when().then(function () {
                                $timeout(function () {
                                    var data = { result: true };
                                    updateProgress(data, _this, false);
                                }, 2000);
                            });
                        }
                        else {
                            vatReportService.generateAll(vatSessionService.project.id, true, vatSessionService.month, vatSessionService.logUser.ID).success(function (data) {
                                updateProgress(data, _this);
                            }).error(function () {
                                taskError(_this);
                            });
                        }
                        break;
                }
            };
            task.prototype.name = null;
            task.prototype.id = null;
            task.prototype.status = null;
            task.prototype.text = null;

            vatReportService.getTemplate(vatSessionService.project.id, constant.serviceType.VAT, vatSessionService.month).then(function (report) {
                var result = [];
                result.push({ name: $translate.instant('ProcessData'), items: [new task('GenerateStdTb', 'unstarted')] });
                result.push({ name: $translate.instant('ProcessData'), items: [new task('CompareUnbilled', 'unstarted')] });
                result.push({ name: $translate.instant('ProcessData'), items: [new task('CaculateUnbilled', 'unstarted'), new task('UpdateReportConfig', 'unstarted'), new task('GenerateFinanceReport', 'unstarted')] });
                //result[result.length - 1].items.forEach(function (t) { t.seqNo = result.length - 1 });

                fixedRef = [];
                if (report && report.data && report.data.data) {
                    result.push({
                        name: $translate.instant('GenerateReport'),
                        isReportTask: true,
                        items: _.map(report.data.data, function (x) {
                            return new task(x.templateId, 'unstarted', x.templateName);
                        })
                    });

                    // 从第二张报表开始添加依赖
                    for (var i = 1; i < report.data.data.length - 1; i++) {
                        fixedRef.push({
                            referFrom: report.data.data[i] && report.data.data[i].templateId,
                            referTo: report.data.data[i + 1] && report.data.data[i + 1].templateId,
                            resolved: false
                        });
                    }
                }

                result.push({ name: $translate.instant('CalculateKeyValue'), items: [new task('CalculateKeyValue', 'unstarted')] });
                result.push({ name: $translate.instant('BuildinModel'), items: [new task('CaculateBuildinModel', 'unstarted')] });
                result.push({ name: $translate.instant('ModelCollection'), items: [new task('CollectBuildinModelResult', 'unstarted')] });

                var i = 0;
                result.forEach(function (item) {
                    result[i].items.forEach(function (t) { t.seqNo = i });
                    i++;
                    taskList = taskList.concat(item.items);
                });

                $scope.tasks = result;
            });
        };

        function doStartCaculate() {
            $scope.readonly = true;
            $scope.resolveRef.length = 0;
            $scope.resolveRef.push({
                referFrom: 'UpdateReportConfig',
                referTo: 'CaculateUnbilled',
                resolved: false
            }, {
                referFrom: 'UpdateReportConfig',
                referTo: 'GenerateFinanceReport',
                resolved: false
            });
            fixedRef.forEach(function (r) {
                $scope.resolveRef.push(angular.copy(r));
            });
            taskList.forEach(function (t) {
                t.status = 'unstarted';
                t.text = $translate.instant(t.status);
            })
            $scope.tasks[0].items.forEach(function (t) {
                t.doTask();
                t.status = 'processing';
                t.text = $translate.instant(t.status);
            });
            writeLog($translate.instant('startCaculateData'), null);  
            //$scope.tasks[1].items.forEach(function (t) { t.doTask(); });
        }

        var startCaculate = function () {
            if (vatSessionService.project.projectStatusList[vatSessionService.month] >= constant.ProjectStatusEnum.Generated) {
                swal({
                    title: "warning!",
                    text: $translate.instant('IsConfirmReCalcuate').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[vatSessionService.month]) }),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                    function (isConfirm) {
                        if (isConfirm) {
                            doStartCaculate();
                        }
                        else {
                            swal.close();
                        }
                    });
            }
            else {
                doStartCaculate();
            }
        };

        var caculateProgress = function (task) {

            var completedCnt = taskList.filter(function (t) {
                return (t.status === 'completed' || t.status === 'error');
            }).length;
            $scope.progress = PWC.round(completedCnt / taskList.length * 100, 0);
            if (!_.isEmpty($scope.resolveRef)) {
                var resolveTasks = _.where($scope.resolveRef, { referFrom: task.id });
                resolveTasks.forEach(function (x) {
                    x.resolved = true;
                });
            }

            var finish = $scope.tasks[task.seqNo].items.every(function (t) {
                    return t.status === 'completed' || t.status === 'error';
                });

            //上一个任务完成
            if (finish && task.seqNo < $scope.tasks.length - 1) {
                var unstarted = $scope.tasks[task.seqNo + 1].items.every(function (t) {
                        return t.status === 'unstarted';
                    });
                if (unstarted) {
                    var readyTasks;
                    if (!_.isEmpty($scope.resolveRef)) {
                        readyTasks = _.reject($scope.tasks[task.seqNo + 1].items, function (t) {
                            return _.some($scope.resolveRef, function (x) {
                                return !x.resolved && x.referTo === t.id;
                            });
                        });
                    }
                    else {
                        readyTasks = $scope.tasks[task.seqNo + 1].items;
                    }
                    readyTasks.forEach(function (t) {
                        t.doTask();
                        t.status = 'processing';
                        t.text = $translate.instant(t.status);
                    });
                }
            }
            //查找任务中剩余子任务进行处理
            else {
                var unstarted = _.filter($scope.tasks[task.seqNo].items, function (t) {
                        return t.status === 'unstarted';
                    });
                if (unstarted.length > 0) {
                    var readyTasks;
                    if (!_.isEmpty($scope.resolveRef)) {
                        readyTasks = _.reject(unstarted, function (t) {
                                return _.some($scope.resolveRef, function (x) {
                                    return !x.resolved && x.referTo === t.id;
                                });
                            });
                    } else {
                        readyTasks = unstarted;
                    }
                    readyTasks.forEach(function (t) {
                        t.doTask();
                        t.status = 'processing';
                        t.text = $translate.instant(t.status);
                    });
                }
            }
  
            $scope.readonly = taskList.some(function (t) {
                return t.status !== 'completed' && t.status !== 'error';
            });

            if (!$scope.readonly) {
                vatCommonService.setProjectStatus(vatSessionService.project.dbName, vatSessionService.month, constant.ProjectStatusEnum.Generated
                    , constant.DictionaryDictKey.WFDataProcess, enums.FinishStatusEnum.Finished);
            }
        };

        var updateProgress = function (data, task, ifWriteLog) {
            if (data && data.result) {
                task.status = 'completed';
                task.text = $translate.instant(task.status);
            }
            else {
                task.status = 'error';
                task.text = $translate.instant(task.status);
                //SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            }
            caculateProgress(task);
            if (ifWriteLog === undefined || ifWriteLog) {
            writeLog(task.name, task.text);
            }
            //sendMessage(task);
        };

        var taskError = function (task) {
            task.status = 'error';
            task.text = $translate.instant(task.status);
            caculateProgress(task);
            writeLog(task.name, task.text);
            sendMessage(task);
            //SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        };

        $scope.showOperateLogPop = function () {
            $scope.isShowLog = true;
        };

        var writeLog = function (taskName, status) {
            var logDto = {};
            logDto.ModuleID = $scope.moduleid;
            logDto.CreatorID = vatSessionService.logUser.ID;
            logDto.OperationObject = $translate.instant('vatCaculateDataDesc');
            logDto.Comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
            logDto.Period = vatSessionService.month;

            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = taskName;
            logDto.OperationName = taskName;
            logDto.OperationType = enums.vatLogOperationTypeEnum.CalculateData;
            logDto.UpdateState = status == null ? '' : status;
            vatOperationLogService.addOperationLog(logDto);

        };

        var sendMessage = function (task) {
            var msgDto = {};
            msgDto.DbName = vatSessionService.project.dbName;
            msgDto.NodeDictKey = constant.DictionaryDictKey.DataProcess;
            msgDto.TaskDictKey = constant.DictionaryDictKey.WFDataProcess;
            msgDto.ExceptionDateTime = new Date();
            msgDto.ExceptionMessageDetails = [];

            var msgDetailDto = {};
            msgDetailDto.PeriodId = vatSessionService.month;
            msgDetailDto.ExceptionIssueTitle = constant.WorkflowMessage.Issue;
            msgDetailDto.ExceptionIssueValue = constant.WorkflowMessage.ExceptionIssueValue;
            msgDetailDto.ProcessDataDtTitle = constant.WorkflowMessage.CalDateTime;
            msgDetailDto.ProcessDataDtValue = new Date();
            msgDetailDto.ExceptionDetailTitle = constant.WorkflowMessage.MessageDetail;
            msgDetailDto.ExceptionDetailValue = task.name + task.text;

            msgDto.ExceptionMessageDetails.push(msgDetailDto);
            vatWorkflowService.addExceptionMessage(msgDto);
        };

        (function initialize() {
            $scope.readonly = false;
            $scope.progress = 0;
            $scope.resolveRef = [];
            initTasks();
            $scope.startCaculate = startCaculate;

        })();
    }
]);

vatModule.directive('vatCaculateData', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatCaculateData.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/reduction/vat-caculate-data/vat-caculate-data.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'vatCaculateDataController',
            link: function ($scope, $element, $attr) {
                $scope.token = $('input[name="__RequestVerificationToken"]').val();
            }
        };
    }
]);
vatModule.controller('vatGoodsMappingController', ['$scope', '$log', '$timeout', '$q', '$translate', 'loginContext', 'apiInterceptor', 'SweetAlert', 'vatSessionService', 'uiGridConstants', 'enums', 'vatReductionService', 'vatOperationLogService',
function ($scope, $log, $timeout, $q, $translate, loginContext, apiInterceptor, SweetAlert, vatSessionService, uiGridConstants, enums, vatReductionService, vatOperationLogService) {
    'use strict';
    $log.debug('vatGoodsMappingController.ctor()...');

    var isDouble = 0;
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    //写日志
    $scope.period = vatSessionService.month;
    $scope.moduleid = enums.vatModuleEnum.Import_GoodsMapping;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        OperationObject: '',
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.period,
    };

    $scope.mappingList = [];
    $scope.stdGoodsList = [
            { StdId: 1, StdName: $translate.instant('GP_TransportationService') },
            { StdId: 2, StdName: $translate.instant('GP_TelecomService') },
            { StdId: 3, StdName: $translate.instant('GP_BuildService') },
            { StdId: 4, StdName: $translate.instant('GP_EstateLeasingService') },
            { StdId: 5, StdName: $translate.instant('GP_LandUseRight') },
            { StdId: 6, StdName: $translate.instant('GP_FinancialService') },
            { StdId: 7, StdName: $translate.instant('GP_LifeService') },
            { StdId: 8, StdName: $translate.instant('GP_InvisibleCapital') },
            { StdId: 9, StdName: $translate.instant('GP_TangibleMovablesService') },
            { StdId: 10, StdName: $translate.instant('GP_GoodsAndRepairService') },
            { StdId: 11, StdName: $translate.instant('Other') }
    ];

    //匹配结果
    $scope.gridLeftOptions = {
        columns: [{ caption: $translate.instant('CustGoodsName'), dataField: "custGoodsName", alignment: 'left', },
              { caption: $translate.instant('StdGoodsName'), dataField: "stdGoodsName", alignment: 'left', }, ],
        bindingOptions: { "dataSource.store.data": "mappingList", },
        dataSource: { store: { type: "array", key: 'id' } },
        selection: { mode: "multiple", showCheckBoxesMode: "always", },
        hoverStateEnabled: true,
        scrolling: { mode: "virtual" },
        noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText')
        //remoteOperations: { sorting: true, paging: false }, 
        //onSelectionChanged: function (selectedItems) { 
        //    var data = selectedItems.selectedRowsData;
        //    $scope.selectMappIds = [];
        //    if (data.length > 0) {
        //        data.forEach(function (v) {
        //            $scope.selectMappIds.push(v.id);
        //        }); 
        //    }
        //}
    }

    //标准货物名称
    $scope.gridRightOptions = {
        columns: [{
            caption: $translate.instant('StdGoodsNameList'),
            dataField: "StdName",
            alignment: 'left',
        }],
        bindingOptions: {
            "dataSource.store.data": "stdGoodsList"
        },
        dataSource: {
            store: { type: "array", key: 'StdId' }
        },
        remoteOperations: { sorting: true, paging: false },
        hoverStateEnabled: true,

        onRowPrepared: function (e) {
            if (e.rowType == "header") {
                e.rowElement.css("display", 'none');
            }
        },
        onCellClick: function (e) {
            isDouble++;
            setTimeout(function () {
                if (isDouble == 2) {
                    if ($scope.hasEditPermission)
                    {
                        doGoodsMapping(e.value);
                    }                   
                }
                isDouble = 0;
            }, 500);
        }
    }
    var doGoodsMapping = function (value) {
        var dataGrid = $('#gridLeft').dxDataGrid("instance");
        if (dataGrid.getSelectedRowsData().length > 0) {
            var modifyList = [];
            var customerList = [];
            var stdList = [];
            var originalList = [];
            dataGrid.getSelectedRowsData().forEach(function (m) {
                stdList.push(m.stdGoodsName);
                originalList.push(m.custGoodsName + "-" + m.stdGoodsName);
                customerList.push(m.custGoodsName);
                var mapp = m;
                mapp.stdGoodsName = value;
                modifyList.push(mapp);
            });

            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            if (PWC.isNullOrEmpty(value)) {
                //取消对应
                logDto.OperationObject = customerList.join(",");
                logDto.OperationContent = value;
                logDto.OperationName = $translate.instant('CancelMapping');
                logDto.OperationType = enums.vatLogOperationTypeEnum.GM_CancelMapping;
                logDto.OriginalState = originalList.join(",");
                logDto.UpdateState = customerList.join(",");
            }
            else {
                //手动对应
                logDto.OperationObject = customerList.join(",");
                logDto.OperationContent = stdList.join(",");
                logDto.OperationName = $translate.instant('HandleMapping');
                logDto.OperationType = enums.vatLogOperationTypeEnum.GM_ManualMapping;
                logDto.OriginalState = customerList.join(",");
                logDto.UpdateState = customerList.join(",") + "-" + value;
            }

            vatReductionService.updateGoodsMapping(modifyList).success(function (result) {
                if (result) {
                    vatOperationLogService.addOperationLog(logDto);

                    initGoodsMappingFromDB();
                    dataGrid.refresh();
                    dataGrid.clearSelection();
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }
        else {
            SweetAlert.warning($translate.instant('SelectMappTips'));
        }
    }

    var cancelGoodsMapping = function () {
        doGoodsMapping("");
    }

    function initGoodsMappingFromDB() {
        vatReductionService.getGoodsMappingList().success(function (data) {
            if (data && data.length > 0) {
                $scope.mappingList = data;
            }
        }).error(function () {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }

    //日志
    $scope.showOperateLogPop = function () {
        $scope.isShowLog = true;
    };

    var getUserPermission = function () {

        var list = [];

        var code = constant.vatPermission.dataManage.goodsMapping.saveCode; 
        list.push(code);

        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
            $scope.hasEditPermission = data[code];
        });
    };

    (function initialize() {
        $log.debug('vatGoodsMappingController.ctor()...');
        getUserPermission();
        $scope.cancelGoodsMapping = cancelGoodsMapping;
        initGoodsMappingFromDB();

    })();
}
]);
vatModule.directive('vatGoodsMapping', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatGoodsMapping.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/reduction/vat-goods-mapping/vat-goods-mapping.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'vatGoodsMappingController',
            link: function ($scope, $element, $attr) {
                $scope.token = $('input[name="__RequestVerificationToken"]').val();
            }
        };
    }
]);
vatModule.controller('vatUnbilledInvoiceController', ['$scope', '$log', '$timeout', '$q', '$translate','$interval', 'loginContext', 'apiInterceptor', 'SweetAlert', 'vatSessionService', 'uiGridConstants', 'enums', 'vatReductionService',
function ($scope, $log, $timeout, $q, $translate, $interval, loginContext, apiInterceptor, SweetAlert, vatSessionService, uiGridConstants, enums, vatReductionService) {
    'use strict';
    $log.debug('vatUnbilledInvoiceController.ctor()...');

    $scope.period = vatSessionService.month;
    $scope.ImportErrorTag = true;
    $scope.TotalDebitAmount = 0;
    $scope.TotalCreditAmount = 0;
    $scope.TotalAmount = 0;
    $scope.TotalTaxAmount = 0;
    $scope.MapTotalDebitAmount = 0;
    $scope.MapTotalCreditAmount = 0;
    $scope.MapTotalAmount = 0;
    $scope.MapTotalTaxAmount = 0;

    $scope.voucherSearchTypeList = [
        { id: 10, name: $translate.instant('Enum_UnBilled') },
        { id: 20, name: $translate.instant('Enum_PartBilled') },
       { id: 30, name: $translate.instant('Enum_Billed') },
    ];
    $scope.invoiceSearchTypeList = [
       { id: 40, name: $translate.instant('Enum_NotAccounting') },
       { id: 50, name: $translate.instant('Enum_PartAccounting') },
        { id: 60, name: $translate.instant('Enum_Accounting') },
    ];
    $scope.voucherSearchType = {};
    $scope.invoiceSearchType = {};
    $scope.tranCode = "";
    $scope.IsVoucher = true;

    //发票类型
    var invoiceTypeEnum = {
        Normal: $translate.instant('Normal'),
        Special: $translate.instant('Special')
    };
    //发票类型转换
    $scope.typeToString = function (strType) {
        var type = invoiceTypeEnum.Normal;
        switch (strType) {
            case 0:
                type = invoiceTypeEnum.Normal;
                break;
            case 1:
                type = invoiceTypeEnum.Special;
                break;
            default:
                type = invoiceTypeEnum.Normal;
        }
        return type;
    }

    var voucherColumns = [
            { name: $translate.instant('period'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.period}}<span></div>' },
            { name: $translate.instant('VoucherDate'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents" ><span>{{row.entity.date | date:"yyyy-MM-dd"}}<span></div>' },
            { name: $translate.instant('VoucherID'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.vid}}<span></div>' },
             { name: $translate.instant('VoucherAccountCode'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode}}<span></div>' },
            { name: $translate.instant('VoucherSummary'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.summary}}<span></div>' },           
            { name: $translate.instant('VoucherDebitAmount'), width: '15%', headerCellClass: 'right', cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.debit}}<span></div>' },
            { name: $translate.instant('VoucherCreditAmount'), width: '15%', headerCellClass: 'right', cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.credit}}<span></div>' },
    ];
    var invoiceColumns = [
            { name: $translate.instant('period'), width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodID}}<span></div>' },
            { name: $translate.instant('InvoiceDate'), width: '12%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceDate | date:"yyyy-MM-dd"}}<span></div>' },
            { name: $translate.instant('InvoiceType'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{grid.appScope.typeToString(row.entity.invoiceType)}}<span></div>' },
            { name: $translate.instant('ClassCode'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.classCode}}<span></div>' },
            { name: $translate.instant('InvoiceNumber'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceNumber}}<span></div>' },
            { name: $translate.instant('BuyerName'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.buyerName}}<span></div>' },
            { name: $translate.instant('BuyerTaxNumber'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.buyerTaxNumber}}<span></div>' },
            { name: $translate.instant('Amount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.amount}}<span></div>' },
              { name: $translate.instant('TaxRate'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{((row.entity.taxRate) * 100).toFixed(0) + "%"}}<span></div>' },
            { name: $translate.instant('TaxAmount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.taxAmount}}<span></div>' },
    ];
    //Voucher数据源
    $scope.gridOptionsVoucher = {
        rowHeight: constant.UIGrid.rowHeight,
        selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
        enableColumnResizing: true,
        enableRowSelection: true,
        enableRowHeaderSelection: false,
        multiSelect: false,
        modifierKeysToMultiSelect: false,
        noUnselect: true,
        enableSorting: false,
        enableColumnMenus: false,
        enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
        enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
        columnDefs: voucherColumns,
        onRegisterApi: function (gridApi) {
            $scope.gridVoucherApi = gridApi;

            $interval(function () {
                $scope.gridVoucherApi.core.handleWindowResize();
            }, 500, 60 * 60 * 8);

            if (gridApi.selection) {
                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    voucherRowSelectedEvent(row);
                });
            }

        }
    };


    //Voucher历史数据源
    $scope.gridOptionsHistoryVoucher = {
        rowHeight: constant.UIGrid.rowHeight,
        selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
        enableColumnResizing: true,
        enableRowSelection: true,
        enableRowHeaderSelection: false,
        multiSelect: false,
        modifierKeysToMultiSelect: false,
        noUnselect: true,
        enableSorting: false,
        enableColumnMenus: false,
        enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
        enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
        columnDefs: voucherColumns,
        onRegisterApi: function (gridApi) {
            $scope.gridHistoryVoucherApi = gridApi;

            $interval(function () {
                $scope.gridHistoryVoucherApi.core.handleWindowResize();
            }, 500, 60 * 60 * 8);

            if (gridApi.selection) {
                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    voucherRowSelectedEvent(row);
                });
            }

        }
    };

    //MapVoucher数据源
    $scope.gridOptionsMapVoucher = {
        rowHeight: constant.UIGrid.rowHeight,
        selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
        enableColumnResizing: true,
        enableSorting: false,
        enableColumnMenus: false,
        enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
        enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
        columnDefs: voucherColumns,
        onRegisterApi: function (gridApi) {
            $scope.gridMapVoucherApi = gridApi;

            $interval(function () {
                $scope.gridMapVoucherApi.core.handleWindowResize();
            }, 500, 60 * 60 * 8);
        }
    };

    //Invoice数据源
    $scope.gridOptionsInvoice = {
        rowHeight: constant.UIGrid.rowHeight,
        selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
        enableColumnResizing: true,
        enableRowSelection: true,
        enableRowHeaderSelection: false,
        multiSelect: false,
        modifierKeysToMultiSelect: false,
        noUnselect: true,
        enableSorting: false,
        enableColumnMenus: false,
        enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
        enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
        columnDefs: invoiceColumns,
        onRegisterApi: function (gridApi) {
            $scope.gridInvoiceApi = gridApi;

            $interval(function () {
                $scope.gridInvoiceApi.core.handleWindowResize();
            }, 500, 60 * 60 * 8);

            if (gridApi.selection) {
                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    invoiceRowSelectedEvent(row);
                });
            }
        }
    };

    //Invoice历史数据源
    $scope.gridOptionsHistoryInvoice = {
        rowHeight: constant.UIGrid.rowHeight,
        selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
        enableColumnResizing: true,
        enableRowSelection: true,
        enableRowHeaderSelection: false,
        multiSelect: false,
        modifierKeysToMultiSelect: false,
        noUnselect: true,
        enableSorting: false,
        enableColumnMenus: false,
        enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
        enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
        columnDefs: invoiceColumns,
        onRegisterApi: function (gridApi) {
            $scope.gridHistoryInvoiceApi = gridApi;

            $interval(function () {
                $scope.gridHistoryInvoiceApi.core.handleWindowResize();
            }, 500, 60 * 60 * 8);

            if (gridApi.selection) {
                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    invoiceRowSelectedEvent(row);
                });
            }
        }
    };

    //MapInvoice数据源
    $scope.gridOptionsMapInvoice = {
        rowHeight: constant.UIGrid.rowHeight,
        selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
        enableColumnResizing: true,
        enableSorting: false,
        enableColumnMenus: false,
        enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
        enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
        columnDefs: invoiceColumns,
        onRegisterApi: function (gridApi) {
            $scope.gridMapInvoiceApi = gridApi;

            $interval(function () {
                $scope.gridMapInvoiceApi.core.handleWindowResize();
            }, 500, 60 * 60 * 8);
        }
    };

    //切换VoucherTab
    $scope.switchVoucherTable = function (event) {
        $('.voucher-tab span').each(function () {
            $(this).removeClass('active');
        });

        $(event.target).addClass('active');

        if (event.target.innerText == $translate.instant('CurrentPeriod')) {
            $('#gridVoucher').css('display', 'block');
            $('#gridHistoryVoucher').css('display', 'none');
            $scope.isVoucherHistory = false;
        }
        else {
            $('#gridHistoryVoucher').css('display', 'block');
            $('#gridVoucher').css('display', 'none');
            $scope.isVoucherHistory = true;
        }
        setErrorWrapCssDefault();
        getVoucherListByPage(1, $scope.isVoucherHistory);
    };

    //切换InvoiceTab
    $scope.switchInvoiceTable = function (event) {
        $('.invoice-tab span').each(function () {
            $(this).removeClass('active');
        });

        $(event.target).addClass('active');

        if (event.target.innerText == $translate.instant('CurrentPeriod')) {
            $('#gridInvoice').css('display', 'block');
            $('#gridHistoryInvoice').css('display', 'none');
            $scope.isInvoiceHistory = false;
        }
        else {
            $('#gridHistoryInvoice').css('display', 'block');
            $('#gridInvoice').css('display', 'none');
            $scope.isInvoiceHistory = true;
        }
        setErrorWrapCssDefault();
        getInvoiceListByPage(1, $scope.isInvoiceHistory);
    };

    var voucherRowSelectedEvent = function (row) {
        $scope.IsVoucher = true;
        setErrorWrapCssDispalyHeight();
        setMapTableFloat(true);
        $scope.gridInvoiceApi.selection.clearSelectedRows();
        $scope.gridHistoryInvoiceApi.selection.clearSelectedRows();
        var queryParams = {
            VID: row.entity.vid,
            Period: row.entity.period,
            Group: row.entity.group,
            ItemID: row.entity.itemID,
            CurPeriod: $scope.period,
        }
        vatReductionService.getVoucherMapInvoice(queryParams).success(function (data) {
            if (data && data.tranCode) {
                setMapGridData(data);
            }
            else {
                setMapGridDataNull();
            }
        }).error(function () {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }

    var invoiceRowSelectedEvent = function (row) {
        $scope.IsVoucher = false;
        setMapTableFloat(false);
        setErrorWrapCssDispalyHeight();
        $scope.gridVoucherApi.selection.clearSelectedRows();
        $scope.gridHistoryVoucherApi.selection.clearSelectedRows();
        var queryParams = {
            InvoiceCode: row.entity.classCode,
            CurPeriod: $scope.period,
            InvoiceNumber: row.entity.invoiceNumber,
        }
        vatReductionService.getInvoiceMapVoucher(queryParams).success(function (data) {
            if (data && data.tranCode) {
                setMapGridData(data);
            }
            else {
                setMapGridDataNull();
            }
        }).error(function () {
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }

    var setMapGridData = function (data) {
        var mapDebit = 0;
        var mapCredit = 0;
        if (data.voucherList !== null) {
            data.voucherList.forEach(function (v) {
                mapDebit += v.debit;
                mapCredit += v.credit;
                v.debit = PWC.round(v.debit, 2);
                v.credit = PWC.round(v.credit, 2);
            });
        }
        var mapAmount = 0;
        var mapTaxAmount = 0;
        if (data.invoiceList !== null) {
            data.invoiceList.forEach(function (v) {
                mapAmount += v.amount;
                mapTaxAmount += v.taxAmount;
                v.amount = PWC.round(v.amount, 2);
                v.taxAmount = PWC.round(v.taxAmount, 2);
            });
        }

        $scope.tranCode = data.tranCode;
        $scope.MapTotalDebitAmount = PWC.round(mapDebit, 2);
        $scope.MapTotalCreditAmount = PWC.round(mapCredit, 2);
        $scope.MapTotalAmount = PWC.round(mapAmount, 2);
        $scope.MapTotalTaxAmount = PWC.round(mapTaxAmount, 2);

        $scope.gridOptionsMapVoucher.data = data.voucherList;
        $scope.gridOptionsMapInvoice.data = data.invoiceList;
    }

    var setMapGridDataNull = function () {
        $scope.tranCode = '';
        $scope.MapTotalDebitAmount = 0;
        $scope.MapTotalCreditAmount = 0;
        $scope.MapTotalAmount = 0;
        $scope.MapTotalTaxAmount = 0;
        $scope.gridOptionsMapVoucher.data = [];
        $scope.gridOptionsMapInvoice.data = [];
    }

    //初始化Voucher分页信息
    var initVoucherPagination = function () {
        $scope.queryVoucherResult = {
            list: [],
            pageInfo: {
                totalCount: -1,
                pageIndex: 1,
                pageSize: 10,
                totalPage: 0,
            }
        }
        $scope.curVoucherPage = 1;
    };
    //初始化Invoice分页信息
    var initInvoicePagination = function () {
        $scope.queryInvoiceResult = {
            list: [],
            pageInfo: {
                totalCount: -1,
                pageIndex: 1,
                pageSize: 10,
                totalPage: 0,
            }
        }
        $scope.curInvoicePage = 1;
    };
    //切换账票显示方向
    var setMapTableFloat = function (isvoucher) {
        if (isvoucher) {
            $('.map-voucher-table').css('float', 'left');
            $('.map-voucher-table').css('padding-left', '20px');
            $('.map-voucher-table').css('padding-right', '0px');

            $('.map-invoice-table').css('float', 'right');
            $('.map-invoice-table').css('padding-left', '0px');
            $('.map-invoice-table').css('padding-right', '20px');
        }
        else {
            $('.map-voucher-table').css('float', 'right');
            $('.map-voucher-table').css('padding-left', '0px');
            $('.map-voucher-table').css('padding-right', '20px');

            $('.map-invoice-table').css('float', 'left');
            $('.map-invoice-table').css('padding-left', '20px');
            $('.map-invoice-table').css('padding-right', '0px');
        }
    }
    //账票对应关系grid的高度
    var getMapGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $("#map-item-wrapper").height();

            // Enough space
            if (y > constant.UIGrid.gapHeight) {
                y = y - constant.UIGrid.gapHeight;
                return {
                    height: (y - 40 - 67 - 30) + "px"
                };
            } else {
                return {
                    height: '0px'
                };
            }
        }
        return {
        };
    };

    //对应关系中间图片的高度
    var getImgGridHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $('.map-detail').height();
            // Enough space
            if (y > 140) {
                return {
                    'padding-top': (y - 140) / 2 + "px"
                };
            } else {
                return {
                    'padding-top': '0px'
                };
            }
        }
        return {
        };
    };

    //对应关系中间交易号内容的高度
    var getTranCodeHeight = function () {
        if ($scope.isLoadComplete) {
            var y = $('.map-detail').height();
            // Enough space
            if (y > 140) {
                return {
                    'top': (y - 140) / 2 + "px"
                };
            } else {
                return {
                    'top': '25px'
                };
            }
        }
        return {
        };
    };

    //显示对应关系grid明细
    var toggleMapGridTab = function () {
        $scope.ImportErrorTag = !$scope.ImportErrorTag;
        // topIcon and content-resize gapBottom 15px
        if (!$scope.ImportErrorTag) {
            setErrorWrapCssDefault();
        } else {
            setErrorWrapCssDispalyHeight();
        }
    };

    var setErrorWrapCssDispalyHeight = function () {
        if (parseInt($('#content-resizer').css('bottom')) < 100) {
            $('#content-resizer').css('bottom', '300px');
            $('.map-container').css('height', '300px');
        }
    }

    var setErrorWrapCssDefault = function () {
        $('#content-resizer').css('bottom', '10px');
        $('.map-container').css('height', '10px');
        $('#detail-table-wrapper').css('bottom', '5px');
        var y = ($(".total-container").height() - 5) + "px";
        $('.detail-table').css('height', y);
    };

    //获取记账信息
    var getVoucherListByPage = function (pageIndex, isVoucherHistory) {
        $scope.curVoucherPage = pageIndex;
        //初始化查询信息
        var pageInfo = {
            totalCount: $scope.queryVoucherResult.pageInfo.totalCount,
            pageIndex: pageIndex,
            pageSize: $scope.queryVoucherResult.pageInfo.pageSize,
            totalPage: 0,
        }
        var queryParams = {
            pageInfo: pageInfo,
            status: $scope.voucherSearchType.selected.id,
            period: $scope.period,
        };
        if (isVoucherHistory) {
            vatReductionService.getVoucherHistoryList(queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                        v.debit = PWC.round(v.debit, 2);
                        v.credit = PWC.round(v.credit, 2);
                    });
                    $scope.TotalDebitAmount = PWC.round(data.debitTotalAmount, 2);
                    $scope.TotalCreditAmount = PWC.round(data.creditTotalAmount, 2);

                    $scope.gridOptionsHistoryVoucher.data = data.list;
                    $scope.queryVoucherResult.pageInfo = data.pageInfo;
                    computeVoucherPage(isVoucherHistory);
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }
        else {
            vatReductionService.getVoucherList(queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                        v.debit = PWC.round(v.debit, 2);
                        v.credit = PWC.round(v.credit, 2);
                    });
                    $scope.TotalDebitAmount = PWC.round(data.debitTotalAmount, 2);
                    $scope.TotalCreditAmount = PWC.round(data.creditTotalAmount, 2);

                    $scope.gridOptionsVoucher.data = data.list;
                    $scope.queryVoucherResult.pageInfo = data.pageInfo;
                    computeVoucherPage(isVoucherHistory);
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }
    }

    //获取记账信息
    var getInvoiceListByPage = function (pageIndex, isInvoiceHistory) {
        $scope.curInvoicePage = pageIndex;
        //初始化查询信息
        var pageInfo = {
            totalCount: $scope.queryInvoiceResult.pageInfo.totalCount,
            pageIndex: pageIndex,
            pageSize: $scope.queryInvoiceResult.pageInfo.pageSize,
            totalPage: 0,
        }
        var queryParams = {
            pageInfo: pageInfo,
            status: $scope.invoiceSearchType.selected.id,
            period: $scope.period,
        };
        if (isInvoiceHistory) {
            vatReductionService.getOuputInvoiceHistoryList(queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                        v.amount = PWC.round(v.amount, 2);
                        v.taxAmount = PWC.round(v.taxAmount, 2);
                    });
                    $scope.TotalAmount = PWC.round(data.amountTotal, 2);
                    $scope.TotalTaxAmount = PWC.round(data.taxAmountTotal, 2);  

                    $scope.gridOptionsHistoryInvoice.data = data.list;
                    $scope.queryInvoiceResult.pageInfo = data.pageInfo;
                    computeInvoicePage(isInvoiceHistory);
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }
        else {
            vatReductionService.getOuputInvoiceList(queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                        v.amount = PWC.round(v.amount, 2);
                        v.taxAmount = PWC.round(v.taxAmount, 2);
                    }); 
                    $scope.TotalAmount = PWC.round(data.amountTotal, 2);
                    $scope.TotalTaxAmount = PWC.round(data.taxAmountTotal, 2);

                    $scope.gridOptionsInvoice.data = data.list;
                    $scope.queryInvoiceResult.pageInfo = data.pageInfo;
                    computeInvoicePage(isInvoiceHistory);
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

    }

    //计算Voucher页数，创建分页栏
    var computeVoucherPage = function (isVoucherHistory) {

        if ($scope.queryVoucherResult.pageInfo && $scope.queryVoucherResult.pageInfo.totalCount > 0) {

            var totalPage = parseInt($scope.queryVoucherResult.pageInfo.totalCount / $scope.queryVoucherResult.pageInfo.pageSize);
            totalPage = $scope.queryVoucherResult.pageInfo.totalCount % $scope.queryVoucherResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;
            $scope.queryVoucherResult.pageInfo.totalPage = totalPage;

            var createVoucherPage = $("#totalVoucherPage").createPage({
                pageCount: totalPage,
                current: $scope.curVoucherPage,
                backFn: function (p) {
                    //单击回调方法，p是当前页码
                    getVoucherListByPage(p, isVoucherHistory);
                }
            });
            $('#totalVoucherPage').css('display', 'inline-block');
        } else {
            var createPage = $("#totalVoucherPage").createPage({
                pageCount: 0,
                current: $scope.curVoucherPage,
                backFn: function (p) {
                    //单击回调方法，p是当前页码
                    getVoucherListByPage(p, isVoucherHistory);
                }
            });
            $('#totalVoucherPage').css('display', 'inline-block');
        }
    };
    //计算Invoice页数，创建分页栏
    var computeInvoicePage = function (isInvoiceHistory) {

        if ($scope.queryInvoiceResult.pageInfo && $scope.queryInvoiceResult.pageInfo.totalCount > 0) {

            var totalPage = parseInt($scope.queryInvoiceResult.pageInfo.totalCount / $scope.queryInvoiceResult.pageInfo.pageSize);
            totalPage = $scope.queryInvoiceResult.pageInfo.totalCount % $scope.queryInvoiceResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;
            $scope.queryInvoiceResult.pageInfo.totalPage = totalPage;

            var createInvoicePage = $("#totalInvoicePage").createPage({
                pageCount: totalPage,
                current: $scope.curInvoicePage,
                backFn: function (p) {
                    //单击回调方法，p是当前页码
                    getInvoiceListByPage(p, isInvoiceHistory);
                }
            });
            $('#totalInvoicePage').css('display', 'inline-block');
        } else {
            var createPage = $("#totalInvoicePage").createPage({
                pageCount: 0,
                current: $scope.curInvoicePage,
                backFn: function (p) {
                    //单击回调方法，p是当前页码
                    getInvoiceListByPage(p, isInvoiceHistory);
                }
            });
            $('#totalInvoicePage').css('display', 'inline-block');
        }
    };
    //初始获取数据
    var InitDataFromDB = function () {
        $scope.voucherSearchType.selected = $scope.voucherSearchTypeList[0];
        $scope.invoiceSearchType.selected = $scope.invoiceSearchTypeList[0];
        $scope.isVoucherHistory = false;
        $scope.isInvoiceHistory = false;
        getVoucherListByPage(1, $scope.isVoucherHistory);
        getInvoiceListByPage(1, $scope.isInvoiceHistory);
    }
    //过滤Voucher选择事件
    function changeVoucherSearchType(selectVoucherType) {
        setErrorWrapCssDefault();
        getVoucherListByPage(1, $scope.isVoucherHistory);       
    }
    //过滤Invoice选择事件
    function changeInvoiceSearchType() {
        setErrorWrapCssDefault();
        getInvoiceListByPage(1, $scope.isInvoiceHistory);       
    }

    var InitTabUI = function () {
        $('#gridVoucher').css('display', 'block');
        $('#gridHistoryVoucher').css('display', 'none');

        $('#gridInvoice').css('display', 'block');
        $('#gridHistoryInvoice').css('display', 'none');
    };

    (function initialize() {
        $log.debug('vatUnbilledInvoiceController.ctor()...');

        $scope.changeVoucherSearchType = changeVoucherSearchType;
        $scope.changeInvoiceSearchType = changeInvoiceSearchType;
        $scope.toggleMapGridTab = toggleMapGridTab;
        $scope.getMapGridHeight = getMapGridHeight;
        $scope.getImgGridHeight = getImgGridHeight;
        $scope.getTranCodeHeight = getTranCodeHeight;

        initVoucherPagination();
        initInvoicePagination();
        InitDataFromDB();

        $timeout(function () {
            $scope.isLoadComplete = true;

            setErrorWrapCssDefault();
            InitTabUI();
        }, 500);

    })();
}
]);
vatModule.directive('vatUnbilledInvoice', ['$log',
    function ($log) {
        'use strict';

        $log.debug('vatUnbilledInvoice.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/reduction/vat-unbilled-invoice/vat-unbilled-invoice.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'vatUnbilledInvoiceController',
            link: function ($scope, $element, $attr) {
                $scope.token = $('input[name="__RequestVerificationToken"]').val();
            }
        };
    }
]);
vatModule.controller('VatReportLayoutController', ['$scope', '$log', '$q', 'loginContext',
    '$translate', '$location', 'templateGroupService', 'vatSessionService', 'vatReportService', '$state',
    function ($scope, $log, $q, loginContext, $translate, $location, templateGroupService, vatSessionService, vatReportService, $state) {
        'use strict';
        $log.debug('VatReportLayoutController.ctor()...');

        $scope.$on('refreshGenerateReport', function (event, data) {
            //$scope.selectedTemplateId = data.templateId;
            loadTemplateMenu();
        });
        var loadTemplateMenu = function () {
            // Mock Data
            var projectID = vatSessionService.project.id;
            //because project in overview is mock up, so I have to mock the project id from database,
            //otherwise the project not exist in database.
            //通用
            //projectID = 'd6dcfb47-a92c-4b0b-a063-354b63756bd0';
            //房地产
            //projectID = '0cf0945f-d41c-4df3-8235-ae693d5e724d';
            $q.all([
                templateGroupService.getGroupTemplateByGroupID(6390933830635520, projectID),
                vatReportService.getTemplate(vatSessionService.project.id, constant.serviceType.VAT, vatSessionService.month)
            ]).then(function (result) {
                if (!_.isEmpty(result[0]) && !_.isEmpty(result[0].data) && !_.isEmpty(result[0].data.data)
                    && !_.isEmpty(result[1]) && !_.isEmpty(result[1].data) && !_.isEmpty(result[1].data.data)) {

                    // 获取 BSPL Report Template
                    var grps = [];
                    if ($scope.hasBsPlPermission) {
                        //todo:use reject here later , filter here just for test --FX
                        grps = _.filter(result[0].data.data, {name: 'TaxReturn'});
                        if (grps && grps[0] && grps[0].children) {
                            if (!$scope.hasBsPermission) {
                                grps.children = _.reject(grps[0].children, {name: '资产负债表'});
                            }

                            if (!$scope.hasPlPermission) {
                                grps.children = _.reject(grps[0].children, {name: '利润表'});
                            }
                        }
                    }


                    if ($scope.hasTaxReturnPermission && $scope.hasQueryTaxReturnPermission) {
                        // 获取 申报表 Report Template
                        var taxRtnGrp = {
                            name: 'TaxReturn',
                            children: _.map(result[1].data.data, function (x) {
                                //if (x.templateID === $scope.selectedTemplateId) {
                                //    $state.go('vat.generateReport.reportView', { id: x.id, templateid: x.templateID, name: x.templateName });
                                //}
                                return {
                                    reportId: x.id,
                                    id: x.templateId,
                                    name: x.templateName,
                                    code: x.templateCode
                                };
                            }),
                            orderIndex: grps.length
                        };
                        grps.push(taxRtnGrp);
                    }

                    $scope.groups = _.chain(grps).sortBy(function (x) {
                        return x.orderIndex
                    }).map(function (x) {
                        x.isExpand = true;
                        return x;
                    }).value();

                    $scope.selectedTemplateId = null;
                    if (vatSessionService.isFromTopMenu) {
                        var firstNode = _.first(grps);
                        var firstSubNode = _.first(firstNode.children);
                        if(firstSubNode.id!==undefined) {
                            $scope.selectedTemplateId = firstSubNode.id;
                            $state.go('vat.generateReport.reportView', {
                                id: firstSubNode.reportId,
                                templateid: firstSubNode.id,
                                name: firstSubNode.name,
                                templatecode: firstSubNode.code
                            });
                            vatSessionService.isFromTopMenu = false;
                        }
                    }
                    //var firstNode = _.first(grps);
                    //var firstSubNode = _.first(firstNode.children);
                    //$scope.selectedTemplateId = firstSubNode.id;
                    //$state.go('vat.generateReport.reportView', { id: firstSubNode.reportId, templateid: firstSubNode.id, name: firstSubNode.name, templatecode: firstSubNode.code });
                }
                //$scope.menus = [{ id: 'mainVatReturns', text: $translate.instant('mainVatReturnsReport').replace(/;/g, '<br/>') }];
            });
        };

        //检查用户机构权限
        var checkUserOrganizationPermissionList = function () {
            var list = [];
            var reportTemp = constant.vatPermission.reportView;
            list.push(reportTemp.bsplCode);
            list.push(reportTemp.bspl.bsCode);
            list.push(reportTemp.bspl.plCode);
            list.push(reportTemp.taxReturnCode);
            list.push(reportTemp.taxReturn.queryCode);
            list.push(reportTemp.taxReturn.editCode);
            $scope.hasBsPlPermission = false;
            $scope.hasBsPermission = false;
            $scope.hasPlPermission = false;
            $scope.hasTaxReturnPermission = false;
            $scope.hasQueryTaxReturnPermission = false;
            $scope.hasEditTaxReturnPermission = false;
            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasBsPlPermission = data[reportTemp.bsplCode];
                $scope.hasBsPermission = data[reportTemp.bspl.bsCode];
                $scope.hasPlPermission = data[reportTemp.bspl.plCode];
                $scope.hasTaxReturnPermission = data[reportTemp.taxReturnCode];
                $scope.hasQueryTaxReturnPermission = data[reportTemp.taxReturn.queryCode];
                $scope.hasEditTaxReturnPermission = data[reportTemp.taxReturn.editCode];
            });
        };
        var toggleGroup = function (group) {
            group.isExpand = !group.isExpand;
        };
        (function initialize() {
            checkUserOrganizationPermissionList();
            loadTemplateMenu();
            $scope.expend = true;
            $scope.toggleGroup = toggleGroup;
        })();

    }]);
vatModule.directive('vatReportLayout', ['$log', '$rootScope', '$timeout', 'enums',
    function ($log, $rootScope, $timeout, enums) {
        'use strict';

        $log.debug('vatReportLayout.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/vat/report/vat-report-layout/vat-report-layout.html' + '?_=' + Math.random(),
            replace: true,
            scope: {},
            controller: 'VatReportLayoutController',
            link: function ($scope, $element, $attr) {



                Split(['#vat-report-nav-menu', '#vat-report-content'], {
                    sizes: [17, 83],
                    minSize: [1, 1330],
                    onDragEnd: function () {
                        $timeout(function () {
                            $rootScope.$broadcast(enums.vatEvent.layoutChanged, {});
                        }, 700);
                    }
                })


                $scope.isCollapsed = false;
            }
        };
    }
]);

vatModule.controller('VatLayoutController', ['$scope', '$rootScope', '$q', '$log', '$timeout', '$state', '$translate', 'projectService', 'SweetAlert', 'loginContext'
    , 'vatSessionService', 'vatCommonService', 'vatWorkflowService', 'application', 'enums', '$uibModal',
function ($scope, $rootScope, $q, $log, $timeout, $state, $translate, projectService, SweetAlert, loginContext
    , vatSessionService, vatCommonService, vatWorkflowService, application, enums, $uibModal) {
    'use strict';
    $log.debug('VatLayoutController.ctor()...');

    $scope.dateFormat = $translate.instant('dateFormat4YearMonth');
    $scope.showSubMenu = true;
    $scope.projectName = vatSessionService.project.organizationName + '(' + vatSessionService.project.year + ')';

    $scope.selectedDate = new Date(vatSessionService.project.year, vatSessionService.month - 1, 1);
    $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
    $scope.endDate = new Date(vatSessionService.project.year, 11, 31, 23, 59, 59);
    var subMenus = [];

    var subStatusDto = {
        dispalyIndex: -1,
        name: '',
        isImported: false
    };

    var msgboxOptions = {
        title: $translate.instant('UnsavedChange'),
        text: $translate.instant('ComfirmIgnoreUnsavedChanges'),
        type: "warning",
        showCancelButton: true,
        confirmButtonColor: "#e0301e",
        confirmButtonText: $translate.instant('ConfirmYes'),
        cancelButtonText: $translate.instant('ConfirmNo'),
        closeOnConfirm: true,
        closeOnCancel: true
    };

    $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams, options) {
        var mainMenu = ['vat.importData', 'vat.previewData', 'vat.reductionData', 'vat.analyzeLayout'];
        if (vatSessionService.dataChanged) {
            event.preventDefault();
            SweetAlert.swal(msgboxOptions, function (isConfirm) {
                if (isConfirm) {
                    vatSessionService.dataChanged = false;
                    if (_.contains(mainMenu, toState.name)) {
                        goFirstSubMenu(toState);
                    }
                    else {
                        $state.go(toState, toParams, options);
                    };
                };
            });
        }
        else {
            if (_.contains(mainMenu, toState.name)) {
                event.preventDefault();
                goFirstSubMenu(toState);
            };
        };
    });

    $scope.changeDate = function (e) {
        $log.debug("start to change date");
        var temp = e.date.getMonth() + 1;
        if (vatSessionService.month != temp) {
            $timeout(function () {
                $log.debug($scope.changeDate);
                projectService.isProjectStatusExisted(vatSessionService.project.dbName, temp).success(function (or) {
                    if (or.result) {//如果当前期间还没有导入任何数据的话，就添加一条未开始状态的记录  
                        if (_.isNull(or.data)) {
                            projectService.setProjectStatus(vatSessionService.project.dbName, temp, constant.ProjectStatusEnum.UnStarted).success(function (or) {
                                if (or.result) {
                                    vatSessionService.project.projectStatusList[temp] = constant.ProjectStatusEnum.UnStarted;
                                    initStatus(vatSessionService.project.dbName, vatSessionService.project.id, temp);
                                }
                                else {
                                    SweetAlert.error($translate.instant('SetProjectStatusError'));
                                }
                            });
                        }
                        else { //已经导入的话，更新最新项目状态
                            vatSessionService.project.projectStatusList[temp] = or.data.status;
                            initStatus(vatSessionService.project.dbName, vatSessionService.project.id, temp);
                        }
                    }
                });

                if (vatSessionService.dataChanged) {
                    SweetAlert.swal(msgboxOptions, function (isConfirm) {
                        if (isConfirm) {
                            vatSessionService.dataChanged = false;
                            vatSessionService.month = temp;
                            $scope.selectedDate = new Date(vatSessionService.project.year, temp - 1, 1);;
                            $state.reload($state.$current);
                        } else {
                            $scope.elePicker.datepicker("setDate", $scope.selectedDate);
                        };
                    });
                }
                else {
                    vatSessionService.month = temp;
                    $scope.selectedDate = new Date(vatSessionService.project.year, temp - 1, 1);
                    //查看报表时路由为三层结构，特殊处理,其他逻辑不变
                    if ($state.$current.parent && $state.$current.parent.self.name === 'vat.generateReport') {
                        $scope.$broadcast('refreshGenerateReport', { templateId: $state.params.templateid });
                    }
                    else {
                        $state.reload($state.$current);
                    }
                };
            }, 100);
        }
    };

    $scope.setPermissionMenu = function () {
        $scope.menus = [];
        var menuList = [
                    constant.vatPermission.dataImport.balanceSheet.queryCode,
                    constant.vatPermission.dataImport.journalEntry.queryCode,
                    constant.vatPermission.dataImport.erpImport.queryCode,
                    constant.vatPermission.dataImport.outputInvoice.queryCode,
                    constant.vatPermission.dataImport.inputInvoice.queryCode,
                    constant.vatPermission.dataImport.customInvoice.queryCode,
                    constant.vatPermission.dataImport.voucherMapping.queryCode,
                    constant.vatPermission.dataImport.invoiceMapping.queryCode,
                    constant.vatPermission.dataImport.auditAdjust.queryCode,

                    constant.vatPermission.dataPreview.balanceSheet.queryCode,
                    constant.vatPermission.dataPreview.accountVoucher.queryCode,
                    constant.vatPermission.dataPreview.customInvoice.queryCode,
                    constant.vatPermission.dataPreview.outputInvoice.queryCode,
                    constant.vatPermission.dataPreview.inputInvoice.queryCode,

                    constant.vatPermission.dataManage.caculateDataCode,
                    constant.vatPermission.dataManage.accountMappingCode,
                    constant.vatPermission.dataManage.goodsMappingCode,
                    constant.vatPermission.dataManage.unbilledInvoiceCode,

                    constant.vatPermission.reportView.bsplCode,
                    constant.vatPermission.reportView.taxReturnCode,

                    constant.vatPermission.dataAnalysis.modelAnalysisCode,
                    constant.vatPermission.dataAnalysis.dashboard.dashboardCode,
                    //constant.vatPermission.dataAnalysis.vatTaxDifferenceCode,
        ];

        $scope.$root.checkUserOrganizationPermissionList(menuList).success(function (data) {
            if (data) {
                if (data[constant.vatPermission.dataImport.balanceSheet.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.balanceSheet', state: 'importData.balanceSheet', num: 1,
                        permission: constant.vatPermission.dataImport.balanceSheet.queryCode, url: '#/vat/importData/balanceSheet'
                    });
                }
                else if (data[constant.vatPermission.dataImport.journalEntry.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.journalEntry', state: 'importData.journalEntry', num: 1,
                        permission: constant.vatPermission.dataImport.journalEntry.queryCode, url: '#/vat/importData/journalEntry'
                    });
                }
                else if (data[constant.vatPermission.dataImport.erpImport.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.erpData', state: 'importData.erpData', num: 1,
                        permission: constant.vatPermission.dataImport.erpImport.queryCode, url: '#/vat/importData/erpData'
                    });
                }
                else if (data[constant.vatPermission.dataImport.outputInvoice.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.outputInvoice', state: 'importData.outputInvoice', num: 1,
                        permission: constant.vatPermission.dataImport.outputInvoice.queryCode, url: '#/vat/importData/outputInvoice'
                    });
                }
                else if (data[constant.vatPermission.dataImport.inputInvoice.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.inputInvoice', state: 'importData.inputInvoice', num: 1,
                        permission: constant.vatPermission.dataImport.inputInvoice.queryCode, url: '#/vat/importData/inputInvoice'
                    });
                }
                else if (data[constant.vatPermission.dataImport.customInvoice.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.customInvoice', state: 'importData.customInvoice', num: 1,
                        permission: constant.vatPermission.dataImport.customInvoice.queryCode, url: '#/vat/importData/customInvoice'
                    });
                }
                else if (data[constant.vatPermission.dataImport.voucherMapping.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.voucherMapping', state: 'importData.voucherMapping', num: 1,
                        permission: constant.vatPermission.dataImport.voucherMapping.queryCode, url: '#/vat/importData/voucherMapping'
                    });
                }
                else if (data[constant.vatPermission.dataImport.invoiceMapping.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.invoiceMapping', state: 'importData.invoiceMapping', num: 1,
                        permission: constant.vatPermission.dataImport.invoiceMapping.queryCode, url: '#/vat/importData/invoiceMapping'
                    });
                }
                else if (data[constant.vatPermission.dataImport.auditAdjust.queryCode]) {
                    $scope.menus.push({
                        name: 'importData', state: 'importData', num: 1,
                        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                    });
                    subMenus.push({
                        name: 'importData.auditAdjust', state: 'importData.auditAdjust', num: 1,
                        permission: constant.vatPermission.dataImport.auditAdjust.queryCode, url: '#/vat/importData/auditAdjust'
                    });
                }
                //else {
                //    $scope.menus.push({
                //        name: 'importData', state: 'importData', num: 1,
                //        permission: constant.vatPermission.dataImport.dataImportCode, url: '#/vat/importData'
                //    });
                //    subMenus.push({
                //        name: 'importData.productItem', state: 'importData.productItem', num: 1,
                //        permission: '02', url: '#/vat/importData/productItem'
                //    });
                //}

                if (data[constant.vatPermission.dataPreview.balanceSheet.queryCode]) {
                    $scope.menus.push({
                        name: 'previewData', state: 'previewData', num: 2,
                        permission: constant.vatPermission.dataPreview.dataPreviewCode, url: '#/vat/previewData'
                    });
                    subMenus.push({
                        name: 'previewData.balanceSheet', state: 'previewData.balanceSheet', num: 2,
                        permission: constant.vatPermission.dataPreview.balanceSheet.queryCode, url: '#/vat/previewData/balanceSheet'
                    });
                }
                else if (data[constant.vatPermission.dataPreview.accountVoucher.queryCode]) {
                    $scope.menus.push({
                        name: 'previewData', state: 'previewData', num: 2,
                        permission: constant.vatPermission.dataPreview.dataPreviewCode, url: '#/vat/previewData'
                    });
                    subMenus.push({
                        name: 'previewData.accountVoucher', state: 'previewData.accountVoucher', num: 2,
                        permission: constant.vatPermission.dataPreview.accountVoucher.queryCode, url: '#/vat/previewData/accountVoucher'
                    });
                }
                else if (data[constant.vatPermission.dataPreview.inputInvoice.queryCode]) {
                    $scope.menus.push({
                        name: 'previewData', state: 'previewData', num: 2,
                        permission: constant.vatPermission.dataPreview.dataPreviewCode, url: '#/vat/previewData'
                    });
                    subMenus.push({
                        name: 'previewData.inputInvoice', state: 'previewData.inputInvoice', num: 2,
                        permission: constant.vatPermission.dataPreview.inputInvoice.queryCode, url: '#/vat/previewData/inputInvoice'
                    });
                }
                else if (data[constant.vatPermission.dataPreview.outputInvoice.queryCode]) {
                    $scope.menus.push({
                        name: 'previewData', state: 'previewData', num: 2,
                        permission: constant.vatPermission.dataPreview.dataPreviewCode, url: '#/vat/previewData'
                    });
                    subMenus.push({
                        name: 'previewData.outputInvoice', state: 'previewData.outputInvoice', num: 2,
                        permission: constant.vatPermission.dataPreview.outputInvoice.queryCode, url: '#/vat/previewData/outputInvoice'
                    });
                }
                else if (data[constant.vatPermission.dataPreview.customInvoice.queryCode]) {
                    $scope.menus.push({
                        name: 'previewData', state: 'previewData', num: 2,
                        permission: constant.vatPermission.dataPreview.dataPreviewCode, url: '#/vat/previewData'
                    });
                    subMenus.push({
                        name: 'previewData.customInvoice', state: 'previewData.customInvoice', num: 2,
                        permission: constant.vatPermission.dataPreview.customInvoice.queryCode, url: '#/vat/previewData/customInvoice'
                    });
                }
                //else {
                //    $scope.menus.push({
                //        name: 'previewData', state: 'previewData', num: 2,
                //        permission: constant.vatPermission.dataPreview.dataPreviewCode, url: '#/vat/previewData'
                //    });
                //    subMenus.push({
                //        name: 'previewData.productItem', state: 'previewData.productItem', num: 2,
                //        permission: '02', url: '#/vat/previewData/productItem'
                //    });
                //}

                if (data[constant.vatPermission.dataManage.caculateDataCode]) {
                    $scope.menus.push({
                        name: 'reductionData', state: 'reductionData', num: 3,
                        permission: constant.vatPermission.dataManage.dataManageCode, url: '#/vat/reductionData'
                    });
                    subMenus.push({
                        name: 'reductionData.caculateData', state: 'reductionData.caculateData', num: 3,
                        permission: constant.vatPermission.dataManage.caculateDataCode, url: '#/vat/reductionData/caculateData'
                    });
                }
                else if (data[constant.vatPermission.dataManage.accountMappingCode]) {
                    $scope.menus.push({
                        name: 'reductionData', state: 'reductionData', num: 3,
                        permission: constant.vatPermission.dataManage.dataManageCode, url: '#/vat/reductionData'
                    });
                    subMenus.push({
                        name: 'reductionData.accountMapping', state: 'reductionData.accountMapping', num: 3,
                        permission: constant.vatPermission.dataManage.accountMappingCode, url: '#/vat/reductionData/accountMapping'
                    });
                }
                else if (data[constant.vatPermission.dataManage.goodsMappingCode]) {
                    $scope.menus.push({
                        name: 'reductionData', state: 'reductionData', num: 3,
                        permission: constant.vatPermission.dataManage.dataManageCode, url: '#/vat/reductionData'
                    });
                    subMenus.push({
                        name: 'reductionData.goodsMapping', state: 'reductionData.goodsMapping', num: 3,
                        permission: constant.vatPermission.dataManage.goodsMappingCode, url: '#/vat/reductionData/goodsMapping'
                    });
                }
                else if (data[constant.vatPermission.dataManage.unbilledInvoiceCode]) {
                    $scope.menus.push({
                        name: 'reductionData', state: 'reductionData', num: 3,
                        permission: constant.vatPermission.dataManage.dataManageCode, url: '#/vat/reductionData'
                    });
                    subMenus.push({
                        name: 'reductionData.unbilledInvoice', state: 'reductionData.unbilledInvoice', num: 3,
                        permission: constant.vatPermission.dataManage.unbilledInvoiceCode, url: '#/vat/reductionData/unbilledInvoice'
                    });
                }

                if (data[constant.vatPermission.reportView.bsplCode] || data[constant.vatPermission.reportView.taxReturnCode]) {
                    $scope.menus.push({
                        name: 'generateReport', state: 'generateReport', num: 4,
                        permission: constant.vatPermission.reportView.reportViewCode, url: '#/vat/generateReport'
                    });
                    subMenus.push({
                        name: 'generateReport', state: 'generateReport', num: 4,
                        permission: constant.vatPermission.reportView.reportViewCode, url: '#/vat/generateReport'
                    });
                }

                if (data[constant.vatPermission.dataAnalysis.modelAnalysisCode]) {
                    $scope.menus.push({                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
                        name: 'analyzeLayout', state: 'analyzeLayout', num: 5,
                        permission: constant.vatPermission.dataAnalysis.dataAnalysisCode, url: '#/vat/analyzeLayout'
                    });
                    subMenus.push({
                        name: 'analyzeLayout.analyzeReport', state: 'analyzeLayout.analyzeReport', num: 5,
                        permission: constant.vatPermission.dataAnalysis.modelAnalysisCode, url: '#/vat/analyzeLayout/analyzeReport'
                    });
                }
                //else if (data[constant.vatPermission.dataAnalysis.dashboard.dashboardCode]) {
                //    $scope.menus.push({
                //        name: 'analyzeLayout', state: 'analyzeLayout', num: 5,
                //        permission: constant.vatPermission.dataAnalysis.dataAnalysisCode, url: '#/vat/analyzeLayout'
                //    });
                //    subMenus.push({
                //        name: 'analyzeLayout.analyzeOrganizeDashboard', state: 'analyzeLayout.analyzeOrganizeDashboard', num: 5,
                //        permission: constant.vatPermission.dataAnalysis.dashboard.dashboardCode, url: '#/analyzeOrganizeDashboard'
                //    });
                //}
                else  {
                    //data[constant.vatPermission.dataAnalysis.vatTaxDifferenceCode]
                    $scope.menus.push({
                        name: 'analyzeLayout', state: 'analyzeLayout', num: 5,
                        permission: constant.vatPermission.dataAnalysis.dataAnalysisCode, url: '#/vat/analyzeLayout'
                    });
                    subMenus.push({
                        name: 'analyzeLayout.vatTaxDifference', state: 'analyzeLayout.vatTaxDifference', num: 5,
                        permission: constant.vatPermission.dataAnalysis.vatTaxDifferenceCode, url: '#/analyzeLayout/vatTaxDifference'
                    });
                }
            }
        });

    }

    var goFirstSubMenu = function (toState) {
        if (toState && toState.name && toState.name.length > 4 && $scope.menus) {
            var to = toState.name.substring(4);
            var state = _.find(subMenus, function (v, i, arr) {
                if (v && v['state'].indexOf(to + '.') >= 0) {
                    return true;
                }
            });
            if (state) {
                if (state['state'] && state['state'].indexOf('analyzeOrganizeDashboard')>=0) { 
                    $state.go('organizationDashboard', { id: vatSessionService.project.organizationID });
                }
                else {
                    $state.go('vat.' + state['state']);
                } 
            }
            else {
                $state.go(toState);
            };
        }
    } 

    $scope.$on(application.events.showSubMenu, function (event, data) {
        if (data) {
            $scope.showSubMenu = data.show;
        }
    });

    $scope.setReportSession = function (menuName) {
        if (menuName === 'generateReport') {
            vatSessionService.isFromTopMenu = true;
        }
    }

    $scope.showProjectStatus = function () {
        var modalInstance = $uibModal.open({
            animation: false,
            //appendTo: angular.element(document.querySelector('#imgProjectStatus')),//把弹出框加到imgProjectStatus下面
            ariaLabelledBy: 'modal-title',
            ariaDescribedBy: 'modal-body',
            templateUrl: 'model-project-status.html',
            scope: $scope,
            windowClass: "model-project-status"
        });

        modalInstance.rendered.then(function () {
            $log.debug("modalInstance.rendered");
            // Grab target element
            var element = document.querySelector('#imgProjectStatus'),
            // Get target position and size
            rect = element.getBoundingClientRect(),
            // Grab modal element
            modal = document.querySelector('.model-project-status');

            $log.debug(rect);
            // Set style 
            modal.style.margin = 0;
            //modal.style.width = rect.width + 'px';
            modal.style.top = rect.top + 'px';
            modal.style.left = rect.left + 'px';

        });

        $scope.closeModal = function () {
            modalInstance.dismiss('cancel');
        };

        setSubStatusDto();
        setApproveDetailDto();
        setSubmitDetailDto();
        setStartStatusText(vatSessionService.month);
    }

    $scope.showSubStatus = function () {
        var temp = $scope.displaySubStatus;
        $scope.displaySubStatus = !temp;
    }

    $scope.showApproveDetail = function () {
        var temp = $scope.displayApproveDetails;
        $scope.displayApproveDetails = !temp;
    }

    //设置项目状态Title
    function setLayoutStatusTitle(statusId) {
        $log.debug("setLayoutStatusTitle");
        $scope.statusTitle = $translate.instant('ProjectStatusTitle');
        switch (statusId) {
            case constant.ProjectStatusEnum.UnStarted:
                $scope.statusTitle += $translate.instant('ProjectStatusUnStarted');
                break;
            case constant.ProjectStatusEnum.Imported:
                $scope.statusTitle += $translate.instant('ProjectStatusImported');
                break;
            case constant.ProjectStatusEnum.AccountMapSubmitted:
                $scope.statusTitle += $translate.instant('ProjectStatusAcccountMapSubmitted');
                break;
            case constant.ProjectStatusEnum.Generated:
                $scope.statusTitle += $translate.instant('ProjectStatusGenerated');
                break;
            case constant.ProjectStatusEnum.ReportSubmitted:
                $scope.statusTitle += $translate.instant('ProjectStatusReportSubmitted');
                break;
            case constant.ProjectStatusEnum.ReportApproved:
                $scope.statusTitle += $translate.instant('ProjectStatusReportApproved');
                break;
            case constant.ProjectStatusEnum.ReportRejected:
                $scope.statusTitle += $translate.instant('ProjectStatusReportRejected');
                break;
            case constant.ProjectStatusEnum.Completed:
                $scope.statusTitle += $translate.instant('ProejctStatusCompleted');
                break;
        }
    }


    function setSubStatusDto() {
        $log.debug("setSubStatusDto");
        $scope.subStatusList = [];
        var tbStatus = { dispalyIndex: 1, name: $translate.instant('balanceSheet'), isImported: vatSessionService.project.importSubStatus.isTbImport };
        var entryStatus = { dispalyIndex: 2, name: $translate.instant('JournalEntryTitle'), isImported: vatSessionService.project.importSubStatus.isEntryImport };
        var erpStatus = { dispalyIndex: 3, name: $translate.instant('erpData'), isImported: vatSessionService.project.importSubStatus.isErpImport };
        var outputInvoiceStatus = { dispalyIndex: 4, name: $translate.instant('outputInvoice'), isImported: vatSessionService.project.importSubStatus.isOutputInvoiceImport };
        var inputInvoiceStatus = { dispalyIndex: 5, name: $translate.instant('inputInvoice'), isImported: vatSessionService.project.importSubStatus.isInputInvoiceImport };
        var customStatus = { dispalyIndex: 6, name: $translate.instant('customInvoice'), isImported: vatSessionService.project.importSubStatus.isCustomInvoiceImport };
        var voucherMapStatus = { dispalyIndex: 7, name: $translate.instant('voucherMapping'), isImported: vatSessionService.project.importSubStatus.isVoucherMapImport };
        var invoiceMapStatus = { dispalyIndex: 8, name: $translate.instant('invoiceMapping'), isImported: vatSessionService.project.importSubStatus.isInvoiceMapImport };
        var adjustStatus = { dispalyIndex: 9, name: $translate.instant('auditAdjust'), isImported: vatSessionService.project.importSubStatus.isAdjustImport };

        $scope.subStatusList.push(tbStatus);
        $scope.subStatusList.push(entryStatus);
        $scope.subStatusList.push(erpStatus);
        $scope.subStatusList.push(outputInvoiceStatus);
        $scope.subStatusList.push(inputInvoiceStatus);
        $scope.subStatusList.push(customStatus);
        $scope.subStatusList.push(voucherMapStatus);
        $scope.subStatusList.push(invoiceMapStatus);
        $scope.subStatusList.push(adjustStatus);
        $log.debug($scope.subStatusList);
    }

    function setSubmitDetailDto() {
        $log.debug("setSubmitDetailDto");
        $scope.submitDetailDto = {
            userId:"",
            userName: "",
            finishedDateTime: "",
            finishedData: "",
            isDone: false
        }
        var wf = vatSessionService.project.workflow;
        if (_.isNull(wf)) {
            return;
        }

        var viewReportNode = _.where(wf.workflowNodeList, { dictionaryKey: constant.DictionaryDictKey.ViewReport })[0];
        if (!_.isNull(viewReportNode) && !_.isUndefined(viewReportNode)) {
            var submitTask = _.where(viewReportNode.workflowTaskList, { dictionaryKey: constant.DictionaryDictKey.WFSubmitReport })[0];
            if (!_.isNull(submitTask) && !_.isUndefined(submitTask)) {
                $scope.submitDetailDto.userId = submitTask.userId;
                $scope.submitDetailDto.userName = submitTask.userName;
                $scope.submitDetailDto.finishedDateTime = !_.isNull(submitTask.createTime)
                                                          ? (new Date(submitTask.createTime)).dateTimeToString('yyyyMMdd') : "";
                $scope.submitDetailDto.isDone = submitTask.isDone;
                $scope.submitDetailDto.finishedData = $scope.submitDetailDto.userName + " " + $scope.submitDetailDto.finishedDateTime;

            }
        }
    }

    function setApproveDetailDto() {
        $log.debug("setApproveDetailDto");
        $scope.approveDetailList = [];
        switch (vatSessionService.project.projectStatusList[vatSessionService.month]) {
            case constant.ProjectStatusEnum.ReportApproved:
                $scope.approveTitle = $translate.instant('ProjectStatusReportApproved');
                break;
            case constant.ProjectStatusEnum.ReportRejected:
                $scope.approveTitle = $translate.instant('ProjectStatusReportRejected');
                break;
            default:
                $scope.approveTitle = $translate.instant('ProjectStatusReportApproved');;
        }

        var wf = vatSessionService.project.workflow;
        if (_.isNull(wf)) {
            return;
        }

        var approveReportNode = _.where(wf.workflowNodeList, { dictionaryKey: constant.DictionaryDictKey.ApproveReport })[0];     
        if (!_.isNull(approveReportNode) && !_.isUndefined(approveReportNode)) {
            $.each(approveReportNode.auditReportLevelList, function (index, item) {
                var approveDto = {
                    orderIndex: -1,
                    name: "",
                    isDone: false,
                    finishedByUserName: "",
                    finishedDateTime: "",
                    finishedData: "",
                    isRejected: false,
                    ngClassInActive: false
                };

                approveDto.orderIndex = item.orderIndex;
                approveDto.name = item.name + ' ' + $translate.instant('ProjectStatusReportApproved');
                approveDto.isDone = item.isDone;
                approveDto.finishedByUserName = !_.isNull(item.finishedByUserName) ? item.finishedByUserName : "";
                approveDto.finishedDateTime = !_.isNull(item.finishedDateTime) ? (new Date(item.finishedDateTime)).dateTimeToString('yyyyMMdd') : "";
                approveDto.finishedData = approveDto.finishedByUserName + "  " + approveDto.finishedDateTime;
                approveDto.ngClassInActive = vatSessionService.project.projectStatusList[vatSessionService.month] < 60 || (!approveDto.isDone
                                              && !approveDto.isRejected) ? true : false; //没有完成&&没有拒绝审核：未操作。显示为灰色
                $scope.approveDetailList.push(approveDto);
            });

            $scope.approveDetailList.forEach(function (a) {
                //如果当前层级'未完成'的话，检查是否作为'拒绝审核'操作。做过的话，重新设置dto数据
                if (!a.isDone) {
                    vatWorkflowService.getWorkflowApproveReportLog(vatSessionService.project.dbName, vatSessionService.month, a.orderIndex,
                      enums.vatLogOperationTypeEnum.RejectReport, enums.ReportTemplateCode.TaxDeclarationCategory)
                        .success(function (or) {
                            if (or.result) {
                                if (!_.isNull(or.data)) {
                                    a.isRejected = true;
                                    a.name = a.name.substring(0, a.name.indexOf(' ')) + ' ' + $translate.instant('HasRejected');
                                    a.finishedByUserName = or.data.userName;
                                    a.finishedDateTime = !_.isNull(or.data.createTime) ? (new Date(or.data.createTime)).dateTimeToString('yyyyMMdd') : "";
                                    a.finishedData = a.finishedByUserName + "  " + a.finishedDateTime;
                                    a.ngClassInActive = vatSessionService.project.projectStatusList[vatSessionService.month] < 60
                                                       || (!a.isDone && !a.isRejected) ? true : false;

                                    //如下操作：一级通过审核，二级拒绝审核，提交审核，一级通过审核。 
                                    //此时状态为“已审核”，审核的子状态：1级审核 已审核; 2级审核 已驳回 :应该显示为灰色
                                    if (vatSessionService.project.projectStatusList[vatSessionService.month] === 60 && a.orderIndex > 1) {
                                        var previousLevel = _.where($scope.approveDetailList, { orderIndex: a.orderIndex - 1 })[0];
                                        if (!_.isUndefined(previousLevel)) {
                                            if (previousLevel.isDone && a.isRejected) {
                                                a.ngClassInActive = true;
                                            }
                                        }
                                    }

                                }                               
                            }
                    });
                }
            });
        }

    }


    //项目未开始时，第一个节点显示”未开始”，开始以后显示“开始”
    function setStartStatusText(period) {
        var curPeriodStatus = vatSessionService.project.projectStatusList[period];
        if (!_.isUndefined(curPeriodStatus)) {
            if (_.isEqual(curPeriodStatus, constant.ProjectStatusEnum.UnStarted)) {
                $scope.startStatusText = $translate.instant('ProjectStatusUnStarted');
            }
            else {
                $scope.startStatusText = $translate.instant('ProjectStatusStarted');
            }
        }
    }


    function initStatus(dbName, id, month) {
        $q.all([
           projectService.getProjectStatus(dbName, id, month),
           //vatWorkflowService.getWorkflowDetailByDb(dbName, month)
        ]).then(function (result) {
            var statusData = result[0].data;
            var workflowData = result[1].data;
            if (statusData.result) {
                $log.debug("vat-layout.ctrl.js  initStatus set project importSubStatus");
                vatSessionService.project.importSubStatus = statusData.data.importSubStatus;
                $scope.layoutVatSession = vatSessionService;
                $scope.period = vatSessionService.month;
                setLayoutStatusTitle(vatSessionService.project.projectStatusList[month]);
                setStartStatusText(month);
                $log.debug(vatSessionService.project.importSubStatus);
            }

            if (workflowData.result) {
                $log.debug("vat-layout.ctrl.js  initStatus set project workflow");
                vatSessionService.project.workflow = workflowData.data;
                $log.debug(vatSessionService.project.workflow);
            }
        });
    }

    function triggerSchedulerJob() {
        vatWorkflowService.execute();
    }

    (function initialize() {
        $log.debug("vat-layout-crtl.js initialize() ");
        $scope.displaySubStatus = false;//导入子状态是否显示   
        $scope.displayApproveDetails = false;//审核详细详细是否显示
        $scope.triggerSchedulerJob = triggerSchedulerJob;
        initStatus(vatSessionService.project.dbName, vatSessionService.project.id, vatSessionService.month);
        $scope.setPermissionMenu();


        $rootScope.$on('statusChanged', function (event, args) {
            $log.debug("receive statusChanged");
            $log.debug(args.status);
            setLayoutStatusTitle(args.status);
        });

    })();
}]);

vatModule.directive('vatLayout', ['$log', 'region', 'enums',
function ($log, region, enums) {
    'use strict';

    $log.debug('vatLayout.ctor()...');

    return {
        restrict: 'E',
        templateUrl: '/app/vat/vat-layout/vat-layout.html' + '?_=' + Math.random(),
        replace: true,
        scope: {},
        controller: 'VatLayoutController',
        link: function ($scope, $element, $attr) {

            var ele = $("#vatDatepicker");
            ele.datepicker({
                startDate: $scope.startDate,
                endDate: $scope.endDate,
                language: region,
                viewMode: 1,
                minViewMode: 1,
                autoclose: true,//选中之后自动隐藏日期选择框
                clearBtn: false,//清除按钮
                todayBtn: false,//今日按钮
                format: $scope.dateFormat//日期格式，详见 http://bootstrap-datepicker.readthedocs.org/en/release/options.html#format
            }).on('changeDate', function (e) {
                $scope.changeDate(e);
            });
            ele.datepicker("setDate", $scope.selectedDate);
            $scope.elePicker = ele;

            $scope.menuStates = enums.vatMenuStates;
            $scope.menuState = enums.vatMenuStates.expanded;

            // Click to collapse the top menu
            // Param collapseMenu should be 1 to collapse, and 2 to expand.
            // 0: Expanded; 1: Collapsing, 2: Expanding, 3: Collapsed
            $scope.collapseMenu = function (collapseMenu) {
                $scope.menuState = collapseMenu;
            };

            // Handle css for top menu while collapse animation ended
            $scope.headerAnimationEnd = function ($event) {
                // Here we have to add class `collapsed` with JQuery grammar, because we want
                // it work immediately.
                if ($scope.menuState === enums.vatMenuStates.collapsing) {
                    angular.element('.vat-header').addClass('collapsed');
                }

                $scope.$apply(function () {
                    if ($scope.menuState === enums.vatMenuStates.collapsing) {
                        $scope.menuState = enums.vatMenuStates.collapsed;
                    }
                    else if ($scope.menuState === enums.vatMenuStates.expanding) {
                        $scope.menuState = enums.vatMenuStates.expanded;
                    }
                });
            }

            // Repaint spreadJS while spreadJS control expanded already
            $scope.contentAnimationEnd = function ($event) {
                $scope.$broadcast(enums.vatEvent.layoutChanged);
            };
        }
    };
}
]);